/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(re){for(var e=[],o=0,L=re.length;o<L;o++)e[o]=ye[re[o]];return e};define(ye[61],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(S,A){const y=Object.create(null);for(const I of S){const O=A(I);let P=y[O];P||(P=y[O]=[]),P.push(I)}return y}e.groupBy=o;function L(S,A){const y=[],I=[];for(const O of S)A.has(O)||y.push(O);for(const O of A)S.has(O)||I.push(O);return{removed:y,added:I}}e.diffSets=L;function l(S,A){const y=[],I=[];for(const[O,P]of S)A.has(O)||y.push(P);for(const[O,P]of A)S.has(O)||I.push(P);return{removed:y,added:I}}e.diffMaps=l;class R{constructor(){this.a=new Map}add(A,y){let I=this.a.get(A);I||(I=new Set,this.a.set(A,I)),I.add(y)}delete(A,y){const I=this.a.get(A);!I||(I.delete(y),I.size===0&&this.a.delete(A))}forEach(A,y){const I=this.a.get(A);!I||I.forEach(y)}}e.SetMap=R}),define(ye[62],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(S){return(A,y,I)=>{let O=null,P=null;if(typeof I.value=="function"?(O="value",P=I.value):typeof I.get=="function"&&(O="get",P=I.get),!P)throw new Error("not supported");I[O]=S(P,y)}}function L(S,A,y){let I=null,O=null;if(typeof y.value=="function"?(I="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(I="get",O=y.get),!O)throw new Error("not supported");const P=`$memoize$${A}`;y[I]=function(...v){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,v)}),this[P]}}e.memoize=L;function l(S,A,y){return o((I,O)=>{const P=`$debounce$${O}`,v=`$debounce$result$${O}`;return function(...k){this[v]||(this[v]=y?y():void 0),clearTimeout(this[P]),A&&(this[v]=A(this[v],...k),k=[this[v]]),this[P]=setTimeout(()=>{I.apply(this,k),this[v]=y?y():void 0},S)}})}e.debounce=l;function R(S,A,y){return o((I,O)=>{const P=`$throttle$timer$${O}`,v=`$throttle$result$${O}`,k=`$throttle$lastRun$${O}`,D=`$throttle$pending$${O}`;return function(...f){if(this[v]||(this[v]=y?y():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),A&&(this[v]=A(this[v],...f)),this[D])return;const d=this[k]+S;d<=Date.now()?(this[k]=Date.now(),I.apply(this,[this[v]]),this[v]=y?y():void 0):(this[D]=!0,this[P]=setTimeout(()=>{this[D]=!1,this[k]=Date.now(),I.apply(this,[this[v]]),this[v]=y?y():void 0},d-Date.now()))}})}e.throttle=R}),define(ye[10],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?C.isErrorNoTelemetry(s)?new C(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(r=>{r(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=o,e.errorHandler=new o;function L(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=L;function l(n){if(!n||typeof n!="object")return!1;const s=n;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function R(n){I(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=R;function S(n){I(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=S;function A(n){if(n instanceof Error){const{name:s,message:r}=n,a=n.stacktrace||n.stack;return{$isError:!0,name:s,message:r,stack:a,noTelemetry:C.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=A;const y="Canceled";function I(n){return n instanceof O?!0:n instanceof Error&&n.name===y&&n.message===y}e.isCancellationError=I;class O extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=O;function P(){const n=new Error(y);return n.name=n.message,n}e.canceled=P;function v(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=v;function k(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=k;function D(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function f(n){const s=new Error(`${n} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function d(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=d;class u extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=u;class m extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=m;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class C extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof C)return s;const r=new C;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class p extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(ye[15],De([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(ae,le=0){return ae[ae.length-(1+le)]}e.tail=L;function l(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}e.tail2=l;function R(ae,le,ue=(ne,ce)=>ne===ce){if(ae===le)return!0;if(!ae||!le||ae.length!==le.length)return!1;for(let ne=0,ce=ae.length;ne<ce;ne++)if(!ue(ae[ne],le[ne]))return!1;return!0}e.equals=R;function S(ae,le){const ue=ae.length-1;le<ue&&(ae[le]=ae[ue]),ae.pop()}e.removeFastWithoutKeepingOrder=S;function A(ae,le,ue){return y(ae.length,ne=>ue(ae[ne],le))}e.binarySearch=A;function y(ae,le){let ue=0,ne=ae-1;for(;ue<=ne;){const ce=(ue+ne)/2|0,oe=le(ce);if(oe<0)ue=ce+1;else if(oe>0)ne=ce-1;else return ce}return-(ue+1)}e.binarySearch2=y;function I(ae,le){let ue=0,ne=ae.length;if(ne===0)return 0;for(;ue<ne;){const ce=Math.floor((ue+ne)/2);le(ae[ce])?ne=ce:ue=ce+1}return ue}e.findFirstInSorted=I;function O(ae,le,ue){if(ae=ae|0,ae>=le.length)throw new TypeError("invalid index");const ne=le[Math.floor(le.length*Math.random())],ce=[],oe=[],M=[];for(const z of le){const G=ue(z,ne);G<0?ce.push(z):G>0?oe.push(z):M.push(z)}return ae<ce.length?O(ae,ce,ue):ae<ce.length+M.length?M[0]:O(ae-(ce.length+M.length),oe,ue)}e.quickSelect=O;function P(ae,le){const ue=[];let ne;for(const ce of ae.slice(0).sort(le))!ne||le(ne[0],ce)!==0?(ne=[ce],ue.push(ne)):ne.push(ce);return ue}e.groupBy=P;function v(ae,le,ue){const ne=[];function ce(z,G,te){if(G===0&&te.length===0)return;const de=ne[ne.length-1];de&&de.start+de.deleteCount===z?(de.deleteCount+=G,de.toInsert.push(...te)):ne.push({start:z,deleteCount:G,toInsert:te})}let oe=0,M=0;for(;;){if(oe===ae.length){ce(oe,0,le.slice(M));break}if(M===le.length){ce(oe,ae.length-oe,[]);break}const z=ae[oe],G=le[M],te=ue(z,G);te===0?(oe+=1,M+=1):te<0?(ce(oe,1,[]),oe+=1):te>0&&(ce(oe,0,[G]),M+=1)}return ne}e.sortedDiff=v;function k(ae,le,ue){const ne=v(ae,le,ue),ce=[],oe=[];for(const M of ne)ce.push(...ae.slice(M.start,M.start+M.deleteCount)),oe.push(...M.toInsert);return{removed:ce,added:oe}}e.delta=k;function D(ae,le,ue){if(ue===0)return[];const ne=ae.slice(0,ue).sort(le);return d(ae,le,ne,ue,ae.length),ne}e.top=D;function f(ae,le,ue,ne,ce){return ue===0?Promise.resolve([]):new Promise((oe,M)=>{(async()=>{const z=ae.length,G=ae.slice(0,ue).sort(le);for(let te=ue,de=Math.min(ue+ne,z);te<z;te=de,de=Math.min(de+ne,z)){if(te>ue&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new o.CancellationError;d(ae,le,G,te,de)}return G})().then(oe,M)})}e.topAsync=f;function d(ae,le,ue,ne,ce){for(const oe=ue.length;ne<ce;ne++){const M=ae[ne];if(le(M,ue[oe-1])<0){ue.pop();const z=I(ue,G=>le(M,G)<0);ue.splice(z,0,M)}}}function u(ae){return ae.filter(le=>!!le)}e.coalesce=u;function m(ae){let le=0;for(let ue=0;ue<ae.length;ue++)ae[ue]&&(ae[le]=ae[ue],le+=1);ae.length=le}e.coalesceInPlace=m;function b(ae,le,ue){ae.splice(ue,0,ae.splice(le,1)[0])}e.move=b;function C(ae){return!Array.isArray(ae)||ae.length===0}e.isFalsyOrEmpty=C;function p(ae){return Array.isArray(ae)&&ae.length>0}e.isNonEmptyArray=p;function n(ae,le=ue=>ue){const ue=new Set;return ae.filter(ne=>{const ce=le(ne);return ue.has(ce)?!1:(ue.add(ce),!0)})}e.distinct=n;function s(ae){const le=new Set;return ue=>{const ne=ae(ue);return le.has(ne)?!1:(le.add(ne),!0)}}e.uniqueFilter=s;function r(ae,le){const ue=a(ae,le);if(ue!==-1)return ae[ue]}e.findLast=r;function a(ae,le){for(let ue=ae.length-1;ue>=0;ue--){const ne=ae[ue];if(le(ne))return ue}return-1}e.lastIndex=a;function c(ae,le){return ae.length>0?ae[0]:le}e.firstOrDefault=c;function g(ae,le){return ae.length>0?ae[ae.length-1]:le}e.lastOrDefault=g;function i(ae,le,ue=(ne,ce)=>ne===ce){let ne=0;for(let ce=0,oe=Math.min(ae.length,le.length);ce<oe&&ue(ae[ce],le[ce]);ce++)ne++;return ne}e.commonPrefixLength=i;function t(ae){return[].concat(...ae)}e.flatten=t;function h(ae,le){let ue=typeof le=="number"?ae:0;typeof le=="number"?ue=ae:(ue=0,le=ae);const ne=[];if(ue<=le)for(let ce=ue;ce<le;ce++)ne.push(ce);else for(let ce=ue;ce>le;ce--)ne.push(ce);return ne}e.range=h;function E(ae,le,ue){return ae.reduce((ne,ce)=>(ne[le(ce)]=ue?ue(ce):ce,ne),Object.create(null))}e.index=E;function w(ae,le){return ae.push(le),()=>N(ae,le)}e.insert=w;function N(ae,le){const ue=ae.indexOf(le);if(ue>-1)return ae.splice(ue,1),le}e.remove=N;function j(ae,le,ue){const ne=ae.slice(0,le),ce=ae.slice(le);return ne.concat(ue,ce)}e.arrayInsert=j;function V(ae,le){let ue;if(typeof le=="number"){let ne=le;ue=()=>{const ce=Math.sin(ne++)*179426549;return ce-Math.floor(ce)}}else ue=Math.random;for(let ne=ae.length-1;ne>0;ne-=1){const ce=Math.floor(ue()*(ne+1)),oe=ae[ne];ae[ne]=ae[ce],ae[ce]=oe}}e.shuffle=V;function Q(ae,le){const ue=ae.indexOf(le);ue>-1&&(ae.splice(ue,1),ae.unshift(le))}e.pushToStart=Q;function q(ae,le){const ue=ae.indexOf(le);ue>-1&&(ae.splice(ue,1),ae.push(le))}e.pushToEnd=q;function U(ae,le){for(const ue of le)ae.push(ue)}e.pushMany=U;function T(ae,le){return Array.isArray(ae)?ae.map(le):le(ae)}e.mapArrayOrNot=T;function F(ae){return Array.isArray(ae)?ae:[ae]}e.asArray=F;function B(ae){return ae[Math.floor(Math.random()*ae.length)]}e.getRandomElement=B;function Z(ae,le){for(const ue of ae){const ne=le(ue);if(ne!==void 0)return ne}}e.mapFind=Z;function _(ae,le,ue){const ne=Y(ae,le),ce=ae.length,oe=ue.length;ae.length=ce+oe;for(let M=ce-1;M>=ne;M--)ae[M+oe]=ae[M];for(let M=0;M<oe;M++)ae[M+ne]=ue[M]}e.insertInto=_;function H(ae,le,ue,ne){const ce=Y(ae,le),oe=ae.splice(ce,ue);return _(ae,ce,ne),oe}e.splice=H;function Y(ae,le){return le<0?Math.max(le+ae.length,0):Math.min(le,ae.length)}var ie;(function(ae){function le(ce){return ce<0}ae.isLessThan=le;function ue(ce){return ce>0}ae.isGreaterThan=ue;function ne(ce){return ce===0}ae.isNeitherLessOrGreaterThan=ne,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function ge(ae,le){return(ue,ne)=>le(ae(ue),ae(ne))}e.compareBy=ge;function X(...ae){return(le,ue)=>{for(const ne of ae){const ce=ne(le,ue);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const J=(ae,le)=>ae-le;e.numberComparator=J;function ee(ae,le){if(ae.length===0)return;let ue=ae[0];for(let ne=1;ne<ae.length;ne++){const ce=ae[ne];le(ce,ue)>0&&(ue=ce)}return ue}e.findMaxBy=ee;function me(ae,le){if(ae.length===0)return;let ue=ae[0];for(let ne=1;ne<ae.length;ne++){const ce=ae[ne];le(ce,ue)>=0&&(ue=ce)}return ue}e.findLastMaxBy=me;function ve(ae,le){return ee(ae,(ue,ne)=>-le(ue,ne))}e.findMinBy=ve;class Ie{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let ue=this.c;for(;ue<this.f.length&&le(this.f[ue]);)ue++;const ne=ue===this.c?null:this.f.slice(this.c,ue);return this.c=ue,ne}takeFromEndWhile(le){let ue=this.d;for(;ue>=0&&le(this.f[ue]);)ue--;const ne=ue===this.d?null:this.f.slice(ue+1,this.d+1);return this.d=ue,ne}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const ue=this.f.slice(this.c,this.c+le);return this.c+=le,ue}}e.ArrayQueue=Ie;class Re{constructor(le){this.iterate=le}forEach(le){this.iterate(ue=>(le(ue),!0))}toArray(){const le=[];return this.iterate(ue=>(le.push(ue),!0)),le}filter(le){return new Re(ue=>this.iterate(ne=>le(ne)?ue(ne):!0))}map(le){return new Re(ue=>this.iterate(ne=>ue(le(ne))))}some(le){let ue=!1;return this.iterate(ne=>(ue=le(ne),!ue)),ue}findFirst(le){let ue;return this.iterate(ne=>le(ne)?(ue=ne,!1):!0),ue}findLast(le){let ue;return this.iterate(ne=>(le(ne)&&(ue=ne),!0)),ue}findLastMaxBy(le){let ue,ne=!0;return this.iterate(ce=>((ne||ie.isGreaterThan(le(ce,ue)))&&(ne=!1,ue=ce),!0)),ue}}Re.empty=new Re(ae=>{}),e.CallbackIterable=Re}),define(ye[50],De([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(y,I){if(!y)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=L;function l(y,I="Unreachable"){throw new Error(I)}e.assertNever=l;function R(y){if(!y)throw new o.BugIndicatingError("Assertion Failed")}e.assert=R;function S(y){if(!y()){debugger;y(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=S;function A(y,I){let O=0;for(;O<y.length-1;){const P=y[O],v=y[O+1];if(!I(P,v))return!1;O++}return!0}e.checkAdjacentItems=A}),define(ye[63],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(L){const l=this;let R=!1,S;return function(){return R||(R=!0,S=L.apply(l,arguments)),S}}e.once=o}),define(ye[101],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(ye[64],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(L){function l(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}L.is=l;const R=Object.freeze([]);function S(){return R}L.empty=S;function*A(C){yield C}L.single=A;function y(C){return l(C)?C:A(C)}L.wrap=y;function I(C){return C||R}L.from=I;function O(C){return!C||C[Symbol.iterator]().next().done===!0}L.isEmpty=O;function P(C){return C[Symbol.iterator]().next().value}L.first=P;function v(C,p){for(const n of C)if(p(n))return!0;return!1}L.some=v;function k(C,p){for(const n of C)if(p(n))return n}L.find=k;function*D(C,p){for(const n of C)p(n)&&(yield n)}L.filter=D;function*f(C,p){let n=0;for(const s of C)yield p(s,n++)}L.map=f;function*d(...C){for(const p of C)for(const n of p)yield n}L.concat=d;function u(C,p,n){let s=n;for(const r of C)s=p(s,r);return s}L.reduce=u;function*m(C,p,n=C.length){for(p<0&&(p+=C.length),n<0?n+=C.length:n>C.length&&(n=C.length);p<n;p++)yield C[p]}L.slice=m;function b(C,p=Number.POSITIVE_INFINITY){const n=[];if(p===0)return[n,C];const s=C[Symbol.iterator]();for(let r=0;r<p;r++){const a=s.next();if(a.done)return[n,L.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}L.consume=b})(o=e.Iterable||(e.Iterable={}))}),define(ye[146],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function S(n,s=!1){let r=0;const a=n.length;let c="",g=0,i=16,t=0;function h(q){let U=0,T=0;for(;U<q;){const F=n.charCodeAt(r);if(F>=48&&F<=57)T=T*16+F-48;else if(F>=65&&F<=70)T=T*16+F-65+10;else if(F>=97&&F<=102)T=T*16+F-97+10;else break;r++,U++}return U<q&&(T=-1),T}function E(q){r=q,c="",g=0,i=16,t=0}function w(){const q=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&I(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&I(n.charCodeAt(r)))for(r++;r<n.length&&I(n.charCodeAt(r));)r++;else return t=3,n.substring(q,r);let U=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&I(n.charCodeAt(r))){for(r++;r<n.length&&I(n.charCodeAt(r));)r++;U=r}else t=3;return n.substring(q,U)}function N(){let q="",U=r;for(;;){if(r>=a){q+=n.substring(U,r),t=2;break}const T=n.charCodeAt(r);if(T===34){q+=n.substring(U,r),r++;break}if(T===92){if(q+=n.substring(U,r),r++,r>=a){t=2;break}switch(n.charCodeAt(r++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const B=h(4);B>=0?q+=String.fromCharCode(B):t=4;break}default:t=5}U=r;continue}if(T>=0&&T<=31)if(y(T)){q+=n.substring(U,r),t=2;break}else t=6;r++}return q}function j(){if(c="",t=0,g=r,r>=a)return g=a,i=17;let q=n.charCodeAt(r);if(A(q)){do r++,c+=String.fromCharCode(q),q=n.charCodeAt(r);while(A(q));return i=15}if(y(q))return r++,c+=String.fromCharCode(q),q===13&&n.charCodeAt(r)===10&&(r++,c+=`
`),i=14;switch(q){case 123:return r++,i=1;case 125:return r++,i=2;case 91:return r++,i=3;case 93:return r++,i=4;case 58:return r++,i=6;case 44:return r++,i=5;case 34:return r++,c=N(),i=10;case 47:{const U=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<a&&!y(n.charCodeAt(r));)r++;return c=n.substring(U,r),i=12}if(n.charCodeAt(r+1)===42){r+=2;const T=a-1;let F=!1;for(;r<T;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,t=1),c=n.substring(U,r),i=13}return c+=String.fromCharCode(q),r++,i=16}case 45:if(c+=String.fromCharCode(q),r++,r===a||!I(n.charCodeAt(r)))return i=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=w(),i=11;default:for(;r<a&&V(q);)r++,q=n.charCodeAt(r);if(g!==r){switch(c=n.substring(g,r),c){case"true":return i=8;case"false":return i=9;case"null":return i=7}return i=16}return c+=String.fromCharCode(q),r++,i=16}}function V(q){if(A(q)||y(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let q;do q=j();while(q>=12&&q<=15);return q}return{setPosition:E,getPosition:()=>r,scan:s?Q:j,getToken:()=>i,getTokenValue:()=>c,getTokenOffset:()=>g,getTokenLength:()=>r-g,getTokenError:()=>t}}e.createScanner=S;function A(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function I(n){return n>=48&&n<=57}var O;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(O||(O={}));function P(n,s){const r=[],a=new Object;let c;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let i=!1;function t(h,E,w,N){g.value=h,g.offset=E,g.length=w,g.type=N,g.colonOffset=void 0,c=g}try{b(n,{onObjectBegin:(h,E)=>{if(s<=h)throw a;c=void 0,i=s>h,r.push("")},onObjectProperty:(h,E,w)=>{if(s<E||(t(h,E,w,"property"),r[r.length-1]=h,s<=E+w))throw a},onObjectEnd:(h,E)=>{if(s<=h)throw a;c=void 0,r.pop()},onArrayBegin:(h,E)=>{if(s<=h)throw a;c=void 0,r.push(0)},onArrayEnd:(h,E)=>{if(s<=h)throw a;c=void 0,r.pop()},onLiteralValue:(h,E,w)=>{if(s<E||(t(h,E,w,p(h)),s<=E+w))throw a},onSeparator:(h,E,w)=>{if(s<=E)throw a;if(h===":"&&c&&c.type==="property")c.colonOffset=E,i=!1,c=void 0;else if(h===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(i=!0,r[r.length-1]=""),c=void 0}}})}catch(h){if(h!==a)throw h}return{path:r,previousNode:c,isAtPropertyKey:i,matches:h=>{let E=0;for(let w=0;E<h.length&&w<r.length;w++)if(h[E]===r[w]||h[E]==="*")E++;else if(h[E]!=="**")return!1;return E===h.length}}}e.getLocation=P;function v(n,s=[],r=R.DEFAULT){let a=null,c=[];const g=[];function i(h){Array.isArray(c)?c.push(h):a!==null&&(c[a]=h)}return b(n,{onObjectBegin:()=>{const h={};i(h),g.push(c),c=h,a=null},onObjectProperty:h=>{a=h},onObjectEnd:()=>{c=g.pop()},onArrayBegin:()=>{const h=[];i(h),g.push(c),c=h,a=null},onArrayEnd:()=>{c=g.pop()},onLiteralValue:i,onError:(h,E,w)=>{s.push({error:h,offset:E,length:w})}},r),c[0]}e.parse=v;function k(n,s=[],r=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(h){a.type==="property"&&(a.length=h-a.offset,a=a.parent)}function g(h){return a.children.push(h),h}b(n,{onObjectBegin:h=>{a=g({type:"object",offset:h,length:-1,parent:a,children:[]})},onObjectProperty:(h,E,w)=>{a=g({type:"property",offset:E,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:h,offset:E,length:w,parent:a})},onObjectEnd:(h,E)=>{a.length=h+E-a.offset,a=a.parent,c(h+E)},onArrayBegin:(h,E)=>{a=g({type:"array",offset:h,length:-1,parent:a,children:[]})},onArrayEnd:(h,E)=>{a.length=h+E-a.offset,a=a.parent,c(h+E)},onLiteralValue:(h,E,w)=>{g({type:p(h),offset:E,length:w,parent:a,value:h}),c(E+w)},onSeparator:(h,E,w)=>{a.type==="property"&&(h===":"?a.colonOffset=E:h===","&&c(E))},onError:(h,E,w)=>{s.push({error:h,offset:E,length:w})}},r);const t=a.children[0];return t&&delete t.parent,t}e.parseTree=k;function D(n,s){if(!n)return;let r=n;for(const a of s)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const g of r.children)if(Array.isArray(g.children)&&g.children[0].value===a){r=g.children[1],c=!0;break}if(!c)return}else{const c=a;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=D;function f(n){if(!n.parent||!n.parent.children)return[];const s=f(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;s.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&s.push(r)}return s}e.getNodePath=f;function d(n){switch(n.type){case"array":return n.children.map(d);case"object":{const s=Object.create(null);for(const r of n.children){const a=r.children[1];a&&(s[r.children[0].value]=d(a))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=d;function u(n,s,r=!1){return s>=n.offset&&s<n.offset+n.length||r&&s===n.offset+n.length}e.contains=u;function m(n,s,r=!1){if(u(n,s,r)){const a=n.children;if(Array.isArray(a))for(let c=0;c<a.length&&a[c].offset<=s;c++){const g=m(a[c],s,r);if(g)return g}return n}}e.findNodeAtOffset=m;function b(n,s,r=R.DEFAULT){const a=S(n,!1);function c(ge){return ge?()=>ge(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(ge){return ge?X=>ge(X,a.getTokenOffset(),a.getTokenLength()):()=>!0}const i=c(s.onObjectBegin),t=g(s.onObjectProperty),h=c(s.onObjectEnd),E=c(s.onArrayBegin),w=c(s.onArrayEnd),N=g(s.onLiteralValue),j=g(s.onSeparator),V=c(s.onComment),Q=g(s.onError),q=r&&r.disallowComments,U=r&&r.allowTrailingComma;function T(){for(;;){const ge=a.scan();switch(a.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:q||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(ge){case 12:case 13:q?F(10):V();break;case 16:F(1);break;case 15:case 14:break;default:return ge}}}function F(ge,X=[],J=[]){if(Q(ge),X.length+J.length>0){let ee=a.getToken();for(;ee!==17;){if(X.indexOf(ee)!==-1){T();break}else if(J.indexOf(ee)!==-1)break;ee=T()}}}function B(ge){const X=a.getTokenValue();return ge?N(X):t(X),T(),!0}function Z(){switch(a.getToken()){case 11:{let ge=0;try{ge=JSON.parse(a.getTokenValue()),typeof ge!="number"&&(F(2),ge=0)}catch{F(2)}N(ge);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return T(),!0}function _(){return a.getToken()!==10?(F(3,[],[2,5]),!1):(B(!1),a.getToken()===6?(j(":"),T(),ie()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function H(){i(),T();let ge=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(ge||F(4,[],[]),j(","),T(),a.getToken()===2&&U)break}else ge&&F(6,[],[]);_()||F(4,[],[2,5]),ge=!0}return h(),a.getToken()!==2?F(7,[2],[]):T(),!0}function Y(){E(),T();let ge=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(ge||F(4,[],[]),j(","),T(),a.getToken()===4&&U)break}else ge&&F(6,[],[]);ie()||F(4,[],[4,5]),ge=!0}return w(),a.getToken()!==4?F(8,[4],[]):T(),!0}function ie(){switch(a.getToken()){case 3:return Y();case 1:return H();case 10:return B(!0);default:return Z()}}return T(),a.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):ie()?(a.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=b;function C(n,s){const r=S(n),a=[];let c,g=0,i;do switch(i=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:g!==i&&a.push(n.substring(g,i)),s!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,s)),g=r.getPosition();break}while(c!==17);return a.join("")}e.stripComments=C;function p(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ye[65],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=o}),define(ye[6],De([1,0,63,64]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let R=null;function S(g){R=g}if(e.setDisposableTracker=S,l){const g="__is_disposable_tracked__";S(new class{trackDisposable(i){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{i[g]||console.log(t)},3e3)}setParent(i,t){if(i&&i!==m.None)try{i[g]=!0}catch{}}markAsDisposed(i){if(i&&i!==m.None)try{i[g]=!0}catch{}}markAsSingleton(i){}})}function A(g){return R?.trackDisposable(g),g}function y(g){R?.markAsDisposed(g)}function I(g,i){R?.setParent(g,i)}function O(g,i){if(!!R)for(const t of g)R.setParent(t,i)}function P(g){return R?.markAsSingleton(g),g}e.markAsSingleton=P;function v(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=v;function k(g){if(L.Iterable.is(g)){const i=[];for(const t of g)if(t)try{t.dispose()}catch(h){i.push(h)}if(i.length===1)throw i[0];if(i.length>1)throw new AggregateError(i,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.dispose=k;function D(g){for(const i of g)v(i)&&i.dispose();return[]}e.disposeIfDisposable=D;function f(...g){const i=d(()=>k(g));return O(g,i),i}e.combinedDisposable=f;function d(g){const i=A({dispose:(0,o.once)(()=>{y(i),g()})});return i}e.toDisposable=d;class u{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{k(this.c)}finally{this.c.clear()}}add(i){if(!i)return i;if(i===this)throw new Error("Cannot register a disposable on itself!");return I(i,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(i),i}}u.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=u;class m{constructor(){this.q=new u,A(this),I(this.q,this)}dispose(){y(this),this.q.dispose()}B(i){if(i===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(i)}}m.None=Object.freeze({dispose(){}}),e.Disposable=m;class b{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(i){this.b||i===this.a||(this.a?.dispose(),i&&I(i,this),this.a=i)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const i=this.a;return this.a=void 0,i&&I(i,null),i}}e.MutableDisposable=b;class C{constructor(i){this.b=i,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=C;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(i){let t=i;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,y(this))},this}}e.SafeDisposable=p;class n{constructor(){this.a=new Map}acquire(i,...t){let h=this.a.get(i);h||(h={counter:0,object:this.b(i,...t)},this.a.set(i,h));const{object:E}=h,w=(0,o.once)(()=>{--h.counter===0&&(this.c(i,h.object),this.a.delete(i))});return h.counter++,{object:E,dispose:w}}}e.ReferenceCollection=n;class s{constructor(i){this.a=i}async acquire(i,...t){const h=this.a.acquire(i,...t);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(E){throw h.dispose(),E}}}e.AsyncReferenceCollection=s;class r{constructor(i){this.object=i}dispose(){}}e.ImmortalReference=r;function a(g){const i=new u;try{g(i)}finally{i.dispose()}}e.disposeOnReturn=a;class c{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{k(this.a.values())}finally{this.a.clear()}}has(i){return this.a.has(i)}get(i){return this.a.get(i)}set(i,t,h=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),h||this.a.get(i)?.dispose(),this.a.set(i,t)}deleteAndDispose(i){this.a.get(i)?.dispose(),this.a.delete(i)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=c}),define(ye[66],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(R){this.element=R,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class L{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let R=this.a;for(;R!==o.Undefined;){const S=R.next;R.prev=o.Undefined,R.next=o.Undefined,R=S}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,S){const A=new o(R);if(this.a===o.Undefined)this.a=A,this.b=A;else if(S){const I=this.b;this.b=A,A.prev=I,I.next=A}else{const I=this.a;this.a=A,A.next=I,I.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==o.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==o.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==o.Undefined&&R.next!==o.Undefined){const S=R.prev;S.next=R.next,R.next.prev=S}else R.prev===o.Undefined&&R.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):R.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):R.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==o.Undefined;)yield R.element,R=R.next}}e.LinkedList=L}),define(ye[28],De([1,0]),function(re,e){"use strict";var o,L,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(D,f,d){let u=D.get(f);return u===void 0&&(u=d,D.set(f,u)),u}e.getOrSet=R;function S(D){const f=[];return D.forEach((d,u)=>{f.push(`${u} => ${d}`)}),`Map(${D.size}) {${f.join(", ")}}`}e.mapToString=S;function A(D){const f=[];return D.forEach(d=>{f.push(d)}),`Set(${D.size}) {${f.join(", ")}}`}e.setToString=A;class y{constructor(f,d){this.uri=f,this.value=d}}class I{constructor(f,d){this[o]="ResourceMap",f instanceof I?(this.b=new Map(f.b),this.c=d??I.a):(this.b=new Map,this.c=f??I.a)}set(f,d){return this.b.set(this.c(f),new y(f,d)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,d){typeof d<"u"&&(f=f.bind(d));for(const[u,m]of this.b)f(m.value,m.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}I.a=D=>D.toString(),e.ResourceMap=I;class O{constructor(f,d){this[L]="ResourceSet",!f||typeof f=="function"?this.a=new I(f):(this.a=new I(d),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,d){this.a.forEach((u,m)=>f.call(d,m,m,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var P;(function(D){D[D.None=0]="None",D[D.AsOld=1]="AsOld",D[D.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class v{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,d=0){const u=this.a.get(f);if(!!u)return d!==0&&this.j(u,d),u.value}set(f,d,u=0){let m=this.a.get(f);if(m)m.value=d,u!==0&&this.j(m,u);else{switch(m={key:f,value:d,next:void 0,previous:void 0},u){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(f,m),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const d=this.a.get(f);if(!!d)return this.a.delete(f),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,d){const u=this.e;let m=this.b;for(;m;){if(d?f.bind(d)(m.value,m.key,this):f(m.value,m.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const f=this,d=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.key,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return m}values(){const f=this,d=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.value,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return m}entries(){const f=this,d=this.e;let u=this.b;const m={[Symbol.iterator](){return m},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:[u.key,u.value],done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return m}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let d=this.b,u=this.size;for(;d&&u>f;)this.a.delete(d.key),d=d.next,u--;this.b=d,this.d=u,d&&(d.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const d=f.next,u=f.previous;if(!d||!u)throw new Error("Invalid list");d.previous=u,u.next=d}f.next=void 0,f.previous=void 0,this.e++}j(f,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(f===this.b)return;const u=f.next,m=f.previous;f===this.c?(m.next=void 0,this.c=m):(u.previous=m,m.next=u),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(d===2){if(f===this.c)return;const u=f.next,m=f.previous;f===this.b?(u.previous=void 0,this.b=u):(u.previous=m,m.next=u),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((d,u)=>{f.push([u,d])}),f}fromJSON(f){this.clear();for(const[d,u]of f)this.set(d,u)}}e.LinkedMap=v;class k extends v{constructor(f,d=1){super(),this.k=f,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,d=2){return super.get(f,d)}peek(f){return super.get(f,0)}set(f,d){return super.set(f,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=k}),function(re,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],De([0]),e):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ae,le){for(var ue=0;ue<le.length;ue++){var ne=le[ue];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(ae,ne.key,ne)}}function o(ae,le,ue){return le&&e(ae.prototype,le),ue&&e(ae,ue),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function L(ae,le){if(!!ae){if(typeof ae=="string")return l(ae,le);var ue=Object.prototype.toString.call(ae).slice(8,-1);if(ue==="Object"&&ae.constructor&&(ue=ae.constructor.name),ue==="Map"||ue==="Set")return Array.from(ae);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return l(ae,le)}}function l(ae,le){(le==null||le>ae.length)&&(le=ae.length);for(var ue=0,ne=new Array(le);ue<le;ue++)ne[ue]=ae[ue];return ne}function R(ae,le){var ue=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(ue)return(ue=ue.call(ae)).next.bind(ue);if(Array.isArray(ae)||(ue=L(ae))||le&&ae&&typeof ae.length=="number"){ue&&(ae=ue);var ne=0;return function(){return ne>=ae.length?{done:!0}:{done:!1,value:ae[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=S();function A(ae){re.defaults=ae}var y=/[&<>"']/,I=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return v[le]};function D(ae,le){if(le){if(y.test(ae))return ae.replace(I,k)}else if(O.test(ae))return ae.replace(P,k);return ae}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ae){return ae.replace(f,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var u=/(^|[^\[])\^/g;function m(ae,le){ae=typeof ae=="string"?ae:ae.source,le=le||"";var ue={replace:function(ce,oe){return oe=oe.source||oe,oe=oe.replace(u,"$1"),ae=ae.replace(ce,oe),ue},getRegex:function(){return new RegExp(ae,le)}};return ue}var b=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(ae,le,ue){if(ae){var ne;try{ne=decodeURIComponent(d(ue)).replace(b,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}le&&!C.test(ue)&&(ue=c(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var n={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ae,le){n[" "+ae]||(s.test(ae)?n[" "+ae]=ae+"/":n[" "+ae]=h(ae,"/",!0)),ae=n[" "+ae];var ue=ae.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:ae.replace(r,"$1")+le:le.charAt(0)==="/"?ue?le:ae.replace(a,"$1")+le:ae+le}var g={exec:function(){}};function i(ae){for(var le=1,ue,ne;le<arguments.length;le++){ue=arguments[le];for(ne in ue)Object.prototype.hasOwnProperty.call(ue,ne)&&(ae[ne]=ue[ne])}return ae}function t(ae,le){var ue=ae.replace(/\|/g,function(oe,M,z){for(var G=!1,te=M;--te>=0&&z[te]==="\\";)G=!G;return G?"|":" |"}),ne=ue.split(/ \|/),ce=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>le)ne.splice(le);else for(;ne.length<le;)ne.push("");for(;ce<ne.length;ce++)ne[ce]=ne[ce].trim().replace(/\\\|/g,"|");return ne}function h(ae,le,ue){var ne=ae.length;if(ne===0)return"";for(var ce=0;ce<ne;){var oe=ae.charAt(ne-ce-1);if(oe===le&&!ue)ce++;else if(oe!==le&&ue)ce++;else break}return ae.slice(0,ne-ce)}function E(ae,le){if(ae.indexOf(le[1])===-1)return-1;for(var ue=ae.length,ne=0,ce=0;ce<ue;ce++)if(ae[ce]==="\\")ce++;else if(ae[ce]===le[0])ne++;else if(ae[ce]===le[1]&&(ne--,ne<0))return ce;return-1}function w(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(ae,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=ae),le>>=1,ae+=ae;return ue+ae}function j(ae,le,ue,ne){var ce=le.href,oe=le.title?D(le.title):null,M=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){ne.state.inLink=!0;var z={type:"link",raw:ue,href:ce,title:oe,text:M,tokens:ne.inlineTokens(M)};return ne.state.inLink=!1,z}return{type:"image",raw:ue,href:ce,title:oe,text:D(M)}}function V(ae,le){var ue=ae.match(/^(\s+)(?:```)/);if(ue===null)return le;var ne=ue[1];return le.split(`
`).map(function(ce){var oe=ce.match(/^\s+/);if(oe===null)return ce;var M=oe[0];return M.length>=ne.length?ce.slice(ne.length):ce}).join(`
`)}var Q=function(){function ae(ue){this.options=ue||re.defaults}var le=ae.prototype;return le.space=function(ne){var ce=this.rules.block.newline.exec(ne);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},le.code=function(ne){var ce=this.rules.block.code.exec(ne);if(ce){var oe=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:h(oe,`
`)}}},le.fences=function(ne){var ce=this.rules.block.fences.exec(ne);if(ce){var oe=ce[0],M=V(oe,ce[3]||"");return{type:"code",raw:oe,lang:ce[2]?ce[2].trim():ce[2],text:M}}},le.heading=function(ne){var ce=this.rules.block.heading.exec(ne);if(ce){var oe=ce[2].trim();if(/#$/.test(oe)){var M=h(oe,"#");(this.options.pedantic||!M||/ $/.test(M))&&(oe=M.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:oe,tokens:this.lexer.inline(oe)}}},le.hr=function(ne){var ce=this.rules.block.hr.exec(ne);if(ce)return{type:"hr",raw:ce[0]}},le.blockquote=function(ne){var ce=this.rules.block.blockquote.exec(ne);if(ce){var oe=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},le.list=function(ne){var ce=this.rules.block.list.exec(ne);if(ce){var oe,M,z,G,te,de,we,Pe,be,Ce,ke,He,Ge=ce[1].trim(),nt=Ge.length>1,Qe={type:"list",raw:"",ordered:nt,start:nt?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=nt?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=nt?Ge:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(He=!1,!(!(ce=tt.exec(ne))||this.rules.block.hr.test(ne)));){if(oe=ce[0],ne=ne.substring(oe.length),Pe=ce[2].split(`
`,1)[0],be=ne.split(`
`,1)[0],this.options.pedantic?(G=2,ke=Pe.trimLeft()):(G=ce[2].search(/[^ ]/),G=G>4?1:G,ke=Pe.slice(G),G+=ce[1].length),de=!1,!Pe&&/^ *$/.test(be)&&(oe+=be+`
`,ne=ne.substring(be.length+1),He=!0),!He)for(var rt=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),$=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");ne&&(Ce=ne.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Pe)||$.test(Pe)||rt.test(Pe)||Be.test(ne)));){if(Pe.search(/[^ ]/)>=G||!Pe.trim())ke+=`
`+Pe.slice(G);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),oe+=Ce+`
`,ne=ne.substring(Ce.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(oe)&&(we=!0)),this.options.gfm&&(M=/^\[[ xX]\] /.exec(ke),M&&(z=M[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:oe,task:!!M,checked:z,loose:!1,text:ke}),Qe.raw+=oe}Qe.items[Qe.items.length-1].raw=oe.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var K=Qe.items.length;for(te=0;te<K;te++){this.lexer.state.top=!1,Qe.items[te].tokens=this.lexer.blockTokens(Qe.items[te].text,[]);var he=Qe.items[te].tokens.filter(function(Ne){return Ne.type==="space"}),Le=he.every(function(Ne){for(var qe=Ne.raw.split(""),je=0,Ze=R(qe),st;!(st=Ze()).done;){var at=st.value;if(at===`
`&&(je+=1),je>1)return!0}return!1});!Qe.loose&&he.length&&Le&&(Qe.loose=!0,Qe.items[te].loose=!0)}return Qe}},le.html=function(ne){var ce=this.rules.block.html.exec(ne);if(ce){var oe={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var M=this.options.sanitizer?this.options.sanitizer(ce[0]):D(ce[0]);oe.type="paragraph",oe.text=M,oe.tokens=this.lexer.inline(M)}return oe}},le.def=function(ne){var ce=this.rules.block.def.exec(ne);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var oe=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:ce[0],href:ce[2],title:ce[3]}}},le.table=function(ne){var ce=this.rules.block.table.exec(ne);if(ce){var oe={type:"table",header:t(ce[1]).map(function(we){return{text:we}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=ce[0];var M=oe.align.length,z,G,te,de;for(z=0;z<M;z++)/^ *-+: *$/.test(oe.align[z])?oe.align[z]="right":/^ *:-+: *$/.test(oe.align[z])?oe.align[z]="center":/^ *:-+ *$/.test(oe.align[z])?oe.align[z]="left":oe.align[z]=null;for(M=oe.rows.length,z=0;z<M;z++)oe.rows[z]=t(oe.rows[z],oe.header.length).map(function(we){return{text:we}});for(M=oe.header.length,G=0;G<M;G++)oe.header[G].tokens=this.lexer.inline(oe.header[G].text);for(M=oe.rows.length,G=0;G<M;G++)for(de=oe.rows[G],te=0;te<de.length;te++)de[te].tokens=this.lexer.inline(de[te].text);return oe}}},le.lheading=function(ne){var ce=this.rules.block.lheading.exec(ne);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},le.paragraph=function(ne){var ce=this.rules.block.paragraph.exec(ne);if(ce){var oe=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:oe,tokens:this.lexer.inline(oe)}}},le.text=function(ne){var ce=this.rules.block.text.exec(ne);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},le.escape=function(ne){var ce=this.rules.inline.escape.exec(ne);if(ce)return{type:"escape",raw:ce[0],text:D(ce[1])}},le.tag=function(ne){var ce=this.rules.inline.tag.exec(ne);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):D(ce[0]):ce[0]}},le.link=function(ne){var ce=this.rules.inline.link.exec(ne);if(ce){var oe=ce[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var M=h(oe.slice(0,-1),"\\");if((oe.length-M.length)%2===0)return}else{var z=E(ce[2],"()");if(z>-1){var G=ce[0].indexOf("!")===0?5:4,te=G+ce[1].length+z;ce[2]=ce[2].substring(0,z),ce[0]=ce[0].substring(0,te).trim(),ce[3]=""}}var de=ce[2],we="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],we=Pe[3])}else we=ce[3]?ce[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(oe)?de=de.slice(1):de=de.slice(1,-1)),j(ce,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},le.reflink=function(ne,ce){var oe;if((oe=this.rules.inline.reflink.exec(ne))||(oe=this.rules.inline.nolink.exec(ne))){var M=(oe[2]||oe[1]).replace(/\s+/g," ");if(M=ce[M.toLowerCase()],!M||!M.href){var z=oe[0].charAt(0);return{type:"text",raw:z,text:z}}return j(oe,M,oe[0],this.lexer)}},le.emStrong=function(ne,ce,oe){oe===void 0&&(oe="");var M=this.rules.inline.emStrong.lDelim.exec(ne);if(!!M&&!(M[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=M[1]||M[2]||"";if(!z||z&&(oe===""||this.rules.inline.punctuation.exec(oe))){var G=M[0].length-1,te,de,we=G,Pe=0,be=M[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,ce=ce.slice(-1*ne.length+G);(M=be.exec(ce))!=null;)if(te=M[1]||M[2]||M[3]||M[4]||M[5]||M[6],!!te){if(de=te.length,M[3]||M[4]){we+=de;continue}else if((M[5]||M[6])&&G%3&&!((G+de)%3)){Pe+=de;continue}if(we-=de,!(we>0)){if(de=Math.min(de,de+we+Pe),Math.min(G,de)%2){var Ce=ne.slice(1,G+M.index+de);return{type:"em",raw:ne.slice(0,G+M.index+de+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=ne.slice(2,G+M.index+de-1);return{type:"strong",raw:ne.slice(0,G+M.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},le.codespan=function(ne){var ce=this.rules.inline.code.exec(ne);if(ce){var oe=ce[2].replace(/\n/g," "),M=/[^ ]/.test(oe),z=/^ /.test(oe)&&/ $/.test(oe);return M&&z&&(oe=oe.substring(1,oe.length-1)),oe=D(oe,!0),{type:"codespan",raw:ce[0],text:oe}}},le.br=function(ne){var ce=this.rules.inline.br.exec(ne);if(ce)return{type:"br",raw:ce[0]}},le.del=function(ne){var ce=this.rules.inline.del.exec(ne);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},le.autolink=function(ne,ce){var oe=this.rules.inline.autolink.exec(ne);if(oe){var M,z;return oe[2]==="@"?(M=D(this.options.mangle?ce(oe[1]):oe[1]),z="mailto:"+M):(M=D(oe[1]),z=M),{type:"link",raw:oe[0],text:M,href:z,tokens:[{type:"text",raw:M,text:M}]}}},le.url=function(ne,ce){var oe;if(oe=this.rules.inline.url.exec(ne)){var M,z;if(oe[2]==="@")M=D(this.options.mangle?ce(oe[0]):oe[0]),z="mailto:"+M;else{var G;do G=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(G!==oe[0]);M=D(oe[0]),oe[1]==="www."?z="http://"+M:z=M}return{type:"link",raw:oe[0],text:M,href:z,tokens:[{type:"text",raw:M,text:M}]}}},le.inlineText=function(ne,ce){var oe=this.rules.inline.text.exec(ne);if(oe){var M;return this.lexer.state.inRawBlock?M=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):D(oe[0]):oe[0]:M=D(this.options.smartypants?ce(oe[0]):oe[0]),{type:"text",raw:oe[0],text:M}}},ae}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=m(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=m(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=m(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=m(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=m(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=m(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=i({},q),q.gfm=i({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=m(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=m(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=i({},q.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:m(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=m(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=m(q._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=m(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=m(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=m(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=m(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=m(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=m(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=m(U.reflink).replace("label",U._label).replace("ref",q._label).getRegex(),U.nolink=m(U.nolink).replace("ref",q._label).getRegex(),U.reflinkSearch=m(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=i({},U),U.pedantic=i({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=i({},U.normal,{escape:m(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=m(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=i({},U.gfm,{br:m(U.br).replace("{2,}","*").getRegex(),text:m(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ae){var le="",ue,ne,ce=ae.length;for(ue=0;ue<ce;ue++)ne=ae.charCodeAt(ue),Math.random()>.5&&(ne="x"+ne.toString(16)),le+="&#"+ne+";";return le}var B=function(){function ae(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||re.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:q.normal,inline:U.normal};this.options.pedantic?(ne.block=q.pedantic,ne.inline=U.pedantic):this.options.gfm&&(ne.block=q.gfm,this.options.breaks?ne.inline=U.breaks:ne.inline=U.gfm),this.tokenizer.rules=ne}ae.lex=function(ne,ce){var oe=new ae(ce);return oe.lex(ne)},ae.lexInline=function(ne,ce){var oe=new ae(ce);return oe.inlineTokens(ne)};var le=ae.prototype;return le.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},le.blockTokens=function(ne,ce){var oe=this;ce===void 0&&(ce=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(we,Pe,be){return Pe+"    ".repeat(be.length)});for(var M,z,G,te;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(M=we.call({lexer:oe},ne,ce))?(ne=ne.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.space(ne)){ne=ne.substring(M.raw.length),M.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(M);continue}if(M=this.tokenizer.code(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+M.raw,z.text+=`
`+M.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(M);continue}if(M=this.tokenizer.fences(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.heading(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.hr(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.blockquote(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.list(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.html(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.def(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+M.raw,z.text+=`
`+M.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[M.tag]||(this.tokens.links[M.tag]={href:M.href,title:M.title});continue}if(M=this.tokenizer.table(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.lheading(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(G=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Pe=ne.slice(1),be=void 0;oe.options.extensions.startBlock.forEach(function(Ce){be=Ce.call({lexer:this},Pe),typeof be=="number"&&be>=0&&(we=Math.min(we,be))}),we<1/0&&we>=0&&(G=ne.substring(0,we+1))}(),this.state.top&&(M=this.tokenizer.paragraph(G))){z=ce[ce.length-1],te&&z.type==="paragraph"?(z.raw+=`
`+M.raw,z.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(M),te=G.length!==ne.length,ne=ne.substring(M.raw.length);continue}if(M=this.tokenizer.text(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=`
`+M.raw,z.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(M);continue}if(ne){var de="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ce},le.inline=function(ne,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ne,tokens:ce}),ce},le.inlineTokens=function(ne,ce){var oe=this;ce===void 0&&(ce=[]);var M,z,G,te=ne,de,we,Pe;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)be.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,de.index)+"["+N("a",de[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,de.index)+"["+N("a",de[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,de.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(we||(Pe=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(M=ke.call({lexer:oe},ne,ce))?(ne=ne.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.escape(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.tag(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&M.type==="text"&&z.type==="text"?(z.raw+=M.raw,z.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.link(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&M.type==="text"&&z.type==="text"?(z.raw+=M.raw,z.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.emStrong(ne,te,Pe)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.codespan(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.br(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.del(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.autolink(ne,F)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(!this.state.inLink&&(M=this.tokenizer.url(ne,F))){ne=ne.substring(M.raw.length),ce.push(M);continue}if(G=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,He=ne.slice(1),Ge=void 0;oe.options.extensions.startInline.forEach(function(nt){Ge=nt.call({lexer:this},He),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(G=ne.substring(0,ke+1))}(),M=this.tokenizer.inlineText(G,T)){ne=ne.substring(M.raw.length),M.raw.slice(-1)!=="_"&&(Pe=M.raw.slice(-1)),we=!0,z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=M.raw,z.text+=M.text):ce.push(M);continue}if(ne){var Ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ce},o(ae,null,[{key:"rules",get:function(){return{block:q,inline:U}}}]),ae}(),Z=function(){function ae(ue){this.options=ue||re.defaults}var le=ae.prototype;return le.code=function(ne,ce,oe){var M=(ce||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(ne,M);z!=null&&z!==ne&&(oe=!0,ne=z)}return ne=ne.replace(/\n$/,"")+`
`,M?'<pre><code class="'+this.options.langPrefix+D(M,!0)+'">'+(oe?ne:D(ne,!0))+`</code></pre>
`:"<pre><code>"+(oe?ne:D(ne,!0))+`</code></pre>
`},le.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},le.html=function(ne){return ne},le.heading=function(ne,ce,oe,M){if(this.options.headerIds){var z=this.options.headerPrefix+M.slug(oe);return"<h"+ce+' id="'+z+'">'+ne+"</h"+ce+`>
`}return"<h"+ce+">"+ne+"</h"+ce+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(ne,ce,oe){var M=ce?"ol":"ul",z=ce&&oe!==1?' start="'+oe+'"':"";return"<"+M+z+`>
`+ne+"</"+M+`>
`},le.listitem=function(ne){return"<li>"+ne+`</li>
`},le.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(ne){return"<p>"+ne+`</p>
`},le.table=function(ne,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+ce+`</table>
`},le.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},le.tablecell=function(ne,ce){var oe=ce.header?"th":"td",M=ce.align?"<"+oe+' align="'+ce.align+'">':"<"+oe+">";return M+ne+("</"+oe+`>
`)},le.strong=function(ne){return"<strong>"+ne+"</strong>"},le.em=function(ne){return"<em>"+ne+"</em>"},le.codespan=function(ne){return"<code>"+ne+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(ne){return"<del>"+ne+"</del>"},le.link=function(ne,ce,oe){if(ne=p(this.options.sanitize,this.options.baseUrl,ne),ne===null)return oe;var M='<a href="'+D(ne)+'"';return ce&&(M+=' title="'+ce+'"'),M+=">"+oe+"</a>",M},le.image=function(ne,ce,oe){if(ne=p(this.options.sanitize,this.options.baseUrl,ne),ne===null)return oe;var M='<img src="'+ne+'" alt="'+oe+'"';return ce&&(M+=' title="'+ce+'"'),M+=this.options.xhtml?"/>":">",M},le.text=function(ne){return ne},ae}(),_=function(){function ae(){}var le=ae.prototype;return le.strong=function(ne){return ne},le.em=function(ne){return ne},le.codespan=function(ne){return ne},le.del=function(ne){return ne},le.html=function(ne){return ne},le.text=function(ne){return ne},le.link=function(ne,ce,oe){return""+oe},le.image=function(ne,ce,oe){return""+oe},le.br=function(){return""},ae}(),H=function(){function ae(){this.seen={}}var le=ae.prototype;return le.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(ne,ce){var oe=ne,M=0;if(this.seen.hasOwnProperty(oe)){M=this.seen[ne];do M++,oe=ne+"-"+M;while(this.seen.hasOwnProperty(oe))}return ce||(this.seen[ne]=M,this.seen[oe]=0),oe},le.slug=function(ne,ce){ce===void 0&&(ce={});var oe=this.serialize(ne);return this.getNextSafeSlug(oe,ce.dryrun)},ae}(),Y=function(){function ae(ue){this.options=ue||re.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new H}ae.parse=function(ne,ce){var oe=new ae(ce);return oe.parse(ne)},ae.parseInline=function(ne,ce){var oe=new ae(ce);return oe.parseInline(ne)};var le=ae.prototype;return le.parse=function(ne,ce){ce===void 0&&(ce=!0);var oe="",M,z,G,te,de,we,Pe,be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,$,K=ne.length;for(M=0;M<K;M++){if(ke=ne[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&($=this.options.extensions.renderers[ke.type].call({parser:this},ke),$!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){oe+=$||"";continue}switch(ke.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,d(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(be="",Pe="",te=ke.header.length,z=0;z<te;z++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[z].tokens),{header:!0,align:ke.align[z]});for(be+=this.renderer.tablerow(Pe),Ce="",te=ke.rows.length,z=0;z<te;z++){for(we=ke.rows[z],Pe="",de=we.length,G=0;G<de;G++)Pe+=this.renderer.tablecell(this.parseInline(we[G].tokens),{header:!1,align:ke.align[G]});Ce+=this.renderer.tablerow(Pe)}oe+=this.renderer.table(be,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),oe+=this.renderer.blockquote(Ce);continue}case"list":{for(He=ke.ordered,Ge=ke.start,nt=ke.loose,te=ke.items.length,Ce="",z=0;z<te;z++)tt=ke.items[z],rt=tt.checked,Be=tt.task,Qe="",tt.task&&(it=this.renderer.checkbox(rt),nt?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Qe+=it),Qe+=this.parse(tt.tokens,nt),Ce+=this.renderer.listitem(Qe,Be,rt);oe+=this.renderer.list(Ce,He,Ge);continue}case"html":{oe+=this.renderer.html(ke.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;M+1<K&&ne[M+1].type==="text";)ke=ne[++M],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);oe+=ce?this.renderer.paragraph(Ce):Ce;continue}default:{var he='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return oe},le.parseInline=function(ne,ce){ce=ce||this.renderer;var oe="",M,z,G,te=ne.length;for(M=0;M<te;M++){if(z=ne[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(G=this.options.extensions.renderers[z.type].call({parser:this},z),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){oe+=G||"";continue}switch(z.type){case"escape":{oe+=ce.text(z.text);break}case"html":{oe+=ce.html(z.text);break}case"link":{oe+=ce.link(z.href,z.title,this.parseInline(z.tokens,ce));break}case"image":{oe+=ce.image(z.href,z.title,z.text);break}case"strong":{oe+=ce.strong(this.parseInline(z.tokens,ce));break}case"em":{oe+=ce.em(this.parseInline(z.tokens,ce));break}case"codespan":{oe+=ce.codespan(z.text);break}case"br":{oe+=ce.br();break}case"del":{oe+=ce.del(this.parseInline(z.tokens,ce));break}case"text":{oe+=ce.text(z.text);break}default:{var de='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return oe},ae}();function ie(ae,le,ue){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=i({},ie.defaults,le||{}),w(le),ue){var ne=le.highlight,ce;try{ce=B.lex(ae,le)}catch(te){return ue(te)}var oe=function(de){var we;if(!de)try{le.walkTokens&&ie.walkTokens(ce,le.walkTokens),we=Y.parse(ce,le)}catch(Pe){de=Pe}return le.highlight=ne,de?ue(de):ue(null,we)};if(!ne||ne.length<3||(delete le.highlight,!ce.length))return oe();var M=0;ie.walkTokens(ce,function(te){te.type==="code"&&(M++,setTimeout(function(){ne(te.text,te.lang,function(de,we){if(de)return oe(de);we!=null&&we!==te.text&&(te.text=we,te.escaped=!0),M--,M===0&&oe()})},0))}),M===0&&oe();return}function z(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+D(te.message+"",!0)+"</pre>";throw te}try{var G=B.lex(ae,le);if(le.walkTokens){if(le.async)return Promise.all(ie.walkTokens(G,le.walkTokens)).then(function(){return Y.parse(G,le)}).catch(z);ie.walkTokens(G,le.walkTokens)}return Y.parse(G,le)}catch(te){z(te)}}ie.options=ie.setOptions=function(ae){return i(ie.defaults,ae),A(ie.defaults),ie},ie.getDefaults=S,ie.defaults=re.defaults,ie.use=function(){for(var ae=arguments.length,le=new Array(ae),ue=0;ue<ae;ue++)le[ue]=arguments[ue];var ne=i.apply(void 0,[{}].concat(le)),ce=ie.defaults.extensions||{renderers:{},childTokens:{}},oe;le.forEach(function(M){if(M.extensions&&(oe=!0,M.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var te=ce.renderers?ce.renderers[G.name]:null;te?ce.renderers[G.name]=function(){for(var de=arguments.length,we=new Array(de),Pe=0;Pe<de;Pe++)we[Pe]=arguments[Pe];var be=G.renderer.apply(this,we);return be===!1&&(be=te.apply(this,we)),be}:ce.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[G.level]?ce[G.level].unshift(G.tokenizer):ce[G.level]=[G.tokenizer],G.start&&(G.level==="block"?ce.startBlock?ce.startBlock.push(G.start):ce.startBlock=[G.start]:G.level==="inline"&&(ce.startInline?ce.startInline.push(G.start):ce.startInline=[G.start]))}G.childTokens&&(ce.childTokens[G.name]=G.childTokens)})),M.renderer&&function(){var G=ie.defaults.renderer||new Z,te=function(Pe){var be=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),He=0;He<Ce;He++)ke[He]=arguments[He];var Ge=M.renderer[Pe].apply(G,ke);return Ge===!1&&(Ge=be.apply(G,ke)),Ge}};for(var de in M.renderer)te(de);ne.renderer=G}(),M.tokenizer&&function(){var G=ie.defaults.tokenizer||new Q,te=function(Pe){var be=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),He=0;He<Ce;He++)ke[He]=arguments[He];var Ge=M.tokenizer[Pe].apply(G,ke);return Ge===!1&&(Ge=be.apply(G,ke)),Ge}};for(var de in M.tokenizer)te(de);ne.tokenizer=G}(),M.walkTokens){var z=ie.defaults.walkTokens;ne.walkTokens=function(G){var te=[];return te.push(M.walkTokens.call(this,G)),z&&(te=te.concat(z.call(this,G))),te}}oe&&(ne.extensions=ce),ie.setOptions(ne)})},ie.walkTokens=function(ae,le){for(var ue=[],ne=function(){var z=oe.value;switch(ue=ue.concat(le.call(ie,z)),z.type){case"table":{for(var G=R(z.header),te;!(te=G()).done;){var de=te.value;ue=ue.concat(ie.walkTokens(de.tokens,le))}for(var we=R(z.rows),Pe;!(Pe=we()).done;)for(var be=Pe.value,Ce=R(be),ke;!(ke=Ce()).done;){var He=ke.value;ue=ue.concat(ie.walkTokens(He.tokens,le))}break}case"list":{ue=ue.concat(ie.walkTokens(z.items,le));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[z.type]?ie.defaults.extensions.childTokens[z.type].forEach(function(Ge){ue=ue.concat(ie.walkTokens(z[Ge],le))}):z.tokens&&(ue=ue.concat(ie.walkTokens(z.tokens,le)))}},ce=R(ae),oe;!(oe=ce()).done;)ne();return ue},ie.parseInline=function(ae,le){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");le=i({},ie.defaults,le||{}),w(le);try{var ue=B.lexInline(ae,le);return le.walkTokens&&ie.walkTokens(ue,le.walkTokens),Y.parseInline(ue,le)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+D(ne.message+"",!0)+"</pre>";throw ne}},ie.Parser=Y,ie.parser=Y.parse,ie.Renderer=Z,ie.TextRenderer=_,ie.Lexer=B,ie.lexer=B.lex,ie.Tokenizer=Q,ie.Slugger=H,ie.parse=ie;var ge=ie.options,X=ie.setOptions,J=ie.use,ee=ie.walkTokens,me=ie.parseInline,ve=ie,Ie=Y.parse,Re=B.lex;re.Lexer=B,re.Parser=Y,re.Renderer=Z,re.Slugger=H,re.TextRenderer=_,re.Tokenizer=Q,re.getDefaults=S,re.lexer=Re,re.marked=ie,re.options=ge,re.parse=ve,re.parseInline=me,re.parser=Ie,re.setOptions=X,re.use=J,re.walkTokens=ee,Object.defineProperty(re,"__esModule",{value:!0})}),define(ye[86],De([1,0,28]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new o.LRUCache(1e4);function l(I){return y(I,"NFC",L)}e.normalizeNFC=l;const R=new o.LRUCache(1e4);function S(I){return y(I,"NFD",R)}e.normalizeNFD=S;const A=/[^\u0000-\u0080]/;function y(I,O,P){if(!I)return I;const v=P.get(I);if(v)return v;let k;return A.test(I)?k=I.normalize(O):k=I,P.set(I,k),k}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(O){return S(O).replace(I,"")}}()}),define(ye[102],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(A,y,I){return Math.min(Math.max(A,y),I)}e.clamp=o;function L(A,y){return(y+A%y)%y}e.rot=L;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class S{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const I=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=S}),function(){function re(l){const R=[];typeof l=="number"&&R.push("code/timeOrigin",l);function S(y){R.push(y,Date.now())}function A(){const y=[];for(let I=0;I<R.length;I+=2)y.push({name:R[I],startTime:R[I+1]});return y}return{mark:S,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const S of performance.getEntriesByType("mark"))R.push({name:S.name,startTime:Math.round(l+S.startTime)});return R}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function o(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=o(L))}(),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var L in o)(typeof exports=="object"?exports:re)[L]=o[L]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function o(L){if(e[L])return e[L].exports;var l=e[L]={i:L,l:!1,exports:{}};return re[L].call(l.exports,l,l.exports,o),l.l=!0,l.exports}return o.m=re,o.c=e,o.d=function(L,l,R){o.o(L,l)||Object.defineProperty(L,l,{enumerable:!0,get:R})},o.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},o.t=function(L,l){if(1&l&&(L=o(L)),8&l||4&l&&typeof L=="object"&&L&&L.__esModule)return L;var R=Object.create(null);if(o.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:L}),2&l&&typeof L!="string")for(var S in L)o.d(R,S,function(A){return L[A]}.bind(null,S));return R},o.n=function(L){var l=L&&L.__esModule?function(){return L.default}:function(){return L};return o.d(l,"a",l),l},o.o=function(L,l){return Object.prototype.hasOwnProperty.call(L,l)},o.p="",o(o.s=0)}([function(re,e,o){(function(L){var l;e=re.exports=J,l=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var be=Array.prototype.slice.call(arguments,0);be.unshift("SEMVER"),console.log.apply(console,be)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],I=0,O=I++;y[O]="0|[1-9]\\d*";var P=I++;y[P]="[0-9]+";var v=I++;y[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=I++;y[k]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var D=I++;y[D]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var f=I++;y[f]="(?:"+y[O]+"|"+y[v]+")";var d=I++;y[d]="(?:"+y[P]+"|"+y[v]+")";var u=I++;y[u]="(?:-("+y[f]+"(?:\\."+y[f]+")*))";var m=I++;y[m]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var b=I++;y[b]="[0-9A-Za-z-]+";var C=I++;y[C]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var p=I++,n="v?"+y[k]+y[u]+"?"+y[C]+"?";y[p]="^"+n+"$";var s="[v=\\s]*"+y[D]+y[m]+"?"+y[C]+"?",r=I++;y[r]="^"+s+"$";var a=I++;y[a]="((?:<|>)?=?)";var c=I++;y[c]=y[P]+"|x|X|\\*";var g=I++;y[g]=y[O]+"|x|X|\\*";var i=I++;y[i]="[v=\\s]*("+y[g]+")(?:\\.("+y[g]+")(?:\\.("+y[g]+")(?:"+y[u]+")?"+y[C]+"?)?)?";var t=I++;y[t]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[m]+")?"+y[C]+"?)?)?";var h=I++;y[h]="^"+y[a]+"\\s*"+y[i]+"$";var E=I++;y[E]="^"+y[a]+"\\s*"+y[t]+"$";var w=I++;y[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=I++;y[N]="(?:~>?)";var j=I++;y[j]="(\\s*)"+y[N]+"\\s+",A[j]=new RegExp(y[j],"g");var V=I++;y[V]="^"+y[N]+y[i]+"$";var Q=I++;y[Q]="^"+y[N]+y[t]+"$";var q=I++;y[q]="(?:\\^)";var U=I++;y[U]="(\\s*)"+y[q]+"\\s+",A[U]=new RegExp(y[U],"g");var T=I++;y[T]="^"+y[q]+y[i]+"$";var F=I++;y[F]="^"+y[q]+y[t]+"$";var B=I++;y[B]="^"+y[a]+"\\s*("+s+")$|^$";var Z=I++;y[Z]="^"+y[a]+"\\s*("+n+")$|^$";var _=I++;y[_]="(\\s*)"+y[a]+"\\s*("+s+"|"+y[i]+")",A[_]=new RegExp(y[_],"g");var H=I++;y[H]="^\\s*("+y[i]+")\\s+-\\s+("+y[i]+")\\s*$";var Y=I++;y[Y]="^\\s*("+y[t]+")\\s+-\\s+("+y[t]+")\\s*$";var ie=I++;y[ie]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)l(ge,y[ge]),A[ge]||(A[ge]=new RegExp(y[ge]));function X(be,Ce){if(be instanceof J)return be;if(typeof be!="string"||be.length>R||!(Ce?A[r]:A[p]).test(be))return null;try{return new J(be,Ce)}catch{return null}}function J(be,Ce){if(be instanceof J){if(be.loose===Ce)return be;be=be.version}else if(typeof be!="string")throw new TypeError("Invalid Version: "+be);if(be.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof J))return new J(be,Ce);l("SemVer",be,Ce),this.loose=Ce;var ke=be.trim().match(Ce?A[r]:A[p]);if(!ke)throw new TypeError("Invalid Version: "+be);if(this.raw=be,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var Ge=+He;if(Ge>=0&&Ge<S)return Ge}return He}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=X,e.valid=function(be,Ce){var ke=X(be,Ce);return ke?ke.version:null},e.clean=function(be,Ce){var ke=X(be.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(be){return l("SemVer.compare",this.version,this.loose,be),be instanceof J||(be=new J(be,this.loose)),this.compareMain(be)||this.comparePre(be)},J.prototype.compareMain=function(be){return be instanceof J||(be=new J(be,this.loose)),me(this.major,be.major)||me(this.minor,be.minor)||me(this.patch,be.patch)},J.prototype.comparePre=function(be){if(be instanceof J||(be=new J(be,this.loose)),this.prerelease.length&&!be.prerelease.length)return-1;if(!this.prerelease.length&&be.prerelease.length)return 1;if(!this.prerelease.length&&!be.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],He=be.prerelease[Ce];if(l("prerelease compare",Ce,ke,He),ke===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(ke===void 0)return-1;if(ke!==He)return me(ke,He)}while(++Ce)},J.prototype.inc=function(be,Ce){switch(be){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+be)}return this.format(),this.raw=this.version,this},e.inc=function(be,Ce,ke,He){typeof ke=="string"&&(He=ke,ke=void 0);try{return new J(be,ke).inc(Ce,He).version}catch{return null}},e.diff=function(be,Ce){if(ae(be,Ce))return null;var ke=X(be),He=X(Ce);if(ke.prerelease.length||He.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==He[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==He[Ge])return Ge},e.compareIdentifiers=me;var ee=/^[0-9]+$/;function me(be,Ce){var ke=ee.test(be),He=ee.test(Ce);return ke&&He&&(be=+be,Ce=+Ce),ke&&!He?-1:He&&!ke?1:be<Ce?-1:be>Ce?1:0}function ve(be,Ce,ke){return new J(be,ke).compare(new J(Ce,ke))}function Ie(be,Ce,ke){return ve(be,Ce,ke)>0}function Re(be,Ce,ke){return ve(be,Ce,ke)<0}function ae(be,Ce,ke){return ve(be,Ce,ke)===0}function le(be,Ce,ke){return ve(be,Ce,ke)!==0}function ue(be,Ce,ke){return ve(be,Ce,ke)>=0}function ne(be,Ce,ke){return ve(be,Ce,ke)<=0}function ce(be,Ce,ke,He){var Ge;switch(Ce){case"===":typeof be=="object"&&(be=be.version),typeof ke=="object"&&(ke=ke.version),Ge=be===ke;break;case"!==":typeof be=="object"&&(be=be.version),typeof ke=="object"&&(ke=ke.version),Ge=be!==ke;break;case"":case"=":case"==":Ge=ae(be,ke,He);break;case"!=":Ge=le(be,ke,He);break;case">":Ge=Ie(be,ke,He);break;case">=":Ge=ue(be,ke,He);break;case"<":Ge=Re(be,ke,He);break;case"<=":Ge=ne(be,ke,He);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ge}function oe(be,Ce){if(be instanceof oe){if(be.loose===Ce)return be;be=be.value}if(!(this instanceof oe))return new oe(be,Ce);l("comparator",be,Ce),this.loose=Ce,this.parse(be),this.semver===M?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(be,Ce){return me(Ce,be)},e.major=function(be,Ce){return new J(be,Ce).major},e.minor=function(be,Ce){return new J(be,Ce).minor},e.patch=function(be,Ce){return new J(be,Ce).patch},e.compare=ve,e.compareLoose=function(be,Ce){return ve(be,Ce,!0)},e.rcompare=function(be,Ce,ke){return ve(Ce,be,ke)},e.sort=function(be,Ce){return be.sort(function(ke,He){return e.compare(ke,He,Ce)})},e.rsort=function(be,Ce){return be.sort(function(ke,He){return e.rcompare(ke,He,Ce)})},e.gt=Ie,e.lt=Re,e.eq=ae,e.neq=le,e.gte=ue,e.lte=ne,e.cmp=ce,e.Comparator=oe;var M={};function z(be,Ce){if(be instanceof z)return be.loose===Ce?be:new z(be.raw,Ce);if(be instanceof oe)return new z(be.value,Ce);if(!(this instanceof z))return new z(be,Ce);if(this.loose=Ce,this.raw=be,this.set=be.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+be);this.format()}function G(be){return!be||be.toLowerCase()==="x"||be==="*"}function te(be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,$,K){return((Ce=G(ke)?"":G(He)?">="+ke+".0.0":G(Ge)?">="+ke+"."+He+".0":">="+Ce)+" "+(tt=G(rt)?"":G(Be)?"<"+(+rt+1)+".0.0":G(it)?"<"+rt+"."+(+Be+1)+".0":$?"<="+rt+"."+Be+"."+it+"-"+$:"<="+tt)).trim()}function de(be,Ce){for(var ke=0;ke<be.length;ke++)if(!be[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<be.length;ke++)if(l(be[ke].semver),be[ke].semver!==M&&be[ke].semver.prerelease.length>0){var He=be[ke].semver;if(He.major===Ce.major&&He.minor===Ce.minor&&He.patch===Ce.patch)return!0}return!1}return!0}function we(be,Ce,ke){try{Ce=new z(Ce,ke)}catch{return!1}return Ce.test(be)}function Pe(be,Ce,ke,He){var Ge,nt,Qe,tt,rt;switch(be=new J(be,He),Ce=new z(Ce,He),ke){case">":Ge=Ie,nt=ne,Qe=Re,tt=">",rt=">=";break;case"<":Ge=Re,nt=ue,Qe=Ie,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(be,Ce,He))return!1;for(var Be=0;Be<Ce.set.length;++Be){var it=Ce.set[Be],$=null,K=null;if(it.forEach(function(he){he.semver===M&&(he=new oe(">=0.0.0")),$=$||he,K=K||he,Ge(he.semver,$.semver,He)?$=he:Qe(he.semver,K.semver,He)&&(K=he)}),$.operator===tt||$.operator===rt||(!K.operator||K.operator===tt)&&nt(be,K.semver)||K.operator===rt&&Qe(be,K.semver))return!1}return!0}oe.prototype.parse=function(be){var Ce=this.loose?A[B]:A[Z],ke=be.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+be);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new J(ke[2],this.loose):this.semver=M},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(be){return l("Comparator.test",be,this.loose),this.semver===M||(typeof be=="string"&&(be=new J(be,this.loose)),ce(be,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(be,Ce){if(!(be instanceof oe))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new z(be.value,Ce),we(this.value,ke,Ce);if(be.operator==="")return ke=new z(this.value,Ce),we(be.semver,ke,Ce);var He=!(this.operator!==">="&&this.operator!==">"||be.operator!==">="&&be.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||be.operator!=="<="&&be.operator!=="<"),nt=this.semver.version===be.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||be.operator!==">="&&be.operator!=="<="),tt=ce(this.semver,"<",be.semver,Ce)&&(this.operator===">="||this.operator===">")&&(be.operator==="<="||be.operator==="<"),rt=ce(this.semver,">",be.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(be.operator===">="||be.operator===">");return He||Ge||nt&&Qe||tt||rt},e.Range=z,z.prototype.format=function(){return this.range=this.set.map(function(be){return be.join(" ").trim()}).join("||").trim(),this.range},z.prototype.toString=function(){return this.range},z.prototype.parseRange=function(be){var Ce=this.loose;be=be.trim(),l("range",be,Ce);var ke=Ce?A[Y]:A[H];be=be.replace(ke,te),l("hyphen replace",be),be=be.replace(A[_],"$1$2$3"),l("comparator trim",be,A[_]),be=(be=(be=be.replace(A[j],"$1~")).replace(A[U],"$1^")).split(/\s+/).join(" ");var He=Ce?A[B]:A[Z],Ge=be.split(" ").map(function(nt){return function(Qe,tt){return l("comp",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function($,K){l("caret",$,K);var he=K?A[F]:A[T];return $.replace(he,function(Le,Ne,qe,je,Ze){var st;return l("caret",$,Le,Ne,qe,je,Ze),G(Ne)?st="":G(qe)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":G(je)?st=Ne==="0"?">="+Ne+"."+qe+".0 <"+Ne+"."+(+qe+1)+".0":">="+Ne+"."+qe+".0 <"+(+Ne+1)+".0.0":Ze?(l("replaceCaret pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=Ne==="0"?qe==="0"?">="+Ne+"."+qe+"."+je+Ze+" <"+Ne+"."+qe+"."+(+je+1):">="+Ne+"."+qe+"."+je+Ze+" <"+Ne+"."+(+qe+1)+".0":">="+Ne+"."+qe+"."+je+Ze+" <"+(+Ne+1)+".0.0"):(l("no pr"),st=Ne==="0"?qe==="0"?">="+Ne+"."+qe+"."+je+" <"+Ne+"."+qe+"."+(+je+1):">="+Ne+"."+qe+"."+je+" <"+Ne+"."+(+qe+1)+".0":">="+Ne+"."+qe+"."+je+" <"+(+Ne+1)+".0.0"),l("caret return",st),st})}(it,Be)}).join(" ")}(Qe,tt),l("caret",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function($,K){var he=K?A[Q]:A[V];return $.replace(he,function(Le,Ne,qe,je,Ze){var st;return l("tilde",$,Le,Ne,qe,je,Ze),G(Ne)?st="":G(qe)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":G(je)?st=">="+Ne+"."+qe+".0 <"+Ne+"."+(+qe+1)+".0":Ze?(l("replaceTilde pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=">="+Ne+"."+qe+"."+je+Ze+" <"+Ne+"."+(+qe+1)+".0"):st=">="+Ne+"."+qe+"."+je+" <"+Ne+"."+(+qe+1)+".0",l("tilde return",st),st})}(it,Be)}).join(" ")}(Qe,tt),l("tildes",Qe),Qe=function(rt,Be){return l("replaceXRanges",rt,Be),rt.split(/\s+/).map(function(it){return function($,K){$=$.trim();var he=K?A[E]:A[h];return $.replace(he,function(Le,Ne,qe,je,Ze,st){l("xRange",$,Le,Ne,qe,je,Ze,st);var at=G(qe),mt=at||G(je),gt=mt||G(Ze);return Ne==="="&&gt&&(Ne=""),at?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&gt?(mt&&(je=0),gt&&(Ze=0),Ne===">"?(Ne=">=",mt?(qe=+qe+1,je=0,Ze=0):gt&&(je=+je+1,Ze=0)):Ne==="<="&&(Ne="<",mt?qe=+qe+1:je=+je+1),Le=Ne+qe+"."+je+"."+Ze):mt?Le=">="+qe+".0.0 <"+(+qe+1)+".0.0":gt&&(Le=">="+qe+"."+je+".0 <"+qe+"."+(+je+1)+".0"),l("xRange return",Le),Le})}(it,Be)}).join(" ")}(Qe,tt),l("xrange",Qe),Qe=function(rt,Be){return l("replaceStars",rt,Be),rt.trim().replace(A[ie],"")}(Qe,tt),l("stars",Qe),Qe}(nt,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(nt){return!!nt.match(He)})),Ge=Ge.map(function(nt){return new oe(nt,Ce)})},z.prototype.intersects=function(be,Ce){if(!(be instanceof z))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(He){return be.set.some(function(Ge){return Ge.every(function(nt){return He.intersects(nt,Ce)})})})})},e.toComparators=function(be,Ce){return new z(be,Ce).set.map(function(ke){return ke.map(function(He){return He.value}).join(" ").trim().split(" ")})},z.prototype.test=function(be){if(!be)return!1;typeof be=="string"&&(be=new J(be,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(de(this.set[Ce],be))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(be,Ce,ke){var He=null,Ge=null;try{var nt=new z(Ce,ke)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(He&&Ge.compare(Qe)!==-1||(Ge=new J(He=Qe,ke)))}),He},e.minSatisfying=function(be,Ce,ke){var He=null,Ge=null;try{var nt=new z(Ce,ke)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(He&&Ge.compare(Qe)!==1||(Ge=new J(He=Qe,ke)))}),He},e.validRange=function(be,Ce){try{return new z(be,Ce).range||"*"}catch{return null}},e.ltr=function(be,Ce,ke){return Pe(be,Ce,"<",ke)},e.gtr=function(be,Ce,ke){return Pe(be,Ce,">",ke)},e.outside=Pe,e.prerelease=function(be,Ce){var ke=X(be,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(be,Ce,ke){return be=new z(be,ke),Ce=new z(Ce,ke),be.intersects(Ce)},e.coerce=function(be){if(be instanceof J)return be;if(typeof be!="string")return null;var Ce=be.match(A[w]);return Ce==null?null:X((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,o(1))},function(re,e){var o,L,l=re.exports={};function R(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function A(d){if(o===setTimeout)return setTimeout(d,0);if((o===R||!o)&&setTimeout)return o=setTimeout,setTimeout(d,0);try{return o(d,0)}catch{try{return o.call(null,d,0)}catch{return o.call(this,d,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:R}catch{o=R}try{L=typeof clearTimeout=="function"?clearTimeout:S}catch{L=S}})();var y,I=[],O=!1,P=-1;function v(){O&&y&&(O=!1,y.length?I=y.concat(I):P=-1,I.length&&k())}function k(){if(!O){var d=A(v);O=!0;for(var u=I.length;u;){for(y=I,I=[];++P<u;)y&&y[P].run();P=-1,u=I.length}y=null,O=!1,function(m){if(L===clearTimeout)return clearTimeout(m);if((L===S||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(m);try{L(m)}catch{try{return L.call(null,m)}catch{return L.call(this,m)}}}(d)}}function D(d,u){this.fun=d,this.array=u}function f(){}l.nextTick=function(d){var u=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)u[m-1]=arguments[m];I.push(new D(d,u)),I.length!==1||O||A(k)},D.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=f,l.addListener=f,l.once=f,l.off=f,l.removeListener=f,l.removeAllListeners=f,l.emit=f,l.prependListener=f,l.prependOnceListener=f,l.listeners=function(d){return[]},l.binding=function(d){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(d){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(ye[103],De([1,0,10,6]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(C){const p=C;return p?typeof p.read=="function":!1}e.isReadable=l;function R(C){const p=C;return p?[p.on,p.pause,p.resume,p.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=R;function S(C){const p=C;return p?R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=S;function A(C,p){return new y(C,p)}e.newWriteableStream=A;class y{constructor(p,n){this.e=p,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(n=>n(p))}h(p){this.c.error.length===0?(0,o.onUnexpectedError)(p):this.c.error.slice(0).forEach(n=>n(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,n){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(p,n){if(this.a.destroyed)return;let s;switch(p){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(n);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function I(C,p){const n=[];let s;for(;(s=C.read())!==null;)n.push(s);return p(n)}e.consumeReadable=I;function O(C,p,n){const s=[];let r;for(;(r=C.read())!==null&&s.length<n;)s.push(r);return r===null&&s.length>0?p(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return C.read()}}}e.peekReadable=O;function P(C,p){return new Promise((n,s)=>{const r=[];v(C,{onData:a=>{p&&r.push(a)},onError:a=>{p?s(a):n(void 0)},onEnd:()=>{n(p?p(r):void 0)}})})}e.consumeStream=P;function v(C,p){let n=!1;return C.on("error",s=>{n||p.onError(s)}),C.on("end",()=>{n||p.onEnd()}),C.on("data",s=>{n||p.onData(s)}),(0,L.toDisposable)(()=>n=!0)}e.listenStream=v;function k(C,p){return new Promise((n,s)=>{const r=new L.DisposableStore,a=[],c=t=>{if(a.push(t),a.length>p)return r.dispose(),C.pause(),n({stream:C,buffer:a,ended:!1})},g=t=>s(t),i=()=>n({stream:C,buffer:a,ended:!0});r.add((0,L.toDisposable)(()=>C.removeListener("error",g))),C.on("error",g),r.add((0,L.toDisposable)(()=>C.removeListener("end",i))),C.on("end",i),r.add((0,L.toDisposable)(()=>C.removeListener("data",c))),C.on("data",c)})}e.peekStream=k;function D(C,p){const n=A(p);return n.end(C),n}e.toStream=D;function f(){const C=A(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=f;function d(C){let p=!1;return{read:()=>p?null:(p=!0,C)}}e.toReadable=d;function u(C,p,n){const s=A(n);return v(C,{onData:r=>s.write(p.data(r)),onError:r=>s.error(p.error?p.error(r):r),onEnd:()=>s.end()}),s}e.transform=u;function m(C,p,n){let s=!1;return{read:()=>{const r=p.read();return s?r:(s=!0,r!==null?n([C,r]):C)}}}e.prefixedReadable=m;function b(C,p,n){let s=!1;const r=A(n);return v(p,{onData:a=>s?r.write(a):(s=!0,r.write(n([C,a]))),onError:a=>r.error(a),onEnd:()=>{s||(s=!0,r.write(C)),r.end()}}),r}e.prefixedStream=b}),define(ye[22],De([1,0,103]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let l,R;class S{static alloc(t){return L?new S(Buffer.allocUnsafe(t)):new S(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new S(t)}static fromString(t,h){return!(h?.dontUseNodeBuffer||!1)&&L?new S(Buffer.from(t)):(l||(l=new TextEncoder),new S(l.encode(t)))}static fromByteArray(t){const h=S.alloc(t.length);for(let E=0,w=t.length;E<w;E++)h.buffer[E]=t[E];return h}static concat(t,h){if(typeof h>"u"){h=0;for(let N=0,j=t.length;N<j;N++)h+=t[N].byteLength}const E=S.alloc(h);let w=0;for(let N=0,j=t.length;N<j;N++){const V=t[N];E.set(V,w),w+=V.byteLength}return E}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=S.alloc(this.byteLength);return t.set(this),t}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,h){return new S(this.buffer.subarray(t,h))}set(t,h){if(t instanceof S)this.buffer.set(t.buffer,h);else if(t instanceof Uint8Array)this.buffer.set(t,h);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),h);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,h){O(this.buffer,t,h)}readUInt32LE(t){return P(this.buffer,t)}writeUInt32LE(t,h){v(this.buffer,t,h)}readUInt8(t){return k(this.buffer,t)}writeUInt8(t,h){D(this.buffer,t,h)}}e.VSBuffer=S;function A(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0}e.readUInt16LE=A;function y(i,t,h){i[h+0]=t&255,t=t>>>8,i[h+1]=t&255}e.writeUInt16LE=y;function I(i,t){return i[t]*2**24+i[t+1]*2**16+i[t+2]*2**8+i[t+3]}e.readUInt32BE=I;function O(i,t,h){i[h+3]=t,t=t>>>8,i[h+2]=t,t=t>>>8,i[h+1]=t,t=t>>>8,i[h]=t}e.writeUInt32BE=O;function P(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0|i[t+2]<<16>>>0|i[t+3]<<24>>>0}e.readUInt32LE=P;function v(i,t,h){i[h+0]=t&255,t=t>>>8,i[h+1]=t&255,t=t>>>8,i[h+2]=t&255,t=t>>>8,i[h+3]=t&255}e.writeUInt32LE=v;function k(i,t){return i[t]}e.readUInt8=k;function D(i,t,h){i[h]=t}e.writeUInt8=D;function f(i){return o.consumeReadable(i,t=>S.concat(t))}e.readableToBuffer=f;function d(i){return o.toReadable(i)}e.bufferToReadable=d;function u(i){return o.consumeStream(i,t=>S.concat(t))}e.streamToBuffer=u;async function m(i){return i.ended?S.concat(i.buffer):S.concat([...i.buffer,await u(i.stream)])}e.bufferedStreamToBuffer=m;function b(i){return o.toStream(i,t=>S.concat(t))}e.bufferToStream=b;function C(i){return o.transform(i,{data:t=>typeof t=="string"?S.fromString(t):S.wrap(t)},t=>S.concat(t))}e.streamToBufferReadableStream=C;function p(i){return o.newWriteableStream(t=>S.concat(t),i)}e.newWriteableBufferStream=p;function n(i,t){return o.prefixedReadable(i,t,h=>S.concat(h))}e.prefixedBufferReadable=n;function s(i,t){return o.prefixedStream(i,t,h=>S.concat(h))}e.prefixedBufferStream=s;function r(i){let t=0,h=0,E=0;const w=new Uint8Array(Math.floor(i.length/4*3)),N=V=>{switch(h){case 3:w[E++]=t|V,h=0;break;case 2:w[E++]=t|V>>>2,t=V<<6,h=3;break;case 1:w[E++]=t|V>>>4,t=V<<4,h=2;break;default:t=V<<2,h=1}};for(let V=0;V<i.length;V++){const Q=i.charCodeAt(V);if(Q>=65&&Q<=90)N(Q-65);else if(Q>=97&&Q<=122)N(Q-97+26);else if(Q>=48&&Q<=57)N(Q-48+52);else if(Q===43||Q===45)N(62);else if(Q===47||Q===95)N(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${i[V]}`)}}const j=E;for(;h>0;)N(0);return S.wrap(w).slice(0,j)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:i},t=!0,h=!1){const E=h?c:a;let w="";const N=i.byteLength%3;let j=0;for(;j<i.byteLength-N;j+=3){const V=i[j+0],Q=i[j+1],q=i[j+2];w+=E[V>>>2],w+=E[(V<<4|Q>>>4)&63],w+=E[(Q<<2|q>>>6)&63],w+=E[q&63]}if(N===1){const V=i[j+0];w+=E[V>>>2],w+=E[V<<4&63],t&&(w+="==")}else if(N===2){const V=i[j+0],Q=i[j+1];w+=E[V>>>2],w+=E[(V<<4|Q>>>4)&63],w+=E[Q<<2&63],t&&(w+="=")}return w}e.encodeBase64=g}),define(ye[148],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[9],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function L(s){return Array.isArray(s)&&s.every(r=>o(r))}e.isStringArray=L;function l(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=l;function R(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}e.isTypedArray=R;function S(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=S;function A(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=A;function y(s){return s===!0||s===!1}e.isBoolean=y;function I(s){return typeof s>"u"}e.isUndefined=I;function O(s){return!P(s)}e.isDefined=O;function P(s){return I(s)||s===null}e.isUndefinedOrNull=P;function v(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=v;function k(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=k;function D(...s){const r=[];for(let a=0;a<s.length;a++){const c=s[a];if(P(c))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);r.push(c)}return r}e.assertAllDefined=D;const f=Object.prototype.hasOwnProperty;function d(s){if(!l(s))return!1;for(const r in s)if(f.call(s,r))return!1;return!0}e.isEmptyObject=d;function u(s){return typeof s=="function"}e.isFunction=u;function m(...s){return s.length>0&&s.every(u)}e.areFunctions=m;function b(s,r){const a=Math.min(s.length,r.length);for(let c=0;c<a;c++)C(s[c],r[c])}e.validateConstraints=b;function C(s,r){if(o(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(u(r)){try{if(s instanceof r)return}catch{}if(!P(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=C;function p(s){return s===null?void 0:s}e.withNullAsUndefined=p;function n(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=n}),define(ye[67],De([1,0,9]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function l(A,y){if((0,o.isString)(y)){const I=L[y];if(I===void 0)throw new Error(`${A} references an unknown codicon: ${y}`);y=I}return L[A]=y,{id:A}}function R(){return L}e.getCodiconFontCharacters=R;function S(){return Object.values(e.Codicon)}e.getAllCodicons=S,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(ye[23],De([1,0,9]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const m=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([b,C])=>{m[b]=C&&typeof C=="object"?L(C):C}),m}e.deepClone=L;function l(u){if(!u||typeof u!="object")return u;const m=[u];for(;m.length>0;){const b=m.shift();Object.freeze(b);for(const C in b)if(R.call(b,C)){const p=b[C];typeof p=="object"&&!Object.isFrozen(p)&&!(0,o.isTypedArray)(p)&&m.push(p)}}return u}e.deepFreeze=l;const R=Object.prototype.hasOwnProperty;function S(u,m){return A(u,m,new Set)}e.cloneAndChange=S;function A(u,m,b){if((0,o.isUndefinedOrNull)(u))return u;const C=m(u);if(typeof C<"u")return C;if(Array.isArray(u)){const p=[];for(const n of u)p.push(A(n,m,b));return p}if((0,o.isObject)(u)){if(b.has(u))throw new Error("Cannot clone recursive data-structure");b.add(u);const p={};for(const n in u)R.call(u,n)&&(p[n]=A(u[n],m,b));return b.delete(u),p}return u}function y(u,m,b=!0){return(0,o.isObject)(u)?((0,o.isObject)(m)&&Object.keys(m).forEach(C=>{C in u?b&&((0,o.isObject)(u[C])&&(0,o.isObject)(m[C])?y(u[C],m[C],b):u[C]=m[C]):u[C]=m[C]}),u):m}e.mixin=y;function I(u,m){if(u===m)return!0;if(u==null||m===null||m===void 0||typeof u!=typeof m||typeof u!="object"||Array.isArray(u)!==Array.isArray(m))return!1;let b,C;if(Array.isArray(u)){if(u.length!==m.length)return!1;for(b=0;b<u.length;b++)if(!I(u[b],m[b]))return!1}else{const p=[];for(C in u)p.push(C);p.sort();const n=[];for(C in m)n.push(C);if(n.sort(),!I(p,n))return!1;for(b=0;b<p.length;b++)if(!I(u[p[b]],m[p[b]]))return!1}return!0}e.equals=I;function O(u){const m=new Set;return JSON.stringify(u,(b,C)=>{if((0,o.isObject)(C)||Array.isArray(C)){if(m.has(C))return"[Circular]";m.add(C)}return C})}e.safeStringify=O;function P(u,m){const b=Object.create(null);return!u||!m||Object.keys(m).forEach(p=>{const n=u[p],s=m[p];I(n,s)||(b[p]=s)}),b}e.distinct=P;function v(u,m){const b=m.toLowerCase(),C=Object.keys(u).find(p=>p.toLowerCase()===b);return C?u[C]:u[m]}e.getCaseInsensitive=v;function k(u,m){const b=Object.create(null);for(const[C,p]of Object.entries(u))m(C,p)&&(b[C]=p);return b}e.filter=k;function D(u){let m=[],b=Object.getPrototypeOf(u);for(;Object.prototype!==b;)m=m.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return m}e.getAllPropertyNames=D;function f(u){const m=[];for(const b of D(u))typeof u[b]=="function"&&m.push(b);return m}e.getAllMethodNames=f;function d(u,m){const b=p=>function(){const n=Array.prototype.slice.call(arguments,0);return m(p,n)},C={};for(const p of u)C[p]=b(p);return C}e.createProxyObject=d}),define(ye[51],De([1,0,67]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(S){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}S.isThemeColor=A})(L=e.ThemeColor||(e.ThemeColor={}));function l(S){return{id:S}}e.themeColorFromId=l;var R;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function y(m){const b=A.exec(m.id);if(!b)return y(o.Codicon.error);const[,C,p]=b,n=["codicon","codicon-"+C];return p&&n.push("codicon-modifier-"+p.substring(1)),n}S.asClassNameArray=y;function I(m){return y(m).join(" ")}S.asClassName=I;function O(m){return"."+y(m).join(".")}S.asCSSSelector=O;function P(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||L.isThemeColor(m.color))}S.isThemeIcon=P;const v=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function k(m){const b=v.exec(m);if(!b)return;const[,C]=b;return{id:C}}S.fromString=k;function D(m){return{id:m}}S.fromId=D;function f(m,b){let C=m.id;const p=C.lastIndexOf("~");return p!==-1&&(C=C.substring(0,p)),b&&(C=`${C}~${b}`),{id:C}}S.modify=f;function d(m){const b=m.id.lastIndexOf("~");if(b!==-1)return m.id.substring(b+1)}S.getModifier=d;function u(m,b){return m.id===b.id&&m.color?.id===b.color?.id}S.isEqual=u})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(ye[104],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o=e.Constants||(e.Constants={}));function L(R){return R<0?0:R>255?255:R|0}e.toUint8=L;function l(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=l}),define(ye[30],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(l){return o.test(l)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),S=[];for(let A=0;A<256;A++)S.push(A.toString(16).padStart(2,"0"));return function(){l(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,I="";return I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I}}()}),define(ye[149],De([1,0,15,30]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(A){return{id:(0,L.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=l;function R(A,y,I){return{id:(0,L.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:I}),value:void 0}}e.createFileDataTransferItem=R;class S{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,I){const O=this.a.get(y);O?O.push(I):this.a.set(this.b(y),[I])}replace(y,I){this.a.set(this.b(y),[I])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,I]of this.a.entries())for(const O of I)yield[y,O]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[I,O]of this.entries())y(O,I)}b(y){return y.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:A=>(0,o.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[105],De([1,0,104]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(A){const y=(0,o.toUint8)(A);this.c=y,this.a=L.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const I=(0,o.toUint8)(y);A>=0&&A<256?this.a[A]=I:this.b.set(A,I)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=L;var l;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(l||(l={}));class R{constructor(){this.a=new L(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[52],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(l,R){this.lineNumber=l,this.column=R}with(l=this.lineNumber,R=this.column){return l===this.lineNumber&&R===this.column?this:new o(l,R)}delta(l=0,R=0){return this.with(this.lineNumber+l,this.column+R)}equals(l){return o.equals(this,l)}static equals(l,R){return!l&&!R?!0:!!l&&!!R&&l.lineNumber===R.lineNumber&&l.column===R.column}isBefore(l){return o.isBefore(this,l)}static isBefore(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<R.column}isBeforeOrEqual(l){return o.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<=R.column}static compare(l,R){const S=l.lineNumber|0,A=R.lineNumber|0;if(S===A){const y=l.column|0,I=R.column|0;return y-I}return S-A}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new o(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=o}),define(ye[32],De([1,0,52]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(R,S,A,y){R>A||R===A&&S>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=R,this.endColumn=S):(this.startLineNumber=R,this.startColumn=S,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return L.containsPosition(this,R)}static containsPosition(R,S){return!(S.lineNumber<R.startLineNumber||S.lineNumber>R.endLineNumber||S.lineNumber===R.startLineNumber&&S.column<R.startColumn||S.lineNumber===R.endLineNumber&&S.column>R.endColumn)}static strictContainsPosition(R,S){return!(S.lineNumber<R.startLineNumber||S.lineNumber>R.endLineNumber||S.lineNumber===R.startLineNumber&&S.column<=R.startColumn||S.lineNumber===R.endLineNumber&&S.column>=R.endColumn)}containsRange(R){return L.containsRange(this,R)}static containsRange(R,S){return!(S.startLineNumber<R.startLineNumber||S.endLineNumber<R.startLineNumber||S.startLineNumber>R.endLineNumber||S.endLineNumber>R.endLineNumber||S.startLineNumber===R.startLineNumber&&S.startColumn<R.startColumn||S.endLineNumber===R.endLineNumber&&S.endColumn>R.endColumn)}strictContainsRange(R){return L.strictContainsRange(this,R)}static strictContainsRange(R,S){return!(S.startLineNumber<R.startLineNumber||S.endLineNumber<R.startLineNumber||S.startLineNumber>R.endLineNumber||S.endLineNumber>R.endLineNumber||S.startLineNumber===R.startLineNumber&&S.startColumn<=R.startColumn||S.endLineNumber===R.endLineNumber&&S.endColumn>=R.endColumn)}plusRange(R){return L.plusRange(this,R)}static plusRange(R,S){let A,y,I,O;return S.startLineNumber<R.startLineNumber?(A=S.startLineNumber,y=S.startColumn):S.startLineNumber===R.startLineNumber?(A=S.startLineNumber,y=Math.min(S.startColumn,R.startColumn)):(A=R.startLineNumber,y=R.startColumn),S.endLineNumber>R.endLineNumber?(I=S.endLineNumber,O=S.endColumn):S.endLineNumber===R.endLineNumber?(I=S.endLineNumber,O=Math.max(S.endColumn,R.endColumn)):(I=R.endLineNumber,O=R.endColumn),new L(A,y,I,O)}intersectRanges(R){return L.intersectRanges(this,R)}static intersectRanges(R,S){let A=R.startLineNumber,y=R.startColumn,I=R.endLineNumber,O=R.endColumn;const P=S.startLineNumber,v=S.startColumn,k=S.endLineNumber,D=S.endColumn;return A<P?(A=P,y=v):A===P&&(y=Math.max(y,v)),I>k?(I=k,O=D):I===k&&(O=Math.min(O,D)),A>I||A===I&&y>O?null:new L(A,y,I,O)}equalsRange(R){return L.equalsRange(this,R)}static equalsRange(R,S){return!R&&!S?!0:!!R&&!!S&&R.startLineNumber===S.startLineNumber&&R.startColumn===S.startColumn&&R.endLineNumber===S.endLineNumber&&R.endColumn===S.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(R){return new o.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(R){return new o.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,S){return new L(this.startLineNumber,this.startColumn,R,S)}setStartPosition(R,S){return new L(R,S,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(R){return new L(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(R){return new L(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new L(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,S=R){return new L(R.lineNumber,R.column,S.lineNumber,S.column)}static lift(R){return R?new L(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,S){return!(R.endLineNumber<S.startLineNumber||R.endLineNumber===S.startLineNumber&&R.endColumn<S.startColumn||S.endLineNumber<R.startLineNumber||S.endLineNumber===R.startLineNumber&&S.endColumn<R.startColumn)}static areIntersecting(R,S){return!(R.endLineNumber<S.startLineNumber||R.endLineNumber===S.startLineNumber&&R.endColumn<=S.startColumn||S.endLineNumber<R.startLineNumber||S.endLineNumber===R.startLineNumber&&S.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,S){if(R&&S){const I=R.startLineNumber|0,O=S.startLineNumber|0;if(I===O){const P=R.startColumn|0,v=S.startColumn|0;if(P===v){const k=R.endLineNumber|0,D=S.endLineNumber|0;if(k===D){const f=R.endColumn|0,d=S.endColumn|0;return f-d}return k-D}return P-v}return I-O}return(R?1:0)-(S?1:0)}static compareRangesUsingEnds(R,S){return R.endLineNumber===S.endLineNumber?R.endColumn===S.endColumn?R.startLineNumber===S.startLineNumber?R.startColumn-S.startColumn:R.startLineNumber-S.startLineNumber:R.endColumn-S.endColumn:R.endLineNumber-S.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=L}),define(ye[150],De([1,0,52,32]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(l=e.SelectionDirection||(e.SelectionDirection={}));class R extends L.Range{constructor(A,y,I,O){super(A,y,I,O),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=I,this.positionColumn=O}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,y):new R(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new R(A,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let I=0,O=A.length;I<O;I++)if(!this.selectionsEqual(A[I],y[I]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,I,O,P){return P===0?new R(A,y,I,O):new R(I,O,A,y)}}e.Selection=R}),define(ye[151],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[152],De([1,0,105]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class l extends o.CharacterClassifier{constructor(A){super(0);for(let y=0,I=A.length;y<I;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function R(S){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=S(y)),A[y])}e.getMapForWordSeparators=R(S=>new l(S))}),define(ye[106],De([1,0,64,6,66]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(v+="\\"+k);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function S(P){let v=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)v=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),v=new RegExp(P.source,k)}return v.lastIndex=0,v}e.ensureValidWordDefinition=S;const A=new l.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const v=A.unshift(P);return(0,L.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=y;function I(P,v,k,D,f){if(f||(f=o.Iterable.first(A)),k.length>f.maxLen){let C=P-f.maxLen/2;return C<0?C=0:D+=C,k=k.substring(C,P+f.maxLen/2),I(P,v,k,D,f)}const d=Date.now(),u=P-1-D;let m=-1,b=null;for(let C=1;!(Date.now()-d>=f.timeBudget);C++){const p=u-f.windowSize*C;v.lastIndex=Math.max(0,p);const n=O(v,k,u,m);if(!n&&b||(b=n,p<=0))break;m=p}if(b){const C={word:b[0],startColumn:D+1+b.index,endColumn:D+1+b.index+b[0].length};return v.lastIndex=0,C}return null}e.getWordAtText=I;function O(P,v,k,D){let f;for(;f=P.exec(v);){const d=f.index||0;if(d<=k&&P.lastIndex>=k)return f;if(D>0&&d>D)return null}return null}}),define(ye[153],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class L{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,I=A.notIn.length;y<I;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const I=A.findTokenIndexAtOffset(y-2),O=A.getStandardTokenType(I);return this.isOK(O)}g(A,y){for(let I=A;I<=y;I++){const O=String.fromCharCode(I);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=L;class l{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=l;function R(S,A,y){S.has(A)?S.get(A).push(y):S.set(A,[y])}}),define(ye[154],De([1,0,105]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var L;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class l{constructor(D,f,d){const u=new Uint8Array(D*f);for(let m=0,b=D*f;m<b;m++)u[m]=d;this.a=u,this.rows=D,this.cols=f}get(D,f){return this.a[D*this.cols+f]}set(D,f,d){this.a[D*this.cols+f]=d}}class R{constructor(D){let f=0,d=0;for(let m=0,b=D.length;m<b;m++){const[C,p,n]=D[m];p>f&&(f=p),C>d&&(d=C),n>d&&(d=n)}f++,d++;const u=new l(d,f,0);for(let m=0,b=D.length;m<b;m++){const[C,p,n]=D[m];u.set(C,p,n)}this.a=u,this.b=f}nextState(D,f){return f<0||f>=this.b?0:this.a.get(D,f)}}e.StateMachine=R;let S=null;function A(){return S===null&&(S=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let I=null;function O(){if(I===null){I=new o.CharacterClassifier(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<k.length;f++)I.set(k.charCodeAt(f),1);const D=".,;:";for(let f=0;f<D.length;f++)I.set(D.charCodeAt(f),2)}return I}class P{static a(D,f,d,u,m){let b=m-1;do{const C=f.charCodeAt(b);if(D.get(C)!==2)break;b--}while(b>u);if(u>0){const C=f.charCodeAt(u-1),p=f.charCodeAt(b);(C===40&&p===41||C===91&&p===93||C===123&&p===125)&&b--}return{range:{startLineNumber:d,startColumn:u+1,endLineNumber:d,endColumn:b+2},url:f.substring(u,b+1)}}static computeLinks(D,f=A()){const d=O(),u=[];for(let m=1,b=D.getLineCount();m<=b;m++){const C=D.getLineContent(m),p=C.length;let n=0,s=0,r=0,a=1,c=!1,g=!1,i=!1,t=!1;for(;n<p;){let h=!1;const E=C.charCodeAt(n);if(a===13){let w;switch(E){case 40:c=!0,w=0;break;case 41:w=c?0:1;break;case 91:i=!0,g=!0,w=0;break;case 93:i=!1,w=g?0:1;break;case 123:t=!0,w=0;break;case 125:w=t?0:1;break;case 39:case 34:case 96:r===E?w=1:r===39||r===34||r===96?w=0:w=1;break;case 42:w=r===42?1:0;break;case 124:w=r===124?1:0;break;case 32:w=i?0:1;break;default:w=d.get(E)}w===1&&(u.push(P.a(d,C,m,s,n)),h=!0)}else if(a===12){let w;E===91?(g=!0,w=0):w=d.get(E),w===1?h=!0:a=13}else a=f.nextState(a,E),a===0&&(h=!0);h&&(a=1,c=!1,g=!1,t=!1,s=n+1,r=E),n++}a===13&&u.push(P.a(d,C,m,s,p))}return u}}e.LinkComputer=P;function v(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:P.computeLinks(k)}e.computeLinks=v}),define(ye[107],De([1,0,23]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var l;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(l=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var S;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),C.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,C.indentSize|0),this.a=!1),this.insertSpaces=Boolean(C.insertSpaces),this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=Boolean(C.trimAutoWhitespace),this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.a===C.a&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class O{constructor(C,p){this._findMatchBrand=void 0,this.range=C,this.matches=p}}e.FindMatch=O;var P;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var k;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(k=e.PositionAffinity||(e.PositionAffinity={}));var D;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(D=e.ModelConstants||(e.ModelConstants={}));class f{constructor(C,p,n,s,r,a){this.identifier=C,this.range=p,this.text=n,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=r,this._isTracked=a}}e.ValidAnnotatedEditOperation=f;class d{constructor(C,p,n){this.regex=C,this.wordSeparators=p,this.simpleSearch=n}}e.SearchData=d;class u{constructor(C,p,n){this.reverseEdits=C,this.changes=p,this.trimAutoWhitespaceLineNumbers=n}}e.ApplyEditsResult=u;function m(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=m}),define(ye[155],De([1,0,15,104]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,I){y=(0,L.toUint32)(y);const O=this.a,P=this.b,v=I.length;return v===0?!1:(this.a=new Uint32Array(O.length+v),this.a.set(O.subarray(0,y),0),this.a.set(O.subarray(y),y+v),this.a.set(I,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,I){return y=(0,L.toUint32)(y),I=(0,L.toUint32)(I),this.a[y]===I?!1:(this.a[y]=I,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,I){y=(0,L.toUint32)(y),I=(0,L.toUint32)(I);const O=this.a,P=this.b;if(y>=O.length)return!1;const v=O.length-y;return I>=v&&(I=v),I===0?!1:(this.a=new Uint32Array(O.length-I),this.a.set(O.subarray(0,y),0),this.a.set(O.subarray(y+I),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,L.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let I=this.c[0]+1;I===0&&(this.b[0]=this.a[0],I++),y>=this.a.length&&(y=this.a.length-1);for(let O=I;O<=y;O++)this.b[O]=this.b[O-1]+this.a[O];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let I=0,O=this.a.length-1,P=0,v=0,k=0;for(;I<=O;)if(P=I+(O-I)/2|0,v=this.b[P],k=v-this.a[P],y<k)O=P-1;else if(y>=v)I=P+1;else break;return new S(P,y-k)}}e.PrefixSumComputer=l;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const I=this.e[y],O=I>0?this.d[I-1]:0;return new S(I,y-O)}removeValues(y,I){this.a.splice(y,I),this.f(y)}insertValues(y,I){this.a=(0,o.arrayInsert)(this.a,y,I),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,I=this.a.length;y<I;y++){const O=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+O;for(let v=0;v<O;v++)this.e[P+v]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,I){this.a[y]!==I&&(this.a[y]=I,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class S{constructor(y,I){this.index=y,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=I}}e.PrefixSumIndexOfResult=S}),define(ye[156],De([17,18]),function(re,e){return re.create("vs/base/common/actions",e)}),define(ye[157],De([17,18]),function(re,e){return re.create("vs/base/common/date",e)}),define(ye[158],De([1,0,157]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,l=L*60,R=l*24,S=R*7,A=R*30,y=R*365;function I(P,v,k,D){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return(0,o.localize)(0,null,I(new Date().getTime()+f*1e3,!1));if(!D&&f<30)return(0,o.localize)(1,null);let d;return f<L?(d=f,v?d===1?k?(0,o.localize)(2,null,d):(0,o.localize)(3,null,d):k?(0,o.localize)(4,null,d):(0,o.localize)(5,null,d):d===1?k?(0,o.localize)(6,null,d):(0,o.localize)(7,null,d):k?(0,o.localize)(8,null,d):(0,o.localize)(9,null,d)):f<l?(d=Math.floor(f/L),v?d===1?k?(0,o.localize)(10,null,d):(0,o.localize)(11,null,d):k?(0,o.localize)(12,null,d):(0,o.localize)(13,null,d):d===1?k?(0,o.localize)(14,null,d):(0,o.localize)(15,null,d):k?(0,o.localize)(16,null,d):(0,o.localize)(17,null,d)):f<R?(d=Math.floor(f/l),v?d===1?k?(0,o.localize)(18,null,d):(0,o.localize)(19,null,d):k?(0,o.localize)(20,null,d):(0,o.localize)(21,null,d):d===1?k?(0,o.localize)(22,null,d):(0,o.localize)(23,null,d):k?(0,o.localize)(24,null,d):(0,o.localize)(25,null,d)):f<S?(d=Math.floor(f/R),v?d===1?(0,o.localize)(26,null,d):(0,o.localize)(27,null,d):d===1?(0,o.localize)(28,null,d):(0,o.localize)(29,null,d)):f<A?(d=Math.floor(f/S),v?d===1?k?(0,o.localize)(30,null,d):(0,o.localize)(31,null,d):k?(0,o.localize)(32,null,d):(0,o.localize)(33,null,d):d===1?k?(0,o.localize)(34,null,d):(0,o.localize)(35,null,d):k?(0,o.localize)(36,null,d):(0,o.localize)(37,null,d)):f<y?(d=Math.floor(f/A),v?d===1?k?(0,o.localize)(38,null,d):(0,o.localize)(39,null,d):k?(0,o.localize)(40,null,d):(0,o.localize)(41,null,d):d===1?k?(0,o.localize)(42,null,d):(0,o.localize)(43,null,d):k?(0,o.localize)(44,null,d):(0,o.localize)(45,null,d)):(d=Math.floor(f/y),v?d===1?k?(0,o.localize)(46,null,d):(0,o.localize)(47,null,d):k?(0,o.localize)(48,null,d):(0,o.localize)(49,null,d):d===1?k?(0,o.localize)(50,null,d):(0,o.localize)(51,null,d):k?(0,o.localize)(52,null,d):(0,o.localize)(53,null,d))}e.fromNow=I;function O(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(ye[159],De([17,18]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(ye[45],De([1,0,15,9,159]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,v){return v&&(P.stack||P.stacktrace)?l.localize(0,null,A(P),S(P.stack)||S(P.stacktrace)):A(P)}function S(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?l.localize(1,null,P.message):P.message||l.localize(2,null)}function y(P=null,v=!1){if(!P)return l.localize(3,null);if(Array.isArray(P)){const k=o.coalesce(P),D=y(k[0],v);return k.length>1?l.localize(4,null,D,k.length):D}if(L.isString(P))return P;if(P.detail){const k=P.detail;if(k.error)return R(k.error,v);if(k.exception)return R(k.exception,v)}return P.stack?R(P,v):P.message?P.message:l.localize(5,null)}e.toErrorMessage=y;function I(P){const v=P;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=I;function O(P,v){let k;return typeof P=="string"?k=new Error(P):k=P,k.actions=v,k}e.createErrorWithActions=O}),define(ye[160],De([17,18]),function(re,e){return re.create("vs/base/common/platform",e)}),define(ye[11],De([1,0,160]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let L=!1,l=!1,R=!1,S=!1,A=!1,y=!1,I=!1,O=!1,P=!1,v=!1,k,D=e.LANGUAGE_DEFAULT,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const m=typeof u?.versions?.electron=="string",b=m&&u?.type==="renderer";if(typeof navigator=="object"&&!b)d=navigator.userAgent,L=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,O=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,y=!0,k=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,D=k;else if(typeof u=="object"){L=u.platform==="win32",l=u.platform==="darwin",R=u.platform==="linux",S=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,I=m,P=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.LANGUAGE_DEFAULT,D=e.LANGUAGE_DEFAULT;const i=u.env.VSCODE_NLS_CONFIG;if(i)try{const t=JSON.parse(i),h=t.availableLanguages["*"];k=t.locale,D=h||e.LANGUAGE_DEFAULT,f=t._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var C;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function p(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let n=0;l?n=1:L?n=3:R&&(n=2),e.isWindows=L,e.isMacintosh=l,e.isLinux=R,e.isLinuxSnap=S,e.isNative=A,e.isElectron=I,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=O,e.isMobile=v,e.isCI=P,e.platform=n,e.userAgent=d,e.language=D;var s;(function(i){function t(){return e.language}i.value=t;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function E(){return e.language==="en"}i.isDefault=E})(s=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const i=[];e.globals.addEventListener("message",h=>{if(h.data&&h.data.vscodeScheduleAsyncWork)for(let E=0,w=i.length;E<w;E++){const N=i[E];if(N.id===h.data.vscodeScheduleAsyncWork){i.splice(E,1),N.callback();return}}});let t=0;return h=>{const E=++t;i.push({id:E,callback:h}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return i=>setTimeout(i)})();var r;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||O?2:L?1:3;let a=!0,c=!1;function g(){if(!c){c=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=g,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],De([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const l=o.globals.vscode.process;L={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ye[12],De([1,0,36]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,l=97,R=90,S=122,A=46,y=47,I=92,O=58,P=63;class v extends Error{constructor(s,r,a){let c;typeof r=="string"&&r.indexOf("not ")===0?(c="must not be",r=r.replace(/^not /,"")):c="must be";const g=s.indexOf(".")!==-1?"property":"argument";let i=`The "${s}" ${g} ${c} of type ${r}`;i+=`. Received type ${typeof a}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function k(n,s){if(n===null||typeof n!="object")throw new v(s,"Object",n)}function D(n,s){if(typeof n!="string")throw new v(s,"string",n)}const f=o.platform==="win32";function d(n){return n===y||n===I}function u(n){return n===y}function m(n){return n>=L&&n<=R||n>=l&&n<=S}function b(n,s,r,a){let c="",g=0,i=-1,t=0,h=0;for(let E=0;E<=n.length;++E){if(E<n.length)h=n.charCodeAt(E);else{if(a(h))break;h=y}if(a(h)){if(!(i===E-1||t===1))if(t===2){if(c.length<2||g!==2||c.charCodeAt(c.length-1)!==A||c.charCodeAt(c.length-2)!==A){if(c.length>2){const w=c.lastIndexOf(r);w===-1?(c="",g=0):(c=c.slice(0,w),g=c.length-1-c.lastIndexOf(r)),i=E,t=0;continue}else if(c.length!==0){c="",g=0,i=E,t=0;continue}}s&&(c+=c.length>0?`${r}..`:"..",g=2)}else c.length>0?c+=`${r}${n.slice(i+1,E)}`:c=n.slice(i+1,E),g=E-i-1;i=E,t=0}else h===A&&t!==-1?++t:t=-1}return c}function C(n,s){k(s,"pathObject");const r=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${a}`:`${r}${n}${a}`:a}e.win32={resolve(...n){let s="",r="",a=!1;for(let c=n.length-1;c>=-1;c--){let g;if(c>=0){if(g=n[c],D(g,"path"),g.length===0)continue}else s.length===0?g=o.cwd():(g=o.env[`=${s}`]||o.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==s.toLowerCase()&&g.charCodeAt(2)===I)&&(g=`${s}\\`));const i=g.length;let t=0,h="",E=!1;const w=g.charCodeAt(0);if(i===1)d(w)&&(t=1,E=!0);else if(d(w))if(E=!0,d(g.charCodeAt(1))){let N=2,j=N;for(;N<i&&!d(g.charCodeAt(N));)N++;if(N<i&&N!==j){const V=g.slice(j,N);for(j=N;N<i&&d(g.charCodeAt(N));)N++;if(N<i&&N!==j){for(j=N;N<i&&!d(g.charCodeAt(N));)N++;(N===i||N!==j)&&(h=`\\\\${V}\\${g.slice(j,N)}`,t=N)}}}else t=1;else m(w)&&g.charCodeAt(1)===O&&(h=g.slice(0,2),t=2,i>2&&d(g.charCodeAt(2))&&(E=!0,t=3));if(h.length>0)if(s.length>0){if(h.toLowerCase()!==s.toLowerCase())continue}else s=h;if(a){if(s.length>0)break}else if(r=`${g.slice(t)}\\${r}`,a=E,E&&s.length>0)break}return r=b(r,!a,"\\",d),a?`${s}\\${r}`:`${s}${r}`||"."},normalize(n){D(n,"path");const s=n.length;if(s===0)return".";let r=0,a,c=!1;const g=n.charCodeAt(0);if(s===1)return u(g)?"\\":n;if(d(g))if(c=!0,d(n.charCodeAt(1))){let t=2,h=t;for(;t<s&&!d(n.charCodeAt(t));)t++;if(t<s&&t!==h){const E=n.slice(h,t);for(h=t;t<s&&d(n.charCodeAt(t));)t++;if(t<s&&t!==h){for(h=t;t<s&&!d(n.charCodeAt(t));)t++;if(t===s)return`\\\\${E}\\${n.slice(h)}\\`;t!==h&&(a=`\\\\${E}\\${n.slice(h,t)}`,r=t)}}}else r=1;else m(g)&&n.charCodeAt(1)===O&&(a=n.slice(0,2),r=2,s>2&&d(n.charCodeAt(2))&&(c=!0,r=3));let i=r<s?b(n.slice(r),!c,"\\",d):"";return i.length===0&&!c&&(i="."),i.length>0&&d(n.charCodeAt(s-1))&&(i+="\\"),a===void 0?c?`\\${i}`:i:c?`${a}\\${i}`:`${a}${i}`},isAbsolute(n){D(n,"path");const s=n.length;if(s===0)return!1;const r=n.charCodeAt(0);return d(r)||s>2&&m(r)&&n.charCodeAt(1)===O&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,r;for(let g=0;g<n.length;++g){const i=n[g];D(i,"path"),i.length>0&&(s===void 0?s=r=i:s+=`\\${i}`)}if(s===void 0)return".";let a=!0,c=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++c;const g=r.length;g>1&&d(r.charCodeAt(1))&&(++c,g>2&&(d(r.charCodeAt(2))?++c:a=!1))}if(a){for(;c<s.length&&d(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return e.win32.normalize(s)},relative(n,s){if(D(n,"from"),D(s,"to"),n===s)return"";const r=e.win32.resolve(n),a=e.win32.resolve(s);if(r===a||(n=r.toLowerCase(),s=a.toLowerCase(),n===s))return"";let c=0;for(;c<n.length&&n.charCodeAt(c)===I;)c++;let g=n.length;for(;g-1>c&&n.charCodeAt(g-1)===I;)g--;const i=g-c;let t=0;for(;t<s.length&&s.charCodeAt(t)===I;)t++;let h=s.length;for(;h-1>t&&s.charCodeAt(h-1)===I;)h--;const E=h-t,w=i<E?i:E;let N=-1,j=0;for(;j<w;j++){const Q=n.charCodeAt(c+j);if(Q!==s.charCodeAt(t+j))break;Q===I&&(N=j)}if(j!==w){if(N===-1)return a}else{if(E>w){if(s.charCodeAt(t+j)===I)return a.slice(t+j+1);if(j===2)return a.slice(t+j)}i>w&&(n.charCodeAt(c+j)===I?N=j:j===2&&(N=3)),N===-1&&(N=0)}let V="";for(j=c+N+1;j<=g;++j)(j===g||n.charCodeAt(j)===I)&&(V+=V.length===0?"..":"\\..");return t+=N,V.length>0?`${V}${a.slice(t,h)}`:(a.charCodeAt(t)===I&&++t,a.slice(t,h))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=e.win32.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===I){if(s.charCodeAt(1)===I){const r=s.charCodeAt(2);if(r!==P&&r!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(m(s.charCodeAt(0))&&s.charCodeAt(1)===O&&s.charCodeAt(2)===I)return`\\\\?\\${s}`;return n},dirname(n){D(n,"path");const s=n.length;if(s===0)return".";let r=-1,a=0;const c=n.charCodeAt(0);if(s===1)return d(c)?n:".";if(d(c)){if(r=a=1,d(n.charCodeAt(1))){let t=2,h=t;for(;t<s&&!d(n.charCodeAt(t));)t++;if(t<s&&t!==h){for(h=t;t<s&&d(n.charCodeAt(t));)t++;if(t<s&&t!==h){for(h=t;t<s&&!d(n.charCodeAt(t));)t++;if(t===s)return n;t!==h&&(r=a=t+1)}}}}else m(c)&&n.charCodeAt(1)===O&&(r=s>2&&d(n.charCodeAt(2))?3:2,a=r);let g=-1,i=!0;for(let t=s-1;t>=a;--t)if(d(n.charCodeAt(t))){if(!i){g=t;break}}else i=!1;if(g===-1){if(r===-1)return".";g=r}return n.slice(0,g)},basename(n,s){s!==void 0&&D(s,"ext"),D(n,"path");let r=0,a=-1,c=!0,g;if(n.length>=2&&m(n.charCodeAt(0))&&n.charCodeAt(1)===O&&(r=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let i=s.length-1,t=-1;for(g=n.length-1;g>=r;--g){const h=n.charCodeAt(g);if(d(h)){if(!c){r=g+1;break}}else t===-1&&(c=!1,t=g+1),i>=0&&(h===s.charCodeAt(i)?--i===-1&&(a=g):(i=-1,a=t))}return r===a?a=t:a===-1&&(a=n.length),n.slice(r,a)}for(g=n.length-1;g>=r;--g)if(d(n.charCodeAt(g))){if(!c){r=g+1;break}}else a===-1&&(c=!1,a=g+1);return a===-1?"":n.slice(r,a)},extname(n){D(n,"path");let s=0,r=-1,a=0,c=-1,g=!0,i=0;n.length>=2&&n.charCodeAt(1)===O&&m(n.charCodeAt(0))&&(s=a=2);for(let t=n.length-1;t>=s;--t){const h=n.charCodeAt(t);if(d(h)){if(!g){a=t+1;break}continue}c===-1&&(g=!1,c=t+1),h===A?r===-1?r=t:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||c===-1||i===0||i===1&&r===c-1&&r===a+1?"":n.slice(r,c)},format:C.bind(null,"\\"),parse(n){D(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const r=n.length;let a=0,c=n.charCodeAt(0);if(r===1)return d(c)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(d(c)){if(a=1,d(n.charCodeAt(1))){let N=2,j=N;for(;N<r&&!d(n.charCodeAt(N));)N++;if(N<r&&N!==j){for(j=N;N<r&&d(n.charCodeAt(N));)N++;if(N<r&&N!==j){for(j=N;N<r&&!d(n.charCodeAt(N));)N++;N===r?a=N:N!==j&&(a=N+1)}}}}else if(m(c)&&n.charCodeAt(1)===O){if(r<=2)return s.root=s.dir=n,s;if(a=2,d(n.charCodeAt(2))){if(r===3)return s.root=s.dir=n,s;a=3}}a>0&&(s.root=n.slice(0,a));let g=-1,i=a,t=-1,h=!0,E=n.length-1,w=0;for(;E>=a;--E){if(c=n.charCodeAt(E),d(c)){if(!h){i=E+1;break}continue}t===-1&&(h=!1,t=E+1),c===A?g===-1?g=E:w!==1&&(w=1):g!==-1&&(w=-1)}return t!==-1&&(g===-1||w===0||w===1&&g===t-1&&g===i+1?s.base=s.name=n.slice(i,t):(s.name=n.slice(i,g),s.base=n.slice(i,t),s.ext=n.slice(g,t))),i>0&&i!==a?s.dir=n.slice(0,i-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(f){const n=/\\/g;return()=>{const s=o.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...n){let s="",r=!1;for(let a=n.length-1;a>=-1&&!r;a--){const c=a>=0?n[a]:p();D(c,"path"),c.length!==0&&(s=`${c}/${s}`,r=c.charCodeAt(0)===y)}return s=b(s,!r,"/",u),r?`/${s}`:s.length>0?s:"."},normalize(n){if(D(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===y,r=n.charCodeAt(n.length-1)===y;return n=b(n,!s,"/",u),n.length===0?s?"/":r?"./":".":(r&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return D(n,"path"),n.length>0&&n.charCodeAt(0)===y},join(...n){if(n.length===0)return".";let s;for(let r=0;r<n.length;++r){const a=n[r];D(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":e.posix.normalize(s)},relative(n,s){if(D(n,"from"),D(s,"to"),n===s||(n=e.posix.resolve(n),s=e.posix.resolve(s),n===s))return"";const r=1,a=n.length,c=a-r,g=1,i=s.length-g,t=c<i?c:i;let h=-1,E=0;for(;E<t;E++){const N=n.charCodeAt(r+E);if(N!==s.charCodeAt(g+E))break;N===y&&(h=E)}if(E===t)if(i>t){if(s.charCodeAt(g+E)===y)return s.slice(g+E+1);if(E===0)return s.slice(g+E)}else c>t&&(n.charCodeAt(r+E)===y?h=E:E===0&&(h=0));let w="";for(E=r+h+1;E<=a;++E)(E===a||n.charCodeAt(E)===y)&&(w+=w.length===0?"..":"/..");return`${w}${s.slice(g+h)}`},toNamespacedPath(n){return n},dirname(n){if(D(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===y;let r=-1,a=!0;for(let c=n.length-1;c>=1;--c)if(n.charCodeAt(c)===y){if(!a){r=c;break}}else a=!1;return r===-1?s?"/":".":s&&r===1?"//":n.slice(0,r)},basename(n,s){s!==void 0&&D(s,"ext"),D(n,"path");let r=0,a=-1,c=!0,g;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let i=s.length-1,t=-1;for(g=n.length-1;g>=0;--g){const h=n.charCodeAt(g);if(h===y){if(!c){r=g+1;break}}else t===-1&&(c=!1,t=g+1),i>=0&&(h===s.charCodeAt(i)?--i===-1&&(a=g):(i=-1,a=t))}return r===a?a=t:a===-1&&(a=n.length),n.slice(r,a)}for(g=n.length-1;g>=0;--g)if(n.charCodeAt(g)===y){if(!c){r=g+1;break}}else a===-1&&(c=!1,a=g+1);return a===-1?"":n.slice(r,a)},extname(n){D(n,"path");let s=-1,r=0,a=-1,c=!0,g=0;for(let i=n.length-1;i>=0;--i){const t=n.charCodeAt(i);if(t===y){if(!c){r=i+1;break}continue}a===-1&&(c=!1,a=i+1),t===A?s===-1?s=i:g!==1&&(g=1):s!==-1&&(g=-1)}return s===-1||a===-1||g===0||g===1&&s===a-1&&s===r+1?"":n.slice(s,a)},format:C.bind(null,"/"),parse(n){D(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const r=n.charCodeAt(0)===y;let a;r?(s.root="/",a=1):a=0;let c=-1,g=0,i=-1,t=!0,h=n.length-1,E=0;for(;h>=a;--h){const w=n.charCodeAt(h);if(w===y){if(!t){g=h+1;break}continue}i===-1&&(t=!1,i=h+1),w===A?c===-1?c=h:E!==1&&(E=1):c!==-1&&(E=-1)}if(i!==-1){const w=g===0&&r?1:g;c===-1||E===0||E===1&&c===i-1&&c===g+1?s.base=s.name=n.slice(w,i):(s.name=n.slice(w,c),s.base=n.slice(w,i),s.ext=n.slice(c,i))}return g>0?s.dir=n.slice(0,g-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[108],De([1,0,65,12]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new o.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),R=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(t,h,E=!1){const w=t||"",N=h||"",j=l.value.collator.compare(w,N);return l.value.collatorIsNumeric&&j===0&&w!==N?w<N?-1:1:j}e.compareFileNames=A;function y(t,h){const E=R.value.collator;return t=t||"",h=h||"",C(E,t,h)}e.compareFileNamesDefault=y;function I(t,h){const E=R.value.collator;return t=t||"",h=h||"",r(t,h)||C(E,t,h)}e.compareFileNamesUpper=I;function O(t,h){const E=R.value.collator;return t=t||"",h=h||"",s(t,h)||C(E,t,h)}e.compareFileNamesLower=O;function P(t,h){return t=t||"",h=h||"",t===h?0:t<h?-1:1}e.compareFileNamesUnicode=P;function v(t,h){const[E,w]=m(t),[N,j]=m(h);let V=l.value.collator.compare(w,j);if(V===0){if(l.value.collatorIsNumeric&&w!==j)return w<j?-1:1;if(V=l.value.collator.compare(E,N),l.value.collatorIsNumeric&&V===0&&E!==N)return E<N?-1:1}return V}e.compareFileExtensions=v;function k(t,h){t=t||"",h=h||"";const E=b(t),w=b(h),N=R.value.collator,j=S.value.collator;return C(j,E,w)||C(N,t,h)}e.compareFileExtensionsDefault=k;function D(t,h){t=t||"",h=h||"";const E=b(t),w=b(h),N=R.value.collator,j=S.value.collator;return C(j,E,w)||r(t,h)||C(N,t,h)}e.compareFileExtensionsUpper=D;function f(t,h){t=t||"",h=h||"";const E=b(t),w=b(h),N=R.value.collator,j=S.value.collator;return C(j,E,w)||s(t,h)||C(N,t,h)}e.compareFileExtensionsLower=f;function d(t,h){t=t||"",h=h||"";const E=b(t).toLowerCase(),w=b(h).toLowerCase();return E!==w?E<w?-1:1:t!==h?t<h?-1:1:0}e.compareFileExtensionsUnicode=d;const u=/^(.*?)(\.([^.]*))?$/;function m(t,h=!1){const E=t?u.exec(t):[];let w=[E&&E[1]||"",E&&E[3]||""];return h&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function b(t){const h=t?u.exec(t):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function C(t,h,E){const w=t.compare(h,E);return w!==0?w:h.length!==E.length?h.length<E.length?-1:1:0}function p(t){const h=t.charAt(0);return h.toLocaleUpperCase()!==h}function n(t){const h=t.charAt(0);return h.toLocaleLowerCase()!==h}function s(t,h){return p(t)&&n(h)?-1:n(t)&&p(h)?1:0}function r(t,h){return n(t)&&p(h)?-1:p(t)&&n(h)?1:0}function a(t,h,E=!1){return E||(t=t&&t.toLowerCase(),h=h&&h.toLowerCase()),t===h?0:t<h?-1:1}function c(t,h,E=!1){const w=t.split(L.sep),N=h.split(L.sep),j=w.length-1,V=N.length-1;let Q,q;for(let U=0;;U++){if(Q=j===U,q=V===U,Q&&q)return A(w[U],N[U],E);if(Q)return-1;if(q)return 1;const T=a(w[U],N[U],E);if(T!==0)return T}}e.comparePaths=c;function g(t,h,E){const w=t.toLowerCase(),N=h.toLowerCase(),j=i(t,h,E);if(j)return j;const V=w.endsWith(E),Q=N.endsWith(E);if(V!==Q)return V?-1:1;const q=A(w,N);return q!==0?q:w.localeCompare(N)}e.compareAnything=g;function i(t,h,E){const w=t.toLowerCase(),N=h.toLowerCase(),j=w.startsWith(E),V=N.startsWith(E);if(j!==V)return j?-1:1;if(j&&V){if(w.length<N.length)return-1;if(w.length>N.length)return 1}return 0}e.compareByPrefix=i}),define(ye[87],De([1,0,12]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(O){const P=(0,o.extname)(O),v=L[P.toLowerCase()];return v!==void 0?v:S(O)}e.getMediaOrTextMime=R;function S(O){const P=(0,o.extname)(O);return l[P.toLowerCase()]}e.getMediaMime=S;function A(O){for(const P in l)if(l[P]===O)return P}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function I(O,P){const v=y.exec(O);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:P?void 0:O}e.normalizeMimeType=I}),define(ye[109],De([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var l;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...y){const I=y.reduce((v,k)=>(v[k]=!0,v),{}),O=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(v=>!I[v]).forEach(v=>{for(let k=0;k<O.length;k++)if(v.search(O[k])!==-1){delete A[v];break}})}e.sanitizeProcessEnvironment=R;function S(A){!A||(delete A.DEBUG,o.isMacintosh&&delete A.DYLD_LIBRARY_PATH,o.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=S}),define(ye[43],De([1,0,11]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=o.globals.performance&&typeof o.globals.performance.now=="function";class l{static create(S=!0){return new l(S)}constructor(S){this.a=L&&S,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?o.globals.performance.now():Date.now()}}e.StopWatch=l}),define(ye[3],De([1,0,10,63,6,66,43]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var I;(function(g){g.None=()=>l.Disposable.None;function i(ve){if(y){const{onDidAddListener:Ie}=ve,Re=D.create();let ae=0;ve.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Ie?.()}}}function t(ve,Ie){return U(ve,()=>{},0,void 0,!0,void 0,Ie)}g.defer=t;function h(ve){return(Ie,Re=null,ae)=>{let le=!1,ue;return ue=ve(ne=>{if(!le)return ue?ue.dispose():le=!0,Ie.call(Re,ne)},null,ae),le&&ue.dispose(),ue}}g.once=h;function E(ve,Ie,Re){return q((ae,le=null,ue)=>ve(ne=>ae.call(le,Ie(ne)),null,ue),Re)}g.map=E;function w(ve,Ie,Re){return q((ae,le=null,ue)=>ve(ne=>{Ie(ne),ae.call(le,ne)},null,ue),Re)}g.forEach=w;function N(ve,Ie,Re){return q((ae,le=null,ue)=>ve(ne=>Ie(ne)&&ae.call(le,ne),null,ue),Re)}g.filter=N;function j(ve){return ve}g.signal=j;function V(...ve){return(Ie,Re=null,ae)=>(0,l.combinedDisposable)(...ve.map(le=>le(ue=>Ie.call(Re,ue),null,ae)))}g.any=V;function Q(ve,Ie,Re,ae){let le=Re;return E(ve,ue=>(le=Ie(le,ue),le),ae)}g.reduce=Q;function q(ve,Ie){let Re;const ae={onWillAddFirstListener(){Re=ve(le.fire,le)},onDidRemoveLastListener(){Re?.dispose()}};Ie||i(ae);const le=new d(ae);return Ie?.add(le),le.event}function U(ve,Ie,Re=100,ae=!1,le=!1,ue,ne){let ce,oe,M,z=0,G;const te={leakWarningThreshold:ue,onWillAddFirstListener(){ce=ve(we=>{z++,oe=Ie(oe,we),ae&&!M&&(de.fire(oe),oe=void 0),G=()=>{const Pe=oe;oe=void 0,M=void 0,(!ae||z>1)&&de.fire(Pe),z=0},typeof Re=="number"?(clearTimeout(M),M=setTimeout(G,Re)):M===void 0&&(M=0,queueMicrotask(G))})},onWillRemoveListener(){le&&z>0&&G?.()},onDidRemoveLastListener(){G=void 0,ce.dispose()}};ne||i(te);const de=new d(te);return ne?.add(de),de.event}g.debounce=U;function T(ve,Ie=0,Re){return g.debounce(ve,(ae,le)=>ae?(ae.push(le),ae):[le],Ie,void 0,!0,void 0,Re)}g.accumulate=T;function F(ve,Ie=(ae,le)=>ae===le,Re){let ae=!0,le;return N(ve,ue=>{const ne=ae||!Ie(ue,le);return ae=!1,le=ue,ne},Re)}g.latch=F;function B(ve,Ie,Re){return[g.filter(ve,Ie,Re),g.filter(ve,ae=>!Ie(ae),Re)]}g.split=B;function Z(ve,Ie=!1,Re=[]){let ae=Re.slice(),le=ve(ce=>{ae?ae.push(ce):ne.fire(ce)});const ue=()=>{ae?.forEach(ce=>ne.fire(ce)),ae=null},ne=new d({onWillAddFirstListener(){le||(le=ve(ce=>ne.fire(ce)))},onDidAddFirstListener(){ae&&(Ie?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return ne.event}g.buffer=Z;class _{constructor(Ie){this.event=Ie,this.c=new l.DisposableStore}map(Ie){return new _(E(this.event,Ie,this.c))}forEach(Ie){return new _(w(this.event,Ie,this.c))}filter(Ie){return new _(N(this.event,Ie,this.c))}reduce(Ie,Re){return new _(Q(this.event,Ie,Re,this.c))}latch(){return new _(F(this.event,void 0,this.c))}debounce(Ie,Re=100,ae=!1,le=!1,ue){return new _(U(this.event,Ie,Re,ae,le,ue,this.c))}on(Ie,Re,ae){return this.event(Ie,Re,ae)}once(Ie,Re,ae){return h(this.event)(Ie,Re,ae)}dispose(){this.c.dispose()}}function H(ve){return new _(ve)}g.chain=H;function Y(ve,Ie,Re=ae=>ae){const ae=(...ce)=>ne.fire(Re(...ce)),le=()=>ve.on(Ie,ae),ue=()=>ve.removeListener(Ie,ae),ne=new d({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ne.event}g.fromNodeEventEmitter=Y;function ie(ve,Ie,Re=ae=>ae){const ae=(...ce)=>ne.fire(Re(...ce)),le=()=>ve.addEventListener(Ie,ae),ue=()=>ve.removeEventListener(Ie,ae),ne=new d({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ne.event}g.fromDOMEventEmitter=ie;function ge(ve){return new Promise(Ie=>h(ve)(Ie))}g.toPromise=ge;function X(ve,Ie){return Ie(void 0),ve(Re=>Ie(Re))}g.runAndSubscribe=X;function J(ve,Ie){let Re=null;function ae(ue){Re?.dispose(),Re=new l.DisposableStore,Ie(ue,Re)}ae(void 0);const le=ve(ue=>ae(ue));return(0,l.toDisposable)(()=>{le.dispose(),Re?.dispose()})}g.runAndSubscribeWithStore=J;class ee{constructor(Ie,Re){this.obs=Ie,this.c=0,this.d=!1;const ae={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Re||i(ae),this.emitter=new d(ae),Re&&Re.add(this.emitter)}beginUpdate(Ie){this.c++}handleChange(Ie,Re){this.d=!0}endUpdate(Ie){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function me(ve,Ie){return new ee(ve,Ie).emitter.event}g.fromObservable=me})(I=e.Event||(e.Event={}));class O{constructor(i){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${i}_${O.c++}`,O.all.add(this)}start(i){this.d=new S.StopWatch(!0),this.listenerCount=i}stop(){if(this.d){const i=this.d.elapsed();this.durations.push(i),this.elapsedOverall+=i,this.invocationCount+=1,this.d=void 0}}}O.all=new Set,O.c=0,e.EventProfiling=O;let P=-1;function v(g){const i=P;return P=g,{dispose(){P=i}}}e.setGlobalLeakWarningThreshold=v;class k{constructor(i,t=Math.random().toString(18).slice(2,5)){this.threshold=i,this.name=t,this.d=0}dispose(){this.c?.clear()}check(i,t){const h=this.threshold;if(h<=0||t<h)return;this.c||(this.c=new Map);const E=this.c.get(i.value)||0;if(this.c.set(i.value,E+1),this.d-=1,this.d<=0){this.d=h*.5;let w,N=0;for(const[j,V]of this.c)(!w||N<V)&&(w=j,N=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${N}):`),console.warn(w)}return()=>{const w=this.c.get(i.value)||0;this.c.set(i.value,w-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(i){this.value=i}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(i,t,h){this.callback=i,this.callbackThis=t,this.stack=h,this.subscription=new l.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class d{constructor(i){this.j=!1,this.d=i,this.f=P>0||this.d?.leakWarningThreshold?new k(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new O(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const i=Array.from(this.q);queueMicrotask(()=>{for(const t of i)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(i,t,h)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let w,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=D.create(),w=this.f.check(N,this.q.size+1)),A&&(N=N??D.create());const j=new f(i,t,N),V=this.q.push(j);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,i,t);const Q=j.subscription.set(()=>{w?.(),this.j||(this.d?.onWillRemoveListener?.(this),V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return h instanceof l.DisposableStore?h.add(Q):Array.isArray(h)&&h.push(Q),Q}),this.l}fire(i){if(this.q){this.m||(this.m=new m);for(const t of this.q)this.m.push(this,t,i);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(i,t,h){this.c.push(new b(i,t,h))}clear(i){const t=new R.LinkedList;for(const h of this.c)h.emitter!==i&&t.push(h);this.c=t}deliver(){for(;this.c.size>0;){const i=this.c.shift();try{i.listener.invoke(i.event)}catch(t){(0,o.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=u;class m extends u{clear(i){this.c.clear()}}class b{constructor(i,t,h){this.emitter=i,this.listener=t,this.event=h}}class C extends d{async fireAsync(i,t,h){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,i]);for(;this.c.size>0&&!t.isCancellationRequested;){const[E,w]=this.c.shift(),N=[],j={...w,token:t,waitUntil:V=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");h&&(V=h(V,E.callback)),N.push(V)}};try{E.invoke(j)}catch(V){(0,o.onUnexpectedError)(V);continue}Object.freeze(N),await Promise.allSettled(N).then(V=>{for(const Q of V)Q.status==="rejected"&&(0,o.onUnexpectedError)(Q.reason)})}}}}e.AsyncEmitter=C;class p extends d{constructor(i){super(i),this.h=0,this.s=new R.LinkedList,this.t=i?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const i=Array.from(this.s);this.s.clear(),super.fire(this.t(i))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(i){this.q&&(this.h!==0?this.s.push(i):super.fire(i))}}e.PauseableEmitter=p;class n extends p{constructor(i){super(i),this.c=i.delay??100}fire(i){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(i)}}e.DebounceEmitter=n;class s extends d{constructor(i){super(i),this.c=[],this.h=i?.merge}fire(i){!this.hasListeners()||(this.c.push(i),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(t=>super.fire(t)),this.c=[]}))}}e.MicrotaskEmitter=s;class r{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(i){const t={event:i,listener:null};this.f.push(t),this.d&&this.j(t);const h=()=>{this.d&&this.k(t);const E=this.f.indexOf(t);this.f.splice(E,1)};return(0,l.toDisposable)((0,L.once)(h))}g(){this.d=!0,this.f.forEach(i=>this.j(i))}h(){this.d=!1,this.f.forEach(i=>this.k(i))}j(i){i.listener=i.event(t=>this.c.fire(t))}k(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.c=[]}wrapEvent(i){return(t,h,E)=>i(w=>{const N=this.c[this.c.length-1];N?N.push(()=>t.call(h,w)):t.call(h,w)},void 0,E)}bufferEvents(i){const t=[];this.c.push(t);const h=i();return this.c.pop(),t.forEach(E=>E()),h}}e.EventBufferer=a;class c{constructor(){this.c=!1,this.d=I.None,this.f=l.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(i){this.d=i,this.c&&(this.f.dispose(),this.f=i(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=c}),define(ye[161],De([1,0,3,6,156]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends L.Disposable{constructor(v,k="",D="",f=!0,d){super(),this.h=this.B(new o.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=k,this.u=D,this.w=f,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,k){this.C&&await this.C(v)}}e.Action=R;class S extends L.Disposable{constructor(){super(...arguments),this.f=this.B(new o.Emitter),this.onWillRun=this.f.event,this.h=this.B(new o.Emitter),this.onDidRun=this.h.event}async run(v,k){if(!v.enabled)return;this.f.fire({action:v});let D;try{await this.runAction(v,k)}catch(f){D=f}this.h.fire({action:v,error:D})}async runAction(v,k){await v.run(k)}}e.ActionRunner=S;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let k=[];for(const D of v)D.length&&(k.length?k=[...k,new A,...D]:k=D);return k}async run(){}}A.ID="vs.actions.separator",e.Separator=A;class y{get actions(){return this.a}constructor(v,k,D,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=k,this.class=f,this.a=D}async run(){}}e.SubmenuAction=y;class I extends R{constructor(){super(I.ID,l.localize(0,null),void 0,!1)}}I.ID="vs.actions.empty",e.EmptySubmenuAction=I;function O(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}e.toAction=O}),define(ye[21],De([1,0,3]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(A,y){const I=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(I)}}});var l;(function(A){function y(I){return I===A.None||I===A.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(l=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new o.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=l.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=S}),define(ye[162],De([1,0,21]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new o.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=L;class l{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=l;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=R}),define(ye[8],De([1,0,162,65]),function(re,e,o,L){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const S=/{(\d+)}/g;function A($,...K){return K.length===0?$:$.replace(S,function(he,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=K.length?he:K[Ne]})}e.format=A;const y=/{([^}]+)}/g;function I($,K){return $.replace(y,(he,Le)=>K[Le]??he)}e.format2=I;function O($){return $.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}e.escape=O;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function v($,K){let he=0;const Le=K.charCodeAt(0);for(let Ne=$.length-1;Ne>=0;Ne--)$.charCodeAt(Ne)===Le&&he++;return he}e.count=v;function k($,K,he="\u2026"){return $.length<=K?$:`${$.substr(0,K)}${he}`}e.truncate=k;function D($,K=" "){const he=f($,K);return d(he,K)}e.trim=D;function f($,K){if(!$||!K)return $;const he=K.length;if(he===0||$.length===0)return $;let Le=0;for(;$.indexOf(K,Le)===Le;)Le=Le+he;return $.substring(Le)}e.ltrim=f;function d($,K){if(!$||!K)return $;const he=K.length,Le=$.length;if(he===0||Le===0)return $;let Ne=Le,qe=-1;for(;qe=$.lastIndexOf(K,Ne-1),!(qe===-1||qe+he!==Ne);){if(qe===0)return"";Ne=qe}return $.substring(0,Ne)}e.rtrim=d;function u($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function m($){return $.replace(/\*/g,"")}e.stripWildcards=m;function b($,K,he={}){if(!$)throw new Error("Cannot create regex from empty string");K||($=P($)),he.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return he.global&&(Le+="g"),he.matchCase||(Le+="i"),he.multiline&&(Le+="m"),he.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=b;function C($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function p($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function n($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=n;function s($){return $.split(/\r\n|\r|\n/)}e.splitLines=s;function r($){for(let K=0,he=$.length;K<he;K++){const Le=$.charCodeAt(K);if(Le!==32&&Le!==9)return K}return-1}e.firstNonWhitespaceIndex=r;function a($,K=0,he=$.length){for(let Le=K;Le<he;Le++){const Ne=$.charCodeAt(Le);if(Ne!==32&&Ne!==9)return $.substring(K,Le)}return $.substring(K,he)}e.getLeadingWhitespace=a;function c($,K=$.length-1){for(let he=K;he>=0;he--){const Le=$.charCodeAt(he);if(Le!==32&&Le!==9)return he}return-1}e.lastNonWhitespaceIndex=c;function g($,K,he){const Le=[];let Ne=0;for(const qe of $.matchAll(K)){if(Le.push($.slice(Ne,qe.index)),qe.index===void 0)throw new Error("match.index should be defined");Ne=qe.index+qe[0].length,Le.push(he(qe[0],...qe.slice(1),qe.index,$,qe.groups))}return Le.push($.slice(Ne)),Promise.all(Le).then(qe=>qe.join(""))}e.replaceAsync=g;function i($,K){return $<K?-1:$>K?1:0}e.compare=i;function t($,K,he=0,Le=$.length,Ne=0,qe=K.length){for(;he<Le&&Ne<qe;he++,Ne++){const st=$.charCodeAt(he),at=K.charCodeAt(Ne);if(st<at)return-1;if(st>at)return 1}const je=Le-he,Ze=qe-Ne;return je<Ze?-1:je>Ze?1:0}e.compareSubstring=t;function h($,K){return E($,K,0,$.length,0,K.length)}e.compareIgnoreCase=h;function E($,K,he=0,Le=$.length,Ne=0,qe=K.length){for(;he<Le&&Ne<qe;he++,Ne++){let st=$.charCodeAt(he),at=K.charCodeAt(Ne);if(st===at)continue;if(st>=128||at>=128)return t($.toLowerCase(),K.toLowerCase(),he,Le,Ne,qe);N(st)&&(st-=32),N(at)&&(at-=32);const mt=st-at;if(mt!==0)return mt}const je=Le-he,Ze=qe-Ne;return je<Ze?-1:je>Ze?1:0}e.compareSubstringIgnoreCase=E;function w($){return $>=48&&$<=57}e.isAsciiDigit=w;function N($){return $>=97&&$<=122}e.isLowerAsciiLetter=N;function j($){return $>=65&&$<=90}e.isUpperAsciiLetter=j;function V($,K){return $.length===K.length&&E($,K)===0}e.equalsIgnoreCase=V;function Q($,K){const he=K.length;return K.length>$.length?!1:E($,K,0,he)===0}e.startsWithIgnoreCase=Q;function q($,K){const he=Math.min($.length,K.length);let Le;for(Le=0;Le<he;Le++)if($.charCodeAt(Le)!==K.charCodeAt(Le))return Le;return he}e.commonPrefixLength=q;function U($,K){const he=Math.min($.length,K.length);let Le;const Ne=$.length-1,qe=K.length-1;for(Le=0;Le<he;Le++)if($.charCodeAt(Ne-Le)!==K.charCodeAt(qe-Le))return Le;return he}e.commonSuffixLength=U;function T($){return 55296<=$&&$<=56319}e.isHighSurrogate=T;function F($){return 56320<=$&&$<=57343}e.isLowSurrogate=F;function B($,K){return($-55296<<10)+(K-56320)+65536}e.computeCodePoint=B;function Z($,K,he){const Le=$.charCodeAt(he);if(T(Le)&&he+1<K){const Ne=$.charCodeAt(he+1);if(F(Ne))return B(Le,Ne)}return Le}e.getNextCodePoint=Z;function _($,K){const he=$.charCodeAt(K-1);if(F(he)&&K>1){const Le=$.charCodeAt(K-2);if(T(Le))return B(Le,he)}return he}class H{get offset(){return this.e}constructor(K,he=0){this.c=K,this.d=K.length,this.e=he}setOffset(K){this.e=K}prevCodePoint(){const K=_(this.c,this.e);return this.e-=K>=65536?2:1,K}nextCodePoint(){const K=Z(this.c,this.d,this.e);return this.e+=K>=65536?2:1,K}eol(){return this.e>=this.d}}e.CodePointIterator=H;class Y{get offset(){return this.c.offset}constructor(K,he=0){this.c=new H(K,he)}nextGraphemeLength(){const K=He.getInstance(),he=this.c,Le=he.offset;let Ne=K.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const qe=he.offset,je=K.getGraphemeBreakType(he.nextCodePoint());if(Ce(Ne,je)){he.setOffset(qe);break}Ne=je}return he.offset-Le}prevGraphemeLength(){const K=He.getInstance(),he=this.c,Le=he.offset;let Ne=K.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const qe=he.offset,je=K.getGraphemeBreakType(he.prevCodePoint());if(Ce(je,Ne)){he.setOffset(qe);break}Ne=je}return Le-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Y;function ie($,K){return new Y($,K).nextGraphemeLength()}e.nextCharLength=ie;function ge($,K){return new Y($,K).prevGraphemeLength()}e.prevCharLength=ge;function X($,K){K>0&&F($.charCodeAt(K))&&K--;const he=K+ie($,K);return[he-ge($,he),he]}e.getCharContainingOffset=X;function J($){const K=new Y($);let he=0;for(;!K.eol();)he++,K.nextGraphemeLength();return he}e.charCount=J;let ee;function me(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve($){return ee||(ee=me()),ee.test($)}e.containsRTL=ve;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Re($){return Ie.test($)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ae($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=ae;function le($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=le;function ue($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=ue;function ne($,K){if($.length<K)return $;const he=/\b/g;let Le=0;for(;he.test($)&&!($.length-he.lastIndex<K);)Le=he.lastIndex,he.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ne;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function oe($){return $&&($=$.replace(ce,"")),$}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function M($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=M;function z($){return M($)?$.substr(1):$}e.stripUTF8BOM=z;function G($,K){if(!$||!K||$.length<K.length)return!1;const he=K.length,Le=$.toLowerCase();let Ne=0,qe=-1;for(;Ne<he;){const je=Le.indexOf(K[Ne],qe+1);if(je<0)return!1;qe=je,Ne++}return!0}e.fuzzyContains=G;function te($,K=!1){return $?(K&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=te;function de($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=de;function we($,K=1){if(K===0)return"";let he=-1;do he=$.indexOf(`
`,he+1),K--;while(K>0&&he>=0);return he===-1?$:($[he-1]==="\r"&&he--,$.substr(0,he))}e.getNLines=we;function Pe($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Pe;function be($){return He.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=be;function Ce($,K){return $===0?K!==5&&K!==7:$===2&&K===3?!1:$===4||$===2||$===3||K===4||K===2||K===3?!0:!($===8&&(K===8||K===9||K===11||K===12)||($===11||$===9)&&(K===9||K===10)||($===12||$===10)&&K===10||K===5||K===13||K===7||$===1||$===13&&K===14||$===6&&K===6)}var ke;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(ke=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{static getInstance(){return He.c||(He.c=new He),He.c}constructor(){this.d=Ge()}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const he=this.d,Le=he.length/3;let Ne=1;for(;Ne<=Le;)if(K<he[3*Ne])Ne=2*Ne;else if(K>he[3*Ne+1])Ne=2*Ne+1;else return he[3*Ne+2];return 0}}He.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,K){if($===0)return 0;const he=Qe($,K);if(he!==void 0)return he;const Le=new H(K,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function Qe($,K){const he=new H(K,$);let Le=he.prevCodePoint();for(;tt(Le)||Le===65039||Le===8419;){if(he.offset===0)return;Le=he.prevCodePoint()}if(!ue(Le))return;let Ne=he.offset;return Ne>0&&he.prevCodePoint()===8205&&(Ne=he.offset),Ne}function tt($){return 127995<=$&&$<=127999}var rt;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(K){return Be.d.get(Array.from(K))}static getLocales(){return Be.e.value}constructor(K){this.f=K}isAmbiguous(K){return this.f.has(K)}getPrimaryConfusable(K){return this.f.get(K)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Be,Be.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new o.LRUCachedFunction($=>{function K(at){const mt=new Map;for(let gt=0;gt<at.length;gt+=2)mt.set(at[gt],at[gt+1]);return mt}function he(at,mt){const gt=new Map(at);for(const[Et,lt]of mt)gt.set(Et,lt);return gt}function Le(at,mt){if(!at)return mt;const gt=new Map;for(const[Et,lt]of at)mt.has(Et)&&gt.set(Et,lt);return gt}const Ne=l.c.value;let qe=$.filter(at=>!at.startsWith("_")&&at in Ne);qe.length===0&&(qe=["_default"]);let je;for(const at of qe){const mt=K(Ne[at]);je=Le(je,mt)}const Ze=K(Ne._common),st=he(Ze,je);return new Be(st)}),Be.e=new L.Lazy(()=>Object.keys(Be.c.value).filter($=>!$.startsWith("_"))),e.AmbiguousCharacters=Be;class it{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(it.c())),this.d}static isInvisibleCharacter(K){return it.e().has(K)}static get codePoints(){return it.e()}}it.d=void 0,e.InvisibleCharacters=it}),define(ye[33],De([1,0,12,11,8,9]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(c){return c===47||c===92}e.isPathSeparator=S;function A(c){return c.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=A;function y(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=y;function I(c,g=o.posix.sep){if(!c)return"";const i=c.length,t=c.charCodeAt(0);if(S(t)){if(S(c.charCodeAt(1))&&!S(c.charCodeAt(2))){let E=3;const w=E;for(;E<i&&!S(c.charCodeAt(E));E++);if(w!==E&&!S(c.charCodeAt(E+1))){for(E+=1;E<i;E++)if(S(c.charCodeAt(E)))return c.slice(0,E+1).replace(/[\\/]/g,g)}}return g}else if(u(t)&&c.charCodeAt(1)===58)return S(c.charCodeAt(2))?c.slice(0,2)+g:c.slice(0,2);let h=c.indexOf("://");if(h!==-1){for(h+=3;h<i;h++)if(S(c.charCodeAt(h)))return c.slice(0,h+1)}return""}e.getRoot=I;function O(c){if(!L.isWindows||!c||c.length<5)return!1;let g=c.charCodeAt(0);if(g!==92||(g=c.charCodeAt(1),g!==92))return!1;let i=2;const t=i;for(;i<c.length&&(g=c.charCodeAt(i),g!==92);i++);return!(t===i||(g=c.charCodeAt(i+1),isNaN(g)||g===92))}e.isUNC=O;const P=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(c,g=L.isWindows){const i=g?P:v;return!(!c||c.length===0||/^\s+$/.test(c)||(i.lastIndex=0,i.test(c))||g&&k.test(c)||c==="."||c===".."||g&&c[c.length-1]==="."||g&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=D;function f(c,g,i){const t=c===g;return!i||t?t:!c||!g?!1:(0,l.equalsIgnoreCase)(c,g)}e.isEqual=f;function d(c,g,i,t=o.sep){if(c===g)return!0;if(!c||!g||g.length>c.length)return!1;if(i){if(!(0,l.startsWithIgnoreCase)(c,g))return!1;if(g.length===c.length)return!0;let E=g.length;return g.charAt(g.length-1)===t&&E--,c.charAt(E)===t}return g.charAt(g.length-1)!==t&&(g+=t),c.indexOf(g)===0}e.isEqualOrParent=d;function u(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=u;function m(c,g){return L.isWindows&&c.endsWith(":")&&(c+=o.sep),(0,o.isAbsolute)(c)||(c=(0,o.join)(g,c)),c=(0,o.normalize)(c),L.isWindows?(c=(0,l.rtrim)(c,o.sep),c.endsWith(":")&&(c+=o.sep)):(c=(0,l.rtrim)(c,o.sep),c||(c=o.sep)),c}e.sanitizeFilePath=m;function b(c){const g=(0,o.normalize)(c);return L.isWindows?c.length>3?!1:C(g)&&(c.length===2||g.charCodeAt(2)===92):g===o.posix.sep}e.isRootOrDriveLetter=b;function C(c,g=L.isWindows){return g?u(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function p(c){return C(c)?c[0]:void 0}e.getDriveLetter=p;function n(c,g,i){return g.length>c.length?-1:c===g?0:(i&&(c=c.toLowerCase(),g=g.toLowerCase()),c.indexOf(g))}e.indexOfPath=n;function s(c){const g=c.split(":");let i,t,h;for(const E of g){const w=Number(E);(0,R.isNumber)(w)?t===void 0?t=w:h===void 0&&(h=w):i=i?[i,E].join(":"):E}if(!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:t!==void 0?t:void 0,column:h!==void 0?h:t!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(c,g,i=8){let t="";for(let E=0;E<i;E++)t+=r.charAt(Math.floor(Math.random()*r.length));let h;return g?h=`${g}-${t}`:h=t,c?(0,o.join)(c,h):h}e.randomPath=a}),define(ye[110],De([1,0,28,8]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...oe){return function(M,z){for(let G=0,te=oe.length;G<te;G++){const de=oe[G](M,z);if(de)return de}return null}}e.or=l,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(oe,M,z){if(!z||z.length<M.length)return null;let G;return oe?G=L.startsWithIgnoreCase(z,M):G=z.indexOf(M)===0,G?M.length>0?[{start:0,end:M.length}]:[]:null}function S(oe,M){const z=M.toLowerCase().indexOf(oe.toLowerCase());return z===-1?null:[{start:z,end:z+oe.length}]}e.matchesContiguousSubString=S;function A(oe,M){return y(oe.toLowerCase(),M.toLowerCase(),0,0)}e.matchesSubString=A;function y(oe,M,z,G){if(z===oe.length)return[];if(G===M.length)return null;if(oe[z]===M[G]){let te=null;return(te=y(oe,M,z+1,G+1))?u({start:G,end:G+1},te):null}return y(oe,M,z,G+1)}function I(oe){return 97<=oe&&oe<=122}function O(oe){return 65<=oe&&oe<=90}e.isUpper=O;function P(oe){return 48<=oe&&oe<=57}function v(oe){return oe===32||oe===9||oe===10||oe===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>k.add(oe.charCodeAt(0)));function D(oe){return v(oe)||k.has(oe)}function f(oe,M){return oe===M||D(oe)&&D(M)}function d(oe){return I(oe)||O(oe)||P(oe)}function u(oe,M){return M.length===0?M=[oe]:oe.end===M[0].start?M[0].start=oe.start:M.unshift(oe),M}function m(oe,M){for(let z=M;z<oe.length;z++){const G=oe.charCodeAt(z);if(O(G)||P(G)||z>0&&!d(oe.charCodeAt(z-1)))return z}return oe.length}function b(oe,M,z,G){if(z===oe.length)return[];if(G===M.length)return null;if(oe[z]!==M[G].toLowerCase())return null;{let te=null,de=G+1;for(te=b(oe,M,z+1,G+1);!te&&(de=m(M,de))<M.length;)te=b(oe,M,z+1,de),de++;return te===null?null:u({start:G,end:G+1},te)}}function C(oe){let M=0,z=0,G=0,te=0,de=0;for(let ke=0;ke<oe.length;ke++)de=oe.charCodeAt(ke),O(de)&&M++,I(de)&&z++,d(de)&&G++,P(de)&&te++;const we=M/oe.length,Pe=z/oe.length,be=G/oe.length,Ce=te/oe.length;return{upperPercent:we,lowerPercent:Pe,alphaPercent:be,numericPercent:Ce}}function p(oe){const{upperPercent:M,lowerPercent:z}=oe;return z===0&&M>.6}function n(oe){const{upperPercent:M,lowerPercent:z,alphaPercent:G,numericPercent:te}=oe;return z>.2&&M<.8&&G>.6&&te<.2}function s(oe){let M=0,z=0,G=0,te=0;for(let de=0;de<oe.length;de++)G=oe.charCodeAt(de),O(G)&&M++,I(G)&&z++,v(G)&&te++;return(M===0||z===0)&&te===0?oe.length<=30:M<=5}function r(oe,M){if(!M||(M=M.trim(),M.length===0)||!s(oe)||M.length>60)return null;const z=C(M);if(!n(z)){if(!p(z))return null;M=M.toLowerCase()}let G=null,te=0;for(oe=oe.toLowerCase();te<M.length&&(G=b(oe,M,0,te))===null;)te=m(M,te+1);return G}e.matchesCamelCase=r;function a(oe,M,z=!1){if(!M||M.length===0)return null;let G=null,te=0;for(oe=oe.toLowerCase(),M=M.toLowerCase();te<M.length&&(G=c(oe,M,0,te,z))===null;)te=g(M,te+1);return G}e.matchesWords=a;function c(oe,M,z,G,te){if(z===oe.length)return[];if(G===M.length)return null;if(f(oe.charCodeAt(z),M.charCodeAt(G))){let de=null,we=G+1;if(de=c(oe,M,z+1,G+1,te),!te)for(;!de&&(we=g(M,we))<M.length;)de=c(oe,M,z+1,we,te),we++;return de?oe.charCodeAt(z)!==M.charCodeAt(G)?de:u({start:G,end:G+1},de):null}else return null}function g(oe,M){for(let z=M;z<oe.length;z++)if(D(oe.charCodeAt(z))||z>0&&D(oe.charCodeAt(z-1)))return z;return oe.length}const i=l(e.matchesPrefix,r,S),t=l(e.matchesPrefix,r,A),h=new o.LRUCache(1e4);function E(oe,M,z=!1){if(typeof oe!="string"||typeof M!="string")return null;let G=h.get(oe);G||(G=new RegExp(L.convertSimple2RegExpPattern(oe),"i"),h.set(oe,G));const te=G.exec(M);return te?[{start:te.index,end:te.index+te[0].length}]:z?t(oe,M):i(oe,M)}e.matchesFuzzy=E;function w(oe,M){const z=Ie(oe,oe.toLowerCase(),0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?j(z):null}e.matchesFuzzy2=w;function N(oe,M,z,G,te,de){const we=Math.min(13,oe.length);for(;z<we;z++){const Pe=Ie(oe,M,z,G,te,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=N;function j(oe){if(typeof oe>"u")return[];const M=[],z=oe[1];for(let G=oe.length-1;G>1;G--){const te=oe[G]+z,de=M[M.length-1];de&&de.end===te?de.end=te+1:M.push({start:te,end:te+1})}return M}e.createMatches=j;const V=128;function Q(){const oe=[],M=[];for(let z=0;z<=V;z++)M[z]=0;for(let z=0;z<=V;z++)oe.push(M.slice(0));return oe}function q(oe){const M=[];for(let z=0;z<=oe;z++)M[z]=0;return M}const U=q(2*V),T=q(2*V),F=Q(),B=Q(),Z=Q(),_=!1;function H(oe,M,z,G,te){function de(Pe,be,Ce=" "){for(;Pe.length<be;)Pe=Ce+Pe;return Pe}let we=` |   |${G.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=z;Pe++)Pe===0?we+=" |":we+=`${M[Pe-1]}|`,we+=oe[Pe].slice(0,te+1).map(be=>de(be.toString(),3)).join("|")+`
`;return we}function Y(oe,M,z,G){oe=oe.substr(M),z=z.substr(G),console.log(H(B,oe,oe.length,z,z.length)),console.log(H(Z,oe,oe.length,z,z.length)),console.log(H(F,oe,oe.length,z,z.length))}function ie(oe,M){if(M<0||M>=oe.length)return!1;const z=oe.codePointAt(M);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(z)}}function ge(oe,M){if(M<0||M>=oe.length)return!1;switch(oe.charCodeAt(M)){case 32:case 9:return!0;default:return!1}}function X(oe,M,z){return M[oe]!==z[oe]}function J(oe,M,z,G,te,de,we=!1){for(;M<z&&te<de;)oe[M]===G[te]&&(we&&(U[M]=te),M+=1),te+=1;return M===z}e.isPatternInWord=J;var ee;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var me;(function(oe){oe.Default=[-100,0];function M(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}oe.isDefault=M})(me=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(M,z){this.firstMatchCanBeWeak=M,this.boostFullMatch=z}}ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ve;function Ie(oe,M,z,G,te,de,we=ve.default){const Pe=oe.length>V?V:oe.length,be=G.length>V?V:G.length;if(z>=Pe||de>=be||Pe-z>be-de||!J(M,z,Pe,te,de,be,!0))return;Re(Pe,be,z,de,M,te);let Ce=1,ke=1,He=z,Ge=de;const nt=[!1];for(Ce=1,He=z;He<Pe;Ce++,He++){const it=U[He],$=T[He],K=He+1<Pe?T[He+1]:be;for(ke=it-de+1,Ge=it;Ge<K;ke++,Ge++){let he=Number.MIN_SAFE_INTEGER,Le=!1;Ge<=$&&(he=ae(oe,M,He,z,G,te,Ge,be,de,F[Ce-1][ke-1]===0,nt));let Ne=0;he!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=he+B[Ce-1][ke-1]);const qe=Ge>it,je=qe?B[Ce][ke-1]+(F[Ce][ke-1]>0?-5:0):0,Ze=Ge>it+1&&F[Ce][ke-1]>0,st=Ze?B[Ce][ke-2]+(F[Ce][ke-2]>0?-5:0):0;if(Ze&&(!qe||st>=je)&&(!Le||st>=Ne))B[Ce][ke]=st,Z[Ce][ke]=3,F[Ce][ke]=0;else if(qe&&(!Le||je>=Ne))B[Ce][ke]=je,Z[Ce][ke]=2,F[Ce][ke]=0;else if(Le)B[Ce][ke]=Ne,Z[Ce][ke]=1,F[Ce][ke]=F[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(_&&Y(oe,z,G,de),!nt[0]&&!we.firstMatchCanBeWeak)return;Ce--,ke--;const Qe=[B[Ce][ke],de];let tt=0,rt=0;for(;Ce>=1;){let it=ke;do{const $=Z[Ce][it];if($===3)it=it-2;else if($===2)it=it-1;else break}while(it>=1);tt>1&&M[z+Ce-1]===te[de+ke-1]&&!X(it+de-1,G,te)&&tt+1>F[Ce][it]&&(it=ke),it===ke?tt++:tt=1,rt||(rt=it),Ce--,ke=it-1,Qe.push(ke)}be===Pe&&we.boostFullMatch&&(Qe[0]+=2);const Be=rt-Pe;return Qe[0]-=Be,Qe}e.fuzzyScore=Ie;function Re(oe,M,z,G,te,de){let we=oe-1,Pe=M-1;for(;we>=z&&Pe>=G;)te[we]===de[Pe]&&(T[we]=Pe,we--),Pe--}function ae(oe,M,z,G,te,de,we,Pe,be,Ce,ke){if(M[z]!==de[we])return Number.MIN_SAFE_INTEGER;let He=1,Ge=!1;return we===z-G?He=oe[z]===te[we]?7:5:X(we,te,de)&&(we===0||!X(we-1,te,de))?(He=oe[z]===te[we]?7:5,Ge=!0):ie(de,we)&&(we===0||!ie(de,we-1))?He=5:(ie(de,we-1)||ge(de,we-1))&&(He=5,Ge=!0),He>1&&z===G&&(ke[0]=!0),Ge||(Ge=X(we,te,de)||ie(de,we-1)||ge(de,we-1)),z===G?we>be&&(He-=Ge?3:5):Ce?He+=Ge?2:0:He+=Ge?0:1,we+1===Pe&&(He-=Ge?3:5),He}function le(oe,M,z,G,te,de,we){return ne(oe,M,z,G,te,de,!0,we)}e.fuzzyScoreGracefulAggressive=le;function ue(oe,M,z,G,te,de,we){return ne(oe,M,z,G,te,de,!1,we)}e.fuzzyScoreGraceful=ue;function ne(oe,M,z,G,te,de,we,Pe){let be=Ie(oe,M,z,G,te,de,Pe);if(be&&!we)return be;if(oe.length>=3){const Ce=Math.min(7,oe.length-1);for(let ke=z+1;ke<Ce;ke++){const He=ce(oe,ke);if(He){const Ge=Ie(He,He.toLowerCase(),z,G,te,de,Pe);Ge&&(Ge[0]-=3,(!be||Ge[0]>be[0])&&(be=Ge))}}}return be}function ce(oe,M){if(M+1>=oe.length)return;const z=oe[M],G=oe[M+1];if(z!==G)return oe.slice(0,M)+G+z+oe.slice(M+2)}}),define(ye[88],De([1,0,8]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(u){return l(u,0)}e.hash=L;function l(u,m){switch(typeof u){case"object":return u===null?R(349,m):Array.isArray(u)?y(u,m):I(u,m);case"string":return A(u,m);case"boolean":return S(u,m);case"number":return R(u,m);case"undefined":return R(937,m);default:return R(617,m)}}e.doHash=l;function R(u,m){return(m<<5)-m+u|0}e.numberHash=R;function S(u,m){return R(u?433:863,m)}function A(u,m){m=R(149417,m);for(let b=0,C=u.length;b<C;b++)m=R(u.charCodeAt(b),m);return m}e.stringHash=A;function y(u,m){return m=R(104579,m),u.reduce((b,C)=>l(C,b),m)}function I(u,m){return m=R(181387,m),Object.keys(u).sort().reduce((b,C)=>(b=A(C,b),l(u[C],b)),m)}class O{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=l(m,this.g),this.g}}e.Hasher=O;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function v(u,m,b=32){const C=b-m,p=~((1<<C)-1);return(u<<m|(p&u)>>>C)>>>0}function k(u,m=0,b=u.byteLength,C=0){for(let p=0;p<b;p++)u[m+p]=C}function D(u,m,b="0"){for(;u.length<m;)u=b+u;return u}function f(u,m=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(b=>b.toString(16).padStart(2,"0")).join(""):D((u>>>0).toString(16),m/4)}e.toHexString=f;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const b=m.length;if(b===0)return;const C=this.p;let p=this.r,n=this.u,s,r;for(n!==0?(s=n,r=-1,n=0):(s=m.charCodeAt(0),r=0);;){let a=s;if(o.isHighSurrogate(s))if(r+1<b){const c=m.charCodeAt(r+1);o.isLowSurrogate(c)?(r++,a=o.computeCodePoint(s,c)):a=65533}else{n=s;break}else o.isLowSurrogate(s)&&(a=65533);if(p=this.w(C,p,a),r++,r<b)s=m.charCodeAt(r);else break}this.r=p,this.u=n}w(m,b,C){return C<128?m[b++]=C:C<2048?(m[b++]=192|(C&1984)>>>6,m[b++]=128|(C&63)>>>0):C<65536?(m[b++]=224|(C&61440)>>>12,m[b++]=128|(C&4032)>>>6,m[b++]=128|(C&63)>>>0):(m[b++]=240|(C&1835008)>>>18,m[b++]=128|(C&258048)>>>12,m[b++]=128|(C&4032)>>>6,m[b++]=128|(C&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=d.g,b=this.q;for(let i=0;i<64;i+=4)m.setUint32(i,b.getUint32(i,!1),!1);for(let i=64;i<320;i+=4)m.setUint32(i,v(m.getUint32(i-12,!1)^m.getUint32(i-32,!1)^m.getUint32(i-56,!1)^m.getUint32(i-64,!1),1),!1);let C=this.h,p=this.l,n=this.m,s=this.n,r=this.o,a,c,g;for(let i=0;i<80;i++)i<20?(a=p&n|~p&s,c=1518500249):i<40?(a=p^n^s,c=1859775393):i<60?(a=p&n|p&s|n&s,c=2400959708):(a=p^n^s,c=3395469782),g=v(C,5)+a+r+c+m.getUint32(i*4,!1)&4294967295,r=s,s=n,n=v(p,30),p=C,C=g;this.h=this.h+C&4294967295,this.l=this.l+p&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}d.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=d}),define(ye[111],De([1,0,108,110,88,12,11,8]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,I=[y,[]];function O(F,B,Z,_){if(!F||!B)return I;const H=F.length,Y=B.length;if(H<Y)return I;const ie=F.toLowerCase();return P(B,Z,Y,F,ie,H,_)}e.scoreFuzzy=O;function P(F,B,Z,_,H,Y,ie){const ge=[],X=[];for(let ve=0;ve<Z;ve++){const Ie=ve*Y,Re=Ie-Y,ae=ve>0,le=F[ve],ue=B[ve];for(let ne=0;ne<Y;ne++){const ce=ne>0,oe=Ie+ne,M=oe-1,z=Re+ne-1,G=ce?ge[M]:0,te=ae&&ce?ge[z]:0,de=ae&&ce?X[z]:0;let we;!te&&ae?we=0:we=v(le,ue,_,H,ne,de),we&&te+we>=G&&(ie||ae||H.startsWith(B,ne))?(X[oe]=de+1,ge[oe]=te+we):(X[oe]=y,ge[oe]=G)}}const J=[];let ee=Z-1,me=Y-1;for(;ee>=0&&me>=0;){const ve=ee*Y+me;X[ve]===y||(J.push(me),ee--),me--}return[ge[Z*Y-1],J.reverse()]}function v(F,B,Z,_,H,Y){let ie=0;if(!k(B,_[H]))return ie;if(ie+=1,Y>0&&(ie+=Y*5),F===Z[H]&&(ie+=1),H===0)ie+=8;else{const ge=D(Z.charCodeAt(H-1));ge?ie+=ge:(0,L.isUpper)(Z.charCodeAt(H))&&Y===0&&(ie+=2)}return ie}function k(F,B){return F===B?!0:F==="/"||F==="\\"?B==="/"||B==="\\":!1}function D(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(F,B,Z=0,_=0){const H=B;return H.values&&H.values.length>1?u(F,H.values,Z,_):m(F,B,Z,_)}e.scoreFuzzy2=d;function u(F,B,Z,_){let H=0;const Y=[];for(const ie of B){const[ge,X]=m(F,ie,Z,_);if(typeof ge!="number")return f;H+=ge,Y.push(...X)}return[H,t(Y)]}function m(F,B,Z,_){const H=(0,L.fuzzyScore)(B.original,B.originalLowercase,Z,F,F.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?[H[0],(0,L.createMatches)(H)]:f}const b=Object.freeze({score:0}),C=1<<18,p=1<<17,n=1<<16;function s(F,B,Z,_){const H=_.values?_.values:[_];return(0,l.hash)({[_.normalized]:{values:H.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:F,description:B,allowNonContiguousMatches:Z}})}function r(F,B,Z,_,H){if(!F||!B.normalized)return b;const Y=_.getItemLabel(F);if(!Y)return b;const ie=_.getItemDescription(F),ge=s(Y,ie,Z,B),X=H[ge];if(X)return X;const J=a(Y,ie,_.getItemPath(F),B,Z);return H[ge]=J,J}e.scoreItemFuzzy=r;function a(F,B,Z,_,H){const Y=!Z||!_.containsPathSeparator;return Z&&(S.isLinux?_.pathNormalized===Z:(0,A.equalsIgnoreCase)(_.pathNormalized,Z))?{score:C,labelMatch:[{start:0,end:F.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:_.values&&_.values.length>1?c(F,B,Z,_.values,Y,H):g(F,B,Z,_,Y,H)}function c(F,B,Z,_,H,Y){let ie=0;const ge=[],X=[];for(const J of _){const{score:ee,labelMatch:me,descriptionMatch:ve}=g(F,B,Z,J,H,Y);if(ee===y)return b;ie+=ee,me&&ge.push(...me),ve&&X.push(...ve)}return{score:ie,labelMatch:t(ge),descriptionMatch:t(X)}}function g(F,B,Z,_,H,Y){if(H||!B){const[ie,ge]=O(F,_.normalized,_.normalizedLowercase,Y&&!_.expectContiguousMatch);if(ie){const X=(0,L.matchesPrefix)(_.normalized,F);let J;return X?(J=p,J+=Math.round(_.normalized.length/F.length*100)):J=n,{score:J+ie,labelMatch:X||i(ge)}}}if(B){let ie=B;Z&&(ie=`${B}${R.sep}`);const ge=ie.length,X=`${ie}${F}`,[J,ee]=O(X,_.normalized,_.normalizedLowercase,Y&&!_.expectContiguousMatch);if(J){const me=i(ee),ve=[],Ie=[];return me.forEach(Re=>{Re.start<ge&&Re.end>ge?(ve.push({start:0,end:Re.end-ge}),Ie.push({start:Re.start,end:ge})):Re.start>=ge?ve.push({start:Re.start-ge,end:Re.end-ge}):Ie.push(Re)}),{score:J,labelMatch:ve,descriptionMatch:Ie}}}return b}function i(F){const B=[];if(!F)return B;let Z;for(const _ of F)Z&&Z.end===_?Z.end+=1:(Z={start:_,end:_+1},B.push(Z));return B}function t(F){const B=F.sort((H,Y)=>H.start-Y.start),Z=[];let _;for(const H of B)!_||!h(_,H)?(_=H,Z.push(H)):(_.start=Math.min(_.start,H.start),_.end=Math.max(_.end,H.end));return Z}function h(F,B){return!(F.end<B.start||B.end<F.start)}function E(F,B,Z,_,H,Y){const ie=r(F,Z,_,H,Y),ge=r(B,Z,_,H,Y),X=ie.score,J=ge.score;if((X===C||J===C)&&X!==J)return X===C?-1:1;if(X>n||J>n){if(X!==J)return X>J?-1:1;if(X<p&&J<p){const le=N(ie.labelMatch,ge.labelMatch);if(le!==0)return le}const Re=H.getItemLabel(F)||"",ae=H.getItemLabel(B)||"";if(Re.length!==ae.length)return Re.length-ae.length}if(X!==J)return X>J?-1:1;const ee=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,me=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(ee&&!me)return-1;if(me&&!ee)return 1;const ve=w(F,ie,H),Ie=w(B,ge,H);return ve&&Ie&&ve!==Ie?Ie>ve?-1:1:j(F,B,Z,H)}e.compareItemsByFuzzyScore=E;function w(F,B,Z){let _=-1,H=-1;if(B.descriptionMatch&&B.descriptionMatch.length?_=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(_=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(H=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const Y=Z.getItemDescription(F);Y&&(H+=Y.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(H=B.descriptionMatch[B.descriptionMatch.length-1].end);return H-_}function N(F,B){if(!F&&!B||(!F||!F.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!F||!F.length)return 1;const Z=F[0].start,H=F[F.length-1].end-Z,Y=B[0].start,ge=B[B.length-1].end-Y;return H===ge?0:ge<H?1:-1}function j(F,B,Z,_){const H=_.getItemLabel(F)||"",Y=_.getItemLabel(B)||"",ie=_.getItemDescription(F),ge=_.getItemDescription(B),X=H.length+(ie?ie.length:0),J=Y.length+(ge?ge.length:0);if(X!==J)return X-J;const ee=_.getItemPath(F),me=_.getItemPath(B);return ee&&me&&ee.length!==me.length?ee.length-me.length:H!==Y?(0,o.compareAnything)(H,Y,Z.normalized):ie&&ge&&ie!==ge?(0,o.compareAnything)(ie,ge,Z.normalized):ee&&me&&ee!==me?(0,o.compareAnything)(ee,me,Z.normalized):0}function V(F){return F.startsWith('"')&&F.endsWith('"')}const Q=" ";function q(F){typeof F!="string"&&(F="");const B=F.toLowerCase(),{pathNormalized:Z,normalized:_,normalizedLowercase:H}=U(F),Y=Z.indexOf(R.sep)>=0,ie=V(F);let ge;const X=F.split(Q);if(X.length>1)for(const J of X){const ee=V(J),{pathNormalized:me,normalized:ve,normalizedLowercase:Ie}=U(J);ve&&(ge||(ge=[]),ge.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:me,normalized:ve,normalizedLowercase:Ie,expectContiguousMatch:ee}))}return{original:F,originalLowercase:B,pathNormalized:Z,normalized:_,normalizedLowercase:H,values:ge,containsPathSeparator:Y,expectContiguousMatch:ie}}e.prepareQuery=q;function U(F){let B;S.isWindows?B=F.replace(/\//g,R.sep):B=F.replace(/\\/g,R.sep);const Z=(0,A.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function T(F){return Array.isArray(F)?q(F.map(B=>B.original).join(Q)):q(F.original)}e.pieceToQuery=T}),define(ye[163],De([1,0,110,8,51]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",S=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function y(u){return u.replace(A,(m,b)=>b?m:`\\${m}`)}e.escapeIcons=y;const I=new RegExp(`\\\\${S.source}`,"g");function O(u){return u.replace(I,m=>`\\${m}`)}e.markdownEscapeEscapedIcons=O;const P=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function v(u){return u.indexOf(R)===-1?u:u.replace(P,(m,b,C,p)=>C?m:b||p||"")}e.stripIcons=v;function k(u){return u?u.replace(/\$\((.*?)\)/g,(m,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;const D=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(u){D.lastIndex=0;let m="";const b=[];let C=0;for(;;){const p=D.lastIndex,n=D.exec(u),s=u.substring(p,n?.index);if(s.length>0){m+=s;for(let r=0;r<s.length;r++)b.push(C)}if(!n)break;C+=n[0].length}return{text:m,iconOffsets:b}}e.parseLabelWithIcons=f;function d(u,m,b=!1){const{text:C,iconOffsets:p}=m;if(!p||p.length===0)return(0,o.matchesFuzzy)(u,C,b);const n=(0,L.ltrim)(C," "),s=C.length-n.length,r=(0,o.matchesFuzzy)(u,n,b);if(r)for(const a of r){const c=p[a.start+s]+s;a.start+=c,a.end+=c}return r}e.matchesFuzzyIconAware=d}),define(ye[37],De([1,0,8]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(L||(L={})),function(l){const R="error",S="warning",A="warn",y="info",I="ignore";function O(v){return v?o.equalsIgnoreCase(R,v)?l.Error:o.equalsIgnoreCase(S,v)||o.equalsIgnoreCase(A,v)?l.Warning:o.equalsIgnoreCase(y,v)?l.Info:l.Ignore:l.Ignore}l.fromValue=O;function P(v){switch(v){case l.Error:return R;case l.Warning:return S;case l.Info:return y;default:return I}}l.toString=P}(L||(L={})),e.default=L}),define(ye[68],De([1,0,15,8]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const D=k.charCodeAt(0),f=this.b.charCodeAt(this.c);return D-f}value(){return this.b[this.c]}}e.StringIterator=l;class R{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,L.compareSubstring)(k,this.b,0,k.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class S{constructor(k=!0,D=!0){this.f=k,this.g=D}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let D=k.length-1;D>=0;D--,this.c--){const f=this.b.charCodeAt(D);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,L.compareSubstring)(k,this.b,0,k.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=S;var A;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(k,D){this.f=k,this.g=D,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(k,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,L.compare)(k,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(O||(O={}));class P{static forUris(k=()=>!1,D=()=>!1){return new P(new y(k,D))}static forPaths(k=!1){return new P(new S(void 0,!k))}static forStrings(){return new P(new l)}static forConfigKeys(){return new P(new R)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,D){if(D){const f=D.slice(0);(0,o.shuffle)(f);for(const d of f)this.set(d,k)}else{const f=k.slice(0);(0,o.shuffle)(f);for(const d of f)this.set(d[0],d[1])}}set(k,D){const f=this.b.reset(k);let d;this.c||(this.c=new I,this.c.segment=f.value());const u=[];for(d=this.c;;){const b=f.cmp(d.segment);if(b>0)d.left||(d.left=new I,d.left.segment=f.value()),u.push([-1,d]),d=d.left;else if(b<0)d.right||(d.right=new I,d.right.segment=f.value()),u.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new I,d.mid.segment=f.value()),u.push([0,d]),d=d.mid;else break}const m=d.value;d.value=D,d.key=k;for(let b=u.length-1;b>=0;b--){const C=u[b][1];C.updateHeight();const p=C.balanceFactor();if(p<-1||p>1){const n=u[b][0],s=u[b+1][0];if(n===1&&s===1)u[b][1]=C.rotateLeft();else if(n===-1&&s===-1)u[b][1]=C.rotateRight();else if(n===1&&s===-1)C.right=u[b+1][1]=u[b+1][1].rotateRight(),u[b][1]=C.rotateLeft();else if(n===-1&&s===1)C.left=u[b+1][1]=u[b+1][1].rotateLeft(),u[b][1]=C.rotateRight();else throw new Error;if(b>0)switch(u[b-1][0]){case-1:u[b-1][1].left=u[b][1];break;case 1:u[b-1][1].right=u[b][1];break;case 0:u[b-1][1].mid=u[b][1];break}else this.c=u[0][1]}}return m}get(k){return this.d(k)?.value}d(k){const D=this.b.reset(k);let f=this.c;for(;f;){const d=D.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(D.hasNext())D.next(),f=f.mid;else break}return f}has(k){const D=this.d(k);return!(D?.value===void 0&&D?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,D){const f=this.b.reset(k),d=[];let u=this.c;for(;u;){const m=f.cmp(u.segment);if(m>0)d.push([-1,u]),u=u.left;else if(m<0)d.push([1,u]),u=u.right;else if(f.hasNext())f.next(),d.push([0,u]),u=u.mid;else break}if(!!u){if(D?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const m=this.f(u.right);if(m.key){const{key:b,value:C,segment:p}=m;this.e(m.key,!1),u.key=b,u.value=C,u.segment=p}}else{const m=u.left??u.right;if(d.length>0){const[b,C]=d[d.length-1];switch(b){case-1:C.left=m;break;case 0:C.mid=m;break;case 1:C.right=m;break}}else this.c=m}for(let m=d.length-1;m>=0;m--){const b=d[m][1];b.updateHeight();const C=b.balanceFactor();if(C>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),d[m][1]=b.rotateLeft()):C<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),d[m][1]=b.rotateRight()),m>0)switch(d[m-1][0]){case-1:d[m-1][1].left=d[m][1];break;case 1:d[m-1][1].right=d[m][1];break;case 0:d[m-1][1].mid=d[m][1];break}else this.c=d[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const D=this.b.reset(k);let f=this.c,d;for(;f;){const u=D.cmp(f.segment);if(u>0)f=f.left;else if(u<0)f=f.right;else if(D.hasNext())D.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(k){return this.g(k,!1)}g(k,D){const f=this.b.reset(k);let d=this.c;for(;d;){const u=f.cmp(d.segment);if(u>0)d=d.left;else if(u<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this.h(d.mid):D?d.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[D,f]of this)k(f,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const D=[];return this.j(k,D),D[Symbol.iterator]()}j(k,D){!k||(k.left&&this.j(k.left,D),k.value&&D.push([k.key,k.value]),k.mid&&this.j(k.mid,D),k.right&&this.j(k.right,D))}_isBalanced(){const k=D=>{if(!D)return!0;const f=D.balanceFactor();return f<-1||f>1?!1:k(D.left)&&k(D.right)};return k(this.c)}}e.TernarySearchTree=P}),define(ye[2],De([1,0,12,11]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,R=/^\//,S=/^\/\//;function A(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,a){return!r&&!a?"file":r}function I(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const O="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(a){return a instanceof k?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,c,g,i,t,h=!1){typeof a=="object"?(this.scheme=a.scheme||O,this.authority=a.authority||O,this.path=a.path||O,this.query=a.query||O,this.fragment=a.fragment||O):(this.scheme=y(a,h),this.authority=c||O,this.path=I(this.scheme,g||O),this.query=i||O,this.fragment=t||O,A(this,h))}get fsPath(){return b(this,!1)}with(a){if(!a)return this;let{scheme:c,authority:g,path:i,query:t,fragment:h}=a;return c===void 0?c=this.scheme:c===null&&(c=O),g===void 0?g=this.authority:g===null&&(g=O),i===void 0?i=this.path:i===null&&(i=O),t===void 0?t=this.query:t===null&&(t=O),h===void 0?h=this.fragment:h===null&&(h=O),c===this.scheme&&g===this.authority&&i===this.path&&t===this.query&&h===this.fragment?this:new f(c,g,i,t,h)}static parse(a,c=!1){const g=v.exec(a);return g?new f(g[2]||O,s(g[4]||O),s(g[5]||O),s(g[7]||O),s(g[9]||O),c):new f(O,O,O,O,O)}static file(a){let c=O;if(L.isWindows&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const g=a.indexOf(P,2);g===-1?(c=a.substring(2),a=P):(c=a.substring(2,g),a=a.substring(g)||P)}return new f("file",c,a,O,O)}static from(a){const c=new f(a.scheme,a.authority,a.path,a.query,a.fragment);return A(c,!0),c}static joinPath(a,...c){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.isWindows&&a.scheme==="file"?g=k.file(o.win32.join(b(a,!0),...c)).path:g=o.posix.join(a.path,...c),a.with({path:g})}toString(a=!1){return C(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof k)return a;{const c=new f(a);return c._formatted=a.external,c._fsPath=a._sep===D?a.fsPath:null,c}}else return a}}e.URI=k;const D=L.isWindows?1:void 0;class f extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(a=!1){return a?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=D),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(r,a,c){let g,i=-1;for(let t=0;t<r.length;t++){const h=r.charCodeAt(t);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||a&&h===47||c&&h===91||c&&h===93||c&&h===58)i!==-1&&(g+=encodeURIComponent(r.substring(i,t)),i=-1),g!==void 0&&(g+=r.charAt(t));else{g===void 0&&(g=r.substr(0,t));const E=d[h];E!==void 0?(i!==-1&&(g+=encodeURIComponent(r.substring(i,t)),i=-1),g+=E):i===-1&&(i=t)}}return i!==-1&&(g+=encodeURIComponent(r.substring(i))),g!==void 0?g:r}function m(r){let a;for(let c=0;c<r.length;c++){const g=r.charCodeAt(c);g===35||g===63?(a===void 0&&(a=r.substr(0,c)),a+=d[g]):a!==void 0&&(a+=r[c])}return a!==void 0?a:r}function b(r,a){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=b;function C(r,a){const c=a?m:u;let g="",{scheme:i,authority:t,path:h,query:E,fragment:w}=r;if(i&&(g+=i,g+=":"),(t||i==="file")&&(g+=P,g+=P),t){let N=t.indexOf("@");if(N!==-1){const j=t.substr(0,N);t=t.substr(N+1),N=j.lastIndexOf(":"),N===-1?g+=c(j,!1,!1):(g+=c(j.substr(0,N),!1,!1),g+=":",g+=c(j.substr(N+1),!1,!0)),g+="@"}t=t.toLowerCase(),N=t.lastIndexOf(":"),N===-1?g+=c(t,!1,!0):(g+=c(t.substr(0,N),!1,!0),g+=t.substr(N))}if(h){if(h.length>=3&&h.charCodeAt(0)===47&&h.charCodeAt(2)===58){const N=h.charCodeAt(1);N>=65&&N<=90&&(h=`/${String.fromCharCode(N+32)}:${h.substr(3)}`)}else if(h.length>=2&&h.charCodeAt(1)===58){const N=h.charCodeAt(0);N>=65&&N<=90&&(h=`${String.fromCharCode(N+32)}:${h.substr(2)}`)}g+=c(h,!0,!1)}return E&&(g+="?",g+=c(E,!1,!1)),w&&(g+="#",g+=a?w:u(w,!1,!1)),g}function p(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+p(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(n)?r.replace(n,a=>p(a)):r}}),define(ye[69],De([1,0,22,8,2]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(I){return JSON.stringify(I,A)}e.stringify=R;function S(I){let O=JSON.parse(I);return O=y(O),O}e.parse=S;function A(I,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,L.regExpFlags)(O)}:O}function y(I,O=0){if(!I||O>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return l.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof o.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let P=0;P<I.length;++P)I[P]=y(I[P],O+1);else for(const P in I)Object.hasOwnProperty.call(I,P)&&(I[P]=y(I[P],O+1))}return I}e.revive=y}),define(ye[16],De([1,0,10,11,2]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${R.vscodeRemoteResource}`}set(O,P,v){this.a[O]=P,this.b[O]=v}setConnectionToken(O,P){this.c[O]=P}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(d){return o.onUnexpectedError(d),O}const P=O.authority;let v=this.a[P];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const k=this.b[P],D=this.c[P];let f=`path=${encodeURIComponent(O.path)}`;return typeof D=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),l.URI.from({scheme:L.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${k}`,path:this.f,query:f})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(O){const P=this.b(O,re);return this.uriToBrowserUri(P)}uriToBrowserUri(O){return O.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===R.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${R.vscodeFileResource}://${A.a}`)?O.with({scheme:R.vscodeFileResource,authority:O.authority||A.a,query:null,fragment:null}):O}asFileUri(O){const P=this.b(O,re);return this.uriToFileUri(P)}uriToFileUri(O){return O.scheme===R.vscodeFileResource?O.with({scheme:R.file,authority:O.authority!==A.a?O.authority:null,query:null,fragment:null}):O}b(O,P){return l.URI.isUri(O)?O:l.URI.parse(P.toUrl(O))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(I){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(O.get("3"));const P="vscode-coi";function v(D){let f;typeof D=="string"?f=new URL(D).searchParams:D instanceof URL?f=D.searchParams:l.URI.isUri(D)&&(f=new URL(D.toString(!0)).searchParams);const d=f?.get(P);if(!!d)return O.get(d)}I.getHeadersFromQuery=v;function k(D,f,d){if(!globalThis.crossOriginIsolated)return;const u=f&&d?"3":d?"2":"1";D instanceof URLSearchParams?D.set(P,u):D[P]=u}I.addSearchParam=k})(y=e.COI||(e.COI={}))}),define(ye[24],De([1,0,33,16,12,11,8,2]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(k){return(0,A.uriToFsPath)(k,!0)}e.originalFSPath=y;class I{constructor(D){this.a=D}compare(D,f,d=!1){return D===f?0:(0,S.compare)(this.getComparisonKey(D,d),this.getComparisonKey(f,d))}isEqual(D,f,d=!1){return D===f?!0:!D||!f?!1:this.getComparisonKey(D,d)===this.getComparisonKey(f,d)}getComparisonKey(D,f=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,f,d=!1){if(D.scheme===f.scheme){if(D.scheme===L.Schemas.file)return o.isEqualOrParent(y(D),y(f),this.a(D))&&D.query===f.query&&(d||D.fragment===f.fragment);if((0,e.isEqualAuthority)(D.authority,f.authority))return o.isEqualOrParent(D.path,f.path,this.a(D),"/")&&D.query===f.query&&(d||D.fragment===f.fragment)}return!1}joinPath(D,...f){return A.URI.joinPath(D,...f)}basenameOrAuthority(D){return(0,e.basename)(D)||D.authority}basename(D){return l.posix.basename(D.path)}extname(D){return l.posix.extname(D.path)}dirname(D){if(D.path.length===0)return D;let f;return D.scheme===L.Schemas.file?f=A.URI.file(l.dirname(y(D))).path:(f=l.posix.dirname(D.path),D.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),f="/")),D.with({path:f})}normalizePath(D){if(!D.path.length)return D;let f;return D.scheme===L.Schemas.file?f=A.URI.file(l.normalize(y(D))).path:f=l.posix.normalize(D.path),D.with({path:f})}relativePath(D,f){if(D.scheme!==f.scheme||!(0,e.isEqualAuthority)(D.authority,f.authority))return;if(D.scheme===L.Schemas.file){const m=l.relative(y(D),y(f));return R.isWindows?o.toSlashes(m):m}let d=D.path||"/";const u=f.path||"/";if(this.a(D)){let m=0;for(const b=Math.min(d.length,u.length);m<b&&!(d.charCodeAt(m)!==u.charCodeAt(m)&&d.charAt(m).toLowerCase()!==u.charAt(m).toLowerCase());m++);d=u.substr(0,m)+d.substr(m)}return l.posix.relative(d,u)}resolvePath(D,f){if(D.scheme===L.Schemas.file){const d=A.URI.file(l.resolve(y(D),f));return D.with({authority:d.authority,path:d.path})}return f=o.toPosixPath(f),D.with({path:l.posix.resolve(D.path,f)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,f){return D===f||D!==void 0&&f!==void 0&&(0,S.equalsIgnoreCase)(D,f)}hasTrailingPathSeparator(D,f=l.sep){if(D.scheme===L.Schemas.file){const d=y(D);return d.length>o.getRoot(d).length&&d[d.length-1]===f}else{const d=D.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,f=l.sep){return(0,e.hasTrailingPathSeparator)(D,f)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,f=l.sep){let d=!1;if(D.scheme===L.Schemas.file){const u=y(D);d=u!==void 0&&u.length===o.getRoot(u).length&&u[u.length-1]===f}else{f="/";const u=D.path;d=u.length===1&&u.charCodeAt(u.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(D,f)?D.with({path:D.path+"/"}):D}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(k=>k.scheme===L.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new I(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(k,D){const f=[];for(let d=0;d<k.length;d++){const u=D(k[d]);k.some((m,b)=>b===d?!1:(0,e.isEqualOrParent)(u,D(m)))||f.push(k[d])}return f}e.distinctParents=O;var P;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function D(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[C,p]=b.split(":");C&&p&&d.set(C,p)});const m=f.path.substring(0,f.path.indexOf(";"));return m&&d.set(k.META_DATA_MIME,m),d}k.parseMetaData=D})(P=e.DataUri||(e.DataUri={}));function v(k,D,f){if(D){let d=k.path;return d&&d[0]!==l.posix.sep&&(d=l.posix.sep+d),k.with({scheme:f,authority:D,path:d})}return k.with({scheme:f})}e.toLocalResource=v}),define(ye[19],De([1,0,21,10,3,6,24,11,148]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(J){return!!J&&typeof J.then=="function"}e.isThenable=I;function O(J){const ee=new o.CancellationTokenSource,me=J(ee.token),ve=new Promise((Ie,Re)=>{const ae=ee.token.onCancellationRequested(()=>{ae.dispose(),ee.dispose(),Re(new L.CancellationError)});Promise.resolve(me).then(le=>{ae.dispose(),ee.dispose(),Ie(le)},le=>{ae.dispose(),ee.dispose(),Re(le)})});return new class{cancel(){ee.cancel()}then(Ie,Re){return ve.then(Ie,Re)}catch(Ie){return this.then(void 0,Ie)}finally(Ie){return ve.finally(Ie)}}}e.createCancelablePromise=O;function P(J,ee,me){return new Promise((ve,Ie)=>{const Re=ee.onCancellationRequested(()=>{Re.dispose(),ve(me)});J.then(ve,Ie).finally(()=>Re.dispose())})}e.raceCancellation=P;function v(J,ee){return new Promise((me,ve)=>{const Ie=ee.onCancellationRequested(()=>{Ie.dispose(),ve(new L.CancellationError)});J.then(me,ve).finally(()=>Ie.dispose())})}e.raceCancellationError=v;async function k(J){let ee=-1;const me=J.map((Ie,Re)=>Ie.then(ae=>(ee=Re,ae))),ve=await Promise.race(me);return J.forEach((Ie,Re)=>{Re!==ee&&Ie.cancel()}),ve}e.raceCancellablePromises=k;function D(J,ee,me){let ve;const Ie=setTimeout(()=>{ve?.(void 0),me?.()},ee);return Promise.race([J.finally(()=>clearTimeout(Ie)),new Promise(Re=>ve=Re)])}e.raceTimeout=D;function f(J){return new Promise((ee,me)=>{const ve=J();I(ve)?ve.then(ee,me):ee(ve)})}e.asPromise=f;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(ee){if(this.a){if(this.d=ee,!this.b){const me=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(me,me).then(ve)})}return new Promise((me,ve)=>{this.b.then(me,ve)})}return this.a=ee(),new Promise((me,ve)=>{this.a.then(Ie=>{this.a=null,me(Ie)},Ie=>{this.a=null,ve(Ie)})})}}e.Throttler=d;class u{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.Sequencer=u;class m{constructor(){this.a=new Map}queue(ee,me){const Ie=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(ee)===Ie&&this.a.delete(ee)});return this.a.set(ee,Ie),Ie}}e.SequencerByKey=m;const b=(J,ee)=>{let me=!0;const ve=setTimeout(()=>{me=!1,ee()},J);return{isTriggered:()=>me,dispose:()=>{clearTimeout(ve),me=!1}}},C=J=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,J())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class p{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,me=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((Ie,Re)=>{this.d=Ie,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const Ie=this.g;return this.g=null,Ie()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=me===y.MicrotaskDelay?C(ve):b(me,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class n{constructor(ee){this.a=new p(ee),this.b=new d}trigger(ee,me){return this.a.trigger(()=>this.b.queue(ee),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class s{constructor(){this.a=!1,this.b=new Promise((ee,me)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function a(J,ee){return ee?new Promise((me,ve)=>{const Ie=setTimeout(()=>{Re.dispose(),me()},J),Re=ee.onCancellationRequested(()=>{clearTimeout(Ie),Re.dispose(),ve(new L.CancellationError)})}):O(me=>a(J,me))}e.timeout=a;function c(J,ee=0){const me=setTimeout(J,ee);return(0,R.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=c;function g(J){const ee=[];let me=0;const ve=J.length;function Ie(){return me<ve?J[me++]():null}function Re(ae){ae!=null&&ee.push(ae);const le=Ie();return le?le.then(Re):Promise.resolve(ee)}return Promise.resolve(null).then(Re)}e.sequence=g;function i(J,ee=ve=>!!ve,me=null){let ve=0;const Ie=J.length,Re=()=>{if(ve>=Ie)return Promise.resolve(me);const ae=J[ve++];return Promise.resolve(ae()).then(ue=>ee(ue)?Promise.resolve(ue):Re())};return Re()}e.first=i;function t(J,ee=ve=>!!ve,me=null){if(J.length===0)return Promise.resolve(me);let ve=J.length;const Ie=()=>{ve=-1;for(const Re of J)Re.cancel?.()};return new Promise((Re,ae)=>{for(const le of J)le.then(ue=>{--ve>=0&&ee(ue)?(Ie(),Re(ue)):ve===0&&Re(me)}).catch(ue=>{--ve>=0&&(Ie(),ae(ue))})})}e.firstParallel=t;class h{constructor(ee){this.a=0,this.d=ee,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(ee){return this.a++,new Promise((me,ve)=>{this.f.push({factory:ee,c:me,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ee=this.f.shift();this.b++;const me=ee.factory();me.then(ee.c,ee.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=h;class E extends h{constructor(){super(1)}}e.Queue=E;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const ee=new _;return this.b.add(ee),ee.p}d(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueFor(ee,me=S.extUri){const ve=me.getComparisonKey(ee);let Ie=this.a.get(ve);return Ie||(Ie=new E,l.Event.once(Ie.onDrained)(()=>{Ie?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ie)),Ie}f(){!this.d()||this.g()}g(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.g()}}e.ResourceQueue=w;class N{constructor(ee,me){this.a=-1,typeof ee=="function"&&typeof me=="number"&&this.setIfNotSet(ee,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},me)}setIfNotSet(ee,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},me))}}e.TimeoutTimer=N;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ee,me){this.cancel(),this.a=setInterval(()=>{ee()},me)}}e.IntervalTimer=j;class V{constructor(ee,me){this.b=-1,this.a=ee,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class Q{constructor(ee,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=ee,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Q;class q extends V{constructor(ee,me){super(ee,me),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=q;class U extends R.Disposable{constructor(ee,me){super(),this.g=ee,this.h=me,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const me of ee)this.a.push(me);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,A.setTimeout0)(()=>{if(ee)return;const me=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(J,ee)=>{const me=requestIdleCallback(J,typeof ee=="number"?{timeout:ee}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(me))}}}}();class T{constructor(ee){this.d=!1,this.a=()=>{try{this.f=ee()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function F(J,ee,me){let ve;for(let Ie=0;Ie<me;Ie++)try{return await J()}catch(Re){ve=Re,await a(ee)}throw ve}e.retry=F;class B{hasPending(ee){return this.a?typeof ee=="number"?this.a.taskId===ee:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(ee,me,ve){return this.a={taskId:ee,cancel:()=>ve?.(),promise:me},me.then(()=>this.d(ee),()=>this.d(ee)),me}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this.b)this.b.run=ee;else{let me,ve;const Ie=new Promise((Re,ae)=>{me=Re,ve=ae});this.b={run:ee,promise:Ie,promiseResolve:me,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=B;class Z{constructor(ee,me=()=>Date.now()){this.d=ee,this.f=me,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.IntervalCounter=Z;class _{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((ee,me)=>{this.a=ee,this.b=me})}complete(ee){return new Promise(me=>{this.a(ee),this.f=!0,me()})}error(ee){return new Promise(me=>{this.b(ee),this.d=!0,me()})}cancel(){new Promise(ee=>{this.b(new L.CancellationError),this.d=!0,ee()})}}e.DeferredPromise=_;var H;(function(J){async function ee(ve){let Ie;const Re=await Promise.all(ve.map(ae=>ae.then(le=>le,le=>{Ie||(Ie=le)})));if(typeof Ie<"u")throw Ie;return Re}J.settled=ee;function me(ve){return new Promise(async(Ie,Re)=>{try{await ve(Ie,Re)}catch(ae){Re(ae)}})}J.withAsyncBody=me})(H=e.Promises||(e.Promises={}));var Y;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(Y||(Y={}));class ie{static fromArray(ee){return new ie(me=>{me.emitMany(ee)})}static fromPromise(ee){return new ie(async me=>{me.emitMany(await ee)})}static fromPromises(ee){return new ie(async me=>{await Promise.all(ee.map(async ve=>me.emitOne(await ve)))})}static merge(ee){return new ie(async me=>{await Promise.all(ee.map(async ve=>{for await(const Ie of ve)me.emitOne(Ie)}))})}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const me={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(ee(me)),this.j()}catch(ve){this.k(ve)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,me){return new ie(async ve=>{for await(const Ie of ee)ve.emitOne(me(Ie))})}map(ee){return ie.map(this,ee)}static filter(ee,me){return new ie(async ve=>{for await(const Ie of ee)me(Ie)&&ve.emitOne(Ie)})}filter(ee){return ie.filter(this,ee)}static coalesce(ee){return ie.filter(ee,me=>!!me)}coalesce(){return ie.coalesce(this)}static async toPromise(ee){const me=[];for await(const ve of ee)me.push(ve);return me}toPromise(){return ie.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class ge extends ie{constructor(ee,me){super(me),this.l=ee}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ge;function X(J){const ee=new o.CancellationTokenSource,me=J(ee.token);return new ge(ee,async ve=>{const Ie=ee.token.onCancellationRequested(()=>{Ie.dispose(),ee.dispose(),ve.reject(new L.CancellationError)});try{for await(const Re of me){if(ee.token.isCancellationRequested)return;ve.emitOne(Re)}Ie.dispose(),ee.dispose()}catch(Re){Ie.dispose(),ee.dispose(),ve.reject(Re)}})}e.createCancelableAsyncIterable=X}),define(ye[38],De([1,0,15,19,33,28,12,11,8]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",P="[^/\\\\]",v=/\//g;function k(Z,_){switch(Z){case 0:return"";case 1:return`${P}*?`;default:return`(?:${O}|${P}+${O}${_?`|${O}${P}+`:""})*?`}}function D(Z,_){if(!Z)return[];const H=[];let Y=!1,ie=!1,ge="";for(const X of Z){switch(X){case _:if(!Y&&!ie){H.push(ge),ge="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ge+=X}return ge&&H.push(ge),H}e.splitGlobAware=D;function f(Z){if(!Z)return"";let _="";const H=D(Z,e.GLOB_SPLIT);if(H.every(Y=>Y===e.GLOBSTAR))_=".*";else{let Y=!1;H.forEach((ie,ge)=>{if(ie===e.GLOBSTAR){if(Y)return;_+=k(2,ge===H.length-1)}else{let X=!1,J="",ee=!1,me="";for(const ve of ie){if(ve!=="}"&&X){J+=ve;continue}if(ee&&(ve!=="]"||!me)){let Ie;ve==="-"?Ie=ve:(ve==="^"||ve==="!")&&!me?Ie="^":ve===e.GLOB_SPLIT?Ie="":Ie=(0,y.escapeRegExpCharacters)(ve),me+=Ie;continue}switch(ve){case"{":X=!0;continue;case"[":ee=!0;continue;case"}":{_+=`(?:${D(J,",").map(ae=>f(ae)).join("|")})`,X=!1,J="";break}case"]":{_+="["+me+"]",ee=!1,me="";break}case"?":_+=P;continue;case"*":_+=k(1);continue;default:_+=(0,y.escapeRegExpCharacters)(ve)}}ge<H.length-1&&(H[ge+1]!==e.GLOBSTAR||ge+2<H.length)&&(_+=O)}Y=ie===e.GLOBSTAR})}return _}const d=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new R.LRUCache(1e4),s=function(){return!1},r=function(){return null};function a(Z,_){if(!Z)return r;let H;typeof Z!="string"?H=Z.pattern:H=Z,H=H.trim();const Y=`${H}_${!!_.trimForExclusions}`;let ie=n.get(Y);if(ie)return c(ie,Z);let ge;return d.test(H)?ie=i(H.substr(4),H):(ge=u.exec(g(H,_)))?ie=t(ge[1],H):(_.trimForExclusions?b:m).test(H)?ie=h(H,_):(ge=C.exec(g(H,_)))?ie=E(ge[1].substr(1),H,!0):(ge=p.exec(g(H,_)))?ie=E(ge[1],H,!1):ie=w(H),n.set(Y,ie),c(ie,Z)}function c(Z,_){if(typeof _=="string")return Z;const H=function(Y,ie){return(0,l.isEqualOrParent)(Y,_.base,!A.isLinux)?Z((0,y.ltrim)(Y.substr(_.base.length),S.sep),ie):null};return H.allBasenames=Z.allBasenames,H.allPaths=Z.allPaths,H.basenames=Z.basenames,H.patterns=Z.patterns,H}function g(Z,_){return _.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function i(Z,_){return function(H,Y){return typeof H=="string"&&H.endsWith(Z)?_:null}}function t(Z,_){const H=`/${Z}`,Y=`\\${Z}`,ie=function(X,J){return typeof X!="string"?null:J?J===Z?_:null:X===Z||X.endsWith(H)||X.endsWith(Y)?_:null},ge=[Z];return ie.basenames=ge,ie.patterns=[_],ie.allBasenames=ge,ie}function h(Z,_){const H=F(Z.slice(1,-1).split(",").map(J=>a(J,_)).filter(J=>J!==r),Z),Y=H.length;if(!Y)return r;if(Y===1)return H[0];const ie=function(J,ee){for(let me=0,ve=H.length;me<ve;me++)if(H[me](J,ee))return Z;return null},ge=H.find(J=>!!J.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const X=H.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return X.length&&(ie.allPaths=X),ie}function E(Z,_,H){const Y=S.sep===S.posix.sep,ie=Y?Z:Z.replace(v,S.sep),ge=S.sep+ie,X=S.posix.sep+Z;let J;return H?J=function(ee,me){return typeof ee=="string"&&(ee===ie||ee.endsWith(ge)||!Y&&(ee===Z||ee.endsWith(X)))?_:null}:J=function(ee,me){return typeof ee=="string"&&(ee===ie||!Y&&ee===Z)?_:null},J.allPaths=[(H?"*/":"./")+Z],J}function w(Z){try{const _=new RegExp(`^${f(Z)}$`);return function(H){return _.lastIndex=0,typeof H=="string"&&_.test(H)?Z:null}}catch{return r}}function N(Z,_,H){return!Z||typeof _!="string"?!1:j(Z)(_,void 0,H)}e.match=N;function j(Z,_={}){if(!Z)return s;if(typeof Z=="string"||V(Z)){const H=a(Z,_);if(H===r)return s;const Y=function(ie,ge){return!!H(ie,ge)};return H.allBasenames&&(Y.allBasenames=H.allBasenames),H.allPaths&&(Y.allPaths=H.allPaths),Y}return U(Z,_)}e.parse=j;function V(Z){const _=Z;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=V;function Q(Z){return Z.allBasenames||[]}e.getBasenameTerms=Q;function q(Z){return Z.allPaths||[]}e.getPathTerms=q;function U(Z,_){const H=F(Object.getOwnPropertyNames(Z).map(J=>T(J,Z[J],_)).filter(J=>J!==r)),Y=H.length;if(!Y)return r;if(!H.some(J=>!!J.requiresSiblings)){if(Y===1)return H[0];const J=function(ve,Ie){let Re;for(let ae=0,le=H.length;ae<le;ae++){const ue=H[ae](ve,Ie);if(typeof ue=="string")return ue;(0,L.isThenable)(ue)&&(Re||(Re=[]),Re.push(ue))}return Re?(async()=>{for(const ae of Re){const le=await ae;if(typeof le=="string")return le}return null})():null},ee=H.find(ve=>!!ve.allBasenames);ee&&(J.allBasenames=ee.allBasenames);const me=H.reduce((ve,Ie)=>Ie.allPaths?ve.concat(Ie.allPaths):ve,[]);return me.length&&(J.allPaths=me),J}const ie=function(J,ee,me){let ve,Ie;for(let Re=0,ae=H.length;Re<ae;Re++){const le=H[Re];le.requiresSiblings&&me&&(ee||(ee=(0,S.basename)(J)),ve||(ve=ee.substr(0,ee.length-(0,S.extname)(J).length)));const ue=le(J,ee,ve,me);if(typeof ue=="string")return ue;(0,L.isThenable)(ue)&&(Ie||(Ie=[]),Ie.push(ue))}return Ie?(async()=>{for(const Re of Ie){const ae=await Re;if(typeof ae=="string")return ae}return null})():null},ge=H.find(J=>!!J.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const X=H.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return X.length&&(ie.allPaths=X),ie}function T(Z,_,H){if(_===!1)return r;const Y=a(Z,H);if(Y===r)return r;if(typeof _=="boolean")return Y;if(_){const ie=_.when;if(typeof ie=="string"){const ge=(X,J,ee,me)=>{if(!me||!Y(X,J))return null;const ve=ie.replace("$(basename)",()=>ee),Ie=me(ve);return(0,L.isThenable)(Ie)?Ie.then(Re=>Re?Z:null):Ie?Z:null};return ge.requiresSiblings=!0,ge}}return Y}function F(Z,_){const H=Z.filter(J=>!!J.basenames);if(H.length<2)return Z;const Y=H.reduce((J,ee)=>{const me=ee.basenames;return me?J.concat(me):J},[]);let ie;if(_){ie=[];for(let J=0,ee=Y.length;J<ee;J++)ie.push(_)}else ie=H.reduce((J,ee)=>{const me=ee.patterns;return me?J.concat(me):J},[]);const ge=function(J,ee){if(typeof J!="string")return null;if(!ee){let ve;for(ve=J.length;ve>0;ve--){const Ie=J.charCodeAt(ve-1);if(Ie===47||Ie===92)break}ee=J.substr(ve)}const me=Y.indexOf(ee);return me!==-1?ie[me]:null};ge.basenames=Y,ge.patterns=ie,ge.allBasenames=Y;const X=Z.filter(J=>!J.basenames);return X.push(ge),X}function B(Z,_){return(0,o.equals)(Z,_,(H,Y)=>typeof H=="string"&&typeof Y=="string"?H===Y:typeof H!="string"&&typeof Y!="string"?H.base===Y.base&&H.pattern===Y.pattern:!1)}e.patternsEquals=B}),define(ye[112],De([1,0,10,163,24,8,2]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(u="",m=!1){if(this.value=u,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(u,m=0){return this.value+=v(this.supportThemeIcons?(0,L.escapeIcons)(u):u).replace(/([ \t]+)/g,(b,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,m){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}appendLink(u,m,b){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(u),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(u,m){const b=new RegExp((0,R.escapeRegExpCharacters)(m),"g");return u.replace(b,(C,p)=>u.charAt(p-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=y;function I(d){return O(d)?!d.value:Array.isArray(d)?d.every(I):!0}e.isEmptyMarkdownString=I;function O(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function P(d,u){return d===u?!0:!d||!u?!1:d.value===u.value&&d.isTrusted===u.isTrusted&&d.supportThemeIcons===u.supportThemeIcons&&d.supportHtml===u.supportHtml&&(d.baseUri===u.baseUri||!!d.baseUri&&!!u.baseUri&&(0,l.isEqual)(S.URI.from(d.baseUri),S.URI.from(u.baseUri)))}e.markdownStringEqual=P;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function k(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function D(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=D;function f(d){const u=[],m=d.split("|").map(C=>C.trim());d=m[0];const b=m[1];if(b){const C=/height=(\d+)/.exec(b),p=/width=(\d+)/.exec(b),n=C?C[1]:"",s=p?p[1]:"",r=isFinite(parseInt(s)),a=isFinite(parseInt(n));r&&u.push(`width="${s}"`),a&&u.push(`height="${n}"`)}return{href:d,dimensions:u}}e.parseHrefAndDimensions=f}),define(ye[113],De([1,0,15,33,12,11,24,8]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,a){const{os:c,tildify:g,relative:i}=a;if(i){const E=I(r,i,c);if(typeof E=="string")return E}let t=r.fsPath;if(c===1&&!R.isWindows?t=t.replace(/\//g,"\\"):c!==1&&R.isWindows&&(t=t.replace(/\\/g,"/")),c!==1&&g?.userHome){const E=g.userHome.fsPath;let w;r.scheme!==g.userHome.scheme&&r.path.startsWith(l.posix.sep)?w=g.userHome.with({path:r.path}).fsPath:w=r.fsPath,t=v(w,E,c)}return(c===1?l.win32:l.posix).normalize(O(t,c===1))}e.getPathLabel=y;function I(r,a,c){const g=c===1?l.win32:l.posix,i=c===3?S.extUri:S.extUriIgnorePathCase,t=a.getWorkspace(),h=(0,o.firstOrDefault)(t.folders);if(!h)return;r.scheme!==h.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=h.uri.with({path:r.path}));const E=a.getWorkspaceFolder(r);if(!E)return;let w;if(i.isEqual(E.uri,r)?w="":w=i.relativePath(E.uri,r)??"",w&&(w=g.normalize(w)),t.folders.length>1&&!a.noPrefix){const N=E.name?E.name:i.basenameOrAuthority(E.uri);w=w?`${N} \u2022 ${w}`:N}return w}function O(r,a=R.isWindows){return(0,L.hasDriveLetter)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=O;let P=Object.create(null);function v(r,a,c=R.OS){if(c===1||!r||!a)return r;let g=P.original===a?P.normalized:void 0;g||(g=a,R.isWindows&&(g=(0,L.toSlashes)(g)),g=`${(0,A.rtrim)(g,l.posix.sep)}${l.posix.sep}`,P={original:a,normalized:g});let i=r;return R.isWindows&&(i=(0,L.toSlashes)(i)),(c===3?i.startsWith(g):(0,A.startsWithIgnoreCase)(i,g))?`~/${i.substr(g.length)}`:r}e.tildify=v;function k(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=k;const D="\u2026",f="\\\\",d="~";function u(r,a=l.sep){const c=new Array(r.length);let g=!1;for(let i=0;i<r.length;i++){const t=r[i];if(t===""){c[i]=`.${a}`;continue}if(!t){c[i]=t;continue}g=!0;let h="",E=t;E.indexOf(f)===0?(h=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length)):E.indexOf(a)===0?(h=E.substr(0,E.indexOf(a)+a.length),E=E.substr(E.indexOf(a)+a.length)):E.indexOf(d)===0&&(h=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length));const w=E.split(a);for(let N=1;g&&N<=w.length;N++)for(let j=w.length-N;g&&j>=0;j--){g=!1;let V=w.slice(j,j+N).join(a);for(let Q=0;!g&&Q<r.length;Q++)if(Q!==i&&r[Q]&&r[Q].indexOf(V)>-1){const q=j+N===w.length,U=j>0&&r[Q].indexOf(a)>-1?a+V:V,T=r[Q].endsWith(U);g=!q||T}if(!g){let Q="";(w[0].endsWith(":")||h!=="")&&(j===1&&(j=0,N++,V=w[0]+a+V),j>0&&(Q=w[0]+a),Q=h+Q),j>0&&(Q=Q+D+a),Q=Q+V,j+N<w.length&&(Q=Q+a+D),c[i]=Q}}g&&(c[i]=t)}return c}e.shorten=u;var m;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function b(r,a=Object.create(null)){const c=[];let g=!1,i="";for(const t of r)if(t==="$"||g&&t==="{")i&&c.push({value:i,type:m.TEXT}),i="",g=!0;else if(t==="}"&&g){const h=a[i];if(typeof h=="string")h.length&&c.push({value:h,type:m.VARIABLE});else if(h){const E=c[c.length-1];(!E||E.type!==m.SEPARATOR)&&c.push({value:h.label,type:m.SEPARATOR})}i="",g=!1}else i+=t;return i&&!g&&c.push({value:i,type:m.TEXT}),c.filter((t,h)=>{if(t.type===m.SEPARATOR){const E=c[h-1],w=c[h+1];return[E,w].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=b;function C(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function p(r,a){return R.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function n(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(r){const a=r.indexOf("/")!==-1?l.posix:l.win32,c=a.basename(r),g=a.dirname(r);return c.length?{name:c,parentPath:g}:{name:g,parentPath:""}}e.splitName=s}),define(ye[114],De([1,0,22,2]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(P){return P.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const k=this.a.transformIncoming(v);return k===v?v:l(L.URI.from(k))}transformOutgoing(v){const k=this.a.transformOutgoing(v);return k===v?v:l(L.URI.from(k))}transformOutgoingURI(v){const k=this.a.transformOutgoing(v);return k===v?v:L.URI.from(k)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function S(P,v,k){if(!P||k>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return v.transformOutgoing(P);for(const D in P)if(Object.hasOwnProperty.call(P,D)){const f=S(P[D],v,k+1);f!==null&&(P[D]=f)}}return null}function A(P,v){const k=S(P,v,0);return k===null?P:k}e.transformOutgoingURIs=A;function y(P,v,k,D){if(!P||D>200)return null;if(typeof P=="object"){if(P.$mid===1)return k?L.URI.revive(v.transformIncoming(P)):v.transformIncoming(P);if(P instanceof o.VSBuffer)return null;for(const f in P)if(Object.hasOwnProperty.call(P,f)){const d=y(P[f],v,k,D+1);d!==null&&(P[f]=d)}}return null}function I(P,v){const k=y(P,v,!1,0);return k===null?P:k}e.transformIncomingURIs=I;function O(P,v){const k=y(P,v,!0,0);return k===null?P:k}e.transformAndReviveIncomingURIs=O}),define(ye[29],De([1,0,70,89,319,19,33,86,12,11,24,2]),function(re,e,o,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function k(U,T=v.UNLINK){if((0,S.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return T===v.UNLINK?f(U):D(U)}async function D(U){try{const T=(0,S.randomPath)((0,L.tmpdir)());try{await o.promises.rename(U,T)}catch(F){return F.code==="ENOENT"?void 0:f(U)}f(T).catch(F=>{})}catch(T){if(T.code!=="ENOENT")throw T}}async function f(U){return(0,l.promisify)(o.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function d(U){if((0,S.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function u(U,T){return C(await(T?m(U):(0,l.promisify)(o.readdir)(U)))}async function m(U){try{return await(0,l.promisify)(o.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const T=[],F=await u(U);for(const B of F){let Z=!1,_=!1,H=!1;try{const Y=await e.Promises.lstat((0,y.join)(U,B));Z=Y.isFile(),_=Y.isDirectory(),H=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}T.push({name:B,isFile:()=>Z,isDirectory:()=>_,isSymbolicLink:()=>H})}return T}function b(U){return C(o.readdirSync(U))}e.readdirSync=b;function C(U){return U.map(T=>typeof T=="string"?I.isMacintosh?(0,A.normalizeNFC)(T):T:(T.name=I.isMacintosh?(0,A.normalizeNFC)(T.name):T.name,T))}async function p(U){const T=await u(U),F=[];for(const B of T)await s.existsDirectory((0,y.join)(U,B))&&F.push(B);return F}function n(U,T=1e3){return new Promise(F=>{let B=!1;const Z=setInterval(()=>{B||(B=!0,o.access(U,_=>{B=!1,_&&(clearInterval(Z),F(void 0))}))},T)})}e.whenDeleted=n;var s;(function(U){async function T(Z){let _;try{if(_=await e.Promises.lstat(Z),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(I.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw Y}throw H}}U.stat=T;async function F(Z){try{const{stat:_,symbolicLink:H}=await U.stat(Z);return _.isFile()&&H?.dangling!==!0}catch{}return!1}U.existsFile=F;async function B(Z){try{const{stat:_,symbolicLink:H}=await U.stat(Z);return _.isDirectory()&&H?.dangling!==!0}catch{}return!1}U.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function a(U,T,F){return r.queueFor(P.URI.file(U),O.extUriBiasedIgnorePathCase).queue(()=>{const B=h(F);return new Promise((Z,_)=>i(U,T,B,H=>H?_(H):Z()))})}let c=!0;function g(U){c=U}e.configureFlushOnWrite=g;function i(U,T,F,B){if(!c)return o.writeFile(U,T,{mode:F.mode,flag:F.flag},B);o.open(U,F.flag,F.mode,(Z,_)=>{if(Z)return B(Z);o.writeFile(_,T,H=>{if(H)return o.close(_,()=>B(H));o.fdatasync(_,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),g(!1)),o.close(_,ie=>B(ie))))})})}function t(U,T,F){const B=h(F);if(!c)return o.writeFileSync(U,T,{mode:B.mode,flag:B.flag});const Z=o.openSync(U,B.flag,B.mode);try{o.writeFileSync(Z,T);try{o.fdatasyncSync(Z)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),g(!1)}}finally{o.closeSync(Z)}}e.writeFileSync=t;function h(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function E(U,T){if(U!==T)try{await e.Promises.rename(U,T)}catch(F){if(U.toLowerCase()!==T.toLowerCase()&&F.code==="EXDEV"||U.endsWith("."))await w(U,T,{preserveSymlinks:!1}),await k(U,v.MOVE);else throw F}}async function w(U,T,F){return j(U,T,{root:{source:U,target:T},options:F,handledSourcePaths:new Set})}const N=511;async function j(U,T,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:B,symbolicLink:Z}=await s.stat(U);if(Z){if(F.options.preserveSymlinks)try{return await q(U,T,F)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(Z.dangling)return}return B.isDirectory()?V(U,T,B.mode&N,F):Q(U,T,B.mode&N)}async function V(U,T,F,B){await e.Promises.mkdir(T,{recursive:!0,mode:F});const Z=await u(U);for(const _ of Z)await j((0,y.join)(U,_),(0,y.join)(T,_),B)}async function Q(U,T,F){await e.Promises.copyFile(U,T),await e.Promises.chmod(T,F)}async function q(U,T,F){let B=await e.Promises.readlink(U);(0,S.isEqualOrParent)(B,F.root.source,!I.isLinux)&&(B=(0,y.join)(F.root.target,B.substr(F.root.source.length+1))),await e.Promises.symlink(B,T)}e.Promises=new class{get access(){return(0,l.promisify)(o.access)}get stat(){return(0,l.promisify)(o.stat)}get lstat(){return(0,l.promisify)(o.lstat)}get utimes(){return(0,l.promisify)(o.utimes)}get read(){return(U,T,F,B,Z)=>new Promise((_,H)=>{o.read(U,T,F,B,Z,(Y,ie,ge)=>Y?H(Y):_({bytesRead:ie,buffer:ge}))})}get readFile(){return(0,l.promisify)(o.readFile)}get write(){return(U,T,F,B,Z)=>new Promise((_,H)=>{o.write(U,T,F,B,Z,(Y,ie,ge)=>Y?H(Y):_({bytesWritten:ie,buffer:ge}))})}get appendFile(){return(0,l.promisify)(o.appendFile)}get fdatasync(){return(0,l.promisify)(o.fdatasync)}get truncate(){return(0,l.promisify)(o.truncate)}get rename(){return(0,l.promisify)(o.rename)}get copyFile(){return(0,l.promisify)(o.copyFile)}get open(){return(0,l.promisify)(o.open)}get close(){return(0,l.promisify)(o.close)}get symlink(){return(0,l.promisify)(o.symlink)}get readlink(){return(0,l.promisify)(o.readlink)}get chmod(){return(0,l.promisify)(o.chmod)}get mkdir(){return(0,l.promisify)(o.mkdir)}get unlink(){return(0,l.promisify)(o.unlink)}get rmdir(){return(0,l.promisify)(o.rmdir)}get realpath(){return(0,l.promisify)(o.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return p}get writeFile(){return a}get rm(){return k}get move(){return E}get copy(){return w}}}),define(ye[115],De([1,0,70,12,11,8,29]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(v){if(l.isLinux)return v;const k=(0,L.dirname)(v);if(v===k)return v;const D=((0,L.basename)(v)||v).toLowerCase();try{const d=(0,S.readdirSync)(k).filter(u=>u.toLowerCase()===D);if(d.length===1){const u=A(k);if(u)return(0,L.join)(u,d[0])}else if(d.length>1){const u=d.indexOf(D);if(u>=0){const m=A(k);if(m)return(0,L.join)(m,d[u])}}}catch{}return null}e.realcaseSync=A;async function y(v){if(l.isLinux)return v;const k=(0,L.dirname)(v);if(v===k)return v;const D=((0,L.basename)(v)||v).toLowerCase();try{const d=(await S.Promises.readdir(k)).filter(u=>u.toLowerCase()===D);if(d.length===1){const u=await y(k);if(u)return(0,L.join)(u,d[0])}else if(d.length>1){const u=d.indexOf(D);if(u>=0){const m=await y(k);if(m)return(0,L.join)(m,d[u])}}}catch{}return null}e.realcase=y;async function I(v){try{return await S.Promises.realpath(v)}catch{const D=P(v);return await S.Promises.access(D,o.constants.R_OK),D}}e.realpath=I;function O(v){try{return o.realpathSync(v)}catch{const D=P(v);return o.accessSync(D,o.constants.R_OK),D}}e.realpathSync=O;function P(v){return(0,R.rtrim)((0,L.normalize)(v),L.sep)}}),define(ye[116],De([1,0,12,11,36,109,9,29]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(P=l.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function I(P){let v=[],k=!1;const D=function(f){if(k){v.push(f);return}(!P.send(f,u=>{if(u&&console.error(u),k=!1,v.length>0){const m=v.slice(0);v=[],m.forEach(b=>D(b))}})||L.isWindows)&&(k=!0)};return{send:D}}e.createQueuedSender=I;var O;(function(P){async function v(k,D,f){if(o.isAbsolute(k))return k;if(D===void 0&&(D=l.cwd()),o.dirname(k)!=="."||(f===void 0&&S.isString(l.env.PATH)&&(f=l.env.PATH.split(o.delimiter)),f===void 0||f.length===0))return o.join(D,k);async function u(m){if(await A.Promises.exists(m)){let b;try{b=await A.Promises.stat(m)}catch(C){C.message.startsWith("EACCES")&&(b=await A.Promises.lstat(m))}return b?!b.isDirectory():!1}return!1}for(const m of f){let b;if(o.isAbsolute(m)?b=o.join(m,k):b=o.join(D,m,k),await u(b))return b;let C=b+".com";if(await u(C)||(C=b+".exe",await u(C)))return C}return o.join(D,k)}P.findExecutable=v})(O=e.win32||(e.win32={}))});var xe=this&&this.__decorate||function(re,e,o,L){var l=arguments.length,R=l<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,o):L,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(re,e,o,L);else for(var A=re.length-1;A>=0;A--)(S=re[A])&&(R=(l<3?S(R):l>3?S(e,o,R):S(e,o))||R);return l>3&&R&&Object.defineProperty(e,o,R),R};define(ye[117],De([1,0,15,19,22,21,62,10,3,6,69,8,9]),function(re,e,o,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(k||(k={}));function D(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(f||(f={}));function d(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(u||(u={}));function m(_){let H=0;for(let Y=0;;Y+=7){const ie=_.read(1);if(H|=(ie.buffer[0]&127)<<Y,!(ie.buffer[0]&128))return H}}const b=r(0);function C(_,H){if(H===0){_.write(b);return}let Y=0;for(let ge=H;ge!==0;ge=ge>>>7)Y++;const ie=l.VSBuffer.alloc(Y);for(let ge=0;H!==0;ge++)ie.buffer[ge]=H&127,H=H>>>7,H>0&&(ie.buffer[ge]|=128);_.write(ie)}class p{constructor(H){this.b=H,this.a=0}read(H){const Y=this.b.slice(this.a,this.a+H);return this.a+=Y.byteLength,Y}}e.BufferReader=p;class n{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(H){this.a.push(H)}}e.BufferWriter=n;var s;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(s||(s={}));function r(_){const H=l.VSBuffer.alloc(1);return H.writeUInt8(_,0),H}const a={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},c=typeof Buffer<"u";function g(_,H){if(typeof H>"u")_.write(a.Undefined);else if(typeof H=="string"){const Y=l.VSBuffer.fromString(H);_.write(a.String),C(_,Y.byteLength),_.write(Y)}else if(c&&Buffer.isBuffer(H)){const Y=l.VSBuffer.wrap(H);_.write(a.Buffer),C(_,Y.byteLength),_.write(Y)}else if(H instanceof l.VSBuffer)_.write(a.VSBuffer),C(_,H.byteLength),_.write(H);else if(Array.isArray(H)){_.write(a.Array),C(_,H.length);for(const Y of H)g(_,Y)}else if(typeof H=="number"&&(H|0)===H)_.write(a.Uint),C(_,H);else{const Y=l.VSBuffer.fromString(JSON.stringify(H));_.write(a.Object),C(_,Y.byteLength),_.write(Y)}}e.serialize=g;function i(_){switch(_.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return _.read(m(_)).toString();case s.Buffer:return _.read(m(_)).buffer;case s.VSBuffer:return _.read(m(_));case s.Array:{const Y=m(_),ie=[];for(let ge=0;ge<Y;ge++)ie.push(i(_));return ie}case s.Object:return JSON.parse(_.read(m(_)).toString());case s.Int:return m(_)}}e.deserialize=i;class t{constructor(H,Y,ie=null,ge=1e3){this.h=H,this.j=Y,this.k=ie,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(H,Y){this.b.set(H,Y),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case 200:{const Y=this.o([H.type]);this.k?.logOutgoing(Y,0,1,d(H.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([H.type,H.id],H.data);this.k?.logOutgoing(Y,H.id,1,d(H.type),H.data);return}}}o(H,Y=void 0){const ie=new n;return g(ie,H),g(ie,Y),this.p(ie.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const Y=new p(H),ie=i(Y),ge=i(Y),X=ie[0];switch(X){case 100:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}: ${ie[2]}.${ie[3]}`,ge),this.s({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 102:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}: ${ie[2]}.${ie[3]}`,ge),this.t({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 101:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}`),this.u({type:X,id:ie[1]});case 103:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}`),this.u({type:X,id:ie[1]})}}s(H){const Y=this.b.get(H.channelName);if(!Y){this.v(H);return}const ie=new R.CancellationTokenSource;let ge;try{ge=Y.call(this.j,H.name,H.arg,ie.token)}catch(ee){ge=Promise.reject(ee)}const X=H.id;ge.then(ee=>{this.m({id:X,data:ee,type:201}),this.d.delete(H.id)},ee=>{ee instanceof Error?this.m({id:X,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:X,data:ee,type:203}),this.d.delete(H.id)});const J=(0,I.toDisposable)(()=>ie.cancel());this.d.set(H.id,J)}t(H){const Y=this.b.get(H.channelName);if(!Y){this.v(H);return}const ie=H.id,X=Y.listen(this.j,H.name,H.arg)(J=>this.m({id:ie,data:J,type:204}));this.d.set(H.id,X)}u(H){const Y=this.d.get(H.id);Y&&(Y.dispose(),this.d.delete(H.id))}v(H){let Y=this.g.get(H.channelName);Y||(Y=[],this.g.set(H.channelName,Y));const ie=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:H,timeoutTimer:ie})}w(H){const Y=this.g.get(H);if(Y){for(const ie of Y)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,I.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=t;var h;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(H,Y=null){this.l=H,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=Y}getChannel(H){const Y=this;return{call(ie,ge,X){return Y.a?Promise.reject(new A.CancellationError):Y.m(H,ie,ge,X)},listen(ie,ge){return Y.a?y.Event.None:Y.o(H,ie,ge)}}}m(H,Y,ie,ge=R.CancellationToken.None){const X=this.g++,ee={id:X,type:100,channelName:H,name:Y,arg:ie};if(ge.isCancellationRequested)return Promise.reject(new A.CancellationError);let me;return new Promise((Ie,Re)=>{if(ge.isCancellationRequested)return Re(new A.CancellationError);const ae=()=>{const ce=oe=>{switch(oe.type){case 201:this.f.delete(X),Ie(oe.data);break;case 202:{this.f.delete(X);const M=new Error(oe.data.message);M.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,M.name=oe.data.name,Re(M);break}case 203:this.f.delete(X),Re(oe.data);break}};this.f.set(X,ce),this.p(ee)};let le=null;this.b===u.Idle?ae():(le=(0,L.createCancelablePromise)(ce=>this.u()),le.then(()=>{le=null,ae()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:X,type:101}),Re(new A.CancellationError)},ne=ge.onCancellationRequested(ue);me=(0,I.combinedDisposable)((0,I.toDisposable)(ue),ne),this.d.add(me)}).finally(()=>{this.d.delete(me)})}o(H,Y,ie){const ge=this.g++,J={id:ge,type:102,channelName:H,name:Y,arg:ie};let ee=null;const me=new y.Emitter({onWillAddFirstListener:()=>{ee=(0,L.createCancelablePromise)(Ie=>this.u()),ee.then(()=>{ee=null,this.d.add(me),this.p(J)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(me),this.p({id:ge,type:103}))}}),ve=Ie=>me.fire(Ie.data);return this.f.set(ge,ve),me.event}p(H){switch(H.type){case 100:case 102:{const Y=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(Y,H.id,0,`${D(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const Y=this.q([H.type,H.id]);this.j?.logOutgoing(Y,H.id,0,D(H.type));return}}}q(H,Y=void 0){const ie=new n;return g(ie,H),g(ie,Y),this.r(ie.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const Y=new p(H),ie=i(Y),ge=i(Y),X=ie[0];switch(X){case 200:return this.j?.logIncoming(H.byteLength,0,0,d(X)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,ie[1],0,d(X),ge),this.t({type:ie[0],id:ie[1],data:ge})}}t(H){if(H.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,I.dispose)(this.d.values()),this.d.clear()}}xe([S.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class w{get connections(){const H=[];return this.f.forEach(Y=>H.push(Y)),H}constructor(H){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,H(({protocol:Y,onDidClientDisconnect:ie})=>{y.Event.once(Y.onMessage)(X=>{const J=new p(X),ee=i(J),me=new t(Y,ee),ve=new E(Y);this.a.forEach((Re,ae)=>me.registerChannel(ae,Re));const Ie={channelServer:me,channelClient:ve,ctx:ee};this.f.add(Ie),this.g.fire(Ie),ie(()=>{me.dispose(),ve.dispose(),this.f.delete(Ie),this.h.fire(Ie)})})})}getChannel(H,Y){const ie=this;return{call(ge,X,J){let ee;if((0,v.isFunction)(Y)){const ve=(0,o.getRandomElement)(ie.connections.filter(Y));ee=ve?Promise.resolve(ve):y.Event.toPromise(y.Event.filter(ie.onDidAddConnection,Y))}else ee=Y.routeCall(ie,ge,X);const me=ee.then(ve=>ve.channelClient.getChannel(H));return j(me).call(ge,X,J)},listen(ge,X){if((0,v.isFunction)(Y))return ie.j(H,Y,ge,X);const J=Y.routeEvent(ie,ge,X).then(ee=>ee.channelClient.getChannel(H));return j(J).listen(ge,X)}}}j(H,Y,ie,ge){const X=this;let J=new I.DisposableStore;const ee=new y.Emitter({onWillAddFirstListener:()=>{J=new I.DisposableStore;const me=new y.EventMultiplexer,ve=new Map,Ie=ae=>{const ue=ae.channelClient.getChannel(H).listen(ie,ge),ne=me.add(ue);ve.set(ae,ne)},Re=ae=>{const le=ve.get(ae);!le||(le.dispose(),ve.delete(ae))};X.connections.filter(Y).forEach(Ie),y.Event.filter(X.onDidAddConnection,Y)(Ie,void 0,J),X.onDidRemoveConnection(Re,void 0,J),me.event(ee.fire,ee,J),J.add(me)},onDidRemoveLastListener:()=>{J.dispose()}});return ee.event}registerChannel(H,Y){this.a.set(H,Y),this.f.forEach(ie=>{ie.channelServer.registerChannel(H,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=w;class N{constructor(H,Y,ie=null){const ge=new n;g(ge,Y),H.send(ge.buffer),this.a=new E(H,ie),this.d=new t(H,Y,ie)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,Y){this.d.registerChannel(H,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function j(_){return{call(H,Y,ie){return _.then(ge=>ge.call(H,Y,ie))},listen(H,Y){const ie=new y.Relay;return _.then(ge=>ie.input=ge.listen(H,Y)),ie.event}}}e.getDelayedChannel=j;function V(_){let H=!1;return{call(Y,ie,ge){return H?_.call(Y,ie,ge):(0,L.timeout)(0).then(()=>H=!0).then(()=>_.call(Y,ie,ge))},listen(Y,ie){if(H)return _.listen(Y,ie);const ge=new y.Relay;return(0,L.timeout)(0).then(()=>H=!0).then(()=>ge.input=_.listen(Y,ie)),ge.event}}}e.getNextTickChannel=V;class Q{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const Y of H.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await y.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.StaticRouter=Q;var q;(function(_){function H(X,J){const ee=X,me=J&&J.disableMarshalling,ve=new Map;for(const Ie in ee)ie(Ie)&&ve.set(Ie,y.Event.buffer(ee[Ie],!0));return new class{listen(Ie,Re,ae){const le=ve.get(Re);if(le)return le;if(ge(Re)){const ue=ee[Re];if(typeof ue=="function")return ue.call(ee,ae)}throw new Error(`Event not found: ${Re}`)}call(Ie,Re,ae){const le=ee[Re];if(typeof le=="function"){if(!me&&Array.isArray(ae))for(let ue=0;ue<ae.length;ue++)ae[ue]=(0,O.revive)(ae[ue]);return le.apply(ee,ae)}throw new Error(`Method not found: ${Re}`)}}}_.fromService=H;function Y(X,J){const ee=J&&J.disableMarshalling;return new Proxy({},{get(me,ve){if(typeof ve=="string")return J?.properties?.has(ve)?J.properties.get(ve):ge(ve)?function(Ie){return X.listen(ve,Ie)}:ie(ve)?X.listen(ve):async function(...Ie){let Re;J&&!(0,v.isUndefinedOrNull)(J.context)?Re=[J.context,...Ie]:Re=Ie;const ae=await X.call(ve,Re);return ee?ae:(0,O.revive)(ae)};throw new Error(`Property not found: ${String(ve)}`)}})}_.toService=Y;function ie(X){return X[0]==="o"&&X[1]==="n"&&P.isUpperAsciiLetter(X.charCodeAt(2))}function ge(X){return/^onDynamic/.test(X)&&P.isUpperAsciiLetter(X.charCodeAt(9))}})(q=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const H=_.toString();if(H!=="[object Object]")return H}return _}function F(_){return Array.isArray(_)?_.map(T):T(_)}function B(_,H,Y,ie,ge,X,J){J=F(J);const ee=U[ge],me=ee[ie%ee.length];let ve=[`%c[${_}]%c[${String(H).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(X)?(ve=ve.concat(J),ve.push(")")):ve.push(J),console.log.apply(console,ve)}class Z{constructor(H,Y){this.d=H,this.f=Y,this.a=0,this.b=0}logOutgoing(H,Y,ie,ge,X){this.b+=H,B(this.d,this.b,H,Y,ie,ge,X)}logIncoming(H,Y,ie,ge,X){this.a+=H,B(this.f,this.a,H,Y,ie,ge,X)}}e.IPCLogger=Z}),define(ye[118],De([1,0,19,22,3,6,117]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(E){E.enableDiagnostics=!1,E.records=[];const w=new WeakMap;let N=0;function j(Q,q){if(!w.has(Q)){const U=String(++N);w.set(Q,U)}return w.get(Q)}function V(Q,q,U,T){if(!E.enableDiagnostics)return;const F=j(Q,q);if(T instanceof L.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const B=L.VSBuffer.alloc(T.byteLength);B.set(T),E.records.push({timestamp:Date.now(),id:F,label:q,type:U,buff:B})}else E.records.push({timestamp:Date.now(),id:F,label:q,type:U,data:T})}E.traceSocketEvent=V})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let O=null;function P(){return O||(O=L.VSBuffer.alloc(0)),O}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,N){if(w===0)return P();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const q=this.a[0];return N&&(this.a.shift(),this.b-=w),q}if(this.a[0].byteLength>w){const q=this.a[0].slice(0,w);return N&&(this.a[0]=this.a[0].slice(w),this.b-=w),q}const j=L.VSBuffer.alloc(w);let V=0,Q=0;for(;w>0;){const q=this.a[Q];if(q.byteLength>w){const U=q.slice(0,w);j.set(U,V),V+=w,N&&(this.a[Q]=q.slice(w),this.b-=w),w-=w}else j.set(q,V),V+=q.byteLength,N?(this.a.shift(),this.b-=q.byteLength):Q++,w-=q.byteLength}return j}}e.ChunkStream=v;var k;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(k||(k={}));function D(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(w,N,j,V){this.type=w,this.id=N,this.ack=j,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends R.Disposable{constructor(w){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=w,this.b=!1,this.c=new v,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:D(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const j=this.g.messageType,V=this.g.id,Q=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new d(j,V,Q,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=L.VSBuffer.alloc(13);N.writeUInt8(w.type,0),N.writeUInt32BE(w.id,1),N.writeUInt32BE(w.ack,5),N.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:D(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",w.data),this.j(N,w.data)}g(w,N){const j=this.f===0;return this.d.push(w,N),this.f+=w.byteLength+N.byteLength,j}h(){const w=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,N){this.g(w,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:w.byteLength}),this.c.write(w)}}class b extends R.Disposable{constructor(w){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new m(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new d(1,0,0,w))}}e.Protocol=b;class C extends S.IPCClient{static fromSocket(w,N){return new C(new b(w),N)}get onDidDispose(){return this.b.onDidDispose}constructor(w,N,j=null){super(w,N,j),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.Client=C;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.BufferedEmitter=p;class n{constructor(w){this.data=w,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let w=0,N=this.a;for(;N;)N=N.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let N=0,j=this.a;for(;j;)w[N++]=j.data,j=j.next;return w}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const N=new n(w);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const w=Date.now();for(let N=0;N<r.a;N++)this.c[N]=w-1e3*N;setInterval(()=>{for(let N=r.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),N=(1+r.a)*1e3;let j=0;for(let V=0;V<r.a;V++)w-this.c[V]<=N&&j++;return 1-j/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var a;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(a=e.ConnectionHealth||(e.ConnectionHealth={}));function c(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=c;class g{constructor(w){this.connectionHealth=w}}e.ConnectionHealthChangedEvent=g;class i{constructor(w,N){this.roundTripTime=w,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=i;class t{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.x=new p,this.onControlMessage=this.x.event,this.y=new p,this.onMessage=this.y.event,this.z=new p,this.onDidDispose=this.z.event,this.A=new p,this.onSocketClose=this.A.event,this.B=new p,this.onSocketTimeout=this.B.event,this.C=new p,this.onHighRoundTripTime=this.C.event,this.D=new p,this.onDidChangeConnectionHealth=this.D.event,this.u=w.loadEstimator??r.getInstance(),this.v=w.measureRoundTripTime??!1,this.w=w.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=w.socket,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new d(5,0,0,P());this.p.write(w),this.p.flush()}sendPause(){const w=new d(7,0,0,P());this.p.write(w)}sendResume(){const w=new d(8,0,0,P());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,N){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new u(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new h),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const w=new d(3,0,this.h,P());this.p.write(w);const N=this.b.toArray();for(let j=0,V=N.length;j<V;j++)this.p.write(N[j]);this.G()}acceptDisconnect(){this.z.fire()}E(w){if(w.ack>this.d){this.d=w.ack;do{const N=this.b.peek();if(N&&N.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case 0:break;case 1:{if(w.id>this.g)if(w.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new d(6,0,0,P())))}else this.g=w.id,this.j=Date.now(),this.F(),this.y.fire(w.data);break}case 2:{this.x.fire(w.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let j=0,V=N.length;j<V;j++)this.p.write(N[j]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(w.data);break}case 11:{this.r.handleResponse(w.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const N=++this.c;this.h=this.g;const j=new d(1,N,this.h,w);this.b.push(j),this.a||(this.p.write(j),this.G())}sendControl(w){const N=new d(2,0,0,w);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-w+5)}G(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),N=Date.now()-w.writtenTime,j=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(N>=2e4&&j>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:j});return}const Q=Math.max(2e4-N,2e4-j,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},Q)}H(){if(this.g<=this.h)return;this.h=this.g;const w=new d(3,0,this.h,P());this.p.write(w)}I(){this.h=this.g;const w=new d(9,0,this.h,P());this.p.write(w)}J(w){this.h=this.g;const N=new d(10,0,this.h,w);this.p.write(N)}K(w){this.h=this.g;const N=new d(11,0,this.h,w);this.p.write(N)}}e.PersistentProtocol=t;class h extends R.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new o.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},w=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const w=++this.h,N=L.VSBuffer.alloc(4);N.writeUInt32BE(w,0),this.a.fire(N)},6e4)}handleResponse(w){if(w.byteLength!==4)return;const N=w.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const j=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=j;const Q=this.l,q=this.j.filter(U=>U>=1e3).length;this.l=q>=3?1:0,j>1e3&&this.b.fire(new i(j,q)),Q!==this.l&&this.c.fire(this.l)}}}),define(ye[119],De([1,0,22,10,3,6,12,11,30,117,118]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(i,t){O.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,i,t)}constructor(i,t=""){this.f=!0,this.debugLabel=t,this.socket=i,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=h=>{if(this.traceSocketEvent("error",{code:h?.code,message:h?.message}),h){if(h.code==="EPIPE")return;(0,L.onUnexpectedError)(h)}},this.socket.on("error",this.a),this.b=h=>{this.traceSocketEvent("close",{hadError:h}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(i){const t=h=>{this.traceSocketEvent("read",h),i(o.VSBuffer.wrap(h))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(i){const t=h=>{i({type:0,hadError:h,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(i){const t=()=>{i()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(i){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",i),this.socket.write(i.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,L.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,L.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((i,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),i();return}const h=()=>{this.socket.off("close",h),this.socket.off("end",h),this.socket.off("error",h),this.socket.off("timeout",h),this.socket.off("drain",h),this.traceSocketEvent("nodeDrainEnd"),i()};this.socket.on("close",h),this.socket.on("end",h),this.socket.on("error",h),this.socket.on("timeout",h),this.socket.on("drain",h)})}}e.NodeSocket=v;var k;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var D;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(D||(D={}));class f extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(i,t){this.socket.traceSocketEvent(i,t)}constructor(i,t,h,E){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=i,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:h?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new d(this,t,h,E,this.f,(w,N)=>this.k(w,N))),this.B(this.a.onError(w=>{console.error(w),(0,L.onUnexpectedError)(w),this.g.fire({type:0,hadError:!0,error:w})})),this.b=new O.ChunkStream,this.B(this.socket.onData(w=>this.l(w))),this.B(this.socket.onClose(async w=>{this.a.isProcessingReadQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(w)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(i){return this.f.event(i)}onClose(i){return this.g.event(i)}onEnd(i){return this.socket.onEnd(i)}write(i){let t=0;for(;t<i.byteLength;)this.a.writeMessage(i.slice(t,Math.min(t+262144,i.byteLength))),t+=262144}k(i,t){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",i);let h=2;i.byteLength<126?h+=0:i.byteLength<2**16?h+=2:h+=8;const E=o.VSBuffer.alloc(h);if(t?E.writeUInt8(194,0):E.writeUInt8(130,0),i.byteLength<126)E.writeUInt8(i.byteLength,1);else if(i.byteLength<2**16){E.writeUInt8(126,1);let w=1;E.writeUInt8(i.byteLength>>>8&255,++w),E.writeUInt8(i.byteLength>>>0&255,++w)}else{E.writeUInt8(127,1);let w=1;E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(i.byteLength>>>24&255,++w),E.writeUInt8(i.byteLength>>>16&255,++w),E.writeUInt8(i.byteLength>>>8&255,++w),E.writeUInt8(i.byteLength>>>0&255,++w)}this.socket.write(o.VSBuffer.concat([E,i]))}end(){this.h=!0,this.socket.end()}l(i){if(i.byteLength!==0){for(this.b.acceptChunk(i);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const t=this.b.peek(this.j.readLen),h=t.readUInt8(0),E=(h&128)>>>7,w=(h&64)>>>6,N=t.readUInt8(1),j=(N&128)>>>7,V=N&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(w)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const t=this.b.read(this.j.readLen),h=t.readUInt8(1),E=(h&128)>>>7;let w=h&127,N=1;w===126?w=t.readUInt8(++N)*2**8+t.readUInt8(++N):w===127&&(w=t.readUInt8(++N)*0+t.readUInt8(++N)*0+t.readUInt8(++N)*0+t.readUInt8(++N)*0+t.readUInt8(++N)*2**24+t.readUInt8(++N)*2**16+t.readUInt8(++N)*2**8+t.readUInt8(++N));let j=0;E&&(j=t.readUInt8(++N)*2**24+t.readUInt8(++N)*2**16+t.readUInt8(++N)*2**8+t.readUInt8(++N)),this.j.state=3,this.j.readLen=w,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const t=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),b(t,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(t,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:o.VSBuffer.alloc(0)}constructor(i,t,h,E,w,N){super(),this.l=i,this.m=w,this.n=N,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,t?(this.b=this.B(new u(this.l,E,h,{windowBits:15})),this.f=this.B(new m(this.l,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(i){this.g.push(i),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const i=this.g.shift();if(this.f){const t=await this.s(this.f,i);this.n(t,!0)}else this.n(i,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(i,t){return new Promise((h,E)=>{i.write(t),i.flush(w=>h(w))})}acceptFrame(i,t,h){this.h.push({data:i,isCompressed:t,isLastFrameOfMessage:h}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const i=this.h.shift();if(this.b&&i.isCompressed){const t=await this.w(this.b,i.data,i.isLastFrameOfMessage);this.m.fire(t)}else this.m.fire(i.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(i,t,h){return new Promise((E,w)=>{i.write(t),h&&i.write(o.VSBuffer.fromByteArray([0,0,255,255])),i.flush(N=>E(N))})}}class u extends R.Disposable{get recordedInflateBytes(){return this.j?o.VSBuffer.concat(this.f):o.VSBuffer.alloc(0)}constructor(i,t,h,E){super(),this.h=i,this.j=t,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(E),this.b.on("error",w=>{this.h.traceSocketEvent("zlibInflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.h.traceSocketEvent("zlibInflateData",w),this.g.push(o.VSBuffer.wrap(w))}),h&&(this.h.traceSocketEvent("zlibInflateInitialWrite",h.buffer),this.b.write(h.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(i){this.j&&this.f.push(i.clone()),this.h.traceSocketEvent("zlibInflateWrite",i),this.b.write(i.buffer)}flush(i){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const t=o.VSBuffer.concat(this.g);this.g.length=0,i(t)})}}class m extends R.Disposable{constructor(i,t){super(),this.g=i,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",h=>{this.g.traceSocketEvent("zlibDeflateError",{message:h?.message,code:h?.code}),this.a.fire(h)}),this.b.on("data",h=>{this.g.traceSocketEvent("zlibDeflateData",h),this.f.push(o.VSBuffer.wrap(h))})}write(i){this.g.traceSocketEvent("zlibDeflateWrite",i.buffer),this.b.write(i.buffer)}flush(i){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let t=o.VSBuffer.concat(this.f);this.f.length=0,t=t.slice(0,t.byteLength-4),i(t)})}}function b(g,i){if(i===0)return;const t=g.byteLength>>>2;for(let V=0;V<t;V++){const Q=g.readUInt32BE(V*4);g.writeUInt32BE(Q^i,V*4)}const h=t*4,E=g.byteLength-h,w=i>>>24&255,N=i>>>16&255,j=i>>>8&255;E>=1&&g.writeUInt8(g.readUInt8(h)^w,h),E>=2&&g.writeUInt8(g.readUInt8(h+1)^N,h+1),E>=3&&g.writeUInt8(g.readUInt8(h+2)^j,h+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const C={[2]:107,[1]:103};function p(){const g=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let i;return e.XDG_RUNTIME_DIR?i=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):i=(0,S.join)(P().os.tmpdir(),`vscode-ipc-${g}.sock`),s(i),i}e.createRandomIPCHandle=p;function n(g,i,t){const h=P().crypto.createHash("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${h}-${t}-${i}-sock`;const E=t.substr(0,4),w=i.substr(0,6),N=h.substr(0,8);let j;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${E}-${w}.sock`):j=(0,S.join)(g,`${E}-${w}.sock`),s(j),j}e.createStaticIPCHandle=n;function s(g){const i=C[A.platform];typeof i=="number"&&g.length>=i&&console.warn(`WARNING: IPC handle "${g}" is longer than ${i} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{static b(i){const t=l.Event.fromNodeEventEmitter(i,"connection");return l.Event.map(t,h=>({protocol:new O.Protocol(new v(h,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(h,"close"))}))}constructor(i){super(r.b(i)),this.d=i}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function a(g){return new Promise((i,t)=>{const h=P().net.createServer();h.on("error",t),h.listen(g,()=>{h.removeListener("error",t),i(new r(h))})})}e.serve=a;function c(g,i){return new Promise((t,h)=>{const E=P().net.createConnection(g,()=>{E.removeListener("error",h),t(O.Client.fromSocket(new v(E,`ipc-client${i}`),i))});E.once("error",h)})}e.connect=c}),define(ye[164],De([1,0,38,12]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(R,S,A,y,I,O){if(Array.isArray(R)){let P=0;for(const v of R){const k=l(v,S,A,y,I,O);if(k===10)return k;k>P&&(P=k)}return P}else{if(typeof R=="string")return y?R==="*"?5:R===A?10:0:0;if(R){const{language:P,pattern:v,scheme:k,hasAccessToAllModels:D,notebookType:f}=R;if(!y&&!D)return 0;f&&I&&(S=I);let d=0;if(k)if(k===S.scheme)d=10;else if(k==="*")d=5;else return 0;if(P)if(P===A)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(f)if(f===O)d=10;else if(f==="*"&&O!==void 0)d=Math.max(d,5);else return 0;if(v){let u;if(typeof v=="string"?u=v:u={...v,base:(0,L.normalize)(v.base)},u===S.fsPath||(0,o.match)(u,S.fsPath))d=10;else return 0}return d}else return 0}}e.score=l}),define(ye[165],De([1,0,8,52,155]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,y,I,O){this.c=A,this.d=y,this.f=I,this.g=O,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const I of y)this.n(I.range),this.o(new L.Position(I.range.startLineNumber,I.range.startColumn),I.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,I=new Uint32Array(y);for(let O=0;O<y;O++)I[O]=this.d[O].length+A;this.h=new l.PrefixSumComputer(I)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const I=(0,o.splitLines)(y);if(I.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+I[0]+this.d[A.lineNumber-1].substring(A.column-1));return}I[I.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+I[0]);const O=new Uint32Array(I.length-1);for(let P=1;P<I.length;P++)this.d.splice(A.lineNumber+P-1,0,I[P]),O[P-1]=I[P].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,O)}}e.MirrorTextModel=R}),define(ye[166],De([1,0,8,152,52,32,107]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(m,b,C,p){this.searchString=m,this.isRegex=b,this.matchCase=C,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let m;this.isRegex?m=I(this.searchString):m=this.searchString.indexOf(`
`)>=0;let b=null;try{b=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:m,global:!0,unicode:!0})}catch{return null}if(!b)return null;let C=!this.isRegex&&!m;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new S.SearchData(b,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=y;function I(u){if(!u||u.length===0)return!1;for(let m=0,b=u.length;m<b;m++){const C=u.charCodeAt(m);if(C===10)return!0;if(C===92){if(m++,m>=b)break;const p=u.charCodeAt(m);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=I;function O(u,m,b){if(!b)return new S.FindMatch(u,null);const C=[];for(let p=0,n=m.length;p<n;p++)C[p]=m[p];return new S.FindMatch(u,C)}e.createFindMatch=O;class P{constructor(m){const b=[];let C=0;for(let p=0,n=m.length;p<n;p++)m.charCodeAt(p)===10&&(b[C++]=p);this.a=b}findLineFeedCountBeforeOffset(m){const b=this.a;let C=0,p=b.length-1;if(p===-1||m<=b[0])return 0;for(;C<p;){const n=C+((p-C)/2>>0);b[n]>=m?p=n-1:b[n+1]>=m?(C=n,p=n):C=n+1}return C+1}}class v{static findMatches(m,b,C,p,n){const s=b.parseSearchRequest();return s?s.regex.multiline?this.b(m,C,new d(s.wordSeparators,s.regex),p,n):this.c(m,C,s,p,n):[]}static a(m,b,C,p,n,s){let r,a=0;p?(a=p.findLineFeedCountBeforeOffset(n),r=b+n+a):r=b+n;let c;if(p){const h=p.findLineFeedCountBeforeOffset(n+s.length)-a;c=r+s.length+h}else c=r+s.length;const g=m.getPositionAt(r),i=m.getPositionAt(c);return new R.Range(g.lineNumber,g.column,i.lineNumber,i.column)}static b(m,b,C,p,n){const s=m.getOffsetAt(b.getStartPosition()),r=m.getValueInRange(b,1),a=m.getEOL()===`\r
`?new P(r):null,c=[];let g=0,i;for(C.reset(0);i=C.next(r);)if(c[g++]=O(this.a(m,s,r,a,i.index,i[0]),i,p),g>=n)return c;return c}static c(m,b,C,p,n){const s=[];let r=0;if(b.startLineNumber===b.endLineNumber){const c=m.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return r=this.d(C,c,b.startLineNumber,b.startColumn-1,r,s,p,n),s}const a=m.getLineContent(b.startLineNumber).substring(b.startColumn-1);r=this.d(C,a,b.startLineNumber,b.startColumn-1,r,s,p,n);for(let c=b.startLineNumber+1;c<b.endLineNumber&&r<n;c++)r=this.d(C,m.getLineContent(c),c,0,r,s,p,n);if(r<n){const c=m.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);r=this.d(C,c,b.endLineNumber,0,r,s,p,n)}return s}static d(m,b,C,p,n,s,r,a){const c=m.wordSeparators;if(!r&&m.simpleSearch){const t=m.simpleSearch,h=t.length,E=b.length;let w=-h;for(;(w=b.indexOf(t,w+h))!==-1;)if((!c||f(c,b,E,w,h))&&(s[n++]=new S.FindMatch(new R.Range(C,w+1+p,C,w+1+h+p),null),n>=a))return n;return n}const g=new d(m.wordSeparators,m.regex);let i;g.reset(0);do if(i=g.next(b),i&&(s[n++]=O(new R.Range(C,i.index+1+p,C,i.index+1+i[0].length+p),i,r),n>=a))return n;while(i);return n}static findNextMatch(m,b,C,p){const n=b.parseSearchRequest();if(!n)return null;const s=new d(n.wordSeparators,n.regex);return n.regex.multiline?this.e(m,C,s,p):this.f(m,C,s,p)}static e(m,b,C,p){const n=new l.Position(b.lineNumber,1),s=m.getOffsetAt(n),r=m.getLineCount(),a=m.getValueInRange(new R.Range(n.lineNumber,n.column,r,m.getLineMaxColumn(r)),1),c=m.getEOL()===`\r
`?new P(a):null;C.reset(b.column-1);const g=C.next(a);return g?O(this.a(m,s,a,c,g.index,g[0]),g,p):b.lineNumber!==1||b.column!==1?this.e(m,new l.Position(1,1),C,p):null}static f(m,b,C,p){const n=m.getLineCount(),s=b.lineNumber,r=m.getLineContent(s),a=this.g(C,r,s,b.column,p);if(a)return a;for(let c=1;c<=n;c++){const g=(s+c-1)%n,i=m.getLineContent(g+1),t=this.g(C,i,g+1,1,p);if(t)return t}return null}static g(m,b,C,p,n){m.reset(p-1);const s=m.next(b);return s?O(new R.Range(C,s.index+1,C,s.index+1+s[0].length),s,n):null}static findPreviousMatch(m,b,C,p){const n=b.parseSearchRequest();if(!n)return null;const s=new d(n.wordSeparators,n.regex);return n.regex.multiline?this.h(m,C,s,p):this.j(m,C,s,p)}static h(m,b,C,p){const n=this.b(m,new R.Range(1,1,b.lineNumber,b.column),C,p,10*A);if(n.length>0)return n[n.length-1];const s=m.getLineCount();return b.lineNumber!==s||b.column!==m.getLineMaxColumn(s)?this.h(m,new l.Position(s,m.getLineMaxColumn(s)),C,p):null}static j(m,b,C,p){const n=m.getLineCount(),s=b.lineNumber,r=m.getLineContent(s).substring(0,b.column-1),a=this.k(C,r,s,p);if(a)return a;for(let c=1;c<=n;c++){const g=(n+s-c-1)%n,i=m.getLineContent(g+1),t=this.k(C,i,g+1,p);if(t)return t}return null}static k(m,b,C,p){let n=null,s;for(m.reset(0);s=m.next(b);)n=O(new R.Range(C,s.index+1,C,s.index+1+s[0].length),s,p);return n}}e.TextModelSearch=v;function k(u,m,b,C,p){if(C===0)return!0;const n=m.charCodeAt(C-1);if(u.get(n)!==0||n===13||n===10)return!0;if(p>0){const s=m.charCodeAt(C);if(u.get(s)!==0)return!0}return!1}function D(u,m,b,C,p){if(C+p===b)return!0;const n=m.charCodeAt(C+p);if(u.get(n)!==0||n===13||n===10)return!0;if(p>0){const s=m.charCodeAt(C+p-1);if(u.get(s)!==0)return!0}return!1}function f(u,m,b,C,p){return k(u,m,b,C,p)&&D(u,m,b,C,p)}e.isValidMatch=f;class d{constructor(m,b){this._wordSeparators=m,this.a=b,this.b=-1,this.c=0}reset(m){this.a.lastIndex=m,this.b=-1,this.c=0}next(m){const b=m.length;let C;do{if(this.b+this.c===b||(C=this.a.exec(m),!C))return null;const p=C.index,n=C[0].length;if(p===this.b&&n===this.c){if(n===0){o.getNextCodePoint(m,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=n,!this._wordSeparators||f(this._wordSeparators,m,b,p,n))return C}while(C);return null}}e.Searcher=d}),define(ye[120],De([1,0,22,11]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(l||(l={}));function R(P){for(let v=0,k=P.length;v<k;v+=4){const D=P[v+0],f=P[v+1],d=P[v+2],u=P[v+3];P[v+0]=u,P[v+1]=d,P[v+2]=f,P[v+3]=D}}function S(P){const v=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||R(v),o.VSBuffer.wrap(v)}function A(P){const v=P.buffer;if(L.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const k=new Uint8Array(v.byteLength);return k.set(v),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function y(P){const v=new Uint32Array(I(P));let k=0;if(v[k++]=P.id,P.type==="full")v[k++]=1,v[k++]=P.data.length,v.set(P.data,k),k+=P.data.length;else{v[k++]=2,v[k++]=P.deltas.length;for(const D of P.deltas)v[k++]=D.start,v[k++]=D.deleteCount,D.data?(v[k++]=D.data.length,v.set(D.data,k),k+=D.data.length):v[k++]=0}return S(v)}e.encodeSemanticTokensDto=y;function I(P){let v=0;if(v+=1+1,P.type==="full")v+=1+P.data.length;else{v+=1,v+=(1+1+1)*P.deltas.length;for(const k of P.deltas)k.data&&(v+=k.data.length)}return v}function O(P){const v=A(P);let k=0;const D=v[k++];if(v[k++]===1){const m=v[k++],b=v.subarray(k,k+m);return k+=m,{id:D,type:"full",data:b}}const d=v[k++],u=[];for(let m=0;m<d;m++){const b=v[k++],C=v[k++],p=v[k++];let n;p>0&&(n=v.subarray(k,k+p),k+=p),u[m]={start:b,deleteCount:C,data:n}}return{id:D,type:"delta",deltas:u}}e.decodeSemanticTokensDto=O}),define(ye[167],De([1,0,3,6]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new o.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,L.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const I=new R(this,A,y);return this.b.set(A,I),(0,L.toDisposable)(()=>{const O=this.b.get(A);!O||O!==I||(this.b.delete(A),O.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const I=this.b.get(A);return!I||I.isResolved?null:(await I.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const I=this.b.get(A);return!!(!I||I.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class R extends L.Disposable{get isResolved(){return this.c}constructor(A,y,I){super(),this.f=A,this.g=y,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[71],De([1,0,67,2,32,167]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class S{constructor(h,E,w){this.offset=h,this.type=E,this.language=w,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=S;class A{constructor(h,E){this.tokens=h,this.endState=E,this._tokenizationResultBrand=void 0}}e.TokenizationResult=A;class y{constructor(h,E){this.tokens=h,this.endState=E,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var I;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var O;(function(t){const h=new Map;h.set(0,o.Codicon.symbolMethod),h.set(1,o.Codicon.symbolFunction),h.set(2,o.Codicon.symbolConstructor),h.set(3,o.Codicon.symbolField),h.set(4,o.Codicon.symbolVariable),h.set(5,o.Codicon.symbolClass),h.set(6,o.Codicon.symbolStruct),h.set(7,o.Codicon.symbolInterface),h.set(8,o.Codicon.symbolModule),h.set(9,o.Codicon.symbolProperty),h.set(10,o.Codicon.symbolEvent),h.set(11,o.Codicon.symbolOperator),h.set(12,o.Codicon.symbolUnit),h.set(13,o.Codicon.symbolValue),h.set(15,o.Codicon.symbolEnum),h.set(14,o.Codicon.symbolConstant),h.set(15,o.Codicon.symbolEnum),h.set(16,o.Codicon.symbolEnumMember),h.set(17,o.Codicon.symbolKeyword),h.set(27,o.Codicon.symbolSnippet),h.set(18,o.Codicon.symbolText),h.set(19,o.Codicon.symbolColor),h.set(20,o.Codicon.symbolFile),h.set(21,o.Codicon.symbolReference),h.set(22,o.Codicon.symbolCustomColor),h.set(23,o.Codicon.symbolFolder),h.set(24,o.Codicon.symbolTypeParameter),h.set(25,o.Codicon.account),h.set(26,o.Codicon.issues);function E(j){let V=h.get(j);return V||(console.info("No codicon found for CompletionItemKind "+j),V=o.Codicon.symbolProperty),V}t.toIcon=E;const w=new Map;w.set("method",0),w.set("function",1),w.set("constructor",2),w.set("field",3),w.set("variable",4),w.set("class",5),w.set("struct",6),w.set("interface",7),w.set("module",8),w.set("property",9),w.set("event",10),w.set("operator",11),w.set("unit",12),w.set("value",13),w.set("constant",14),w.set("enum",15),w.set("enum-member",16),w.set("enumMember",16),w.set("keyword",17),w.set("snippet",27),w.set("text",18),w.set("color",19),w.set("file",20),w.set("reference",21),w.set("customcolor",22),w.set("folder",23),w.set("type-parameter",24),w.set("typeParameter",24),w.set("account",25),w.set("issue",26);function N(j,V){let Q=w.get(j);return typeof Q>"u"&&!V&&(Q=9),Q}t.fromString=N})(O=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(t){t[t.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function m(t){return t&&L.URI.isUri(t.uri)&&l.Range.isIRange(t.range)&&(l.Range.isIRange(t.originSelectionRange)||l.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=m;var b;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var C;(function(t){t[t.Deprecated=1]="Deprecated"})(C=e.SymbolTag||(e.SymbolTag={}));var p;(function(t){const h=new Map;h.set(0,o.Codicon.symbolFile),h.set(1,o.Codicon.symbolModule),h.set(2,o.Codicon.symbolNamespace),h.set(3,o.Codicon.symbolPackage),h.set(4,o.Codicon.symbolClass),h.set(5,o.Codicon.symbolMethod),h.set(6,o.Codicon.symbolProperty),h.set(7,o.Codicon.symbolField),h.set(8,o.Codicon.symbolConstructor),h.set(9,o.Codicon.symbolEnum),h.set(10,o.Codicon.symbolInterface),h.set(11,o.Codicon.symbolFunction),h.set(12,o.Codicon.symbolVariable),h.set(13,o.Codicon.symbolConstant),h.set(14,o.Codicon.symbolString),h.set(15,o.Codicon.symbolNumber),h.set(16,o.Codicon.symbolBoolean),h.set(17,o.Codicon.symbolArray),h.set(18,o.Codicon.symbolObject),h.set(19,o.Codicon.symbolKey),h.set(20,o.Codicon.symbolNull),h.set(21,o.Codicon.symbolEnumMember),h.set(22,o.Codicon.symbolStruct),h.set(23,o.Codicon.symbolEvent),h.set(24,o.Codicon.symbolOperator),h.set(25,o.Codicon.symbolTypeParameter);function E(w){let N=h.get(w);return N||(console.info("No codicon found for SymbolKind "+w),N=o.Codicon.symbolProperty),N}t.toIcon=E})(p=e.SymbolKinds||(e.SymbolKinds={}));class n{static fromValue(h){switch(h){case"comment":return n.Comment;case"imports":return n.Imports;case"region":return n.Region}return new n(h)}constructor(h){this.value=h}}n.Comment=new n("comment"),n.Imports=new n("imports"),n.Region=new n("region"),e.FoldingRangeKind=n;var s;(function(t){function h(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}t.is=h})(s=e.Command||(e.Command={}));var r;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(a=e.CommentThreadState||(e.CommentThreadState={}));var c;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var g;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(g=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var i;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(i=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[168],De([17,18]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,168,11,106,15,23,151]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function($){$[$.None=0]="None",$[$.Keep=1]="Keep",$[$.Brackets=2]="Brackets",$[$.Advanced=3]="Advanced",$[$.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(K){this.c=K}hasChanged(K){return this.c[K]}}e.ConfigurationChangedEvent=I;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class P{constructor(K,he,Le,Ne){this.id=K,this.name=he,this.defaultValue=Le,this.schema=Ne}applyUpdate(K,he){return k(K,he)}compute(K,he,Le){return Le}}class v{constructor(K,he){this.newValue=K,this.didChange=he}}e.ApplyUpdateResult=v;function k($,K){if(typeof $!="object"||typeof K!="object"||!$||!K)return new v(K,$!==K);if(Array.isArray($)||Array.isArray(K)){const Le=Array.isArray($)&&Array.isArray(K)&&R.equals($,K);return new v(K,!Le)}let he=!1;for(const Le in K)if(K.hasOwnProperty(Le)){const Ne=k($[Le],K[Le]);Ne.didChange&&($[Le]=Ne.newValue,he=!0)}return new v($,he)}class D{constructor(K){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0}applyUpdate(K,he){return k(K,he)}validate(K){return this.defaultValue}}class f{constructor(K,he,Le,Ne){this.id=K,this.name=he,this.defaultValue=Le,this.schema=Ne}applyUpdate(K,he){return k(K,he)}validate(K){return typeof K>"u"?this.defaultValue:K}compute(K,he,Le){return Le}}function d($,K){return typeof $>"u"?K:$==="false"?!1:Boolean($)}e.boolean=d;class u extends f{constructor(K,he,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(K,he,Le,Ne)}validate(K){return d(K,this.defaultValue)}}function m($,K,he,Le){if(typeof $>"u")return K;let Ne=parseInt($,10);return isNaN(Ne)?K:(Ne=Math.max(he,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=m;class b extends f{static clampedInt(K,he,Le,Ne){return m(K,he,Le,Ne)}constructor(K,he,Le,Ne,qe,je=void 0){typeof je<"u"&&(je.type="integer",je.default=Le,je.minimum=Ne,je.maximum=qe),super(K,he,Le,je),this.minimum=Ne,this.maximum=qe}validate(K){return b.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}class C extends f{static clamp(K,he,Le){return K<he?he:K>Le?Le:K}static float(K,he){if(typeof K=="number")return K;if(typeof K>"u")return he;const Le=parseFloat(K);return isNaN(Le)?he:Le}constructor(K,he,Le,Ne,qe){typeof qe<"u"&&(qe.type="number",qe.default=Le),super(K,he,Le,qe),this.validationFn=Ne}validate(K){return this.validationFn(C.float(K,this.defaultValue))}}class p extends f{static string(K,he){return typeof K!="string"?he:K}constructor(K,he,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(K,he,Le,Ne)}validate(K){return p.string(K,this.defaultValue)}}function n($,K,he){return typeof $!="string"||he.indexOf($)===-1?K:$}e.stringSet=n;class s extends f{constructor(K,he,Le,Ne,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.enum=Ne,qe.default=Le),super(K,he,Le,qe),this.c=Ne}validate(K){return n(K,this.defaultValue,this.c)}}class r extends P{constructor(K,he,Le,Ne,qe,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=qe,Ze.default=Ne),super(K,he,Le,Ze),this.c=qe,this.d=je}validate(K){return typeof K!="string"?this.defaultValue:this.c.indexOf(K)===-1?this.defaultValue:this.d(K)}}function a($){switch($){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(K){switch(K){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(K,he,Le){return Le===0?K.accessibilitySupport:Le}}class g extends P{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:o.localize(5,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{insertSpace:d(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function($){$[$.Hidden=0]="Hidden",$[$.Blink=1]="Blink",$[$.Smooth=2]="Smooth",$[$.Phase=3]="Phase",$[$.Expand=4]="Expand",$[$.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t($){switch($){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function($){$[$.Line=1]="Line",$[$.Block=2]="Block",$[$.Underline=3]="Underline",$[$.LineThin=4]="LineThin",$[$.BlockOutline=5]="BlockOutline",$[$.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E($){switch($){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function w($){switch($){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class N extends D{constructor(){super(135)}compute(K,he,Le){const Ne=["monaco-editor"];return he.get(36)&&Ne.push(he.get(36)),K.extraEditorClassName&&Ne.push(K.extraEditorClassName),he.get(70)==="default"?Ne.push("mouse-default"):he.get(70)==="copy"&&Ne.push("mouse-copy"),he.get(105)&&Ne.push("showUnused"),he.get(133)&&Ne.push("showDeprecated"),Ne.join(" ")}}class j extends u{constructor(){super(34,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(K,he,Le){return Le&&K.emptySelectionClipboard}}class V extends P{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:o.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:o.localize(18,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{cursorMoveOnType:d(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":n(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":n(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(he.loop,this.defaultValue.loop)}}}class Q extends P{constructor(){super(48,"fontLigatures",Q.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?Q.OFF:K==="true"?Q.ON:K:Boolean(K)?Q.ON:Q.OFF}}Q.OFF='"liga" off, "calt" off',Q.ON='"liga" on, "calt" on',e.EditorFontLigatures=Q;class q extends P{constructor(){super(51,"fontVariations",q.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?q.OFF:K==="true"?q.TRANSLATE:K:Boolean(K)?q.TRANSLATE:q.OFF}compute(K,he,Le){return K.fontInfo.fontVariationSettings}}q.OFF="normal",q.TRANSLATE="translate",e.EditorFontVariations=q;class U extends D{constructor(){super(47)}compute(K,he,Le){return K.fontInfo}}class T extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(K){const he=C.float(K,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(he,6,100)}compute(K,he,Le){return K.fontInfo.fontSize}}class F extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.d,maximum:F.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(K){return K==="normal"||K==="bold"?K:String(b.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,F.d,F.e))}}F.c=["normal","bold","100","200","300","400","500","600","700","800","900"],F.d=1,F.e=1e3;class B extends P{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...he},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...he},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...he},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:Le,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:Le,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:Le,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:Le,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:Le,description:o.localize(41,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{multiple:n(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??n(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??n(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??n(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??n(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??n(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends P{constructor(){const K={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:K.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:K.above,description:o.localize(45,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:d(he.enabled,this.defaultValue.enabled),delay:b.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:d(he.sticky,this.defaultValue.sticky),above:d(he.above,this.defaultValue.above)}}}var _;(function($){$[$.None=0]="None",$[$.Text=1]="Text",$[$.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class H extends D{constructor(){super(138)}compute(K,he,Le){return H.computeLayout(he,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio})}static computeContainedMinimapLineCount(K){const he=K.height/K.lineHeight,Le=Math.floor(K.paddingTop/K.lineHeight);let Ne=Math.floor(K.paddingBottom/K.lineHeight);K.scrollBeyondLastLine&&(Ne=Math.max(Ne,he-1));const qe=(Le+K.viewLineCount+Ne)/(K.pixelRatio*K.height),je=Math.floor(K.viewLineCount/qe);return{typicalViewportLineCount:he,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:qe,minimapLineCount:je}}static c(K,he){const Le=K.outerWidth,Ne=K.outerHeight,qe=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const je=he.stableMinimapLayoutInput,Ze=je&&K.outerHeight===je.outerHeight&&K.lineHeight===je.lineHeight&&K.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&K.pixelRatio===je.pixelRatio&&K.scrollBeyondLastLine===je.scrollBeyondLastLine&&K.paddingTop===je.paddingTop&&K.paddingBottom===je.paddingBottom&&K.minimap.enabled===je.minimap.enabled&&K.minimap.side===je.minimap.side&&K.minimap.size===je.minimap.size&&K.minimap.showSlider===je.minimap.showSlider&&K.minimap.renderCharacters===je.minimap.renderCharacters&&K.minimap.maxColumn===je.minimap.maxColumn&&K.minimap.scale===je.minimap.scale&&K.verticalScrollbarWidth===je.verticalScrollbarWidth&&K.isViewportWrapping===je.isViewportWrapping,st=K.lineHeight,at=K.typicalHalfwidthCharacterWidth,mt=K.scrollBeyondLastLine,gt=K.minimap.renderCharacters;let Et=qe>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const lt=K.minimap.maxColumn,pt=K.minimap.size,xt=K.minimap.side,jt=K.verticalScrollbarWidth,kt=K.viewLineCount,ft=K.remainingWidth,Tt=K.isViewportWrapping,Bt=gt?2:3;let At=Math.floor(qe*Ne);const Xe=At/qe;let Nt=!1,Gt=!1,Ft=Bt*Et,bt=Et/qe,Ae=1;if(pt==="fill"||pt==="fit"){const{typicalViewportLineCount:Ve,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:ut,desiredRatio:Pt,minimapLineCount:St}=H.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:mt,paddingTop:K.paddingTop,paddingBottom:K.paddingBottom,height:Ne,lineHeight:st,pixelRatio:qe});if(kt/St>1)Nt=!0,Gt=!0,Et=1,Ft=1,bt=Et/qe;else{let wt=!1,Rt=Et+1;if(pt==="fit"){const yt=Math.ceil((et+kt+ut)*Ft);Tt&&Ze&&ft<=he.stableFitRemainingWidth?(wt=!0,Rt=he.stableFitMaxMinimapScale):wt=yt>At}if(pt==="fill"||wt){Nt=!0;const yt=Et;Ft=Math.min(st*qe,Math.max(1,Math.floor(1/Pt))),Tt&&Ze&&ft<=he.stableFitRemainingWidth&&(Rt=he.stableFitMaxMinimapScale),Et=Math.min(Rt,Math.max(1,Math.floor(Ft/Bt))),Et>yt&&(Ae=Math.min(2,Et/yt)),bt=Et/qe/Ae,At=Math.ceil(Math.max(Ve,et+kt+ut)*Ft),Tt?(he.stableMinimapLayoutInput=K,he.stableFitRemainingWidth=ft,he.stableFitMaxMinimapScale=Et):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Oe=Math.floor(lt*bt),Se=Math.min(Oe,Math.max(0,Math.floor((ft-jt-2)*bt/(at+bt)))+e.MINIMAP_GUTTER_WIDTH);let se=Math.floor(qe*Se);const Fe=se/qe;se=Math.floor(se*Ae);const We=gt?1:2,Ye=xt==="left"?0:Le-Se-jt;return{renderMinimap:We,minimapLeft:Ye,minimapWidth:Se,minimapHeightIsEditorHeight:Nt,minimapIsSampling:Gt,minimapScale:Et,minimapLineHeight:Ft,minimapCanvasInnerWidth:se,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Xe}}static computeLayout(K,he){const Le=he.outerWidth|0,Ne=he.outerHeight|0,qe=he.lineHeight|0,je=he.lineNumbersDigitCount|0,Ze=he.typicalHalfwidthCharacterWidth,st=he.maxDigitWidth,at=he.pixelRatio,mt=he.viewLineCount,gt=K.get(130),Et=gt==="inherit"?K.get(129):gt,lt=Et==="inherit"?K.get(125):Et,pt=K.get(128),xt=he.isDominatedByLongLines,jt=K.get(54),kt=K.get(64).renderType!==0,ft=K.get(65),Tt=K.get(99),Bt=K.get(80),At=K.get(69),Xe=K.get(97),Nt=Xe.verticalScrollbarSize,Gt=Xe.verticalHasArrows,Ft=Xe.arrowSize,bt=Xe.horizontalScrollbarSize,Ae=K.get(40),Oe=K.get(104)!=="never";let Se=K.get(62);Ae&&Oe&&(Se+=16);let se=0;if(kt){const ei=Math.max(je,ft);se=Math.round(ei*st)}let Fe=0;jt&&(Fe=qe);let We=0,Ye=We+Fe,Ve=Ye+se,et=Ve+Se;const ut=Le-Fe-se-Se;let Pt=!1,St=!1,Dt=-1;Et==="inherit"&&xt?(Pt=!0,St=!0):lt==="on"||lt==="bounded"?St=!0:lt==="wordWrapColumn"&&(Dt=pt);const wt=H.c({outerWidth:Le,outerHeight:Ne,lineHeight:qe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:at,scrollBeyondLastLine:Tt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:At,verticalScrollbarWidth:Nt,viewLineCount:mt,remainingWidth:ut,isViewportWrapping:St},he.memory||new O);wt.renderMinimap!==0&&wt.minimapLeft===0&&(We+=wt.minimapWidth,Ye+=wt.minimapWidth,Ve+=wt.minimapWidth,et+=wt.minimapWidth);const Rt=ut-wt.minimapWidth,yt=Math.max(1,Math.floor((Rt-Nt-2)/Ze)),ri=Gt?Ft:0;return St&&(Dt=Math.max(1,yt),lt==="bounded"&&(Dt=Math.min(Dt,pt))),{width:Le,height:Ne,glyphMarginLeft:We,glyphMarginWidth:Fe,lineNumbersLeft:Ye,lineNumbersWidth:se,decorationsLeft:Ve,decorationsWidth:Se,contentLeft:et,contentWidth:Rt,minimap:wt,viewportColumn:yt,isWordWrapMinified:Pt,isViewportWrapping:St,wrappingColumn:Dt,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:bt,overviewRuler:{top:ri,width:Nt,height:Ne-2*ri,right:0}}}}e.EditorLayoutInfoComputer=H;class Y extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate(K){return n(K,"simple",["simple","advanced"])}compute(K,he,Le){return he.get(2)===2?"advanced":Le}}class ie extends P{constructor(){const K={enabled:!0};super(61,"lightbulb",K,{"editor.lightbulb.enabled":{type:"boolean",default:K.enabled,description:o.localize(49,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:d(K.enabled,this.defaultValue.enabled)}}}class ge extends P{constructor(){const K={enabled:!1,maxLineCount:5};super(109,"stickyScroll",K,{"editor.stickyScroll.enabled":{type:"boolean",default:K.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:K.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:d(he.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends P{constructor(){const K={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",K,{"editor.inlayHints.enabled":{type:"string",default:K.enabled,description:o.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(53,null),o.localize(54,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(55,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:o.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,markdownDescription:o.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:K.padding,description:o.localize(59,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:n(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(he.fontFamily,this.defaultValue.fontFamily),padding:d(he.padding,this.defaultValue.padding)}}}class J extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate(K){return typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)?-parseFloat(K.substring(0,K.length-2)):b.clampedInt(K,this.defaultValue,0,1e3)}compute(K,he,Le){return Le<0?b.clampedInt(-Le*K.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class ee extends C{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>C.clamp(K,0,150),{markdownDescription:o.localize(60,null)})}compute(K,he,Le){return K.fontInfo.lineHeight}}class me extends P{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:o.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:K.autohide,description:o.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)],default:K.size,description:o.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:o.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:o.localize(68,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:o.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:o.localize(71,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:d(he.enabled,this.defaultValue.enabled),autohide:d(he.autohide,this.defaultValue.autohide),size:n(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:n(he.side,this.defaultValue.side,["right","left"]),showSlider:n(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(he.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(he.scale,1,1,3),maxColumn:b.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve($){return $==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ie extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{top:b.clampedInt(he.top,0,0,1e3),bottom:b.clampedInt(he.bottom,0,0,1e3)}}}class Re extends P{constructor(){const K={enabled:!0,cycle:!0};super(81,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:o.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:o.localize(75,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:d(he.enabled,this.defaultValue.enabled),cycle:d(he.cycle,this.defaultValue.cycle)}}}class ae extends D{constructor(){super(136)}compute(K,he,Le){return K.pixelRatio}}class le extends P{constructor(){const K={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(76,null),o.localize(77,null),o.localize(78,null)]}];super(84,"quickSuggestions",K,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:K.strings,description:o.localize(79,null)},comments:{anyOf:he,default:K.comments,description:o.localize(80,null)},other:{anyOf:he,default:K.other,description:o.localize(81,null)}},default:K,markdownDescription:o.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=K}validate(K){if(typeof K=="boolean"){const at=K?"on":"off";return{comments:at,strings:at,other:at}}if(!K||typeof K!="object")return this.defaultValue;const{other:he,comments:Le,strings:Ne}=K,qe=["on","inline","off"];let je,Ze,st;return typeof he=="boolean"?je=he?"on":"off":je=n(he,this.defaultValue.other,qe),typeof Le=="boolean"?Ze=Le?"on":"off":Ze=n(Le,this.defaultValue.comments,qe),typeof Ne=="boolean"?st=Ne?"on":"off":st=n(Ne,this.defaultValue.strings,qe),{other:je,comments:Ze,strings:st}}}var ue;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative",$[$.Interval=3]="Interval",$[$.Custom=4]="Custom"})(ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ne extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(83,null),o.localize(84,null),o.localize(85,null),o.localize(86,null)],default:"on",description:o.localize(87,null)})}validate(K){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof K<"u"&&(typeof K=="function"?(he=4,Le=K):K==="interval"?he=3:K==="relative"?he=2:K==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function ce($){const K=$.get(92);return K==="editable"?$.get(86):K!=="on"}e.filterValidationDecorations=ce;class oe extends P{constructor(){const K=[],he={type:"number",description:o.localize(88,null)};super(96,"rulers",K,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:o.localize(89,null),format:"color-hex"}}}]},default:K,description:o.localize(90,null)})}validate(K){if(Array.isArray(K)){const he=[];for(const Le of K)if(typeof Le=="number")he.push({column:b.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;he.push({column:b.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return he.sort((Le,Ne)=>Le.column-Ne.column),he}return this.defaultValue}}function M($,K){if(typeof $!="string")return K;switch($){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends P{constructor(){const K={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(91,null),o.localize(92,null),o.localize(93,null)],default:"auto",description:o.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(95,null),o.localize(96,null),o.localize(97,null)],default:"auto",description:o.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:o.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:o.localize(101,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K,Le=b.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=b.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(he.vertical,this.defaultValue.vertical),horizontal:M(he.horizontal,this.defaultValue.horizontal),useShadows:d(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:b.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:b.clampedInt(he.verticalSliderSize,Ne,0,1e3),scrollByPage:d(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends P{constructor(){const K={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",K,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.nonBasicASCII,description:o.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:K.invisibleCharacters,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:K.ambiguousCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeComments,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeStrings,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:K.allowedCharacters,description:o.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:K.allowedLocales,description:o.localize(108,null)}})}applyUpdate(K,he){let Le=!1;he.allowedCharacters&&K&&(S.equals(K.allowedCharacters,he.allowedCharacters)||(K={...K,allowedCharacters:he.allowedCharacters},Le=!0)),he.allowedLocales&&K&&(S.equals(K.allowedLocales,he.allowedLocales)||(K={...K,allowedLocales:he.allowedLocales},Le=!0));const Ne=super.applyUpdate(K,he);return Le?new v(Ne.newValue,!0):Ne}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{nonBasicASCII:Pe(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(K.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(K.allowedLocales,this.defaultValue.allowedLocales)}}c(K,he){if(typeof K!="object"||!K)return he;const Le={};for(const[Ne,qe]of Object.entries(K))qe===!0&&(Le[Ne]=!0);return Le}}class te extends P{constructor(){const K={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:o.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover"],enumDescriptions:[o.localize(110,null),o.localize(111,null)],description:o.localize(112,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:d(he.enabled,this.defaultValue.enabled),mode:n(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:n(he.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class de extends P{constructor(){const K={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,markdownDescription:o.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:K.independentColorPoolPerBracketType,description:o.localize(114,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:d(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends P{constructor(){const K={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",K,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(115,null),o.localize(116,null),o.localize(117,null)],default:K.bracketPairs,description:o.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(119,null),o.localize(120,null),o.localize(121,null)],default:K.bracketPairsHorizontal,description:o.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:K.highlightActiveBracketPair,description:o.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:K.indentation,description:o.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(125,null),o.localize(126,null),o.localize(127,null)],default:K.highlightActiveIndentation,description:o.localize(128,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{bracketPairs:Pe(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe($,K,he){const Le=he.indexOf($);return Le===-1?K:he[Le]}class be extends P{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(129,null),o.localize(130,null)],default:K.insertMode,description:o.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:o.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:o.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:o.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(135,null),o.localize(136,null),o.localize(137,null),o.localize(138,null)],default:K.selectionMode,markdownDescription:o.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:o.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:o.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:o.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:o.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:o.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{insertMode:n(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:n(he.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(he.showIcons,this.defaultValue.showIcons),showStatusBar:d(he.showStatusBar,this.defaultValue.showStatusBar),preview:d(he.preview,this.defaultValue.preview),previewMode:n(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(he.showMethods,this.defaultValue.showMethods),showFunctions:d(he.showFunctions,this.defaultValue.showFunctions),showConstructors:d(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(he.showFields,this.defaultValue.showFields),showVariables:d(he.showVariables,this.defaultValue.showVariables),showClasses:d(he.showClasses,this.defaultValue.showClasses),showStructs:d(he.showStructs,this.defaultValue.showStructs),showInterfaces:d(he.showInterfaces,this.defaultValue.showInterfaces),showModules:d(he.showModules,this.defaultValue.showModules),showProperties:d(he.showProperties,this.defaultValue.showProperties),showEvents:d(he.showEvents,this.defaultValue.showEvents),showOperators:d(he.showOperators,this.defaultValue.showOperators),showUnits:d(he.showUnits,this.defaultValue.showUnits),showValues:d(he.showValues,this.defaultValue.showValues),showConstants:d(he.showConstants,this.defaultValue.showConstants),showEnums:d(he.showEnums,this.defaultValue.showEnums),showEnumMembers:d(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(he.showKeywords,this.defaultValue.showKeywords),showWords:d(he.showWords,this.defaultValue.showWords),showColors:d(he.showColors,this.defaultValue.showColors),showFiles:d(he.showFiles,this.defaultValue.showFiles),showReferences:d(he.showReferences,this.defaultValue.showReferences),showFolders:d(he.showFolders,this.defaultValue.showFolders),showTypeParameters:d(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(he.showSnippets,this.defaultValue.showSnippets),showUsers:d(he.showUsers,this.defaultValue.showUsers),showIssues:d(he.showIssues,this.defaultValue.showIssues)}}}class Ce extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(177,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var ke;(function($){$[$.None=0]="None",$[$.Same=1]="Same",$[$.Indent=2]="Indent",$[$.DeepIndent=3]="DeepIndent"})(ke=e.WrappingIndent||(e.WrappingIndent={}));class He extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(178,null),o.localize(179,null),o.localize(180,null),o.localize(181,null)],description:o.localize(182,null),default:"same"}})}validate(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(K,he,Le){return he.get(2)===2?0:Le}}class Ge extends D{constructor(){super(139)}compute(K,he,Le){const Ne=he.get(138);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class nt extends P{constructor(){const K={enabled:!0};super(33,"dropIntoEditor",K,{"editor.dropIntoEditor.enabled":{type:"boolean",default:K.enabled,markdownDescription:o.localize(183,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:d(K.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?tt:L.isLinux?rt:Qe,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be($){return e.editorOptionsRegistry[$.id]=$,$}var it;(function($){$[$.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",$[$.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",$[$.accessibilitySupport=2]="accessibilitySupport",$[$.accessibilityPageSize=3]="accessibilityPageSize",$[$.ariaLabel=4]="ariaLabel",$[$.autoClosingBrackets=5]="autoClosingBrackets",$[$.autoClosingDelete=6]="autoClosingDelete",$[$.autoClosingOvertype=7]="autoClosingOvertype",$[$.autoClosingQuotes=8]="autoClosingQuotes",$[$.autoIndent=9]="autoIndent",$[$.automaticLayout=10]="automaticLayout",$[$.autoSurround=11]="autoSurround",$[$.bracketPairColorization=12]="bracketPairColorization",$[$.guides=13]="guides",$[$.codeLens=14]="codeLens",$[$.codeLensFontFamily=15]="codeLensFontFamily",$[$.codeLensFontSize=16]="codeLensFontSize",$[$.colorDecorators=17]="colorDecorators",$[$.colorDecoratorsLimit=18]="colorDecoratorsLimit",$[$.columnSelection=19]="columnSelection",$[$.comments=20]="comments",$[$.contextmenu=21]="contextmenu",$[$.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",$[$.cursorBlinking=23]="cursorBlinking",$[$.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",$[$.cursorStyle=25]="cursorStyle",$[$.cursorSurroundingLines=26]="cursorSurroundingLines",$[$.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",$[$.cursorWidth=28]="cursorWidth",$[$.disableLayerHinting=29]="disableLayerHinting",$[$.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",$[$.domReadOnly=31]="domReadOnly",$[$.dragAndDrop=32]="dragAndDrop",$[$.dropIntoEditor=33]="dropIntoEditor",$[$.emptySelectionClipboard=34]="emptySelectionClipboard",$[$.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",$[$.extraEditorClassName=36]="extraEditorClassName",$[$.fastScrollSensitivity=37]="fastScrollSensitivity",$[$.find=38]="find",$[$.fixedOverflowWidgets=39]="fixedOverflowWidgets",$[$.folding=40]="folding",$[$.foldingStrategy=41]="foldingStrategy",$[$.foldingHighlight=42]="foldingHighlight",$[$.foldingImportsByDefault=43]="foldingImportsByDefault",$[$.foldingMaximumRegions=44]="foldingMaximumRegions",$[$.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",$[$.fontFamily=46]="fontFamily",$[$.fontInfo=47]="fontInfo",$[$.fontLigatures=48]="fontLigatures",$[$.fontSize=49]="fontSize",$[$.fontWeight=50]="fontWeight",$[$.fontVariations=51]="fontVariations",$[$.formatOnPaste=52]="formatOnPaste",$[$.formatOnType=53]="formatOnType",$[$.glyphMargin=54]="glyphMargin",$[$.gotoLocation=55]="gotoLocation",$[$.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",$[$.hover=57]="hover",$[$.inDiffEditor=58]="inDiffEditor",$[$.inlineSuggest=59]="inlineSuggest",$[$.letterSpacing=60]="letterSpacing",$[$.lightbulb=61]="lightbulb",$[$.lineDecorationsWidth=62]="lineDecorationsWidth",$[$.lineHeight=63]="lineHeight",$[$.lineNumbers=64]="lineNumbers",$[$.lineNumbersMinChars=65]="lineNumbersMinChars",$[$.linkedEditing=66]="linkedEditing",$[$.links=67]="links",$[$.matchBrackets=68]="matchBrackets",$[$.minimap=69]="minimap",$[$.mouseStyle=70]="mouseStyle",$[$.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",$[$.mouseWheelZoom=72]="mouseWheelZoom",$[$.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",$[$.multiCursorModifier=74]="multiCursorModifier",$[$.multiCursorPaste=75]="multiCursorPaste",$[$.multiCursorLimit=76]="multiCursorLimit",$[$.occurrencesHighlight=77]="occurrencesHighlight",$[$.overviewRulerBorder=78]="overviewRulerBorder",$[$.overviewRulerLanes=79]="overviewRulerLanes",$[$.padding=80]="padding",$[$.parameterHints=81]="parameterHints",$[$.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",$[$.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",$[$.quickSuggestions=84]="quickSuggestions",$[$.quickSuggestionsDelay=85]="quickSuggestionsDelay",$[$.readOnly=86]="readOnly",$[$.renameOnType=87]="renameOnType",$[$.renderControlCharacters=88]="renderControlCharacters",$[$.renderFinalNewline=89]="renderFinalNewline",$[$.renderLineHighlight=90]="renderLineHighlight",$[$.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",$[$.renderValidationDecorations=92]="renderValidationDecorations",$[$.renderWhitespace=93]="renderWhitespace",$[$.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",$[$.roundedSelection=95]="roundedSelection",$[$.rulers=96]="rulers",$[$.scrollbar=97]="scrollbar",$[$.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",$[$.scrollBeyondLastLine=99]="scrollBeyondLastLine",$[$.scrollPredominantAxis=100]="scrollPredominantAxis",$[$.selectionClipboard=101]="selectionClipboard",$[$.selectionHighlight=102]="selectionHighlight",$[$.selectOnLineNumbers=103]="selectOnLineNumbers",$[$.showFoldingControls=104]="showFoldingControls",$[$.showUnused=105]="showUnused",$[$.snippetSuggestions=106]="snippetSuggestions",$[$.smartSelect=107]="smartSelect",$[$.smoothScrolling=108]="smoothScrolling",$[$.stickyScroll=109]="stickyScroll",$[$.stickyTabStops=110]="stickyTabStops",$[$.stopRenderingLineAfter=111]="stopRenderingLineAfter",$[$.suggest=112]="suggest",$[$.suggestFontSize=113]="suggestFontSize",$[$.suggestLineHeight=114]="suggestLineHeight",$[$.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",$[$.suggestSelection=116]="suggestSelection",$[$.tabCompletion=117]="tabCompletion",$[$.tabIndex=118]="tabIndex",$[$.unicodeHighlighting=119]="unicodeHighlighting",$[$.unusualLineTerminators=120]="unusualLineTerminators",$[$.useShadowDOM=121]="useShadowDOM",$[$.useTabStops=122]="useTabStops",$[$.wordBreak=123]="wordBreak",$[$.wordSeparators=124]="wordSeparators",$[$.wordWrap=125]="wordWrap",$[$.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",$[$.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",$[$.wordWrapColumn=128]="wordWrapColumn",$[$.wordWrapOverride1=129]="wordWrapOverride1",$[$.wordWrapOverride2=130]="wordWrapOverride2",$[$.wrappingIndent=131]="wrappingIndent",$[$.wrappingStrategy=132]="wrappingStrategy",$[$.showDeprecated=133]="showDeprecated",$[$.inlayHints=134]="inlayHints",$[$.editorClassName=135]="editorClassName",$[$.pixelRatio=136]="pixelRatio",$[$.tabFocusMode=137]="tabFocusMode",$[$.layoutInfo=138]="layoutInfo",$[$.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(184,null)})),acceptSuggestionOnEnter:Be(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(185,null),""],markdownDescription:o.localize(186,null)})),accessibilitySupport:Be(new c),accessibilityPageSize:Be(new b(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(187,null),tags:["accessibility"]})),ariaLabel:Be(new p(4,"ariaLabel",o.localize(188,null))),autoClosingBrackets:Be(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(189,null),o.localize(190,null),""],description:o.localize(191,null)})),autoClosingDelete:Be(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(192,null),""],description:o.localize(193,null)})),autoClosingOvertype:Be(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(194,null),""],description:o.localize(195,null)})),autoClosingQuotes:Be(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(196,null),o.localize(197,null),""],description:o.localize(198,null)})),autoIndent:Be(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[o.localize(199,null),o.localize(200,null),o.localize(201,null),o.localize(202,null),o.localize(203,null)],description:o.localize(204,null)})),automaticLayout:Be(new u(10,"automaticLayout",!1)),autoSurround:Be(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(205,null),o.localize(206,null),o.localize(207,null),""],description:o.localize(208,null)})),bracketPairColorization:Be(new de),bracketPairGuides:Be(new we),stickyTabStops:Be(new u(110,"stickyTabStops",!1,{description:o.localize(209,null)})),codeLens:Be(new u(14,"codeLens",!0,{description:o.localize(210,null)})),codeLensFontFamily:Be(new p(15,"codeLensFontFamily","",{description:o.localize(211,null)})),codeLensFontSize:Be(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(212,null)})),colorDecorators:Be(new u(17,"colorDecorators",!0,{description:o.localize(213,null)})),colorDecoratorsLimit:Be(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(214,null)})),columnSelection:Be(new u(19,"columnSelection",!1,{description:o.localize(215,null)})),comments:Be(new g),contextmenu:Be(new u(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new u(22,"copyWithSyntaxHighlighting",!0,{description:o.localize(216,null)})),cursorBlinking:Be(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:o.localize(217,null)})),cursorSmoothCaretAnimation:Be(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(218,null),o.localize(219,null),o.localize(220,null)],description:o.localize(221,null)})),cursorStyle:Be(new r(25,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:o.localize(222,null)})),cursorSurroundingLines:Be(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(223,null)})),cursorSurroundingLinesStyle:Be(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(224,null),o.localize(225,null)],description:o.localize(226,null)})),cursorWidth:Be(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(227,null)})),disableLayerHinting:Be(new u(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new u(30,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new u(31,"domReadOnly",!1)),dragAndDrop:Be(new u(32,"dragAndDrop",!0,{description:o.localize(228,null)})),emptySelectionClipboard:Be(new j),dropIntoEditor:Be(new nt),stickyScroll:Be(new ge),experimentalWhitespaceRendering:Be(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(229,null),o.localize(230,null),o.localize(231,null)],description:o.localize(232,null)})),extraEditorClassName:Be(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Be(new C(37,"fastScrollSensitivity",5,$=>$<=0?5:$,{markdownDescription:o.localize(233,null)})),find:Be(new V),fixedOverflowWidgets:Be(new u(39,"fixedOverflowWidgets",!1)),folding:Be(new u(40,"folding",!0,{description:o.localize(234,null)})),foldingStrategy:Be(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(235,null),o.localize(236,null)],description:o.localize(237,null)})),foldingHighlight:Be(new u(42,"foldingHighlight",!0,{description:o.localize(238,null)})),foldingImportsByDefault:Be(new u(43,"foldingImportsByDefault",!1,{description:o.localize(239,null)})),foldingMaximumRegions:Be(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(240,null)})),unfoldOnClickAfterEndOfLine:Be(new u(45,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(241,null)})),fontFamily:Be(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(242,null)})),fontInfo:Be(new U),fontLigatures2:Be(new Q),fontSize:Be(new T),fontWeight:Be(new F),fontVariations:Be(new q),formatOnPaste:Be(new u(52,"formatOnPaste",!1,{description:o.localize(243,null)})),formatOnType:Be(new u(53,"formatOnType",!1,{description:o.localize(244,null)})),glyphMargin:Be(new u(54,"glyphMargin",!0,{description:o.localize(245,null)})),gotoLocation:Be(new B),hideCursorInOverviewRuler:Be(new u(56,"hideCursorInOverviewRuler",!1,{description:o.localize(246,null)})),hover:Be(new Z),inDiffEditor:Be(new u(58,"inDiffEditor",!1)),letterSpacing:Be(new C(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,$=>C.clamp($,-5,20),{description:o.localize(247,null)})),lightbulb:Be(new ie),lineDecorationsWidth:Be(new J),lineHeight:Be(new ee),lineNumbers:Be(new ne),lineNumbersMinChars:Be(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new u(66,"linkedEditing",!1,{description:o.localize(248,null)})),links:Be(new u(67,"links",!0,{description:o.localize(249,null)})),matchBrackets:Be(new s(68,"matchBrackets","always",["always","near","never"],{description:o.localize(250,null)})),minimap:Be(new me),mouseStyle:Be(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new C(71,"mouseWheelScrollSensitivity",1,$=>$===0?1:$,{markdownDescription:o.localize(251,null)})),mouseWheelZoom:Be(new u(72,"mouseWheelZoom",!1,{markdownDescription:o.localize(252,null)})),multiCursorMergeOverlapping:Be(new u(73,"multiCursorMergeOverlapping",!0,{description:o.localize(253,null)})),multiCursorModifier:Be(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[o.localize(254,null),o.localize(255,null)],markdownDescription:o.localize(256,null)})),multiCursorPaste:Be(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(257,null),o.localize(258,null)],markdownDescription:o.localize(259,null)})),multiCursorLimit:Be(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(260,null)})),occurrencesHighlight:Be(new u(77,"occurrencesHighlight",!0,{description:o.localize(261,null)})),overviewRulerBorder:Be(new u(78,"overviewRulerBorder",!0,{description:o.localize(262,null)})),overviewRulerLanes:Be(new b(79,"overviewRulerLanes",3,0,3)),padding:Be(new Ie),parameterHints:Be(new Re),peekWidgetDefaultFocus:Be(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(263,null),o.localize(264,null)],description:o.localize(265,null)})),definitionLinkOpensInPeek:Be(new u(83,"definitionLinkOpensInPeek",!1,{description:o.localize(266,null)})),quickSuggestions:Be(new le),quickSuggestionsDelay:Be(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(267,null)})),readOnly:Be(new u(86,"readOnly",!1)),renameOnType:Be(new u(87,"renameOnType",!1,{description:o.localize(268,null),markdownDeprecationMessage:o.localize(269,null)})),renderControlCharacters:Be(new u(88,"renderControlCharacters",!0,{description:o.localize(270,null),restricted:!0})),renderFinalNewline:Be(new s(89,"renderFinalNewline",L.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(271,null)})),renderLineHighlight:Be(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(272,null)],description:o.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Be(new u(91,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(274,null)})),renderValidationDecorations:Be(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(275,null),o.localize(276,null),o.localize(277,null),""],description:o.localize(278,null)})),revealHorizontalRightPadding:Be(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new u(95,"roundedSelection",!0,{description:o.localize(279,null)})),rulers:Be(new oe),scrollbar:Be(new z),scrollBeyondLastColumn:Be(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(280,null)})),scrollBeyondLastLine:Be(new u(99,"scrollBeyondLastLine",!0,{description:o.localize(281,null)})),scrollPredominantAxis:Be(new u(100,"scrollPredominantAxis",!0,{description:o.localize(282,null)})),selectionClipboard:Be(new u(101,"selectionClipboard",!0,{description:o.localize(283,null),included:L.isLinux})),selectionHighlight:Be(new u(102,"selectionHighlight",!0,{description:o.localize(284,null)})),selectOnLineNumbers:Be(new u(103,"selectOnLineNumbers",!0)),showFoldingControls:Be(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(285,null),o.localize(286,null),o.localize(287,null)],description:o.localize(288,null)})),showUnused:Be(new u(105,"showUnused",!0,{description:o.localize(289,null)})),showDeprecated:Be(new u(133,"showDeprecated",!0,{description:o.localize(290,null)})),inlayHints:Be(new X),snippetSuggestions:Be(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(291,null),o.localize(292,null),o.localize(293,null),o.localize(294,null)],description:o.localize(295,null)})),smartSelect:Be(new Ce),smoothScrolling:Be(new u(108,"smoothScrolling",!1,{description:o.localize(296,null)})),stopRenderingLineAfter:Be(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new be),inlineSuggest:Be(new te),suggestFontSize:Be(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new u(115,"suggestOnTriggerCharacters",!0,{description:o.localize(299,null)})),suggestSelection:Be(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(300,null),o.localize(301,null),o.localize(302,null)],description:o.localize(303,null)})),tabCompletion:Be(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(304,null),o.localize(305,null),o.localize(306,null)],description:o.localize(307,null)})),tabIndex:Be(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new G),unusualLineTerminators:Be(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(308,null),o.localize(309,null),o.localize(310,null)],description:o.localize(311,null)})),useShadowDOM:Be(new u(121,"useShadowDOM",!0)),useTabStops:Be(new u(122,"useTabStops",!0,{description:o.localize(312,null)})),wordBreak:Be(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(313,null),o.localize(314,null)],description:o.localize(315,null)})),wordSeparators:Be(new p(124,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:o.localize(316,null)})),wordWrap:Be(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(317,null),o.localize(318,null),o.localize(319,null),o.localize(320,null)],description:o.localize(321,null)})),wordWrapBreakAfterCharacters:Be(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(322,null)})),wordWrapOverride1:Be(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new N),pixelRatio:Be(new ae),tabFocusMode:Be(new u(137,"tabFocusMode",!1,{markdownDescription:o.localize(323,null)})),layoutInfo:Be(new H),wrappingInfo:Be(new Ge),wrappingIndent:Be(new He),wrappingStrategy:Be(new Y)}}),define(ye[169],De([17,18]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[170],De([17,18]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[171],De([17,18]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[172],De([17,18]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[173],De([17,18]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(ye[174],De([17,18]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(ye[175],De([17,18]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[176],De([17,18]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(ye[177],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[178],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[179],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[180],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[181],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[182],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[183],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[184],De([17,18]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[185],De([17,18]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[186],De([17,18]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[187],De([17,18]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(ye[188],De([17,18]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(ye[189],De([17,18]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[190],De([17,18]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[191],De([17,18]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[192],De([17,18]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[193],De([17,18]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[194],De([17,18]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[195],De([17,18]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[196],De([17,18]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[197],De([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(L=e.TokenType||(e.TokenType={}));class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(S){if(S.type!==19)throw(0,o.illegalArgument)(`expected an error token but got ${JSON.stringify(S)}`);switch(S.lexeme){case"=":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '||'?`;default:{const A=S.lexeme;return A&&A.length>1&&A.startsWith("'")?`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you forget to close the string?`:A&&A.length>1&&A.endsWith("'")?`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you forget to open the string?`:`Unexpected token '${S.lexeme}' at offset ${S.offset}`}}}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,o.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(){const S={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(S),this.f.push(S)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const A=this.c.substring(this.d,this.e),y=l.b.get(A);y?this.k(y):this.f.push({type:17,lexeme:A,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,A=!1,y=!1;for(;;){if(S>=this.c.length){this.e=S,this.l();return}const O=this.c.charCodeAt(S);if(A)A=!1;else if(O===47&&!y){S++;break}else O===91?y=!0:O===92?A=!0:O===93&&(y=!1);S++}for(;S<this.c.length&&l.a.has(this.c.charCodeAt(S));)S++;this.e=S;const I=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:I,offset:this.d})}r(){return this.e>=this.c.length}}l.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0))),l.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=l}),define(ye[198],De([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class L{constructor(){this.a=new Map}register(R,S){this.a.set(R,S)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const S in R.contributes){const A=this.a.get(S);if(!A)continue;const y=R.contributes[S],I=Array.isArray(y)?y:[y];try{A(I,R.activationEvents)}catch(O){(0,o.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=L,e.ImplicitActivationEvents=new L}),define(ye[199],De([1,0,24,37,171,320]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(u){return u=u.trim(),u==="*"||S.test(u)}e.isValidVersionStr=y;function I(u){if(!y(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=u.match(S);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=I;function O(u){if(!u)return null;const m=u.majorBase,b=u.majorMustEqual,C=u.minorBase;let p=u.minorMustEqual;const n=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(m===0||(p=!1),s=!1);let r=0;if(u.preRelease){const a=A.exec(u.preRelease);if(a){const[,c,g,i]=a;r=Date.UTC(Number(c),Number(g)-1,Number(i))}}return{majorBase:m,majorMustEqual:b,minorBase:C,minorMustEqual:p,patchBase:n,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function P(u,m,b){let C;typeof u=="string"?C=O(I(u)):C=u;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let n;if(typeof b=="string"?n=O(I(b)):n=b,!C||!n)return!1;const s=C.majorBase,r=C.minorBase,a=C.patchBase;let c=n.majorBase,g=n.minorBase,i=n.patchBase;const t=n.notBefore;let h=n.majorMustEqual,E=n.minorMustEqual,w=n.patchMustEqual;return n.isMinimum?s>c?!0:s<c?!1:r>g?!0:r<g||p&&p<t?!1:a>=i:(s===1&&c===0&&(!h||!E||!w)&&(c=1,g=0,i=0,h=!0,E=!1,w=!1),s<c?!1:s>c?!h:r<g?!1:r>g?!E:a<i?!1:a>i?!w:!(p&&p<t))}e.isValidVersion=P;function v(u,m,b,C,p){const n=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return n.push([L.default.Error,l.localize(0,null)]),n;if(typeof C.name!="string")return n.push([L.default.Error,l.localize(1,null,"name")]),n;if(typeof C.version!="string")return n.push([L.default.Error,l.localize(2,null,"version")]),n;if(!C.engines)return n.push([L.default.Error,l.localize(3,null,"engines")]),n;if(typeof C.engines.vscode!="string")return n.push([L.default.Error,l.localize(4,null,"engines.vscode")]),n;if(typeof C.extensionDependencies<"u"&&!d(C.extensionDependencies))return n.push([L.default.Error,l.localize(5,null,"extensionDependencies")]),n;if(typeof C.activationEvents<"u"){if(!d(C.activationEvents))return n.push([L.default.Error,l.localize(6,null,"activationEvents")]),n;if(typeof C.main>"u"&&typeof C.browser>"u")return n.push([L.default.Error,l.localize(7,null,"activationEvents","main")]),n}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&n.push([L.default.Warning,l.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return n.push([L.default.Error,l.localize(9,null,"main")]),n;{const a=(0,o.joinPath)(b,C.main);(0,o.isEqualOrParent)(a,b)||n.push([L.default.Warning,l.localize(10,null,a.path,b.path)])}if(typeof C.activationEvents>"u")return n.push([L.default.Error,l.localize(11,null,"activationEvents","main")]),n}if(typeof C.browser<"u"){if(typeof C.browser!="string")return n.push([L.default.Error,l.localize(12,null,"browser")]),n;{const a=(0,o.joinPath)(b,C.browser);(0,o.isEqualOrParent)(a,b)||n.push([L.default.Warning,l.localize(13,null,a.path,b.path)])}if(typeof C.activationEvents>"u")return n.push([L.default.Error,l.localize(14,null,"activationEvents","browser")]),n}if(!R.valid(C.version))return n.push([L.default.Error,l.localize(15,null)]),n;const s=[];if(!k(u,m,C,p,s))for(const a of s)n.push([L.default.Error,a]);return n}e.validateExtensionManifest=v;function k(u,m,b,C,p){return C||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(u,m,b.engines.vscode,p)}e.isValidExtensionVersion=k;function D(u,m,b){return u==="*"||f(m,b,u)}e.isEngineValid=D;function f(u,m,b,C=[]){const p=O(I(b));if(!p)return C.push(l.localize(16,null,b)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return C.push(l.localize(17,null,b)),!1}else if(!p.majorMustEqual)return C.push(l.localize(18,null,b)),!1;return P(u,m,p)?!0:(C.push(l.localize(19,null,u,b)),!1)}function d(u){if(!Array.isArray(u))return!1;for(let m=0,b=u.length;m<b;m++)if(typeof u[m]!="string")return!1;return!0}}),define(ye[122],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(l,R=[],S=!1){this.ctor=l,this.staticArguments=R,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=o}),define(ye[90],De([1,0,122]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var l;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function R(A,y,I){y instanceof o.SyncDescriptor||(y=new o.SyncDescriptor(y,[],Boolean(I))),L.push([A,y])}e.registerSingleton=R;function S(){return L}e.getSingletonServiceDescriptors=S}),define(ye[200],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(R,S){this.key=R,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class L{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const S of this.a.values())S.outgoing.size===0&&R.push(S);return R}insertEdge(R,S){const A=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(S);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(R){const S=this.b(R);this.a.delete(S);for(const A of this.a.values())A.outgoing.delete(S),A.incoming.delete(S)}lookupOrInsertNode(R){const S=this.b(R);let A=this.a.get(S);return A||(A=new o(S,R),this.a.set(S,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[S,A]of this.a)R.push(`${S}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,S]of this.a){const A=new Set([R]),y=this.c(S,A);if(y)return y}}c(R,S){for(const[A,y]of R.outgoing){if(S.has(A))return[...S,A].join(" -> ");S.add(A);const I=this.c(y,S);if(I)return I;S.delete(A)}}}e.Graph=L}),define(ye[4],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=A})(o=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function L(S,A,y){A[o.DI_TARGET]===A?A[o.DI_DEPENDENCIES].push({id:S,index:y}):(A[o.DI_DEPENDENCIES]=[{id:S,index:y}],A[o.DI_TARGET]=A)}function l(S){if(o.serviceIds.has(S))return o.serviceIds.get(S);const A=function(y,I,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(A,y,O)};return A.toString=()=>S,o.serviceIds.set(S,A),A}e.createDecorator=l;function R(S){return S}e.refineServiceDecorator=R}),define(ye[53],De([1,0,9,2,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof L.URI)}e.isConfigurationOverrides=R;function S(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=S;var A;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function I(d,u){const m=Object.create(null);for(const b in d)O(m,b,d[b],u);return m}e.toValuesTree=I;function O(d,u,m,b){const C=u.split("."),p=C.pop();let n=d;for(let s=0;s<C.length;s++){const r=C[s];let a=n[r];switch(typeof a){case"undefined":a=n[r]=Object.create(null);break;case"object":break;default:b(`Ignoring ${u} as ${C.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}n=a}if(typeof n=="object"&&n!==null)try{n[p]=m}catch{b(`Ignoring ${u} as ${C.join(".")} is ${JSON.stringify(n)}`)}else b(`Ignoring ${u} as ${C.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=O;function P(d,u){const m=u.split(".");v(d,m)}e.removeFromValueTree=P;function v(d,u){const m=u.shift();if(u.length===0){delete d[m];return}if(Object.keys(d).indexOf(m)!==-1){const b=d[m];typeof b=="object"&&!Array.isArray(b)&&(v(b,u),Object.keys(b).length===0&&delete d[m])}}function k(d,u,m){function b(n,s){let r=n;for(const a of s){if(typeof r!="object"||r===null)return;r=r[a]}return r}const C=u.split("."),p=b(d,C);return typeof p>"u"?m:p}e.getConfigurationValue=k;function D(d,u,m){Object.keys(u).forEach(b=>{b!=="__proto__"&&(b in d?o.isObject(d[b])&&o.isObject(u[b])?D(d[b],u[b],m):m&&(d[b]=u[b]):d[b]=u[b])})}e.merge=D;function f(d){return d.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ye[54],De([1,0,11,8,197,4]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",o.isMacintosh),S.set("isLinux",o.isLinux),S.set("isWindows",o.isWindows),S.set("isWeb",o.isWeb),S.set("isMacNative",o.isMacintosh&&!o.isWeb),S.set("isEdge",o.isEdge),S.set("isFirefox",o.isFirefox),S.set("isChrome",o.isChrome),S.set("isSafari",o.isSafari);const A=Object.prototype.hasOwnProperty;var y;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return D.INSTANCE}static true(){return f.INSTANCE}static has(T){return d.create(T)}static equals(T,F){return u.create(T,F)}static notEquals(T,F){return C.create(T,F)}static regex(T,F){return g.create(T,F)}static in(T,F){return m.create(T,F)}static notIn(T,F){return b.create(T,F)}static not(T){return p.create(T)}static and(...T){return h.create(T,null,!0)}static or(...T){return E.create(T,null,!0)}static greater(T,F){return s.create(T,F)}static greaterEquals(T,F){return r.create(T,F)}static smaller(T,F){return a.create(T,F)}static smallerEquals(T,F){return c.create(T,F)}static deserializeOrErrorNew(T){if(!T)return{type:"error",lexingErrors:[],parsingErrors:[]};const F=new P,B=F.parse(T);return B===void 0?{type:"error",lexingErrors:F.lexingErrors.map(Z=>l.Scanner.reportError(Z)),parsingErrors:F.parsingErrors}:{type:"ok",expr:B}}static deserialize(T){if(!!T)return this.c(T)}static c(T){const F=T.split("||");return E.create(F.map(B=>this.d(B)),null,!0)}static d(T){const F=T.split("&&");return h.create(F.map(B=>this.f(B)),null,!0)}static f(T){if(T=T.trim(),T.indexOf("!=")>=0){const F=T.split("!=");return C.create(F[0].trim(),this.g(F[1]))}if(T.indexOf("==")>=0){const F=T.split("==");return u.create(F[0].trim(),this.g(F[1]))}if(T.indexOf("=~")>=0){const F=T.split("=~");return g.create(F[0].trim(),this.h(F[1]))}if(T.indexOf(" not in ")>=0){const F=T.split(" not in ");return b.create(F[0].trim(),this.g(F[1]))}if(T.indexOf(" in ")>=0){const F=T.split(" in ");return m.create(F[0].trim(),this.g(F[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const F=T.split(">=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const F=T.split(">");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const F=T.split("<=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const F=T.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(T)?p.create(T.substr(1).trim()):d.create(T)}static g(T){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const F=/^'([^']*)'$/.exec(T);return F?F[1].trim():T}static h(T){if((0,L.isFalsyOrWhitespace)(T))return null;const F=T.indexOf("/"),B=T.lastIndexOf("/");if(F===B||F<0)return null;const Z=T.slice(F+1,B),_=T[B+1]==="i"?"i":"";try{return new RegExp(Z,_)}catch{return null}}}e.ContextKeyExpr=I;class O extends Error{}class P{constructor(){this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(T){if(T===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(T).scan(),this.f=0,this.g=[];try{const F=this.h();if(!this.D())throw this.z(this.C());return F}catch(F){if(!(F instanceof O)){const B=this.C();this.g.push(`Unexpected error: ${F} for token ${l.Scanner.getLexeme(B)} at offset ${B.offset}.`)}return}}h(){return this.k()}k(){const T=[this.l()];for(;this.v(16);){const F=this.l();T.push(F)}return T.length===1?T[0]:I.or(...T)}l(){const T=[this.o()];for(;this.v(15);){const F=this.o();T.push(F)}return T.length===1?T[0]:I.and(...T)}o(){if(this.v(2)){const T=this.C();switch(T.type){case 17:return this.w(),I.not(T.lexeme);case 11:return this.w(),I.false();case 12:return this.w(),I.true();default:throw this.y("KEY, 'true', or 'false'",T)}}return this.s()}s(){const T=this.C();switch(T.type){case 11:return this.w(),I.true();case 12:return this.w(),I.false();case 0:{this.w();const F=this.h();return this.x(1,"')'"),F}case 17:{const F=T.lexeme;if(this.w(),this.v(9)){const Z=this.C();switch(Z.type){case 10:case 19:{const _=[Z.lexeme];this.w();let H=this.C(),Y=0;for(let ee=0;ee<Z.lexeme.length;ee++)Z.lexeme.charCodeAt(ee)===40?Y++:Z.lexeme.charCodeAt(ee)===41&&Y--;for(;!this.D()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let ee=0;ee<H.lexeme.length;ee++)H.lexeme.charCodeAt(ee)===40?Y++:Z.lexeme.charCodeAt(ee)===41&&Y--}if(Y<0)break;_.push(l.Scanner.getLexeme(H)),this.w(),H=this.C()}const ie=_.join(""),ge=ie.lastIndexOf("/"),X=ge===ie.length-1?void 0:ie.substring(ge+1),J=new RegExp(ie.substring(1,ge),X);return I.regex(F,J)}case 18:{const _=Z.lexeme;this.w();let H=null;if(!(0,L.isFalsyOrWhitespace)(_)){const Y=_.indexOf("/"),ie=_.lastIndexOf("/");if(Y!==ie&&Y>=0){const ge=_.slice(Y+1,ie),X=_[ie+1]==="i"?"i":"";try{H=new RegExp(ge,X)}catch{}}}if(H===null)throw this.y("REGEX",Z);return g.create(F,H)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const Z=this.t();return I.notIn(F,Z)}switch(this.C().type){case 3:{this.w();const Z=this.t();switch(Z){case"true":return I.has(F);case"false":return I.not(F);default:return I.equals(F,Z)}}case 4:{this.w();const Z=this.t();switch(Z){case"true":return I.not(F);case"false":return I.has(F);default:return I.notEquals(F,Z)}}case 5:return this.w(),a.create(F,this.t());case 6:return this.w(),c.create(F,this.t());case 7:return this.w(),s.create(F,this.t());case 8:return this.w(),r.create(F,this.t());case 13:return this.w(),I.in(F,this.t());default:return I.has(F)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const T=this.C();switch(T.type){case 17:case 18:return this.w(),T.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(T){return this.B(T)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(T,F){if(this.B(T))return this.w();throw this.y(F,this.C())}y(T,F){return this.A(`Expected ${T} but got '${l.Scanner.getLexeme(F)}' at offset ${F.offset}.`)}z(T){return this.A(`Unexpected '${l.Scanner.getLexeme(T)}' at offset ${T.offset}.`)}A(T){return this.g.push(T),new O}B(T){return this.C().type===T}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=P;function v(U,T){const F=U?U.substituteConstants():void 0,B=T?T.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}e.expressionsAreEqualWithConstantSubstitution=v;function k(U,T){return U.cmp(T)}class D{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return f.INSTANCE}}D.INSTANCE=new D,e.ContextKeyFalseExpr=D;class f{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return D.INSTANCE}}f.INSTANCE=new f,e.ContextKeyTrueExpr=f;class d{static create(T,F=null){const B=S.get(T);return typeof B=="boolean"?B?f.INSTANCE:D.INSTANCE:new d(T,F)}constructor(T,F){this.key=T,this.c=F,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:N(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=S.get(this.key);return typeof T=="boolean"?T?f.INSTANCE:D.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=d;class u{static create(T,F,B=null){if(typeof F=="boolean")return F?d.create(T,B):p.create(T,B);const Z=S.get(T);return typeof Z=="boolean"?F===(Z?"true":"false")?f.INSTANCE:D.INSTANCE:new u(T,F,B)}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=S.get(this.c);if(typeof T=="boolean"){const F=T?"true":"false";return this.d===F?f.INSTANCE:D.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class m{static create(T,F){return new m(T,F)}constructor(T,F){this.d=T,this.f=F,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:j(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.f),B=T.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?A.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class b{static create(T,F){return new b(T,F)}constructor(T,F){this.d=T,this.f=F,this.type=11,this.c=m.create(T,F)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class C{static create(T,F,B=null){if(typeof F=="boolean")return F?p.create(T,B):d.create(T,B);const Z=S.get(T);return typeof Z=="boolean"?F===(Z?"true":"false")?D.INSTANCE:f.INSTANCE:new C(T,F,B)}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=S.get(this.c);if(typeof T=="boolean"){const F=T?"true":"false";return this.d===F?D.INSTANCE:f.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=C;class p{static create(T,F=null){const B=S.get(T);return typeof B=="boolean"?B?D.INSTANCE:f.INSTANCE:new p(T,F)}constructor(T,F){this.c=T,this.d=F,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:N(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=S.get(this.c);return typeof T=="boolean"?T?D.INSTANCE:f.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function n(U,T){if(typeof U=="string"){const F=parseFloat(U);isNaN(F)||(U=F)}return typeof U=="string"||typeof U=="number"?T(U):D.INSTANCE}class s{static create(T,F,B=null){return n(F,Z=>new s(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=s;class r{static create(T,F,B=null){return n(F,Z=>new r(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=a.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=r;class a{static create(T,F,B=null){return n(F,Z=>new a(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=a;class c{static create(T,F,B=null){return n(F,Z=>new c(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=c;class g{static create(T,F){return new g(T,F)}constructor(T,F){this.d=T,this.f=F,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const F=this.f?this.f.source:"",B=T.f?T.f.source:"";return F<B?-1:F>B?1:0}equals(T){if(T.type===this.type){const F=this.f?this.f.source:"",B=T.f?T.f.source:"";return this.d===T.d&&F===B}return!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=i.create(this)),this.c}}e.ContextKeyRegexExpr=g;class i{static create(T){return new i(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(T){return new i(this.c.map(T))}negate(){return this.c}}e.ContextKeyNotRegexExpr=i;function t(U){let T=null;for(let F=0,B=U.length;F<B;F++){const Z=U[F].substituteConstants();if(U[F]!==Z&&T===null){T=[];for(let _=0;_<F;_++)T[_]=U[_]}T!==null&&(T[F]=Z)}return T===null?U:T}class h{static create(T,F,B){return h.d(T,F,B)}constructor(T,F){this.expr=T,this.c=F,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Z=k(this.expr[F],T.expr[F]);if(Z!==0)return Z}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=t(this.expr);return T===this.expr?this:h.create(T,this.c,!1)}evaluate(T){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(T))return!1;return!0}static d(T,F,B){const Z=[];let _=!1;for(const H of T)if(!!H){if(H.type===1){_=!0;continue}if(H.type===0)return D.INSTANCE;if(H.type===6){Z.push(...H.expr);continue}Z.push(H)}if(Z.length===0&&_)return f.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(k);for(let H=1;H<Z.length;H++)Z[H-1].equals(Z[H])&&(Z.splice(H,1),H--);if(Z.length===1)return Z[0];for(;Z.length>1;){const H=Z[Z.length-1];if(H.type!==9)break;Z.pop();const Y=Z.pop(),ie=Z.length===0,ge=E.create(H.expr.map(X=>h.create([X,Y],null,B)),null,ie);ge&&(Z.push(ge),Z.sort(k))}if(Z.length===1)return Z[0];if(B){for(let H=0;H<Z.length;H++)for(let Y=H+1;Y<Z.length;Y++)if(Z[H].negate().equals(Z[Y]))return D.INSTANCE;if(Z.length===1)return Z[0]}return new h(Z,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new h(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.c){const T=[];for(const F of this.expr)T.push(F.negate());this.c=E.create(T,this,!0)}return this.c}}class E{static create(T,F,B){return E.d(T,F,B)}constructor(T,F){this.expr=T,this.c=F,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Z=k(this.expr[F],T.expr[F]);if(Z!==0)return Z}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=t(this.expr);return T===this.expr?this:E.create(T,this.c,!1)}evaluate(T){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(T))return!0;return!1}static d(T,F,B){let Z=[],_=!1;if(T){for(let H=0,Y=T.length;H<Y;H++){const ie=T[H];if(!!ie){if(ie.type===0){_=!0;continue}if(ie.type===1)return f.INSTANCE;if(ie.type===9){Z=Z.concat(ie.expr);continue}Z.push(ie)}}if(Z.length===0&&_)return D.INSTANCE;Z.sort(k)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let H=1;H<Z.length;H++)Z[H-1].equals(Z[H])&&(Z.splice(H,1),H--);if(Z.length===1)return Z[0];if(B){for(let H=0;H<Z.length;H++)for(let Y=H+1;Y<Z.length;Y++)if(Z[H].negate().equals(Z[Y]))return f.INSTANCE;if(Z.length===1)return Z[0]}return new E(Z,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new E(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.c){const T=[];for(const F of this.expr)T.push(F.negate());for(;T.length>1;){const F=T.shift(),B=T.shift(),Z=[];for(const _ of q(F))for(const H of q(B))Z.push(h.create([_,H],null,!1));T.unshift(E.create(Z,null,!1))}this.c=E.create(T,this,!0)}return this.c}}class w extends d{static all(){return w.d.values()}constructor(T,F,B){super(T,null),this.f=F,typeof B=="object"?w.d.push({...B,key:T}):B!==!0&&w.d.push({key:T,description:B,type:F!=null?typeof F:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return u.create(this.key,T)}notEqualsTo(T){return C.create(this.key,T)}}w.d=[],e.RawContextKey=w,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function N(U,T){return U<T?-1:U>T?1:0}function j(U,T,F,B){return U<F?-1:U>F?1:T<B?-1:T>B?1:0}function V(U,T){if(U.type===0||T.type===1)return!0;if(U.type===9)return T.type===9?Q(U.expr,T.expr):!1;if(T.type===9){for(const F of T.expr)if(V(U,F))return!0;return!1}if(U.type===6){if(T.type===6)return Q(T.expr,U.expr);for(const F of U.expr)if(V(F,T))return!0;return!1}return U.equals(T)}e.implies=V;function Q(U,T){let F=0,B=0;for(;F<U.length&&B<T.length;){const Z=U[F].cmp(T[B]);if(Z<0)return!1;Z===0&&F++,B++}return F===U.length}function q(U){return U.type===9?U.expr:[U]}}),define(ye[201],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],De([1,0,170,4]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function S(u,m){switch(u){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function A(u,m){return m==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(u,m,b){return A(m,b)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===b?!0:I(b).includes(u)}e.isTargetPlatformCompatible=y;function I(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function O(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=O;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var k;(function(u){u.Install="install",u.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var D;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var f;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(m,b){super(m),this.code=b,this.name=b}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,o.localize)(1,null),original:"Preferences"}}),define(ye[202],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(ye[203],De([1,0,46,16,12,11,109,29,116,172,202]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=I.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends v{openTerminal(C,p){return this.spawnTerminal(o,C,y.getWindowsShell(),p)}spawnTerminal(C,p,n,s){const r=p.windowsExec||k.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=l.basename(r,".exe").toLowerCase();if(a==="cmder")return C.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return r.indexOf(" ")>=0&&c.push('""'),c.push(r),a==="wt"&&c.push("-d ."),new Promise((g,i)=>{const t=d(process),h=C.spawn(n,c,{cwd:s,env:t});h.on("error",i),h.on("exit",()=>g())})}runInTerminal(C,p,n,s,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:k.getDefaultTerminalWindows();return new Promise((c,g)=>{const i=`"${p} - ${P}"`,t=`""${n.join('" "')}" & pause"`,h=Object.assign({},d(process),s);Object.keys(h).filter(V=>h[V]===null).forEach(V=>delete h[V]);const E={cwd:p,env:h,windowsVerbatimArguments:!0};let w,N;l.basename(a,".exe")==="wt"?(w=a,N=["-d",".",k.b,"/c",t]):(w=k.b,N=["/c","start",i,"/wait",a,"/c",t]),o.spawn(w,N,E).on("error",V=>{g(u(V))}),c(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const C=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${C?"Sysnative":"System32"}\\cmd.exe`}return k.d}}k.b="cmd.exe",e.WindowsExternalTerminalService=k;class D extends v{openTerminal(C,p){return this.spawnTerminal(o,C,p)}runInTerminal(C,p,n,s,r){const a=r.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((c,g)=>{if(a===O.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const i=a===O.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",h=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${i}.scpt`).fsPath,"-t",C||P,"-w",p];for(const N of n)h.push("-a"),h.push(N);if(s){const N=Object.assign({},d(process),s);for(const j in N){const V=N[j];V===null?(h.push("-u"),h.push(j)):(h.push("-e"),h.push(`${j}=${V}`))}}let E="";const w=o.spawn(D.b,h);w.on("error",N=>{g(u(N))}),w.stderr.on("data",N=>{E+=N.toString()}),w.on("exit",N=>{if(N===0)c(void 0);else if(E){const j=E.split(`
`,1);g(new Error(j[0]))}else g(new Error(I.localize(1,null,i,N)))})}else g(new Error(I.localize(2,null,a)))})}spawnTerminal(C,p,n){const s=p.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const c=["-a",s];n&&c.push(n);const g=d(process),i=C.spawn("/usr/bin/open",c,{cwd:n,env:g});i.on("error",a),i.on("exit",()=>r())})}}D.b="/usr/bin/osascript",e.MacExternalTerminalService=D;class f extends v{openTerminal(C,p){return this.spawnTerminal(o,C,p)}runInTerminal(C,p,n,s,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,g)=>{const i=[];a.then(t=>{t.indexOf("gnome-terminal")>=0?i.push("-x"):i.push("-e"),i.push("bash"),i.push("-c");const h=`${m(n)}; echo; read -p "${f.b}" -n1;`;i.push(`''${h}''`);const E=Object.assign({},d(process),s);Object.keys(E).filter(V=>E[V]===null).forEach(V=>delete E[V]);const w={cwd:p,env:E};let N="";const j=o.spawn(t,i,w);j.on("error",V=>{g(u(V))}),j.stderr.on("data",V=>{N+=V.toString()}),j.on("exit",V=>{if(V===0)c(void 0);else if(N){const Q=N.split(`
`,1);g(new Error(Q[0]))}else g(new Error(I.localize(4,null,t,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.isLinux)f.d=Promise.resolve("xterm");else{const C=await A.Promises.exists("/etc/debian_version");f.d=new Promise(p=>{C?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return f.d}spawnTerminal(C,p,n){const s=p.linuxExec?Promise.resolve(p.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{s.then(c=>{const g=d(process),i=C.spawn(c,[],{cwd:n,env:g});i.on("error",a),i.on("exit",()=>r())})})}}f.b=I.localize(3,null),e.LinuxExternalTerminalService=f;function d(b){const C={...b.env};return(0,S.sanitizeProcessEnvironment)(C),C}function u(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function m(b){let C="";for(const p of b)p.indexOf(" ")>=0?C+='"'+p+'"':C+=p,C+=" ";return C}}),define(ye[44],De([1,0,68,12,8,9,2,173,4,11,16]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(H){return H.create===!0}e.isFileOpenForWriteOptions=P;var v;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var k;(function(H){H[H.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var D;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(D=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=f;function d(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=d;function u(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=u;function m(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function b(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=b;function C(H){return f(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;var p;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class n extends Error{static create(Y,ie){const ge=new n(Y.toString(),ie);return a(ge,ie),ge}constructor(Y,ie){super(Y),this.code=ie}}e.FileSystemProviderError=n;function s(H,Y){return n.create(H,Y)}e.createFileSystemProviderError=s;function r(H){return H||s((0,A.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=r;function a(H,Y){return H.name=Y?`${Y} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=a;function c(H){if(!H)return p.Unknown;if(H instanceof n)return H.code;const Y=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Y)return p.Unknown;switch(Y[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=c;function g(H){if(H instanceof N)return H.fileOperationResult;switch(c(H)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=g;var i;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(Y,ie,ge){this.resource=Y,this.operation=ie,this.target=ge}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=t;var h;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(h=e.FileChangeType||(e.FileChangeType={}));class E{constructor(Y,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ge=new Map;for(const X of Y){const J=ge.get(X.type);switch(J?J.push([X.resource,X]):ge.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,J]of ge)switch(X){case 1:this.a=o.TernarySearchTree.forUris(()=>ie),this.a.fill(J);break;case 0:this.b=o.TernarySearchTree.forUris(()=>ie),this.b.fill(J);break;case 2:this.c=o.TernarySearchTree.forUris(()=>ie),this.c.fill(J);break}}contains(Y,...ie){return this.d(Y,{includeChildren:!1},...ie)}affects(Y,...ie){return this.d(Y,{includeChildren:!0},...ie)}d(Y,ie,...ge){if(!Y)return!1;const X=ge.length>0;return!!((!X||ge.includes(1))&&(this.a?.get(Y)||ie.includeChildren&&this.a?.findSuperstr(Y))||(!X||ge.includes(0))&&(this.b?.get(Y)||ie.includeChildren&&this.b?.findSuperstr(Y))||(!X||ge.includes(2))&&(this.c?.findSubstr(Y)||ie.includeChildren&&this.c?.findSuperstr(Y)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=E;function w(H,Y,ie){return!H||!Y||H===Y||Y.length>H.length?!1:(Y.charAt(Y.length-1)!==L.sep&&(Y+=L.sep),ie?(0,l.startsWithIgnoreCase)(H,Y):H.indexOf(Y)===0)}e.isParent=w;class N extends Error{constructor(Y,ie,ge){super(Y),this.fileOperationResult=ie,this.options=ge}}e.FileOperationError=N;class j extends N{constructor(Y,ie,ge,X){super(Y,ie,X),this.fileOperationResult=ie,this.size=ge}}e.TooLargeFileOperationError=j;class V extends N{constructor(Y,ie,ge){super(Y,2,ge),this.stat=ie}}e.NotModifiedSinceFileOperationError=V;var Q;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var q;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(q=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=U;async function T(H,Y){if(!Y.hasProvider(S.URI.from({scheme:H.scheme})))return new Promise(ie=>{const ge=Y.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===H.scheme&&X.added&&(ge.dispose(),ie())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(Y){return(0,R.isNumber)(Y)||(Y=0),Y<F.KB?(0,A.localize)(1,null,Y.toFixed(0)):Y<F.MB?(0,A.localize)(2,null,(Y/F.KB).toFixed(2)):Y<F.GB?(0,A.localize)(3,null,(Y/F.MB).toFixed(2)):Y<F.TB?(0,A.localize)(4,null,(Y/F.GB).toFixed(2)):(0,A.localize)(5,null,(Y/F.TB).toFixed(2))}}F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB,e.ByteSize=F;var B;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function Z(H){return{maxFileSize:H===0?300*F.MB:16*F.GB,maxHeapSize:H===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=Z;function _(H){const Y=typeof H=="string"||H?.scheme===O.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===O.Schemas.file?1024*F.MB:Y?10*F.MB:I.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=_}),define(ye[91],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...l){this.a=new Map;for(const[R,S]of l)this.set(R,S)}set(l,R){const S=this.a.get(l);return this.a.set(l,R),S}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=o}),define(ye[204],De([1,0,19,10,6,122,200,4,91,66]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class P extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new y.ServiceCollection,u=!1,m,b=O){this.f=d,this.g=u,this.h=m,this.i=b,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=b?m?._globalGraph??new S.Graph(C=>C):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...u){const m=D.traceInvocation(this.i,d);let b=!1;try{return d({get:p=>{if(b)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(p,m);if(!n)throw new Error(`[invokeFunction] unknown service '${p}'`);return n}},...u)}finally{b=!0,m.stop()}}createInstance(d,...u){let m,b;return d instanceof R.SyncDescriptor?(m=D.traceCreation(this.i,d.ctor),b=this.j(d.ctor,d.staticArguments.concat(u),m)):(m=D.traceCreation(this.i,d),b=this.j(d,u,m)),m.stop(),b}j(d,u=[],m){const b=A._util.getServiceDependencies(d).sort((n,s)=>n.index-s.index),C=[];for(const n of b){const s=this.m(n.id,m);s||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${n.id}.`,!1),C.push(s)}const p=b.length>0?b[0].index:u.length;if(u.length!==p){console.trace(`[createInstance] First service dependency of ${d.name} at position ${p+1} conflicts with ${u.length} static arguments`);const n=p-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,p)}return Reflect.construct(d,u.concat(C))}k(d,u){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,u);else if(this.h)this.h.k(d,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const u=this.f.get(d);return!u&&this.h?this.h.l(d):u}m(d,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const m=this.l(d);return m instanceof R.SyncDescriptor?this.q(d,m,u.branch(d,!0)):(u.branch(d,!1),m)}q(d,u,m){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,u,m)}finally{this.o.delete(d)}}r(d,u,m){const b=new S.Graph(n=>n.id.toString());let C=0;const p=[{id:d,desc:u,_trace:m}];for(;p.length;){const n=p.pop();if(b.lookupOrInsertNode(n),C++>1e3)throw new P(b);for(const s of A._util.getServiceDependencies(n.desc.ctor)){const r=this.l(s.id);if(r||this.u(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),r instanceof R.SyncDescriptor){const a={id:s.id,desc:r,_trace:n._trace.branch(s.id,!0)};b.insertEdge(n,a),p.push(a)}}}for(;;){const n=b.roots();if(n.length===0){if(!b.isEmpty())throw new P(b);break}for(const{data:s}of n){if(this.l(s.id)instanceof R.SyncDescriptor){const a=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,a)}b.removeNode(s)}}return this.l(d)}s(d,u,m=[],b,C){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,u,m,b,C);if(this.h)return this.h.s(d,u,m,b,C);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(d,u,m=[],b,C){if(b){const p=new v(void 0,this.g,this,this.i);p.c=String(d);const n=new Map,s=new o.IdleValue(()=>{const r=p.j(u,m,C);for(const[a,c]of n){const g=r[a];if(typeof g=="function")for(const i of c)g.apply(r,i)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let i=n.get(a);return i||(i=new I.LinkedList,n.set(a,i)),(h,E,w)=>{const N=i.push([h,E,w]);return(0,l.toDisposable)(N)}}if(a in r)return r[a];const c=s.value;let g=c[a];return typeof g!="function"||(g=g.bind(c),r[a]=g),g},set(r,a,c){return s.value[a]=c,!0},getPrototypeOf(r){return u.prototype}})}else return this.j(u,m,C)}u(d,u){if(u&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var k;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(k||(k={}));class D{static traceInvocation(d,u){return d?new D(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(d,u){return d?new D(1,u.name):D.c}constructor(d,u){this.type=d,this.name=u,this.g=Date.now(),this.h=[]}branch(d,u){const m=new D(3,d.toString());return this.h.push([d,u,m]),m}stop(){const d=Date.now()-this.g;D.f+=d;let u=!1;function m(C,p){const n=[],s=new Array(C+1).join("	");for(const[r,a,c]of p.h)if(a&&c){u=!0,n.push(`${s}CREATES -> ${r}`);const g=m(C+1,c);g&&n.push(g)}else n.push(`${s}uses -> ${r}`);return n.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(d>2||u)&&D.all.add(b.join(`
`))}}D.all=new Set,D.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}},D.f=0,e.Trace=D}),define(ye[13],De([1,0,45,3,6,28,11,9,2,4]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function O(){return new Date().toISOString()}function P(i){return(0,A.isNumber)(i)}e.isLogLevel=P;var v;(function(i){i[i.Off=0]="Off",i[i.Trace=1]="Trace",i[i.Debug=2]="Debug",i[i.Info=3]="Info",i[i.Warning=4]="Warning",i[i.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function k(i,t,h){switch(t){case v.Trace:i.trace(h);break;case v.Debug:i.debug(h);break;case v.Info:i.info(h);break;case v.Warning:i.warn(h);break;case v.Error:i.error(h);break;case v.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=k;function D(i){let t="";for(let h=0;h<i.length;h++){let E=i[h];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}t+=(h>0?" ":"")+E}return t}e.format=D;class f extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==v.Off&&this.b<=t}}e.AbstractLogger=f;class d extends f{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...h){this.f(v.Trace)&&this.g(v.Trace,D([t,...h]))}debug(t,...h){this.f(v.Debug)&&this.g(v.Debug,D([t,...h]))}info(t,...h){this.f(v.Info)&&this.g(v.Info,D([t,...h]))}warn(t,...h){this.f(v.Warning)&&this.g(v.Warning,D([t,...h]))}error(t,...h){if(this.f(v.Error))if(t instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=t.stack,this.g(v.Error,D(E))}else this.g(v.Error,D([t,...h]))}flush(){}}e.AbstractMessageLogger=d;class u extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!S.isWindows}trace(t,...h){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...h):console.log(`[main ${O()}]`,t,...h))}debug(t,...h){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...h):console.log(`[main ${O()}]`,t,...h))}info(t,...h){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...h):console.log(`[main ${O()}]`,t,...h))}warn(t,...h){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${O()}]\x1B[0m`,t,...h):console.warn(`[main ${O()}]`,t,...h))}error(t,...h){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${O()}]\x1B[0m`,t,...h):console.error(`[main ${O()}]`,t,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=u;class m extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...h){this.f(v.Trace)&&console.log("%cTRACE","color: #888",t,...h)}debug(t,...h){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...h)}info(t,...h){this.f(v.Info)&&console.log("%c INFO","color: #33f",t,...h)}warn(t,...h){this.f(v.Warning)&&console.log("%c WARN","color: #993",t,...h)}error(t,...h){this.f(v.Error)&&console.log("%c  ERR","color: #f33",t,...h)}dispose(){}flush(){}}e.ConsoleLogger=m;class b extends f{constructor(t,h=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(h)}trace(t,...h){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(t),...h])}debug(t,...h){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(t),...h])}info(t,...h){this.f(v.Info)&&this.g.log(v.Info,[this.h(t),...h])}warn(t,...h){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(t),...h])}error(t,...h){this.f(v.Error)&&this.g.log(v.Error,[this.h(t),...h])}h(t){return typeof t=="string"?t:(0,o.toErrorMessage)(t,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class C extends f{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const h of this.g)h.setLevel(t);super.setLevel(t)}trace(t,...h){for(const E of this.g)E.trace(t,...h)}debug(t,...h){for(const E of this.g)E.debug(t,...h)}info(t,...h){for(const E of this.g)E.info(t,...h)}warn(t,...h){for(const E of this.g)E.warn(t,...h)}error(t,...h){for(const E of this.g)E.error(t,...h)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogger=C;class p extends l.Disposable{constructor(t,h){if(super(),this.j=t,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new L.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeVisibility=this.h.event,h)for(const E of h)this.c.set(E.resource,E)}getLogger(t){return this.b.get(t)}createLogger(t,h){let E=this.b.get(t);const w=h?.logLevel==="always"?v.Trace:h?.logLevel;return E||(E=this.k(t,w??this.getLogLevel(t)??this.j,h),this.b.set(t,E)),this.registerLogger({resource:t,id:h?.id??t.toString(),logLevel:w,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId}),E}setLogLevel(t,h){if(y.URI.isUri(t)){const E=t,w=h,N=this.c.get(E);N&&w!==N.logLevel&&(N.logLevel=w===this.j?void 0:w,this.b.get(E)?.setLevel(w),this.c.set(N.resource,N),this.g.fire([E,w]))}else{this.j=t;for(const[E,w]of this.b.entries())this.c.get(E)?.logLevel===void 0&&w.setLevel(this.j);this.g.fire(this.j)}}setVisibility(t,h){const E=this.c.get(t);E&&h!==!E.hidden&&(E.hidden=!h,this.c.set(E.resource,E),this.h.fire([t,h]))}getLogLevel(t){let h;return t&&(h=this.c.get(t)?.logLevel),h??this.j}registerLogger(t){const h=this.c.get(t.resource);h?h.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this.c.set(t.resource,t),this.f.fire({added:[t],removed:[]}))}deregisterLogger(t){const h=this.c.get(t);if(h){this.c.delete(t);const E=this.b.get(t);E&&(this.b.delete(t),E.dispose()),this.f.fire({added:[],removed:[h]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(t){return this.c.get(t)}dispose(){this.b.forEach(t=>t.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class n{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...h){}debug(t,...h){}info(t,...h){}warn(t,...h){}error(t,...h){}critical(t,...h){}dispose(){}flush(){}}e.NullLogger=n;class s extends n{}e.NullLogService=s;class r extends p{constructor(){super(v.Info)}k(t,h,E){return new n}}e.NullLoggerService=r;function a(i){if(i.verbose)return v.Trace;if(typeof i.logLevel=="string"){const t=g(i.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function c(i){switch(i){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=c;function g(i){switch(i){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=g}),define(ye[205],De([1,0,6,13]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends o.Disposable{constructor(S,A=[]){super(),this.a=new L.MultiplexLogger([S,...A]),this.B(S.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...A){this.a.trace(S,...A)}debug(S,...A){this.a.debug(S,...A)}info(S,...A){this.a.info(S,...A)}warn(S,...A){this.a.warn(S,...A)}error(S,...A){this.a.error(S,...A)}flush(){this.a.flush()}}e.LogService=l}),define(ye[206],De([1,0,44,13]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(I){I[I.Trace=0]="Trace",I[I.Debug=1]="Debug",I[I.Info=2]="Info",I[I.Warning=3]="Warning",I[I.Error=4]="Error",I[I.Critical=5]="Critical",I[I.Off=6]="Off"})(l||(l={}));async function R(I,O,P,v,k){try{const D=await new Promise((d,u)=>{re(["spdlog"],d,u)});D.setFlushOn(l.Trace);const f=await D.createAsyncRotatingLogger(I,O,P,v);return k?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(D){console.error(D)}return null}function S(I,O,P){switch(O){case L.LogLevel.Trace:I.trace(P);break;case L.LogLevel.Debug:I.debug(P);break;case L.LogLevel.Info:I.info(P);break;case L.LogLevel.Warning:I.warn(P);break;case L.LogLevel.Error:I.error(P);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function A(I,O){switch(O){case L.LogLevel.Trace:I.setLevel(l.Trace);break;case L.LogLevel.Debug:I.setLevel(l.Debug);break;case L.LogLevel.Info:I.setLevel(l.Info);break;case L.LogLevel.Warning:I.setLevel(l.Warning);break;case L.LogLevel.Error:I.setLevel(l.Error);break;case L.LogLevel.Off:I.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${O}`)}}class y extends L.AbstractMessageLogger{constructor(O,P,v,k,D){super(),this.k=[],this.setLevel(D),this.l=this.n(O,P,v,k),this.B(this.onDidChangeLogLevel(f=>{this.m&&A(this.m,f)}))}async n(O,P,v,k){const D=v?6:1,f=30/D*o.ByteSize.MB,d=await R(O,P,f,D,k);if(d){this.m=d,A(this.m,this.getLevel());for(const{level:u,message:m}of this.k)S(this.m,u,m);this.k=[]}}g(O,P){this.m?S(this.m,O,P):this.getLevel()<=O&&this.k.push({level:O,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[124],De([1,0,37,174,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function I(D,f){return f-D}y.compare=I;const O=Object.create(null);O[y.Error]=(0,L.localize)(0,null),O[y.Warning]=(0,L.localize)(1,null),O[y.Info]=(0,L.localize)(2,null);function P(D){return O[D]||""}y.toString=P;function v(D){switch(D){case o.default.Error:return y.Error;case o.default.Warning:return y.Warning;case o.default.Info:return y.Info;case o.default.Ignore:return y.Hint}}y.fromSeverity=v;function k(D){switch(D){case y.Error:return o.default.Error;case y.Warning:return o.default.Warning;case y.Info:return o.default.Info;case y.Hint:return o.default.Ignore}}y.toSeverity=k}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const I="";function O(v){return P(v,!0)}y.makeKey=O;function P(v,k){const D=[I];return v.source?D.push(v.source.replace("\xA6","\\\xA6")):D.push(I),v.code?typeof v.code=="string"?D.push(v.code.replace("\xA6","\\\xA6")):D.push(v.code.value.replace("\xA6","\\\xA6")):D.push(I),v.severity!==void 0&&v.severity!==null?D.push(S.toString(v.severity)):D.push(I),v.message&&k?D.push(v.message.replace("\xA6","\\\xA6")):D.push(I),v.startLineNumber!==void 0&&v.startLineNumber!==null?D.push(v.startLineNumber.toString()):D.push(I),v.startColumn!==void 0&&v.startColumn!==null?D.push(v.startColumn.toString()):D.push(I),v.endLineNumber!==void 0&&v.endLineNumber!==null?D.push(v.endLineNumber.toString()):D.push(I),v.endColumn!==void 0&&v.endColumn!==null?D.push(v.endColumn.toString()):D.push(I),D.push(I),D.join("\xA6")}y.makeKeyOptionalMessage=P})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(ye[207],De([1,0,3,37,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,l.createDecorator)("notificationService");var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(ye[125],De([1,0,8,2,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function R(I,O){return L.URI.isUri(I)?(0,o.equalsIgnoreCase)(I.scheme,O):(0,o.startsWithIgnoreCase)(I,O+":")}e.matchesScheme=R;function S(I,...O){return O.some(P=>R(I,P))}e.matchesSomeScheme=S;function A(I,O){return I.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function y(I){let O;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return P&&(O={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},I=I.with({fragment:""})),{selection:O,uri:I}}e.extractSelection=y}),define(ye[208],De([1,0,11,36]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.context<"u"){const R=o.globals.vscode.context.configuration();if(R)l=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:R.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(ye[209],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(re,e){return function(o,L){e(o,L,re)}};define(ye[126],De([1,0,19,21,6,4]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var S;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}A.None=Object.freeze({report(){}}),e.Progress=A;let y=class extends l.Disposable{constructor(P,v){super(),this.a=new o.DeferredPromise,v.withProgress(P,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,l.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};y=xe([ze(1,e.IProgressService)],y),e.UnmanagedProgress=y;class I extends l.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new l.DisposableStore)}start(P){this.stop();const v=++this.a,k=new L.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,l.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,l.toDisposable)(()=>k.cancel())),this.b.add((0,l.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:k.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[39],De([1,0,50,9]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(S,A){o.ok(L.isString(S)),o.ok(L.isObject(A)),o.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,A)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.Registry=new l}),define(ye[92],De([1,0,3,39]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new o.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,I){this.a[l(y)]=I,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const S=new R;L.Registry.add(e.Extensions.JSONContribution,S)}),define(ye[127],De([1,0,15,3,9,169,53,92,39]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(A.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const r=new Set;this.n(n,s,r),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(n){const s=new Set;this.o(n,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const r=new Set;this.o(s,r),this.n(n,!1,r),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const r=[];for(const{overrides:a,source:c}of n)for(const g in a)if(s.add(g),e.OVERRIDE_PROPERTY_REGEX.test(g)){const i=this.a.get(g),t=i?.valuesSources??new Map;if(c)for(const N of Object.keys(a[g]))t.set(N,c);const h={...i?.value||{},...a[g]};this.a.set(g,{source:c,value:h,valuesSources:t});const E=(0,S.getLanguageTagSettingPlainKey)(g),w={type:"object",default:h,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:l.isString(c)?void 0:c,defaultValueSource:c};r.push(...f(g)),this.d[g]=w,this.b.properties[g]=w}else{this.a.set(g,{value:a[g],source:c});const i=this.d[g];i&&(this.w(g,i),this.r(g,i))}this.m(r)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:r,source:a}of n)for(const c in r){const g=this.a.get(c),i=l.isString(a)?a:a?.id,t=l.isString(g?.source)?g?.source:g?.source?.id;if(i===t)if(s.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const h=this.d[c];h&&(this.w(c,h),this.r(c,h))}}this.u()}deltaConfiguration(n){let s=!1;const r=new Set;n.removedDefaults&&(this.l(n.removedDefaults,r),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,r),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,r),n.addedConfigurations&&this.n(n.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,r){n.forEach(a=>{this.p(a,s,a.extensionInfo,a.restrictedProperties,void 0,r),this.c.push(a),this.q(a)})}o(n,s){const r=a=>{if(a.properties)for(const c in a.properties){s.add(c);const g=this.d[c];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[c],this.s(c,a.properties[c])}a.allOf?.forEach(c=>r(c))};for(const a of n){r(a);const c=this.c.indexOf(a);c!==-1&&this.c.splice(c,1)}}p(n,s=!0,r,a,c=3,g){c=l.isUndefinedOrNull(n.scope)?c:n.scope;const i=n.properties;if(i)for(const h in i){const E=i[h];if(s&&b(h,E)){delete i[h];continue}if(E.source=r,E.defaultDefaultValue=i[h].default,this.w(h,E),e.OVERRIDE_PROPERTY_REGEX.test(h)?E.scope=void 0:(E.scope=l.isUndefinedOrNull(E.scope)?c:E.scope,E.restricted=l.isUndefinedOrNull(E.restricted)?!!a?.includes(h):E.restricted),i[h].hasOwnProperty("included")&&!i[h].included){this.f[h]=i[h],delete i[h];continue}else this.d[h]=i[h],i[h].policy?.name&&this.e.set(i[h].policy.name,h);!i[h].deprecationMessage&&i[h].markdownDeprecationMessage&&(i[h].deprecationMessage=i[h].markdownDeprecationMessage),g.add(h)}const t=n.allOf;if(t)for(const h of t)this.p(h,s,r,a,c,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=r=>{const a=r.properties;if(a)for(const g in a)this.r(g,a[g]);r.allOf?.forEach(s)};s(n)}r(n,s){switch(e.allSettings.properties[n]=s,s.scope){case 1:e.applicationSettings.properties[n]=s;break;case 2:e.machineSettings.properties[n]=s;break;case 6:e.machineOverridableSettings.properties[n]=s;break;case 3:e.windowSettings.properties[n]=s;break;case 4:e.resourceSettings.properties[n]=s;break;case 5:e.resourceSettings.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.allSettings.properties[n],s.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}v(){const n={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,s){const r=this.a.get(n);let a=r?.value,c=r?.source;l.isUndefined(a)&&(a=s.defaultDefaultValue,c=void 0),l.isUndefined(a)&&(a=u(s.type)),s.default=a,s.defaultValueSource=c}}const k="\\[([^\\]]+)\\]",D=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(p){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let s=D.exec(p);for(;s?.length;){const r=s[1].trim();r&&n.push(r),s=D.exec(p)}}return(0,o.distinct)(n)}e.overrideIdentifiersFromKey=f;function d(p){return p.reduce((n,s)=>`${n}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function u(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const m=new v;y.Registry.add(e.Extensions.Configuration,m);function b(p,n){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):m.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?R.localize(9,null,p,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function C(){const p=[],n=m.getConfigurationProperties();for(const s of Object.keys(n))p.push([s,n[s].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=C}),define(ye[210],De([1,0,15,3,146,6,28,23,9,2,53,127,39]),function(re,e,o,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(s){return Object.isFrozen(s)?s:A.deepFreeze(s)}class D{constructor(r={},a=[],c=[],g){this.b=r,this.c=a,this.d=c,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof D)return a;const c=new f("");return c.parseRaw(a),c.configurationModel});this.f=r.reduce((a,c)=>c===a?c:a.merge(c),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const c=this.rawConfiguration.getValue(r),g=a?this.rawConfiguration.getOverrideValue(r,a):void 0,i=a?this.rawConfiguration.override(a).getValue(r):c;return{value:c,override:g,merged:i}}getOverrideValue(r,a){const c=this.i(a);return c?r?(0,O.getConfigurationValue)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const c of this.overrides)c.identifiers.includes(r)&&a.push(...c.keys);return o.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return o.distinct(r)}override(r){let a=this.a.get(r);return a||(a=this.g(r),this.a.set(r,a)),a}merge(...r){const a=A.deepClone(this.contents),c=A.deepClone(this.overrides),g=[...this.keys],i=this.raw?.length?[...this.raw]:[this];for(const t of r)if(i.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.h(a,t.contents);for(const h of t.overrides){const[E]=c.filter(w=>o.equals(w.identifiers,h.identifiers));E?(this.h(E.contents,h.contents),E.keys.push(...h.keys),E.keys=o.distinct(E.keys)):c.push(A.deepClone(h))}for(const h of t.keys)g.indexOf(h)===-1&&g.push(h)}return new D(a,g,c,i.every(t=>t instanceof D)?void 0:i)}g(r){const a=this.i(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const c={};for(const g of o.distinct([...Object.keys(this.contents),...Object.keys(a)])){let i=this.contents[g];const t=a[g];t&&(typeof i=="object"&&typeof t=="object"?(i=A.deepClone(i),this.h(i,t)):i=t),c[g]=i}return new D(c,this.keys,this.overrides)}h(r,a){for(const c of Object.keys(a)){if(c in r&&y.isObject(r[c])&&y.isObject(a[c])){this.h(r[c],a[c]);continue}r[c]=A.deepClone(a[c])}}i(r){let a=null,c=null;const g=i=>{i&&(c?this.h(c,i):c=A.deepClone(i))};for(const i of this.overrides)o.equals(i.identifiers,[r])?a=i.contents:i.identifiers.includes(r)&&g(i.contents);return g(a),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.j(r,a,!0)}setValue(r,a){this.j(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,O.removeFromValueTree)(this.contents,r),P.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(c=>o.equals(c.identifiers,(0,P.overrideIdentifiersFromKey)(r))),1))}j(r,a,c){(0,O.addToValueTree)(this.contents,r,a,g=>console.error(g)),c=c||this.keys.indexOf(r)===-1,c&&this.keys.push(r),P.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],g=>console.error(g))})}}e.ConfigurationModel=D;class f{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!y.isUndefinedOrNull(r)){const c=this.g(r);this.parseRaw(c,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:c,keys:g,overrides:i,restricted:t,hasExcludedProperties:h}=this.h(r,a);this.b=new D(c,g,i,h?[r]:void 0),this.c=t||[]}g(r){let a={},c=null,g=[];const i=[],t=[];function h(w){Array.isArray(g)?g.push(w):c!==null&&(g[c]=w)}const E={onObjectBegin:()=>{const w={};h(w),i.push(g),g=w,c=null},onObjectProperty:w=>{c=w},onObjectEnd:()=>{g=i.pop()},onArrayBegin:()=>{const w=[];h(w),i.push(g),g=w,c=null},onArrayEnd:()=>{g=i.pop()},onLiteralValue:h,onError:(w,N,j)=>{t.push({error:w,offset:N,length:j})}};if(r)try{l.visit(r,E),a=g[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return a}h(r,a){const c=v.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),g=this.i(r,c,!0,a);r=g.raw;const i=(0,O.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),t=Object.keys(r),h=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:i,keys:t,overrides:h,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(r,a,c,g){let i=!1;if(!g?.scopes&&!g?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:i};const t={},h=[];for(const E in r)if(P.OVERRIDE_PROPERTY_REGEX.test(E)&&c){const w=this.i(r[E],a,!1,g);t[E]=w.raw,i=i||w.hasExcludedProperties,h.push(...w.restricted)}else{const w=a[E],N=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&h.push(E),(N===void 0||g.scopes===void 0||g.scopes.includes(N))&&!(g.skipRestricted&&w?.restricted)?t[E]=r[E]:i=!0}return{raw:t,restricted:h,hasExcludedProperties:i}}j(r,a){const c=[];for(const g of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(g)){const i={};for(const t in r[g])i[t]=r[g][t];c.push({identifiers:(0,P.overrideIdentifiersFromKey)(g),keys:Object.keys(i),contents:(0,O.toValuesTree)(i,a)})}return c}}e.ConfigurationModelParser=f;class d extends R.Disposable{constructor(r,a,c,g){super(),this.f=r,this.g=a,this.h=g,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(c.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,i=>i.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,i=>(i.isOperation(0)||i.isOperation(3)||i.isOperation(1)||i.isOperation(4))&&c.isEqual(i.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new D}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class u{constructor(r,a,c,g,i,t,h,E,w,N,j,V,Q){this.a=r,this.b=a,this.c=c,this.overrideIdentifiers=g,this.d=i,this.f=t,this.g=h,this.h=E,this.i=w,this.j=N,this.k=j,this.l=V,this.m=Q}get value(){return k(this.c)}n(r,a,c){const g=r.inspect(a,c);return{get value(){return k(g.value)},get override(){return k(g.override)},get merged(){return k(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(r,a,c,g,i=new D,t=new D,h=new S.ResourceMap,E=new D,w=new S.ResourceMap){this.c=r,this.d=a,this.f=c,this.g=g,this.h=i,this.i=t,this.j=h,this.l=E,this.m=w,this.a=null,this.b=new S.ResourceMap,this.n=null}getValue(r,a,c){return this.q(r,a,c).getValue(r)}updateValue(r,a,c={}){let g;c.resource?(g=this.m.get(c.resource),g||(g=new D,this.m.set(c.resource,g))):g=this.l,a===void 0?g.removeValue(r):g.setValue(r,a),c.resource||(this.a=null)}inspect(r,a,c){const g=this.q(r,a,c),i=this.u(a.resource,c),t=a.resource?this.m.get(a.resource)||this.l:this.l,h=new Set;for(const E of g.overrides)for(const w of E.identifiers)g.getOverrideValue(r,w)!==void 0&&h.add(w);return new u(r,a,g.getValue(r),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,i||void 0,t)}keys(r){const a=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,a){this.j.set(r,a),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const c=[];if(!a){const{added:g,updated:i,removed:t}=p(this.c,r);a=[...g,...i,...t]}for(const g of a)for(const i of(0,P.overrideIdentifiersFromKey)(g)){const t=this.c.getKeysForOverrideIdentifier(i),h=r.getKeysForOverrideIdentifier(i),E=[...h.filter(w=>t.indexOf(w)===-1),...t.filter(w=>h.indexOf(w)===-1),...t.filter(w=>!A.equals(this.c.override(i).getValue(w),r.override(i).getValue(w)))];c.push([i,E])}return this.updateDefaultConfiguration(r),{keys:a,overrides:c}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:c,removed:g}=p(this.d,r),i=[...a,...c,...g];return i.length&&this.updatePolicyConfiguration(r),{keys:i,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.applicationConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateApplicationConfiguration(r),{keys:t,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.localUserConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateLocalUserConfiguration(r),{keys:t,overrides:i}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.remoteUserConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateRemoteUserConfiguration(r),{keys:t,overrides:i}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:c,removed:g,overrides:i}=p(this.workspaceConfiguration,r),t=[...a,...c,...g];return t.length&&this.updateWorkspaceConfiguration(r),{keys:t,overrides:i}}compareAndUpdateFolderConfiguration(r,a){const c=this.p.get(r),{added:g,updated:i,removed:t,overrides:h}=p(c,a),E=[...g,...i,...t];return(E.length||!c)&&this.updateFolderConfiguration(r,a),{keys:E,overrides:h}}compareAndDeleteFolderConfiguration(r){const a=this.p.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:g,removed:i,overrides:t}=p(a,void 0);return{keys:[...c,...g,...i],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,a,c){let g=this.r(a,c);return a.overrideIdentifier&&(g=g.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(g=g.merge(this.d)),g}r({resource:r},a){let c=this.s();if(a&&r){const g=a.getFolder(r);g&&(c=this.t(g.uri)||c);const i=this.m.get(r);i&&(c=c.merge(i))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let a=this.b.get(r);if(!a){const c=this.s(),g=this.j.get(r);g?(a=c.merge(g),this.b.set(r,a)):a=c}return a}u(r,a){if(a&&r){const c=a.getFolder(r);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,a)=>{const{contents:c,overrides:g,keys:i}=this.j.get(a);return r.push([a,{contents:c,overrides:g,keys:i}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this.i.keys.forEach(a=>r.add(a)),this.j.forEach(a=>a.keys.forEach(c=>r.add(c))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}w(r){const a=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c)),this.i.getKeysForOverrideIdentifier(r).forEach(c=>a.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(g=>a.add(g))),[...a.values()]}static parse(r){const a=this.x(r.defaults),c=this.x(r.policy),g=this.x(r.application),i=this.x(r.user),t=this.x(r.workspace),h=r.folders.reduce((E,w)=>(E.set(I.URI.revive(w[0]),this.x(w[1])),E),new S.ResourceMap);return new m(a,c,g,i,new D,t,h,new D,new S.ResourceMap)}static x(r){return new D(r.contents,r.keys,r.overrides)}}e.Configuration=m;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const g of s)g.keys.forEach(i=>r.add(i)),g.overrides.forEach(([i,t])=>{const h=(0,S.getOrSet)(a,i,new Set);t.forEach(E=>h.add(E))});const c=[];return a.forEach((g,i)=>c.push([i,[...g.values()]])),{keys:[...r.values()],overrides:c}}e.mergeChanges=b;class C{constructor(r,a,c,g){this.change=r,this.f=a,this.g=c,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const i of r.keys)this.affectedKeys.add(i);for(const[,i]of r.overrides)for(const t of i)this.affectedKeys.add(t);this.d=this.a;for(const i of this.affectedKeys)this.d+=i+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(r,a){const c=this.a+r,g=this.d.indexOf(c);if(g<0)return!1;const i=g+c.length;if(i>=this.d.length)return!1;const t=this.d.charCodeAt(i);if(t!==this.b&&t!==this.c)return!1;if(a){const h=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.f?.workspace):void 0,E=this.g.getValue(r,a,this.h);return!A.equals(h,E)}return!0}}e.ConfigurationChangeEvent=C;function p(s,r){const{added:a,removed:c,updated:g}=n(r?.rawConfiguration,s?.rawConfiguration),i=[],t=s?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const E=h.filter(w=>!t.includes(w));for(const w of E)i.push([w,r.getKeysForOverrideIdentifier(w)])}if(s){const E=t.filter(w=>!h.includes(w));for(const w of E)i.push([w,s.getKeysForOverrideIdentifier(w)])}if(r&&s){for(const E of t)if(h.includes(E)){const w=n({contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});i.push([E,[...w.added,...w.removed,...w.updated]])}}return{added:a,removed:c,updated:g,overrides:i}}function n(s,r){const a=s?r?s.keys.filter(i=>r.keys.indexOf(i)===-1):[...s.keys]:[],c=r?s?r.keys.filter(i=>s.keys.indexOf(i)===-1):[...r.keys]:[],g=[];if(s&&r){for(const i of r.keys)if(s.keys.indexOf(i)!==-1){const t=(0,O.getConfigurationValue)(r.contents,i),h=(0,O.getConfigurationValue)(s.contents,i);A.equals(t,h)||g.push(i)}}return{added:a,removed:c,updated:g}}}),define(ye[128],De([1,0,10,4]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var l;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends o.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===l.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===l.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===l.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,I=l.Unknown,O){super(y),this._message=y,this._code=I,this._detail=O,this.isHandled=I===l.NotAvailable&&O===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function S(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=S}),define(ye[72],De([1,0,16]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(I){return I.scheme===o.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=L;function l(I){if(!I)return;const O=I.indexOf("+");return O<0?I:I.substr(0,O)}e.getRemoteName=l;function R(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=R;function S(I){const{host:O,port:P}=y(I);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:P}}e.parseAuthorityWithPort=S;function A(I,O){let{host:P,port:v}=y(I);return typeof v>"u"&&(v=O),{host:P,port:v}}e.parseAuthorityWithOptionalPort=A;function y(I){const O=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const P=I.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const v=I.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:I,port:void 0}}}),define(ye[27],De([1,0,8,4,72]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var A;(function(k){k.WIN32_X64="win32-x64",k.WIN32_IA32="win32-ia32",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(D){this.value=D,this.c=D.toLowerCase()}static equals(D,f){if(typeof D>"u"||D===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof D=="string"||typeof f=="string"){const d=typeof D=="string"?D:D.value,u=typeof f=="string"?f:f.value;return o.equalsIgnoreCase(d,u)}return D.c===f.c}static toKey(D){return typeof D=="string"?D.toLowerCase():D.c}}e.ExtensionIdentifier=y;function I(k){return O(k)}e.isApplicationScopedExtension=I;function O(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function P(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function v(k,D){if(D){const f=`onResolveRemoteAuthority:${(0,l.getRemoteName)(D)}`;return!!k.activationEvents?.includes(f)}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[211],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.b=new Map}c(){return new Promise((l,R)=>re(["vsda"],l,R))}async createNewMessage(l){try{const R=await this.c(),S=new R.validator;if(S){const A=String(o.a++);return this.b.set(A,S),{id:A,data:S.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,R){if(!l.id)return!0;const S=this.b.get(l.id);if(!S)return!1;this.b.delete(l.id);try{return S.validate(R)==="ok"}catch{return!1}}async sign(l){try{const R=await this.c(),S=new R.signer;if(S)return S.sign(l)}catch{}return l}}o.a=1,e.SignService=o}),define(ye[212],De([1,0,11,36,2,30]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(I){if(o.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function A(I,O,P,v,k,D,f,d,u,m){const b=Object.create(null);b["common.machineId"]=f,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=k,b.version=D,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,o.PlatformToString)(o.platform),b["common.nodePlatform"]=L.platform,b["common.nodeArch"]=v,b["common.product"]=m||"desktop",d&&(b["common.msftInternal"]=d);let C=0;const p=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>C++,enumerable:!0}}),o.isLinuxSnap&&(b["common.snap"]="true");const n=S(P);n&&(b["common.platformDetail"]=n);try{const s=await I.readFile(l.URI.file(u));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(I){const O=L.env.USERDNSDOMAIN;if(!O)return!1;const P=O.toLowerCase();return I.some(v=>P===v)}e.verifyMicrosoftInternalDomain=y}),define(ye[213],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[73],De([1,0,23,9,3,53,72,212,213]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(c){this.value=c}}e.TelemetryTrustedValue=I;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,g){return Promise.resolve(void 0)}publicLog2(c,g){return this.publicLog(c,g)}publicLogError(c,g){return Promise.resolve(void 0)}publicLogError2(c,g){return this.publicLogError(c,g)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class P{async publicLog(c,g,i){}async publicLogError(c,g,i){}}e.NullEndpointTelemetryService=P,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(a,c){return l.Event.debounce(c.onDidChangeConfiguration,(i,t)=>{const h=i?new Set([...i.affectedKeys,...t.affectedKeys]):t.affectedKeys;return{...t,affectedKeys:h}},1e3,!0)(i=>{i.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(i.source),configurationKeys:Array.from(i.affectedKeys)})})}e.configurationTelemetry=v;function k(a,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!a.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=k;function D(a,c){return!(c.isBuilt||c.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=D;function f(a){const c=a.getValue(y.TELEMETRY_SETTING_ID),g=a.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||g===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function d(a){const c={},g={},i={};b(a,i);for(let t in i){t=t.length>150?t.substr(t.length-149):t;const h=i[t];typeof h=="number"?g[t]=h:typeof h=="boolean"?g[t]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${h.length}`),c[t]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(c[t]=h)}return{properties:c,measurements:g}}e.validateTelemetryData=d;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(a){if(!a)return"none";const c=(0,S.getRemoteName)(a);return u.has(c)?c:"other"}e.cleanRemoteAuthority=m;function b(a,c,g=0,i){if(!!a)for(const t of Object.getOwnPropertyNames(a)){const h=a[t],E=i?i+t:t;Array.isArray(h)?c[E]=(0,o.safeStringify)(h):h instanceof Date?c[E]=h.toISOString():(0,L.isObject)(h)?g<2?b(h,c,g+1,E+"."):c[E]=(0,o.safeStringify)(h):c[E]=h}}function C(a,c){const g=a.msftInternalDomains||[],i=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(g)||i}e.isInternalTelemetry=C;function p(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=p;function n(a,c){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let g=a;const i=[];for(const w of c)for(;;){const N=w.exec(a);if(!N)break;i.push([N.index,w.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(g="";;){const w=h.exec(a);if(!w)break;const N=i.some(([j,V])=>w.index<V&&j<h.lastIndex);!t.test(w[0])&&!N&&(g+=a.substring(E,w.index)+"<REDACTED: user-file-path>",E=h.lastIndex)}return E<a.length&&(g+=a.substr(E)),g}function s(a){if(!a)return a;const c=a.toLowerCase(),g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of g)if(i.regex.test(c))return`<REDACTED: ${i.label}>`;return a}function r(a,c){return(0,o.cloneAndChange)(a,g=>{if(g instanceof I)return g.value;if(typeof g=="string"){let i=g.replaceAll("%20"," ");i=n(i,c);for(const t of c)i=i.replace(t,"");return i=s(i),i}})}e.cleanData=r}),define(ye[214],De([1,0,8,123,27,11,2,10,36,73]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,o.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=O;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(a){const c=a.manifest?a.manifest.version:a.version,g=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new v(a.identifier,c,g)}static parse(a){const c=P.exec(a);return c&&c[1]&&c[2]?new v({id:c[1]},c[2],c[4]||void 0):null}constructor(a,c,g="undefined"){this.version=c,this.targetPlatform=g,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof v?O(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=v;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(r){const a=k.exec(r);return a&&a[1]?[d(a[1]),a[2]]:[d(r),void 0]}e.getIdAndVersion=D;function f(r,a){return`${r}.${a}`}e.getExtensionId=f;function d(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function u(r,a){return d(f(r,a))}e.getGalleryExtensionId=u;function m(r,a){const c=[],g=i=>{for(const t of c)if(t.some(h=>O(a(h),a(i))))return t;return null};for(const i of r){const t=g(i);t?t.push(i):c.push([i])}return c}e.groupByExtension=m;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function C(r){return{id:new I.TelemetryTrustedValue(r.identifier.id),name:new I.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(r,a){const c=[],g=a.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const i=g.shift();if(i&&c.every(t=>!O(t.identifier,{id:i}))){const t=r.filter(h=>O(h.identifier,{id:i}));t.length===1&&(c.push(t[0]),g.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=p;async function n(r,a){if(!R.isLinux)return!1;let c;try{c=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(i){a.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(i))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,a){const c=await n(r,a),g=(0,L.getTargetPlatform)(c?"alpine":R.platform,y.arch);return a.debug("ComputeTargetPlatform:",g),g}e.computeTargetPlatform=s}),define(ye[215],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=o;function L(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=L;function l(S){return Array.from(S.entries()).map(A=>[A[0],o(A[1].map)])}e.serializeEnvironmentVariableCollections=l;function R(S){return new Map(S.map(A=>[A[0],{map:L(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[216],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,R,S=5){const A=R(y=>{const I=typeof y=="string"?y:y.data;let O=this.a.get(l);if(O){O.data.push(I);return}const P=setTimeout(()=>this.flushBuffer(l),S);O={data:[I],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(l),A.dispose()}},this.a.set(l,O)});return A}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const R=this.a.get(l);R&&(this.a.delete(l),this.b(l,R.data.join("")))}}e.TerminalDataBufferer=o}),define(ye[217],De([1,0,19,67,51,3,9,2,175,92,39]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var P;(function(C){function p(n,s){let r=n.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const a=D.getIcon(r.id);if(!a)return;r=a.defaults}return r}C.getDefinition=p})(P=e.IconContribution||(e.IconContribution={}));var v;(function(C){function p(s){return{weight:s.weight,style:s.style,src:s.src.map(r=>({format:r.format,location:r.location.toString()}))}}C.toJSONObject=p;function n(s){const r=a=>(0,S.isString)(a)?a:void 0;if(s&&Array.isArray(s.src)&&s.src.every(a=>(0,S.isString)(a.format)&&(0,S.isString)(a.location)))return{weight:r(s.weight),style:r(s.style),src:s.src.map(a=>({format:a.format,location:A.URI.parse(a.location)}))}}C.fromJSONObject=n})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class k{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,n,s,r){const a=this.b[p];if(a){if(s&&!a.description){a.description=s,this.d.properties[p].markdownDescription=`${s} $(${p})`;const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enumDescriptions[i]=s),this.a.fire()}return a}const c={id:p,description:s,defaults:n,deprecationMessage:r};this.b[p]=c;const g={$ref:"#/definitions/icons"};return r&&(g.deprecationMessage=r),s&&(g.markdownDescription=`${s}: $(${p})`),this.d.properties[p]=g,this.e.enum.push(p),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const n=this.e.enum.indexOf(p);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,n){const s=this.f[p];return s||(this.f[p]=n,this.a.fire(),n)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(a,c)=>a.id.localeCompare(c.id),n=a=>{for(;l.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(a=>this.b[a]);for(const a of r.filter(c=>!!c.description).sort(p))s.push(`|<i class="${n(a)}"></i>|${a.id}|${l.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const a of r.filter(c=>!l.ThemeIcon.isThemeIcon(c.defaults)).sort(p))s.push(`|<i class="${n(a)}"></i>|${a.id}|`);return s.join(`
`)}}const D=new k;O.Registry.add(e.Extensions.IconContribution,D);function f(C,p,n,s){return D.registerIcon(C,p,n,s)}e.registerIcon=f;function d(){return D}e.getIconRegistry=d;function u(){const C=(0,L.getCodiconFontCharacters)();for(const p in C){const n="\\"+C[p].toString(16);D.registerIcon(p,{fontCharacter:n})}}u(),e.iconsSchemaId="vscode://schemas/icons";const m=O.Registry.as(I.Extensions.JSONContribution);m.registerSchema(e.iconsSchemaId,D.getIconSchema());const b=new o.RunOnceScheduler(()=>m.notifySchemaChanged(e.iconsSchemaId),200);D.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=f("widget-close",L.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",L.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",L.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=l.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(ye[129],De([1,0,3,53,4,13]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var S;(function(f){f.Http="http",f.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=P;function v(f,d,u,m){if(u===1)return!1;if(u===2&&P(d)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(b?.length===4&&parseInt(b[1])>=18)return!1}return f<1024}e.isPortPrivileged=v;class k{constructor(d,u,m){this.remoteAddress=d,this.localAddress=u,this.b=m,this.a=new o.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=k;let D=class{constructor(d,u){this.i=d,this.j=u,this.a=new o.Emitter,this.onTunnelOpened=this.a.event,this.b=new o.Emitter,this.onTunnelClosed=this.b.event,this.c=new o.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],u=Array.from(this.d.values());for(const m of u){const b=Array.from(m.values());for(const C of b){const p=await C.value;p&&d.push(p)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:u}of d.values())await u.then(m=>m?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,u,m,b,C){this.o(d,u,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:u,localAddress:m,privacy:b,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,u){(P(d)||O(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const m=this.q(d,u);if(m)return++m.refcount,m.value}openTunnel(d,u,m,b,C,p=!1,n,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${m} on local port ${C}.`),!d)return;if(u||(u="localhost"),b||(b=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(d,u,m,b,C,p,n,s);return r?r.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.m(a);return(a.tunnelRemoteHost!==u||a.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(c),c}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const u=this.d.get(d.tunnelRemoteHost);if(u){const m=u.get(d.tunnelRemotePort);m&&(m.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,m))}}}}async n(d,u,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${u}.`);const b=m.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(u),b}}async closeTunnel(d,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${u} `);const m=this.d.get(d);if(m&&m.has(u)){const b=m.get(u);b.refcount=0,await this.n(d,u,b)}}o(d,u,m){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(u,{refcount:1,value:m})}async p(d,u){const m=this.d.get(d);m&&(await m.get(u)||m.delete(u),m.size===0&&this.d.delete(d))}q(d,u){const m=[d];O(d)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):P(d)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const b=m.map(C=>this.d.get(C));for(const C of b){const p=C?.get(u);if(p)return p}}canTunnel(d){return!!I(d)}s(d,u,m,b,C,p,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${m} on local port ${b}.`);const s=m;this.h.add(s);const r=b===void 0?m:b,a={elevationRequired:C?this.isPortPrivileged(r):!1},c={remoteAddress:{host:u,port:m},localAddressPort:b,privacy:p,public:p?p!==A.Private:void 0,protocol:n},g=d.forwardPort(c,a);return g?(this.o(u,m,g),g.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),g}};D=xe([ze(0,R.ILogService),ze(1,L.IConfigurationService)],D),e.AbstractTunnelService=D}),define(ye[218],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var L;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(L=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[219],De([1,0,16]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function L(y){return y.scheme!==o.Schemas.file&&y.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=L;function l(y){if(y.folders.length)return y.folders.every(I=>L(I.uri))?y.folders[0].uri:void 0;if(y.configuration&&L(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=l;function R(y){return l(y)?.scheme}e.getVirtualWorkspaceScheme=R;function S(y){return l(y)?.authority}e.getVirtualWorkspaceAuthority=S;function A(y){return l(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],De([1,0,176,12,68,24,2,4,16]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function I(r){const a=r;return typeof a?.id=="string"&&S.URI.isUri(a.uri)}e.isSingleFolderWorkspaceIdentifier=I;function O(r){return typeof r?.id=="string"&&!I(r)&&!v(r)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(r,a){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,L.basename)(r)}:a?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=r;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=P;function v(r){const a=r;return typeof a?.id=="string"&&S.URI.isUri(a.configPath)}e.isWorkspaceIdentifier=v;function k(r){const a=r;if(a?.uri)return{id:a.id,uri:S.URI.revive(a.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:S.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=k;var D;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const a=r;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.isWorkspace=f;function d(r){const a=r;return!!(a&&typeof a=="object"&&S.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.isWorkspaceFolder=d;class u{constructor(a,c,g,i,t){this.h=a,this.j=g,this.k=i,this.l=t,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class m{constructor(a,c){this.raw=c,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,R.joinPath)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function b(r){return new m({uri:r,index:0,name:(0,R.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(r,a){return R.extUriBiasedIgnorePathCase.isEqualOrParent(r,a.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function p(r){let a;return S.URI.isUri(r)?a=r:a=r.configuration,a?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=p;function n(r,a){return!C(r,a)&&!p(r)}e.isSavedWorkspace=n;function s(r){return(typeof r=="string"?(0,L.extname)(r):(0,R.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[74],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const R=this.c++;return this.b.set(R,l),this.e(),R}get(l,R){return this.b.has(l)?this.b.get(l)[R]:void 0}delete(l){this.b.delete(l),this.e()}e(){!o.a||console.log(`${this.d} cache size - ${this.b.size}`)}}o.a=!1,e.Cache=o}),define(ye[48],De([1,0,16,24,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new L.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(ye[220],De([1,0,13,205,25]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends L.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:y.logName}))}};R=xe([ze(0,o.ILoggerService),ze(1,l.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(ye[221],De([1,0,19]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(S,A,y){this.h=new Map,this.a=S,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(I=>(this.f=I,this)),this.g=this.c.onDidChangeStorage(I=>{I.shared===this.b&&I.key===this.a&&(this.f=I.value)}),this.i=new o.RunOnceScheduler(()=>{const I=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of I.values())O.complete()}catch(O){for(const P of I.values())P.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this.d}get(S,A){let y=this.f[S];return typeof y>"u"&&(y=A),y}update(S,A){this.f[S]=A;const y=this.h.get(S);if(y!==void 0)return y.p;const I=new o.DeferredPromise;return this.h.set(S,I),this.i.isScheduled()||this.i.schedule(),I.p}dispose(){this.g.dispose()}}e.ExtensionMemento=L;class l extends L{setKeysForSync(S){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},S)}constructor(S,A){super(S.identifier.value,!0,A),this.j=S}}e.ExtensionGlobalMemento=l}),define(ye[222],De([1,0,3,2]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(S){this.c=S,this.a=new o.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(S,A,y,I){const P=this.c.getNotebookDocument(L.URI.revive(S)).acceptModelChanged(A.value,y,I);this.b.fire(P)}$acceptDirtyStateChanged(S,A){this.c.getNotebookDocument(L.URI.revive(S)).acceptDirty(A)}$acceptModelSaved(S){const A=this.c.getNotebookDocument(L.URI.revive(S));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(ye[20],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class L{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=L});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[223],De([1,0,27,3]),function(re,e,o,L){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,y){l.set(this,void 0),this.b=new L.Emitter,this.onDidChange=this.b.event,this.a=o.ExtensionIdentifier.toKey(A.identifier),_e(this,l,y,"f"),Ue(this,l,"f").onDidChangePassword(I=>{I.extensionId===this.a&&this.b.fire({key:I.key})})}get(A){return Ue(this,l,"f").get(this.a,A)}store(A,y){return Ue(this,l,"f").store(this.a,A,y)}delete(A){return Ue(this,l,"f").delete(this.a,A)}}e.ExtensionSecrets=R,l=new WeakMap}),define(ye[55],De([1,0,4,129,3,20]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(y){function I(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:P.protocol}}y.fromApiTunnel=I;function O(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==L.TunnelPrivacyId.ConstantPrivate&&P.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}y.fromServiceTunnel=O})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let A=class{constructor(I){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,O){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,O){return{dispose:()=>{}}}async $providePortAttributes(I,O,P,v,k){return[]}async $forwardPort(I,O){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=xe([ze(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[56],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class L{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=L}),define(ye[224],De([1,0,22]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let I=this.buffers.indexOf(y);return I<0&&(I=this.buffers.length,this.buffers.push(y)),I}}function l(A,y){if(y.serializeBuffersForPostMessage){const I=new L,O=(k,D)=>{if(D instanceof ArrayBuffer){const f=I.add(D);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(D)){const f=R(D);if(f){const d=I.add(D.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:f,byteLength:D.byteLength,byteOffset:D.byteOffset}}}}return D},P=JSON.stringify(A,O),v=I.buffers.map(k=>{const D=new Uint8Array(k);return o.VSBuffer.wrap(D)});return{message:P,buffers:v}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=l;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(A,y){const I=y.map(v=>{const k=new ArrayBuffer(v.byteLength);return new Uint8Array(k).set(v.buffer),k}),O=y.length?(v,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const D=k,{index:f}=D,d=I[f];if(D.view)switch(D.view.type){case 1:return new Int8Array(d,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return k}:void 0;return{message:JSON.parse(A,O),arrayBuffers:I}}e.deserializeWebviewMessage=S}),define(ye[225],De([1,0,114]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(R){return{transformIncoming:S=>S.scheme==="vscode-remote"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="file"?{scheme:"vscode-local",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoing:S=>S.scheme==="file"?{scheme:"vscode-remote",authority:R,path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="vscode-local"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoingScheme:S=>S==="file"?"vscode-remote":S==="vscode-local"?"file":S}}function l(R){return new o.URITransformer(L(R))}e.createURITransformer=l}),define(ye[130],De([1,0,187,9,2,6,4,39,44,16,45,161,37]),function(re,e,o,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(X){const J=X;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.isEditorPaneWithSelection=f;function d(X,J,ee){for(const me of ee.visibleEditorPanes)if(me.group.id===J&&X.matches(me.input))return me.getViewState()}e.findViewStateForEditor=d;function u(X){if(t(X))return!1;const J=X;return l.URI.isUri(J?.resource)}e.isResourceEditorInput=u;function m(X){if(t(X))return!1;const J=X;return J?.original!==void 0&&J.modified!==void 0}e.isResourceDiffEditorInput=m;function b(X){if(t(X)||m(X))return!1;const J=X;return J?.primary!==void 0&&J.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function C(X){if(t(X))return!1;const J=X;return J?J.resource===void 0||J.resource.scheme===I.Schemas.untitled||J.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;const p=/Untitled-\d+/;function n(X){return X.scheme===I.Schemas.untitled&&X.path.length>1&&!p.test(X.path)}e.isUntitledWithAssociatedResource=n;function s(X){if(t(X))return!1;const J=X;return l.URI.isUri(J?.base?.resource)&&l.URI.isUri(J?.input1?.resource)&&l.URI.isUri(J?.input2?.resource)&&l.URI.isUri(J?.result?.resource)}e.isResourceMergeEditorInput=s;var r;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var a;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.a=new Map}registerSource(J,ee){let me=this.a.get(J);return me||(me={source:J,label:ee},this.a.set(J,me)),me.source}getSourceLabel(J){return this.a.get(J)?.label??J}}e.SaveSourceRegistry=new c;var g;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(g=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class i extends R.Disposable{}e.AbstractEditorInput=i;function t(X){return X instanceof i}e.isEditorInput=t;function h(X){const J=X;return l.URI.isUri(J?.preferredResource)}function E(X){const J=X;return t(J?.primary)&&t(J?.secondary)}e.isSideBySideEditorInput=E;function w(X){const J=X;return t(J?.modified)&&t(J?.original)}e.isDiffEditorInput=w;function N(X,J,ee,me,ve){return ge(me,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const Ie={...ee,limits:{size:Number.MAX_VALUE}};X.openEditor(J,Ie)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=N;function j(X){return t(X?.editor)}e.isEditorInputWithOptions=j;function V(X){const J=X;return j(X)&&J?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function Q(X){const J=X;return typeof J?.groupId=="number"&&t(J.editor)}e.isEditorIdentifier=Q;var q;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(q=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var T;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(T=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(J,ee){if(!J)return;if(s(J))return e.EditorResourceAccessor.getOriginalUri(J.result,ee);if(ee?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(J);if(ve&&Ie){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(Ie,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getOriginalUri(ve,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(Ie,{filterByScheme:ee.filterByScheme});J=ee.supportSideBySide===T.PRIMARY?ve:Ie}}if(m(J)||b(J)||s(J))return;const me=h(J)?J.preferredResource:J.resource;return!me||!ee||!ee.filterByScheme?me:this.b(me,ee.filterByScheme)}a(J){return E(J)||b(J)?{primary:J.primary,secondary:J.secondary}:w(J)||m(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,ee){if(!J)return;if(s(J))return e.EditorResourceAccessor.getCanonicalUri(J.result,ee);if(ee?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(J);if(ve&&Ie){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(Ie,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getCanonicalUri(ve,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(Ie,{filterByScheme:ee.filterByScheme});J=ee.supportSideBySide===T.PRIMARY?ve:Ie}}if(m(J)||b(J)||s(J))return;const me=J.resource;return!me||!ee||!ee.filterByScheme?me:this.b(me,ee.filterByScheme)}b(J,ee){if(Array.isArray(ee)){if(ee.some(me=>J.scheme===me))return J}else if(ee===J.scheme)return J}}e.EditorResourceAccessor=new F;var B;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(J){const ee=this.a=J.get(S.IInstantiationService);for(const[me,ve]of this.c)this.e(me,ve,ee);this.c.clear()}e(J,ee,me){const ve=me.createInstance(ee);this.d.set(J,ve)}registerFileEditorFactory(J){if(this.b)throw new Error("Can only register one file editor factory.");this.b=J}getFileEditorFactory(){return(0,L.assertIsDefined)(this.b)}registerEditorSerializer(J,ee){if(this.c.has(J)||this.d.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.a?this.e(J,ee,this.a):this.c.set(J,ee),(0,R.toDisposable)(()=>{this.c.delete(J),this.d.delete(J)})}getEditorSerializer(J){return this.d.get(typeof J=="string"?J:J.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function _(X,J,ee){return!X||!X.length?[]:await Promise.all(X.map(async me=>{const ve=l.URI.revive(me.fileUri);if(!ve){ee.info("Cannot resolve the path because it is not valid.",me);return}if(!await J.canHandleResource(ve)){ee.info("Cannot resolve the path because it cannot be handled",me);return}let Re=me.exists,ae=me.type;if(typeof Re!="boolean"||typeof ae!="number")try{ae=(await J.stat(ve)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Re=!0}catch(ue){ee.error(ue),Re=!1}if(!Re&&me.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",me);return}if(ae===y.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",me);return}const le={...me.options,pinned:!0};return Re?{resource:ve,options:le}:{resource:ve,options:le,forceUntitled:!0}}))}e.pathsToEditors=_;var H;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}));function Y(X){const J=X;if(!J)return!1;const ee=J;if(ee.modified)return Y(ee.modified);const me=J;return!!(me.contributionsState&&me.viewState&&Array.isArray(me.cursorState))}e.isTextEditorViewState=Y;function ie(X){return(0,O.isErrorWithActions)(X)}e.isEditorOpenError=ie;function ge(X,J,ee){const me=(0,O.createErrorWithActions)(X,J);return me.forceMessage=ee?.forceMessage,me.forceSeverity=ee?.forceSeverity,me.allowDialog=ee?.allowDialog,me}e.createEditorOpenError=ge}),define(ye[226],De([1,0,3,188,4,6,28,39,15,61,23,67,217]),function(re,e,o,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",P.Codicon.window,(0,L.localize)(0,null));var k;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(k=e.Extensions||(e.Extensions={}));var D;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(D=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class d extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new o.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new o.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(a,c,g){const i=this.get(a.id);if(i)return i;const t=a;return t.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,S.getOrSet)(this.g,c,[]).push(t),g?.isDefault&&this.h.push(t),this.c.fire({viewContainer:t,viewContainerLocation:c}),t}deregisterViewContainer(a){for(const c of this.g.keys()){const g=this.g.get(c),i=g?.indexOf(a);if(i!==-1){g?.splice(i,1),g.length===0&&this.g.delete(c),this.f.fire({viewContainer:a,viewContainerLocation:c});return}}}get(a){return this.all.filter(c=>c.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(g=>g?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(c=>this.getViewContainerLocation(c)===a)}}A.Registry.add(k.ViewContainersRegistry,new d);var u;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(u=e.ViewContentGroups||(e.ViewContentGroups={}));function m(r,a){const c=r.group??u.More,g=a.group??u.More;return c!==g?c.localeCompare(g):(r.order??5)-(a.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new o.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new o.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new o.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new o.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new I.SetMap}registerViews(a,c){this.registerViews2([{views:a,viewContainer:c}])}registerViews2(a){a.forEach(({views:c,viewContainer:g})=>this.l(c,g)),this.c.fire(a)}deregisterViews(a,c){const g=this.m(a,c);g.length&&this.f.fire({views:g,viewContainer:c})}moveViews(a,c){for(const g of this.j.keys())if(g!==c){const i=this.m(a,g);i.length&&(this.l(i,c),this.g.fire({views:i,from:g,to:c}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const c of this.i){const g=(this.j.get(c)||[]).filter(i=>i.id===a)[0];if(g)return g}return null}getViewContainer(a){for(const c of this.i)if((this.j.get(c)||[]).filter(i=>i.id===a)[0])return c;return null}registerViewWelcomeContent(a,c){return this.k.add(a,c),this.h.fire(a),(0,R.toDisposable)(()=>{this.k.delete(a,c),this.h.fire(a)})}registerViewWelcomeContent2(a,c){const g=new Map;for(const[i,t]of c)this.k.add(a,t),g.set(i,(0,R.toDisposable)(()=>{this.k.delete(a,t),this.h.fire(a)}));return this.h.fire(a),g}getViewWelcomeContent(a){const c=[];return this.k.forEach(a,g=>c.push(g)),c.sort(m)}l(a,c){let g=this.j.get(c);g||(g=[],this.j.set(c,g),this.i.push(c));for(const i of a){if(this.getView(i.id)!==null)throw new Error((0,L.localize)(1,null,i.id));g.push(i)}}m(a,c){const g=this.j.get(c);if(!g)return[];const i=[],t=[];for(const h of g)a.includes(h)?i.push(h):t.push(h);return i.length&&(t.length?this.j.set(c,t):(this.j.delete(c),this.i.splice(this.i.indexOf(c),1))),i}}A.Registry.add(k.ViewsRegistry,new b),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var C;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(C=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class n{constructor(a,c){this.c=!1,this.d=!1,(0,O.mixin)(this,a),this.d=!!c,this.resolve=async g=>{if(c&&!this.c){const i=await c(g);i&&(this.tooltip=this.tooltip??i.tooltip,this.command=this.command??i.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=n;class s extends Error{constructor(a){super((0,L.localize)(2,null,a))}}e.NoTreeViewError=s}),define(ye[131],De([1,0,3,19,189]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new o.Emitter,this.n=new o.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,I,O){const P={command:A};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof O=="number"){const v=setTimeout(()=>{clearTimeout(v);const k=this.f.get(P.seq);if(k){this.f.delete(P.seq);const D={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,l.localize)(0,null,O,A)};k(D)}},O)}return I&&this.f.set(P.seq,I),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,L.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,I=this.f.get(y.request_seq);I&&(this.f.delete(y.request_seq),I(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,I)=>A.set(I,y)),await(0,L.timeout)(500),A.forEach((y,I)=>{y({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.f.delete(I)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[227],De([1,0,190,54,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new L.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new L.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new L.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new L.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new L.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new L.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new L.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new L.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new L.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new L.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new L.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new L.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new L.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new L.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new L.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new L.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new L.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new L.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new L.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new L.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new L.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new L.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new L.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new L.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new L.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new L.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new L.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new L.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new L.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new L.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new L.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new L.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new L.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new L.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new L.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new L.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new L.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new L.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new L.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new L.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new L.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new L.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new L.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new L.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new L.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new L.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new L.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new L.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new L.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new L.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new L.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const R=v=>o.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var S;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(S=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,l.createDecorator)("debugService");var P;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[228],De([1,0,8,2,12,23,16,32,21,15]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function P(i,t,h){return i.replace(O,function(E,w){return t&&w.length>0&&w[0]!=="_"?E:h&&h.hasOwnProperty(w)?h[w]:E})}e.formatPII=P;function v(i){const t={};for(const h of Object.keys(i))h.startsWith("!")||(t[h]=i[h]);return t}e.filterExceptionsFromTelemetry=v;function k(i){return i.configuration.request==="attach"&&!D(i)&&(!i.parentSession||k(i.parentSession))}e.isSessionAttach=k;function D(i){let t=i.configuration.type;if(!!t)return t==="vslsShare"&&(t=i.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(t,"extensionhost")||(0,o.equalsIgnoreCase)(t,"pwa-extensionhost")?i:i.parentSession?D(i.parentSession):void 0}e.getExtensionHostDebugSession=D;function f(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=f;function d(i,t,h){let E,w=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=N.exec(i);){const V=j.index+1,Q=V+j[0].length;if(V<=t&&Q>=h){E=j[0],w=V;break}}if(E){const V=/\w+/g;let Q=null;for(;(Q=V.exec(E))&&!(Q.index+1+w+Q[0].length>=h););Q&&(E=E.substring(0,V.lastIndex))}return E?{start:w,end:w+E.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;async function u(i,t,h,E){if(i.evaluatableExpressionProvider.has(t)){const w=i.evaluatableExpressionProvider.ordered(t),N=(0,I.coalesce)(await Promise.all(w.map(async j=>{try{return await j.provideEvaluatableExpression(t,h,E??y.CancellationToken.None)}catch{return}})));if(N.length>0){let j=N[0].expression;const V=N[0].range;return j||(j=t.getLineContent(h.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:j}}}else{const w=t.getLineContent(h.lineNumber),{start:N,end:j}=d(w,h.column,h.column),V=w.substring(N-1,j);return{matchingExpression:V,range:new A.Range(h.lineNumber,N,h.lineNumber,N+V.length)}}return null}e.getEvaluatableExpressionAtPosition=u;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(i){return!!(i&&i.match(m))}e.isUri=b;function C(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(b(i.path))return L.URI.parse(i.path);if((0,l.isAbsolute)(i.path))return L.URI.file(i.path)}return i.path}function p(i){if(typeof i.path=="object"){const t=L.URI.revive(i.path);if(t)return t.scheme===S.Schemas.file?t.fsPath:t.toString()}return i.path}function n(i,t){const h=t?C:p,E=(0,R.deepClone)(i);return r(E,(w,N)=>{w&&N&&(N.path=h(N))}),E}e.convertToDAPaths=n;function s(i,t){const h=t?C:p,E=(0,R.deepClone)(i);return r(E,(w,N)=>{!w&&N&&(N.path=h(N))}),E}e.convertToVSCPaths=s;function r(i,t){switch(i.type){case"event":{const h=i;switch(h.event){case"output":t(!1,h.body.source);break;case"loadedSource":t(!1,h.body.source);break;case"breakpoint":t(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=i;switch(h.command){case"setBreakpoints":t(!0,h.arguments.source);break;case"breakpointLocations":t(!0,h.arguments.source);break;case"source":t(!0,h.arguments.source);break;case"gotoTargets":t(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(E=>t(!1,E));break;default:break}break}case"response":{const h=i;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(E=>t(!1,E.source));break;case"loadedSources":h.body.sources.forEach(E=>t(!1,E));break;case"scopes":h.body.scopes.forEach(E=>t(!1,E.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(E=>t(!1,E.source));break;case"setBreakpoints":h.body.breakpoints.forEach(E=>t(!1,E.source));break;case"disassemble":h.body?.instructions.forEach(w=>t(!1,w.location));break;default:break}break}}}function a(i){return i.filter(t=>!t.presentation?.hidden).sort((t,h)=>t.presentation?h.presentation?t.presentation.group?h.presentation.group?t.presentation.group!==h.presentation.group?t.presentation.group.localeCompare(h.presentation.group):c(t.presentation.order,h.presentation.order):-1:h.presentation.group?1:c(t.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.getVisibleAndSorted=a;function c(i,t){return typeof i!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:i-t}async function g(i,t){const h=i.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(h!=="none"&&(await t.saveAll(),h==="allEditorsInActiveGroup")){const E=t.activeEditorPane;E&&E.input.resource?.scheme===S.Schemas.untitled&&await t.save({editor:E.input,groupId:E.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=g}),define(ye[229],De([1,0,46,230,23,12,11,8,29,191,131]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends O.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(u,m){this.p=m,this.r=Buffer.allocUnsafe(0),this.t=-1,u.on("data",b=>this.w(b))}sendMessage(u){if(this.p){const m=JSON.stringify(u);this.p.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${P.a}${m}`,"utf8")}}w(u){for(this.r=Buffer.concat([this.r,u]);;){if(this.t>=0){if(this.r.length>=this.t){const m=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(b){this.m.fire(new Error((b.message||b)+`
`+m))}continue}}else{const m=this.r.indexOf(P.a);if(m!==-1){const C=this.r.toString("utf8",0,m).split(P.b);for(const p of C){const n=p.split(P.l);n[0]==="Content-Length"&&(this.t=Number(n[1]))}this.r=this.r.slice(m+P.a.length);continue}}break}}}P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */,e.StreamDebugAdapter=P;class v extends P{startSession(){return new Promise((u,m)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),u(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.x.on("error",C=>{b?this.m.fire(C):m(C)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class k extends v{constructor(u){super(),this.z=u}y(u){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",u)}}e.SocketDebugAdapter=k;class D extends v{constructor(u){super(),this.z=u}y(u){return L.createConnection(this.z.path,u)}}e.NamedPipeDebugAdapter=D;class f extends P{constructor(u,m){super(),this.y=u,this.z=m}async startSession(){const u=this.y.command,m=this.y.args,b=this.y.options||{};try{if(u)if(R.isAbsolute(u)){if(!await y.Promises.exists(u))throw new Error(I.localize(0,null,u))}else u.indexOf("/")<0&&u.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.z));let C=process.env;if(b.env&&Object.keys(b.env).length>0&&(C=l.mixin(l.deepClone(process.env),b.env)),u==="node")if(Array.isArray(m)&&m.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:C,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(n.cwd=b.cwd);const s=o.fork(m[0],m.slice(1),n);if(!s.pid)throw new Error(I.localize(2,null,m[0]));this.x=s}else throw new Error(I.localize(3,null));else{const p={env:C};b.cwd&&(p.cwd=b.cwd),this.x=o.spawn(u,m,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,n)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(C){this.m.fire(C)}}async stopSession(){return this.x?(await this.u(),S.isWindows?new Promise((u,m)=>{const b=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(C,p,n){if(C)return m(C)});b.on("exit",u),b.on("error",m)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(u,m){if(!u)return;const b=Object.create(null);u.runtime&&(u.runtime.indexOf("./")===0?b.runtime=R.join(m,u.runtime):b.runtime=u.runtime),u.runtimeArgs&&(b.runtimeArgs=u.runtimeArgs),u.program&&(R.isAbsolute(u.program)?b.program=u.program:b.program=R.join(m,u.program)),u.args&&(b.args=u.args);const C=u;return C.win&&(b.win=f.A(C.win,m)),C.winx86&&(b.winx86=f.A(C.winx86,m)),C.windows&&(b.windows=f.A(C.windows,m)),C.osx&&(b.osx=f.A(C.osx,m)),C.linux&&(b.linux=f.A(C.linux,m)),b}static platformAdapterExecutable(u,m){let b=Object.create(null);m=m.toLowerCase();for(const a of u)if(a.contributes){const c=a.contributes.debuggers;c&&c.length>0&&c.filter(g=>typeof g.type=="string"&&A.equalsIgnoreCase(g.type,m)).forEach(g=>{const i=f.A(g,a.extensionLocation.fsPath);b=l.mixin(b,i,a.isBuiltin)})}let C;S.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?C=b.winx86||b.win||b.windows:S.isWindows?C=b.win||b.windows:S.isMacintosh?C=b.osx:S.isLinux&&(C=b.linux),C=C||b;const p=C.program||b.program,n=C.args||b.args,s=C.runtime||b.runtime,r=C.runtimeArgs||b.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof p=="string"?[p]:[]).concat(n||[])};if(p)return{type:"executable",command:p,args:n||[]}}}e.ExecutableDebugAdapter=f}),define(ye[231],De([1,0,46,33,11]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(I,O){return new Promise((P,v)=>{let k="";const D=o.spawn(I,O);D.pid&&D.stdout.on("data",f=>{k+=f.toString()}),D.on("error",f=>{v(f)}),D.on("close",f=>{P(k)})})}async function S(I){if(I)if(l.isWindows){const O=await new Promise((P,v)=>{re(["windows-process-tree"],P,v)});return new Promise(P=>{O.getProcessTree(I,v=>{P(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(I)]).then(O=>{const P=O.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},O=>!0);return Promise.resolve(!0)}e.hasChildProcesses=S;var A;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(A||(A={}));function y(I,O,P,v,k){I=I.trim().toLowerCase();let D;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?D=1:I.indexOf("cmd.exe")>=0?D=0:I.indexOf("bash")>=0?D=2:l.isWindows?D=0:D=2;let f,d=" ";switch(D){case 1:if(f=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),v){const u=(0,L.getDriveLetter)(v);u&&(d+=`${u}:; `),d+=`cd ${f(v)}; `}if(k)for(const u in k){const m=k[u];m===null?d+=`Remove-Item env:${u}; `:d+=`\${env:${u}}='${m}'; `}if(O.length>0){const u=O.shift(),m=P?u:f(u);d+=m[0]==="'"?`& ${m} `:`${m} `;for(const b of O)d+=b==="<"||b===">"||P?b:f(b),d+=" "}break;case 0:if(f=u=>(u=u.replace(/\"/g,'""'),u=u.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>u.includes(m))||u.length===0?`"${u}"`:u),v){const u=(0,L.getDriveLetter)(v);u&&(d+=`${u}: && `),d+=`cd ${f(v)} && `}if(k){d+='cmd /C "';for(const u in k){let m=k[u];m===null?d+=`set "${u}=" && `:(m=m.replace(/[&^|<>]/g,b=>`^${b}`),d+=`set "${u}=${m}" && `)}}for(const u of O)d+=u==="<"||u===">"||P?u:f(u),d+=" ";k&&(d+='"');break;case 2:{f=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),m.length===0?'""':m);const u=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(v&&(d+=`cd ${f(v)} ; `),k){d+="/usr/bin/env";for(const m in k){const b=k[m];b===null?d+=` -u ${u(m)}`:d+=` ${u(`${m}=${b}`)}`}d+=" "}for(const m of O)d+=m==="<"||m===">"||P?m:f(m),d+=" ";break}}return d}e.prepareCommand=y}),define(ye[93],De([1,0,22,38,64,87,16,12,11,54]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var D;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(D=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var m;(function(T){T.scheme=S.Schemas.vscodeNotebookCell;const F=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${F.join("")}]+`),Z=7;function _(J,ee){const me=ee.toString(Z),Ie=`${me.length<F.length?F[me.length-1]:"z"}${me}s${(0,o.encodeBase64)(o.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:T.scheme,fragment:Ie})}T.generate=_;function H(J){if(J.scheme!==T.scheme)return;const ee=J.fragment.indexOf("s");if(ee<0)return;const me=parseInt(J.fragment.substring(0,ee).replace(B,""),Z),ve=(0,o.decodeBase64)(J.fragment.substring(ee+1)).toString();if(!isNaN(me))return{handle:me,notebook:J.with({scheme:ve,fragment:null})}}T.parse=H;function Y(J,ee){return J.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${ee??""},${J.scheme!==S.Schemas.file?J.scheme:""}`})}T.generateCellOutputUri=Y;function ie(J){if(J.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!ee)return;const me=ee[1]&&ee[1]!==""?ee[1]:void 0,ve=ee[2];return{outputId:me,notebook:J.with({scheme:ve||S.Schemas.file,fragment:null})}}T.parseCellOutputUri=ie;function ge(J,ee,me){return T.generate(J,ee).with({scheme:me})}T.generateCellPropertyUri=ge;function X(J,ee){if(J.scheme===ee)return T.parse(J.with({scheme:T.scheme}))}T.parseCellPropertyUri=X})(m=e.CellUri||(e.CellUri={}));const b=T=>y.isWindows?T.replace(/\//g,"\\"):T;class C{constructor(F=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.e=B,this.d=[...new Set(F)].map(Z=>({pattern:Z,matches:L.parse(b(Z))}))}sort(F){const B=new Map(l.Iterable.map(F,_=>[_,b(_)]));let Z=[];for(const{matches:_}of this.d)for(const[H,Y]of B)if(_(Y)){Z.push(H),B.delete(H);break}return B.size&&(Z=Z.concat([...B.keys()].sort((_,H)=>this.e.indexOf(_)-this.e.indexOf(H)))),Z}prioritize(F,B){const Z=this.f(F);if(Z===-1){this.d.unshift({pattern:F,matches:L.parse(b(F))});return}const _=new Set(B.map(Y=>this.f(Y,Z)));_.delete(-1);const H=Array.from(_).sort();this.d.splice(Z+1,0,...H.map(Y=>this.d[Y]));for(let Y=H.length-1;Y>=0;Y--)this.d.splice(H[Y],1)}toArray(){return this.d.map(F=>F.pattern)}f(F,B=this.d.length){const Z=b(F);for(let _=0;_<B;_++)if(this.d[_].matches(Z))return _;return-1}}e.MimeTypeDisplayOrder=C;function p(T,F,B,Z=(_,H)=>_===H){const _=[];function H(ge,X,J){if(X===0&&J.length===0)return;const ee=_[_.length-1];ee&&ee.start+ee.deleteCount===ge?(ee.deleteCount+=X,ee.toInsert.push(...J)):_.push({start:ge,deleteCount:X,toInsert:J})}let Y=0,ie=0;for(;;){if(Y===T.length){H(Y,0,F.slice(ie));break}if(ie===F.length){H(Y,T.length-Y,[]);break}const ge=T[Y],X=F[ie];if(Z(ge,X)){Y+=1,ie+=1;continue}B(X)?(H(Y,1,[]),Y+=1):(H(Y,0,[X]),ie+=1)}return _}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(T){T.default="default",T.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(T){const F=T;return!!((typeof F.include=="string"||L.isRelativePattern(F.include))&&(typeof F.exclude=="string"||L.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=s;function r(T,F,B){if(Array.isArray(T.viewType)&&T.viewType.indexOf(F)>=0||T.viewType===F)return!0;if(T.filenamePattern){const Z=s(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,_=s(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(L.match(Z,(0,A.basename)(B.fsPath).toLowerCase()))return!(_&&L.match(_,(0,A.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var a;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(F){return`${c.d}${F}`}static parse(F){if(F.startsWith(c.d))return F.substring(c.d.length)}}c.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=c;function g(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.isTextStreamMime=g;const i=new TextDecoder;function t(T){const F=[];let B=!1;for(const Z of T)(F.length===0||B)&&(F.push(Z),B=!0);return N(F),U(o.VSBuffer.concat(F.map(Z=>o.VSBuffer.wrap(Z))))}e.compressOutputItemStreams=t;const h=`${String.fromCharCode(27)}[A`,E=h.split("").map(T=>T.charCodeAt(0)),w=10;function N(T){T.forEach((F,B)=>{if(B===0||F.length<h.length)return;const Z=T[B-1],_=F.subarray(0,h.length);if(_[0]===E[0]&&_[1]===E[1]&&_[2]===E[2]){const H=Z.lastIndexOf(w);if(H===-1)return;T[B-1]=Z.subarray(0,H),T[B]=F.subarray(h.length)}})}function j(T){let F=T;do T=F,F=T.replace(/[^\n]\x08/gm,"");while(F.length<T.length);return T}function V(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const F=T.match(/^(.*)\r+/m)[1];let B=T.match(/\r+(.*)$/m)[1];B=B+F.slice(B.length,F.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return T}const Q="\b".charCodeAt(0),q="\r".charCodeAt(0);function U(T){return!T.buffer.includes(Q)&&!T.buffer.includes(q)?T:o.VSBuffer.fromString(V(j(i.decode(T.buffer))))}}),define(ye[232],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(ye[57],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(R){R.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(S,A,y=S.parent){if(S._isRoot)return new l([A]);const I=[S.id];for(let O=y;O&&O.id!==A;O=O.parent)I.push(O.id);return I.push(A),new l(I.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const A=S.indexOf("\0");return A===-1?S:S.slice(0,A)}static fromString(S){return new l(S.split("\0"))}static join(S,A){return new l([...S.path,A])}static joinToString(S,A){return S.toString()+"\0"+A}static parentId(S){const A=S.lastIndexOf("\0");return A===-1?void 0:S.slice(0,A)}static localId(S){const A=S.lastIndexOf("\0");return A===-1?S:S.slice(A+1)}static compare(S,A){return S===A?0:A.startsWith(S+"\0")?2:S.startsWith(A+"\0")?3:1}constructor(S,A=S.length){if(this.path=S,this.d=A,S.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new l(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new l(this.path,S)}compare(S){if(typeof S=="string")return l.compare(this.toString(),S);for(let A=0;A<S.d&&A<this.d;A++)if(S.path[A]!==this.path[A])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.TestId=l}),define(ye[75],De([1,0,2,32,57]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(i){i[i.Unset=0]="Unset",i[i.Queued=1]="Queued",i[i.Running=2]="Running",i[i.Passed=3]="Passed",i[i.Failed=4]="Failed",i[i.Skipped=5]="Skipped",i[i.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var S;(function(i){i[i.Run=2]="Run",i[i.Debug=4]="Debug",i[i.Coverage=8]="Coverage",i[i.HasNonDefaultProfile=16]="HasNonDefaultProfile",i[i.HasConfigurable=32]="HasConfigurable",i[i.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=i=>"runId"in i;e.isStartControllerTests=A;var y;(function(i){i.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),i.deserialize=t=>({range:L.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var I;(function(i){i[i.Error=0]="Error",i[i.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var O;(function(i){i.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.deserialize(t.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const P=(i,t)=>`${t?"s":"e"}${i}`;e.getMarkId=P;var v;(function(i){i.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.serialize(t.location)}),i.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.deserialize(t.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var k;(function(i){i.serialize=t=>t.type===0?O.serialize(t):v.serialize(t),i.deserialize=t=>t.type===0?O.deserialize(t):v.deserialize(t)})(k=e.ITestMessage||(e.ITestMessage={}));var D;(function(i){i.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),i.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(k.serialize)}),i.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(k.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",d=(i,t)=>i+f+t;e.namespaceTestTag=d;const u=i=>{const t=i.indexOf(f);return{ctrlId:i.slice(0,t),tagId:i.slice(t+1)}};e.denamespaceTestTag=u;var m;(function(i){i.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),i.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?L.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(m=e.ITestItem||(e.ITestItem={}));var b;(function(i){i[i.NotExpandable=0]="NotExpandable",i[i.Expandable=1]="Expandable",i[i.BusyExpanding=2]="BusyExpanding",i[i.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var C;(function(i){i.serialize=t=>({expand:t.expand,item:m.serialize(t.item)}),i.deserialize=t=>({controllerId:l.TestId.root(t.item.extId),expand:t.expand,item:m.deserialize(t.item)})})(C=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(i){i.serialize=t=>{let h;return t.item&&(h={},t.item.label!==void 0&&(h.label=t.item.label),t.item.tags!==void 0&&(h.tags=t.item.tags),t.item.busy!==void 0&&(h.busy=t.item.busy),t.item.uri!==void 0&&(h.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(h.range=t.item.range?.toJSON()),t.item.description!==void 0&&(h.description=t.item.description),t.item.error!==void 0&&(h.error=t.item.error),t.item.sortText!==void 0&&(h.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:h}},i.deserialize=t=>{let h;return t.item&&(h={},t.item.label!==void 0&&(h.label=t.item.label),t.item.tags!==void 0&&(h.tags=t.item.tags),t.item.busy!==void 0&&(h.busy=t.item.busy),t.item.range!==void 0&&(h.range=t.item.range?L.Range.lift(t.item.range):null),t.item.description!==void 0&&(h.description=t.item.description),t.item.error!==void 0&&(h.error=t.item.error),t.item.sortText!==void 0&&(h.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:h}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const n=(i,t)=>{t.expand!==void 0&&(i.expand=t.expand),t.item!==void 0&&(i.item=i.item?Object.assign(i.item,t.item):t.item)};e.applyTestItemUpdate=n;var s;(function(i){i.serializeWithoutMessages=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(D.serializeWithoutMessages),retired:t.retired}),i.serialize=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(D.serialize),retired:t.retired}),i.deserialize=t=>({...C.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(D.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(i){i[i.Function=0]="Function",i[i.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var a;(function(i){i[i.Add=0]="Add",i[i.Update=1]="Update",i[i.DocumentSynced=2]="DocumentSynced",i[i.Remove=3]="Remove",i[i.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",i[i.Retire=5]="Retire",i[i.AddTag=6]="AddTag",i[i.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var c;(function(i){i.deserialize=t=>t.op===0?{op:t.op,item:C.deserialize(t.item)}:t.op===1?{op:t.op,item:p.deserialize(t.item)}:t.op===2?{op:t.op,uri:o.URI.revive(t.uri),docv:t.docv}:t,i.serialize=t=>t.op===0?{op:t.op,item:C.serialize(t.item)}:t.op===1?{op:t.op,item:p.serialize(t.item)}:t})(c=e.TestsDiffOp||(e.TestsDiffOp={}));class g{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const h=this.o();for(const E of t)switch(E.op){case 0:this.j(C.deserialize(E.item),h);break;case 1:this.k(p.deserialize(E.item),h);break;case 3:this.l(E.itemId,h);break;case 5:this.m(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this.c.set(E.tag.id,E.tag);break;case 7:this.c.delete(E.id);break}h.complete?.()}j(t,h){const E=l.TestId.parentId(t.item.extId)?.toString();let w;if(!E)w=this.p(t),this.f.add(w),this.d.set(t.item.extId,w);else if(this.d.has(E)){const N=this.d.get(E);N.children.add(t.item.extId),w=this.p(t,N),this.d.set(t.item.extId,w)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return h.add?.(w),t.expand===2&&this.g++,w}k(t,h){const E=this.d.get(t.extId);if(!!E)return t.expand!==void 0&&(E.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(E,t),h.update?.(E),E}l(t,h){const E=this.d.get(t);if(!E)return;const w=l.TestId.parentId(E.item.extId)?.toString();w?this.d.get(w).children.delete(E.item.extId):this.f.delete(E);const N=[[t]];for(;N.length;)for(const j of N.pop()){const V=this.d.get(j);V&&(N.push(V.children),this.d.delete(j),h.remove?.(V,V!==E),V.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=g}),define(ye[94],De([1,0,19,3,6,50,75,57]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(m,b)=>m===b,P=Object.entries({range:(m,b)=>m===b?!0:!m||!b?!1:m.equalsRange(b),busy:I,label:I,description:I,error:I,sortText:I,tags:(m,b)=>!(m.length!==b.length||m.some(C=>!b.includes(C)))}),v=(m,b)=>{let C;for(const[p,n]of P)n(m[p],b[p])||(C?C[p]=b[p]:C={[p]:b[p]});return C};class k extends l.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new L.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const C of this.tree.values())this.G(C)}get resolveHandler(){return this.h}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const C of this.k)if(C.op===2&&C.uri===b.uri){C.docv=b.docv;return}break}case 1:{const C=this.k[this.k.length-1];if(C){if(C.op===1&&C.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(C.item,b.item);return}if(C.op===0&&C.item.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(C.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,C){const p=this.tree.get(b);if(!!p){if((p.expandLevels===void 0||C>p.expandLevels)&&(p.expandLevels=C),p.expand===1){const n=this.I(p);return n.isOpen()?this.H(p,C-1):n.wait().then(()=>this.H(p,C-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,C-1)):this.H(p,C-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,C){switch(C.op){case 3:this.L(A.TestId.joinToString(b.fullId,C.id));break;case 0:this.u(C.item,b);break;case 5:for(const p of C.ops)this.p(b,p);break;case 1:this.w(C.new,C.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:C.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(C)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,C){const p=A.TestId.fromExtHostTestItem(b,this.root.id,C?.actual),n=this.m.getApiFor(b);n.parent&&n.parent!==C?.actual&&this.m.getChildren(n.parent).delete(b.id);let s=this.tree.get(p.toString());if(!s){s={fullId:p,actual:b,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(b,C),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(b)}}),this.F(b,s,C);return}if(s.actual===b){this.D(b,s,C);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.L(p.toString()),this.u(b,C);const r=this.m.getChildren(s.actual),a=s.actual,c=v(this.m.toITestItem(a),this.m.toITestItem(b));this.m.getApiFor(a).listener=void 0,s.actual=b,s.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(b.tags,a.tags,p.toString()),delete c.tags),this.p(s,{op:4,update:c})),this.F(b,s,C);for(const[g,i]of r)this.m.getChildren(b).get(i.id)||this.L(A.TestId.joinToString(p,i.id));this.s(s.actual.uri)}w(b,C,p){const n=new Set(C.map(s=>s.id));for(const s of b)n.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:p,item:{tags:b.map(s=>(0,S.namespaceTestTag)(this.m.controllerId,s.id))}}}),n.forEach(this.z,this)}y(b){const C=this.j.get(b.id);C?C.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const C=this.j.get(b);C&&!--C.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.m.controllerId,b)}))}C(b,C){this.m.getApiFor(b).parent=C&&C.actual!==this.root?C.actual:void 0}D(b,C,p){this.C(b,p);const n=this.m.getApiFor(b);n.parent=p?.actual,n.listener=s=>this.p(C,s),this.G(C)}F(b,C,p){this.D(b,C,p);for(const[n,s]of this.m.getChildren(b))this.u(s,C)}G(b){let C;this.h?b.resolveBarrier?C=b.resolveBarrier.isOpen()?3:2:C=b.actual.canResolveChildren?1:0:C=0,C!==b.expand&&(b.expand=C,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:C}}),C===1&&b.expandLevels!==void 0&&this.I(b))}H(b,C){if(C<0)return;const p=[];for(const[n,s]of this.m.getChildren(b.actual)){const r=this.expand(A.TestId.joinToString(b.fullId,s.id),C);(0,o.isThenable)(r)&&p.push(r)}if(p.length)return Promise.all(p).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const s=new o.Barrier;return s.open(),s}b.expand=2,this.J(b);const C=b.resolveBarrier=new o.Barrier,p=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let n;try{n=this.h(b.actual===this.root?void 0:b.actual)}catch(s){p(s)}return(0,o.isThenable)(n)?n.catch(p).then(()=>{C.open(),this.G(b)}):(C.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const C=this.tree.get(b);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const p=[C];for(;p.length;){const n=p.pop();if(!!n){this.m.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.z(s.id);this.tree.delete(n.fullId.toString());for(const[s,r]of this.m.getChildren(n.actual))p.push(this.tree.get(A.TestId.joinToString(n.fullId,r.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=k;class D extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=D;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(b,C,p){super(`TestItem with ID "${b}" is from controller "${C}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=d;const u=(m,b,C)=>{let p=new Map;return{get size(){return p.size},forEach(n,s){for(const r of p.values())n.call(s,r,this)},[Symbol.iterator](){return p.entries()},replace(n){const s=new Map,r=new Set(p.keys()),a={op:5,ops:[]};for(const c of n){if(!(c instanceof C))throw new f(c.id);const g=b(c).controllerId;if(g!==m.controllerId)throw new d(c.id,g,m.controllerId);if(s.has(c.id))throw new D(c.id);s.set(c.id,c),r.delete(c.id),a.ops.push({op:0,item:c})}for(const c of r.keys())a.ops.push({op:3,id:c});m.listener?.(a),p=s},add(n){if(!(n instanceof C))throw new f(n.id);p.set(n.id,n),m.listener?.({op:0,item:n})},delete(n){p.delete(n)&&m.listener?.({op:3,id:n})},get(n){return p.get(n)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=u}),define(ye[132],De([1,0,94]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,l=(S,A)=>{const y={controllerId:A};return L.set(S,y),y};e.createPrivateApiFor=l;const R=S=>{const A=L.get(S);if(!A)throw new o.InvalidTestItemError(S?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[95],De([1,0,16,2]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(A,y){return A.scheme===o.Schemas.http||A.scheme===o.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===o.Schemas.file&&(A=L.URI.from({scheme:o.Schemas.vscodeRemote,authority:y.authority,path:A.path})),L.URI.from({scheme:o.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=l;function R(A){return A.replace(/./g,y=>{const I=y.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?y:"-"+I.toString(16).padStart(4,"0")})}function S(A){return A.replace(/-([0-9a-f]{4})/g,(y,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=S}),define(ye[233],De([1,0,3,6,95]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,y,I){this.d=A,this.e=y,this.f=I,this.a=0,this.b=new L.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const P of this.c.values())O.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,I,O,P){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===A){v=b;break}if(!v)throw new Error("not a visible editor");const k=this,D=this.a++,f=new o.Emitter,d=new o.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,l.asWebviewUri)(b,k.f)}get cspSource(){return l.webviewGenericCspSource}set options(b){this.b=b,k.d.$setOptions(D,b)}get options(){return this.b}set html(b){this.a=b,k.d.$setHtml(D,b)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(b){return k.d.$postMessage(D,b)}},m=new class{constructor(){this.editor=A,this.line=y,this.height=I,this.webview=u,this.onDidDispose=d.event}dispose(){k.c.has(D)&&(k.c.delete(D),k.d.$disposeEditorInset(D),d.fire(),d.dispose(),f.dispose())}};return this.d.$createEditorInset(D,v.id,v.value.document.uri,y+1,I,O||{},P.identifier,P.extensionLocation),this.c.set(D,{editor:A,inset:m,onDidReceiveMessage:f}),m}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(ye[234],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var L;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(L=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(S,A){super(A),this.variable=S}}e.VariableError=l}),define(ye[235],De([1,0,12,36,9,23,11,113,194,234,8]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(k,D,f,d){this.g=new Map,this.a=k,this.b=D,this.d=f,d&&(this.c=d.then(u=>this.h(u)))}h(k){if(S.isWindows){const D=Object.create(null);return Object.keys(k).forEach(f=>{D[f.toLowerCase()]=k[f]}),D}return k}resolveWithEnvironment(k,D,f){return this.j({env:this.h(k),userHome:void 0},D?D.uri:void 0,f)}async resolveAsync(k,D){const f={env:await this.c,userHome:await this.d};return this.j(f,k?k.uri:void 0,D)}async i(k,D,f,d){const u=R.deepClone(D);S.isWindows&&u.windows?Object.keys(u.windows).forEach(b=>u[b]=u.windows[b]):S.isMacintosh&&u.osx?Object.keys(u.osx).forEach(b=>u[b]=u.osx[b]):S.isLinux&&u.linux&&Object.keys(u.linux).forEach(b=>u[b]=u.linux[b]),delete u.windows,delete u.osx,delete u.linux;const m={env:await this.c,userHome:await this.d};return this.j(m,k?k.uri:void 0,u,f,d)}async resolveAnyAsync(k,D,f){return this.i(k,D,f)}async resolveAnyMap(k,D,f){const d=new Map;return{newConfig:await this.i(k,D,f,d),resolvedVariables:d}}resolveWithInteractionReplace(k,D,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,D,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,D){if(this.g.has(k))throw new Error("Variable "+k+" is contributed twice.");this.g.set(k,D)}async j(k,D,f,d,u){if(l.isString(f))return this.l(k,D,f,d,u);if(Array.isArray(f))return Promise.all(f.map(m=>this.j(k,D,m,d,u)));if(l.isObject(f)){const m=Object.create(null),b=await Promise.all(Object.keys(f).map(async C=>[await this.l(k,D,C,d,u),await this.j(k,D,f[C],d,u)]));for(const[C,p]of b)m[C]=p;return m}return f}l(k,D,f,d,u){return(0,O.replaceAsync)(f,P.VARIABLE_REGEXP,async(m,b)=>{if(b.includes(P.VARIABLE_LHS))return m;let C=await this.n(k,m,b,D,d);return u?.set(b,C),C!==m&&l.isString(C)&&C.match(P.VARIABLE_REGEXP)&&(C=await this.l(k,D,C,d,u)),C})}m(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async n(k,D,f,d,u){let m;const b=f.split(":");b.length>1&&(f=b[0],m=b[1]);const C=s=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new I.VariableError(s,(0,y.localize)(0,null,D))},p=s=>{const r=C(s);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,A.normalizeDriveLetter)(a)}throw new I.VariableError(s,(0,y.localize)(1,null,D,o.basename(r)))},n=s=>{if(m){const r=this.a.getFolderUri(m);if(r)return r;throw new I.VariableError(s,(0,y.localize)(2,null,D,m))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new I.VariableError(s,(0,y.localize)(3,null,D)):new I.VariableError(s,(0,y.localize)(4,null,D))};switch(f){case"env":if(m){if(k.env){const s=k.env[S.isWindows?m.toLowerCase():m];if(l.isString(s))return s}return""}throw new I.VariableError(I.VariableKind.Env,(0,y.localize)(5,null,D));case"config":if(m){const s=this.a.getConfigurationValue(d,m);if(l.isUndefinedOrNull(s))throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(6,null,D,m));if(l.isObject(s))throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(7,null,D,m));return s}throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(8,null,D));case"command":return this.o(I.VariableKind.Command,D,m,u,"command");case"input":return this.o(I.VariableKind.Input,D,m,u,"input");case"extensionInstallFolder":if(m){const s=await this.a.getExtension(m);if(!s)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,D,m));return this.m(s.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,D));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(n(I.VariableKind.WorkspaceFolder)));case"cwd":return d||m?(0,A.normalizeDriveLetter)(this.m(n(I.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(o.basename(this.m(n(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,y.localize)(11,null,D))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new I.VariableError(I.VariableKind.LineNumber,(0,y.localize)(12,null,D))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new I.VariableError(I.VariableKind.SelectedText,(0,y.localize)(13,null,D))}case"file":return C(I.VariableKind.File);case"fileWorkspaceFolder":return p(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||m?o.relative(this.m(n(I.VariableKind.RelativeFile)),C(I.VariableKind.RelativeFile)):C(I.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(C(I.VariableKind.RelativeFileDirname));if(d||m){const r=o.relative(this.m(n(I.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return o.dirname(C(I.VariableKind.FileDirname));case"fileExtname":return o.extname(C(I.VariableKind.FileExtname));case"fileBasename":return o.basename(C(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(C(I.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(C(I.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||D}case"execInstallFolder":{const s=this.a.getAppRoot();return s||D}case"pathSeparator":return o.sep;default:try{const s=m?`${f}:${m}`:f;return this.o(I.VariableKind.Unknown,D,s,u,void 0)}catch{return D}}}}o(k,D,f,d,u){if(f&&d){const m=u===void 0?d[f]:d[u+":"+f];if(typeof m=="string")return m;throw new I.VariableError(k,(0,y.localize)(14,null,D))}return D}}P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=P}),define(ye[133],De([1,0,4,130]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var l;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var R;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var A;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function I(D){const f=D;return(0,L.isEditorInput)(f?.editor)&&(0,L.isEditorInput)(f?.replacement)}e.isEditorReplacement=I;var O;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function v(D){const f=D;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=v;function k(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(ye[236],De([1,0,4,133]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(R){const S=R;return typeof R=="number"||(0,L.isEditorGroup)(S)}e.isPreferredGroup=l}),define(ye[237],De([1,0,4,201]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(L.IEnvironmentService)}),define(ye[134],De([1,0,27,3,12]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=R;class S{static isHostExtension(P,v,k){if(v.getExtensionDescription(P))return!1;const D=k.getExtensionDescription(P);return D?!!((D.main||D.browser)&&D.api==="none"):!1}constructor(P){this.c=new L.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(o.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(o.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let v of P.activationEvents)v==="onUri"&&(v=`onUri:${o.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,v){this.d=I(this.d,v),this.d=this.d.concat(P);const k=S.j(this.d);return this.d=I(this.d,k.map(D=>D.identifier)),this.h(),this.c.fire(void 0),new R(k)}static j(P){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,m){this.addNode(u),this.addNode(m),this.c.has(u)?this.c.get(u).push(m):this.c.set(u,[m])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,m){const b=v.getArcs(u);for(let C=0;C<b.length;C++)if(!m.has(b[C]))return!1;return!0}getNodes(){return this.e}},k=new Map;for(const u of P){const m=o.ExtensionIdentifier.toKey(u.identifier);if(k.set(m,u),u.extensionDependencies)for(const b of u.extensionDependencies){const C=o.ExtensionIdentifier.toKey(b);v.addArc(m,C)}}const D=new Set;v.getNodes().filter(u=>v.getArcs(u).length===0).forEach(u=>D.add(u));const f=v.getNodes().filter(u=>!D.has(u));let d;do{d=!1;for(let u=0;u<f.length;u++){const m=f[u];v.hasOnlyGoodArcs(m,D)&&(f.splice(u,1),u--,D.add(m),d=!0)}}while(d);return f.map(u=>k.get(u))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(o.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const v=this.g.get(P);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const v=this.e.get(o.ExtensionIdentifier.toKey(P));return v||void 0}getExtensionDescriptionByUUID(P){for(const v of this.f)if(v.uuid===P)return v}getExtensionDescriptionByIdOrUUID(P,v){return this.getExtensionDescription(P)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=S;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function y(O,P){const v=O.isBuiltin?0:O.isUnderDevelopment?2:1,k=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(v!==k)return v-k;const D=l.posix.basename(O.extensionLocation.path),f=l.posix.basename(P.extensionLocation.path);return D<f?-1:D>f?1:0}function I(O,P){const v=new Set;return P.forEach(k=>v.add(o.ExtensionIdentifier.toKey(k))),O.filter(k=>!v.has(o.ExtensionIdentifier.toKey(k.identifier)))}}),define(ye[238],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(O){O[O.IPC=1]="IPC",O[O.Socket=2]="Socket",O[O.MessagePort=3]="MessagePort"})(o=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class L{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[L.ENV_KEY]=this.pipeName}}L.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=L;class l{constructor(){this.type=2}serialize(P){P[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function S(O){delete O[L.ENV_KEY],delete O[l.ENV_KEY],delete O[R.ENV_KEY]}function A(O,P){S(P),O.serialize(P)}e.writeExtHostConnection=A;function y(O){if(O[L.ENV_KEY])return I(O,new L(O[L.ENV_KEY]));if(O[l.ENV_KEY])return I(O,new l);if(O[R.ENV_KEY])return I(O,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function I(O,P){return S(O),P}}),define(ye[96],De([1,0,22]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(L=e.UIKind||(e.UIKind={}));var l;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function S(I){const O=o.VSBuffer.alloc(1);switch(I){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=S;function A(I,O){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var y;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[76],De([1,0,4,3,13,25,96,72,73,23,2,6,181]),function(re,e,o,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class extends P.Disposable{constructor(u,m){super(),this.m=u,this.n=m,this.a=this.B(new L.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=O.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=m.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(m.onDidChangeLogLevel(b=>{(0,l.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,m,b){const C=this.getTelemetryDetails(),p=new D(m,b,u,this.k,this.i,this.getBuiltInCommonProperties(u),{isUsageEnabled:C.isUsageEnabled,isErrorsEnabled:C.isErrorsEnabled});return this.l.set(u.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(u,m,b){this.f=u,this.g=m,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(u){const m={};switch(m["common.extname"]=`${u.publisher}.${u.name}`,m["common.extversion"]=u.version,m["common.vscodemachineid"]=this.m.telemetryInfo.machineId,m["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,m["common.vscodeversion"]=this.m.version,m["common.isnewappinstall"]=f(this.m.telemetryInfo.firstSessionDate),m["common.product"]=this.m.environment.appHost,this.m.uiKind){case S.UIKind.Web:m["common.uikind"]="web";break;case S.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),m}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const m=this.getTelemetryDetails();this.l.forEach(b=>{b.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(u,m){const b=this.l.get(u.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(m),!0)}};k=xe([ze(0,R.IExtHostInitDataService),ze(1,l.ILoggerService)],k),e.ExtHostTelemetry=k;class D{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,m,b,C,p,n,s){this.g=b,this.h=C,this.i=p,this.j=n,this.a=new L.Emitter,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(u,m){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let m=u.properties??u;return m=(0,y.cleanData)(m,[]),this.c&&(m=(0,I.mixin)(m,this.c)),this.b||(m=(0,I.mixin)(m,this.j)),u.properties?u.properties=m:u=m,u}k(u,m){!this.f||(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(u,m),this.h.trace(u,m))}logUsage(u,m){!this.d.isUsageEnabled||this.k(u,m)}logError(u,m){!this.d.isErrorsEnabled||!this.f||(typeof u=="string"?this.k(u,m):this.f.sendErrorData(u,m))}get apiTelemetryLogger(){if(!this.e){const u=this,m={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(m)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=D;function f(d){const u=Date.now()-new Date(d).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(ye[26],De([1,0,3,2,4,27,214]),function(re,e,o,L,l,R,S){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class y{constructor(g){this.affinity=g,this.kind=1}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class I{constructor(g){this.affinity=g,this.kind=2}equals(g){return this.kind===g.kind&&this.affinity===g.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=I;class O{constructor(){this.kind=3,this.affinity=0}equals(g){return this.kind===g.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class P{constructor(g){this.dependency=g}}e.MissingExtensionDependency=P;var v;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class D{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(g,i){const t=[],h=[],E=[],w=[],N=u(this.c),j=u(g),V=(T,F)=>T.extensionLocation.toString()===F.extensionLocation.toString()||T.isBuiltin===F.isBuiltin||T.isUserBuiltin===F.isUserBuiltin||T.isUnderDevelopment===F.isUnderDevelopment;for(const T of this.c){const F=j.get(R.ExtensionIdentifier.toKey(T.identifier));if(!F){t.push(T.identifier),N.delete(R.ExtensionIdentifier.toKey(T.identifier));continue}if(!V(T,F)){t.push(T.identifier),N.delete(R.ExtensionIdentifier.toKey(T.identifier));continue}}for(const T of g){const F=N.get(R.ExtensionIdentifier.toKey(T.identifier));if(!F){h.push(T);continue}if(!V(F,T)){t.push(F.identifier),N.delete(R.ExtensionIdentifier.toKey(F.identifier));continue}}const Q=d(this.d),q=d(i);for(const T of this.d)q.has(R.ExtensionIdentifier.toKey(T))||E.push(T);for(const T of i)Q.has(R.ExtensionIdentifier.toKey(T))||w.push(T);const U={toRemove:t,toAdd:h,myToRemove:E,myToAdd:w};return this.delta(U),U}delta(g){const{toRemove:i,toAdd:t,myToRemove:h,myToAdd:E}=g,w=d(i),N=d(h);for(let j=0;j<this.c.length;j++)w.has(R.ExtensionIdentifier.toKey(this.c[j].identifier))&&(this.c.splice(j,1),j--);for(let j=0;j<this.d.length;j++)N.has(R.ExtensionIdentifier.toKey(this.d[j]))&&(this.d.splice(j,1),j--);for(const j of t)this.c.push(j);for(const j of E)this.d.push(j)}containsExtension(g){for(const i of this.d)if(R.ExtensionIdentifier.equals(i,g))return!0;return!1}}e.ExtensionHostExtensions=D;class f{constructor(g){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,g)for(const i of g)this.add(i)}get size(){return this.c.size}add(g){return this.c.set(this.d(g),g),this}clear(){this.c.clear()}delete(g){return this.c.delete(this.d(g))}has(g){return this.c.has(this.d(g))}forEach(g,i){this.c.forEach(t=>g.call(i,t,t,this))}*entries(){for(const[g,i]of this.c)yield[i,i]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=f;function d(c){const g=new Set;for(const i of c)g.add(R.ExtensionIdentifier.toKey(i));return g}e.extensionIdentifiersArrayToSet=d;function u(c){const g=new Map;for(const i of c)g.set(R.ExtensionIdentifier.toKey(i.identifier),i);return g}function m(c,g){return c.enabledApiProposals?c.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=m;function b(c,g){if(!m(c,g))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class C{constructor(g,i,t,h){this.codeLoadingTime=g,this.activateCallTime=i,this.activateResolvedTime=t,this.activationReason=h}}e.ActivationTimes=C;class p{constructor(g,i){this.description=g,this.value=i}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var n;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(n=e.ActivationKind||(e.ActivationKind={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function r(c,g){return{identifier:new R.ExtensionIdentifier((0,S.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!g,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=r;class a{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g,i){return Promise.resolve(0)}getInspectPorts(g,i){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=a}),define(ye[239],De([1,0,10,134,27,26,13,19]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(u,m,b,C){this.startup=u,this.codeLoadingTime=m,this.activateCallTime=b,this.activateResolvedTime=C}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class I{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,m){return u===-1||m===-1?-1:m-u}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=I;class O{constructor(u,m,b,C,p,n){this.activationFailed=u,this.activationFailedError=m,this.activationTimes=b,this.module=C,this.exports=p,this.subscriptions=n}}e.ActivatedExtension=O;class P extends O{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class v extends O{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class k extends O{constructor(u){super(!0,u,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(u,m,b,C){this.g=C,this.a=u,this.b=m,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[u,m]of this.d)m.dispose()}isActivated(u){const m=this.d.get(l.ExtensionIdentifier.toKey(u));return Boolean(m&&m.value)}getActivatedExtension(u){const m=this.d.get(l.ExtensionIdentifier.toKey(u));if(!m||!m.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return m.value}async activateByEvent(u,m){if(this.f[u])return;const b=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(b.map(C=>({id:C.identifier,reason:{startup:m,extensionId:C.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,m){const b=this.a.getExtensionDescription(u);if(!b)throw new Error(`Extension '${u}' is not known`);return this.h([{id:b.identifier,reason:m}])}async h(u){const m=u.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(m.map(b=>b.wait()))}j(u){if(this.d.has(l.ExtensionIdentifier.toKey(u.id)))return this.d.get(l.ExtensionIdentifier.toKey(u.id));if(this.l(u.id))return this.k(u,null,[],null);const m=this.a.getExtensionDescription(u.id);if(!m){const p=new Error(`Cannot activate unknown extension '${u.id.value}'`),n=this.k(u,null,[],new k(p));return this.c.onExtensionActivationError(u.id,p,new R.MissingExtensionDependency(u.id.value)),n}const b=[],C=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const p of C){if(this.m(p))continue;const n=this.d.get(l.ExtensionIdentifier.toKey(p));if(n){b.push(n);continue}if(this.l(p)){b.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:u.reason}));continue}const s=this.a.getExtensionDescription(p);if(s){if(!s.main&&!s.browser)continue;b.push(this.j({id:s.identifier,reason:u.reason}));continue}const r=m.displayName||m.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${p}'`),c=this.k(u,m.displayName,[],new k(a));return this.c.onExtensionActivationError(m.identifier,a,new R.MissingExtensionDependency(p)),c}return this.k(u,m.displayName,b,null)}k(u,m,b,C){const p=new f(u.id,m,u.reason,b,C,this.c,this.g);return this.d.set(l.ExtensionIdentifier.toKey(u.id),p),p}l(u){return L.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const m=this.b.getExtensionDescription(u);return m?!m.main&&!m.browser:!1}};D=xe([ze(3,S.ILogService)],D),e.ExtensionsActivator=D;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,m,b,C,p,n,s){this.c=u,this.d=m,this.f=b,this.g=C,this.h=p,this.j=n,this.k=s,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const m=this.g[u];if(m.value&&!m.value.activationFailed){this.g.splice(u,1),u--;continue}if(m.value&&m.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);b.detail=m.value.activationFailedError,this.h=new k(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const m=new Error;if(u&&u.name&&(m.name=u.name),u&&u.message?m.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(m.stack=u.stack),this.h=new k(m),this.b&&o.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};f=xe([ze(6,S.ILogService)],f)});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[7],De([1,0,15,10,112,28,87,8,9,2,30,44,128,93,26]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";var f,d,u,m,b,C,p,n,s,r,a,c,g,i,t,h,E,w,N,j,V,Q,q;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(x){return Object.assign(x,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(x,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(x,[]);{const[fe,...Te]=arguments;return Reflect.construct(x,Te,fe.constructor)}}})}var T;(function(x){x[x.Top=0]="Top",x[x.Bottom=1]="Bottom"})(T=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var F;(function(x){x[x.Command=0]="Command",x[x.Opener=1]="Opener"})(F=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let B=C=class{static from(...W){let fe=W;return new C(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}constructor(W){f.set(this,void 0),_e(this,f,W,"f")}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),_e(this,f,void 0,"f"))}};f=new WeakMap,B=C=xe([U],B),e.Disposable=B;let Z=p=class{static Min(...W){if(W.length===0)throw new TypeError;let fe=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isBefore(fe)&&(fe=Ke)}return fe}static Max(...W){if(W.length===0)throw new TypeError;let fe=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isAfter(fe)&&(fe=Ke)}return fe}static isPosition(W){if(!W)return!1;if(W instanceof p)return!0;const{line:fe,character:Te}=W;return typeof fe=="number"&&typeof Te=="number"}static of(W){if(W instanceof p)return W;if(this.isPosition(W))return new p(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,fe){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(fe<0)throw(0,L.illegalArgument)("character must be non-negative");this.c=W,this.e=fe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,fe=0){if(W===null||fe===null)throw(0,L.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,fe=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&fe===0?this:new p(this.line+Te,this.character+fe)}with(W,fe=this.character){if(W===null||fe===null)throw(0,L.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,fe=typeof W.character=="number"?W.character:this.character),Te===this.line&&fe===this.character?this:new p(Te,fe)}toJSON(){return{line:this.line,character:this.character}}};Z=p=xe([U],Z),e.Position=Z;let _=n=class{static isRange(W){return W instanceof n?!0:W?Z.isPosition(W.start)&&Z.isPosition(W.end):!1}static of(W){if(W instanceof n)return W;if(this.isRange(W))return new n(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,fe,Te,Ke){let Je,ct;if(typeof W=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new Z(W,fe),ct=new Z(Te,Ke)):Z.isPosition(W)&&Z.isPosition(fe)&&(Je=Z.of(W),ct=Z.of(fe)),!Je||!ct)throw new Error("Invalid arguments");Je.isBefore(ct)?(this.c=Je,this.e=ct):(this.c=ct,this.e=Je)}contains(W){return n.isRange(W)?this.contains(W.start)&&this.contains(W.end):Z.isPosition(W)?!(Z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const fe=Z.Max(W.start,this.c),Te=Z.Min(W.end,this.e);if(!fe.isAfter(Te))return new n(fe,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const fe=Z.Min(W.start,this.c),Te=Z.Max(W.end,this.end);return new n(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,fe=this.end){if(W===null||fe===null)throw(0,L.illegalArgument)();let Te;return W?Z.isPosition(W)?Te=W:(Te=W.start||this.start,fe=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new n(Te,fe)}toJSON(){return[this.start,this.end]}};_=n=xe([U],_),e.Range=_;let H=s=class extends _{static isSelection(W){return W instanceof s?!0:W?_.isRange(W)&&Z.isPosition(W.anchor)&&Z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,fe,Te,Ke){let Je,ct;if(typeof W=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new Z(W,fe),ct=new Z(Te,Ke)):Z.isPosition(W)&&Z.isPosition(fe)&&(Je=Z.of(W),ct=Z.of(fe)),!Je||!ct)throw new Error("Invalid arguments");super(Je,ct),this.f=Je,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};H=s=xe([U],H),e.Selection=H;class Y{constructor(W,fe,Te){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,L.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,L.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(fe),this.connectionToken=Te}}e.ResolvedAuthority=Y;class ie extends Error{static NotAvailable(W,fe){return new ie(W,v.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(W){return new ie(W,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,fe=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var ge;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var X;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=r=class{static isTextEdit(W){return W instanceof r?!0:W?_.isRange(W)&&typeof W.newText=="string":!1}static replace(W,fe){return new r(W,fe)}static insert(W,fe){return r.replace(new _(W,W),fe)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const fe=new r(new _(new Z(0,0),new Z(0,0)),"");return fe.newEol=W,fe}get range(){return this.c}set range(W){if(W&&!_.isRange(W))throw(0,L.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this.f=W}constructor(W,fe){this.c=W,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};J=r=xe([U],J),e.TextEdit=J;let ee=a=class{static isNotebookCellEdit(W){return W instanceof a?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,fe){return new a(W,fe)}static insertCells(W,fe){return new a(new Vt(W,W),fe)}static deleteCells(W){return new a(W,[])}static updateCellMetadata(W,fe){const Te=new a(new Vt(W,W),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(W){const fe=new a(new Vt(0,0),[]);return fe.newNotebookMetadata=W,fe}constructor(W,fe){this.range=W,this.newCells=fe}};ee=a=xe([U],ee),e.NotebookEdit=ee;class me{static isSnippetTextEdit(W){return W instanceof me?!0:W?_.isRange(W.range)&&Re.isSnippetString(W.snippet):!1}static replace(W,fe){return new me(W,fe)}static insert(W,fe){return me.replace(new _(W,W),fe)}constructor(W,fe){this.range=W,this.snippet=fe}}e.SnippetTextEdit=me;var ve;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let Ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,fe,Te,Ke){this.c.push({_type:1,from:W,to:fe,options:Te,metadata:Ke})}createFile(W,fe,Te){this.c.push({_type:1,from:void 0,to:W,options:fe,metadata:Te})}deleteFile(W,fe,Te){this.c.push({_type:1,from:W,to:void 0,options:fe,metadata:Te})}e(W,fe,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(W,fe,Te,Ke){const Je=fe.start,ct=fe.end;(Je!==ct||Te.length>0)&&this.c.push({_type:5,uri:W,index:Je,count:ct-Je,cells:Te,metadata:Ke})}g(W,fe,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:fe,metadata:Te}})}replace(W,fe,Te,Ke){this.c.push({_type:2,uri:W,edit:new J(fe,Te),metadata:Ke})}insert(W,fe,Te,Ke){this.replace(W,new _(fe,fe),Te,Ke)}delete(W,fe,Te){this.replace(W,fe,"",Te)}has(W){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===W.toString())}set(W,fe){if(fe)for(const Te of fe){if(!Te)continue;let Ke,Je;Array.isArray(Te)?(Ke=Te[0],Je=Te[1]):Ke=Te,ee.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,Je):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,Je):this.f(W,Ke.range,Ke.newCells,Je):me.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:Je}):this.c.push({_type:2,uri:W,edit:Ke,metadata:Je})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,o.coalesceInPlace)(this.c)}}get(W){const fe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&fe.push(Te.edit);return fe}entries(){const W=new R.ResourceMap;for(const fe of this.c)if(fe._type===2){let Te=W.get(fe.uri);Te||(Te=[fe.uri,[]],W.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ie=xe([U],Ie),e.WorkspaceEdit=Ie;let Re=c=class{static isSnippetString(W){return W instanceof c?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=c.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,fe=this.e++){if(typeof W=="function"){const Te=new c;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=c.c(W);return this.value+="${",this.value+=fe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,fe=this.e++){const Te=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,fe){if(typeof fe=="function"){const Te=new c;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};Re=c=xe([U],Re),e.SnippetString=Re;var ae;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(ae=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=g=class{static isLocation(W){return W instanceof g?!0:W?_.isRange(W.range)&&I.URI.isUri(W.uri):!1}constructor(W,fe){if(this.uri=W,fe)if(_.isRange(fe))this.range=_.of(fe);else if(Z.isPosition(fe))this.range=new _(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ue=g=xe([U],ue),e.Location=ue;let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&_.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}constructor(W,fe){this.location=W,this.message=fe}static isEqual(W,fe){return W===fe?!0:!W||!fe?!1:W.message===fe.message&&W.location.range.isEqual(fe.location.range)&&W.location.uri.toString()===fe.location.uri.toString()}};ne=xe([U],ne),e.DiagnosticRelatedInformation=ne;let ce=class{constructor(W,fe,Te=le.Error){if(!_.isRange(W))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=W,this.message=fe,this.severity=Te}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,fe){return W===fe?!0:!W||!fe?!1:W.message===fe.message&&W.severity===fe.severity&&W.code===fe.code&&W.severity===fe.severity&&W.source===fe.source&&W.range.isEqual(fe.range)&&(0,o.equals)(W.tags,fe.tags)&&(0,o.equals)(W.relatedInformation,fe.relatedInformation,ne.isEqual)}};ce=xe([U],ce),e.Diagnostic=ce;let oe=class{constructor(W,fe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=fe}};oe=xe([U],oe),e.Hover=oe;var M;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(M=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let z=class{constructor(W,fe=M.Text){this.range=W,this.kind=fe}toJSON(){return{range:this.range,kind:M[this.kind]}}};z=xe([U],z),e.DocumentHighlight=z;var G;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(G=e.SymbolKind||(e.SymbolKind={}));var te;(function(x){x[x.Deprecated=1]="Deprecated"})(te=e.SymbolTag||(e.SymbolTag={}));let de=i=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,fe,Te,Ke,Je){this.name=W,this.kind=fe,this.containerName=Je,typeof Te=="string"&&(this.containerName=Te),Ke instanceof ue?this.location=Ke:Te instanceof _&&(this.location=new ue(Ke,Te)),i.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};de=i=xe([U],de),e.SymbolInformation=de;let we=t=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(t.validate)}constructor(W,fe,Te,Ke,Je){this.name=W,this.detail=fe,this.kind=Te,this.range=Ke,this.selectionRange=Je,this.children=[],t.validate(this)}};we=t=xe([U],we),e.DocumentSymbol=we;var Pe;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(W,fe){this.title=W,this.kind=fe}};be=xe([U],be),e.CodeAction=be;let Ce=h=class{constructor(W){this.value=W}append(W){return new h(this.value?this.value+h.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+h.c)}};Ce.c=".",Ce=h=xe([U],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(W,fe){if(this.range=W,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=xe([U],ke),e.SelectionRange=ke;class He{constructor(W,fe,Te,Ke,Je,ct){this.kind=W,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.CallHierarchyItem=He;class Ge{constructor(W,fe){this.fromRanges=fe,this.from=W}}e.CallHierarchyIncomingCall=Ge;class nt{constructor(W,fe){this.fromRanges=fe,this.to=W}}e.CallHierarchyOutgoingCall=nt;var Qe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(W,fe){this.range=W,this.command=fe}get isResolved(){return!!this.command}};tt=xe([U],tt),e.CodeLens=tt;let rt=E=class{static isMarkdownString(W){return W instanceof E?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,fe=!1){d.set(this,void 0),_e(this,d,new l.MarkdownString(W,{supportThemeIcons:fe}),"f")}get value(){return Ue(this,d,"f").value}set value(W){Ue(this,d,"f").value=W}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(W){Ue(this,d,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,d,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,d,"f").supportHtml}set supportHtml(W){Ue(this,d,"f").supportHtml=W}get baseUri(){return Ue(this,d,"f").baseUri}set baseUri(W){Ue(this,d,"f").baseUri=W}appendText(W){return Ue(this,d,"f").appendText(W),this}appendMarkdown(W){return Ue(this,d,"f").appendMarkdown(W),this}appendCodeblock(W,fe){return Ue(this,d,"f").appendCodeblock(fe??"",W),this}};d=new WeakMap,rt=E=xe([U],rt),e.MarkdownString=rt;let Be=class{constructor(W,fe){this.label=W,this.documentation=fe}};Be=xe([U],Be),e.ParameterInformation=Be;let it=class{constructor(W,fe){this.label=W,this.documentation=fe,this.parameters=[]}};it=xe([U],it),e.SignatureInformation=it;let $=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};$=xe([U],$),e.SignatureHelp=$;var K;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(K=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(W){this.value=W}};Le=xe([U],Le),e.InlayHintLabelPart=Le;let Ne=class{constructor(W,fe,Te){this.position=W,this.label=fe,this.kind=Te}};Ne=xe([U],Ne),e.InlayHint=Ne;var qe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(x){x[x.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let st=class{constructor(W,fe){this.label=W,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};st=xe([U],st),e.CompletionItem=st;let at=class{constructor(W=[],fe=!1){this.items=W,this.isIncomplete=fe}};at=xe([U],at),e.CompletionList=at;let mt=class{constructor(W,fe,Te){this.insertText=W,this.range=fe,this.command=Te}};mt=xe([U],mt),e.InlineSuggestion=mt;let gt=class{constructor(W){this.commands=void 0,this.items=W}};gt=xe([U],gt),e.InlineSuggestionList=gt;var Et;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var lt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var xt;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(xt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var jt;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(jt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function W(fe){switch(fe){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=W}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Bt=class{constructor(W,fe){if(fe&&!I.URI.isUri(fe))throw(0,L.illegalArgument)("target");if(!_.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=fe}};Bt=xe([U],Bt),e.DocumentLink=Bt;let At=class{constructor(W,fe,Te,Ke){this.red=W,this.green=fe,this.blue=Te,this.alpha=Ke}};At=xe([U],At),e.Color=At;let Xe=class{constructor(W,fe){if(fe&&!(fe instanceof At))throw(0,L.illegalArgument)("color");if(!_.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=fe}};Xe=xe([U],Xe),e.ColorInformation=Xe;let Nt=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};Nt=xe([U],Nt),e.ColorPresentation=Nt;var Gt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Gt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(W,fe,Te){if(this.startIndex=W,this.length=fe,this.tooltip=Te,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,L.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=Ae;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var se;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(se=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(W){if(this.options=W,typeof W!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=Fe;var We;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(We=e.TaskRevealKind||(e.TaskRevealKind={}));var Ye;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Ye=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=w=class{static from(W){switch(W){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(W,fe){if(this.label=fe,typeof W!="string"||typeof fe!="string")throw(0,L.illegalArgument)("name");this.c=W}get id(){return this.c}};Ve.Clean=new w("clean","Clean"),Ve.Build=new w("build","Build"),Ve.Rebuild=new w("rebuild","Rebuild"),Ve.Test=new w("test","Test"),Ve=w=xe([U],Ve),e.TaskGroup=Ve;function et(x){let W="";for(let fe=0;fe<x.length;fe++)W+=x[fe].replace(/,/g,",,")+",";return W}let ut=class{constructor(W,fe,Te){if(typeof W!="string")throw(0,L.illegalArgument)("process");this.e=[],this.c=W,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)W.push(fe);return et(W)}};ut=xe([U],ut),e.ProcessExecution=ut;let Pt=class{constructor(W,fe,Te){if(this.f=[],Array.isArray(fe)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this.e=W,this.f=fe,this.g=Te}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this.c=W,this.g=fe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)W.push(typeof fe=="string"?fe:fe.value);return et(W)}};Pt=xe([U],Pt),e.ShellExecution=Pt;var St;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var Dt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(Dt=e.TaskScope||(e.TaskScope={}));class wt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=wt;let Rt=N=class{constructor(W,fe,Te,Ke,Je,ct){this.j=!1,this.k=this.definition=W;let ht;typeof fe=="string"?(this.m=this.name=fe,this.t=this.source=Te,this.execution=Ke,ht=Je,this.j=!0):fe===Dt.Global||fe===Dt.Workspace?(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,ht=ct):(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,ht=ct),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ut?this.k={type:N.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:N.f,id:this.n.computeId()}:this.n instanceof wt?this.k={type:N.c,id:this.n.computeId()}:this.k={type:N.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const fe=this.k.type;(N.g===fe||N.e===fe||N.f===fe||N.c===fe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};Rt.c="customExecution",Rt.e="process",Rt.f="shell",Rt.g="$empty",Rt=N=xe([U],Rt),e.Task=Rt;var yt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var ri;(function(x){function W(fe){const Te=fe;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}x.isViewBadge=W})(ri=e.ViewBadge||(e.ViewBadge={}));let ei=j=class{static isTreeItem(W,fe){const Te=W;if(Te.checkboxState!==void 0){(0,D.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ke=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Je=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==si.Checked&&Ke!==si.Unchecked||Je!==void 0&&!(0,y.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(W instanceof j)return!0;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!I.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!I.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!I.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!I.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof rt)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<Ct.None&&Te.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(W,fe=Ct.None){this.collapsibleState=fe,I.URI.isUri(W)?this.resourceUri=W:this.label=W}};ei=j=xe([U],ei),e.TreeItem=ei;var Ct;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(x){x[x.Unchecked=0]="Unchecked",x[x.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,fe){this.value=W,this.id=fe??(0,O.generateUuid)()}};oi=xe([U],oi),e.DataTransferItem=oi;let Jt=class{constructor(W){u.set(this,new Map);for(const[fe,Te]of W??[]){const Ke=Ue(this,u,"f").get(fe);Ke?Ke.push(Te):Ue(this,u,"f").set(fe,[Te])}}get(W){return Ue(this,u,"f").get(W)?.[0]}set(W,fe){Ue(this,u,"f").set(W,[fe])}forEach(W,fe){for(const[Te,Ke]of Ue(this,u,"f"))for(const Je of Ke)W.call(fe,Je,Te,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[W,fe]of Ue(this,u,"f"))for(const Te of fe)yield[W,Te]}};Jt=xe([U],Jt),e.DataTransfer=Jt;let bi=class{constructor(W){this.insertText=W}};bi=xe([U],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(W){this.insertText=W}};Lt=xe([U],Lt),e.DocumentPasteEdit=Lt;let zt=class{constructor(W,fe){this.id=W,this.color=fe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};zt=xe([U],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let vi=class{constructor(W){this.id=W}};vi=xe([U],vi),e.ThemeColor=vi;var ai;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _t=class{get base(){return this.c}set base(W){this.c=W,this.e=I.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,fe){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof fe!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};_t=xe([U],_t),e.RelativePattern=_t;const dt=new WeakMap;function Bi(x,W){dt.set(x,W)}e.setBreakpointId=Bi;let Ut=class{constructor(W,fe,Te,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=dt.get(this)??(0,O.generateUuid)()),this.c}};Ut=xe([U],Ut),e.Breakpoint=Ut;let Xt=class extends Ut{constructor(W,fe,Te,Ke,Je){if(super(fe,Te,Ke,Je),W===null)throw(0,L.illegalArgument)("location");this.location=W}};Xt=xe([U],Xt),e.SourceBreakpoint=Xt;let ci=class extends Ut{constructor(W,fe,Te,Ke,Je){super(fe,Te,Ke,Je),this.functionName=W}};ci=xe([U],ci),e.FunctionBreakpoint=ci;let wi=class extends Ut{constructor(W,fe,Te,Ke,Je,ct,ht){if(super(Ke,Je,ct,ht),!fe)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=fe,this.canPersist=Te}};wi=xe([U],wi),e.DataBreakpoint=wi;let Ei=class{constructor(W,fe,Te){this.command=W,this.args=fe||[],this.options=Te}};Ei=xe([U],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(W,fe){this.port=W,this.host=fe}};li=xe([U],li),e.DebugAdapterServer=li;let Si=class{constructor(W){this.path=W}};Si=xe([U],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(W){this.implementation=W}};ui=xe([U],ui),e.DebugAdapterInlineImplementation=ui;let Zt=class{constructor(W,fe){this.range=W,this.expression=fe}};Zt=xe([U],Zt),e.EvaluatableExpression=Zt;var $i;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(W,fe){this.range=W,this.text=fe}};ti=xe([U],ti),e.InlineValueText=ti;let ii=class{constructor(W,fe,Te=!0){this.range=W,this.variableName=fe,this.caseSensitiveLookup=Te}};ii=xe([U],ii),e.InlineValueVariableLookup=ii;let yi=class{constructor(W,fe){this.range=W,this.expression=fe}};yi=xe([U],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(W,fe){this.frameId=W,this.stoppedLocation=fe}};Di=xe([U],Di),e.InlineValueContext=Di;var ni;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(ni=e.FileChangeType||(e.FileChangeType={}));let Ci=V=class extends Error{static FileExists(W){return new V(W,P.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(W){return new V(W,P.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(W){return new V(W,P.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(W){return new V(W,P.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(W){return new V(W,P.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(W){return new V(W,P.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(W,fe=P.FileSystemProviderErrorCode.Unknown,Te){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Ci=V=xe([U],Ci),e.FileSystemError=Ci;let Ii=class{constructor(W,fe,Te){this.start=W,this.end=fe,this.kind=Te}};Ii=xe([U],Ii),e.FoldingRange=Ii;var zi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(W,fe=[]){this.tokenTypes=W,this.tokenModifiers=fe}}e.SemanticTokensLegend=Ri;function Li(x){return typeof x>"u"||(0,y.isStringArray)(x)}class $e{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let fe=0,Te=W.tokenTypes.length;fe<Te;fe++)this.j.set(W.tokenTypes[fe],fe);for(let fe=0,Te=W.tokenModifiers.length;fe<Te;fe++)this.k.set(W.tokenModifiers[fe],fe)}}push(W,fe,Te,Ke,Je){if(typeof W=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(W,fe,Te,Ke,Je);if(_.isRange(W)&&typeof fe=="string"&&Li(Te))return this.m(W,fe,Te);throw(0,L.illegalArgument)()}m(W,fe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,Je=W.start.character,ct=W.end.character-W.start.character,ht=this.j.get(fe);let Mt=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Mt|=1<<qt>>>0}this.n(Ke,Je,ct,ht,Mt)}n(W,fe,Te,Ke,Je){if(this.f&&(W<this.c||W===this.c&&fe<this.e)){this.f=!1;const Mt=this.g.length/5|0;let Ht=0,qt=0;for(let Kt=0;Kt<Mt;Kt++){let Qt=this.g[5*Kt],Pi=this.g[5*Kt+1];Qt===0?(Qt=Ht,Pi+=qt):Qt+=Ht,this.g[5*Kt]=Qt,this.g[5*Kt+1]=Pi,Ht=Qt,qt=Pi}}let ct=W,ht=fe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ht-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ht,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Je,this.c=W,this.e=fe}static o(W){const fe=[],Te=W.length/5|0;for(let ht=0;ht<Te;ht++)fe[ht]=ht;fe.sort((ht,Mt)=>{const Ht=W[5*ht],qt=W[5*Mt];if(Ht===qt){const Kt=W[5*ht+1],Qt=W[5*Mt+1];return Kt-Qt}return Ht-qt});const Ke=new Uint32Array(W.length);let Je=0,ct=0;for(let ht=0;ht<Te;ht++){const Mt=5*fe[ht],Ht=W[Mt+0],qt=W[Mt+1],Kt=W[Mt+2],Qt=W[Mt+3],Pi=W[Mt+4],sn=Ht-Je,Rn=sn===0?qt-ct:qt,Ai=5*ht;Ke[Ai+0]=sn,Ke[Ai+1]=Rn,Ke[Ai+2]=Kt,Ke[Ai+3]=Qt,Ke[Ai+4]=Pi,Je=Ht,ct=qt}return Ke}build(W){return this.f?new Wt(new Uint32Array(this.g),W):new Wt($e.o(this.g),W)}}e.SemanticTokensBuilder=$e;class Wt{constructor(W,fe){this.resultId=fe,this.data=W}}e.SemanticTokens=Wt;class Oi{constructor(W,fe,Te){this.start=W,this.deleteCount=fe,this.data=Te}}e.SemanticTokensEdit=Oi;class vt{constructor(W,fe){this.resultId=fe,this.edits=W}}e.SemanticTokensEdits=vt;var ji;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new zt("arrow-left")},di=xe([U],di),e.QuickInputButtons=di;var Ni;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(W){if(typeof W.badge=="string"){let fe=(0,A.nextCharLength)(W.badge,0);if(fe<W.badge.length&&(fe+=(0,A.nextCharLength)(W.badge,fe)),W.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!zt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,fe,Te){this.badge=W,this.tooltip=fe,this.color=Te}}e.FileDecoration=qi;let Ti=class{constructor(W){this.kind=W}};Ti=xe([U],Ti),e.ColorTheme=Ti;var xi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,fe){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(fe<0)throw(0,L.illegalArgument)("end must be positive");W<=fe?(this.c=W,this.e=fe):(this.c=fe,this.e=W)}with(W){let fe=this.c,Te=this.e;return W.start!==void 0&&(fe=W.start),W.end!==void 0&&(Te=W.end),fe===this.c&&Te===this.e?this:new Vt(fe,Te)}}e.NotebookRange=Vt;class fi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(fe=>fi.isNotebookCellData(fe))}static isNotebookCellData(W){return!0}constructor(W,fe,Te,Ke,Je,ct,ht){this.kind=W,this.value=fe,this.languageId=Te,this.mime=Ke,this.outputs=Je??[],this.metadata=ct,this.executionSummary=ht,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(W){this.cells=W}}e.NotebookData=Gi;class $t{static isNotebookCellOutputItem(W){return W instanceof $t?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const fe={name:W.name,message:W.message,stack:W.stack};return $t.json(fe,"application/vnd.code.notebook.error")}static stdout(W){return $t.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return $t.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,fe="application/octet-stream"){return new $t(W,fe)}static text(W,fe=S.Mimes.text){const Te=Ue($t,m,"f",b).encode(String(W));return new $t(Te,fe)}static json(W,fe="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return $t.text(Te,fe)}constructor(W,fe){this.data=W,this.mime=fe;const Te=(0,S.normalizeMimeType)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}m=$t,b={value:new TextEncoder},e.NotebookCellOutputItem=$t;class mi{static isNotebookCellOutput(W){return W instanceof mi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,fe=!1){const Te=new Set,Ke=new Set;for(let Je=0;Je<W.length;Je++){const ct=W[Je],ht=(0,S.normalizeMimeType)(ct.mime);if(!Te.has(ht)||(0,k.isTextStreamMime)(ht)){Te.add(ht);continue}Ke.add(Je),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((Je,ct)=>!Ke.has(ct))}constructor(W,fe,Te){this.items=mi.ensureUniqueMimeTypes(W,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,O.generateUuid)(),this.metadata=fe??Te)}}e.NotebookCellOutput=mi;var Ki;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pe;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(pe=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ee;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ee=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(W,fe){this.text=W,this.alignment=fe}}e.NotebookCellStatusBarItem=Me;var ot;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred",x[x.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(W,fe=[]){this.uri=W,this.provides=(0,o.asArray)(fe)}}e.NotebookRendererScript=Ot;class ln{constructor(W){this.label=W}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(W,fe){this.label=W,this.timestamp=fe}};Qi=xe([U],Qi),e.TimelineItem=Qi;var un;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(W,fe){this.ranges=W,this.wordPattern=fe}}e.LinkedEditingRanges=fn;class mn{constructor(W,fe){this.c=W,this.e=fe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(W=void 0,fe=void 0,Te=void 0){this.include=W,this.exclude=fe,this.profile=Te}};Fi=xe([U],Fi),e.TestRunRequest=Fi;let Yi=class extends Fi{constructor(W=void 0,fe=void 0,Te=void 0,Ke=!1){super(W,fe,Te),this.continuous=Ke}};Yi=xe([U],Yi),e.TestRunRequest2=Yi;let Ji=Q=class{static diff(W,fe,Te){const Ke=new Q(W);return Ke.expectedOutput=fe,Ke.actualOutput=Te,Ke}constructor(W){this.message=W}};Ji=Q=xe([U],Ji),e.TestMessage=Ji;let _i=class{constructor(W){this.id=W}};_i=xe([U],_i),e.TestTag=_i;let gi=class{constructor(W,fe){this.covered=W,this.total=fe}};gi=xe([U],gi),e.CoveredCount=gi;let Zi=q=class{static fromDetails(W,fe){const Te=new gi(0,0),Ke=new gi(0,0),Je=new gi(0,0);for(const ht of fe)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const Mt of ht.branches)Ke.total+=1,Ke.covered+=Mt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ht.executionCount>0?1:0;const ct=new q(W,Te,Ke.total>0?Ke:void 0,Je.total>0?Je:void 0);return ct.detailedCoverage=fe,ct}constructor(W,fe,Te,Ke){this.uri=W,this.statementCoverage=fe,this.branchCoverage=Te,this.functionCoverage=Ke}};Zi=q=xe([U],Zi),e.FileCoverage=Zi;let en=class{constructor(W,fe,Te=[]){this.executionCount=W,this.location=fe,this.branches=Te}};en=xe([U],en),e.StatementCoverage=en;let tn=class{constructor(W,fe){this.executionCount=W,this.location=fe}};tn=xe([U],tn),e.BranchCoverage=tn;let nn=class{constructor(W,fe){this.executionCount=W,this.location=fe}};nn=xe([U],nn),e.FunctionCoverage=nn;var bn;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(W,fe,Te,Ke,Je,ct){this.kind=W,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.TypeHierarchyItem=En;class Sn{constructor(W){this.uri=W}}e.TextTabInput=Sn;class yn{constructor(W,fe){this.original=W,this.modified=fe}}e.TextDiffTabInput=yn;class Dn{constructor(W,fe,Te,Ke){this.base=W,this.input1=fe,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Dn;class Cn{constructor(W,fe){this.uri=W,this.viewType=fe}}e.CustomEditorTabInput=Cn;class In{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=In;class kn{constructor(W,fe){this.uri=W,this.notebookType=fe}}e.NotebookEditorTabInput=kn;class Tn{constructor(W,fe,Te){this.original=W,this.modified=fe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(W,fe){this.uri=W,this.inputBoxUri=fe}}e.InteractiveWindowInput=An}),define(ye[135],De([1,0,50,16,8,165,106,7,15]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function O(D,f){f?I.set(D,f):I.delete(D)}e.setWordDefinitionFor=O;function P(D){return I.get(D)}class v extends R.MirrorTextModel{constructor(f,d,u,m,b,C,p,n){super(d,u,m,b),this.m=f,this.p=C,this.q=p,this.notebook=n,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,y.equals)(this.d,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.c},get fileName(){return f.c.fsPath},get isUntitled(){return f.c.scheme===L.Schemas.untitled},get languageId(){return f.p},get version(){return f.g},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(d){return d?f.s(d):f.getText()},get eol(){return f.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return f.d.length},lineAt(d){return f.t(d)},offsetAt(d){return f.u(d)},positionAt(d){return f.v(d)},validateRange(d){return f.w(d)},validatePosition(d){return f.x(d)},getWordRangeAtPosition(d,u){return f.y(d,u)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,o.ok)(!this.b),this.p=f}_acceptIsDirty(f){(0,o.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(f){const d=this.w(f);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const u=this.f,m=d.start.line,b=d.end.line,C=[];C.push(this.d[m].substring(d.start.character));for(let p=m+1;p<b;p++)C.push(this.d[p]);return C.push(this.d[b].substring(0,d.end.character)),C.join(u)}t(f){let d;if(f instanceof A.Position?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new k(d,this.d[d],d===this.d.length-1)}u(f){return f=this.x(f),this.k(),this.h.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.k();const d=this.h.getIndexOf(f),u=this.d[d.index].length;return new A.Position(d.index,Math.min(d.remainder,u))}w(f){if(!(f instanceof A.Range))throw new Error("Invalid argument");const d=this.x(f.start),u=this.x(f.end);return d===f.start&&u===f.end?f:new A.Range(d.line,d.character,u.line,u.character)}x(f){if(!(f instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return f.with(0,0);let{line:d,character:u}=f,m=!1;if(d<0)d=0,u=0,m=!0;else if(d>=this.d.length)d=this.d.length-1,u=this.d[d].length,m=!0;else{const b=this.d[d].length;u<0?(u=0,m=!0):u>b&&(u=b,m=!0)}return m?new A.Position(d,u):f}y(f,d){const u=this.x(f);if(!d)d=P(this.p);else if((0,l.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const m=(0,S.getWordAtText)(u.character+1,(0,S.ensureValidWordDefinition)(d),this.d[u.line],0);if(m)return new A.Range(u.line,m.startColumn-1,u.line,m.endColumn-1)}}e.ExtHostDocumentData=v;class k{constructor(f,d,u){this.a=f,this.b=d,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=k}),define(ye[240],De([1,0,7,20,3]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new o.ColorTheme(o.ColorThemeKind.Dark),this.b=new l.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=o.ColorThemeKind.Light;break;case"hcDark":y=o.ColorThemeKind.HighContrast;break;case"hcLight":y=o.ColorThemeKind.HighContrastLight;break;default:y=o.ColorThemeKind.Dark}this.a=new o.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=xe([ze(0,L.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],De([1,0,15,22,149,63,112,28,147,69,87,23,9,2,32,71,124,132,130,93,57,75,236,7]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ae){function Oe(se){const{selectionStartLineNumber:Fe,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ve}=se,et=new s.Position(Fe-1,We-1),ut=new s.Position(Ye-1,Ve-1);return new s.Selection(et,ut)}Ae.to=Oe;function Se(se){const{anchor:Fe,active:We}=se;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Ae.from=Se})(r=e.Selection||(e.Selection={}));var a;(function(Ae){function Oe(se){if(!se)return;const{start:Fe,end:We}=se;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Ae.from=Oe;function Se(se){if(!se)return;const{startLineNumber:Fe,startColumn:We,endLineNumber:Ye,endColumn:Ve}=se;return new s.Range(Fe-1,We-1,Ye-1,Ve-1)}Ae.to=Se})(a=e.Range||(e.Range={}));var c;(function(Ae){function Oe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ae.to=Oe})(c=e.TokenType||(e.TokenType={}));var g;(function(Ae){function Oe(se){return new s.Position(se.lineNumber-1,se.column-1)}Ae.to=Oe;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Ae.from=Se})(g=e.Position||(e.Position={}));var i;(function(Ae){function Oe(Fe,We){return(0,o.coalesce)((0,o.asArray)(Fe).map(Ye=>Se(Ye,We)))}Ae.from=Oe;function Se(Fe,We){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:se(Fe.scheme,We),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function se(Fe,We){return We&&typeof Fe=="string"?We.transformOutgoingScheme(Fe):Fe}})(i=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Ae){function Oe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Se(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ae.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(Ae){function Oe(se){let Fe;return se.code&&((0,v.isString)(se.code)||(0,v.isNumber)(se.code)?Fe=String(se.code):Fe={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Fe,severity:w.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(E.from),tags:Array.isArray(se.tags)?(0,o.coalesce)(se.tags.map(t.from)):void 0}}Ae.from=Oe;function Se(se){const Fe=new s.Diagnostic(a.to(se),se.message,w.to(se.severity));return Fe.source=se.source,Fe.code=(0,v.isString)(se.code)?se.code:se.code?.value,Fe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(E.to),Fe.tags=se.tags&&(0,o.coalesce)(se.tags.map(t.to)),Fe}Ae.to=Se})(h=e.Diagnostic||(e.Diagnostic={}));var E;(function(Ae){function Oe(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Ae.from=Oe;function Se(se){return new s.DiagnosticRelatedInformation(new s.Location(se.resource,a.to(se)),se.message)}Ae.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(Ae){function Oe(se){switch(se){case s.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Ae.from=Oe;function Se(se){switch(se){case d.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ae.to=Se})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var N;(function(Ae){function Oe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}Ae.from=Oe;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Se})(N=e.ViewColumn||(e.ViewColumn={}));function j(Ae){return typeof Ae.range<"u"}function V(Ae){return Ae.length===0?!0:!!j(Ae[0])}e.isDecorationOptionsArr=V;var Q;(function(Ae){function Oe(Ve){return Ve.map(Ae.from)}Ae.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function se(Ve){let et;if(Se(Ve)){const{language:Dt,value:wt}=Ve;et={value:"```"+Dt+`
`+wt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const ut=Object.create(null);et.uris=ut;const Pt=Dt=>{try{let wt=k.URI.parse(Dt,!0);wt=wt.with({query:Fe(wt.query,ut)}),ut[Dt]=wt}catch{}return""},St=new y.marked.Renderer;return St.link=Pt,St.image=Dt=>typeof Dt=="string"?Pt(S.parseHrefAndDimensions(Dt).href):"",(0,y.marked)(et.value,{renderer:St}),et}Ae.from=se;function Fe(Ve,et){if(!Ve)return Ve;let ut;try{ut=(0,I.parse)(Ve)}catch{}if(!ut)return Ve;let Pt=!1;return ut=(0,P.cloneAndChange)(ut,St=>{if(k.URI.isUri(St)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[Dt]=St,Pt=!0,Dt}else return}),Pt?JSON.stringify(ut):Ve}function We(Ve){const et=new s.MarkdownString(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?k.URI.from(Ve.baseUri):void 0,et}Ae.to=We;function Ye(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Ye})(Q=e.MarkdownString||(e.MarkdownString={}));function q(Ae){return V(Ae)?Ae.map(Oe=>({range:a.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?Q.fromMany(Oe.hoverMessage):Oe.hoverMessage?Q.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:a.from(Oe)}))}e.fromRangeOrRangeWithMessage=q;function U(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?k.URI.file(Ae):Ae}e.pathOrURIToURI=U;var T;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?U(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Ae.from=Oe})(T=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Ae.from=Oe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Ae){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Z;(function(Ae){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?B.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?F.from(Se.light):void 0,dark:Se.dark?F.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Ae.from=Oe})(Z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(Ae){function Oe(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:a.from(se.range)}}Ae.from=Oe;function Se(se){const Fe=new s.TextEdit(a.to(se.range),se.text);return Fe.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Fe}Ae.to=Se})(_=e.TextEdit||(e.TextEdit={}));var H;(function(Ae){function Oe(se,Fe){const We={edits:[]};if(se instanceof s.WorkspaceEdit){const Ye=new A.ResourceSet;for(const Ve of se._allEntries())Ve._type===1&&k.URI.isUri(Ve.to)&&Ve.from===void 0&&Ye.add(Ve.to);for(const Ve of se._allEntries())Ve._type===1?We.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,L.encodeBase64)(L.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?We.edits.push({resource:Ve.uri,textEdit:_.from(Ve.edit),versionId:Ye.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?We.edits.push({resource:Ve.uri,textEdit:{range:a.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?We.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&We.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(at.from)}})}return We}Ae.from=Oe;function Se(se){const Fe=new s.WorkspaceEdit;for(const We of se.edits)We.textEdit?Fe.replace(k.URI.revive(We.resource),a.to(We.textEdit.range),We.textEdit.text):Fe.renameFile(k.URI.revive(We.oldResource),k.URI.revive(We.newResource),We.options);return Fe}Ae.to=Se})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Y;(function(Ae){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=Se;function se(Fe){for(const We in Oe)if(Oe[We]===Fe)return Number(We);return s.SymbolKind.Property}Ae.to=se})(Y=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Ae){function Oe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Se(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Ae.to=Se})(ie=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Ae){function Oe(se){return{name:se.name,kind:Y.from(se.kind),tags:se.tags&&se.tags.map(ie.from),containerName:se.containerName,location:ve.from(se.location)}}Ae.from=Oe;function Se(se){const Fe=new s.SymbolInformation(se.name,Y.to(se.kind),se.containerName,ve.to(se.location));return Fe.tags=se.tags&&se.tags.map(ie.to),Fe}Ae.to=Se})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Ae){function Oe(se){const Fe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:Y.from(se.kind),tags:se.tags?.map(ie.from)??[]};return se.children&&(Fe.children=se.children.map(Oe)),Fe}Ae.from=Oe;function Se(se){const Fe=new s.DocumentSymbol(se.name,se.detail,Y.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,o.isNonEmptyArray)(se.tags)&&(Fe.tags=se.tags.map(ie.to)),se.children&&(Fe.children=se.children.map(Se)),Fe}Ae.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Ae){function Oe(se){const Fe=new s.CallHierarchyItem(Y.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Ae.to=Oe;function Se(se,Fe,We){if(Fe=Fe??se._sessionId,We=We??se._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,name:se.name,detail:se.detail,kind:Y.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ie.from)}}Ae.from=Se})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ee;(function(Ae){function Oe(Se){return new s.CallHierarchyIncomingCall(J.to(Se.from),Se.fromRanges.map(se=>a.to(se)))}Ae.to=Oe})(ee=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(Ae){function Oe(Se){return new s.CallHierarchyOutgoingCall(J.to(Se.to),Se.fromRanges.map(se=>a.to(se)))}Ae.to=Oe})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Ae){function Oe(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Ae.from=Oe;function Se(se){return new s.Location(k.URI.revive(se.uri),a.to(se.range))}Ae.to=Se})(ve=e.location||(e.location={}));var Ie;(function(Ae){function Oe(se){const Fe=se,We=se;return{originSelectionRange:Fe.originSelectionRange?a.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:We.uri,range:a.from(Fe.targetRange?Fe.targetRange:We.range),targetSelectionRange:Fe.targetSelectionRange?a.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function Se(se){return{targetUri:k.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Ae.to=Se})(Ie=e.DefinitionLink||(e.DefinitionLink={}));var Re;(function(Ae){function Oe(se){return{range:a.from(se.range),contents:Q.fromMany(se.contents)}}Ae.from=Oe;function Se(se){return new s.Hover(se.contents.map(Q.to),a.to(se.range))}Ae.to=Se})(Re=e.Hover||(e.Hover={}));var ae;(function(Ae){function Oe(se){return{range:a.from(se.range),expression:se.expression}}Ae.from=Oe;function Se(se){return new s.EvaluatableExpression(a.to(se.range),se.expression)}Ae.to=Se})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Ae){function Oe(se){if(se instanceof s.InlineValueText)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof s.InlineValueVariableLookup)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Se(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Ae.to=Se})(le=e.InlineValue||(e.InlineValue={}));var ue;(function(Ae){function Oe(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Ae.from=Oe;function Se(se){return new s.InlineValueContext(se.frameId,a.to(se.stoppedLocation))}Ae.to=Se})(ue=e.InlineValueContext||(e.InlineValueContext={}));var ne;(function(Ae){function Oe(se){return{range:a.from(se.range),kind:se.kind}}Ae.from=Oe;function Se(se){return new s.DocumentHighlight(a.to(se.range),se.kind)}Ae.to=Se})(ne=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Ae){function Oe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ae.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(Ae){function Oe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Ae.to=Oe})(oe=e.CompletionContext||(e.CompletionContext={}));var M;(function(Ae){function Oe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Se(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Ae.to=Se})(M=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Ae){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se(We){return Oe.get(We)??9}Ae.from=Se;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(We){return se.get(We)??s.CompletionItemKind.Property}Ae.to=Fe})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(Ae){function Oe(Se,se){const Fe=new s.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=z.to(Se.kind),Fe.tags=Se.tags?.map(M.to),Fe.detail=Se.detail,Fe.documentation=S.isMarkdownString(Se.documentation)?Q.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,D.Range.isIRange(Se.range)?Fe.range=a.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:a.to(Se.range.insert),replacing:a.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new s.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof s.Range?new s.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(We=>_.to(We))),Fe.command=se&&Se.command?se.fromInternal(Se.command):void 0,Fe}Ae.to=Oe})(G=e.CompletionItem||(e.CompletionItem={}));var te;(function(Ae){function Oe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:Q.fromStrict(se.documentation)}}Ae.from=Oe;function Se(se){return{label:se.label,documentation:S.isMarkdownString(se.documentation)?Q.to(se.documentation):se.documentation}}Ae.to=Se})(te=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Ae){function Oe(se){return{label:se.label,documentation:Q.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(te.from):[],activeParameter:se.activeParameter}}Ae.from=Oe;function Se(se){return{label:se.label,documentation:S.isMarkdownString(se.documentation)?Q.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(te.to):[],activeParameter:se.activeParameter}}Ae.to=Se})(de=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Ae){function Oe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.from):[]}}Ae.from=Oe;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.to):[]}}Ae.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Se,se){const Fe=new s.InlayHint(g.to(se.position),typeof se.label=="string"?se.label:se.label.map(be.to.bind(void 0,Se)),se.kind&&Ce.to(se.kind));return Fe.textEdits=se.textEdits&&se.textEdits.map(_.to),Fe.tooltip=S.isMarkdownString(se.tooltip)?Q.to(se.tooltip):se.tooltip,Fe.paddingLeft=se.paddingLeft,Fe.paddingRight=se.paddingRight,Fe}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var be;(function(Ae){function Oe(Se,se){const Fe=new s.InlayHintLabelPart(se.label);return Fe.tooltip=S.isMarkdownString(se.tooltip)?Q.to(se.tooltip):se.tooltip,f.Command.is(se.command)&&(Fe.command=Se.fromInternal(se.command)),se.location&&(Fe.location=ve.to(se.location)),Fe}Ae.to=Oe})(be=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(se){return se}Ae.from=Oe;function Se(se){return se}Ae.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Ae.from=Oe;function Se(se){let Fe;if(se.url)try{Fe=typeof se.url=="string"?k.URI.parse(se.url,!0):k.URI.revive(se.url)}catch{}return new s.DocumentLink(a.to(se.range),Fe)}Ae.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var He;(function(Ae){function Oe(se){const Fe=new s.ColorPresentation(se.label);return se.textEdit&&(Fe.textEdit=_.to(se.textEdit)),se.additionalTextEdits&&(Fe.additionalTextEdits=se.additionalTextEdits.map(We=>_.to(We))),Fe}Ae.to=Oe;function Se(se){return{label:se.label,textEdit:se.textEdit?_.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Fe=>_.from(Fe)):void 0}}Ae.from=Se})(He=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Ae){function Oe(se){return new s.Color(se[0],se[1],se[2],se[3])}Ae.to=Oe;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Ae.from=Se})(Ge=e.Color||(e.Color={}));var nt;(function(Ae){function Oe(se){return{range:a.from(se.range)}}Ae.from=Oe;function Se(se){return new s.SelectionRange(a.to(se.range))}Ae.to=Se})(nt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Ae){function Oe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Ae){function Oe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Se(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ae.to=Se})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Ae){function Oe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Ae.from=Oe;function Se(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Ae.to=Se})(rt=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Ae){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Ae){function Oe(se){const Fe={start:se.start+1,end:se.end+1};return se.kind&&(Fe.kind=$.from(se.kind)),Fe}Ae.from=Oe;function Se(se){const Fe={start:se.start-1,end:se.end-1};return se.kind&&(Fe.kind=$.to(se.kind)),Fe}Ae.to=Se})(it=e.FoldingRange||(e.FoldingRange={}));var $;(function(Ae){function Oe(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Ae.from=Oe;function Se(se){if(se)switch(se.value){case f.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Ae.to=Se})($=e.FoldingRangeKind||(e.FoldingRangeKind={}));var K;(function(Ae){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?a.from(Se.selection):void 0,override:typeof Se.override=="boolean"?m.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(K=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Ae){function Oe(We){return We instanceof s.RelativePattern?We.toJSON():typeof We=="string"?We:Se(We)||se(We)?new s.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Ae.from=Oe;function Se(We){const Ye=We;return Ye?k.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function se(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Fe(We){return typeof We=="string"?We:new s.RelativePattern(k.URI.revive(We.baseUri),We.pattern)}Ae.to=Fe})(he=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Ae){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:he.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Ae.from=Oe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Ae){function Oe(se){return{start:se.start,end:se.end}}Ae.from=Oe;function Se(se){return new s.NotebookRange(se.start,se.end)}Ae.to=Se})(Ne=e.NotebookRange||(e.NotebookRange={}));var qe;(function(Ae){function Oe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Ae.to=Oe;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Ae.from=Se})(qe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Ae){function Oe(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Ae.to=Oe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ze;(function(Ae){function Oe(se){switch(se){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}Ae.from=Oe;function Se(se){switch(se){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}Ae.to=Se})(Ze=e.NotebookCellKind||(e.NotebookCellKind={}));var st;(function(Ae){function Oe(se){const Fe={metadata:se.metadata??Object.create(null),cells:[]};for(const We of se.cells)s.NotebookCellData.validate(We),Fe.cells.push(at.from(We));return Fe}Ae.from=Oe;function Se(se){const Fe=new s.NotebookData(se.cells.map(at.to));return(0,v.isEmptyObject)(se.metadata)||(Fe.metadata=se.metadata),Fe}Ae.to=Se})(st=e.NotebookData||(e.NotebookData={}));var at;(function(Ae){function Oe(se){return{cellKind:Ze.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:qe.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(gt.from):[]}}Ae.from=Oe;function Se(se){return new s.NotebookCellData(Ze.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(gt.to):void 0,se.metadata,se.internalMetadata?qe.to(se.internalMetadata):void 0)}Ae.to=Se})(at=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Ae){function Oe(se){return{mime:se.mime,valueBytes:L.VSBuffer.wrap(se.data)}}Ae.from=Oe;function Se(se){return new s.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Ae.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var gt;(function(Ae){function Oe(se){return{outputId:se.id,items:se.items.map(mt.from),metadata:se.metadata}}Ae.from=Oe;function Se(se){const Fe=se.items.map(mt.to);return new s.NotebookCellOutput(Fe,se.outputId,se.metadata)}Ae.to=Se})(gt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Ae){function Oe(Fe){return se(Fe)?{include:(0,v.withNullAsUndefined)(he.from(Fe.include)),exclude:(0,v.withNullAsUndefined)(he.from(Fe.exclude))}:(0,v.withNullAsUndefined)(he.from(Fe))}Ae.from=Oe;function Se(Fe){return se(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Ae.to=Se;function se(Fe){const We=Fe;return We?!(0,v.isUndefinedOrNull)(We.include)&&!(0,v.isUndefinedOrNull)(We.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Ae){function Oe(Se,se,Fe){const We=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(We,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Ae.from=Oe})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var pt;(function(Ae){function Oe(Se,se,Fe){const We=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(We,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Ae.from=Oe})(pt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var xt;(function(Ae){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Ae.from=Oe})(xt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var jt;(function(Ae){function Oe(se){return{uri:se.uri,provides:se.provides}}Ae.from=Oe;function Se(se){return new s.NotebookRendererScript(k.URI.revive(se.uri),se.provides)}Ae.to=Se})(jt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(Ae){function Oe(se){return{message:Q.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Ae.from=Oe;function Se(se){const Fe=new s.TestMessage(typeof se.message=="string"?se.message:Q.to(se.message));return Fe.actualOutput=se.actual,Fe.expectedOutput=se.expected,Fe.location=se.location?ve.to(se.location):void 0,Fe}Ae.to=Se})(kt=e.TestMessage||(e.TestMessage={}));var ft;(function(Ae){Ae.namespace=p.namespaceTestTag,Ae.denamespace=p.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Tt;(function(Ae){function Oe(se){const Fe=(0,u.getPrivateApiFor)(se).controllerId;return{extId:C.TestId.fromExtHostTestItem(se,Fe).toString(),label:se.label,uri:k.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(We=>ft.namespace(Fe,We.id)),range:D.Range.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&Q.fromStrict(se.error)||null}}Ae.from=Oe;function Se(se){return{parent:void 0,error:void 0,id:C.TestId.fromString(se.extId).localId,label:se.label,uri:k.URI.revive(se.uri),tags:(se.tags||[]).map(Fe=>{const{tagId:We}=ft.denamespace(Fe);return new s.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Ae.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(se){return{id:se.id}}Ae.from=Oe;function Se(se){return new s.TestTag(se.id)}Ae.to=Se}(ft=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){const Oe=(se,Fe)=>{const We=[];for(const[Ve,et]of Fe)C.TestId.compare(et.item.extId,Ve)===2&&(Fe.delete(Ve),We.push(et));const Ye={...Tt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(kt.to)})),children:We.map(Ve=>Oe(Ve,Fe))};for(const Ve of Ye.children)Ve.parent=Ye;return Ye};function Se(se){const Fe=[],We=new Map;for(const Ye of se.items){We.set(Ye.item.extId,Ye);const Ve=C.TestId.root(Ye.item.extId);se.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Ye.item.extId))&&Fe.push(Ye)}return{completedAt:se.completedAt,results:Fe.map(Ye=>Oe(Ye,We))}}Ae.to=Se})(Bt=e.TestResults||(e.TestResults={}));var At;(function(Ae){function Oe(We){return{covered:We.covered,total:We.covered}}function Se(We){return"line"in We?g.from(We):a.from(We)}function se(We){return"branches"in We?{count:We.executionCount,location:Se(We.location),type:1,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&Se(Ye.location)})):void 0}:{type:0,count:We.executionCount,location:Se(We.location)}}Ae.fromDetailed=se;function Fe(We){return{uri:We.uri,statement:Oe(We.statementCoverage),branch:We.branchCoverage&&Oe(We.branchCoverage),function:We.functionCoverage&&Oe(We.functionCoverage),details:We.detailedCoverage?.map(se)}}Ae.fromFile=Fe})(At=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Ae){function Oe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Ae){function Oe(se){const Fe=new s.TypeHierarchyItem(Y.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Ae.to=Oe;function Se(se,Fe,We){if(Fe=Fe??se._sessionId,We=We??se._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,kind:Y.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(ie.from)}}Ae.from=Se})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Gt;(function(Ae){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Ae.from=Oe})(Gt=e.ViewBadge||(e.ViewBadge={}));var Ft;(function(Ae){function Oe(We,Ye,Ve){const et=Ye.fileData;return et?new class extends s.DataTransferItem{asFile(){return{name:et.name,uri:k.URI.revive(et.uri),data:(0,R.once)(()=>Ve())}}}("",Ye.id):We===O.Mimes.uriList&&Ye.uriListData?new s.DataTransferItem(Fe(Ye.uriListData)):new s.DataTransferItem(Ye.asString)}Ae.to=Oe;async function Se(We,Ye){const Ve=await Ye.asString();if(We===O.Mimes.uriList)return{id:Ye.id,asString:Ve,fileData:void 0,uriListData:se(Ve)};const et=Ye.asFile();return{id:Ye.id,asString:Ve,fileData:et?{name:et.name,uri:et.uri}:void 0}}Ae.from=Se;function se(We){return l.UriList.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return k.URI.parse(Ye)}catch{}return Ye})}function Fe(We){return l.UriList.create(We.map(Ye=>typeof Ye=="string"?Ye:k.URI.revive(Ye)))}})(Ft=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Ae){function Oe(se,Fe){const We=se.items.map(([Ye,Ve])=>[Ye,Ft.to(Ye,Ve,()=>Fe(Ve.id))]);return new s.DataTransfer(We)}Ae.toDataTransfer=Oe;async function Se(se){const Fe={items:[]},We=[];return se.forEach((Ye,Ve)=>{We.push((async()=>{Fe.items.push([Ve,await Ft.from(Ve,Ye)])})())}),await Promise.all(We),Fe}Ae.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[241],De([1,0,2,10,7,14,66]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(I,O,P,v={timeout:1500,errors:3}){this.c=I,this.d=O,this.f=P,this.g=v,this.a=new S.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(O,P,v)=>{const D={dispose:this.a.push([O,P,I])};return Array.isArray(v)&&v.push(D),D}}async $participateInSave(I,O){const P=o.URI.revive(I);let v=!1;const k=setTimeout(()=>v=!0,this.g.timeout),D=[];try{for(const f of[...this.a]){if(v)break;const d=this.d.getDocument(P),u=await this.h(f,{document:d,reason:R.TextDocumentSaveReason.to(O)});D.push(u)}}finally{clearTimeout(k)}return D}h([I,O,P],v){const k=this.b.get(I);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(P,I,O,v).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const f=this.b.get(I);this.b.set(I,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,O,P,v){const k=[],D=Date.now(),{document:f,reason:d}=v,{version:u}=f,m=Object.freeze({document:f,reason:d,waitUntil(b){if(Object.isFrozen(k))throw(0,L.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(b))}});try{O.apply(P,[m])}catch(b){return Promise.reject(b)}return Object.freeze(k),new Promise((b,C)=>{const p=setTimeout(()=>C(new Error("timeout")),this.g.timeout);return Promise.all(k).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(p),b(n)}).catch(n=>{clearTimeout(p),C(n)})}).then(b=>{const C={edits:[]};for(const p of b)if(Array.isArray(p)&&p.every(n=>n instanceof l.TextEdit))for(const{newText:n,newEol:s,range:r}of p)C.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:n,eol:s&&R.EndOfLine.from(s)}});if(C.edits.length!==0)return u===f.version?this.f.$tryApplyWorkspaceEdit(C):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[242],De([1,0,16,2,14,7,93]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,v,k,D){this.start=P,this.deletedCount=v,this.deletedItems=k,this.items=D}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,v,k){this.notebook=P,this.h=v,this.j=k,this.handle=k.handle,this.uri=L.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(l.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return P.g},set mime(D){P.g=D},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(k)}return this.f}setOutputs(P){this.a=P.map(l.NotebookCellOutput.to)}setOutputItems(P,v,k){const D=k.map(l.NotebookCellOutputItem.to),f=this.a.find(d=>d.id===P);if(f&&(v||(f.items.length=0),f.items.push(...D),f.items.length>1&&f.items.every(d=>S.isTextStreamMime(d.mime)))){const d=new Map,u=[];f.items.forEach(m=>{let b;d.has(m.mime)?b=d.get(m.mime):(b=[],d.set(m.mime,b),u.push(m.mime)),b.push(m.data)}),f.items.length=0,u.forEach(m=>{const b=S.compressOutputItemStreams(d.get(m));f.items.push({mime:m,data:b.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class I{constructor(P,v,k,D,f){this.k=P,this.l=v,this.m=k,this.uri=D,this.handle=I.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,v={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===o.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(k){return k=P.n(k),P.b[k].apiCell},getCells(k){return(k?P.p(k):P.b).map(f=>f.apiCell)},save(){return P.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,v,k){this.g=P.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:k});const D={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},f=[];for(const u of P.rawEvents)u.kind===S.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,D.contentChanges):u.kind===S.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,D.contentChanges):u.kind===S.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),f.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===S.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),f.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===S.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),f.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===S.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===S.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===S.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),f.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),f.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const d=new Map;for(let u=0;u<f.length;u++){const m=f[u],b=d.get(m.cell);if(b===void 0){const C=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});d.set(m.cell,C-1)}else D.cellChanges[b]={...D.cellChanges[b],...m}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let v=P.start|0,k=P.end|0;return v<0&&(v=0),k>this.b.length&&(k=this.b.length),P.with({start:v,end:k})}p(P){P=this.o(P);const v=[];for(let k=P.start;k<P.end;k++)v.push(this.b[k]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,v,k){if(this.j)return;const D=[],f=[],d=[];if(P.reverse().forEach(u=>{const b=u[2].map(n=>{const s=new y(this,this.l,n);return v||f.push(y.asModelAddData(this.apiNotebook,n)),s}),C=new A(u[0],u[1],[],b),p=this.b.splice(u[0],u[1],...b);for(const n of p)d.push(n.uri),C.deletedItems.push(n.apiCell);D.push(C)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),k)for(const u of D)k.push(u.asApiEvent())}s(P,v,k,D){const f=this.b.splice(P,v);this.b.splice(k,0,...f);const d=[new A(P,v,f.map(u=>u.apiCell),[]),new A(k,0,[],f)];for(const u of d)D.push(u.asApiEvent())}t(P,v){this.b[P].setOutputs(v)}u(P,v,k,D){this.b[P].setOutputItems(v,k,D)}v(P,v){const k=this.b[P];k.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(k.uri,v)}w(P,v){const k=this.b[P];k.apiCell.mime=v}x(P,v){this.b[P].setMetadata(v)}y(P,v){this.b[P].setInternalMetadata(v)}getCellFromApiCell(P){return this.b.find(v=>v.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(v=>v.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}I.a=0,e.ExtHostNotebookDocument=I}),define(ye[136],De([1,0,10,14,7]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,y,I,O,P,v){this.id=A,this.f=y,this.notebookData=I,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=O,this.c=v}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(l.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,I){A.f.$tryRevealRange(A.id,L.NotebookRange.from(y),I??l.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(L.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(ye[243],De([1,0,3,13,14]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,y){this.c=A,this.d=y,this.a=new o.Emitter,this.b=new o.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const I=this.d.getEditorById(A);y.visibleRanges&&I._acceptVisibleRanges(y.visibleRanges.ranges.map(l.NotebookRange.to)),y.selections&&I._acceptSelections(y.selections.selections.map(l.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(l.ViewColumn.to(A[y]))}};R=xe([ze(0,L.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[244],De([1,0,14,126,179,21,62,10]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,k,D){const f=this.b++,{title:d,location:u,cancellable:m}=k,b={label:(0,l.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(f,{location:o.ProgressLocation.from(u),title:d,source:b,cancellable:m},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.onUnexpectedExternalError),this.d(f,D,!!m)}d(v,k,D){let f;D&&(f=new R.CancellationTokenSource,this.c.set(v,f));const d=m=>{this.a.$progressEnd(m),this.c.delete(m),f?.dispose()};let u;try{u=k(new O(this.a,v),D&&f?f.token:R.CancellationToken.None)}catch(m){throw d(v),m}return u.then(m=>d(v),m=>d(v)),u}$acceptProgressCanceled(v){const k=this.c.get(v);k&&(k.cancel(),this.c.delete(v))}}e.ExtHostProgress=y;function I(P,v){return P.message=v.message,typeof v.increment=="number"&&(typeof P.increment=="number"?P.increment+=v.increment:P.increment=v.increment),P}class O extends L.Progress{constructor(v,k){super(D=>this.throttledReport(D)),this.c=v,this.d=k}throttledReport(v){this.c.$progressReport(this.d,v)}}xe([(0,S.throttle)(100,(P,v)=>I(P,v),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(ye[137],De([1,0,32,132,57,94,75,14,2]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(b,C,p,n)=>{let s=C;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!p(s,r)){const a=s;s=r,b.listener?.(n(r,a))}}}},O=(b,C)=>b===C,P={range:(b,C)=>b===C?!0:!b||!C?!1:b.isEqual(C),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,C)=>!(b.length!==C.length||b.some(p=>!C.find(n=>p.id===n.id)))},v=b=>C=>({op:4,update:b(C)}),k=(b,C)=>({range:(()=>{let p;const n=v(s=>({range:o.Range.lift(A.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return p},set(s){b.listener?.({op:6}),P.range(p,s)||(p=s,b.listener?.(n(s)))}}})(),label:I(b,C,P.label,v(p=>({label:p}))),description:I(b,void 0,P.description,v(p=>({description:p}))),sortText:I(b,void 0,P.sortText,v(p=>({sortText:p}))),canResolveChildren:I(b,!1,P.canResolveChildren,p=>({op:2,state:p})),busy:I(b,!1,P.busy,v(p=>({busy:p}))),error:I(b,void 0,P.error,v(p=>({error:A.MarkdownString.fromStrict(p)||null}))),tags:I(b,[],P.tags,(p,n)=>({op:1,new:p.map(A.TestTag.from),old:n.map(A.TestTag.from)}))}),D=b=>{const C=l.TestId.fromString(b.extId),p=new d(C.controllerId,C.localId,b.label,y.URI.revive(b.uri)||void 0);return p.range=A.Range.to(b.range||void 0),p.description=b.description||void 0,p.sortText=b.sortText||void 0,p.tags=b.tags.map(n=>A.TestTag.to({id:(0,S.denamespaceTestTag)(n).tagId})),p},f=b=>{let C;for(const p of b.tests){const n=D(p.item);(0,L.getPrivateApiFor)(n).parent=C,C=n}return C};e.toItemFromContext=f;class d{constructor(C,p,n,s){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const r=(0,L.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof u?void 0:r.parent}},children:{value:(0,R.createTestItemChildren)(r,L.getPrivateApiFor,d),enumerable:!0,writable:!1},...k(r,n)})}}e.TestItemImpl=d;class u extends d{constructor(C,p){super(C,C,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class m extends R.TestItemCollection{constructor(C,p,n){super({controllerId:C,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:L.getPrivateApiFor,getChildren:s=>s.children,root:new u(C,p),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=m}),define(ye[138],De([1,0,50,10,101,14,7]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(v,k,D){const f=A.c.nextId();v.$registerTextEditorDecorationType(k.identifier,f,R.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:f,dispose(){v.$removeTextEditorDecorationType(f)}})}}A.c=new l.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=A;class y{constructor(v,k){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,k){this.k();let D=null;if(v instanceof S.Position)D=new S.Range(v,v);else if(v instanceof S.Range)D=v;else throw new Error("Unrecognized location");this.l(D,k,!1)}insert(v,k){this.k(),this.l(new S.Range(v,v),k,!0)}delete(v){this.k();let k=null;if(v instanceof S.Range)k=v;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(v,k,D){const f=this.c.validateRange(v);this.g.push({range:f,text:k,forceMoveMarkers:D})}setEndOfLine(v){if(this.k(),v!==S.EndOfLine.LF&&v!==S.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this.h=v}}class I{constructor(v,k,D,f){this.c=v,this.d=k,this._accept(D),this.e=f;const d=this;this.value={get tabSize(){return d.f},set tabSize(u){d.m(u)},get indentSize(){return d.g},set indentSize(u){d.o(u)},get insertSpaces(){return d.h},set insertSpaces(u){d.q(u)},get cursorStyle(){return d.j},set cursorStyle(u){d.s(u)},get lineNumbers(){return d.k},set lineNumbers(u){d.t(u)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const k=Math.floor(v);return k>0?k:null}if(typeof v=="string"){const k=parseInt(v,10);return isNaN(k)?null:k>0?k:null}return null}m(v){const k=this.l(v);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const k=Math.floor(v);return k>0?k:null}if(typeof v=="string"){const k=parseInt(v,10);return isNaN(k)?null:k>0?k:null}return null}o(v){const k=this.n(v);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const k=this.p(v);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const k={};let D=!1;if(typeof v.tabSize<"u"){const f=this.l(v.tabSize);f==="auto"?(D=!0,k.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,D=!0,k.tabSize=f)}if(typeof v.indentSize<"u"){const f=this.n(v.indentSize);f==="tabSize"?(D=!0,k.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,D=!0,k.indentSize=f)}if(typeof v.insertSpaces<"u"){const f=this.p(v.insertSpaces);f==="auto"?(D=!0,k.insertSpaces=f):this.h!==f&&(this.h=f,D=!0,k.insertSpaces=f)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,D=!0,k.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,D=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(v,k){k.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(D)})}}e.ExtHostTextEditorOptions=I;class O{constructor(v,k,D,f,d,u,m,b){this.id=v,this.j=k,this.k=D,this.g=!1,this.h=new Set,this.c=d,this.d=new I(this.j,this.id,u,D),this.e=m,this.f=b;const C=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw(0,L.readonly)("document")},get selection(){return C.c&&C.c[0]},set selection(p){if(!(p instanceof S.Selection))throw(0,L.illegalArgument)("selection");C.c=[p],C.l()},get selections(){return C.c},set selections(p){if(!Array.isArray(p)||p.some(n=>!(n instanceof S.Selection)))throw(0,L.illegalArgument)("selections");C.c=p,C.l()},get visibleRanges(){return C.e},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return C.d.value},set options(p){C.g||C.d.assign(p)},get viewColumn(){return C.f},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,n={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(f.value,n);return p(s),C.m(s)},insertSnippet(p,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=C.c.map(a=>R.Range.from(a));else if(n instanceof S.Position){const{lineNumber:a,column:c}=R.Position.from(n);r=[{startLineNumber:a,startColumn:c,endLineNumber:a,endColumn:c}]}else if(n instanceof S.Range)r=[R.Range.from(n)];else{r=[];for(const a of n)if(a instanceof S.Range)r.push(R.Range.from(a));else{const{lineNumber:c,column:g}=R.Position.from(a);r.push({startLineNumber:c,startColumn:g,endLineNumber:c,endColumn:g})}}return k.$tryInsertSnippet(v,f.value.version,p.value,r,s)},setDecorations(p,n){const s=n.length===0;s&&!C.h.has(p.key)||(s?C.h.delete(p.key):C.h.add(p.key),C.n(()=>{if(R.isDecorationOptionsArr(n))return k.$trySetDecorations(v,p.key,R.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let a=0,c=n.length;a<c;a++){const g=n[a];r[4*a]=g.start.line+1,r[4*a+1]=g.start.character+1,r[4*a+2]=g.end.line+1,r[4*a+3]=g.end.character+1}return k.$trySetDecorationsFast(v,p.key,r)}}))},revealRange(p,n){C.n(()=>k.$tryRevealRange(v,R.Range.from(p),n||S.TextEditorRevealType.Default))},show(p){k.$tryShowEditor(v,R.ViewColumn.from(p))},hide(){k.$tryHideEditor(v)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,o.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,o.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,o.ok)(!this.g),this.f=v}_acceptSelections(v){(0,o.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const k=v.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const D=k.edits.map(d=>d.range);D.sort((d,u)=>d.end.line===u.end.line?d.end.character===u.end.character?d.start.line===u.start.line?d.start.character-u.start.character:d.start.line-u.start.line:d.end.character-u.end.character:d.end.line-u.end.line);for(let d=0,u=D.length-1;d<u;d++){const m=D[d].end;if(D[d+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=k.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,f,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.ExtHostTextEditor=O}),define(ye[245],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[246],De([1,0,195,10,37,123,92,39,27,245,209,198]),function(re,e,o,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=A.Registry.as(S.Extensions.JSONContribution);class k{constructor(p,n,s){this.a=p,this.b=n,this.c=s}d(p,n){this.a({type:p,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(l.default.Error,p)}warn(p){this.d(l.default.Warning,p)}info(p){this.d(l.default.Info,p)}}e.ExtensionMessageCollector=k;class D{static a(p){const n=new Set;for(let s=0,r=p.length;s<r;s++)n.add(y.ExtensionIdentifier.toKey(p[s].description.identifier));return n}static compute(p,n){if(!p||!p.length)return new D(n,[]);if(!n||!n.length)return new D([],p);const s=this.a(p),r=this.a(n),a=n.filter(g=>!s.has(y.ExtensionIdentifier.toKey(g.description.identifier))),c=p.filter(g=>!r.has(y.ExtensionIdentifier.toKey(g.description.identifier)));return new D(a,c)}constructor(p,n){this.added=p,this.removed=n}}e.ExtensionPointUserDelta=D;class f{constructor(p,n){this.name=p,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=D.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,L.onUnexpectedError)(p)}}}e.ExtensionPoint=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class m{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const n=new f(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,n),p.activationEventsGenerator&&P.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,v.registerSchema(u,e.schema),n}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=m;const b={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(b.ExtensionsRegistry,new m),e.ExtensionsRegistry=A.Registry.as(b.ExtensionsRegistry),v.registerSchema(u,e.schema),v.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(ye[247],De([1,0,192,9,23,246,54,3]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var I;(function(v){function k(D,f,d){if(!D)return;const u=L.isString(D.type)?D.type:void 0;if(!u||u.length===0){d.error(o.localize(3,null));return}const m=[];if(Array.isArray(D.required))for(const b of D.required)L.isString(b)&&m.push(b);return{extensionId:f.value,taskType:u,required:m,properties:D.properties?l.deepClone(D.properties):{},when:D.when?S.ContextKeyExpr.deserialize(D.when):void 0}}v.from=k})(I||(I={}));const O=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,k)=>{for(const D of v)D.type&&k.push(`onTaskType:${D.type}`)},jsonSchema:{description:o.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,D)=>{O.setHandler((f,d)=>{this.c=void 0;try{for(const u of d.removed){const m=u.value;for(const b of m)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const u of d.added){const m=u.value;for(const b of m){const C=I.from(b,u.description.identifier,u.collector);C&&(this.a[C.taskType]=C)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const D of this.all()){const f={type:"object",additionalProperties:!1};D.required.length>0&&(f.required=D.required.slice(0)),D.properties!==void 0?f.properties=l.deepClone(D.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[D.taskType]},k.push(f)}this.c={oneOf:k}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[248],De([1,0,193,9,24,23,54,247]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new S.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var y;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function T(F){if(!F)return U.Strong;switch(F.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=T}(y=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var O;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(U){function T(F){switch(F.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=T}(O=e.RevealKind||(e.RevealKind={}));var P;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function T(F){switch(F.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=T}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(U){function T(F){switch(F.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=T}(v=e.PanelKind||(e.PanelKind={}));var k;(function(U){U.defaults={echo:!0,reveal:O.Always,revealProblems:P.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var D;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(D=e.RuntimeType||(e.RuntimeType={})),function(U){function T(B){switch(B.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=T;function F(B){switch(B){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=F}(D=e.RuntimeType||(e.RuntimeType={}));var f;(function(U){function T(F){return L.isString(F)?F:F.value}U.value=T})(f=e.CommandString||(e.CommandString={}));var d;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function T(B){return B===U.Clean._id||B===U.Build._id||B===U.Rebuild._id||B===U.Test._id}U.is=T;function F(B){if(B!==void 0)return L.isString(B)?T(B)?{_id:B,isDefault:!1}:void 0:B}U.from=F})(d=e.TaskGroup||(e.TaskGroup={}));var u;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var m;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function T(F){switch(F){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=T})(m=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(U){U.parallel="parallel",U.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var C;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(C=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:C.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class n{constructor(T,F,B,Z,_,H){this._label="",this._id=T,F&&(this._label=F),B&&(this.type=B),this.runOptions=Z,this.configurationProperties=_,this._source=H}getDefinition(T){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,F=!1){if(T===void 0)return!1;if(L.isString(T))return T===this._label||T===this.configurationProperties.identifier||F&&T===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.CommonTask=n;class s extends n{constructor(T,F,B,Z,_,H,Y,ie){super(T,B,void 0,Y,ie,F),this.command={},this._source=F,this.hasDefinedMatchers=H,_&&(this.command=_)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case D.Shell:F="shell";break;case D.Process:F="process";break;case D.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(T){return T instanceof s}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:T,id:F};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new s(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.CustomTask=s;class r extends n{constructor(T,F,B,Z,_,H,Y){super(T,B,Z,H,Y,F),this._source=F,this.configures=_}static is(T){return T instanceof r}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===m.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==m.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:T,id:F};return JSON.stringify(B)}}e.ConfiguringTask=r;class a extends n{constructor(T,F,B,Z,_,H,Y,ie,ge){super(T,B,Z,ie,ge,F),this.defines=_,this.hasDefinedMatchers=Y,this.command=H,this.icon=ge.icon,this.hide=ge.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof a}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new a(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.ContributedTask=a;class c extends n{constructor(T,F,B,Z,_,H){super(T,B,Z,_,H,F),this._source=F}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.InMemoryTask=c;var g;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(g=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(g=e.ExecutionEngine||(e.ExecutionEngine={}));var i;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(i=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(T){this.c=new Map;for(let F=0;F<T.length;F++)this.c.set(T[F].uri.toString(),F)}compare(T,F){const B=T.getWorkspaceFolder(),Z=F.getWorkspaceFolder();if(B&&Z){let _=this.c.get(B.uri.toString());_=_===void 0?0:_+1;let H=this.c.get(Z.uri.toString());return H=H===void 0?0:H+1,_===H?T._label.localeCompare(F._label):_-H}else return!B&&Z?-1:B&&!Z?1:0}}e.TaskSorter=t;var h;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(h=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(U){U.SingleRun="singleRun",U.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var w;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(w=e.TaskRunSource||(e.TaskRunSource={}));var N;(function(U){function T(F,B,Z,_){if(B){const H={kind:F,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Z,__task:B};return F==="start"?H.resolvedVariables=_:F==="processStarted"?H.processId=_:F==="processEnded"&&(H.exitCode=_),Object.freeze(H)}else return Object.freeze({kind:"changed"})}U.create=T})(N=e.TaskEvent||(e.TaskEvent={}));var j;(function(U){function T(B){const Z=Object.keys(B).sort();let _="";for(const H of Z){let Y=B[H];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),_+=H+","+Y+","}return _}function F(B){const _={_key:T(B),type:B.taskType};return Object.assign(_,B),_}U.create=F})(j=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var Q;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(Q=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var q;(function(U){function T(F,B){const Z=A.TaskDefinitionRegistry.get(F.type);if(Z===void 0){const ie=R.deepClone(F);return delete ie._key,j.create(ie)}const _=Object.create(null);_.type=Z.taskType;const H=new Set;Z.required.forEach(ie=>H.add(ie));const Y=Z.properties;for(const ie of Object.keys(Y)){const ge=F[ie];if(ge!=null)_[ie]=ge;else if(H.has(ie)){const X=Y[ie];if(X.default!==void 0)_[ie]=R.deepClone(X.default);else switch(X.type){case"boolean":_[ie]=!1;break;case"number":case"integer":_[ie]=0;break;case"string":_[ie]="";break;default:B.error(o.localize(2,null,JSON.stringify(F,void 0,0),ie));return}}}return j.create(_)}U.createTaskIdentifier=T})(q=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[249],De([1,0,10]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((S,A)=>{this.b=S,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(S){this.f||this.h||(this.f=!0,this.g=S,this.a&&this.b(S))}resolveErr(S){this.f||this.h||(this.h=!0,this.i=S,this.a?this.d(S):(0,o.onUnexpectedError)(S))}then(S,A){return this.j().then(S,A)}catch(S){return this.j().then(void 0,S)}finally(S){return this.j().finally(S)}}e.LazyPromise=L;class l extends L{constructor(){super(),this.h=!0,this.i=new o.CancellationError}}e.CanceledLazyPromise=l}),define(ye[58],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++o.count}}o.count=0,e.ProxyIdentifier=o;const L=[];function l(A){const y=new o(A);return L[y.nid]=y,y}e.createProxyIdentifier=l;function R(A){return L[A].sid}e.getStringIdentifierForProxy=R;class S{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=S}),define(ye[5],De([1,0,58]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var R;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(d){return d._id=P.a++,d}}P.a=0,e.IdObject=P;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(D=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,o.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[77],De([1,0,4,13,5,20]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,I){this.c=I,this.a=new Set,this.b=y.getProxy(l.MainContext.MainThreadTelemetry)}report(y,I,O){const P=this.d(y,I);this.a.has(P)||(this.a.add(P),I.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:y}))}d(y,I){return`${y}-${I.identifier.value}`}};S=xe([ze(0,R.IExtHostRpcService),ze(1,L.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,I){}})}),define(ye[250],De([1,0,3,5,7,27]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this.b=new Map,this.c=[],this.d=new o.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,I,O,P={}){const v=R.ExtensionIdentifier.toKey(y.identifier),k=this.f.get(v)||[],D=[...O].sort().join(" ");let f=k.find(d=>d.providerId===I&&d.scopes===D);if(f)return f.result;{const d=this.g(y,v,I,O,P);f={providerId:I,scopes:D,result:d},k.push(f),this.f.set(v,k);try{await d}finally{const u=k.findIndex(m=>m.providerId===I&&m.scopes===D);u>-1&&(k.splice(u),this.f.set(v,k))}return d}}async g(y,I,O,P,v={}){await this.a.$ensureProvider(O);const k=y.displayName||y.name;return this.a.$getSession(O,P,I,k,v)}async removeSession(y,I){const O=this.b.get(y);return O?O.provider.removeSession(I):this.a.$removeSession(y,I)}registerAuthenticationProvider(y,I,O,P){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:I,provider:O,options:P??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===y)||this.c.push({id:y,label:I});const v=O.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(y,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(y,I,P?.supportsMultipleAccounts??!1),new l.Disposable(()=>{v.dispose(),this.b.delete(y);const k=this.c.findIndex(D=>D.id===y);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,I){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,I){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,I){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,I){return this.d.fire({provider:{id:y,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(ye[251],De([1,0,5,20,14]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,y){this.a=A.getProxy(o.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>y.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,I){const O=l.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,I?.isRefactoring??!1)}};R=xe([ze(0,L.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[252],De([1,0,5]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(R){const S=R.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(A){return S.$writeText(A)}})}}e.ExtHostClipboard=L});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[40],De([1,0,9,7,14,23,5,15,13,69,32,52,2,6,4,20,137,22,58,45,43,73,76]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p,n){"use strict";var s,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(w,N,j){s.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),a.set(this,void 0),_e(this,s,w.getProxy(S.MainContext.MainThreadCommands),"f"),this.d=N,_e(this,a,j,"f"),_e(this,r,w.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new g(this,V=>{const Q=this.c.get(V);return Q?.result===t.Void?Q:void 0},N),this.f=[{processArgument(V){return(0,I.revive)(V)}},{processArgument(V){return(0,R.cloneAndChange)(V,function(Q){if(O.Range.isIRange(Q))return l.Range.to(Q);if(P.Position.isIPosition(Q))return l.Position.to(Q);if(O.Range.isIRange(Q.range)&&v.URI.isUri(Q.uri))return l.location.to(Q);if(Q instanceof u.VSBuffer)return Q.buffer.buffer;if(!Array.isArray(Q))return Q})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const N=this.registerCommand(!1,w.id,async(...j)=>{const V=w.args.map((q,U)=>{if(!q.validate(j[U]))throw new Error(`Invalid argument '${q.name}' when running '${w.id}', received: ${j[U]}`);return q.convert(j[U])}),Q=await this.executeCommand(w.internalId,...V);return w.result.convert(Q,j,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new L.Disposable(()=>{N.dispose(),this.c.delete(w.id)})}registerCommand(w,N,j,V,Q,q){if(this.d.trace("ExtHostCommands#registerCommand",N),!N.trim().length)throw new Error("invalid id");if(this.b.has(N))throw new Error(`command '${N}' already exists`);return this.b.set(N,{callback:j,thisArg:V,description:Q,extension:q}),w&&Ue(this,s,"f").$registerCommand(N),new L.Disposable(()=>{this.b.delete(N)&&w&&Ue(this,s,"f").$unregisterCommand(N)})}executeCommand(w,...N){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,N,!0)}async g(w,N,j){if(this.b.has(w))return Ue(this,s,"f").$fireCommandActivationEvent(w),this.h(w,N,!1);{let V=!1;const Q=(0,R.cloneAndChange)(N,function(q){if(q instanceof L.Position)return l.Position.from(q);if(q instanceof L.Range)return l.Range.from(q);if(q instanceof L.Location)return l.location.from(q);if(L.NotebookRange.isNotebookRange(q))return l.NotebookRange.from(q);if(q instanceof ArrayBuffer)return V=!0,u.VSBuffer.wrap(new Uint8Array(q));if(q instanceof Uint8Array)return V=!0,u.VSBuffer.wrap(q);if(q instanceof u.VSBuffer)return V=!0,q;if(!Array.isArray(q))return q});try{const q=await Ue(this,s,"f").$executeCommand(w,V?new m.SerializableObjectWithBuffers(Q):Q,j);return(0,I.revive)(q)}catch(q){if(q instanceof Error&&q.message==="$executeCommand:retry")return this.g(w,N,!1);throw q}}}async h(w,N,j){const V=this.b.get(w);if(!V)throw new Error("Unknown command");const{callback:Q,thisArg:q,description:U}=V;if(U)for(let F=0;F<U.args.length;F++)try{(0,o.validateConstraint)(N[F],U.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${U.args[F].name}' - ${U.args[F].description}`)}const T=C.StopWatch.create();try{return await Q.apply(q,N)}catch(F){if(w===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...N);B&&(w=B.command)}if(this.d.error(F,w,V.extension?.identifier),!j)throw F;if(V.extension?.identifier){const B=Ue(this,a,"f").onExtensionError(V.extension.identifier,F);this.d.trace("forwarded error to extension?",B,V.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)(F)),this.id=w,this.source=V.extension?.displayName??V.extension?.name}}}finally{this.j(V,w,T.elapsed())}}j(w,N,j){!w.extension||Ue(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new p.TelemetryTrustedValue(N),duration:j})}$executeContributedCommand(w,...N){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const j=this.b.get(w);return j?(N=N.map(V=>this.f.reduce((Q,q)=>q.processArgument(Q,j.extension?.identifier),V)),this.h(w,N,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),Ue(this,s,"f").$getCommands().then(N=>(w&&(N=N.filter(j=>j[0]!=="_")),N))}$getContributedCommandHandlerDescriptions(){const w=Object.create(null);for(const[N,j]of this.b){const{description:V}=j;V&&(w[N]=V)}return Promise.resolve(w)}};s=new WeakMap,r=new WeakMap,a=new WeakMap,c=xe([ze(0,f.IExtHostRpcService),ze(1,y.ILogService),ze(2,n.IExtHostTelemetry)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,D.createDecorator)("IExtHostCommands");class g{constructor(w,N,j){this.d=w,this.f=N,this.g=j,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,N){if(!w)return;const j={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return j;const V=this.f(w.command);if(V)j.id=V.internalId,j.arguments=V.args.map((Q,q)=>Q.convert(w.arguments&&w.arguments[q]));else if((0,A.isNonEmptyArray)(w.arguments)){const Q=`${w.command}/${++this.c}`;this.b.set(Q,w),N.add((0,k.toDisposable)(()=>{this.b.delete(Q),this.g.trace("CommandsConverter#DISPOSE",Q)})),j.$ident=Q,j.id=this.delegatingCommandId,j.arguments=[Q],this.g.trace("CommandsConverter#CREATE",w.command,Q)}return j}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const N=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],N?N.command:"MISSING"),N?this.d.executeCommand(N.command,...N.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.CommandsConverter=g;class i{constructor(w,N,j,V){this.name=w,this.description=N,this.validate=j,this.convert=V}optional(){return new i(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,N){return new i(w??this.name,N??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",E=>v.URI.isUri(E),E=>E),i.Position=new i("position","A position in a text document",E=>L.Position.isPosition(E),l.Position.from),i.Range=new i("range","A range in a text document",E=>L.Range.isRange(E),l.Range.from),i.Selection=new i("selection","A selection in a text document",E=>L.Selection.isSelection(E),l.Selection.from),i.Number=new i("number","",E=>typeof E=="number",E=>E),i.String=new i("string","",E=>typeof E=="string",E=>E),i.CallHierarchyItem=new i("item","A call hierarchy item",E=>E instanceof L.CallHierarchyItem,l.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",E=>E instanceof L.TypeHierarchyItem,l.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",E=>E instanceof d.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=i;class t{constructor(w,N){this.description=w,this.convert=N}}t.Void=new t("no result",E=>E),e.ApiCommandResult=t;class h{constructor(w,N,j,V,Q){this.id=w,this.internalId=N,this.description=j,this.args=V,this.result=Q}}e.ApiCommand=h}),define(ye[253],De([1,0,2,14,7,71,40,15,120,125,16]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(L.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,A.isFalsyOrEmpty)(f))return;class u extends l.SymbolInformation{static to(b){const C=new u(b.name,L.SymbolKind.to(b.kind),b.containerName||"",new l.Location(d[0],L.Range.to(b.range)));return C.detail=b.detail,C.range=C.location.range,C.selectionRange=L.Range.to(b.selectionRange),C.children=b.children?b.children.map(u.to):[],C}}return f.map(u.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new S.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(L.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(L.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>l.Position.isPosition(d)),f=>f.map(L.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(d=>{let u;for(const m of d.reverse())u=new l.SelectionRange(L.Range.to(m),u);return u}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(L.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(L.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(L.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(L.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:L.Range.to(f.range),placeholder:f.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return L.WorkspaceEdit.to(f)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(L.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,y.decodeSemanticTokensDto)(f);if(d.type==="full")return new l.SemanticTokens(d.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,y.decodeSemanticTokensDto)(f);if(d.type==="full")return new l.SemanticTokens(d.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,d,u)=>{if(!f)return new l.CompletionList([]);const m=f.suggestions.map(b=>L.CompletionItem.to(b,u));return new l.CompletionList(m,f.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return L.SignatureHelp.to(f)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,d,u)=>k(m=>new l.CodeLens(L.Range.to(m.range),m.command&&u.fromInternal(m.command)))(f))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>l.Range.isRange(f),f=>l.Selection.isSelection(f)?L.Selection.from(f):L.Range.from(f)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,d,u)=>k(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(m.command)}else{const b=new l.CodeAction(m.title,m.kind?new l.CodeActionKind(m.kind):void 0);return m.edit&&(b.edit=L.WorkspaceEdit.to(m.edit)),m.command&&(b.command=u.fromInternal(m.command)),b.isPreferred=m.isPreferred,b}})(f))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new l.ColorInformation(L.Range.to(d.range),L.Color.to(d.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",f=>f instanceof l.Color,L.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:L.Range.from(f.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(L.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,d,u)=>f.map(L.InlayHint.to.bind(void 0,u)))),new S.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(f,d)=>{if(f)return f.map(L.FoldingRange.to)})),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>L.NotebookExclusiveDocumentPattern.to(d))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(L.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>o.URI.isUri(f)||typeof f=="string"&&(0,I.matchesSomeScheme)(f,O.Schemas.http,O.Schemas.https),f=>f),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[L.ViewColumn.from(f),void 0]:[L.ViewColumn.from(f.viewColumn),L.TextEditorOpenOptions.from(f)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[L.ViewColumn.from(f),void 0]:[L.ViewColumn.from(f.viewColumn),L.TextEditorOpenOptions.from(f)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[L.ViewColumn.from(f.viewColumn),L.TextEditorOpenOptions.from(f)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(L.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(L.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(L.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void),new S.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[S.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],S.ApiCommandResult.Void),new S.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[S.ApiCommandArgument.String.with("name","The context key name"),new S.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],S.ApiCommandResult.Void)];class v{static register(d){P.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function k(f){return d=>{if(Array.isArray(d))return d.map(f)}}function D(f){if(!Array.isArray(f))return;const d=[];for(const u of f)R.isLocationLink(u)?d.push(L.DefinitionLink.to(u)):d.push(L.location.to(u));return d}}),define(ye[254],De([1,0,19,62,3,6,2,71,27,14,7,5]),function(re,e,o,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(k,D,f){const d=k.getProxy(P.MainContext.MainThreadComments);class u{constructor(){this.b=new Map,this.c=new Map,D.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const g=this.b.get(c.handle);return g?g.value:c}else if(c&&c.$mid===7){const g=this.b.get(c.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.commentThreadHandle);return i?i.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const g=this.b.get(c.thread.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.thread.commentThreadHandle);return i?c.$mid===8?i.value:{thread:i.value,text:c.text}:c}else if(c&&c.$mid===10){const g=this.b.get(c.thread.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.thread.commentThreadHandle);if(!i)return c;const t=c.commentUniqueId,h=i.getCommentByUniqueId(t);return h||c}else if(c&&c.$mid===11){const g=this.b.get(c.thread.commentControlHandle);if(!g)return c;const i=g.getCommentThread(c.thread.commentThreadHandle);if(!i)return c;const t=c.text,h=c.commentUniqueId,E=i.getCommentByUniqueId(h);return E?(typeof E.body=="string"?E.body=t:E.body=new O.MarkdownString(t),E):c}return c}})}createCommentController(c,g,i){const t=u.a++,h=new b(c,t,g,i);this.b.set(h.handle,h);const E=this.c.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return E.push(h),this.c.set(y.ExtensionIdentifier.toKey(c.identifier),E),h.value}$createCommentThreadTemplate(c,g,i){const t=this.b.get(c);!t||t.$createCommentThreadTemplate(g,i)}async $updateCommentThreadTemplate(c,g,i){const t=this.b.get(c);!t||t.$updateCommentThreadTemplate(g,i)}$deleteCommentThread(c,g){this.b.get(c)?.$deleteCommentThread(g)}$provideCommentingRanges(c,g,i){const t=this.b.get(c);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const h=f.getDocument(S.URI.revive(g));return(0,o.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(h,i)).then(E=>E?E.map(w=>I.Range.from(w)):void 0)}$toggleReaction(c,g,i,t,h){const E=this.b.get(c);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const w=E.getCommentThread(g);if(w){const N=w.getCommentByUniqueId(t.uniqueIdInThread);if(E!==void 0&&N&&E.reactionHandler)return E.reactionHandler(N,n(h))}return Promise.resolve(void 0)})}dispose(){}}u.a=0;class m{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){c.isEqual(this.p)||(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,g,i,t,h,E,w,N){this.m=g,this.n=i,this.o=t,this.p=h,this.q=E,this.extensionDescription=w,this.r=N,this.handle=m.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),d.$createCommentThread(g,this.handle,this.n,this.o,I.Range.from(this.p),w.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{d.$deleteCommentThread(g,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(V){j.range=V},get comments(){return j.comments},set comments(V){j.comments=V},get collapsibleState(){return j.collapsibleState},set collapsibleState(V){j.collapsibleState=V},get canReply(){return j.canReply},set canReply(V){j.canReply=V},get contextValue(){return j.contextValue},set contextValue(V){j.contextValue=V},get label(){return j.label},set label(V){j.label=V},get state(){return j.state},set state(V){j.state=V},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const c=i=>Object.prototype.hasOwnProperty.call(this.b,i),g={};c("range")&&(g.range=I.Range.from(this.p)),c("label")&&(g.label=this.label),c("contextValue")&&(g.contextValue=this.contextValue??null),c("comments")&&(g.comments=this.q.map(i=>C(this,i,this.k))),c("collapsibleState")&&(g.collapseState=s(this.g)),c("canReply")&&(g.canReply=this.canReply),c("state")&&(g.state=r(this.h)),c("isTemplate")&&(g.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,g)}getCommentByUniqueId(c){for(const g of this.k){const i=g[0],t=g[1];if(c===t)return i}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}m.a=0,xe([(0,L.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,g,i,t){this.f=c,this.g=g,this.h=i,this.i=t,this.a=new Map,d.$registerCommentController(this.handle,i,t);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(E){h.options=E},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(E){h.commentingRangeProvider=E},get reactionHandler(){return h.reactionHandler},set reactionHandler(E){h.reactionHandler=E},createCommentThread(E,w,N){return h.createCommentThread(E,w,N).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(c,g,i,t){if(typeof c=="string"){const h=new m(this.id,this.handle,c,g,i,t,this.f,!1);return this.a.set(h.handle,h),h}else{const h=new m(this.id,this.handle,void 0,c,g,i,this.f,!1);return this.a.set(h.handle,h),h}}$createCommentThreadTemplate(c,g){const i=new m(this.id,this.handle,void 0,S.URI.revive(c),I.Range.to(g),[],this.f,!0);return i.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(i.handle,i),i}$updateCommentThreadTemplate(c,g){const i=this.a.get(c);i&&(i.range=I.Range.to(g))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function C(a,c,g){let i=g.get(c);i||(i=++a.commentHandle,g.set(c,i));const t=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:i,body:typeof c.body=="string"?c.body:I.MarkdownString.from(c.body),userName:c.author.name,userIconPath:t,label:c.label,commentReactions:c.reactions?c.reactions.map(h=>p(h)):void 0,timestamp:c.timestamp?.toJSON()}}function p(a){return{label:a.label,iconPath:a.iconPath?I.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function n(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?S.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function s(a){if(a!==void 0)switch(a){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function r(a){if(a!==void 0)switch(a){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new u}e.createExtHostComments=v}),define(ye[255],De([1,0,23,5,25,20]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let S=class{constructor(O,P){this.a=O.getProxy(L.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,P){const v=this,k=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){v.e(O,P,k,arguments)}})}e(O,P,v,k){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(k,this.b)}),this.c&&this.f(O,v,k)}};S=xe([ze(0,R.IExtHostRpcService),ze(1,l.IExtHostInitDataService)],S),e.AbstractExtHostConsoleForwarder=S;const A=1e5;function y(I,O){const P=[];if(I.length)for(let v=0;v<I.length;v++){let k=I[v];if(typeof k>"u")k="undefined";else if(k instanceof Error){const D=k;D.stack?k=D.stack:k=D.toString()}P.push(k)}if(O){const v=new Error().stack;v&&P.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,o.safeStringify)(P);return v.length>A?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],De([1,0,2,5,7,4,20,13,15,8,12,26]),function(re,e,o,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(D,f){this.h=f,this.f=new Map,this.g=D.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(D,f){const d=Mi.c++;this.f.set(d,{provider:D,extensionDescription:f}),this.g.$registerDecorationProvider(d,f.identifier.value);const u=D.onDidChangeFileDecorations&&D.onDidChangeFileDecorations(m=>{if(!m){this.g.$onDidChange(d,null);return}const b=(0,y.asArray)(m);if(b.length<=Mi.d){this.g.$onDidChange(d,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,b.length);const C=b.map(s=>({uri:s,rank:(0,I.count)(s.path,"/")})),p=(0,y.groupBy)(C,(s,r)=>s.rank-r.rank||(0,I.compare)(s.uri.path,r.uri.path)),n=[];e:for(const s of p){let r;for(const a of s){const c=(0,O.dirname)(a.uri.path);if(r!==c&&(r=c,n.push(a.uri)>=Mi.d))break e}}this.g.$onDidChange(d,n)});return new l.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(D,f,d){if(!this.f.has(D))return Object.create(null);const u=Object.create(null),{provider:m,extensionDescription:b}=this.f.get(D);return await Promise.all(f.map(async C=>{try{const{uri:p,id:n}=C,s=await Promise.resolve(m.provideFileDecoration(o.URI.revive(p),d));if(!s)return;try{l.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.checkProposedApiEnabled)(b,"codiconDecoration"),u[n]=[s.propagate,s.tooltip,s.badge,s.color]}catch(r){this.h.warn(`INVALID decoration from extension '${b}': ${r}`)}}catch(p){this.h.error(p)}})),u}};v.c=0,v.d=250,v=xe([ze(0,S.IExtHostRpcService),ze(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[256],De([1,0,177,124,2,5,7,14,3,13,28,48]),function(re,e,o,L,l,R,S,A,y,I,O,P){"use strict";var v,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(m,b,C,p,n,s,r){this.d=m,this.e=b,this.f=C,this.g=p,v.set(this,void 0),k.set(this,void 0),D.set(this,void 0),this.c=!1,_e(this,D,new O.ResourceMap(a=>n.getComparisonKey(a)),"f"),_e(this,v,s,"f"),_e(this,k,r,"f")}dispose(){this.c||(Ue(this,k,"f").fire([...Ue(this,D,"f").keys()]),Ue(this,v,"f")?.$clear(this.e),Ue(this,D,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(m,b){if(!m){this.clear();return}this.h();let C=[];if(l.URI.isUri(m)){if(!b){this.delete(m);return}Ue(this,D,"f").set(m,b.slice()),C=[m]}else if(Array.isArray(m)){C=[];let n;m=[...m].sort(f.j);for(const s of m){const[r,a]=s;if((!n||r.toString()!==n.toString())&&(n&&Ue(this,D,"f").get(n).length===0&&Ue(this,D,"f").delete(n),n=r,C.push(r),Ue(this,D,"f").set(r,[])),a)Ue(this,D,"f").get(r)?.push(...a);else{const c=Ue(this,D,"f").get(r);c&&(c.length=0)}}}if(Ue(this,k,"f").fire(C),!Ue(this,v,"f"))return;const p=[];for(const n of C){let s=[];const r=Ue(this,D,"f").get(n);if(r)if(r.length>this.f){s=[];const a=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const g of r)if(g.severity===a[c]&&s.push({...A.Diagnostic.from(g),modelVersionId:this.g(n)})===this.f)break e;s.push({severity:L.MarkerSeverity.Info,message:(0,o.localize)(0,null,r.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(a=>({...A.Diagnostic.from(a),modelVersionId:this.g(n)}));p.push([n,s])}Ue(this,v,"f").$changeMany(this.e,p)}delete(m){this.h(),Ue(this,k,"f").fire([m]),Ue(this,D,"f").delete(m),Ue(this,v,"f")?.$changeMany(this.e,[[m,void 0]])}clear(){this.h(),Ue(this,k,"f").fire([...Ue(this,D,"f").keys()]),Ue(this,D,"f").clear(),Ue(this,v,"f")?.$clear(this.e)}forEach(m,b){this.h();for(const[C,p]of this)m.call(b,C,p,this)}*[(v=new WeakMap,k=new WeakMap,D=new WeakMap,Symbol.iterator)](){this.h();for(const m of Ue(this,D,"f").keys())yield[m,this.get(m)]}get(m){this.h();const b=Ue(this,D,"f").get(m);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(m){return this.h(),Array.isArray(Ue(this,D,"f").get(m))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(m,b){return m[0].toString()<b[0].toString()?-1:m[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=f;let d=class pi{static _mapper(m){const b=new O.ResourceMap;for(const C of m)b.set(C,C);return{uris:Object.freeze(Array.from(b.values()))}}constructor(m,b,C,p){this.h=b,this.j=C,this.k=p,this.f=new Map,this.g=new y.DebounceEmitter({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=m.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(m,b){const{f:C,e:p,g:n,h:s,j:r,k:a}=this,c=new class{$changeMany(t,h){p.$changeMany(t,h),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,t,h.length===0?"CLEARING":h)}$clear(t){p.$clear(t),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,t)}dispose(){p.dispose()}};let g;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,g=b;else if(!C.has(b))g=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do g=b+pi.c++;while(C.has(g))}return new class extends f{constructor(){super(b,g,pi.d,t=>a.getDocument(t)?.version,r.extUri,c,n),C.set(g,this)}dispose(){super.dispose(),C.delete(g)}}}getDiagnostics(m){if(m)return this.l(m);{const b=new Map,C=[];for(const p of this.f.values())p.forEach((n,s)=>{let r=b.get(n.toString());typeof r>"u"&&(r=C.length,b.set(n.toString(),r),C.push([n,[]])),C[r][1]=C[r][1].concat(...s)});return C}}l(m){let b=[];for(const C of this.f.values())C.has(m)&&(b=b.concat(C.get(m)));return b}$acceptMarkersChange(m){if(!this.m){const b="_generated_mirror",C=new f(b,b,pi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(b,C),this.m=C}for(const[b,C]of m)this.m.set(l.URI.revive(b),C.map(A.Diagnostic.to))}};d.c=0,d.d=1e3,d=xe([ze(1,I.ILogService),ze(2,P.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[257],De([1,0,2,5,26]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(A){this.a=A.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(A,y){return y?.allowUIResources&&(0,l.checkProposedApiEnabled)(A,"showLocal"),this.a.$showOpenDialog(y).then(I=>I?I.map(O=>o.URI.revive(O)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(y=>y?o.URI.revive(y):void 0)}}e.ExtHostDialogs=R}),define(ye[258],De([1,0,10,2,7,5,16,21,8]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(P,v,k){this.d=v,this.e=k,this.b=new Map,this.c=P.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,v){if(Object.keys(S.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const k=I.a++;this.b.set(k,v),this.c.$registerTextContentProvider(k,P);let D;return typeof v.onDidChange=="function"&&(D=v.onDidChange(f=>{if(f.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(k,f).then(d=>{if(!d&&typeof d!="string")return;const u=this.d.getDocument(f);if(!u)return;const m=(0,y.splitLines)(d);if(!u.equalLines(m))return this.c.$onVirtualDocumentChange(f,d)},o.onUnexpectedError)})),new l.Disposable(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(P,v){const k=this.b.get(P);return k?Promise.resolve(k.provideTextDocumentContent(L.URI.revive(v),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}I.a=0,e.ExtHostDocumentContentProvider=I}),define(ye[259],De([1,0,3,6,2,5,135,14,9,23,7]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(k,D){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.DisposableStore,this.h=new Map,this.f=k.getProxy(R.MainContext.MainThreadDocuments),this.g=D,this.g.onDidRemoveDocuments(f=>{for(const d of f)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const d of f)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const D=this.g.getDocument(k);if(D)return D}getDocument(k){const D=this.getDocumentData(k);if(!D?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return D.document}ensureDocumentData(k){const D=this.g.getDocument(k);if(D)return Promise.resolve(D);let f=this.h.get(k.toString());return f||(f=this.f.$tryOpenDocument(k).then(d=>{this.h.delete(k.toString());const u=l.URI.revive(d);return(0,y.assertIsDefined)(this.g.getDocument(u))},d=>(this.h.delete(k.toString()),Promise.reject(d))),this.h.set(k.toString(),f)),f}createDocumentData(k){return this.f.$tryCreateDocument(k).then(D=>l.URI.revive(D))}$acceptModelLanguageChanged(k,D){const f=l.URI.revive(k),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(D),this.a.fire(d.document)}$acceptModelSaved(k){const D=l.URI.revive(k),f=this.g.getDocument(D);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(k,D){const f=l.URI.revive(k),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");d._acceptIsDirty(D),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,D,f){const d=l.URI.revive(k),u=this.g.getDocument(d);if(!u)throw new Error("unknown document");u._acceptIsDirty(f),u.onEvents(D);let m;D.isUndoing?m=O.TextDocumentChangeReason.Undo:D.isRedoing&&(m=O.TextDocumentChangeReason.Redo),this.c.fire((0,I.deepFreeze)({document:u.document,contentChanges:D.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:m}))}setWordDefinitionFor(k,D){(0,S.setWordDefinitionFor)(k,D)}}e.ExtHostDocuments=P}),define(ye[59],De([1,0,50,3,6,2,4,5,135,20,138,14,13,28,16,64,65]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(C){this.value=C,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(C,p){this.h=C,this.i=p,this.a=null,this.b=new Map,this.c=new k.ResourceMap,this.d=new L.Emitter,this.e=new L.Emitter,this.f=new L.Emitter,this.g=new L.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(C){this.acceptDocumentsAndEditorsDelta(C)}acceptDocumentsAndEditorsDelta(C){const p=[],n=[],s=[];if(C.removedDocuments)for(const r of C.removedDocuments){const a=R.URI.revive(r),c=this.c.get(a);c?.unref()&&(this.c.delete(a),p.push(c.value))}if(C.addedDocuments)for(const r of C.addedDocuments){const a=R.URI.revive(r.uri);let c=this.c.get(a);if(c&&a.scheme!==D.Schemas.vscodeNotebookCell&&a.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);c||(c=new u(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(a,c),n.push(c.value)),c.ref()}if(C.removedEditors)for(const r of C.removedEditors){const a=this.b.get(r);this.b.delete(r),a&&s.push(a)}if(C.addedEditors)for(const r of C.addedEditors){const a=R.URI.revive(r.documentUri);o.ok(this.c.has(a),`document '${a}' does not exist`),o.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const c=this.c.get(a).value,g=new O.ExtHostTextEditor(r.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>c.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(i=>P.Range.to(i)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,g)}C.newActiveEditor!==void 0&&(o.ok(C.newActiveEditor===null||this.b.has(C.newActiveEditor),`active editor '${C.newActiveEditor}' does not exist`),this.a=C.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(s),C.removedDocuments&&this.e.fire(p),C.addedDocuments&&this.d.fire(n),(C.removedEditors||C.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),C.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(C){return this.c.get(C)?.value}allDocuments(){return f.Iterable.map(this.c.values(),C=>C.value)}getEditor(C){return this.b.get(C)}activeEditor(C){if(!this.a)return;const p=this.b.get(this.a);return C?p:p?.value}allEditors(){return[...this.b.values()]}};m=xe([ze(0,I.IExtHostRpcService),ze(1,v.ILogService)],m),e.ExtHostDocumentsAndEditors=m,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],De([1,0,14,5,2,3,4,7,20,9,61]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class P{constructor(d,u,m){this.e=m,this.d=u,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,u={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(l.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,u){this.c=[],this.d="",this.b=d,this.e=u;for(const m of d.tabs)m.isActive&&(this.d=m.id),this.c.push(new P(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,u={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return o.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(m=>m.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(m=>m.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const m=new P(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,m),d.tabDto.isActive&&(this.d=m.tabId),m}else if(d.kind===1){const m=this.c.splice(d.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(d.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,m),m}const u=this.c.find(m=>m.tabId===d.tabDto.id);if(!u)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(d.tabDto),u}activeTabId(){return this.d}}let k=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(L.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,u={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(m=>m.apiObject))},get activeTabGroup(){const m=d.d;return(0,I.assertIsDefined)(d.e.find(C=>C.groupId===m)?.apiObject)},close:async(m,b)=>{const C=Array.isArray(m)?m:[m];return C.length?D(C[0])?this.j(C,b):this.i(C,b):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(d){const u=new Set(this.e.map(r=>r.groupId)),m=new Set(d.map(r=>r.groupId)),b=(0,O.diffSets)(u,m),C=this.e.filter(r=>b.removed.includes(r.groupId)).map(r=>r.apiObject),p=[],n=[];this.e=d.map(r=>{const a=new v(r,()=>this.d);return b.added.includes(a.groupId)?p.push(a.apiObject):n.push(a.apiObject),a});const s=(0,I.assertIsDefined)(d.find(r=>r.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:p,closed:C,changed:n}))}$acceptTabGroupUpdate(d){const u=this.e.find(m=>m.groupId===d.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const u=this.e.find(b=>b.groupId===d.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const m=u.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(d){for(const u of this.e)for(const m of u.tabs)if(m.apiObject===d)return m}h(d){return this.e.find(u=>u.apiObject===d)}async i(d,u){const m=[];for(const b of d){const C=this.g(b);if(!C)throw new Error("Tab close: Invalid tab not found!");m.push(C.tabId)}return this.a.$closeTab(m,u)}async j(d,u){const m=[];for(const b of d){const C=this.h(b);if(!C)throw new Error("Group close: Invalid group not found!");m.push(C.groupId)}return this.a.$closeGroup(m,u)}};k=xe([ze(0,y.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function D(f){return f.tabs!==void 0}}),define(ye[260],De([1,0,2,5,6,7,14,154,8,22,26]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(D){this.b=void 0,this.a.push(D)}delete(D){const f=this.a.indexOf(D);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const D=this.a.sort(),f=[];let d,u,m=14,b=14;for(const C of D){let p=d?(0,y.commonPrefixLength)(d,C):0;for(p===0?u=1:u=b;p<C.length;p++)p+1===C.length?(m=b,b=9):b+=1,f.push([u,C.toUpperCase().charCodeAt(p),b]),f.push([u,C.toLowerCase().charCodeAt(p),b]),u=b;d=C,b=m}f.push([9,58,10]),f.push([10,47,12]),this.b=new A.StateMachine(f)}}provideDocumentLinks(D){this.c();const f=[],d=A.LinkComputer.computeLinks({getLineContent(u){return D.lineAt(u-1).text},getLineCount(){return D.lineCount}},this.b);for(const u of d){const m=S.DocumentLink.to(u);m.target&&f.push(m)}return f}}class v{constructor(D,f){this.i=f,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=D.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(D,f,d,u={}){if(this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(D,"*",this.b));const m=this.h++;this.b.add(f),this.d.add(f),this.c.set(m,d);let b=2;u.isCaseSensitive&&(b+=1024),u.isReadonly&&(b+=2048),typeof d.copy=="function"&&(b+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,O.checkProposedApiEnabled)(D,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(m,f,b).catch(p=>{console.error(`FAILED to register filesystem provider of ${D.identifier.value}-extension for the scheme ${f}`),console.error(p)});const C=d.onDidChangeFile(p=>{const n=[];for(const s of p){const{uri:r,type:a}=s;if(r.scheme!==f)continue;let c;switch(a){case R.FileChangeType.Changed:c=0;break;case R.FileChangeType.Created:c=1;break;case R.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:r,type:c})}this.a.$onFileSystemChange(m,n)});return(0,l.toDisposable)(()=>{C.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(D){const{type:f,ctime:d,mtime:u,size:m,permissions:b}=D;return{type:f,ctime:d,mtime:u,size:m,permissions:b}}$stat(D,f){return Promise.resolve(this.k(D).stat(o.URI.revive(f))).then(d=>v.j(d))}$readdir(D,f){return Promise.resolve(this.k(D).readDirectory(o.URI.revive(f)))}$readFile(D,f){return Promise.resolve(this.k(D).readFile(o.URI.revive(f))).then(d=>I.VSBuffer.wrap(d))}$writeFile(D,f,d,u){return Promise.resolve(this.k(D).writeFile(o.URI.revive(f),d.buffer,u))}$delete(D,f,d){return Promise.resolve(this.k(D).delete(o.URI.revive(f),d))}$rename(D,f,d,u){return Promise.resolve(this.k(D).rename(o.URI.revive(f),o.URI.revive(d),u))}$copy(D,f,d,u){const m=this.k(D);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(o.URI.revive(f),o.URI.revive(d),u))}$mkdir(D,f){return Promise.resolve(this.k(D).createDirectory(o.URI.revive(f)))}$watch(D,f,d,u){const m=this.k(D).watch(o.URI.revive(d),u);this.f.set(f,m)}$unwatch(D,f){const d=this.f.get(f);d&&(d.dispose(),this.f.delete(f))}$open(D,f,d){const u=this.k(D);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(o.URI.revive(f),d))}$close(D,f){const d=this.k(D);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(f))}$read(D,f,d,u){const m=this.k(D);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const b=I.VSBuffer.alloc(u);return Promise.resolve(m.read(f,d,b.buffer,0,u)).then(C=>b.slice(0,C))}$write(D,f,d,u){const m=this.k(D);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(f,d,u.buffer,0,u.byteLength))}k(D){const f=this.c.get(D);if(!f){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return f}}e.ExtHostFileSystem=v}),define(ye[78],De([1,0,5,44,7,22,4,20,48,6]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Yt{constructor(v,k){this.b=new Map,this.a=v.getProxy(o.MainContext.MainThreadFileSystem);const D=this;this.value=Object.freeze({async stat(f){try{const d=D.b.get(f.scheme);if(!d)return await D.a.$stat(f);await D.a.$ensureActivation(f.scheme);const u=await d.stat(f);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(d){Yt.c(d)}},async readDirectory(f){try{const d=D.b.get(f.scheme);return d?(await D.a.$ensureActivation(f.scheme),(await d.readDirectory(f)).slice()):await D.a.$readdir(f)}catch(d){return Yt.c(d)}},async createDirectory(f){try{return await D.a.$mkdir(f)}catch(d){return Yt.c(d)}},async readFile(f){try{const d=D.b.get(f.scheme);return d?(await D.a.$ensureActivation(f.scheme),(await d.readFile(f)).slice()):(await D.a.$readFile(f)).buffer}catch(d){return Yt.c(d)}},async writeFile(f,d){try{return await D.a.$writeFile(f,R.VSBuffer.wrap(d))}catch(u){return Yt.c(u)}},async delete(f,d){try{const u=D.b.get(f.scheme);return u?(await D.a.$ensureActivation(f.scheme),await u.delete(f,{recursive:!1,...d})):await D.a.$delete(f,{recursive:!1,useTrash:!1,...d})}catch(u){return Yt.c(u)}},async rename(f,d,u){try{return await D.a.$rename(f,d,{overwrite:!1,...u})}catch(m){return Yt.c(m)}},async copy(f,d,u){try{return await D.a.$copy(f,d,{overwrite:!1,...u})}catch(m){return Yt.c(m)}},isWritableFileSystem(f){const d=k.getCapabilities(f);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof l.FileSystemError)throw v;if(!(v instanceof Error))throw new l.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(v.message);switch(v.name){case L.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(v.message);case L.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(v.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(v.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(v.message);case L.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(v.message);case L.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(v.message);default:throw new l.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,k){return this.b.set(v,k),(0,I.toDisposable)(()=>this.b.delete(v))}};O=xe([ze(0,A.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[261],De([1,0,3,38,2,5,14,7]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,v,k,D,f,d,u,m){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter;const b=this.h(P,k,f);this.g=0,d&&(this.g+=1),u&&(this.g+=2),m&&(this.g+=4);const C=(0,L.parse)(f),p=typeof f=="string",n=D(s=>{if(!d)for(const r of s.created){const a=l.URI.revive(r);C(a.fsPath)&&(!p||v.getWorkspaceFolder(a))&&this.a.fire(a)}if(!u)for(const r of s.changed){const a=l.URI.revive(r);C(a.fsPath)&&(!p||v.getWorkspaceFolder(a))&&this.b.fire(a)}if(!m)for(const r of s.deleted){const a=l.URI.revive(r);C(a.fsPath)&&(!p||v.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=A.Disposable.from(b,this.a,this.b,this.c,n)}h(P,v,k){const D=A.Disposable.from();if(typeof k=="string")return D;const f=P.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(k.pattern.includes(L.GLOBSTAR)||k.pattern.includes(L.GLOB_SPLIT))&&(d=!0);const u=Math.random();return f.$watch(v.identifier.value,u,k.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>f.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class I{constructor(P,v,k){this.j=P,this.k=v,this.l=k,this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.g=new o.AsyncEmitter,this.h=new o.AsyncEmitter,this.i=new o.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,v,k,D,f,d){return new y(this.j,P,v,this.a.event,S.GlobPattern.from(k),D,f,d)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,v){switch(P){case 2:this.b.fire(Object.freeze({files:v.map(k=>({oldUri:l.URI.revive(k.source),newUri:l.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(k=>l.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(k=>l.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,v){return(k,D,f)=>{const d=function(m){k.call(D,m)};return d.extension=P,v.event(d,void 0,f)}}async $onWillRunFileOperation(P,v,k,D){switch(P){case 2:return await this.n(this.g,{files:v.map(f=>({oldUri:l.URI.revive(f.source),newUri:l.URI.revive(f.target)}))},k,D);case 1:return await this.n(this.i,{files:v.map(f=>l.URI.revive(f.target))},k,D);case 0:case 3:return await this.n(this.h,{files:v.map(f=>l.URI.revive(f.target))},k,D)}}async n(P,v,k,D){const f=new Set,d=[];if(await P.fireAsync(v,D,async(m,b)=>{const C=Date.now(),p=await Promise.resolve(m);p instanceof A.WorkspaceEdit&&(d.push([b.extension,p]),f.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-C>k&&this.k.warn("SLOW file-participant",b.extension.identifier)}),D.isCancellationRequested||d.length===0)return;const u={edits:[]};for(const[,m]of d){const{edits:b}=S.WorkspaceEdit.from(m,{getTextDocumentVersion:C=>this.l.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(b)}return{edit:u,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=I}),define(ye[262],De([1,0,2,40]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(S,A,y,I,O){this.a=A,this.b=y,this.c=I;const P=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new L.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new L.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new L.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new L.ApiCommandResult("Notebook and input URI",v=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const k=this.a.getEditorById(v.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri),notebookEditor:k.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(S,A,y,I){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:S,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(o.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=l}),define(ye[263],De([1,0,6,5]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(S){this.b=0,this.a=S.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,S),(0,o.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=l}),define(ye[264],De([1,0,2,23,14,7,71,5,8,32,15,9,150,21,6,120,101,74,43,10,19,26]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class n{constructor(M,z){this.d=M,this.e=z}async provideDocumentSymbols(M,z){const G=this.d.getDocument(M),te=await this.e.provideDocumentSymbols(G,z);if(!(0,O.isFalsyOrEmpty)(te))return te[0]instanceof R.DocumentSymbol?te.map(l.DocumentSymbol.from):n.f(te)}static f(M){M=M.slice(0).sort((te,de)=>{let we=te.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(te.location.range.end)),we});const z=[],G=[];for(const te of M){const de={name:te.name||"!!MISSING: name!!",kind:l.SymbolKind.from(te.kind),tags:te.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:te.containerName,range:l.Range.from(te.location.range),selectionRange:l.Range.from(te.location.range),children:[]};for(;;){if(G.length===0){G.push(de),z.push(de);break}const we=G[G.length-1];if(I.Range.containsRange(we.range,de.range)&&!I.Range.equalsRange(we.range,de.range)){we.children?.push(de),G.push(de);break}G.pop()}}return z}}class s{constructor(M,z,G){this.g=M,this.h=z,this.j=G,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(M,z){const G=this.g.getDocument(M),te=await this.j.provideCodeLenses(G,z);if(!te||z.isCancellationRequested)return;const de=this.e.add(te),we=new D.DisposableStore;this.f.set(de,we);const Pe={cacheId:de,lenses:[]};for(let be=0;be<te.length;be++)Pe.lenses.push({cacheId:[de,be],range:l.Range.from(te[be].range),command:this.h.toInternal(te[be].command,we)});return Pe}async resolveCodeLens(M,z){const G=M.cacheId&&this.e.get(...M.cacheId);if(!G)return;let te;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?te=G:te=await this.j.resolveCodeLens(G,z),te||(te=G),z.isCancellationRequested)return;const de=M.cacheId&&this.f.get(M.cacheId[0]);if(!!de)return M.command=this.h.toInternal(te.command??s.d,de),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}s.d={command:"missing",title:"!!MISSING: command!!"};function r(oe){return Array.isArray(oe)?oe.map(l.DefinitionLink.from):oe?[l.DefinitionLink.from(oe)]:[]}class a{constructor(M,z){this.d=M,this.e=z}async provideDefinition(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideDefinition(te,de,G);return r(we)}}class c{constructor(M,z){this.d=M,this.e=z}async provideDeclaration(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideDeclaration(te,de,G);return r(we)}}class g{constructor(M,z){this.d=M,this.e=z}async provideImplementation(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideImplementation(te,de,G);return r(we)}}class i{constructor(M,z){this.d=M,this.e=z}async provideTypeDefinition(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideTypeDefinition(te,de,G);return r(we)}}class t{constructor(M,z){this.d=M,this.e=z}async provideHover(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideHover(te,de,G);if(!(!we||(0,O.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=te.getWordRangeAtPosition(de)),we.range||(we.range=new R.Range(de,de)),l.Hover.from(we)}}class h{constructor(M,z){this.d=M,this.e=z}async provideEvaluatableExpression(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideEvaluatableExpression(te,de,G);if(we)return l.EvaluatableExpression.from(we)}}class E{constructor(M,z){this.d=M,this.e=z}async provideInlineValues(M,z,G,te){const de=this.d.getDocument(M),we=await this.e.provideInlineValues(de,l.Range.to(z),l.InlineValueContext.to(G),te);if(Array.isArray(we))return we.map(Pe=>l.InlineValue.from(Pe))}}class w{constructor(M,z){this.d=M,this.e=z}async provideDocumentHighlights(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideDocumentHighlights(te,de,G);if(Array.isArray(we))return we.map(l.DocumentHighlight.from)}}class N{constructor(M,z){this.d=M,this.e=z}async provideLinkedEditingRanges(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideLinkedEditingRanges(te,de,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,O.coalesce)(we.ranges.map(l.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(M,z){this.d=M,this.e=z}async provideReferences(M,z,G,te){const de=this.d.getDocument(M),we=l.Position.to(z),Pe=await this.e.provideReferences(de,we,G,te);if(Array.isArray(Pe))return Pe.map(l.location.from)}}class V{constructor(M,z,G,te,de,we,Pe){this.g=M,this.h=z,this.j=G,this.k=te,this.l=de,this.m=we,this.n=Pe,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(M,z,G,te){const de=this.g.getDocument(M),we=v.Selection.isISelection(z)?l.Selection.to(z):l.Range.to(z),Pe=[];for(const nt of this.j.getDiagnostics(M))if(we.intersection(nt.range)&&Pe.push(nt)>V.d)break;const be={diagnostics:Pe,only:G.only?new R.CodeActionKind(G.only):void 0,triggerKind:l.CodeActionTriggerKind.to(G.trigger)},Ce=await this.k.provideCodeActions(de,we,be,te);if(!(0,O.isNonEmptyArray)(Ce)||te.isCancellationRequested)return;const ke=this.e.add(Ce),He=new D.DisposableStore;this.f.set(ke,He);const Ge=[];for(let nt=0;nt<Ce.length;nt++){const Qe=Ce[nt];!Qe||(V.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,He)})):(be.only&&(Qe.kind?be.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,nt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,He),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(l.Diagnostic.from),edit:Qe.edit&&l.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(M,z){const[G,te]=M,de=this.e.get(G,te);if(!de||V.o(de)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(de,z)??de;return we?.edit?l.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static o(M){return typeof M.command=="string"&&typeof M.title=="string"}}V.d=1e3;class Q{constructor(M,z,G,te){this.d=M,this.e=z,this.f=G,this.g=te}async prepareDocumentPaste(M,z,G,te){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(M),we=z.map(be=>l.Range.to(be)),Pe=l.DataTransfer.toDataTransfer(G,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(de,we,Pe,te),l.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(M,z,G,te,de){const we=this.e.getDocument(z),Pe=G.map(ke=>l.Range.to(ke)),be=l.DataTransfer.toDataTransfer(te,async ke=>(await this.d.$resolvePasteFileData(this.g,M,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(we,Pe,be,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class q{constructor(M,z){this.d=M,this.e=z}async provideDocumentFormattingEdits(M,z,G){const te=this.d.getDocument(M),de=await this.e.provideDocumentFormattingEdits(te,z,G);if(Array.isArray(de))return de.map(l.TextEdit.from)}}class U{constructor(M,z){this.d=M,this.e=z}async provideDocumentRangeFormattingEdits(M,z,G,te){const de=this.d.getDocument(M),we=l.Range.to(z),Pe=await this.e.provideDocumentRangeFormattingEdits(de,we,G,te);if(Array.isArray(Pe))return Pe.map(l.TextEdit.from)}}class T{constructor(M,z){this.d=M,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,z,G,te,de){const we=this.d.getDocument(M),Pe=l.Position.to(z),be=await this.e.provideOnTypeFormattingEdits(we,Pe,G,te,de);if(Array.isArray(be))return be.map(l.TextEdit.from)}}class F{constructor(M,z){this.e=M,this.f=z,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,z){const G=await this.e.provideWorkspaceSymbols(M,z);if(!(0,O.isNonEmptyArray)(G))return{symbols:[]};const te=this.d.add(G),de={cacheId:te,symbols:[]};for(let we=0;we<G.length;we++){const Pe=G[we];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...l.WorkspaceSymbol.from(Pe),cacheId:[te,we]})}return de}async resolveWorkspaceSymbol(M,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this.d.get(...M.cacheId);if(G){const te=await this.e.resolveWorkspaceSymbol(G,z);return te&&(0,L.mixin)(M,l.WorkspaceSymbol.from(te),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class B{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,z,G){this.d=M,this.e=z,this.f=G}async provideRenameEdits(M,z,G,te){const de=this.d.getDocument(M),we=l.Position.to(z);try{const Pe=await this.e.provideRenameEdits(de,we,G,te);return Pe?l.WorkspaceEdit.from(Pe):void 0}catch(Pe){const be=B.g(Pe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(M,z,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const te=this.d.getDocument(M),de=l.Position.to(z);try{const we=await this.e.prepareRename(te,de,G);let Pe,be;if(R.Range.isRange(we)?(Pe=we,be=te.getText(we)):(0,P.isObject)(we)&&(Pe=we.range,be=we.placeholder),!Pe||!be)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(Pe),text:be}}catch(we){const Pe=B.g(we);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(we)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Z{constructor(M,z){this.resultId=M,this.tokens=z}}class _{constructor(M,z){this.f=M,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,z,G){const te=this.f.getDocument(M),de=z!==0?this.d.get(z):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(te,de.resultId,G):await this.g.provideDocumentSemanticTokens(te,G);return de&&this.d.delete(z),we?(we=_.h(we),this.o(_.n(de,we),we)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return _.j(M)?_.k(M)?M:new R.SemanticTokens(new Uint32Array(M.data),M.resultId):_.l(M)?_.m(M)?M:new R.SemanticTokensEdits(M.edits.map(z=>new R.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const z of M.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(M,z){if(!_.j(z)||!M||!M.tokens)return z;const G=M.tokens,te=G.length,de=z.data,we=de.length;let Pe=0;const be=Math.min(te,we);for(;Pe<be&&G[Pe]===de[Pe];)Pe++;if(Pe===te&&Pe===we)return new R.SemanticTokensEdits([],z.resultId);let Ce=0;const ke=be-Pe;for(;Ce<ke&&G[te-Ce-1]===de[we-Ce-1];)Ce++;return new R.SemanticTokensEdits([{start:Pe,deleteCount:te-Pe-Ce,data:de.subarray(Pe,we-Ce)}],z.resultId)}o(M,z){if(_.j(M)){const G=this.e++;return this.d.set(G,new Z(M.resultId,M.data)),(0,f.encodeSemanticTokensDto)({id:G,type:"full",data:M.data})}if(_.l(M)){const G=this.e++;return _.j(z)?this.d.set(G,new Z(z.resultId,z.data)):this.d.set(G,new Z(M.resultId)),(0,f.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(M.edits||[]).map(te=>({start:te.start,deleteCount:te.deleteCount,data:te.data}))})}return null}}class H{constructor(M,z){this.d=M,this.e=z}async provideDocumentRangeSemanticTokens(M,z,G){const te=this.d.getDocument(M),de=await this.e.provideDocumentRangeSemanticTokens(te,l.Range.to(z),G);return de?this.f(de):null}f(M){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}class Y{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,z,G,te,de){this.f=M,this.g=z,this.h=G,this.j=te,this.k=de,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(M,z,G,te){const de=this.f.getDocument(M),we=l.Position.to(z),Pe=de.getWordRangeAtPosition(we)||new R.Range(we,we),be=Pe.with({end:we}),Ce=new m.StopWatch(!0),ke=await this.h.provideCompletionItems(de,we,te,l.CompletionContext.to(G));if(!ke||te.isCancellationRequested)return;const He=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=Y.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),nt=new D.DisposableStore;this.e.set(Ge,nt);const Qe=[],tt={x:Ge,b:Qe,a:{replace:l.Range.from(Pe),insert:l.Range.from(be)},c:He.isIncomplete||void 0,d:Ce.elapsed()};for(let rt=0;rt<He.items.length;rt++){const Be=He.items[rt],it=this.l(Be,[Ge,rt],be,Pe);Qe.push(it)}return tt}async resolveCompletionItem(M,z){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...M);if(!G)return;const te=await this.h.resolveCompletionItem(G,z);if(!!te)return this.l(te,M)}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,z,G,te){const de=this.e.get(z[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(M.command,de),Pe={x:z,a:M.label,b:M.kind!==void 0?l.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(l.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:l.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(l.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=M.textEdit.newText):typeof M.insertText=="string"?Pe.h=M.insertText:M.insertText instanceof R.SnippetString&&(Pe.h=M.insertText.value,Pe.i|=4);let be;return M.textEdit?be=M.textEdit.range:M.range&&(be=M.range),R.Range.isRange(be)?Pe.j=l.Range.from(be):be&&(!G?.isEqual(be.inserting)||!te?.isEqual(be.replacing))&&(Pe.j={insert:l.Range.from(be.inserting),replace:l.Range.from(be.replacing)}),Pe}}class ie{async provideInlineCompletions(M,z,G,te){}disposeCompletions(M){}handleDidShowCompletionItem(M,z){}handlePartialAccept(M,z,G){}}class ge extends ie{constructor(M,z,G,te){super(),this.f=M,this.g=z,this.h=G,this.j=te,this.d=new X,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[S.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[S.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,z,G,te){const de=this.g.getDocument(M),we=l.Position.to(z),Pe=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:l.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},te);if(!Pe||te.isCancellationRequested)return;const be=Array.isArray(Pe)?Pe:Pe.items,Ce=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:be}),items:be.map((Ge,nt)=>{let Qe;Ge.command&&(ke||(ke=new D.DisposableStore),Qe=this.j.toInternal(Ge.command,ke));const tt=Ge.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ge.filterText,range:Ge.range?l.Range.from(Ge.range):void 0,command:Qe,idx:nt,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ce.map(Ge=>(ke||(ke=new D.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,z){const G=this.d.get(M)?.items[z];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G)}handlePartialAccept(M,z,G){const te=this.d.get(M)?.items[z];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(te,G)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const z=this.e++;return this.d.set(z,M),z}disposeReferenceId(M){const z=this.d.get(M);return this.d.delete(M),z}get(M){return this.d.get(M)}}class J{constructor(M,z){this.e=M,this.f=z,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(M,z,G,te){const de=this.e.getDocument(M),we=l.Position.to(z),Pe=this.g(G),be=await this.f.provideSignatureHelp(de,we,te,Pe);if(be){const Ce=this.d.add([be]);return{...l.SignatureHelp.from(be),id:Ce}}}g(M){let z;if(M.activeSignatureHelp){const G=l.SignatureHelp.to(M.activeSignatureHelp),te=this.d.get(M.activeSignatureHelp.id,0);te?(z=te,z.activeSignature=G.activeSignature,z.activeParameter=G.activeParameter):z=G}return{...M,activeSignatureHelp:z}}releaseSignatureHelp(M){this.d.delete(M)}}class ee{constructor(M,z,G,te,de){this.f=M,this.g=z,this.h=G,this.j=te,this.k=de,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(M,z,G){const te=this.f.getDocument(M),de=l.Range.to(z),we=await this.h.provideInlayHints(te,de,G);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${z}`);return}if(G.isCancellationRequested)return;const Pe=this.d.add(we);this.e.set(Pe,new D.DisposableStore);const be={hints:[],cacheId:Pe};for(let Ce=0;Ce<we.length;Ce++)this.l(we[Ce],de)&&be.hints.push(this.m(we[Ce],[Pe,Ce]));return this.j.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this.k.identifier.value}' for ${z}`),be}async resolveInlayHint(M,z){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...M);if(!G)return;const te=await this.h.resolveInlayHint(G,z);if(!!te&&!!this.l(te))return this.m(te,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,z){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(z&&!z.contains(M.position))}m(M,z){const G=this.e.get(z[0]);if(!G)throw Error("DisposableStore is missing...");const te={label:"",cacheId:z,tooltip:l.MarkdownString.fromStrict(M.tooltip),position:l.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(l.TextEdit.from),kind:M.kind&&l.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?te.label=M.label:te.label=M.label.map(de=>{const we={label:de.value};return we.tooltip=l.MarkdownString.fromStrict(de.tooltip),R.Location.isLocation(de.location)&&(we.location=l.location.from(de.location)),de.command&&(we.command=this.g.toInternal(de.command,G)),we}),te}}class me{constructor(M,z){this.e=M,this.f=z,this.d=new u.Cache("DocumentLink")}async provideLinks(M,z){const G=this.e.getDocument(M),te=await this.f.provideDocumentLinks(G,z);if(!(!Array.isArray(te)||te.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:te.filter(me.g).map(l.DocumentLink.from)};{const de=this.d.add(te),we={links:[],cacheId:de};for(let Pe=0;Pe<te.length;Pe++){if(!me.g(te[Pe]))continue;const be=l.DocumentLink.from(te[Pe]);be.cacheId=[de,Pe],we.links.push(be)}return we}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,z){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...M);if(!G)return;const te=await this.f.resolveDocumentLink(G,z);if(!(!te||!me.g(te)))return l.DocumentLink.from(te)}releaseLinks(M){this.d.delete(M)}}class ve{constructor(M,z){this.d=M,this.e=z}async provideColors(M,z){const G=this.d.getDocument(M),te=await this.e.provideDocumentColors(G,z);return Array.isArray(te)?te.map(we=>({color:l.Color.from(we.color),range:l.Range.from(we.range)})):[]}async provideColorPresentations(M,z,G){const te=this.d.getDocument(M),de=l.Range.to(z.range),we=l.Color.to(z.color),Pe=await this.e.provideColorPresentations(we,{document:te,range:de},G);if(!!Array.isArray(Pe))return Pe.map(l.ColorPresentation.from)}}class Ie{constructor(M,z){this.d=M,this.e=z}async provideFoldingRanges(M,z,G){const te=this.d.getDocument(M),de=await this.e.provideFoldingRanges(te,z,G);if(!!Array.isArray(de))return de.map(l.FoldingRange.from)}}class Re{constructor(M,z,G){this.d=M,this.e=z,this.f=G}async provideSelectionRanges(M,z,G){const te=this.d.getDocument(M),de=z.map(l.Position.to),we=await this.e.provideSelectionRanges(te,de,G);if(!(0,O.isNonEmptyArray)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let be=0;be<de.length;be++){const Ce=[];Pe.push(Ce);let ke=de[be],He=we[be];for(;;){if(!He.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(l.SelectionRange.from(He)),!He.parent)break;ke=He.range,He=He.parent}}return Pe}}class ae{constructor(M,z){this.f=M,this.g=z,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(M,z,G){const te=this.f.getDocument(M),de=l.Position.to(z),we=await this.g.prepareCallHierarchy(te,de,G);if(!we)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(we)?we.map(be=>this.h(Pe,be)):[this.h(Pe,we)]}async provideCallsTo(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(te,G);if(!!de)return de.map(we=>({from:this.h(M,we.from),fromRanges:we.fromRanges.map(Pe=>l.Range.from(Pe))}))}async provideCallsFrom(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(te,G);if(!!de)return de.map(we=>({to:this.h(M,we.to),fromRanges:we.fromRanges.map(Pe=>l.Range.from(Pe))}))}releaseSession(M){this.e.delete(M)}h(M,z){const G=this.e.get(M),te=l.CallHierarchyItem.from(z,M,G.size.toString(36));return G.set(te._itemId,z),te}j(M,z){return this.e.get(M)?.get(z)}}class le{constructor(M,z){this.f=M,this.g=z,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(M,z,G){const te=this.f.getDocument(M),de=l.Position.to(z),we=await this.g.prepareTypeHierarchy(te,de,G);if(!we)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(we)?we.map(be=>this.h(Pe,be)):[this.h(Pe,we)]}async provideSupertypes(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(te,G);if(!!de)return de.map(we=>this.h(M,we))}async provideSubtypes(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(te,G);if(!!de)return de.map(we=>this.h(M,we))}releaseSession(M){this.e.delete(M)}h(M,z){const G=this.e.get(M),te=l.TypeHierarchyItem.from(z,M,G.size.toString(36));return G.set(te._itemId,z),te}j(M,z){return this.e.get(M)?.get(z)}}class ue{constructor(M,z,G,te){this.d=M,this.e=z,this.f=G,this.g=te}async provideDocumentOnDropEdits(M,z,G,te,de){const we=this.e.getDocument(z),Pe=l.Position.to(G),be=l.DataTransfer.toDataTransfer(te,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(we,Pe,be,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ne{constructor(M,z){this.adapter=M,this.extension=z}}class ce{constructor(M,z,G,te,de,we,Pe,be){this.g=z,this.h=G,this.j=te,this.k=de,this.l=we,this.m=Pe,this.n=be,this.f=new Map,this.e=M.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(M){return l.DocumentSelector.from(M,this.g)}p(M){return new R.Disposable(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return ce.d++}async s(M,z,G,te,de,we=!1){const Pe=this.f.get(M);if(!Pe||!(Pe.adapter instanceof z))return te;const be=Date.now();we||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,b.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),k.CancellationToken.isCancellationToken(de)?(0,C.raceCancellationError)(Ce,de):Ce}t(M,z){const G=this.q();return this.f.set(G,new ne(M,z)),G}static u(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,z,G,te){const de=this.t(new n(this.h,G),M),we=te&&te.label||ce.u(M);return this.e.$registerDocumentSymbolProvider(de,this.o(z),we),this.p(de)}$provideDocumentSymbols(M,z,G){return this.s(M,n,te=>te.provideDocumentSymbols(o.URI.revive(z),G),void 0,G)}registerCodeLensProvider(M,z,G){const te=this.q(),de=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(te,new ne(new s(this.h,this.j.converter,G),M)),this.e.$registerCodeLensSupport(te,this.o(z),de);let we=this.p(te);if(de!==void 0){const Pe=G.onDidChangeCodeLenses(be=>this.e.$emitCodeLensEvent(de));we=R.Disposable.from(we,Pe)}return we}$provideCodeLenses(M,z,G){return this.s(M,s,te=>te.provideCodeLenses(o.URI.revive(z),G),void 0,G)}$resolveCodeLens(M,z,G){return this.s(M,s,te=>te.resolveCodeLens(z,G),void 0,void 0)}$releaseCodeLenses(M,z){this.s(M,s,G=>Promise.resolve(G.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(M,z,G){const te=this.t(new a(this.h,G),M);return this.e.$registerDefinitionSupport(te,this.o(z)),this.p(te)}$provideDefinition(M,z,G,te){return this.s(M,a,de=>de.provideDefinition(o.URI.revive(z),G,te),[],te)}registerDeclarationProvider(M,z,G){const te=this.t(new c(this.h,G),M);return this.e.$registerDeclarationSupport(te,this.o(z)),this.p(te)}$provideDeclaration(M,z,G,te){return this.s(M,c,de=>de.provideDeclaration(o.URI.revive(z),G,te),[],te)}registerImplementationProvider(M,z,G){const te=this.t(new g(this.h,G),M);return this.e.$registerImplementationSupport(te,this.o(z)),this.p(te)}$provideImplementation(M,z,G,te){return this.s(M,g,de=>de.provideImplementation(o.URI.revive(z),G,te),[],te)}registerTypeDefinitionProvider(M,z,G){const te=this.t(new i(this.h,G),M);return this.e.$registerTypeDefinitionSupport(te,this.o(z)),this.p(te)}$provideTypeDefinition(M,z,G,te){return this.s(M,i,de=>de.provideTypeDefinition(o.URI.revive(z),G,te),[],te)}registerHoverProvider(M,z,G,te){const de=this.t(new t(this.h,G),M);return this.e.$registerHoverProvider(de,this.o(z)),this.p(de)}$provideHover(M,z,G,te){return this.s(M,t,de=>de.provideHover(o.URI.revive(z),G,te),void 0,te)}registerEvaluatableExpressionProvider(M,z,G,te){const de=this.t(new h(this.h,G),M);return this.e.$registerEvaluatableExpressionProvider(de,this.o(z)),this.p(de)}$provideEvaluatableExpression(M,z,G,te){return this.s(M,h,de=>de.provideEvaluatableExpression(o.URI.revive(z),G,te),void 0,te)}registerInlineValuesProvider(M,z,G,te){const de=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,G),M);this.e.$registerInlineValuesProvider(we,this.o(z),de);let Pe=this.p(we);if(de!==void 0){const be=G.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(de));Pe=R.Disposable.from(Pe,be)}return Pe}$provideInlineValues(M,z,G,te,de){return this.s(M,E,we=>we.provideInlineValues(o.URI.revive(z),G,te,de),void 0,de)}registerDocumentHighlightProvider(M,z,G){const te=this.t(new w(this.h,G),M);return this.e.$registerDocumentHighlightProvider(te,this.o(z)),this.p(te)}$provideDocumentHighlights(M,z,G,te){return this.s(M,w,de=>de.provideDocumentHighlights(o.URI.revive(z),G,te),void 0,te)}registerLinkedEditingRangeProvider(M,z,G){const te=this.t(new N(this.h,G),M);return this.e.$registerLinkedEditingRangeProvider(te,this.o(z)),this.p(te)}$provideLinkedEditingRanges(M,z,G,te){return this.s(M,N,async de=>{const we=await de.provideLinkedEditingRanges(o.URI.revive(z),G,te);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ce.w(we.wordPattern):void 0}},void 0,te)}registerReferenceProvider(M,z,G){const te=this.t(new j(this.h,G),M);return this.e.$registerReferenceSupport(te,this.o(z)),this.p(te)}$provideReferences(M,z,G,te,de){return this.s(M,j,we=>we.provideReferences(o.URI.revive(z),G,te,de),void 0,de)}registerCodeActionProvider(M,z,G,te){const de=new D.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,G,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(we,this.o(z),{providedKinds:te?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:te?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},ce.u(M),Boolean(G.resolveCodeAction)),de.add(this.p(we)),de}$provideCodeActions(M,z,G,te,de){return this.s(M,V,we=>we.provideCodeActions(o.URI.revive(z),G,te,de),void 0,de)}$resolveCodeAction(M,z,G){return this.s(M,V,te=>te.resolveCodeAction(z,G),void 0,void 0)}$releaseCodeActions(M,z){this.s(M,V,G=>Promise.resolve(G.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(M,z,G){const te=this.t(new q(this.h,G),M);return this.e.$registerDocumentFormattingSupport(te,this.o(z),M.identifier,M.displayName||M.name),this.p(te)}$provideDocumentFormattingEdits(M,z,G,te){return this.s(M,q,de=>de.provideDocumentFormattingEdits(o.URI.revive(z),G,te),void 0,te)}registerDocumentRangeFormattingEditProvider(M,z,G){const te=this.t(new U(this.h,G),M);return this.e.$registerRangeFormattingSupport(te,this.o(z),M.identifier,M.displayName||M.name),this.p(te)}$provideDocumentRangeFormattingEdits(M,z,G,te,de){return this.s(M,U,we=>we.provideDocumentRangeFormattingEdits(o.URI.revive(z),G,te,de),void 0,de)}registerOnTypeFormattingEditProvider(M,z,G,te){const de=this.t(new T(this.h,G),M);return this.e.$registerOnTypeFormattingSupport(de,this.o(z),te,M.identifier),this.p(de)}$provideOnTypeFormattingEdits(M,z,G,te,de,we){return this.s(M,T,Pe=>Pe.provideOnTypeFormattingEdits(o.URI.revive(z),G,te,de,we),void 0,we)}registerWorkspaceSymbolProvider(M,z){const G=this.t(new F(z,this.l),M);return this.e.$registerNavigateTypeSupport(G,typeof z.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(M,z,G){return this.s(M,F,te=>te.provideWorkspaceSymbols(z,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,z,G){return this.s(M,F,te=>te.resolveWorkspaceSymbol(z,G),void 0,void 0)}$releaseWorkspaceSymbols(M,z){this.s(M,F,G=>G.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(M,z,G){const te=this.t(new B(this.h,G,this.l),M);return this.e.$registerRenameSupport(te,this.o(z),B.supportsResolving(G)),this.p(te)}$provideRenameEdits(M,z,G,te,de){return this.s(M,B,we=>we.provideRenameEdits(o.URI.revive(z),G,te,de),void 0,de)}$resolveRenameLocation(M,z,G,te){return this.s(M,B,de=>de.resolveRenameLocation(o.URI.revive(z),G,te),void 0,te)}registerDocumentSemanticTokensProvider(M,z,G,te){const de=this.t(new _(this.h,G),M),we=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(z),te,we);let Pe=this.p(de);if(we){const be=G.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(we));Pe=R.Disposable.from(Pe,be)}return Pe}$provideDocumentSemanticTokens(M,z,G,te){return this.s(M,_,de=>de.provideDocumentSemanticTokens(o.URI.revive(z),G,te),null,te)}$releaseDocumentSemanticTokens(M,z){this.s(M,_,G=>G.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,z,G,te){const de=this.t(new H(this.h,G),M);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(z),te),this.p(de)}$provideDocumentRangeSemanticTokens(M,z,G,te){return this.s(M,H,de=>de.provideDocumentRangeSemanticTokens(o.URI.revive(z),G,te),null,te)}registerCompletionItemProvider(M,z,G,te){const de=this.t(new Y(this.h,this.j.converter,G,this.m,M),M);return this.e.$registerCompletionsProvider(de,this.o(z),te,Y.supportsResolving(G),`${M.identifier.value}(${te.join("")})`),this.p(de)}$provideCompletionItems(M,z,G,te,de){return this.s(M,Y,we=>we.provideCompletionItems(o.URI.revive(z),G,te,de),void 0,de)}$resolveCompletionItem(M,z,G){return this.s(M,Y,te=>te.resolveCompletionItem(z,G),void 0,G)}$releaseCompletionItems(M,z){this.s(M,Y,G=>G.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(M,z,G){const te=new ge(M,this.h,G,this.j.converter),de=this.t(te,M);return this.e.$registerInlineCompletionsSupport(de,this.o(z),te.supportsHandleEvents),this.p(de)}$provideInlineCompletions(M,z,G,te,de){return this.s(M,ie,we=>we.provideInlineCompletions(o.URI.revive(z),G,te,de),void 0,de)}$handleInlineCompletionDidShow(M,z,G){this.s(M,ie,async te=>{te.handleDidShowCompletionItem(z,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,z,G,te){this.s(M,ie,async de=>{de.handlePartialAccept(z,G,te)},void 0,void 0)}$freeInlineCompletionsList(M,z){this.s(M,ie,async G=>{G.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(M,z,G,te){const de=Array.isArray(te)?{triggerCharacters:te,retriggerCharacters:[]}:te,we=this.t(new J(this.h,G),M);return this.e.$registerSignatureHelpProvider(we,this.o(z),de),this.p(we)}$provideSignatureHelp(M,z,G,te,de){return this.s(M,J,we=>we.provideSignatureHelp(o.URI.revive(z),G,te,de),void 0,de)}$releaseSignatureHelp(M,z){this.s(M,J,G=>G.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(M,z,G){const te=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ee(this.h,this.j.converter,G,this.l,M),M);this.e.$registerInlayHintsProvider(de,this.o(z),typeof G.resolveInlayHint=="function",te,ce.u(M));let we=this.p(de);if(te!==void 0){const Pe=G.onDidChangeInlayHints(be=>this.e.$emitInlayHintsEvent(te));we=R.Disposable.from(we,Pe)}return we}$provideInlayHints(M,z,G,te){return this.s(M,ee,de=>de.provideInlayHints(o.URI.revive(z),G,te),void 0,te)}$resolveInlayHint(M,z,G){return this.s(M,ee,te=>te.resolveInlayHint(z,G),void 0,G)}$releaseInlayHints(M,z){this.s(M,ee,G=>G.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(M,z,G){const te=this.t(new me(this.h,G),M);return this.e.$registerDocumentLinkProvider(te,this.o(z),typeof G.resolveDocumentLink=="function"),this.p(te)}$provideDocumentLinks(M,z,G){return this.s(M,me,te=>te.provideLinks(o.URI.revive(z),G),void 0,G,z.scheme==="output")}$resolveDocumentLink(M,z,G){return this.s(M,me,te=>te.resolveLink(z,G),void 0,void 0,!0)}$releaseDocumentLinks(M,z){this.s(M,me,G=>G.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(M,z,G){const te=this.t(new ve(this.h,G),M);return this.e.$registerDocumentColorProvider(te,this.o(z)),this.p(te)}$provideDocumentColors(M,z,G){return this.s(M,ve,te=>te.provideColors(o.URI.revive(z),G),[],G)}$provideColorPresentations(M,z,G,te){return this.s(M,ve,de=>de.provideColorPresentations(o.URI.revive(z),G,te),void 0,te)}registerFoldingRangeProvider(M,z,G){const te=this.q(),de=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(te,new ne(new Ie(this.h,G),M)),this.e.$registerFoldingRangeProvider(te,this.o(z),M.identifier,de);let we=this.p(te);if(de!==void 0){const Pe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=R.Disposable.from(we,Pe)}return we}$provideFoldingRanges(M,z,G,te){return this.s(M,Ie,de=>de.provideFoldingRanges(o.URI.revive(z),G,te),void 0,te)}registerSelectionRangeProvider(M,z,G){const te=this.t(new Re(this.h,G,this.l),M);return this.e.$registerSelectionRangeProvider(te,this.o(z)),this.p(te)}$provideSelectionRanges(M,z,G,te){return this.s(M,Re,de=>de.provideSelectionRanges(o.URI.revive(z),G,te),[],te)}registerCallHierarchyProvider(M,z,G){const te=this.t(new ae(this.h,G),M);return this.e.$registerCallHierarchyProvider(te,this.o(z)),this.p(te)}$prepareCallHierarchy(M,z,G,te){return this.s(M,ae,de=>Promise.resolve(de.prepareSession(o.URI.revive(z),G,te)),void 0,te)}$provideCallHierarchyIncomingCalls(M,z,G,te){return this.s(M,ae,de=>de.provideCallsTo(z,G,te),void 0,te)}$provideCallHierarchyOutgoingCalls(M,z,G,te){return this.s(M,ae,de=>de.provideCallsFrom(z,G,te),void 0,te)}$releaseCallHierarchy(M,z){this.s(M,ae,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(M,z,G){const te=this.t(new le(this.h,G),M);return this.e.$registerTypeHierarchyProvider(te,this.o(z)),this.p(te)}$prepareTypeHierarchy(M,z,G,te){return this.s(M,le,de=>Promise.resolve(de.prepareSession(o.URI.revive(z),G,te)),void 0,te)}$provideTypeHierarchySupertypes(M,z,G,te){return this.s(M,le,de=>de.provideSupertypes(z,G,te),void 0,te)}$provideTypeHierarchySubtypes(M,z,G,te){return this.s(M,le,de=>de.provideSubtypes(z,G,te),void 0,te)}$releaseTypeHierarchy(M,z){this.s(M,le,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(M,z,G){const te=this.q();return this.f.set(te,new ne(new ue(this.e,this.h,G,te),M)),this.e.$registerDocumentOnDropEditProvider(te,this.o(z)),this.p(te)}$provideDocumentOnDropEdits(M,z,G,te,de,we){return this.s(M,ue,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(z,o.URI.revive(G),te,de,we)),void 0,void 0)}registerDocumentPasteEditProvider(M,z,G,te){const de=this.q();return this.f.set(de,new ne(new Q(this.e,this.h,G,de),M)),this.e.$registerPasteEditProvider(de,this.o(z),!!G.prepareDocumentPaste,te.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(M,z,G,te,de){return this.s(M,Q,we=>we.prepareDocumentPaste(o.URI.revive(z),G,te,de),void 0,de)}$providePasteEdits(M,z,G,te,de,we){return this.s(M,Q,Pe=>Pe.providePasteEdits(z,o.URI.revive(G),te,de,we),void 0,we)}static w(M){return{pattern:M.source,flags:(0,y.regExpFlags)(M)}}static y(M){return{decreaseIndentPattern:ce.w(M.decreaseIndentPattern),increaseIndentPattern:ce.w(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ce.w(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ce.w(M.unIndentedLinePattern):void 0}}static z(M){return{beforeText:ce.w(M.beforeText),afterText:M.afterText?ce.w(M.afterText):void 0,previousLineText:M.previousLineText?ce.w(M.previousLineText):void 0,action:M.action}}static B(M){return M.map(ce.z)}setLanguageConfiguration(M,z,G){const{wordPattern:te}=G;if(te&&(0,y.regExpLeadsToEndlessLoop)(te))throw new Error(`Invalid language configuration: wordPattern '${te}' is not allowed to match the empty string.`);te?this.h.setWordDefinitionFor(z,te):this.h.setWordDefinitionFor(z,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const de=this.q(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ce.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ce.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ce.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this.e.$setLanguageConfiguration(de,z,we),this.p(de)}$setWordDefinitions(M){for(const z of M)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(ye[265],De([1,0,5,14,7,37,19,6]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,P,v,k){this.c=P,this.d=v,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,P){await this.a.$changeLanguage(O,P);const v=this.c.getDocumentData(O);if(!v)throw new Error(`document '${O.toString()}' NOT found`);return v.document}async tokenAtPosition(O,P){const v=O.version,k=L.Position.from(P),D=await this.a.$tokensAtPosition(O.uri,k),f={type:l.StandardTokenType.Other,range:O.getWordRangeAtPosition(P)??new l.Range(P.line,P.character,P.line,P.character)};if(!D)return f;const d={range:L.Range.to(D.range),type:L.TokenType.to(D.type)};return!d.range.contains(P)||v!==O.version?f:d}createLanguageStatusItem(O,P,v){const k=this.f++,D=this.a,f=this.g,d=`${O.identifier.value}/${P}`;if(f.has(d))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);f.add(d);const u={selector:v,id:P,name:O.displayName??O.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let m;const b=new A.DisposableStore,C=()=>{m?.dispose(),m=(0,S.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(k,{id:d,name:u.name??O.displayName??O.name,source:O.displayName??O.name,selector:L.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===l.LanguageStatusSeverity.Error?R.default.Error:u.severity===l.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:u.command&&this.d.toInternal(u.command,b),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},p={dispose(){b.dispose(),m?.dispose(),D.$removeLanguageStatus(k),f.delete(d)},get id(){return u.id},get name(){return u.name},set name(n){u.name=n,C()},get selector(){return u.selector},set selector(n){u.selector=n,C()},get text(){return u.text},set text(n){u.text=n,C()},get detail(){return u.detail},set detail(n){u.detail=n,C()},get severity(){return u.severity},set severity(n){u.severity=n,C()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(n){u.accessibilityInformation=n,C()},get command(){return u.command},set command(n){u.command=n,C()},get busy(){return u.busy},set busy(n){u.busy=n,C()}};return C(),p}}e.ExtHostLanguages=y}),define(ye[97],De([1,0,11,8,2,4,13,5,25,20]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(v,k,D){this.f=D,this.d=new Map,this.a=k.getProxy(A.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===o.LANGUAGE_DEFAULT}getMessage(v,k){const{message:D,args:f,comment:d}=k;if(this.c)return(0,L.format2)(D,f??{});let u=D;d&&d.length>0&&(u+=`/${Array.isArray(d)?d.join(""):d}`);const m=this.d.get(v)?.contents[u];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,L.format2)(m??D,f??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let k;const D=await this.g(v);if(!D){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(D),d=JSON.parse(f);k=v.isBuiltin?d.contents?.bundle:d}catch(f){this.f.error(`Failed to load translations for ${v.identifier.value} from ${D}: ${f.message}`);return}k&&this.d.set(v.identifier.value,{contents:k,uri:D})}async g(v){if(v.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return l.URI.revive(k)}return v.l10n?l.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=xe([ze(0,y.IExtHostInitDataService),ze(1,I.IExtHostRpcService),ze(2,S.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],De([1,0,13,5,25,20,2,69]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends o.AbstractLoggerService{constructor(P,v){super(v.logLevel,v.loggers.map(k=>(0,A.revive)(k))),this.l=P.getProxy(L.MainContext.MainThreadLogger)}$setLogLevel(P,v){v?this.setLogLevel(S.URI.revive(v),P):this.setLogLevel(P)}setVisibility(P,v){super.setVisibility(P,v),this.l.$setVisibility(P,v)}k(P,v,k){return new I(this.l,P,v,k)}};y=xe([ze(0,R.IExtHostRpcService),ze(1,l.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class I extends o.AbstractMessageLogger{constructor(P,v,k,D){super(D?.logLevel==="always"),this.m=P,this.n=v,this.k=!1,this.l=[],this.setLevel(k),this.m.$createLogger(v,D).then(()=>{this.r(this.l),this.k=!0})}g(P,v){const k=[[P,v]];this.k?this.r(k):this.l.push(...k)}r(P){this.m.$log(this.n,P)}}}),define(ye[266],De([1,0,5,13,26]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let S=class{constructor(y,I){this.b=I,this.a=y.getProxy(o.MainContext.MainThreadMessageService)}showMessage(y,I,O,P,v){const k={source:{identifier:y.identifier,label:y.displayName||y.name}};let D;typeof P=="string"||R(P)?D=[P,...v]:(k.modal=P?.modal,k.useCustom=P?.useCustom,k.detail=P?.detail,D=v),k.useCustom&&(0,l.checkProposedApiEnabled)(y,"resolvers");const f=[];for(let d=0;d<D.length;d++){const u=D[d];if(typeof u=="string")f.push({title:u,handle:d,isCloseAffordance:!1});else if(typeof u=="object"){const{title:m,isCloseAffordance:b}=u;f.push({title:m,isCloseAffordance:!!b,handle:d})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(I,O,k,f).then(d=>{if(typeof d=="number")return D[d]})}};S=xe([ze(1,L.ILogService)],S),e.ExtHostMessageService=S}),define(ye[267],De([1,0,22,3,6,28,8,9,2,74,5,40,14,7,58,242,136]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,C,p,n){this.q=p,this.r=n,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new L.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(O.MainContext.MainThreadNotebook),this.c=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=C.converter,C.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const r=s.notebookEditor?.notebookUri,a=s.cell.handle,g=this.g.get(r)?.getCell(a);if(g)return g.apiCell}if(s&&s.$mid===14){const r=s.uri,a=this.g.get(r);if(a)return a.apiNotebook}return s}}),u.x(C)}getEditorById(b){const C=this.h.get(b);if(!C)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return C}getIdByEditor(b){for(const[C,p]of this.h)if(p.apiEditor===b)return C}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,C){const p=this.g.get(b);if(!p&&!C)throw new Error(`NO notebook document for '${b}'`);return p}static s(b,C){if(!C)return;const p=C.filenamePattern.map(n=>v.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(C.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:C.displayName,filenamePattern:p,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,C,p){const n=u.a++,s=typeof p.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(n,p),this.b.$registerNotebookCellStatusBarItemProvider(n,s,C);let r;return s!==void 0&&(r=p.onDidChangeCellStatusBarItems(a=>this.b.$emitCellStatusBarEvent(s))),new k.Disposable(()=>{this.f.delete(n),this.b.$unregisterNotebookCellStatusBarItemProvider(n,s),r?.dispose()})}async createNotebookDocument(b){const C=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return y.URI.revive(C)}async openNotebookDocument(b){const C=this.g.get(b);if(C)return C.apiNotebook;const p=await this.c.$tryOpenNotebook(b),n=this.g.get(y.URI.revive(p));return(0,A.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(b,C){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let p;typeof C=="object"?p={position:v.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(v.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:p={preserveFocus:!1};const n=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,p),s=n&&this.h.get(n)?.apiEditor;if(s)return s;throw n?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,C,p,n){const s=this.f.get(b),r=y.URI.revive(C),a=this.g.get(r);if(!a||!s)return;const c=a.getCellFromIndex(p);if(!c)return;const g=await s.provideCellStatusBarItems(c.apiCell,n);if(!g)return;const i=new l.DisposableStore,t=this.p.add([i]),E=(Array.isArray(g)?g:[g]).map(w=>v.NotebookStatusBarItem.from(w,this.i,i));return{cacheId:t,items:E}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,C,p,n,s){if((0,S.isFalsyOrWhitespace)(C))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,p),this.b.$registerNotebookSerializer(r,{id:b.identifier,location:b.extensionLocation},C,v.NotebookDocumentContentOptions.from(n),u.s(b,s)),(0,l.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(b,C,p){const n=this.u.get(b);if(!n)throw new Error("NO serializer found");const s=await n.deserializeNotebook(C.buffer,p);return new D.SerializableObjectWithBuffers(v.NotebookData.from(s))}async $notebookToData(b,C,p){const n=this.u.get(b);if(!n)throw new Error("NO serializer found");const s=await n.serializeNotebook(v.NotebookData.to(C.value),p);return o.VSBuffer.wrap(s)}w(b,C,p){if(this.h.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const n=new d.ExtHostNotebookEditor(C,this.d,b,p.visibleRanges.map(v.NotebookRange.to),p.selections.map(v.NotebookRange.to),typeof p.viewColumn=="number"?v.ViewColumn.to(p.viewColumn):void 0);this.h.set(C,n)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const p of b.value.removedDocuments){const n=y.URI.revive(p),s=this.g.get(n);s&&(s.dispose(),this.g.delete(n),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(s.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===n.toString()&&this.h.delete(r.id)}if(b.value.addedDocuments){const p=[];for(const n of b.value.addedDocuments){const s=y.URI.revive(n.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const r=new f.ExtHostNotebookDocument(this.c,this.q,this.r,s,n);p.push(...n.cells.map(a=>f.ExtHostCell.asModelAddData(r.apiNotebook,a))),this.g.get(s)?.dispose(),this.g.set(s,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(r.apiNotebook)}}if(b.value.addedEditors)for(const p of b.value.addedEditors){if(this.h.has(p.id))return;const n=y.URI.revive(p.documentUri),s=this.g.get(n);s&&this.w(s,p.id,p)}const C=[];if(b.value.removedEditors)for(const p of b.value.removedEditors){const n=this.h.get(p);n&&(this.h.delete(p),this.k?.id===n.id&&(this.k=void 0),C.push(n))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(n=>this.h.get(n)).filter(n=>!!n);const p=new Set;this.l.forEach(n=>p.add(n.id));for(const n of this.h.values()){const s=p.has(n.id);n._acceptVisibility(s)}this.l=[...this.h.values()].map(n=>n).filter(n=>n.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const C=P.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new P.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>o.VSBuffer.wrap(s))],new P.ApiCommandResult("Notebook Data",s=>v.NotebookData.to(s.value))),n=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new D.SerializableObjectWithBuffers(v.NotebookData.from(s)))],new P.ApiCommandResult("Bytes",s=>s.buffer));b.registerApiCommand(p),b.registerApiCommand(n)}}u.a=0,e.ExtHostNotebookController=u}),define(ye[268],De([1,0,15,19,21,3,6,28,2,27,13,74,5,40,14,7,95,232,26,58]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=class{constructor(c,g,i,t,h){this.k=g,this.l=i,this.m=t,this.n=h,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(v.MainContext.MainThreadNotebookKernels);const E=new k.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const N=this.l.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:N}}else if(w&&"notebookEditor"in w){const N=this.l.getIdByEditor(w.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return w})],k.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(c,g,i,t,h,E){for(const ie of this.h.values())if(ie.controller.id===g&&I.ExtensionIdentifier.equals(c.identifier,ie.extensionId))throw new Error(`notebook controller with id '${g}' ALREADY exist`);const w=this.i++,N=this;this.n.trace(`NotebookController[${w}], CREATED by ${c.identifier.value}, ${g}`);const j=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${c.identifier}'`);let V=!1;const Q=new S.DisposableStore,q=new R.Emitter,U=new R.Emitter,T={id:r(c.identifier,g),notebookType:i,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:t||c.identifier.value,preloads:E?E.map(D.NotebookRendererScript.from):[]};let F=h??j,B;this.a.$addKernel(w,T).catch(ie=>{console.log(ie),V=!0});let Z=0;const _=()=>{if(V)return;const ie=++Z;Promise.resolve().then(()=>{ie===Z&&this.a.$updateKernel(w,T)})},H=new A.ResourceMap,Y={get id(){return g},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:q.event,get label(){return T.label},set label(ie){T.label=ie??c.displayName??c.name,_()},get detail(){return T.detail??""},set detail(ie){T.detail=ie,_()},get description(){return T.description??""},set description(ie){T.description=ie,_()},get kind(){return(0,m.checkProposedApiEnabled)(c,"notebookControllerKind"),T.kind??""},set kind(ie){(0,m.checkProposedApiEnabled)(c,"notebookControllerKind"),T.kind=ie,_()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ie){T.supportedLanguages=ie,_()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){T.supportsExecutionOrder=ie,_()},get rendererScripts(){return T.preloads?T.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return F},set executeHandler(ie){F=ie??j},get interruptHandler(){return B},set interruptHandler(ie){B=ie,T.supportsInterrupt=Boolean(ie),_()},createNotebookCellExecution(ie){if(V)throw new Error("notebook controller is DISPOSED");if(!H.has(ie.notebook.uri))throw N.n.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return N._createNotebookCellExecution(ie,r(c.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${w}], DISPOSED`),V=!0,this.h.delete(w),Q.dispose(),q.dispose(),U.dispose(),this.a.$removeKernel(w))},updateNotebookAffinity(ie,ge){ge===f.NotebookControllerAffinity2.Hidden&&(0,m.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(w,ie.uri,ge)},onDidReceiveMessage:U.event,postMessage(ie,ge){return(0,m.checkProposedApiEnabled)(c,"notebookMessaging"),N.a.$postMessage(w,ge&&N.l.getIdByEditor(ge),ie)},asWebviewUri(ie){return(0,m.checkProposedApiEnabled)(c,"notebookMessaging"),(0,d.asWebviewUri)(ie,N.k.remote)}};return this.h.set(w,{extensionId:c.identifier,controller:Y,onDidReceiveMessage:U,onDidChangeSelection:q,associatedNotebooks:H}),Y}getIdByController(c){for(const[g,i]of this.h)if(i.controller===c)return r(i.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,g){const i=this.d++,t=this;this.n.trace(`NotebookControllerDetectionTask[${i}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(i,g);const h={dispose:()=>{this.c.delete(i),t.a.$removeKernelDetectionTask(i)}};return this.c.set(i,h),h}registerKernelSourceActionProvider(c,g,i){const t=this.f++,h=typeof i.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,E=this;this.e.set(t,i),this.n.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(t,t,g);let w;return h!==void 0&&(w=i.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(h))),{dispose:()=>{this.e.delete(t),E.a.$removeKernelSourceActionProvider(t,t),w?.dispose()}}}async $provideKernelSourceActions(c,g){const i=this.e.get(c);if(i){const t=new S.DisposableStore;return this.g.add([t]),(await i.provideNotebookKernelSourceActions(g)??[]).map(E=>D.NotebookKernelSourceAction.from(E,this.m.converter,t))}return[]}$acceptNotebookAssociation(c,g,i){const t=this.h.get(c);if(t){const h=this.l.getNotebookDocument(y.URI.revive(g));i?t.associatedNotebooks.set(h.uri,!0):t.associatedNotebooks.delete(h.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,h.uri.toString(),i),t.onDidChangeSelection.fire({selected:i,notebook:h.apiNotebook})}}async $executeCells(c,g,i){const t=this.h.get(c);if(!t)return;const h=this.l.getNotebookDocument(y.URI.revive(g)),E=[];for(const w of i){const N=h.getCell(w);N&&E.push(N.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,h.uri.toString(),E.length),await t.controller.executeHandler.call(t.controller,E,h.apiNotebook,t.controller)}catch(w){this.n.error(`NotebookController[${c}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(c,g,i){const t=this.h.get(c);if(!t)return;const h=this.l.getNotebookDocument(y.URI.revive(g));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,h.apiNotebook);else for(const E of i){const w=h.getCell(E);w&&this.b.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,g,i){const t=this.h.get(c);if(!t)return;const h=this.l.getEditorById(g);t.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:i}))}$cellExecutionChanged(c,g,i){const h=this.l.getNotebookDocument(y.URI.revive(c)).getCell(g);if(h){const E=i?D.NotebookCellExecutionState.to(i):f.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:h.apiCell,state:E})}}_createNotebookCellExecution(c,g){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this.b.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const h=new n(g,t,this.a);this.b.set(t.uri,h);const E=h.onDidChangeState(()=>{h.state===p.Resolved&&(h.dispose(),E.dispose(),this.b.delete(t.uri))});return h.asApiObject()}};C=xe([ze(4,O.ILogService)],C),e.ExtHostNotebookKernels=C;var p;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(p||(p={}));class n extends S.Disposable{get state(){return this.f}constructor(c,g,i){super(),this.j=g,this.k=i,this.b=n.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new l.CancellationTokenSource),this.h=new s(10,t=>this.m(t)),this.i=g.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const g=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(g))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let g=this.j;if(c&&(g=this.j.notebook.getCellFromApiCell(c)),!g)throw new Error("INVALID cell");return g.handle}s(c){return c.map(g=>{const i=f.NotebookCellOutput.ensureUniqueMimeTypes(g.items,!0);return i===g.items?D.NotebookCellOutput.from(g):D.NotebookCellOutput.from({items:i,id:g.id,metadata:g.metadata})})}async t(c,g,i){const t=this.r(g),h=this.s((0,o.asArray)(c));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:t,append:i,outputs:h})}async w(c,g,i){return c=f.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(c),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:c.map(D.NotebookCellOutputItem.from),outputId:g.id,append:i})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(i){c.i=i,c.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(i){if(c.f===p.Resolved||c.f===p.Started)throw new Error("Cannot call start again");c.f=p.Started,c.c.fire(),c.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:i})},end(i,t){if(c.f===p.Resolved)throw new Error("Cannot call resolve twice");c.f=p.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new b.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:i}))},clearOutput(i){return c.n(),c.t([],i,!1)},appendOutput(i,t){return c.n(),c.t(i,t,!0)},replaceOutput(i,t){return c.n(),c.t(i,t,!1)},appendOutputItems(i,t){return c.n(),c.w(i,t,!0)},replaceOutputItems(i,t){return c.n(),c.w(i,t,!1)}})}}n.a=0;class s{constructor(c,g){this.d=c,this.e=g,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new L.DeferredPromise,this.b=Date.now(),(0,L.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const g=this.a;return this.a=[],this.e(g).finally(()=>c.complete())}}function r(a,c){return`${a.value}/${c}`}e.createKernelId=r}),define(ye[269],De([1,0,3,5,136]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,I){const O=this.c.getEditorById(A);this.a.get(y)?.fire({editor:O.apiEditor,message:I})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,P,v)=>this.d(y).event(O,P,v),postMessage:(O,P)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,P]=[P,O]);const v=P&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(v?.id,y,O)}}}d(A){let y=this.a.get(A);return y||(y=new o.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=R}),define(ye[270],De([1,0,6,9,2,26,5]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(I){this.b=new Map,this.a=I.getProxy(S.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,O,P){if((0,R.checkProposedApiEnabled)(I,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,P),this.a.$registerProfileContentHandler(O,P.name,P.description,I.identifier.value),(0,o.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(I,O,P,v){const k=this.b.get(I);if(!k)throw new Error(`Unknown handler with id: ${I}`);return k.saveProfile(O,P,v)}async $readProfile(I,O,P){const v=this.b.get(I);if(!v)throw new Error(`Unknown handler with id: ${I}`);return v.readProfile((0,L.isString)(O)?O:l.URI.revive(O),P)}}e.ExtHostProfileContentHandlers=A}),define(ye[271],De([1,0,2,5,19,14]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class S{constructor(y,I){this.d=I,this.c=new Map,this.b=y.getProxy(L.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,I,O){const P=o.URI.revive(I),v=this.c.get(y);return v?(0,l.asPromise)(()=>v.provideOriginalResource(P,O)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(y,I,O,P){const v=S.a++;return this.c.set(v,I),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(y,this.d),O,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}S.a=0,e.ExtHostQuickDiff=S}),define(ye[272],De([1,0,21,3,6,5,2,7,10,15,37,51,26,14]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function D(f,d,u){const m=f.getProxy(R.MainContext.MainThreadQuickOpen);class b{constructor(i,t){this.e=new Map,this.f=0,this.a=i,this.b=t}showQuickPick(i,t,h,E=o.CancellationToken.None){this.c=void 0;const w=Promise.resolve(t),N=++this.f,j=m.$show(N,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},E),V={},Q=j.then(()=>V);return Promise.race([Q,w]).then(q=>{if(q===V)return;const U=(0,v.isProposedApiEnabled)(i,"quickPickItemTooltip");return w.then(T=>{const F=[];for(let B=0;B<T.length;B++){const Z=T[B];typeof Z=="string"?F.push({label:Z,handle:B}):Z.kind===A.QuickPickItemKind.Separator?F.push({type:"separator",label:Z.label}):(Z.tooltip&&!U&&console.warn(`Extension '${i.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${i.identifier.value}`),F.push({label:Z.label,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:U?k.MarkdownString.fromStrict(Z.tooltip):void 0,handle:B}))}return h&&typeof h.onDidSelectItem=="function"&&(this.c=B=>{h.onDidSelectItem(T[B])}),m.$setItems(N,F),j.then(B=>{if(typeof B=="number")return T[B];if(Array.isArray(B))return B.map(Z=>T[Z])})})}).then(void 0,q=>{if(!(0,y.isCancellationError)(q))return m.$setError(N,q),Promise.reject(q)})}$onItemSelected(i){this.c?.(i)}showInput(i,t=o.CancellationToken.None){return this.d=i?.validateInput,m.$input(i,typeof this.d=="function",t).then(void 0,h=>{if(!(0,y.isCancellationError)(h))return Promise.reject(h)})}async $validateInput(i){if(!this.d)return;const t=await this.d(i);if(!t||typeof t=="string")return t;let h;switch(t.severity){case A.InputBoxValidationSeverity.Info:h=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:h=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:h=O.default.Error;break;default:h=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:h}}async showWorkspaceFolderPick(i,t=o.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!h)return;const E=await this.a.getWorkspaceFolders2();if(!!E)return E.find(w=>w.uri.toString()===h.uri.toString())}createQuickPick(i){const t=new a(i,()=>this.e.delete(t._id));return this.e.set(t._id,t),t}createInputBox(i){const t=new c(i,()=>this.e.delete(t._id));return this.e.set(t._id,t),t}$onDidChangeValue(i,t){this.e.get(i)?._fireDidChangeValue(t)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,t){const h=this.e.get(i);h instanceof a&&h._fireDidChangeActive(t)}$onDidChangeSelection(i,t){const h=this.e.get(i);h instanceof a&&h._fireDidChangeSelection(t)}$onDidTriggerButton(i,t){this.e.get(i)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(i,t,h){const E=this.e.get(i);E instanceof a&&E._fireDidTriggerItemButton(t,h)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class C{constructor(i,t){this.x=i,this.y=t,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.Emitter,this.q=new L.Emitter,this.r=new L.Emitter,this.s=new L.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((t,h)=>{const E=t===A.QuickInputButtons.Back?-1:h;this.o.set(E,t)}),this.z({buttons:i.map((t,h)=>({...r(t),tooltip:t.tooltip,handle:t===A.QuickInputButtons.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const t=this.o.get(i);t&&this.r.fire(t)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(i){if(!this.v){for(const t of Object.keys(i)){const h=i[t];this.u[t]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}C.a=1;function p(g){if(g instanceof A.ThemeIcon)return{id:g.id};const i=s(g),t=n(g);return{dark:typeof i=="string"?S.URI.file(i):i,light:typeof t=="string"?S.URI.file(t):t}}function n(g){return typeof g=="object"&&"light"in g?g.light:g}function s(g){return typeof g=="object"&&"dark"in g?g.dark:g}function r(g){const i=p(g.iconPath);let t,h;return"id"in i?h=P.ThemeIcon.asClassName(i):t=i,{iconPath:t,iconClass:h}}class a extends C{constructor(i,t){super(i.identifier,t),this.O=i,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.Emitter,this.L=[],this.M=new L.Emitter,this.N=new L.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((E,w)=>{this.C.set(w,E),this.D.set(E,w)});const t=(0,v.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),h=[];for(let E=0;E<i.length;E++){const w=i[E];w.kind===A.QuickPickItemKind.Separator?h.push({type:"separator",label:w.label}):(w.tooltip&&!t&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),h.push({handle:E,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:t?k.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,j)=>({...r(N),tooltip:N.tooltip,handle:j}))}))}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(t=>this.D.has(t)),this.z({activeItems:this.J.map(t=>this.D.get(t))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(t=>this.D.has(t)),this.z({selectedItems:this.L.map(t=>this.D.get(t))})}_fireDidChangeActive(i){const t=(0,I.coalesce)(i.map(h=>this.C.get(h)));this.J=t,this.K.fire(t)}_fireDidChangeSelection(i){const t=(0,I.coalesce)(i.map(h=>this.C.get(h)));this.L=t,this.M.fire(t)}_fireDidTriggerItemButton(i,t){const h=this.C.get(i);if(!h||!h.buttons||!h.buttons.length)return;const E=h.buttons[t];E&&this.N.fire({button:E,item:h})}}class c extends C{constructor(i,t){super(i.identifier,t),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:O.default.Error}):this.z({validationMessage:i.message,severity:i.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new b(d,u)}e.createExtHostQuickOpen=D});var Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o};define(ye[273],De([1,0,2,3,62,6,19,5,15,108,13,27,51,14,26]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";var f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(t){if(t)return typeof t.iconPath=="string"?o.URI.file(t.iconPath):o.URI.isUri(t.iconPath)||v.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function m(t,h){if(!t.iconPath&&!h.iconPath)return 0;if(t.iconPath){if(!h.iconPath)return 1}else return-1;const E=typeof t.iconPath=="string"?t.iconPath:o.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,w=typeof h.iconPath=="string"?h.iconPath:o.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,I.comparePaths)(E,w)}function b(t,h){let E=0;if(t.strikeThrough!==h.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==h.faded)return t.faded?1:-1;if(t.tooltip!==h.tooltip)return(t.tooltip||"").localeCompare(h.tooltip||"");if(E=m(t,h),E!==0)return E;if(t.light&&h.light)E=m(t.light,h.light);else{if(t.light)return 1;if(h.light)return-1}if(E!==0)return E;if(t.dark&&h.dark)E=m(t.dark,h.dark);else{if(t.dark)return 1;if(h.dark)return-1}return E}function C(t,h){if(t.command!==h.command)return t.command<h.command?-1:1;if(t.title!==h.title)return t.title<h.title?-1:1;if(t.tooltip!==h.tooltip){if(t.tooltip!==void 0&&h.tooltip!==void 0)return t.tooltip<h.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(t.arguments===h.arguments)return 0;if(t.arguments)if(h.arguments){if(t.arguments.length!==h.arguments.length)return t.arguments.length-h.arguments.length}else return 1;else return-1;for(let E=0;E<t.arguments.length;E++){const w=t.arguments[E],N=h.arguments[E];if(w!==N)return w<N?-1:1}return 0}function p(t,h){let E=(0,I.comparePaths)(t.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(E!==0)return E;if(t.command&&h.command)E=C(t.command,h.command);else{if(t.command)return 1;if(h.command)return-1}if(E!==0)return E;if(t.decorations&&h.decorations)E=b(t.decorations,h.decorations);else{if(t.decorations)return 1;if(h.decorations)return-1}return E}function n(t,h){for(let E=0;E<t.length;E++)if(t[E]!==h[E])return!1;return!0}function s(t,h){return t.command===h.command&&t.title===h.title&&t.tooltip===h.tooltip&&(t.arguments&&h.arguments?n(t.arguments,h.arguments):t.arguments===h.arguments)}function r(t,h){return(0,y.equals)(t,h,s)}class a{get value(){return this.d}set value(h){h=h??"",Ue(this,f,"f").$setInputBoxValue(this.l,h),this.m(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){Ue(this,f,"f").$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,D.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,D.checkProposedApiEnabled)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,Ue(this,f,"f").$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,Ue(this,f,"f").$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,Ue(this,f,"f").$setInputBoxVisibility(this.l,h))}constructor(h,E,w){this.k=h,this.l=w,f.set(this,void 0),this.d="",this.e=new L.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,f,E,"f")}showValidationMessage(h,E){(0,D.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,f,"f").$showValidationMessage(this.l,h,E)}$onInputBoxValueChange(h){this.m(h)}m(h){this.d=h,this.e.fire(h)}}e.ExtHostSCMInputBox=a,f=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,E,w,N,j){this.q=h,this.s=E,this.t=w,this.u=N,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,E){const w=this.h.get(h);return w?(0,S.asPromise)(()=>this.s.executeCommand(w.command,...w.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(p),w=(0,y.sortedDiff)(this.o,h,p).map(V=>{const Q=V.toInsert.map(q=>{const U=this.e++;this.g.set(U,q);const T=q.resourceUri;let F;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const ee=new R.DisposableStore;F=this.s.converter.toInternal(q.command,ee),this.j.set(U,ee)}else this.h.set(U,q.command);const B=u(q.decorations),Z=q.decorations&&u(q.decorations.light)||B,_=q.decorations&&u(q.decorations.dark)||B,H=[Z,_],Y=q.decorations&&q.decorations.tooltip||"",ie=q.decorations&&!!q.decorations.strikeThrough,ge=q.decorations&&!!q.decorations.faded,X=q.contextValue||"";return{rawResource:[U,T,H,Y,ie,ge,X,F],handle:U}});return{start:V.start,deleteCount:V.deleteCount,toInsert:Q}}),N=w.map(({start:V,deleteCount:Q,toInsert:q})=>[V,Q,q.map(U=>U.rawResource)]),j=w.reverse();for(const{start:V,deleteCount:Q,toInsert:q}of j){const U=q.map(F=>F.handle),T=this.n.splice(V,Q,...U);for(const F of T)this.g.delete(F),this.h.delete(F),this.j.get(F)?.dispose(),this.j.delete(F)}return this.o=h,N}dispose(){this.l=!0,this.m.fire()}}c.d=0;class g{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,Ue(this,d,"f").$updateSourceControl(this.t,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h;let E;(0,D.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(E=h?.label),Ue(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!h,quickDiffLabel:E})}get commitTemplate(){return this.j}set commitTemplate(h){h!==this.j&&(this.j=h,Ue(this,d,"f").$updateSourceControl(this.t,{commitTemplate:h}))}get acceptInputCommand(){return this.l}set acceptInputCommand(h){this.k.value=new R.DisposableStore,this.l=h;const E=this.v.converter.toInternal(h,this.k.value);Ue(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,D.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(h){(0,D.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=h;const E=h!==void 0?{command:this.v.converter.toInternal(h.command,this.m.value),secondaryCommands:h.secondaryCommands?.map(w=>w.map(N=>this.v.converter.toInternal(N,this.m.value))),description:h.description,enabled:h.enabled}:void 0;Ue(this,d,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(h){if(this.p&&h&&r(this.p,h))return;this.o.value=new R.DisposableStore,this.p=h;const E=(h||[]).map(w=>this.v.converter.toInternal(w,this.o.value));Ue(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(h,E,w,N,j,V){this.u=h,this.v=w,this.w=N,this.x=j,this.y=V,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new L.Emitter,this.onDidChangeSelection=this.s.event,this.t=g.d++,this.z=new Map,this.A=new Set,_e(this,d,E,"f"),this.f=new a(h,Ue(this,d,"f"),this.t),Ue(this,d,"f").$registerSourceControl(this.t,N,j,V)}createResourceGroup(h,E){const w=new c(Ue(this,d,"f"),this.v,this.t,h,E),N=L.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,N),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const h=[],E=[];for(const[w,N]of this.z){N.dispose();const j=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});L.Event.once(w.onDidDispose)(()=>{this.A.delete(w),j.dispose(),this.e.delete(w.handle),Ue(this,d,"f").$unregisterGroup(this.t,w.handle)}),h.push([w.handle,w.id,w.label,w.features]);const V=w._takeResourceStateSnapshot();V.length>0&&E.push([w.handle,V]),this.e.set(w.handle,w)}Ue(this,d,"f").$registerGroups(this.t,h,E),this.z.clear()}eventuallyUpdateResourceStates(){const h=[];this.A.forEach(E=>{const w=E._takeResourceStateSnapshot();w.length!==0&&h.push([E.handle,w])}),h.length>0&&Ue(this,d,"f").$spliceResourceStates(this.t,h),this.A.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.q=h,this.s.fire(h)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(h=>h.dispose()),Ue(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,g.d=0,xe([(0,l.debounce)(100)],g.prototype,"eventuallyAddResourceGroups",null),xe([(0,l.debounce)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let i=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(h,E,w){this.l=E,this.m=w,this.g=new Map,this.h=new Map,this.j=new L.Emitter,this.e=h.getProxy(A.MainContext.MainThreadSCM),this.f=h.getProxy(A.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const j=this.g.get(N.sourceControlHandle);if(!j)return N;const V=j.getResourceGroup(N.groupHandle);return V?V.getResourceState(N.handle):N}else if(N&&N.$mid===4){const j=this.g.get(N.sourceControlHandle);return j?j.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const j=this.g.get(N.handle);return j||N}return N}})}createSourceControl(h,E,w,N){this.m.trace("ExtHostSCM#createSourceControl",h.identifier.value,E,w,N),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const j=on.d++,V=new g(h,this.e,this.l,E,w,N);this.g.set(j,V);const Q=this.h.get(P.ExtensionIdentifier.toKey(h.identifier))||[];return Q.push(V),this.h.set(P.ExtensionIdentifier.toKey(h.identifier),Q),V}getLastInputBox(h){this.m.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const E=this.h.get(P.ExtensionIdentifier.toKey(h.identifier)),w=E&&E[E.length-1];return w&&w.inputBox}$provideOriginalResource(h,E,w){const N=o.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",h,N.toString());const j=this.g.get(h);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>j.quickDiffProvider.provideOriginalResource(N,w)).then(V=>V||null)}$onInputBoxValueChange(h,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",h);const w=this.g.get(h);return w&&w.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(h,E,w,N){this.m.trace("ExtHostSCM#$executeResourceCommand",h,E,w);const j=this.g.get(h);if(!j)return Promise.resolve(void 0);const V=j.getResourceGroup(E);return V?V.$executeResourceCommand(w,N):Promise.resolve(void 0)}$validateInput(h,E,w){this.m.trace("ExtHostSCM#$validateInput",h);const N=this.g.get(h);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>N.inputBox.validateInput(E,w)).then(j=>{if(!j)return Promise.resolve(void 0);const V=k.MarkdownString.fromStrict(j.message);return V?Promise.resolve([V,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}};i.d=0,i=xe([ze(2,O.ILogService)],i),e.ExtHostSCM=i}),define(ye[98],De([1,0,5,3,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new L.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,I){return this.a.$setPassword(A,y,I)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[274],De([1,0,7,5,180,6,14,9]),function(re,e,o,L,l,R,S,A){"use strict";var y,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(D,f,d,u,m=o.StatusBarAlignment.Left,b){y.set(this,void 0),I.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,_e(this,y,D,"f"),_e(this,I,f,"f"),this.c=O.a++,this.e=d,this.f=u,this.g=m,this.h=this.u(b)}u(D){if(!!(0,A.isNumber)(D))return D===Number.POSITIVE_INFINITY?Number.MAX_VALUE:D===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:D}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(D){this.k=D,this.v()}set name(D){this.m=D,this.v()}set tooltip(D){this.l=D,this.v()}set color(D){this.n=D,this.v()}set backgroundColor(D){D&&!O.b.has(D.id)&&(D=void 0),this.o=D,this.v()}set command(D){this.r?.fromApi!==D&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof D=="string"?this.r={fromApi:D,internal:Ue(this,I,"f").toInternal({title:"",command:D},this.p)}:D?this.r={fromApi:D,internal:Ue(this,I,"f").toInternal(D,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(D){this.t=D,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let D;this.e?this.f?D=`${this.e.identifier.value}.${this.f}`:D=this.e.identifier.value:D=this.f;let f;this.m?f=this.m:f=(0,l.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=O.b.get(this.o.id));const u=S.MarkdownString.fromStrict(this.l);Ue(this,y,"f").$setEntry(this.c,D,f,this.k,u,this.r?.internal,d,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}y=new WeakMap,I=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=O;class P{constructor(D){this.b=[],this.a=D.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(D){const f={message:D};return this.b.unshift(f),this.c(),new o.Disposable(()=>{const d=this.b.indexOf(f);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(D,f){this.a=D.getProxy(L.MainContext.MainThreadStatusBar),this.b=f,this.c=new P(this)}createStatusBarEntry(D,f,d,u){return new O(this.a,this.b,D,f,d,u)}setStatusBarMessage(D,f){const d=this.c.setMessage(D);let u;return typeof f=="number"?u=setTimeout(()=>d.dispose(),f):typeof f<"u"&&f.then(()=>d.dispose(),()=>d.dispose()),new o.Disposable(()=>{d.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=v}),define(ye[99],De([1,0,5,3,4]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,y){this.c=y,this.b=new L.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,I){const O=await this.a.$initializeExtensionStorage(A,y);let P;return O&&(P=this.d(A,y,O)),P||I}setValue(A,y,I){return this.a.$setValue(A,y,I)}$acceptValue(A,y,I){const O=this.d(A,y,I);O&&this.b.fire({shared:A,key:y,value:O})}d(A,y,I){try{return JSON.parse(I)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${O}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(ye[79],De([1,0,4,25,13,78,2]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let A=class{constructor(I,O,P){this.d=O,this.f=P,this.a=I.workspace??void 0,this.b=I.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(I){return S.URI.joinPath(this.b.workspaceStorageHome,I)}async h(){if(!this.a)return Promise.resolve(void 0);const I=this.a.id,O=await this.g(I);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(S.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:S.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(I){if(this.c)return S.URI.joinPath(this.c,I.identifier.value)}globalValue(I){return S.URI.joinPath(this.b.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=xe([ze(0,L.IExtHostInitDataService),ze(1,l.ILogService),ze(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[41],De([1,0,3,5,4,2,20,6,7,182,10,215,21,30,216,51,9,19,14]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class b{constructor(i,t,h,E){this.k=i,this._id=t,this.l=h,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(N=>this.f=N);const w=this;this.value={get name(){return w.m||""},get processId(){return w.b},get creationOptions(){return w.l},get exitStatus(){return w.h},get state(){return w.j},sendText(N,j=!0){w.o(),w.k.$sendText(w._id,N,j)},show(N){w.o(),w.k.$show(w._id,N)},hide(){w.o(),w.k.$hide(w._id)},dispose(){w.a||(w.a=!0,w.k.$dispose(w._id))},get dimensions(){if(!(w.d===void 0||w.g===void 0))return{columns:w.d,rows:w.g}}}}async create(i,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:i.name,shellPath:(0,d.withNullAsUndefined)(i.shellPath),shellArgs:(0,d.withNullAsUndefined)(i.shellArgs),cwd:(0,d.withNullAsUndefined)(i.cwd),env:(0,d.withNullAsUndefined)(i.env),icon:(0,d.withNullAsUndefined)(a(i.iconPath)),color:f.ThemeColor.isThemeColor(i.color)?i.color.id:void 0,initialText:(0,d.withNullAsUndefined)(i.message),strictEnv:(0,d.withNullAsUndefined)(i.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(i.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this.n(i.location,t?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(i.isTransient)})}async createExtensionTerminal(i,t,h,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:h,color:f.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(i,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(i,t){return typeof i=="object"?"parentTerminal"in i&&i.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in i?{viewColumn:m.ViewColumn.from(i.viewColumn),preserveFocus:i.preserveFocus}:void 0:i}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(i){this.m=i}setExitStatus(i,t){this.h=Object.freeze({code:i,reason:t})}setDimensions(i,t){return i===this.d&&t===this.g||i===0||t===0?!1:(this.d=i,this.g=t,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(i){this.f?(this.f(i),this.f=void 0):this.b.then(t=>{t!==i&&(this.b=Promise.resolve(i))})}}e.ExtHostTerminal=b;class C{get onProcessReady(){return this.b.event}constructor(i){this.g=i,this.id=0,this.shouldPersist=!1,this.a=new o.Emitter,this.onProcessData=this.a.event,this.b=new o.Emitter,this.d=new o.Emitter,this.onDidChangeProperty=this.d.event,this.f=new o.Emitter,this.onProcessExit=this.f.event}refreshProperty(i){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${i}`)}updateProperty(i,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${i}, value: ${t}`)}async start(){}shutdown(){this.g.close()}input(i){this.g.handleInput?.(i)}resize(i,t){this.g.setDimensions?.({columns:i,rows:t})}async processBinary(i){}acknowledgeDataEvent(i){}async setUnicodeVersion(i){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(i){this.g.onDidWrite(t=>this.a.fire(t)),this.g.onDidClose?.((t=void 0)=>{this.f.fire(t===void 0?void 0:t)}),this.g.onDidOverrideDimensions?.(t=>{t&&this.d.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this.g.onDidChangeName?.(t=>{this.d.fire({type:"title",value:t})}),this.g.open(i||void 0),i&&this.g.setDimensions?.(i),this.b.fire({pid:-1,cwd:""})}}let p=1,n=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(i=>i.value)}get onDidWriteTerminalData(){return this.I.event}constructor(i,t){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new o.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new o.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new o.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new o.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new o.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new o.Emitter,this.onDidChangeShell=this.J.event,this.a=t.getProxy(L.MainContext.MainThreadTerminalService),this.s=new D.TerminalDataBufferer(this.a.$sendProcessData),this.I=new o.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(i),this.B({dispose:()=>{for(const[h,E]of this.g)E.shutdown(!0)}})}getDefaultShell(i){return(i?this.n:this.m)?.path||""}getDefaultShellArgs(i){return(i?this.n:this.m)?.args||[]}createExtensionTerminal(i,t){const h=new b(this.a,(0,k.generateUuid)(),i,i.name),E=new C(i.pty);return h.createExtensionTerminal(i.location,this.L(i,t).resolvedExtHostIdentifier,a(i.iconPath),c(i.color)).then(w=>{const N=this.M(w,E);this.h[w]=N}),this.f.push(h),h.value}L(i,t){if(t=t||{},i.location&&typeof i.location=="object"&&"parentTerminal"in i.location){const h=i.location.parentTerminal;if(h){const E=this.f.find(w=>w.value===h);E&&(t.resolvedExtHostIdentifier=E._id)}}else i.location&&typeof i.location!="object"?t.location=i.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(i,t){if(!this.O(i))throw new Error(`Cannot resolve terminal with id ${i} for virtual process`);const E=new C(t),w=this.M(i,E);this.h[i]=w}async $acceptActiveTerminalChanged(i){const t=this.b;if(i===null){this.b=void 0,t!==this.b&&this.F.fire(this.b);return}const h=this.O(i);h&&(this.b=h,t!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(i,t){const h=this.O(i);h&&this.I.fire({terminal:h.value,data:t})}async $acceptTerminalDimensions(i,t,h){const E=this.O(i);E&&E.setDimensions(t,h)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(i,t,h){this.g.get(i)?.resize(t,h)}async $acceptTerminalTitleChange(i,t){const h=this.O(i);h&&(h.name=t)}async $acceptTerminalClosed(i,t,h){const E=this.Q(this.f,i);if(E!==null){const w=this.f.splice(E,1)[0];w.setExitStatus(t,h),this.C.fire(w.value)}}$acceptTerminalOpened(i,t,h,E){if(t){const j=this.Q(this.f,t);if(j!==null){this.f[j]._id=i,this.D.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const w={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},N=new b(this.a,i,w,h);this.f.push(N),this.D.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(i,t){this.O(i)?._setProcessId(t)}async $startExtensionTerminal(i,t){const h=this.O(i);if(!h)return{message:(0,I.localize)(0,null,i)};h.isOpen||await new Promise(w=>{const N=this.onDidOpenTerminal(async j=>{j===h.value&&(N.dispose(),w())})});const E=this.g.get(i);E?E.startSendingEvents(t):this.j[i]={initialDimensions:t}}M(i,t){const h=new A.DisposableStore;h.add(t.onProcessReady(w=>this.a.$sendProcessReady(i,w.pid,w.cwd))),h.add(t.onDidChangeProperty(w=>this.a.$sendProcessProperty(i,w))),this.s.startBuffering(i,t.onProcessData),h.add(t.onProcessExit(w=>this.N(i,w))),this.g.set(i,t);const E=this.j[i];return E&&t instanceof C&&(t.startSendingEvents(E.initialDimensions),delete this.j[i]),h}$acceptProcessAckDataEvent(i,t){this.g.get(i)?.acknowledgeDataEvent(t)}$acceptProcessInput(i,t){this.g.get(i)?.input(t)}$acceptTerminalInteraction(i){const t=this.O(i);t?.setInteractedWith()&&this.H.fire(t.value)}$acceptProcessResize(i,t,h){try{this.g.get(i)?.resize(t,h)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(i,t){this.g.get(i)?.shutdown(t)}$acceptProcessRequestInitialCwd(i){this.g.get(i)?.getInitialCwd().then(t=>this.a.$sendProcessProperty(i,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(i){this.g.get(i)?.getCwd().then(t=>this.a.$sendProcessProperty(i,{type:"cwd",value:t}))}$acceptProcessRequestLatency(i){return Promise.resolve(i)}registerLinkProvider(i){return this.u.add(i),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(i),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(i,t,h){if(this.v.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this.v.set(t,h),this.a.$registerProfileProvider(t,i.identifier.value),new y.Disposable(()=>{this.v.delete(t),this.a.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(i,t,h){if(this.w.has(i))throw new Error(`Terminal quick fix provider "${i}" is already registered`);return this.w.set(i,h),this.a.$registerQuickFixProvider(i,t),new y.Disposable(()=>{this.w.delete(i),this.a.$unregisterQuickFixProvider(i)})}async $provideTerminalQuickFixes(i,t){const h=new v.CancellationTokenSource().token;if(h.isCancellationRequested)return;const E=this.w.get(i);if(!E)return;const w=await E.provideTerminalQuickFixes(t,h);if(w!==null)return w}async $createContributedProfileTerminal(i,t){const h=new v.CancellationTokenSource().token;let E=await this.v.get(i)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${i}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,t);return}this.createTerminalFromOptions(E.options,t)}}async $provideLinks(i,t){const h=this.O(i);if(!h)return[];this.y.delete(i),this.z.get(i)?.dispose(!0);const w=new v.CancellationTokenSource;this.z.set(i,w);const N=[],j={terminal:h.value,line:t},V=[];for(const U of this.u)V.push(u.Promises.withAsyncBody(async T=>{w.token.onCancellationRequested(()=>T({provider:U,links:[]}));const F=await U.provideTerminalLinks(j,w.token)||[];w.token.isCancellationRequested||T({provider:U,links:F})}));const Q=await Promise.all(V);if(w.token.isCancellationRequested)return[];const q=new Map;for(const U of Q)U&&U.links.length>0&&N.push(...U.links.map(T=>{const F={id:p++,startIndex:T.startIndex,length:T.length,label:T.tooltip};return q.set(F.id,{provider:U.provider,link:T}),F}));return this.y.set(i,q),N}$activateLink(i,t){const h=this.y.get(i)?.get(t);!h||h.provider.handleTerminalLink(h.link)}N(i,t){this.s.stopBuffering(i),this.g.delete(i),delete this.j[i];const h=this.h[i];h&&(h.dispose(),delete this.h[i]),this.a.$sendProcessExit(i,t)}O(i){return this.P(this.f,i)}P(i,t){const h=this.Q(i,t);return h!==null?i[h]:null}Q(i,t){let h=null;return i.some((E,w)=>E._id===t?(h=w,!0):!1),h}getEnvironmentVariableCollection(i){let t=this.l.get(i.identifier.value);return t||(t=new s,this.S(i.identifier.value,t)),t}R(i,t){const h=(0,P.serializeEnvironmentVariableCollection)(t.map);this.a.$setEnvironmentVariableCollection(i,t.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(i){i.forEach(t=>{const h=t[0],E=new s(t[1]);this.S(h,E)})}$acceptDefaultProfile(i,t){const h=this.m;this.m=i,this.n=t,h?.path!==i.path&&this.J.fire(i.path)}S(i,t){this.l.set(i,t),t.onDidChangeCollection(()=>{this.R(i,t)})}};n=xe([ze(1,S.IExtHostRpcService)],n),e.BaseExtHostTerminalService=n;class s{get persistent(){return this.a}set persistent(i){this.a=i,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(i){this.map=new Map,this.a=!0,this.b=new o.Emitter,this.map=new Map(i)}get size(){return this.map.size}replace(i,t){this.d(i,{value:t,type:y.EnvironmentVariableMutatorType.Replace})}append(i,t){this.d(i,{value:t,type:y.EnvironmentVariableMutatorType.Append})}prepend(i,t){this.d(i,{value:t,type:y.EnvironmentVariableMutatorType.Prepend})}d(i,t){const h=this.map.get(i);(!h||h.value!==t.value||h.type!==t.type)&&(this.map.set(i,t),this.b.fire())}get(i){return this.map.get(i)}forEach(i,t){this.map.forEach((h,E)=>i.call(t,E,h,this))}[Symbol.iterator](){return this.map.entries()}delete(i){this.map.delete(i),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends n{constructor(i){super(!1,i)}createTerminal(i,t,h){throw new O.NotSupportedError}createTerminalFromOptions(i,t){throw new O.NotSupportedError}};r=xe([ze(0,S.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function a(g){if(!(!g||typeof g=="string"))return"id"in g?{id:g.id,color:g.color}:g}function c(g){return f.ThemeColor.isThemeColor(g)?g:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o};define(ye[275],De([1,0,15,19,22,21,3,63,88,6,23,9,30,5,20,137,14,7,57,94,75,26]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p){"use strict";var n,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(U,T,F){this.j=F,this.c=new S.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(k.MainContext.MainThreadTesting),this.h=new j(this.f),this.g=new i(this.f),T.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const Z=B,_=Z.tests[Z.tests.length-1].item.extId;return this.d.get(m.TestId.root(_))?.collection.tree.get(_)?.actual??(0,f.toItemFromContext)(B)}})}createTestController(U,T,F,B){if(this.d.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const Z=new I.DisposableStore,_=Z.add(new f.ExtHostTestItemCollection(T,F,this.j));_.root.label=F;const H=new Map,Y=this.f,ie={items:_.root.children,get label(){return F},set label(X){F=X,_.root.label=X,Y.$updateController(T,{label:F})},get refreshHandler(){return B},set refreshHandler(X){B=X,Y.$updateController(T,{canRefresh:!!X})},get id(){return T},createRunProfile:(X,J,ee,me,ve,Ie)=>{let Re=(0,y.hash)(X);for(;H.has(Re);)Re++;return Ie!==void 0&&(0,p.checkProposedApiEnabled)(U,"testContinuousRun"),new V(this.f,H,T,Re,X,J,ee,me,ve,Ie)},createTestItem(X,J,ee){return new f.TestItemImpl(T,X,J,ee)},createTestRun:(X,J,ee=!0)=>this.g.createTestRun(T,_,X,J,ee),set resolveHandler(X){_.resolveHandler=X},get resolveHandler(){return _.resolveHandler},dispose:()=>{Z.dispose()}};Y.$registerTestController(T,F,!!B),Z.add((0,I.toDisposable)(()=>Y.$unregisterTestController(T)));const ge={controller:ie,collection:_,profiles:H};return this.d.set(T,ge),Z.add((0,I.toDisposable)(()=>this.d.delete(T))),Z.add(_.onDidGenerateDiff(X=>Y.$publishDiff(T,X.map(C.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(U,T=R.CancellationToken.None){const F=t(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(F.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(Z=>m.TestId.fromExtHostTestItem(Z,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:Q[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(Z=>Z.id)},T)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,T,F){return(0,o.mapFind)(this.g.trackers,Z=>Z.id===U?Z.getCoverage(T):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(U,T,F,B){return(0,o.mapFind)(this.g.trackers,_=>_.id===U?_.getCoverage(T):void 0)?.resolveFileCoverage(F,B)??Promise.resolve([])}$configureRunProfile(U,T){this.d.get(U)?.profiles.get(T)?.configureHandler?.()}async $refreshTests(U,T){await this.d.get(U)?.controller.refreshHandler?.(T)}$publishTestResults(U){this.results=Object.freeze(U.map(T=>(0,O.deepFreeze)(d.TestResults.to(T))).concat(this.results).sort((T,F)=>F.completedAt-T.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,T){const F=this.d.get(m.TestId.fromString(U).controllerId)?.collection;F&&(await F.expand(U,T<0?1/0:T),F.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(C.TestsDiffOp.deserialize))}async $runControllerTests(U,T){return Promise.all(U.map(F=>this.k(F,!1,T)))}async $startContinuousRun(U,T){const F=new R.CancellationTokenSource(T),B=await Promise.all(U.map(Z=>this.k(Z,!0,F.token)));return!T.isCancellationRequested&&!B.some(Z=>Z.error)&&await new Promise(Z=>T.onCancellationRequested(Z)),F.dispose(!0),B}async k(U,T,F){const B=this.d.get(U.controllerId);if(!B)return{};const{collection:Z,profiles:_}=B,H=_.get(U.profileId);if(!H)return{};const Y=U.testIds.map(J=>Z.tree.get(J)).filter(P.isDefined),ie=U.excludeExtIds.map(J=>B.collection.tree.get(J)).filter(P.isDefined).filter(J=>Y.some(ee=>ee.fullId.compare(J.fullId)===2));if(!Y.length)return{};const ge=new u.TestRunRequest2(Y.some(J=>J.actual instanceof f.TestItemRootImpl)?void 0:Y.map(J=>J.actual),ie.map(J=>J.actual),H,T),X=(0,C.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(ge,h.fromInternal(U,B.collection),F);try{return await H.runHandler(ge,F),{}}catch(J){return{error:String(J)}}finally{X&&(X.hasRunningTasks&&!F.isCancellationRequested&&await S.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};r=xe([ze(0,D.IExtHostRpcService)],r),e.ExtHostTesting=r;const a=1e4;var c;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(c||(c={}));class g extends I.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,T,F){super(),this.k=U,this.l=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new S.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(F));const B=this.B(new L.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const T=this.k.id,F=this.k.controllerId,B=(0,v.generateUuid)(),Z=new E(this.l,T,B),_=ge=>(X,...J)=>{if(Y){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),ge(X,...J))},H=(ge,X)=>{const J=X instanceof Array?X.map(d.TestMessage.from):[d.TestMessage.from(X)];if(ge.uri&&ge.range){const ee={range:d.Range.from(ge.range),uri:ge.uri};for(const me of J)me.location=me.location||ee}this.l.$appendTestMessagesInRun(T,B,m.TestId.fromExtHostTestItem(ge,F).toString(),J)};let Y=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return Z.coverageProvider},set coverageProvider(ge){Z.coverageProvider=ge},enqueued:_(ge=>{this.l.$updateTestStateInRun(T,B,m.TestId.fromExtHostTestItem(ge,F).toString(),1)}),skipped:_(ge=>{this.l.$updateTestStateInRun(T,B,m.TestId.fromExtHostTestItem(ge,F).toString(),5)}),started:_(ge=>{this.l.$updateTestStateInRun(T,B,m.TestId.fromExtHostTestItem(ge,F).toString(),2)}),errored:_((ge,X,J)=>{H(ge,X),this.l.$updateTestStateInRun(T,B,m.TestId.fromExtHostTestItem(ge,F).toString(),6,J)}),failed:_((ge,X,J)=>{H(ge,X),this.l.$updateTestStateInRun(T,B,m.TestId.fromExtHostTestItem(ge,F).toString(),4,J)}),passed:_((ge,X)=>{this.l.$updateTestStateInRun(T,B,m.TestId.fromExtHostTestItem(ge,this.k.controllerId).toString(),3,X)}),appendOutput:(ge,X,J)=>{Y||(J&&(this.k.isIncluded(J)?this.s(J):J=void 0),this.l.$appendOutputToRun(T,B,l.VSBuffer.fromString(ge),X&&d.location.from(X),J&&m.TestId.fromExtHostTestItem(J,F).toString()))},end:()=>{Y||(Y=!0,this.l.$finishedTestRunTask(T,B),this.f.delete(B),this.f.size||this.p())}};return this.f.set(B,{run:ie,coverage:Z}),this.l.$startedTestRunTask(T,{id:B,name:U,running:!0}),ie}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof f.TestItemImpl))throw new b.InvalidTestItemError(U.id);if(this.g.has(m.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const T=[],F=this.k.colllection.root;for(;;){const B=d.TestItem.from(U);if(T.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),U===F))break;U=U.parent||F}this.l.$addTestsToRun(this.k.controllerId,this.k.id,T)}}class i{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,T,F){return this.f(U,T,F)}cancelRunById(U){for(const T of this.c.values())if(T.id===U){T.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,T,F,B,Z){const _=this.c.get(F);if(_)return _.createRun(B);const H=h.fromPublic(U,T,F,Z),Y=t(F);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!F.continuous,profile:Y&&{group:Q[Y.kind],id:Y.profileId},exclude:F.exclude?.map(ge=>m.TestId.fromExtHostTestItem(ge,T.root.id).toString())??[],id:H.id,include:F.include?.map(ge=>m.TestId.fromExtHostTestItem(ge,T.root.id).toString())??[T.root.id],persist:Z});const ie=this.f(F,H);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(H.id),ie.dispose()}),ie.createRun(B)}f(U,T,F){const B=new g(T,this.d,F);return this.c.set(U,B),B.onEnd(()=>this.c.delete(U)),B}}e.TestRunCoordinator=i;const t=q=>{if(!!q.profile){if(!(q.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class h{static fromPublic(U,T,F,B){return new h(U,(0,v.generateUuid)(),F.include?.map(Z=>m.TestId.fromExtHostTestItem(Z,U).toString())??[U],F.exclude?.map(Z=>m.TestId.fromExtHostTestItem(Z,U).toString())??[],B,T)}static fromInternal(U,T){return new h(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,T)}constructor(U,T,F,B,Z,_){this.controllerId=U,this.id=T,this.isPersisted=Z,this.colllection=_,this.c=F.map(H=>H+"\0"),this.d=B.map(H=>H+"\0")}isIncluded(U){const T=m.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.d)if(T===F||T.startsWith(F))return!1;for(const F of this.c)if(T===F||T.startsWith(F))return!0;return!1}}e.TestRunDto=h;class E{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,T,F){this.f=U,this.g=T,this.h=F}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(T){throw this.d=void 0,T}}async resolveFileCoverage(U,T){const F=await this.d;let B=F?.[U];return!this.c||!F||!B?[]:(B.detailedCoverage||(B=F[U]=await this.c.resolveFileCoverage?.(B,T)??B),B.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class w{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,d.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const T=m.TestId.parentId(U.item.extId);if(T&&this.g.has(T.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:T,f:F}=this;return{get added(){return[...U].map(B=>B.revived)},get updated(){return[...T].map(B=>B.revived)},get removed(){return[...F].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class N extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new S.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,T){return{...U,revived:d.TestItem.toPlain(U.item),depth:T?T.depth+1:0,children:new Set}}o(){return new w(this.q)}}class j{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(T=>T.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new N;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class V{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?d.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ue(this,n,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,T,F,B,Z,_,H,Y=!1,ie=void 0,ge=!1){this.controllerId=F,this.profileId=B,this.d=Z,this.kind=_,this.runHandler=H,this.f=Y,this._tag=ie,this.g=ge,n.set(this,void 0),s.set(this,void 0),_e(this,n,U,"f"),_e(this,s,T,"f"),T.set(B,this);const X=Q[_];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);Ue(this,n,"f").$publishTestRunProfile({profileId:B,controllerId:F,tag:ie?d.TestTag.namespace(this.controllerId,ie.id):null,label:Z,group:X,isDefault:Y,hasConfigurationHandler:!1,supportsContinuousRun:ge})}dispose(){Ue(this,s,"f")?.delete(this.profileId)&&(_e(this,s,void 0,"f"),Ue(this,n,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=V,n=new WeakMap,s=new WeakMap;const Q={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(ye[276],De([1,0,15,3,5,138,14,7]),function(re,e,o,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,P){this.i=P,this.a=new L.Emitter,this.b=new L.Emitter,this.c=new L.Emitter,this.d=new L.Emitter,this.f=new L.Emitter,this.g=new L.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(l.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const P=this.i.allEditors();return O?P:P.map(v=>v.value)}async showTextDocument(O,P,v){let k;typeof P=="number"?k={position:S.ViewColumn.from(P),preserveFocus:v}:typeof P=="object"?k={position:S.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?S.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:k={preserveFocus:!1};const D=await this.h.$tryShowTextDocument(O.uri,k),f=D&&this.i.getEditor(D);if(f)return f.value;throw D?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,P){return new R.TextEditorDecorationType(this.h,O,P).value}$acceptEditorPropertiesChanged(O,P){const v=this.i.getEditor(O);if(!v)throw new Error("unknown text editor");if(P.options&&v._acceptOptions(P.options),P.selections){const k=P.selections.selections.map(S.Selection.to);v._acceptSelections(k)}if(P.visibleRanges){const k=o.coalesce(P.visibleRanges.map(S.Range.to));v._acceptVisibleRanges(k)}if(P.options&&this.b.fire({textEditor:v.value,options:{...P.options,lineNumbers:S.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const k=A.TextEditorSelectionChangeKind.fromValue(P.selections.source),D=P.selections.selections.map(S.Selection.to);this.a.fire({textEditor:v.value,selections:D,kind:k})}if(P.visibleRanges){const k=o.coalesce(P.visibleRanges.map(S.Range.to));this.c.fire({textEditor:v.value,visibleRanges:k})}}$acceptEditorPositionData(O){for(const P in O){const v=this.i.getEditor(P);if(!v)throw new Error("Unknown text editor");const k=S.ViewColumn.to(O[P]);v.value.viewColumn!==k&&(v._acceptViewColumn(k),this.d.fire({textEditor:v.value,viewColumn:k}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(ye[277],De([1,0,2,4,5,6,7,14,27,9]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class O{constructor(k,D){this.b=new Map,this.c=new Map,this.a=k.getProxy(l.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&y.ExtensionIdentifier.equals(d,this.b.get(f.source)?.extension)){const u=f.uri===void 0?void 0:o.URI.revive(f.uri);return this.c.get(f.source)?.get(P(u))?.get(f.handle)}else return;return f}})}async $getTimeline(k,D,f,d){return this.b.get(k)?.provider.provideTimeline(o.URI.revive(D),f,d)}registerTimelineProvider(k,D,f,d){const u=new R.DisposableStore,m=this.d(D.id,d,u).bind(this);let b;D.onDidChange&&(b=D.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:D.id}),this));const C=this.c;return this.f({...D,scheme:k,onDidChange:void 0,async provideTimeline(p,n,s){n?.resetCache&&(u.clear(),C.get(D.id)?.clear());const r=await D.provideTimeline(p,n,s);if(r==null)return;const a=m(p,n);return{...r,source:D.id,items:r.items.map(a)}},dispose(){for(const p of C.values())p.get(D.id)?.clear();b?.dispose(),u.dispose()}},f)}d(k,D,f){return(d,u)=>{let m;if(u?.cacheResults){let b=this.c.get(k);b===void 0&&(b=new Map,this.c.set(k,b));const C=P(d);m=b.get(C),m===void 0&&(m=new Map,b.set(C,m))}return b=>{const{iconPath:C,...p}=b,n=`${k}|${b.id??b.timestamp}`;m?.set(n,b);let s,r,a;b.iconPath&&(C instanceof S.ThemeIcon?a={id:C.id,color:C.color}:o.URI.isUri(C)?(s=C,r=C):{light:s,dark:r}=C);let c;return S.MarkdownString.isMarkdownString(p.tooltip)?c=A.MarkdownString.from(p.tooltip):(0,I.isString)(p.tooltip)?c=p.tooltip:S.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=A.MarkdownString.from(p.detail)):(0,I.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=p.detail),{...p,id:p.id??void 0,handle:n,source:k,command:b.command?D.toInternal(b.command,f):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:c,accessibilityInformation:b.accessibilityInformation}}}}f(k,D){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:D}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.ExtHostTimeline=O;function P(v){return v?.toString()}}),define(ye[278],De([1,0,6,16,2,5]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,I,O,P){if(this.c.has(I))throw new Error(`Opener with id '${I}' already registered`);const v=P.schemes.find(k=>!S.a.has(k));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(I,O),this.b.$registerUriOpener(I,P.schemes,y,P.label),(0,o.toDisposable)(()=>{this.c.delete(I),this.b.$unregisterUriOpener(I)})}async $canOpenUri(y,I,O){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const v=l.URI.revive(I);return P.canOpenExternalUri(v,O)}async $openUri(y,I,O){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(l.URI.revive(I.resolvedUri),{sourceUri:l.URI.revive(I.sourceUri)},O)}}S.a=new Set([L.Schemas.http,L.Schemas.https]),e.ExtHostUriOpeners=S}),define(ye[279],De([1,0,5,2,6,10,27]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(I){this.c=new Set,this.d=new Map,this.b=I.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(I,O){if(this.c.has(S.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const P=A.a++;return this.c.add(S.ExtensionIdentifier.toKey(I)),this.d.set(P,O),this.b.$registerUriHandler(P,I),(0,l.toDisposable)(()=>{this.c.delete(S.ExtensionIdentifier.toKey(I)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(I,O){const P=this.d.get(I);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(O))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(I){return L.URI.revive(await this.b.$createAppUri(I))}}A.a=0,e.ExtHostUrls=A});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[80],De([1,0,3,16,23,2,199,224,95,5]),function(re,e,o,L,l,R,S,A,y,I){"use strict";var O,P,v,k,D,f,d,u,m,b,C,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(w,N,j,V,Q,q,U){O.set(this,void 0),P.set(this,void 0),v.set(this,void 0),k.set(this,void 0),D.set(this,void 0),f.set(this,void 0),d.set(this,""),u.set(this,void 0),m.set(this,!1),b.set(this,!1),C.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,n.set(this,new o.Emitter),this._onDidDispose=Ue(this,n,"f").event,_e(this,O,w,"f"),_e(this,P,N,"f"),_e(this,u,j,"f"),_e(this,k,V,"f"),_e(this,D,Q,"f"),_e(this,f,q,"f"),_e(this,C,r(q),"f"),_e(this,p,a(q),"f"),_e(this,v,U,"f")}dispose(){_e(this,m,!0,"f"),Ue(this,n,"f").fire(),Ue(this,n,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return _e(this,b,!0,"f"),(0,y.asWebviewUri)(w,Ue(this,k,"f"))}get cspSource(){const w=Ue(this,f,"f").extensionLocation;if(w.scheme===L.Schemas.https||w.scheme===L.Schemas.http){let N=w.toString();return N.endsWith("/")||(N+="/"),N+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ue(this,d,"f")}set html(w){this.a(),Ue(this,d,"f")!==w&&(_e(this,d,w,"f"),Ue(this,p,"f")&&!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(_e(this,b,!0,"f"),Ue(this,v,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,O,"f"),this.b(w)))}get options(){return this.a(),Ue(this,u,"f")}set options(w){this.a(),l.equals(Ue(this,u,"f"),w)||Ue(this,P,"f").$setOptions(Ue(this,O,"f"),i(Ue(this,f,"f"),Ue(this,D,"f"),w)),_e(this,u,w,"f")}async postMessage(w){if(Ue(this,m,"f"))return!1;const N=(0,A.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Ue(this,C,"f")});return Ue(this,P,"f").$postMessage(Ue(this,O,"f"),N.message,...N.buffers)}a(){if(Ue(this,m,"f"))throw new Error("Webview is disposed")}b(w){if(!Ue(this,p,"f"))return w;const N=Ue(this,f,"f").extensionLocation?.scheme===L.Schemas.vscodeRemote,j=Ue(this,f,"f").extensionLocation.scheme===L.Schemas.vscodeRemote?Ue(this,f,"f").extensionLocation.authority:void 0;return w.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,q,U,T,F)=>{const B=R.URI.from({scheme:U||"file",path:decodeURIComponent(T)}),Z=(0,y.asWebviewUri)(B,{isRemote:N,authority:j}).toString();return`${Q}${Z}${F}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,q,U,T,F)=>{const B=R.URI.from({scheme:U||"file",path:decodeURIComponent(T)}),Z=(0,y.asWebviewUri)(B,{isRemote:N,authority:j}).toString();return`${Q}${Z}${F}`})}}e.ExtHostWebview=s,O=new WeakMap,P=new WeakMap,v=new WeakMap,k=new WeakMap,D=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap,b=new WeakMap,C=new WeakMap,p=new WeakMap,n=new WeakMap;function r(E){try{const w=(0,S.normalizeVersion)((0,S.parseVersion)(E.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function a(E){try{const w=(0,S.normalizeVersion)((0,S.parseVersion)(E.engines.vscode));return w?w.majorBase<1||w.majorBase===1&&w.minorBase<60:!1}catch{return!1}}class c{constructor(w,N,j,V,Q){this.c=N,this.d=j,this.e=V,this.f=Q,this.b=new Map,this.a=w.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(w,N,j){const V=this.g(w);if(V){const{message:Q}=(0,A.deserializeWebviewMessage)(N,j.value);V._onMessageEmitter.fire(Q)}}$onMissingCsp(w,N){this.e.warn(`${N} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,N,j){const V=new s(w,this.a,t(N),this.c,this.d,j,this.f);return this.b.set(w,V),V._onDidDispose(()=>{this.b.delete(w)}),V}deleteWebview(w){this.b.delete(w)}g(w){return this.b.get(w)}}e.ExtHostWebviews=c;function g(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=g;function i(E,w,N){return{enableCommandUris:N.enableCommandUris,enableScripts:N.enableScripts,enableForms:N.enableForms,portMapping:N.portMapping,localResourceRoots:N.localResourceRoots||h(E,w)}}e.serializeWebviewOptions=i;function t(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(w=>R.URI.from(w))}}function h(E,w){return[...(w?.getWorkspaceFolders()||[]).map(N=>N.uri),E.extensionLocation]}}),define(ye[280],De([1,0,21,88,6,16,24,2,14,80,74,5,7]),function(re,e,o,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(s,r){this.document=s,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,r){await this.f(s).undo(),r||this.disposeBackup()}async redo(s,r){await this.f(s).redo(),r||this.disposeBackup()}disposeEdits(s){for(const r of s)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=p(this.document.uri)+this.a++;return(0,S.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const r=this.c.get(s,0);if(!r)throw new Error("No edit found");return r}}class D{constructor(){this.a=new Map}get(s,r){return this.a.get(this.b(s,r))}add(s,r,a){const c=this.b(s,r.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${s} resource:${r.uri}`);const g=new k(r,a);return this.a.set(c,g),g}delete(s,r){const a=this.b(s,r.uri);this.a.delete(a)}b(s,r){return`${s}@@@${r}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this.a=new Map}addTextProvider(s,r,a){return this.b(0,s,r,a)}addCustomProvider(s,r,a){return this.b(1,s,r,a)}get(s){return this.a.get(s)}b(s,r,a,c){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:s,extension:a,provider:c}),new v.Disposable(()=>this.a.delete(r))}}class u{constructor(s,r,a,c,g){this.d=r,this.f=a,this.g=c,this.h=g,this.b=new d,this.c=new D,this.a=s.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,r,a,c){const g=new l.DisposableStore;return b(a)?(g.add(this.b.addTextProvider(r,s,a)),this.a.$registerTextEditorProvider((0,I.toExtensionData)(s),r,c.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(s))):(g.add(this.b.addCustomProvider(r,s,a)),m(a)&&g.add(a.onDidChangeCustomDocument(i=>{const t=this.i(r,i.document.uri);if(C(i)){const h=t.addEdit(i);this.a.$onDidEdit(i.document.uri,r,h,i.label)}else this.a.$onContentChange(i.document.uri,r)})),this.a.$registerCustomEditorProvider((0,I.toExtensionData)(s),r,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(s))),v.Disposable.from(g,new v.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(s,r,a,c,g){const i=this.b.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(i.type!==1)throw new Error(`Invalid provide type for '${r}'`);const t=A.URI.revive(s),h=await i.provider.openCustomDocument(t,{backupId:a,untitledDocumentData:c?.buffer},g);let E;return m(i.provider)&&this.f&&(E=this.f.workspaceValue(i.extension)??this.f.globalValue(i.extension)),this.c.add(r,h,E),{editable:m(i.provider)}}async $disposeCustomDocument(s,r){const a=this.b.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const c=A.URI.revive(s),{document:g}=this.i(r,c);this.c.delete(r,g),g.dispose()}async $resolveCustomEditor(s,r,a,c,g,i){const t=this.b.get(a);if(!t)throw new Error(`No provider found for '${a}'`);const h=y.ViewColumn.to(g),E=this.g.createNewWebview(r,c.contentOptions,t.extension),w=this.h.createNewWebviewPanel(r,a,c.title,h,c.options,E,!0),N=A.URI.revive(s);switch(t.type){case 1:{const{document:j}=this.i(a,N);return t.provider.resolveCustomEditor(j,w,i)}case 0:{const j=this.d.getDocument(N);return t.provider.resolveCustomTextEditor(j,w,i)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,r,a){this.i(r,s).disposeEdits(a)}async $onMoveCustomEditor(s,r,a){const c=this.b.get(a);if(!c)throw new Error(`No provider found for '${a}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const g=this.h.getWebviewPanel(s);if(!g)throw new Error("No webview found");const i=A.URI.revive(r),t=this.d.getDocument(i);await c.provider.moveCustomTextEditor(t,g,o.CancellationToken.None)}async $undo(s,r,a,c){return this.i(r,s).undo(a,c)}async $redo(s,r,a,c){return this.i(r,s).redo(a,c)}async $revert(s,r,a){const c=this.i(r,s);await this.j(r).revertCustomDocument(c.document,a),c.disposeBackup()}async $onSave(s,r,a){const c=this.i(r,s);await this.j(r).saveCustomDocument(c.document,a),c.disposeBackup()}async $onSaveAs(s,r,a,c){const g=this.i(r,s);return this.j(r).saveCustomDocumentAs(g.document,A.URI.revive(a),c)}async $backup(s,r,a){const c=this.i(r,s),i=await this.j(r).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},a);return c.updateBackup(i),i.id}i(s,r){const a=this.c.get(s,A.URI.revive(r));if(!a)throw new Error("No custom document found");return a}j(s){const a=this.b.get(s)?.provider;if(!a||!m(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=u;function m(n){return!!n.onDidChangeCustomDocument}function b(n){return typeof n.resolveCustomTextEditor=="function"}function C(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function p(n){const s=n.scheme===R.Schemas.file||n.scheme===R.Schemas.untitled?n.fsPath:n.toString();return(0,L.hash)(s)+""}});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[281],De([1,0,3,6,2,30,14,80,5,7]),function(re,e,o,L,l,R,S,A,y,I){"use strict";var O,P,v,k,D,f,d,u,m,b,C,p,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends L.Disposable{constructor(g,i,t,h){super(),O.set(this,void 0),P.set(this,void 0),v.set(this,void 0),k.set(this,void 0),D.set(this,void 0),f.set(this,void 0),d.set(this,void 0),u.set(this,void 0),m.set(this,!0),b.set(this,void 0),C.set(this,!1),p.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,p,"f").event,n.set(this,this.B(new o.Emitter)),this.onDidChangeViewState=Ue(this,n,"f").event,_e(this,O,g,"f"),_e(this,P,i,"f"),_e(this,k,t,"f"),_e(this,v,h.viewType,"f"),_e(this,D,h.panelOptions,"f"),_e(this,u,h.viewColumn,"f"),_e(this,f,h.title,"f"),_e(this,b,h.active,"f")}dispose(){Ue(this,C,"f")||(_e(this,C,!0,"f"),Ue(this,p,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,O,"f")),Ue(this,k,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,k,"f")}get viewType(){return this.c(),Ue(this,v,"f")}get title(){return this.c(),Ue(this,f,"f")}set title(g){this.c(),Ue(this,f,"f")!==g&&(_e(this,f,g,"f"),Ue(this,P,"f").$setTitle(Ue(this,O,"f"),g))}get iconPath(){return this.c(),Ue(this,d,"f")}set iconPath(g){this.c(),Ue(this,d,"f")!==g&&(_e(this,d,g,"f"),Ue(this,P,"f").$setIconPath(Ue(this,O,"f"),l.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ue(this,D,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,u,"f")=="number"&&Ue(this,u,"f")<0))return Ue(this,u,"f")}get active(){return this.c(),Ue(this,b,"f")}get visible(){return this.c(),Ue(this,m,"f")}_updateViewState(g){Ue(this,C,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(_e(this,b,g.active,"f"),_e(this,m,g.visible,"f"),_e(this,u,g.viewColumn,"f"),Ue(this,n,"f").fire({webviewPanel:this}))}reveal(g,i){this.c(),Ue(this,P,"f").$reveal(Ue(this,O,"f"),{viewColumn:typeof g>"u"?void 0:S.ViewColumn.from(g),preserveFocus:!!i})}c(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,P=new WeakMap,v=new WeakMap,k=new WeakMap,D=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap,b=new WeakMap,C=new WeakMap,p=new WeakMap,n=new WeakMap;class r{static c(){return(0,R.generateUuid)()}constructor(g,i,t){this.g=i,this.h=t,this.e=new Map,this.f=new Map,this.d=g.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(g,i,t,h,E={}){const w=typeof h=="object"?h.viewColumn:h,N={viewColumn:S.ViewColumn.from(w),preserveFocus:typeof h=="object"&&!!h.preserveFocus},j=(0,A.shouldSerializeBuffersForPostMessage)(g),V=r.c();this.d.$createWebviewPanel((0,A.toExtensionData)(g),V,i,{title:t,panelOptions:a(E),webviewOptions:(0,A.serializeWebviewOptions)(g,this.h,E),serializeBuffersForPostMessage:j},N);const Q=this.g.createNewWebview(V,E,g);return this.createNewWebviewPanel(V,i,t,w,E,Q,!0)}$onDidChangeWebviewPanelViewStates(g){const i=Object.keys(g);i.sort((t,h)=>{const E=g[t],w=g[h];return E.active?1:w.active?-1:+E.visible-+w.visible});for(const t of i){const h=this.getWebviewPanel(t);if(!h)continue;const E=g[t];h._updateViewState({active:E.active,visible:E.visible,viewColumn:S.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.e.delete(g),this.g.deleteWebview(g)}registerWebviewPanelSerializer(g,i,t){if(this.f.has(i))throw new Error(`Serializer for '${i}' already registered`);return this.f.set(i,{serializer:t,extension:g}),this.d.$registerSerializer(i,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(g)}),new I.Disposable(()=>{this.f.delete(i),this.d.$unregisterSerializer(i)})}async $deserializeWebviewPanel(g,i,t,h){const E=this.f.get(i);if(!E)throw new Error(`No serializer found for '${i}'`);const{serializer:w,extension:N}=E,j=this.g.createNewWebview(g,t.webviewOptions,N),V=this.createNewWebviewPanel(g,i,t.title,h,t.panelOptions,j,t.active);await w.deserializeWebviewPanel(V,t.state)}createNewWebviewPanel(g,i,t,h,E,w,N){const j=new s(g,this.d,w,{viewType:i,title:t,viewColumn:h,panelOptions:E,active:N});return this.e.set(g,j),j}getWebviewPanel(g){return this.e.get(g)}}e.ExtHostWebviewPanels=r;function a(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[282],De([1,0,3,6,80,14,5,7]),function(re,e,o,L,l,R,S,A){"use strict";var y,I,O,P,v,k,D,f,d,u,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends L.Disposable{constructor(n,s,r,a,c,g){super(),y.set(this,void 0),I.set(this,void 0),O.set(this,void 0),P.set(this,void 0),v.set(this,!1),k.set(this,void 0),D.set(this,void 0),f.set(this,void 0),d.set(this,void 0),u.set(this,this.B(new o.Emitter)),this.onDidChangeVisibility=Ue(this,u,"f").event,m.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,m,"f").event,_e(this,O,r,"f"),_e(this,D,a,"f"),_e(this,y,n,"f"),_e(this,I,s,"f"),_e(this,P,c,"f"),_e(this,k,g,"f")}dispose(){Ue(this,v,"f")||(_e(this,v,!0,"f"),Ue(this,m,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,D,"f")}set title(n){this.a(),Ue(this,D,"f")!==n&&(_e(this,D,n,"f"),Ue(this,I,"f").$setWebviewViewTitle(Ue(this,y,"f"),n))}get description(){return this.a(),Ue(this,f,"f")}set description(n){this.a(),Ue(this,f,"f")!==n&&(_e(this,f,n,"f"),Ue(this,I,"f").$setWebviewViewDescription(Ue(this,y,"f"),n))}get visible(){return Ue(this,k,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,O,"f")}_setVisible(n){n===Ue(this,k,"f")||Ue(this,v,"f")||(_e(this,k,n,"f"),Ue(this,u,"f").fire())}get badge(){return this.a(),Ue(this,d,"f")}set badge(n){this.a(),!(n?.value===Ue(this,d,"f")?.value&&n?.tooltip===Ue(this,d,"f")?.tooltip)&&(_e(this,d,R.ViewBadge.from(n),"f"),Ue(this,I,"f").$setWebviewViewBadge(Ue(this,y,"f"),n))}show(n){this.a(),Ue(this,I,"f").$show(Ue(this,y,"f"),!!n)}a(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,I=new WeakMap,O=new WeakMap,P=new WeakMap,v=new WeakMap,k=new WeakMap,D=new WeakMap,f=new WeakMap,d=new WeakMap,u=new WeakMap,m=new WeakMap;class C{constructor(n,s){this.d=s,this.b=new Map,this.c=new Map,this.a=n.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,s,r,a){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:r,extension:n}),this.a.$registerWebviewViewProvider((0,l.toExtensionData)(n),s,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(n)}),new A.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(n,s,r,a,c){const g=this.b.get(s);if(!g)throw new Error(`No view provider found for '${s}'`);const{provider:i,extension:t}=g,h=this.d.createNewWebview(n,{},t),E=new b(n,this.a,s,r,h,!0);this.c.set(n,E),await i.resolveWebviewView(E,{state:a},c)}async $onDidChangeWebviewViewVisibility(n,s){this.e(n)._setVisible(s)}async $disposeWebviewView(n){const s=this.e(n);this.c.delete(n),s.dispose(),this.d.deleteWebview(n)}e(n){const s=this.c.get(n);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=C}),define(ye[141],De([1,0,3,5,2,16,8,4,20]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this.d}constructor(P){this.c=new o.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=P.getProxy(L.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,v){let k;if(typeof P=="string"){k=P;try{P=l.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,S.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,k,v)}async asExternalUri(P,v){if((0,S.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this.b.$asExternalUri(P,v);return l.URI.from(k)}};I.a={focused:!0},I=xe([ze(0,y.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[283],De([1,0,119,284,70,40,2,13,47]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(v,k,D){this.b=v,this.c=k,this.f=D,this.a=L.createServer((f,d)=>this.h(f,d)),this.g().catch(f=>(k.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,k){const D=(d,u)=>{k.writeHead(d,{"content-type":"application/json"}),k.end(JSON.stringify(u||null),m=>m&&this.c.error(m))},f=[];v.setEncoding("utf8"),v.on("data",d=>f.push(d)),v.on("end",async()=>{try{const d=JSON.parse(f.join(""));let u;switch(d.type){case"open":u=await this.i(d);break;case"openExternal":u=await this.j(d);break;case"status":u=await this.l(d);break;case"extensionManagement":u=await this.k(d);break;default:D(404,`Unknown message type: ${d.type}`);break}D(200,u)}catch(d){const u=d instanceof Error?d.message:JSON.stringify(d);D(500,u),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:k,folderURIs:D,forceNewWindow:f,diffMode:d,mergeMode:u,addMode:m,forceReuseWindow:b,gotoLineMode:C,waitMarkerFilePath:p,remoteAuthority:n}=v,s=[];if(Array.isArray(D))for(const g of D)try{s.push({folderUri:S.URI.parse(g)})}catch{}if(Array.isArray(k))for(const g of k)try{(0,y.hasWorkspaceFileExtension)(g)?s.push({workspaceUri:S.URI.parse(g)}):s.push({fileUri:S.URI.parse(g)})}catch{}const r=p?S.URI.file(p):void 0,c={forceNewWindow:f,diffMode:d,mergeMode:u,addMode:m,gotoLineMode:C,forceReuseWindow:b,preferNewWindow:!b&&!r&&!m,waitMarkerFileURI:r,remoteAuthority:n};return this.b.executeCommand("_remoteCLI.windowOpen",s,c),""}async j(v){for(const k of v.uris){const D=S.URI.parse(k),f=D.scheme==="file"?D:k;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(v){const k=f=>f?.map(d=>/\.vsix$/i.test(d)?S.URI.parse(d):d),D={list:v.list,install:k(v.install),uninstall:k(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=I;let O=class extends I{constructor(v,k){super(v,k,(0,o.createRandomIPCHandle)())}};O=xe([ze(0,R.IExtHostCommands),ze(1,A.ILogService)],O),e.CLIServer=O}),define(ye[285],De([1,0,255,25,20]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let S=class extends o.AbstractExtHostConsoleForwarder{constructor(y,I){super(y,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,I,O){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),I.apply(console,O),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,I){const O=process[y],P=O.write;let v="";Object.defineProperty(O,"write",{set:()=>{},get:()=>(k,D,f)=>{if(!this.g){v+=k.toString(D);const d=v.length>R?v.length:v.lastIndexOf(`
`);d!==-1&&(console[I](v.slice(0,d)),v=v.slice(d+1))}P.call(O,k,D,f)}})}};S=xe([ze(0,l.IExtHostRpcService),ze(1,L.IExtHostInitDataService)],S),e.ExtHostConsoleForwarder=S}),define(ye[286],De([1,0,12,89,30,40,6,5,2,20]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let O=class extends S.Disposable{constructor(v,k){super();const D=v.getProxy(A.MainContext.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=y.URI.file((0,o.join)((0,L.tmpdir)(),(0,l.generateUuid)()));return await D.$download(f,d),d})}};O=xe([ze(0,I.IExtHostRpcService),ze(1,R.IExtHostCommands)],O),e.ExtHostDownloadService=O}),define(ye[287],De([1,0,140,16,206,30]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class S extends o.ExtHostLoggerService{k(y,I,O){return y.scheme===L.Schemas.file?new l.SpdLogLogger(O?.name||(0,R.generateUuid)(),y.fsPath,!O?.donotRotate,!!O?.donotUseFormatters,I):super.k(y,I,O)}registerLogger(y){super.registerLogger(y),this.l.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.l.$deregisterLogger(y)}}e.ExtHostLoggerService=S}),define(ye[288],De([1,0,70,12,2,79,6,16,19,29]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class O extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(n){const s=await super.g(n);if(s.scheme!==A.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const r=s.fsPath;let a=0;do{let c;a===0?c=r:c=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${a}`:`${r}-${a}`,await P(c);const g=L.join(c,"vscode.lock"),i=await f(this.d,g,!1);if(i)return this.i=i,process.on("exit",()=>{i.dispose()}),l.URI.file(c);a++}while(a<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=O;async function P(p){try{await I.Promises.stat(p);return}catch{}try{await I.Promises.mkdir(p,{recursive:!0})}catch{}}const v=1e3,k=10*60*1e3;class D extends S.Disposable{constructor(n,s){super(),this.b=n,this.c=s,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await d(n,s);(!r||r.pid!==process.pid)&&(n.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await I.Promises.utimes(s,new Date,new Date)}catch(a){n.error(a),n.info(`Lock '${s}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(n){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+n};await I.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function f(p,n,s){try{const a={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(n,JSON.stringify(a),{flag:"wx"})}catch(a){p.error(a)}const r=await d(p,n);return!r||r.pid!==process.pid?s?(p.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),b(p,n)):(p.info(`Lock '${n}': Lock acquired.`),new D(p,n))}async function d(p,n){let s;try{s=await I.Promises.readFile(n)}catch(r){return p.error(r),null}try{return JSON.parse(String(s))}catch(r){return p.error(r),null}}async function u(p,n){let s;try{s=await I.Promises.stat(n)}catch(r){return p.error(r),0}return s.mtime.getTime()}function m(p){try{return process.kill(p,0),!0}catch{return!1}}async function b(p,n){const s=await d(p,n);if(!s)return p.info(`Lock '${n}': Could not read pid of lock holder.`),C(p,n);if(s.willReleaseAt){let i=s.willReleaseAt-Date.now();if(i<5e3){for(i>0?p.info(`Lock '${n}': The lockfile is scheduled to be released in ${i} ms.`):p.info(`Lock '${n}': The lockfile is scheduled to have been released.`);i>0;){if(await(0,y.timeout)(Math.min(100,i)),await u(p,n)===0)return C(p,n);i=s.willReleaseAt-Date.now()}return C(p,n)}}if(!m(s.pid))return p.info(`Lock '${n}': The pid ${s.pid} appears to be gone.`),C(p,n);const r=await u(p,n),a=Date.now()-r;if(a<=k)return p.info(`Lock '${n}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;p.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const c=await u(p,n),g=Date.now()-c;return g<=k?(p.info(`Lock '${n}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(p.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),C(p,n))}async function C(p,n){p.info(`Lock '${n}': Deleting a stale lock.`);try{await I.Promises.unlink(n)}catch{}return f(p,n,!0)}}),define(ye[289],De([1,0,30,20,41]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends l.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,I){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:I})}createTerminalFromOptions(A,y){const I=new l.ExtHostTerminal(this.a,(0,o.generateUuid)(),A,A.name);return this.f.push(I),I.create(A,this.L(A,y)),I.value}};R=xe([ze(0,L.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[290],De([1,0,5,20,186,6,25,2,46,24,29,7,11,55,3,129,102,13]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class m extends f.DisposableTunnel{}function b(i){const t=i.trim().split(`
`),h=[];return t.forEach(w=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);N&&N.length>=3&&h.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),h.reduce((w,N)=>(w[N.socket]=N,w),{})}e.getSockets=b;function C(...i){const t=[].concat(...i.map(n));return[...new Map(t.filter(h=>h.st==="0A").map(h=>{const E=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:p(E[0]),port:parseInt(E[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=C;function p(i){let t="";if(i.length===8)for(let h=i.length-2;h>=0;h-=2)t+=parseInt(i.substr(h,2),16),h!==0&&(t+=".");else for(let h=i.length-4;h>=0;h-=4)t+=parseInt(i.substr(h,4),16).toString(16),h!==0&&(t+=":");return t}function n(i){const t=i.trim().split(`
`),h=t.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return t.map(w=>w.trim().split(/\s+/).reduce((N,j,V)=>(N[h[V]||V]=j,N),{}))}e.loadConnectionTable=n;function s(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function r(i){const t=i.trim().split(`
`),h=[];return t.forEach(E=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);w&&w.length>=4&&h.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),h}e.getRootProcesses=r;async function a(i,t,h){const E=h.reduce((N,j)=>(N[j.pid]=j,N),{}),w=[];return i.forEach(({socket:N,ip:j,port:V})=>{const Q=t[N]?t[N].pid:void 0,q=Q?E[Q]?.cmd:void 0;Q&&q&&!s(q)&&w.push({host:j,port:V,detail:q,pid:Q})}),w}e.findPorts=a;function c(i,t,h){const E=new Map,w=r(t);for(const N of i){const j=h.get(N.port);if(j){E.set(N.port,j);continue}const V=w.find(Q=>Q.cmd.includes(`${N.port}`));if(V){let Q=V,q;do q=w.find(U=>U.ppid===Q.pid),q&&(Q=q);while(q);E.set(N.port,{host:N.ip,port:N.port,pid:Q.pid,detail:Q.cmd,ppid:Q.ppid})}else E.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=c;let g=class extends R.Disposable{constructor(t,h,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new D.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=t.getProxy(o.MainContext.MainThreadTunnelService),v.isLinux&&h.remote.isRemote&&h.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(t,h){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const E=await this.a.$openTunnel(h,t.displayName);if(E){const w=new m(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(w),w}}async getTunnels(){return this.a.$getTunnels()}p(t){return Math.max(t*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(t,h){const E=this.r();return this.l.set(E,{selector:t,provider:h}),this.a.$registerPortsAttributesProvider(t,E),new P.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(t,h,E,w,N){const j=[];for(const Q of t){const q=this.l.get(Q);if(!q)return[];j.push(...await Promise.all(h.map(async U=>q.provider.providePortAttributes(U,E,w,N))))}const V=j.filter(Q=>!!Q);return V.length>0?V.map(Q=>({autoForwardAction:Q.autoForwardAction,port:Q.port})):[]}async $registerCandidateFinder(t){if(t&&this.h)return;this.h=t;const h=new d.MovingAverage;let E;for(;this.h;){const w=new Date().getTime(),N=(await this.findCandidatePorts()).filter(V=>(0,f.isLocalhost)(V.host)||(0,f.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(V=>V.port).join(", ")}`);const j=new Date().getTime()-w;h.update(j),(!E||JSON.stringify(E)!==JSON.stringify(N))&&(E=N,await this.a.$onFoundNewCandidates(E)),await new Promise(V=>setTimeout(()=>V(),this.p(h.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.c=t.showCandidatePort,this.a.$setCandidateFilter()),t.tunnelFactory){this.b=t.tunnelFactory;let h=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&h.length===0&&(h=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const E=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:h}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(t,h){if(this.f.has(t.host)){const E=this.f.get(t.host);E.has(t.port)&&(h&&E.get(t.port).disposeListener.dispose(),await E.get(t.port).tunnel.dispose(),E.delete(t.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(t,h){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(t,h);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const w=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(t.remoteAddress.host)||this.f.set(t.remoteAddress.host,new Map);const N=this.B(w.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(w.remoteAddress))));return this.f.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:w,disposeListener:N}),k.TunnelDtoConverter.fromApiTunnel(w)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const h=await Promise.all(t.map(w=>this.c(w.host,w.port,w.detail??""))),E=t.filter((w,N)=>h[N]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(w=>w.port).join(", ")} to ${E.map(w=>w.port).join(", ")}`),E}async findCandidatePorts(){let t="",h="";try{t=await O.Promises.readFile("/proc/net/tcp","utf8"),h=await O.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=C(t,h),w=await new Promise(F=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,Z,_)=>{F(Z)})}),N=b(w),j=await O.Promises.readdir("/proc"),V=[];for(const F of j)try{const B=Number(F),Z=I.joinPath(A.URI.file("/proc"),F);if((await O.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(B)){const H=await O.Promises.readlink(I.joinPath(Z,"cwd").fsPath),Y=await O.Promises.readFile(I.joinPath(Z,"cmdline").fsPath,"utf8");V.push({pid:B,cwd:H,cmd:Y})}}catch{}const Q=[],q=E.filter(F=>{const B=N[F.socket];return B||Q.push(F),B}),U=a(q,N,V);let T;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Q.length}`),Q.length>0){const F=await new Promise(B=>{(0,y.exec)("ps -F -A -l | grep root",(Z,_,H)=>{B(_)})});this.j=c(Q,F,this.j),T=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${T.map(B=>B.port).join(", ")}`)}return U.then(F=>T?F.concat(T):F)}};g=xe([ze(0,L.IExtHostRpcService),ze(1,S.IExtHostInitDataService),ze(2,u.ILogService)],g),e.ExtHostTunnelService=g}),define(ye[291],De([1,0,19,22,21,10,3,6,114,249,58]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(E,w){try{return JSON.stringify(E,w)}catch{return"null"}}const k="$$ref$$",D={[k]:-1};class f{constructor(w,N){this.jsonString=w,this.referencedBuffers=N}}function d(E,w=null,N=!1){const j=[];return{jsonString:(N?v:JSON.stringify)(E,(Q,q)=>{if(typeof q>"u")return D;if(typeof q=="object"){if(q instanceof L.VSBuffer){const U=j.push(q)-1;return{[k]:U}}if(w)return w(Q,q)}return q}),referencedBuffers:j}}e.stringifyJsonWithBufferRefs=d;function u(E,w,N){return JSON.parse(E,(j,V)=>{if(V){const Q=V[k];if(typeof Q=="number")return w[Q];if(N&&V.$mid===1)return N.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=u;function m(E,w){return JSON.stringify(E,w)}function b(E){return E?(w,N)=>N&&N.$mid===1?E.transformOutgoing(N):N:null}var C;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends A.Disposable{constructor(w,N=null,j=null){super(),this[P]=!0,this.b=this.B(new S.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=N,this.g=j,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,Q=O.ProxyIdentifier.count;V<Q;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new o.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+a.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+a.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,y.transformIncomingURIs)(w,this.g):w}getProxy(w){const{nid:N,sid:j}=w;return this.l[N]||(this.l[N]=this.F(N,j)),this.l[N]}F(w,N){const j={get:(V,Q)=>(typeof Q=="string"&&!V[Q]&&Q.charCodeAt(0)===36&&(V[Q]=(...q)=>this.O(w,Q,q)),Q===r?N:V[Q])};return new Proxy(Object.create(null),j)}set(w,N){return this.k[w.nid]=N,N}assertRegistered(w){for(let N=0,j=w.length;N<j;N++){const V=w[N];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(w){if(this.j)return;const N=w.byteLength,j=c.read(w,0),V=j.readUInt8(),Q=j.readUInt32();switch(V){case 1:case 2:{let{rpcId:q,method:U,args:T}=i.deserializeRequestJSONArgs(j);this.g&&(T=(0,y.transformIncomingURIs)(T,this.g)),this.H(N,Q,q,U,T,V===2);break}case 3:case 4:{let{rpcId:q,method:U,args:T}=i.deserializeRequestMixedArgs(j);this.g&&(T=(0,y.transformIncomingURIs)(T,this.g)),this.H(N,Q,q,U,T,V===4);break}case 5:{this.f?.logIncoming(N,Q,0,"ack"),this.z(Q);break}case 6:{this.I(N,Q);break}case 7:{this.J(N,Q,void 0);break}case 9:{let q=i.deserializeReplyOKJSON(j);this.g&&(q=(0,y.transformIncomingURIs)(q,this.g)),this.J(N,Q,q);break}case 10:{const q=i.deserializeReplyOKJSONWithBuffers(j,this.g);this.J(N,Q,q);break}case 8:{const q=i.deserializeReplyOKVSBuffer(j);this.J(N,Q,q);break}case 11:{let q=i.deserializeReplyErrError(j);this.g&&(q=(0,y.transformIncomingURIs)(q,this.g)),this.L(N,Q,q);break}case 12:{this.L(N,Q,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,N,j,V,Q,q){this.f?.logIncoming(w,N,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(j)}.${V}(`,Q);const U=String(N);let T,F;if(q){const Z=new l.CancellationTokenSource;Q.push(Z.token),T=this.M(j,V,Q),F=()=>Z.cancel()}else T=this.M(j,V,Q),F=n;this.p[U]=F;const B=i.serializeAcknowledged(N);this.f?.logOutgoing(B.byteLength,N,1,"ack"),this.c.send(B),T.then(Z=>{delete this.p[U];const _=i.serializeReplyOK(N,Z,this.h);this.f?.logOutgoing(_.byteLength,N,1,"reply:",Z),this.c.send(_)},Z=>{delete this.p[U];const _=i.serializeReplyErr(N,Z);this.f?.logOutgoing(_.byteLength,N,1,"replyErr:",Z),this.c.send(_)})}I(w,N){this.f?.logIncoming(w,N,1,"receiveCancel");const j=String(N);this.p[j]?.()}J(w,N,j){this.f?.logIncoming(w,N,0,"receiveReply:",j);const V=String(N);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V],Q.resolveOk(j)}L(w,N,j){this.f?.logIncoming(w,N,0,"receiveReplyErr:",j);const V=String(N);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V];let q;j&&(j.$isError?(q=new Error,q.name=j.name,q.message=j.message,q.stack=j.stack):q=j),Q.resolveErr(q)}M(w,N,j){try{return Promise.resolve(this.N(w,N,j))}catch(V){return Promise.reject(V)}}N(w,N,j){const V=this.k[w];if(!V)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(w));const Q=V[N];if(typeof Q!="function")throw new Error("Unknown method "+N+" on actor "+(0,O.getStringIdentifierForProxy)(w));return Q.apply(V,j)}O(w,N,j){if(this.j)return new I.CanceledLazyPromise;let V=null;if(j.length>0&&l.CancellationToken.isCancellationToken(j[j.length-1])&&(V=j.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const Q=i.serializeRequestArguments(j,this.h),q=++this.m,U=String(q),T=new I.LazyPromise;V&&V.onCancellationRequested(()=>{const B=i.serializeCancel(q);this.f?.logOutgoing(B.byteLength,q,0,"cancel"),this.c.send(i.serializeCancel(q))}),this.s[U]=T,this.y(q);const F=i.serializeRequest(q,w,N,Q,!!V);return this.f?.logOutgoing(F.byteLength,q,0,`request: ${(0,O.getStringIdentifierForProxy)(w)}.${N}(`,j),this.c.send(F),T}}P=s,a.a=3*1e3,e.RPCProtocol=a;class c{static alloc(w,N,j){const V=new c(L.VSBuffer.alloc(j+1+4),0);return V.writeUInt8(w),V.writeUInt32(N),V}static read(w,N){return new c(w,N)}get buffer(){return this.a}constructor(w,N){this.a=w,this.b=N}static sizeUInt8(){return 1}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+w).toString();return this.b+=w,j}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+w).toString();return this.b+=w,j}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+w);return this.b+=w,N}static sizeMixedArray(w){let N=0;N+=1;for(let j=0,V=w.length;j<V;j++){const Q=w[j];switch(N+=1,Q.type){case 1:N+=this.sizeLongString(Q.value);break;case 2:N+=this.sizeVSBuffer(Q.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(Q.value);for(let q=0;q<Q.buffers.length;++q)N+=this.sizeVSBuffer(Q.buffers[q]);break;case 4:break}}return N}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let N=0,j=w.length;N<j;N++){const V=w[N];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let Q=0;Q<V.buffers.length;++Q)this.writeBuffer(V.buffers[Q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const N=new Array(w);for(let j=0;j<w;j++)switch(this.readUInt8()){case 1:N[j]=this.readLongString();break;case 2:N[j]=this.readVSBuffer();break;case 3:{const Q=this.readUInt32(),q=this.readLongString(),U=[];for(let T=0;T<Q;++T)U.push(this.readVSBuffer());N[j]=new O.SerializableObjectWithBuffers(u(q,U,null));break}case 4:N[j]=void 0;break}return N}}c.sizeUInt32=4;var g;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(g||(g={}));class i{static a(w){for(let N=0,j=w.length;N<j;N++)if(w[N]instanceof L.VSBuffer||w[N]instanceof O.SerializableObjectWithBuffers||typeof w[N]>"u")return!0;return!1}static serializeRequestArguments(w,N){if(this.a(w)){const j=[];for(let V=0,Q=w.length;V<Q;V++){const q=w[V];if(q instanceof L.VSBuffer)j[V]={type:2,value:q};else if(typeof q>"u")j[V]={type:4};else if(q instanceof O.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:T}=d(q.value,N);j[V]={type:3,value:L.VSBuffer.fromString(U),buffers:T}}else j[V]={type:1,value:L.VSBuffer.fromString(m(q,N))}}return{type:1,args:j}}return{type:0,args:m(w,N)}}static serializeRequest(w,N,j,V,Q){switch(V.type){case 0:return this.b(w,N,j,V.args,Q);case 1:return this.c(w,N,j,V.args,Q)}}static b(w,N,j,V,Q){const q=L.VSBuffer.fromString(j),U=L.VSBuffer.fromString(V);let T=0;T+=c.sizeUInt8(),T+=c.sizeShortString(q),T+=c.sizeLongString(U);const F=c.alloc(Q?2:1,w,T);return F.writeUInt8(N),F.writeShortString(q),F.writeLongString(U),F.buffer}static deserializeRequestJSONArgs(w){const N=w.readUInt8(),j=w.readShortString(),V=w.readLongString();return{rpcId:N,method:j,args:JSON.parse(V)}}static c(w,N,j,V,Q){const q=L.VSBuffer.fromString(j);let U=0;U+=c.sizeUInt8(),U+=c.sizeShortString(q),U+=c.sizeMixedArray(V);const T=c.alloc(Q?4:3,w,U);return T.writeUInt8(N),T.writeShortString(q),T.writeMixedArray(V),T.buffer}static deserializeRequestMixedArgs(w){const N=w.readUInt8(),j=w.readShortString(),V=w.readMixedArray(),Q=new Array(V.length);for(let q=0,U=V.length;q<U;q++){const T=V[q];typeof T=="string"?Q[q]=JSON.parse(T):Q[q]=T}return{rpcId:N,method:j,args:Q}}static serializeAcknowledged(w){return c.alloc(5,w,0).buffer}static serializeCancel(w){return c.alloc(6,w,0).buffer}static serializeReplyOK(w,N,j){if(typeof N>"u")return this.d(w);if(N instanceof L.VSBuffer)return this.e(w,N);if(N instanceof O.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:Q}=d(N.value,j,!0);return this.g(w,V,Q)}else return this.f(w,v(N,j))}static d(w){return c.alloc(7,w,0).buffer}static e(w,N){let j=0;j+=c.sizeVSBuffer(N);const V=c.alloc(8,w,j);return V.writeVSBuffer(N),V.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,N){const j=L.VSBuffer.fromString(N);let V=0;V+=c.sizeLongString(j);const Q=c.alloc(9,w,V);return Q.writeLongString(j),Q.buffer}static g(w,N,j){const V=L.VSBuffer.fromString(N);let Q=0;Q+=c.sizeUInt32,Q+=c.sizeLongString(V);for(const U of j)Q+=c.sizeVSBuffer(U);const q=c.alloc(10,w,Q);q.writeUInt32(j.length),q.writeLongString(V);for(const U of j)q.writeBuffer(U);return q.buffer}static deserializeReplyOKJSON(w){const N=w.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(w,N){const j=w.readUInt32(),V=w.readLongString(),Q=[];for(let q=0;q<j;++q)Q.push(w.readVSBuffer());return new O.SerializableObjectWithBuffers(u(V,Q,N))}static serializeReplyErr(w,N){const j=N?v(R.transformErrorForSerialization(N),null):void 0;if(typeof j!="string")return this.h(w);const V=L.VSBuffer.fromString(j);let Q=0;Q+=c.sizeLongString(V);const q=c.alloc(11,w,Q);return q.writeLongString(V),q.buffer}static deserializeReplyErrError(w){const N=w.readLongString();return JSON.parse(N)}static h(w){return c.alloc(12,w,0).buffer}}var t;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var h;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(h||(h={}))}),define(ye[292],De([1,0,3,39,54,4]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var S;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new o.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new o.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(I){this.a.has(I.id)||(this.a.set(I.id,I),this.b.fire(I.id))}getChannels(){const I=[];return this.a.forEach(O=>I.push(O)),I}getChannel(I){return this.a.get(I)}removeChannel(I){this.a.delete(I),this.c.fire(I)}}L.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(ye[142],De([1,0,5,4,20,27,13,292,78,25,48,158,22,9,44,3,6]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends S.AbstractMessageLogger{get disposed(){return this.l}constructor(p,n,s,r,a){super(),this.id=p,this.name=n,this.m=s,this.n=r,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,p)}replace(p){const n=this.k;this.info(p),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(p,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:n))}hide(){this.n.$close(this.id)}g(p,n){this.k+=v.VSBuffer.fromString(n).byteLength,(0,S.log)(this.m,p,n),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class m extends u{appendLine(p){this.append(p)}}let b=class{constructor(p,n,s,r,a,c){this.i=n,this.j=s,this.k=r,this.l=a,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(o.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(p,n,s){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,a=(0,k.isString)(n)?n:void 0;if((0,k.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const g=this.i.environment.extensionLogLevel?.find(([t])=>R.ExtensionIdentifier.equals(s.identifier,t))?.[1];g&&(c=(0,S.parseLogLevel)(g));const i=r?this.o(p,c,s):this.n(p,a,s);return i.then(t=>{this.g.set(t.id,t),t.visible=t.id===this.h}),r?this.r(p,c??this.m.getLevel(),i):this.q(p,i)}async n(p,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,a=this.k.extUri.joinPath(r,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(p,a,n,s.identifier.value);return new u(g,p,c,this.a,s)}async o(p,n,s){const r=await this.p(s),a=this.k.extUri.joinPath(r,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=a.toString(),g=this.l.createLogger(a,{id:c,name:p,logLevel:n,extensionId:s.identifier.value});return new m(c,p,g,this.a,s)}p(p){let n=this.d.get(p.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(r){if((0,D.toFileSystemProviderErrorCode)(r)!==D.FileSystemProviderErrorCode.FileExists)throw r}return s})())}return n}q(p,n){let s=!1;const r=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return p},append(a){r(),n.then(c=>c.append(a))},appendLine(a){r(),n.then(c=>c.appendLine(a))},clear(){r(),n.then(a=>a.clear())},replace(a){r(),n.then(c=>c.replace(a))},show(a,c){r(),n.then(g=>g.show(a,c))},hide(){r(),n.then(a=>a.hide())},dispose(){s=!0,n.then(a=>a.dispose())}}}r(p,n,s){const r=new d.DisposableStore,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},c=r.add(new f.Emitter);function g(i){n=i,c.fire(i)}return s.then(i=>{r.add(i),i.logLevel!==n&&g(i.logLevel),r.add(i.onDidChangeLogLevel(t=>g(t)))}),{...this.q(p,s),get logLevel(){return n},onDidChangeLogLevel:c.event,trace(i,...t){a(),s.then(h=>h.trace(i,...t))},debug(i,...t){a(),s.then(h=>h.debug(i,...t))},info(i,...t){a(),s.then(h=>h.info(i,...t))},warn(i,...t){a(),s.then(h=>h.warn(i,...t))},error(i,...t){a(),s.then(h=>h.error(i,...t))},dispose(){r.dispose()}}}};b=xe([ze(0,l.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,y.IExtHostConsumerFileSystem),ze(3,O.IExtHostFileSystemInfo),ze(4,S.ILoggerService),ze(5,S.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,L.createDecorator)("IExtHostOutputService")}),define(ye[293],De([1,0,4]),function(re,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(ye[294],De([1,0,33,16,12,11,24,2,4,219,47,237,293]),function(re,e,o,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let k=class cn{constructor(f,d,u,m){this.d=f,this.e=d,this.f=u,this.g=m,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??f})()}hasValidBasename(f,d,u){return typeof d=="string"||typeof d>"u"?this.a.then(m=>this.h(f,m,d)):this.h(f,d,u)}h(f,d,u){return f.scheme===L.Schemas.file||f.scheme===L.Schemas.vscodeRemote?(0,o.isValidBasename)(u??(0,S.basename)(f),d===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return L.Schemas.vscodeRemote;const u=(0,I.getVirtualWorkspaceScheme)(d.getWorkspace());if(u)return u;const m=d.getWorkspace().folders[0];if(m)return m.uri.scheme;const b=d.getWorkspace().configuration;return b?b.scheme:L.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?l.win32:l.posix)}async fileURI(f){let d="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const m=f.indexOf("/",2);m===-1?(d=f.substring(2),f="/"):(d=f.substring(2,m),f=f.substring(m)||"/")}return A.URI.from({scheme:L.Schemas.file,authority:d,path:f,query:"",fragment:""})}};k=xe([ze(1,v.IRemoteAgentService),ze(2,P.IWorkbenchEnvironmentService),ze(3,O.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(ye[81],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(S,A){this.line=S,this.character=A}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,A){return new o(0,0)}with(S){return new o(0,0)}}e.Position=o;class L{constructor(S,A,y,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(S,A),this.end=new o(y,I)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new L(0,0,0,0)}with(S){return new L(0,0,0,0)}}e.Range=L;var l;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(l=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([1,0,15,38,23,33,8,4,12,10,81,19]),function(re,e,o,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",k=" characters skipped \u27EB",D=(v.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var f;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function u(Y){return!!Y.preview}e.resultIsMatch=u;function m(Y){return!!Y.resource}e.isFileMatch=m;function b(Y){return!!Y.message}e.isProgressMessage=b;var C;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(C=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=p;class n{constructor(ie,ge,X){this.ranges=ge;const J=Array.isArray(ge)?ge:[ge];if(X&&X.matchLines===1&&s(J)){ie=(0,S.getNLines)(ie,X.matchLines);let ee="",me=0,ve=0;const Ie=Math.floor(X.charsPerLine/5),Re=[];for(const ae of J){const le=Math.max(ae.startColumn-Ie,0),ue=ae.startColumn+X.charsPerLine;if(le>ve+Ie+D){const ne=v+(le-ve)+k;ee+=ne+ie.slice(le,ue),me+=le-(ve+ne.length)}else ee+=ie.slice(ve,ue);Re.push(new a(0,ae.startColumn-me,ae.endColumn-me)),ve=ue}this.preview={text:ee,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const ee=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:ie,matches:(0,o.mapArrayOrNot)(ge,me=>new r(me.startLineNumber-ee,me.startColumn,me.endLineNumber-ee,me.endColumn))}}}}e.TextSearchMatch=n;function s(Y){const ie=Y[0].startLineNumber;for(const ge of Y)if(ge.startLineNumber!==ie||ge.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,ge,X,J){this.startLineNumber=ie,this.startColumn=ge,this.endLineNumber=X,this.endColumn=J}}e.SearchRange=r;class a extends r{constructor(ie,ge,X){super(ie,ge,ie,X)}}e.OneLineRange=a;var c;(function(Y){Y.List="list",Y.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var g;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(g=e.SearchSortOrder||(e.SearchSortOrder={}));function i(Y,ie=!0){const ge=Y&&Y.files&&Y.files.exclude,X=ie&&Y&&Y.search&&Y.search.exclude;if(!ge&&!X)return;if(!ge||!X)return ge||X;let J=Object.create(null);return J=l.mixin(J,l.deepClone(ge)),J=l.mixin(J,l.deepClone(X),!0),J}e.getExcludes=i;function t(Y,ie){return Y.excludePattern&&L.match(Y.excludePattern,ie)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&L.match(Y.includePattern,ie)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ge=>{const X=ge.folder.fsPath;if(R.isEqualOrParent(ie,X)){const J=y.relative(X,ie);return!ge.includePattern||!!L.match(ge.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var h;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(ie,ge){super(ie),this.code=ge}}e.SearchError=E;function w(Y){const ie=Y.message;if((0,I.isCancellationError)(Y))return new E(ie,h.canceled);try{const ge=JSON.parse(ie);return new E(ge.message,ge.code)}catch{return new E(ie,h.other)}}e.deserializeSearchError=w;function N(Y){const ie={message:Y.message,code:Y.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=N;function j(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=j;function V(Y){return Y.type==="success"}e.isSerializedSearchSuccess=V;function Q(Y){return!!Y.path}e.isSerializedFileMatch=Q;function q(Y,ie){const ge=Y.searchPath?Y.searchPath:Y.relativePath;return(0,S.fuzzyContains)(ge,ie)}e.isFilePatternMatch=q;class U{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function T(Y,ie){const ge={...Y||{},...ie||{}};return Object.keys(ge).filter(X=>{const J=ge[X];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=T;class F{constructor(ie,ge){this.c=null,this.a={...ie.excludePattern||{},...ge.excludePattern||{}},this.b=L.parse(this.a);let X=ie.includePattern;ge.includePattern&&(X?X={...X,...ge.includePattern}:X=ge.includePattern),X&&(this.c=L.parse(X))}matchesExcludesSync(ie,ge,X){return!!(this.b&&this.b(ie,ge,X))}includedInQuerySync(ie,ge,X){return!(this.b&&this.b(ie,ge,X)||this.c&&!this.c(ie,ge,X))}includedInQuery(ie,ge,X){const J=this.b(ie,ge,X),ee=()=>this.c?!!this.c(ie,ge,X):!0;return(0,P.isThenable)(J)?J.then(me=>me?!1:ee()):ee()}hasSiblingExcludeClauses(){return B(this.a)}}e.QueryGlobTester=F;function B(Y){for(const ie in Y)if(typeof Y[ie]!="boolean")return!0;return!1}function Z(Y){if(!Y)return;let ie;return ge=>(ie||(ie=(Y()||Promise.resolve([])).then(X=>X?H(X):{})),ie.then(X=>!!X[ge]))}e.hasSiblingPromiseFn=Z;function _(Y){if(!Y)return;let ie;return ge=>{if(!ie){const X=Y();ie=X?H(X):{}}return!!ie[ge]}}e.hasSiblingFn=_;function H(Y){const ie={};for(const ge of Y)ie[ge]=!0;return ie}}),define(ye[34],De([1,0,15,19,21,3,6,68,16,102,24,8,9,2,184,4,13,207,47,48,25,20,14,7,56,31,5]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p,n,s,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function g(V,Q,q){return new O.ExtUri(U=>E(U,q)).isEqual(V,Q)}function i(V,Q,q){return g(V.uri,Q.uri,q)?0:(0,P.compare)(V.uri.toString(),Q.uri.toString())}function t(V,Q,q){return V.index!==Q.index?V.index<Q.index?-1:1:g(V.uri,Q.uri,q)?(0,P.compare)(V.name,Q.name):(0,P.compare)(V.uri.toString(),Q.uri.toString())}function h(V,Q,q,U){const T=V.slice(0).sort((B,Z)=>q(B,Z,U)),F=Q.slice(0).sort((B,Z)=>q(B,Z,U));return(0,o.delta)(T,F,(B,Z)=>q(B,Z,U))}function E(V,Q){const q=Q.getCapabilities(V.scheme);return!(q&&q&1024)}class w extends m.Workspace{static toExtHostWorkspace(Q,q,U,T){if(!Q)return{workspace:null,added:[],removed:[]};const{id:F,name:B,folders:Z,configuration:_,transient:H,isUntitled:Y}=Q,ie=[],ge=q;q?Z.forEach((me,ve)=>{const Ie=k.URI.revive(me.uri),Re=w.o(U||q,Ie,T);Re?(Re.name=me.name,Re.index=me.index,ie.push(Re)):ie.push({uri:Ie,name:me.name,index:ve})}):ie.push(...Z.map(({uri:me,name:ve,index:Ie})=>({uri:k.URI.revive(me),name:ve,index:Ie}))),ie.sort((me,ve)=>me.index<ve.index?-1:1);const X=new w(F,B,ie,!!H,_?k.URI.revive(_):null,!!Y,me=>E(me,T)),{added:J,removed:ee}=h(ge?ge.workspaceFolders:[],X.workspaceFolders,i,T);return{workspace:X,added:J,removed:ee}}static o(Q,q,U){for(let T=0;T<Q.folders.length;T++){const F=Q.workspaceFolders[T];if(g(F.uri,q,U))return F}}constructor(Q,q,U,T,F,B,Z){super(Q,U.map(_=>new m.WorkspaceFolder(_)),T,F,Z),this.t=q,this.u=B,this.q=[],this.s=A.TernarySearchTree.forUris(Z),U.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(Q,q){return q&&this.s.get(Q)&&(Q=(0,O.dirname)(Q)),this.s.findSubstr(Q)}resolveWorkspaceFolder(Q){return this.s.get(Q)}}let N=class{constructor(Q,q,U,T,F){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=T,this.s=U,this.t=F,this.j=new I.Counter,this.k=new L.Barrier,this.o=Q.getProxy(c.MainContext.MainThreadWorkspace),this.q=Q.getProxy(c.MainContext.MainThreadMessageService);const B=q.workspace;this.l=B?new w(B.id,B.name,[],!!B.transient,B.configuration?k.URI.revive(B.configuration):null,!!B.isUntitled,Z=>E(Z,U)):void 0}$initializeWorkspace(Q,q){this.v=q,this.$acceptWorkspaceData(Q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?k.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(Q,q,U,...T){const F=[];if(Array.isArray(T)&&T.forEach(Y=>{k.URI.isUri(Y.uri)&&!F.some(ie=>g(ie.uri,Y.uri,this.s))&&F.push({uri:Y.uri,name:Y.name||(0,O.basenameOrAuthority)(Y.uri)})}),this.n||[q,U].some(Y=>typeof Y!="number"||Y<0)||U===0&&F.length===0)return!1;const B=this.x?this.x.workspaceFolders:[];if(q+U>B.length)return!1;const Z=B.slice(0);Z.splice(q,U,...F.map(Y=>({uri:Y.uri,name:Y.name||(0,O.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<Z.length;Y++){const ie=Z[Y];if(Z.some((ge,X)=>X!==Y&&g(ie.uri,ge.uri,this.s)))return!1}Z.forEach((Y,ie)=>Y.index=ie);const{added:_,removed:H}=h(B,Z,t,this.s);if(_.length===0&&H.length===0)return!1;if(this.o){const Y=Q.displayName||Q.name;this.o.$updateWorkspaceFolders(Y,q,U,F).then(void 0,ie=>{this.n=void 0;const ge={source:{identifier:Q.identifier,label:Q.displayName||Q.name}};this.q.$showMessage(u.Severity.Error,(0,D.localize)(0,null,Y,ie.toString()),ge,[])})}return this.y(Z),!0}getWorkspaceFolder(Q,q){if(!!this.x)return this.x.getWorkspaceFolder(Q,q)}async getWorkspaceFolder2(Q,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(Q,q)}async resolveWorkspaceFolder(Q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(Q)}getPath(){if(!this.x)return;const{folders:Q}=this.x;if(Q.length!==0)return Q[0].uri.fsPath}getRelativePath(Q,q){let U,T="";if(typeof Q=="string"?(U=k.URI.file(Q),T=Q):typeof Q<"u"&&(U=Q,T=Q.fsPath),!U)return T;const F=this.getWorkspaceFolder(U,!0);if(!F)return T;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let B=(0,O.relativePath)(F.uri,U);return q&&F.name&&(B=`${F.name}/${B}`),B}y(Q){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:Q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(Q){const{workspace:q,added:U,removed:T}=w.toExtHostWorkspace(Q,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:T}))}findFiles(Q,q,U,T,F=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let B;if(q===null?B=!1:q&&(typeof q=="string"?B=q:B=q.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:_}=j(n.GlobPattern.from(Q));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(Z),(0,v.withUndefinedAsNull)(_),(0,v.withUndefinedAsNull)(B),(0,v.withUndefinedAsNull)(U),F).then(H=>Array.isArray(H)?H.map(Y=>k.URI.revive(Y)):[])}async findTextInFiles(Q,q,U,T,F=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const B=this.j.getNext(),Z=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:_,folder:H}=j(n.GlobPattern.from(q.include)),Y=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ie={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:Z,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:_,excludePattern:Y},ge=!1;if(this.u[B]=X=>{if(ge)return;const J=k.URI.revive(X.resource);X.results.forEach(ee=>{(0,a.resultIsMatch)(ee)?U({uri:J,preview:{text:ee.preview.text,matches:(0,o.mapArrayOrNot)(ee.preview.matches,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))},ranges:(0,o.mapArrayOrNot)(ee.ranges,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))}):U({uri:J,text:ee.text,lineNumber:ee.lineNumber})})},F.isCancellationRequested)return{};try{const X=await this.o.$startTextSearch(Q,(0,v.withUndefinedAsNull)(H),ie,B,F);return delete this.u[B],X||{}}catch(X){throw delete this.u[B],X}}$handleTextSearchResult(Q,q){this.u[q]?.(Q)}saveAll(Q){return this.o.$saveAll(Q)}resolveProxy(Q){return this.o.$resolveProxy(Q)}get trusted(){return this.v}requestWorkspaceTrust(Q){return this.o.$requestWorkspaceTrust(Q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(Q,q){if(this.w.has(Q))throw new Error(`A provider has already been registered for scheme ${Q}`);this.w.set(Q,q);const U=this.t.transformOutgoingScheme(Q),T=this.z++;return this.o.$registerEditSessionIdentityProvider(T,U),(0,S.toDisposable)(()=>{this.w.delete(Q),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(Q,q){this.h.info("Getting edit session identifier for workspaceFolder",Q);const U=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const T=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!T),!T)return;const F=await T.provideEditSessionIdentity(U,q);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(Q,q,U,T){this.h.info("Getting edit session identifier for workspaceFolder",Q);const F=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const Z=await B.provideEditSessionIdentityMatch?.(q,U,T);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(Q){return(q,U,T)=>{const F=function(Z){q.call(U,Z)};return F.extension=Q,this.A.event(F,void 0,T)}}async $onWillCreateEditSessionIdentity(Q,q,U){const T=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:T},q,async(F,B)=>{const Z=Date.now();await Promise.resolve(F),Date.now()-Z>U&&this.h.warn("SLOW edit session create-participant",B.extension.identifier)}),q.isCancellationRequested}};N=xe([ze(0,p.IExtHostRpcService),ze(1,C.IExtHostInitDataService),ze(2,b.IExtHostFileSystemInfo),ze(3,d.ILogService),ze(4,r.IURITransformerService)],N),e.ExtHostWorkspace=N,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function j(V){let Q,q;return V&&(typeof V=="string"?Q=V:(Q=V.pattern,q=k.URI.revive(V.baseUri))),{includePattern:Q,folder:q}}}),define(ye[35],De([1,0,23,3,34,5,7,210,127,9,19,4,20,13,2]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(s,r){if(r){const a=r.split(".");let c=s;for(let g=0;c&&g<a.length;g++)c=c[a[g]];return c}}function d(s){return s instanceof D.URI}function u(s){return s&&s.uri instanceof D.URI&&s.languageId&&typeof s.languageId=="string"}function m(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof D.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function C(s){if(d(s))return{resource:s};if(u(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(m(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let p=class{constructor(r,a,c){this.a=r.getProxy(R.MainContext.MainThreadConfiguration),this.c=a,this.b=c,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new n(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,a))}};p=xe([ze(0,v.IExtHostRpcService),ze(1,l.IExtHostWorkspace),ze(2,k.ILogService)],p),e.ExtHostConfiguration=p;class n{constructor(r,a,c,g){this.a=new L.Emitter,this.b=r,this.f=g,this.c=a,this.e=A.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,a){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(a,c))}getConfiguration(r,a,c){const g=C(a)||{},i=this.g(r?f(this.e.getValue(void 0,g,this.c.workspace),r):this.e.getValue(void 0,g,this.c.workspace));r&&this.h(r,g,c?.identifier);function t(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case S.ConfigurationTarget.Global:return 2;case S.ConfigurationTarget.Workspace:return 5;case S.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(E){return typeof f(i,E)<"u"},get:(E,w)=>{this.h(r?`${r}.${E}`:E,g,c?.identifier);let N=f(i,E);if(typeof N>"u")N=w;else{let j;const V=(Q,q)=>{let U;const T=()=>{j=j||(0,o.deepClone)(i),U=U||f(j,q)};return(0,I.isObject)(Q)?new Proxy(Q,{get:(F,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return T(),()=>U;if(j)return U=U||f(j,q),U[B];const Z=F[B];return typeof B=="string"?V(Z,`${q}.${B}`):Z},set:(F,B,Z)=>(T(),U&&(U[B]=Z),!0),deleteProperty:(F,B)=>(T(),U&&delete U[B],!0),defineProperty:(F,B,Z)=>(T(),U&&Object.defineProperty(U,B,Z),!0)}):Q};N=V(N,E)}return N},update:(E,w,N,j)=>{E=r?`${r}.${E}`:E;const V=t(N);return w!==void 0?this.b.$updateConfigurationOption(V,E,w,g,j):this.b.$removeConfigurationOption(V,E,g,j)},inspect:E=>{E=r?`${r}.${E}`:E;const w=this.e.inspect(E,g,this.c.workspace);if(w)return{key:E,defaultValue:(0,o.deepClone)(w.policy?.value??w.default?.value),globalValue:(0,o.deepClone)(w.user?.value??w.application?.value),workspaceValue:(0,o.deepClone)(w.workspace?.value),workspaceFolderValue:(0,o.deepClone)(w.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(w.default?.override),globalLanguageValue:(0,o.deepClone)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,o.deepClone)(w.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(w.workspaceFolder?.override),languageIds:(0,o.deepClone)(w.overrideIdentifiers)}}};return typeof i=="object"&&(0,o.mixin)(h,i,!1),Object.freeze(h)}g(r){const a=c=>(0,I.isObject)(c)?new Proxy(c,{get:(g,i)=>a(g[i]),set:(g,i,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(i)}' of object`)},deleteProperty:(g,i)=>{throw new Error(`TypeError: Cannot delete read only property '${String(i)}' of object`)},defineProperty:(g,i)=>{throw new Error(`TypeError: Cannot define property '${String(i)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return a(r)}h(r,a,c){const g=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),i=c?`[${c.value}] `:"";if(g===4){typeof a?.resource>"u"&&this.f.warn(`${i}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){a?.resource&&this.f.warn(`${i}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,a){const c=new A.ConfigurationChangeEvent(r,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,i)=>c.affectsConfiguration(g,C(i))})}k(r){return r.reduce((a,c)=>(a.set(c[0],c[1]),a),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[82],De([1,0,2,19,3,5,7,34,59,35,21,41,20,25,4,16,11,13,77,248,10]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(Q){function q(T){if(T!=null)return T}Q.from=q;function U(T){if(T!=null)return T}Q.to=U})(n||(n={}));var s;(function(Q){function q(T){if(T!=null)return T}Q.from=q;function U(T){if(T!=null)return T}Q.to=U})(s||(s={}));var r;(function(Q){function q(T){if(T!=null)return T}Q.from=q;function U(T){if(T!=null)return T}Q.to=U})(r||(r={}));var a;(function(Q){function q(F){if(F){const B=F;return B&&!!B.process}else return!1}Q.is=q;function U(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=r.from(F.options)),B}Q.from=U;function T(F){if(F!=null)return new S.ProcessExecution(F.process,F.args,F.options)}Q.to=T})(a||(a={}));var c;(function(Q){function q(T){if(T!=null)return T}Q.from=q;function U(T){if(T!=null)return T}Q.to=U})(c||(c={}));var g;(function(Q){function q(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}Q.is=q;function U(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=c.from(F.options)),B}Q.from=U;function T(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new S.ShellExecution(F.commandLine,F.options):new S.ShellExecution(F.command,F.args?F.args:[],F.options)}Q.to=T})(g||(g={}));var i;(function(Q){function q(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}Q.is=q;function U(F){return{customExecution:"customExecution"}}Q.from=U;function T(F,B){return B.get(F)}Q.to=T})(i=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(Q){function q(U,T){let F;return U.scope!==void 0&&typeof U.scope!="number"?F=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===S.TaskScope.Workspace&&T&&T.workspaceFile?F=T.workspaceFile:F=b.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:F}}Q.from=q})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(Q){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}Q.from=q})(h||(h={}));var E;(function(Q){function q(F,B){if(F==null)return[];const Z=[];for(const _ of F){const H=U(_,B);H&&Z.push(H)}return Z}Q.fromMany=q;function U(F,B){if(F==null)return;let Z;F.execution instanceof S.ProcessExecution?Z=a.from(F.execution):F.execution instanceof S.ShellExecution?Z=g.from(F.execution):F.execution&&F.execution instanceof S.CustomExecution&&(Z=i.from(F.execution));const _=n.from(F.definition);let H;return F.scope?typeof F.scope=="number"?H=F.scope:H=F.scope.uri:H=S.TaskScope.Workspace,!_||!H?void 0:{_id:F._id,definition:_,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:H},execution:Z,isBackground:F.isBackground,group:h.from(F.group),presentationOptions:s.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}Q.from=U;async function T(F,B,Z){if(F==null)return;let _;a.is(F.execution)?_=a.to(F.execution):g.is(F.execution)?_=g.to(F.execution):i.is(F.execution)&&(_=i.to(F._id,Z));const H=n.to(F.definition);let Y;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Y=F.source.scope:Y=await B.resolveWorkspaceFolder(o.URI.revive(F.source.scope)):Y=S.TaskScope.Workspace),!H||!Y)return;const ie=new S.Task(H,Y,F.name,F.source.label,_,F.problemMatchers);return F.isBackground!==void 0&&(ie.isBackground=F.isBackground),F.group!==void 0&&(ie.group=S.TaskGroup.from(F.group._id),ie.group&&F.group.isDefault&&(ie.group=new S.TaskGroup(ie.group.id,ie.group.label),F.group.isDefault===!0&&(ie.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ie.presentationOptions=s.to(F.presentationOptions)),F._id&&(ie._id=F._id),F.detail&&(ie.detail=F.detail),ie}Q.to=T})(E=e.TaskDTO||(e.TaskDTO={}));var w;(function(Q){function q(T){return T}Q.from=q;function U(T){if(!!T)return Object.assign(Object.create(null),T)}Q.to=U})(w||(w={}));class N{constructor(q,U,T){this._id=U,this.a=T,p.set(this,void 0),_e(this,p,q,"f")}get task(){return this.a}terminate(){Ue(this,p,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}p=new WeakMap;let j=class{constructor(q,U,T,F,B,Z,_,H){this.q=new l.Emitter,this.r=new l.Emitter,this.s=new l.Emitter,this.t=new l.Emitter,this.a=q.getProxy(R.MainContext.MainThreadTask),this.b=T,this.c=F,this.d=B,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,T){if(!T)return new S.Disposable(()=>{});const F=this.w();return this.j.set(F,{type:U,provider:T,extension:q}),this.a.$registerTaskProvider(F,U),new S.Disposable(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(w.from(q)).then(async U=>{const T=[];for(const F of U){const B=await E.to(F,this.b,this.m);B&&T.push(B)}return T})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof N))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,T){const F=this.m.get(q.id);F&&(this.o.set(q.id,F),this.e.attachPtyToTerminal(U,await F.callback(T))),this.p=q.id,this.q.fire({execution:await this.y(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){const U=await this.y(q);this.l.delete(q.id),this.k.delete(q.id),this.A(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.y(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(q){const U=await this.y(q.id);this.t.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const T=this.j.get(q);if(!T)return Promise.reject(new Error("no handler found"));const F=[],B=(0,L.asPromise)(()=>T.provider.provideTasks(O.CancellationToken.None)).then(Z=>this.u(U,F,T,Z));return new Promise(Z=>{B.then(_=>{Promise.all(F).then(()=>{Z(_)})})})}async $resolveTask(q,U){const T=this.j.get(q);if(!T)return Promise.reject(new Error("no handler found"));if(U.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${T.type}].`);const F=await E.to(U,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await T.provider.resolveTask(F,O.CancellationToken.None);if(!B)return;this.z(B,T);const Z=E.from(B,T.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return i.is(Z.execution)&&await this.x(Z,B,!0),await this.v(Z)}w(){return this.h++}async x(q,U,T){const F=await this.a.$createTaskId(q);!T&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,U.execution)),this.m.set(F,U.execution)}async y(q,U){if(typeof q=="string"){const B=this.l.get(q);if(!B)throw new C.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const T=this.l.get(q.id);if(T)return T;const F=new Promise((B,Z)=>{function _(H,Y,ie){ie?B(new N(H,Y.id,ie)):Z("Unexpected: Task does not exist.")}U?_(this,q,U):E.to(q.task,this.b,this.m).then(H=>_(this,q,H))});return this.l.set(q.id,F),F.then(B=>(this.k.set(q.id,B),B),B=>Promise.reject(B))}z(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const T=this.n.values();let F=T.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=T.next()}};j=xe([ze(0,v.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,A.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,u.ILogService),ze(7,m.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let V=class extends j{constructor(q,U,T,F,B,Z,_,H){super(q,U,T,F,B,Z,_,H),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const T=E.from(U,q);if(T===void 0)throw new Error("Task is not valid");if(i.is(T.execution))await this.x(T,U,!1);else throw new C.NotSupportedError;const F=await this.y(await this.a.$getTaskExecution(T),U);return this.a.$executeTask(T).catch(B=>{throw new Error(B)}),F}u(q,U,T,F){const B=[];if(F)for(const Z of F){this.z(Z,T),(!Z.definition||!q[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const _=E.from(Z,T.extension);_&&i.is(_.execution)?(B.push(_),U.push(this.x(_,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:T.extension}}async v(q){if(i.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,T){}};V=xe([ze(0,v.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,A.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,u.ILogService),ze(7,m.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,D.createDecorator)("IExtHostTask")}),define(ye[295],De([1,0,12,21,45,38,24,43,31]),function(re,e,o,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(v,k,D){this.k=v,this.l=k,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const k=this.k.folderQueries||[];return new Promise((D,f)=>{const d=u=>{this.f++,v(u)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const m=u.toString(),b=o.basename(m);this.j&&this.j(m,b)||this.v(d,{base:u,basename:b})}),Promise.all(k.map(u=>this.p(u,d))).then(u=>{D({limitHit:this.e,stats:u[0]||void 0})},u=>{f(new Error((0,l.toErrorMessage)(u)))})})}async p(v,k){const D=new L.CancellationTokenSource,f=this.q(v),d=this.r(),u=new y.QueryGlobTester(this.k,v),m=!u.hasSiblingExcludeClauses();let b;try{this.h.add(D),b=A.StopWatch.create();const C=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,D.token),p=b.elapsed(),n=A.StopWatch.create();return this.g&&!this.e||(C&&C.forEach(s=>{const r=o.posix.relative(v.folder.path,s.path);if(m){const a=o.basename(s.path);this.v(k,{base:v.folder,relativePath:r,basename:a});return}this.s(d,v.folder,r,k)}),this.g&&!this.e)?null:(this.u(d,u,k),{providerTime:p,postProcessTime:n.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(v){const k=(0,y.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),D=(0,y.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:D,includes:k,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},k,D,f){if(D===this.a){const u=o.basename(this.a);this.v(f,{base:k,relativePath:this.a,basename:u})}function d(u){const m=o.basename(u),b=o.dirname(u);let C=v[b];C||(C=v[b]=[],d(b)),C.push({base:k,relativePath:u,basename:m})}d(D)}u({rootEntries:v,pathToEntries:k},D,f){const d=this,u=this.a;function m(b){const C=(0,y.hasSiblingFn)(()=>b.map(p=>p.basename));for(let p=0,n=b.length;p<n;p++){const s=b[p],{relativePath:r,basename:a}=s;if(D.matchesExcludesSync(r,a,u!==a?C:void 0))continue;const c=k[r];if(c)m(c);else{if(r===u)continue;d.v(f,s)}if(d.e)break}}m(v)}v(v,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(k))}}class O{constructor(){this.b=new Map}fileSearch(v,k,D,f){const d=this.c(v.cacheKey),u=new I(v,k,d&&d.token);let m=0;const b=C=>{m+=C.length,D(C.map(p=>this.d(p)))};return this.e(u,O.a,b,f).then(C=>({limitHit:C.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:C.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new L.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:S.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,k,D,f){f.onCancellationRequested(()=>{v.cancel()});const d=m=>{m&&(u.push(m),k>0&&u.length>=k&&(D(u),u=[]))};let u=[];return v.search(d).then(m=>(u.length&&D(u),m),m=>(u.length&&D(u),Promise.reject(m)))}}O.a=512,e.FileSearchManager=O}),define(ye[296],De([1,0,15,61,38,113,28,16,12,24,8,9,2,166,196,53,13,47,133,294,31]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(E,w,N,j,V){this.a=E,this.b=w,this.c=N,this.d=j,this.e=V}text(E,w,N={}){E=this.f(E,N);const j=this.a.getValue(),V=w&&w.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(w?.map(u.toWorkspaceFolder),N),type:2,contentPattern:E,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:j.search.usePCRE2||V||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(E,w){const N=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const j={...E,wordSeparators:N.editor.wordSeparators};return this.j(E,w)&&(j.isCaseSensitive=!0),this.k(E)&&(j.isMultiline=!0),j}file(E,w={}){return{...this.h(E,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(E,w){return E?(E=Array.isArray(E)?E.map(c):c(E),w?this.parseSearchPaths(E):{pattern:s(...Array.isArray(E)?E:[E])}):{}}h(E=[],w={}){const N=this.g(w.includePattern,w.expandPatterns),j=this.g(w.excludePattern,w.expandPatterns),V=E.length>1,Q=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(T=>this.q(T,w,j)):E.map(T=>this.r(T,w,j,V))).filter(T=>!!T),q={_reason:w._reason,folderQueries:Q,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:j.pattern,includePattern:N.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const T=o.coalesce(o.flatten(this.c.groups.map(Z=>Z.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const F=T.filter(Z=>(0,C.pathIncludedInQuery)(q,Z.fsPath)),B=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...q,...B}}const U=w.extraFileResources&&w.extraFileResources.filter(T=>(0,C.pathIncludedInQuery)(q,T.fsPath));return q.extraFileResources=U&&U.length?U:void 0,q}i(E){const w=[],N=new S.ResourceMap,j={};let V=!1;return E.forEach(Q=>{if(Q.scheme===A.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(Q)){const U=this.b.getWorkspaceFolder(Q)?.uri??Q.with({path:y.dirname(Q.fsPath)});let T=N.get(U);T||(V=!0,T={folder:U,includePattern:{}},w.push(T),N.set(U,T));const F=y.relative(U.fsPath,Q.fsPath);(0,P.assertIsDefined)(T.includePattern)[F.replace(/\\/g,"/")]=!0}else Q.fsPath&&(V=!0,j[Q.fsPath]=!0)}),{folderQueries:w,includePattern:j,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(E,w){if(w.isSmartCase){if(E.isRegExp){if(O.containsUppercaseCharacter(E.pattern,!0))return!0}else if(O.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,k.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const w=B=>y.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),j=(Array.isArray(E)?E:r(E)).map(B=>{const Z=this.e.resolvedUserHome;return Z?(0,R.untildify)(B,Z.scheme===A.Schemas.file?Z.fsPath:Z.path):B}),V=L.groupBy(j,B=>w(B)?"searchPaths":"exprSegments"),Q=(V.exprSegments||[]).map(B=>O.rtrim(B,"/")).map(B=>O.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),a(B))),q={},U=this.m(V.searchPaths||[]);U&&U.length&&(q.searchPaths=U);const T=o.flatten(Q),F=s(...T);return F&&(q.pattern=F),q}l(E,w){return w.disregardExcludeSettings?void 0:(0,C.getExcludes)(E,!w.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const w=E.flatMap(j=>{let{pathPortion:V,globPortion:Q}=n(j);return Q&&(Q=g(Q)),this.n(V).flatMap(U=>this.o(U,Q))}),N=new Map;return w.forEach(j=>{const V=j.searchPath.toString(),Q=N.get(V);Q?j.pattern&&(Q.pattern=Q.pattern||{},Q.pattern[j.pattern]=!0):N.set(V,{searchPath:j.searchPath,pattern:j.pattern?s(j.pattern):void 0})}),Array.from(N.values())}n(E){if(y.isAbsolute(E)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==A.Schemas.file?[{searchPath:w[0].uri.with({path:E})}]:[{searchPath:v.URI.file(y.normalize(E))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(E=c(E),E.startsWith("../")||E===".."){const j=y.posix.resolve(w.path,E);return[{searchPath:w.with({path:j})}]}const N=g(E);return[{searchPath:w,pattern:N}]}else{if(E==="./"||E===".\\")return[];{const w=E.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(V=>{const Q=w.match(new RegExp(`^${O.escapeRegExpCharacters(V.name)}(?:/(.*)|$)`));return Q?{match:Q,folder:V}:null}).filter(P.isDefined);if(j.length)return j.map(V=>{const Q=V.match[1];return{searchPath:V.folder.uri,pattern:Q&&g(Q)}});{const V=E.match(/\.[\/\\](.+)[\/\\]?/),Q=V?V[1]:E,q=D.localize(0,null,Q);throw new Error(q)}}}}o(E,w){const N=E.pattern&&w?`${E.pattern}/${w}`:E.pattern||w,j=[{searchPath:E.searchPath,pattern:N}];return N&&!N.endsWith("**")&&j.push({searchPath:E.searchPath,pattern:N+"/**"}),j}q(E,w,N){const j=this.r((0,u.toWorkspaceFolder)(E.searchPath),w,N,!1);return j?{...j,includePattern:E.pattern}:null}r(E,w,N,j){let V;const Q=v.URI.isUri(E)?E:E.uri;if(N.searchPaths){const B=N.searchPaths.filter(Z=>(0,I.isEqual)(Z.searchPath,Q))[0];if(B&&!B.pattern)return null;B&&(V=B.pattern)}const q=this.a.getValue({resource:Q}),T={...this.l(q,w)||{},...V||{}},F=v.URI.isUri(E)?(0,I.basename)(E):E.name;return{folder:Q,folderName:j?F:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!q.search.followSymlinks}}};p=xe([ze(0,f.IConfigurationService),ze(1,u.IWorkspaceContextService),ze(2,m.IEditorGroupsService),ze(3,d.ILogService),ze(4,b.IPathService)],p),e.QueryBuilder=p;function n(h){const E=h.match(/[\*\{\}\(\)\[\]\?]/);if(E){const w=E.index,N=h.substr(0,w).match(/[/|\\][^/\\]*$/);if(N){let j=h.substr(0,N.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((N.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((E,w)=>(E[w]=!0,E),Object.create(null)):void 0}function r(h){return l.splitGlobAware(h,",").map(E=>E.trim()).filter(E=>!!E.length)}function a(h){return[`**/${h}/**`,`**/${h}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function c(h){return h.replace(/\\/g,"/")}function g(h){return c(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function i(h){return h.replace(/([?*[\]])/g,"[$1]")}function t(h,E){h=o.distinct(h,j=>j.toString());const w=[],N=E.getWorkspace();return h&&h.forEach(j=>{let V;if(E.getWorkbenchState()===2)V=(0,I.relativePath)(N.folders[0].uri,j),V&&V!=="."&&(V="./"+V);else{const Q=E.getWorkspaceFolder(j);if(Q){const q=Q.name;if(N.folders.filter(T=>T.name===q).length===1){const T=(0,I.relativePath)(Q.uri,j);T===""?V=`./${Q.name}`:V=`./${Q.name}/${T}`}else V=j.fsPath}}V&&w.push(i(V))}),w}e.resolveResourcesForSearchIncludes=t}),define(ye[297],De([1,0,24,2,21,10,4,296,31,47]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function P(f,d){const u=d.activationEvents;if(!u)return Promise.resolve(void 0);const m=[],b=[];for(const a of u)if(/^workspaceContains:/.test(a)){const c=a.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||f.forceUsingSearch?b.push(c):m.push(c)}if(m.length===0&&b.length===0)return Promise.resolve(void 0);let C;const p=new Promise((a,c)=>{C=a}),n=a=>C({activationEvent:a}),s=Promise.all(m.map(a=>v(f,a,n))).then(()=>{}),r=k(f,d.identifier,b,n);return Promise.all([s,r]).then(()=>{C(void 0)}),p}e.checkActivateWorkspaceContainsExtension=P;async function v(f,d,u){for(const m of f.folders)if(await f.exists(o.joinPath(L.URI.revive(m),d))){u(`workspaceContains:${d}`);return}}async function k(f,d,u,m){if(u.length===0)return Promise.resolve(void 0);const b=new l.CancellationTokenSource,C=f.checkExists(f.folders,u,b.token),p=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},O);let n=!1;try{n=await C}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}b.dispose(),clearTimeout(p),n&&m(`workspaceContains:${u.join(",")}`)}function D(f,d,u,m){const b=f.get(S.IInstantiationService),C=f.get(y.ISearchService),n=b.createInstance(A.QueryBuilder).file(d.map(s=>(0,I.toWorkspaceFolder)(L.URI.revive(s))),{_reason:"checkExists",includePattern:u,exists:!0});return C.fileSearch(n,m).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=D});var _e=this&&this.__classPrivateFieldSet||function(re,e,o,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,o):l?l.value=o:e.set(re,o),o},Ue=this&&this.__classPrivateFieldGet||function(re,e,o,L){if(o==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?L:o==="a"?L.call(re):L?L.value:e.get(re)};define(ye[42],De([1,0,178,12,83,24,19,6,68,2,13,5,35,239,99,34,26,134,10,27,22,221,7,128,4,25,79,20,91,55,41,3,297,98,223,16,97,43,11]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p,n,s,r,a,c,g,i,t,h,E,w,N,j,V,Q,q,U){"use strict";var T,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Z=class Ui extends A.Disposable{constructor(X,J,ee,me,ve,Ie,Re,ae,le,ue,ne){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=J,this.g=ee,this.f=Re,this.j=me,this.k=ve,this.l=Ie,this.m=le,this.p=ue,this.s=ne,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new S.Barrier,this.y=new S.Barrier,this.z=new S.Barrier,this.C=new S.Barrier,this.F=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const ce=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new u.ExtensionDescriptionRegistry(Y(this.F,ce)),this.G=new D.ExtHostStorage(this.g,this.l),this.H=new N.ExtHostSecretState(this.g),this.I=ae,this.h=X.createChild(new i.ServiceCollection([D.IExtHostStorage,this.G],[N.IExtHostSecretState,this.H])),this.J=this.B(new k.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(oe,M,z)=>{this.v.$onExtensionActivationError(oe,m.transformErrorForSerialization(M),z)},actualActivateExtension:async(oe,M)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(oe,this.D,this.F))return await this.v.$activateExtension(oe,M),new k.HostExtension;const z=this.D.getExtensionDescription(oe);return this.Y(z,M)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.lb()}catch(X){m.onUnexpectedError(X)}}async Q(){this.I.onWillDeactivateAll();let X=[];try{X=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(X)}terminate(X,J=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${X}`),this.l.flush(),this.p.dispose(),this.J.dispose(),m.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const ee=this.Q();Promise.race([(0,S.timeout)(5e3),ee]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${J}`):this.l.info(`Extension host exiting with code ${J}`),this.l.flush(),this.l.dispose(),this.c.exit(J)})}isActivated(X){return this.z.isOpen()?this.J.isActivated(X):!1}async getExtension(X){const J=await this.v.$getExtension(X);let ee;if(J?.browserNlsBundleUris){ee={};for(const me of Object.keys(J.browserNlsBundleUris))ee[me]=I.URI.revive(J.browserNlsBundleUris[me])}return J&&{...J,identifier:new b.ExtensionIdentifier(J.identifier.value),extensionLocation:I.URI.revive(J.extensionLocation),browserNlsBundleUris:ee}}R(X,J){return this.J.activateByEvent(X,J)}S(X,J){return this.J.activateById(X,J)}activateByIdWithErrors(X,J){return this.S(X,J).then(()=>{const ee=this.J.getActivatedExtension(X);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(X=>this.D)}getExtensionExports(X){return this.z.isOpen()?this.J.getActivatedExtension(X).exports:null}async U(X){if(X.scheme!==V.Schemas.file)return X;const J=await this.c.realpath(X.fsPath);return I.URI.file(J)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(X=>new ie(X))),this.L}async W(X){const J=y.TernarySearchTree.forUris(ee=>R.extUriBiasedIgnorePathCase.ignorePathCasing(ee));return await Promise.all(X.map(async ee=>{if(this.pb(ee)){const me=await this.U(ee.extensionLocation);J.set(me,ee)}})),J}X(X){let J=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(X))return J;const ee=this.J.getActivatedExtension(X);if(!ee)return J;try{typeof ee.module.deactivate=="function"&&(J=Promise.resolve(ee.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${X.value}':`),this.l.error(me)}try{(0,A.dispose)(ee.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.l.error(me)}return J}async Y(X,J){return this.f.remote.isRemote?this.v.$onWillActivateExtension(X.identifier):await this.v.$onWillActivateExtension(X.identifier),this.ab(X,J).then(ee=>{const me=ee.activationTimes;return this.v.$onDidActivateExtension(X.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,J),this.Z(X,J,"success",me),ee},ee=>{throw this.Z(X,J,"failure"),ee})}Z(X,J,ee,me){const ve=_(X,J);this.u.$publicLog2("extensionActivationTimes",{...ve,...me||{},outcome:ee})}ab(X,J){const ee=_(X,J);this.u.$publicLog2("activatePlugin",ee);const me=this.pb(X);if(!me)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${X.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this.l.flush();const ve=new k.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this.qb(X,(0,R.joinPath)(X.extensionLocation,me),ve),this.bb(X)]).then(Ie=>(l.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Ui.cb(this.l,X.identifier,Ie[0],Ie[1],ve))).then(Ie=>(l.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Ie))}bb(X){const J=new p.ExtensionGlobalMemento(X,this.G),ee=new p.ExtensionMemento(X.identifier.value,!1,this.G),me=new j.ExtensionSecrets(X,this.H),ve=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,Ie=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([J.whenReady,ee.whenReady,this.I.whenReady]).then(()=>{const Re=this;let ae,le;const ue=(0,d.isProposedApiEnabled)(X,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:ee,secrets:me,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(ne){return L.join(X.extensionLocation.fsPath,ne)},get storagePath(){return Re.I.workspaceValue(X)?.fsPath},get globalStoragePath(){return Re.I.globalValue(X).fsPath},get logPath(){return L.join(Re.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return I.URI.joinPath(Re.f.logsLocation,X.identifier.value)},get storageUri(){return Re.I.workspaceValue(X)},get globalStorageUri(){return Re.I.globalValue(X)},get extensionMode(){return ve},get extension(){return ae===void 0&&(ae=new H(Re,X.identifier,X,Ie,!1)),ae},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(X,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!le){if(!ue)return;const ne=E.Event.buffer(E.Event.fromDOMEventEmitter(ue,"message",ce=>ce.data));ue.start(),le={onDidReceiveMessage:ne,postMessage:ue.postMessage.bind(ue)}}return le}})})}static cb(X,J,ee,me,ve){return ee=ee||{activate:void 0,deactivate:void 0},this.db(X,J,ee,me,ve).then(Ie=>new k.ActivatedExtension(!1,null,ve.build(),ee,Ie,me.subscriptions))}static db(X,J,ee,me,ve){if(typeof ee.activate=="function")try{ve.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Ie=typeof global=="object"?global:self,Re=ee.activate.apply(Ie,[me]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Re).then(ae=>(ve.activateResolveStop(),ae))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(ee)}eb(X,J){this.S(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:J}).then(void 0,ee=>{this.l.error(ee)})}fb(X,J=0){const me=Date.now();(0,U.setTimeout0)(()=>{for(let ve=J;ve<X.length;ve+=1){const Ie=X[ve];for(const Re of Ie.activationEvents??[])if(Re==="onStartupFinished")if(Date.now()-me>50){this.fb(X,ve);break}else this.eb(Ie,Re)}})}gb(){this.v.$setPerformanceMarks(l.getMarks()),this.k.getConfigProvider().then(X=>{const J=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ee=this.D.getAllExtensionDescriptions();if(J)this.fb(ee);else for(const me of ee)if(me.activationEvents)for(const ve of me.activationEvents)ve==="onStartupFinished"&&this.eb(me,ve)})}hb(){const X=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.ib(ve.added)));const J=this.j.workspace?this.j.workspace.folders:[],ee=this.ib(J),me=Promise.all([X,ee]).then(()=>{});return Promise.race([me,(0,S.timeout)(1e4)]).then(()=>{this.gb()}),me}ib(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(J=>this.jb(X,J))).then(()=>{})}async jb(X,J){if(this.isActivated(J.identifier))return;const ee=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:X.map(Ie=>Ie.uri),forceUsingSearch:ee,exists:Ie=>this.c.exists(Ie.fsPath),checkExists:(Ie,Re,ae)=>this.t.$checkExists(Ie,Re,ae)},ve=await(0,w.checkActivateWorkspaceContainsExtension)(me,J);if(!!ve)return this.S(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:ve.activationEvent}).then(void 0,Ie=>this.l.error(Ie))}async $extensionTestsExecute(){await this.C.wait();try{return await this.kb()}catch(X){throw console.error(X),X}}async kb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:J}=this.f.environment;if(!X||!J)throw new Error(o.localize(0,null));const ee=await this.qb(null,J,new k.ExtensionActivationTimesBuilder(!1));if(!ee||typeof ee.run!="function")throw new Error(o.localize(1,null,J.toString()));return new Promise((me,ve)=>{const Ie=(le,ue)=>{le?ve(le):me(typeof ue=="number"&&ue>0?1:0)},Re=(0,R.originalFSPath)(J),ae=ee.run(Re,Ie);ae&&ae.then&&ae.then(()=>{me(0)}).catch(le=>{ve(le instanceof Error&&le.stack?le.stack:String(le))})})}lb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.hb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,J){return this.M[X]=J,(0,A.toDisposable)(()=>{delete this.M[X]})}async mb(X){const J=X.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const ee=X.substr(0,J);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this.M[ee]}}async $resolveAuthority(X,J){const ee=q.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(X)},${J})][${ee.elapsed()}ms] `,ve=ue=>this.l.info(`${me()}${ue}`),Ie=(ue,ne=void 0)=>this.l.error(`${me()}${ue}`,ne);ve("activating resolver...");const{authorityPrefix:Re,resolver:ae}=await this.mb(X);if(!ae)return Ie("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Re}.`,detail:void 0}};const le=new S.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(ae)),le.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${Re}`);const ue=await ae.resolve(X,{resolveAttempt:J});l.mark(`code/extHost/didResolveAuthorityOK/${Re}`),le.dispose(),ve(`returned ${ue.host}:${ue.port}`);const ne={authority:X,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ce={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:ce,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(l.mark(`code/extHost/didResolveAuthorityError/${Re}`),le.dispose(),Ie("returned an error",ue),ue instanceof n.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(X,J){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(X)})`);const{resolver:ee}=await this.mb(X);if(!ee)return null;const me=I.URI.revive(J);if(typeof ee.getCanonicalURI>"u")return me;const ve=await(0,S.asPromise)(()=>ee.getCanonicalURI(me));return ve||me}static nb(X,J,ee){const me=new u.ExtensionDescriptionRegistry(X.getAllExtensionDescriptions());me.deltaExtensions(ee.toAdd,ee.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(J.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of ee.myToRemove)ve.delete(b.ExtensionIdentifier.toKey(Re));for(const Re of ee.myToAdd)ve.add(b.ExtensionIdentifier.toKey(Re));const Ie=Y(me,ve);return{globalRegistry:me,myExtensions:Ie}}$startExtensionHost(X){X.toAdd.forEach(me=>me.extensionLocation=I.URI.revive(me.extensionLocation));const{globalRegistry:J,myExtensions:ee}=Ui.nb(this.F,this.D,X);return this.F.set(J.getAllExtensionDescriptions()),this.D.set(ee),this.lb()}$activateByEvent(X,J){return J===1?this.R(X,!1):this.z.wait().then(ee=>this.R(X,!1))}async $activate(X,J){return await this.z.wait(),this.D.getExtensionDescription(X)?(await this.S(X,J),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Ie=>Ie.extensionLocation=I.URI.revive(Ie.extensionLocation));const{globalRegistry:J,myExtensions:ee}=Ui.nb(this.F,this.D,X),me=await this.W(ee);return(await this.getExtensionPathIndex()).setSearchTree(me),this.F.set(J.getAllExtensionDescriptions()),this.D.set(ee),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const J=C.VSBuffer.alloc(X),ee=Math.random()%256;for(let me=0;me<X;me++)J.writeUInt8(ee,me);return J}async $updateRemoteConnectionData(X){this.P=X,this.a.fire()}};Z=xe([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,g.IExtHostRpcService),ze(3,f.IExtHostWorkspace),ze(4,v.IExtHostConfiguration),ze(5,O.ILogService),ze(6,a.IExtHostInitDataService),ze(7,c.IExtensionStoragePaths),ze(8,t.IExtHostTunnelService),ze(9,h.IExtHostTerminalService),ze(10,Q.IExtHostLocalizationService)],Z),e.AbstractExtHostExtensionService=Z;function _(ge,X){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class H{constructor(X,J,ee,me,ve){T.set(this,void 0),F.set(this,void 0),B.set(this,void 0),_e(this,T,X,"f"),_e(this,F,J,"f"),_e(this,B,ee.identifier,"f"),this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=L.normalize((0,R.originalFSPath)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=me,this.isFromDifferentExtensionHost=ve}get isActive(){return Ue(this,T,"f").isActivated(Ue(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,T,"f").getExtensionExports(Ue(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,T,"f").activateByIdWithErrors(Ue(this,B,"f"),{startup:!1,extensionId:Ue(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=H,T=new WeakMap,F=new WeakMap,B=new WeakMap;function Y(ge,X){return ge.getAllExtensionDescriptions().filter(J=>X.has(b.ExtensionIdentifier.toKey(J.identifier)))}class ie{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.ExtensionPaths=ie}),define(ye[298],De([1,0,83,2,5,35,26,27,20,25,4,42,36,13,8]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(p,n,s,r,a,c,g){this.c=p,this.d=n,this.e=s,this.f=r,this.g=a,this.h=c,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),o.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const n=await this.g.getExtensionPathIndex();this.register(new u(this.c,n,this.d,p,this.i)),this.register(this.e.createInstance(m,n)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,n,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const n of p.nodeModuleName)this.a.set(n,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(n=>p.alternativeModuleName(n))}};f=xe([ze(2,O.IInstantiationService),ze(3,R.IExtHostConfiguration),ze(4,P.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,k.ILogService)],f),e.RequireInterceptor=f;let d=class rn{constructor(p){if(p.environment.appRoot&&rn.a.size){const n=(0,D.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const n=this.b.exec(this.c(p));if(!n)return;const[,s,r,a]=n,c=rn.a.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),s+c+a}c(p){return p.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=xe([ze(0,I.IExtHostInitDataService)],d);class u{constructor(p,n,s,r,a){this.c=p,this.d=n,this.e=s,this.f=r,this.g=a,this.nodeModuleName="vscode",this.a=new Map}load(p,n){const s=this.d.findSubstr(n);if(s){let r=this.a.get(A.ExtensionIdentifier.toKey(s.identifier));return r||(r=this.c(s,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(s.identifier),r)),r}if(!this.b){let r="";this.d.forEach((a,c)=>r+=`	${c} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${r}`),this.b=this.c(S.nullExtensionDescription,this.e,this.f)}return this.b}}let m=class{constructor(p,n,s){this.d=p,this.nodeModuleName="keytar",this.a=n.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=s,a=n.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let c=r.appRoot.fsPath;v.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,g)=>a.$getPassword(c,g),setPassword:(c,g,i)=>a.$setPassword(c,g,i),deletePassword:(c,g)=>a.$deletePassword(c,g),findPassword:c=>a.$findPassword(c),findCredentials(c){return a.$findCredentials(c)}}}load(p,n){const s=this.d.findSubstr(n);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const n=p.length;if(n<=7||!this.b)return;const s=n-7;if((p.charAt(s)==="/"||p.charAt(s)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};m=xe([ze(1,y.IExtHostRpcService),ze(2,I.IExtHostInitDataService)],m);let b=class{constructor(p,n,s){this.e=p,this.f=n,this.nodeModuleName=["open","opn"],this.d=s.getProxy(l.MainContext.MainThreadTelemetry);const r=s.getProxy(l.MainContext.MainThreadWindow);this.c=(a,c)=>{const g=L.URI.parse(a);return c?this.g(a,c):g.scheme==="http"||g.scheme==="https"?r.$openUri(g,a,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?r.$openUri(g,a,{}):this.g(a,c)}}load(p,n,s){const r=this.e.findSubstr(n);return r&&(this.a=r.identifier.value,this.h()),this.b=s(p),this.c}g(p,n){return this.i(),this.b(p,n)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=xe([ze(2,y.IExtHostRpcService)],b)}),define(ye[49],De([1,0,65,6,12,36,4,59,60,42,7,34,235,35]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,S.createDecorator)("IExtHostVariableResolverProvider");class D extends v.AbstractVariableResolverService{constructor(u,m,b,C,p,n,s){function r(){if(b){const a=b.activeEditor();if(a)return a.document.uri;const c=C.tabGroups.all.find(g=>g.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof O.TextDiffTabInput||c.input instanceof O.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof O.TextTabInput||c.input instanceof O.NotebookEditorTabInput||c.input instanceof O.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:a=>{const c=n.folders.filter(g=>g.name===a);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(a,c)=>p.getConfiguration(void 0,a).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return l.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const a=r();if(a){const c=m.getWorkspaceFolder(a);if(c)return l.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(b){const a=b.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(b){const a=b.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>u.getExtension(a)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let f=class extends L.Disposable{constructor(u,m,b,C,p){super(),this.b=u,this.c=m,this.g=b,this.h=C,this.i=p,this.a=new o.Lazy(async()=>{const n=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.i,n,r,this.j())})}getResolver(){return this.a.value}j(){}};f=xe([ze(0,I.IExtHostExtensionService),ze(1,P.IExtHostWorkspace),ze(2,A.IExtHostDocumentsAndEditors),ze(3,k.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(ye[84],De([1,0,19,3,9,2,4,5,60,42,20,7,34,131,228,35,49]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,a,c,g,i,t){this.D=a,this.E=c,this.F=g,this.G=i,this.H=t,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new L.Emitter,this.n=new L.Emitter,this.o=new L.Emitter,this.u=new L.Emitter,this.k=r.getProxy(A.MainContext.MainThreadDebugService),this.z=new L.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(h=>{h.onDidChange(E=>{this.I(h)}),this.I(h)})}asDebugSourceUri(r,a){const c=r;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let g=`debug:${encodeURIComponent(c.path||"")}`,i="?";return a&&(g+=`${i}session=${encodeURIComponent(a.id)}`,i="&"),g+=`${i}ref=${c.sourceReference}`,R.URI.parse(g)}else{if(c.path)return R.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const a=[];for(const c of r.getAllExtensionDescriptions())if(c.contributes){const g=c.contributes.debuggers;if(g&&g.length>0)for(const i of g)(0,D.isDebuggerMainContribution)(i)&&a.push(i.type)}this.k.$registerDebugTypes(a)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(a=>r.push(a)),r}addBreakpoints(r){this.T();const a=r.filter(i=>{const t=i.id;return this.w.has(t)?!1:(this.w.set(t,i),!0)});this.U(a,[],[]);const c=[],g=new Map;for(const i of a)if(i instanceof P.SourceBreakpoint){let t=g.get(i.location.uri.toString());t||(t={type:"sourceMulti",uri:i.location.uri,lines:[]},g.set(i.location.uri.toString(),t),c.push(t)),t.lines.push({id:i.id,enabled:i.enabled,condition:i.condition,hitCondition:i.hitCondition,logMessage:i.logMessage,line:i.location.range.start.line,character:i.location.range.start.character})}else i instanceof P.FunctionBreakpoint&&c.push({type:"function",id:i.id,enabled:i.enabled,hitCondition:i.hitCondition,logMessage:i.logMessage,condition:i.condition,functionName:i.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(r){this.T();const a=r.filter(t=>this.w.delete(t.id));this.U([],a,[]);const c=a.filter(t=>t instanceof P.SourceBreakpoint).map(t=>t.id),g=a.filter(t=>t instanceof P.FunctionBreakpoint).map(t=>t.id),i=a.filter(t=>t instanceof P.DataBreakpoint).map(t=>t.id);return this.k.$unregisterBreakpoints(c,g,i)}startDebugging(r,a,c){return this.k.$startDebugging(r?r.uri:void 0,a,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,c){if(!a)return new P.Disposable(()=>{});const g=this.d++;return this.f.push({type:r,handle:g,provider:a}),this.k.$registerDebugConfigurationProvider(r,c,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,g),new P.Disposable(()=>{this.f=this.f.filter(i=>i.provider!==a),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(r,a,c){if(!c)return new P.Disposable(()=>{});if(!this.P(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.M(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:a,handle:g,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(a,g),new P.Disposable(()=>{this.h=this.h.filter(i=>i.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new P.Disposable(()=>{});const c=this.i++;return this.j.push({type:r,handle:c,factory:a}),new P.Disposable(()=>{this.j=this.j.filter(g=>g.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let c;const g=await this.W(r);return g&&(c={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,a)}J(r,a){if(r.type==="implementation")return new p(r.implementation)}K(){}async $startDASession(r,a){const c=this,g=await this.V(a);return this.R(this.M(g.type),g).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const t=this.L(i),h=this.J(t,g);if(!h)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const E=h;return this.A.set(r,E),this.Q(g).then(w=>(w&&this.B.set(r,w),E.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const j=N,V={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const Q=await this.C.sign(j.arguments.value);V.body={signature:Q},E.sendResponse(V)}else throw new Error("no signer")}catch(Q){V.success=!1,V.message=Q.message,E.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(N),N=(0,D.convertToVSCPaths)(N,!0),c.k.$acceptDAMessage(r,N)}),E.onError(N=>{w&&w.onError&&w.onError(N),this.k.$acceptDAError(r,N.name,N.message,N.stack)}),E.onExit(N=>{w&&w.onExit&&w.onExit((0,l.withNullAsUndefined)(N),void 0),this.k.$acceptDAExit(r,(0,l.withNullAsUndefined)(N),void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),E.startSession()))})}$sendDAMessage(r,a){a=(0,D.convertToDAPaths)(a,!1);const c=this.B.get(r);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(a),this.A.get(r)?.sendMessage(a)}$stopDASession(r){const a=this.B.get(r);this.B.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const c=this.A.get(r);return this.A.delete(r),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],c=[],g=[];if(r.added)for(const i of r.added){const t=i.id;if(t&&!this.w.has(t)){let h;if(i.type==="function")h=new P.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if(i.type==="data")h=new P.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const E=R.URI.revive(i.uri);h=new P.SourceBreakpoint(new P.Location(E,new P.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}(0,P.setBreakpointId)(h,t),this.w.set(t,h),a.push(h)}}if(r.removed)for(const i of r.removed){const t=this.w.get(i);t&&(this.w.delete(i),c.push(t))}if(r.changed){for(const i of r.changed)if(i.id){const t=this.w.get(i.id);if(t){if(t instanceof P.FunctionBreakpoint&&i.type==="function"){const h=t;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.functionName=i.functionName}else if(t instanceof P.SourceBreakpoint&&i.type==="source"){const h=t;h.enabled=i.enabled,h.condition=i.condition,h.hitCondition=i.hitCondition,h.logMessage=i.logMessage,h.location=new P.Location(R.URI.revive(i.uri),new P.Position(i.line,i.character))}g.push(t)}}}this.U(a,c,g)}$provideDebugConfigurations(r,a,c){return(0,o.asPromise)(async()=>{const g=this.O(r);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const i=await this.W(a);return g.provideDebugConfigurations(i,c)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(r,a,c,g){return(0,o.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.W(a);return i.resolveDebugConfiguration(t,c,g)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,c,g){return(0,o.asPromise)(async()=>{const i=this.O(r);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.W(a);return i.resolveDebugConfigurationWithSubstitutedVariables(t,c,g)})}async $provideDebugAdapter(r,a){const c=this.N(r);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.V(a);return this.R(c,g).then(i=>{if(!i)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.L(i)})}async $acceptDebugSessionStarted(r){const a=await this.V(r);this.m.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.V(r);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,a){(await this.V(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const g={session:await this.V(r),event:a.event,body:a.body};this.u.fire(g)}L(r){if(r instanceof P.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof P.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const a=this.h.filter(c=>c.type===r);if(a.length>0)return a[0].factory}N(r){const a=this.h.filter(c=>c.handle===r);if(a.length>0)return a[0].factory}O(r){const a=this.f.filter(c=>c.handle===r);if(a.length>0)return a[0].provider}P(r,a){if(r.contributes){const c=r.contributes.debuggers;if(c&&c.length>0){for(const g of c)if(g.label&&g.type&&g.type===a)return!0}}return!1}Q(r){const c=r.configuration.type,g=this.j.filter(i=>i.type===c||i.type==="*").map(i=>(0,o.asPromise)(()=>i.factory.createDebugAdapterTracker(r)).then(t=>t,t=>null));return Promise.race([Promise.all(g).then(i=>{const t=i.filter(h=>!!h);if(t.length>0)return new C(t)}),new Promise(i=>setTimeout(()=>i(void 0),1e3))]).catch(i=>{})}async R(r,a){const c=a.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new P.DebugAdapterServer(c));if(r){const i=await this.E.getExtensionRegistry();return(0,o.asPromise)(()=>r.createDebugAdapterDescriptor(a,this.S(a,i))).then(t=>{if(t)return t})}const g=await this.E.getExtensionRegistry();return Promise.resolve(this.S(a,g))}S(r,a){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,a,c){(r.length>0||a.length>0||c.length>0)&&this.z.fire(Object.freeze({added:r,removed:a,changed:c}))}async V(r){if(r)if(typeof r=="string"){const a=this.l.get(r);if(a)return a}else{let a=this.l.get(r.id);if(!a){const c=await this.W(r.folderUri),g=r.parent?this.l.get(r.parent):void 0;a=new m(this.k,r.id,r.type,r.name,c,r.configuration,g),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(r){if(r){const a=R.URI.revive(r);return this.D.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};u=xe([ze(0,O.IExtHostRpcService),ze(1,v.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,d.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class m{constructor(r,a,c,g,i,t,h){this.d=r,this.f=a,this.g=c,this.h=g,this.i=i,this.j=t,this.k=h}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,a){return this.d.$customDebugAdapterRequest(this.f,r,a)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=m;class b{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=b;class C{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.d.forEach(c=>c.onExit?c.onExit(r,a):void 0)}}class p extends k.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let n=class extends u{constructor(r,a,c,g,i,t){super(r,a,c,g,i,t)}};n=xe([ze(0,O.IExtHostRpcService),ze(1,v.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,d.IExtHostVariableResolverProvider)],n),e.WorkerExtHostDebugService=n}),define(ye[299],De([1,0,10,83,2,5,291,13,90,91,25,204,20,56,42,76]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(b){const C=b.get(A.ILogService),n=b.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{C.error(s);const r=o.transformErrorForSerialization(s);n.$onUnexpectedError(r)})}static async installFullHandler(b){const C=b.get(A.ILogService),p=b.get(v.IExtHostRpcService),n=b.get(D.IExtHostExtensionService),s=b.get(f.IExtHostTelemetry),r=p.getProxy(R.MainContext.MainThreadExtensionService),a=p.getProxy(R.MainContext.MainThreadErrors),c=await n.getExtensionPathIndex(),g=new WeakMap;Error.prepareStackTrace=(i,t)=>{let h="",E,w;for(const N of t)h+=`
	at ${N.toString()}`,w=N.getFileName(),!E&&w&&(E=c.findSubstr(l.URI.file(w)));return g.set(i,E?.identifier),`${i.name||"Error"}: ${i.message||""}${h}`},o.setUnexpectedErrorHandler(i=>{C.error(i);const t=o.transformErrorForSerialization(i),h=g.get(i);if(!h){a.$onUnexpectedError(t);return}r.$onExtensionRuntimeError(h,t);const E=s.onExtensionError(h,i);C.trace("forwarded error to extension?",E,h)})}}Error.stackTraceLimit=100;class u{constructor(b,C,p,n,s){this.a=p,this.b=new S.RPCProtocol(b,null,n),C=u.e(C,this.b);const r=new I.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:s}),r.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),r.set(k.IURITransformerService,new k.URITransformerService(n)),r.set(D.IHostUtils,p);const a=new P.InstantiationService(r,!0);a.invokeFunction(d.installEarlyHandler),this.d=a.invokeFunction(c=>c.get(A.ILogService)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",C),this.c=a.invokeFunction(c=>c.get(D.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(d.installFullHandler)}async asBrowserUri(b){const C=this.b.getProxy(R.MainContext.MainThreadExtensionService);return l.URI.revive(await C.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,C){b.allExtensions.forEach(n=>{n.extensionLocation=l.URI.revive(C.transformIncomingURIs(n.extensionLocation));const s={};n.browserNlsBundleUris&&(Object.keys(n.browserNlsBundleUris).forEach(r=>s[r]=l.URI.revive(C.transformIncomingURIs(n.browserNlsBundleUris[r]))),n.browserNlsBundleUris=s)}),b.environment.appRoot=l.URI.revive(C.transformIncomingURIs(b.environment.appRoot));const p=b.environment.extensionDevelopmentLocationURI;return p&&(b.environment.extensionDevelopmentLocationURI=p.map(n=>l.URI.revive(C.transformIncomingURIs(n)))),b.environment.extensionTestsLocationURI=l.URI.revive(C.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=l.URI.revive(C.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=l.URI.revive(C.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=l.URI.revive(C.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=l.URI.revive(C.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=l.URI.revive(C.transformIncomingURIs(b.logsLocation)),b.logFile=l.URI.revive(C.transformIncomingURIs(b.logFile)),b.workspace=C.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=u}),define(ye[300],De([1,0,19,11,185,203,211,84,60,42,20,41,7,49,34,229,231,35]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let m=class extends A.ExtHostDebugServiceBase{constructor(s,r,a,c,g,i,t){super(s,r,a,c,i,t),this.Z=g,this.X=new p}J(s,r){switch(s.type){case"server":return new f.SocketDebugAdapter(s);case"pipeServer":return new f.NamedPipeDebugAdapter(s);case"executable":return new f.ExecutableDebugAdapter(s,r.type)}return super.J(s,r)}S(s,r){const a=f.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),s.type);if(a)return new v.DebugAdapterExecutable(a.command,a.args,a.options)}K(){return new S.SignService}async $runInTerminal(s,r){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(Q=>{this.X.onTerminalClosed(Q)}));const a=await this.F.getConfigProvider(),c=this.Z.getDefaultShell(!0),g=this.Z.getDefaultShellArgs(!0),i=s.title||l.localize(0,null),t=JSON.stringify({shell:c,shellArgs:g});let h=await this.X.checkout(t,i),E,w=!1;if(h)E=s.cwd;else{const Q={shellPath:c,shellArgs:g,cwd:s.cwd,name:i,iconPath:new v.ThemeIcon("debug")};w=!0,h=this.Z.createTerminalFromOptions(Q,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(h,t)}h.show(!0);const N=await h.processId;w?await new Promise(Q=>setTimeout(Q,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?h.sendText("cls"):c.indexOf("bash")>=0?h.sendText("clear"):L.isWindows?h.sendText("cls"):h.sendText("clear"));const j=(0,d.prepareCommand)(c,s.args,!!s.argsCanBeInterpretedByShell,E,s.env);h.sendText(j);const V=this.onDidTerminateDebugSession(Q=>{Q.id===r&&(this.X.free(h),V.dispose())});return N}else if(s.kind==="external")return C(s,await this.F.getConfigProvider());return super.$runInTerminal(s,r)}};m=xe([ze(0,O.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,u.IExtHostConfiguration),ze(4,P.IExtHostTerminalService),ze(5,y.IExtHostEditorTabs),ze(6,k.IExtHostVariableResolverProvider)],m),e.ExtHostDebugService=m;let b;function C(n,s){if(!b)if(L.isWindows)b=new R.WindowsExternalTerminalService;else if(L.isMacintosh)b=new R.MacExternalTerminalService;else if(L.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=s.getConfiguration("terminal");return b.runInTerminal(n.title,n.cwd,n.args,n.env||{},r.external||{})}class p{constructor(){this.b=new Map}async checkout(s,r){const c=[...this.b.entries()].map(([g,i])=>(0,o.createCancelablePromise)(async t=>{if(g.name!==r||i.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await g.processId))return null;const h=Date.now();return i.lastUsedAt+p.a>h||t.isCancellationRequested||i.config!==s?null:(i.lastUsedAt=h,g)}));return await(0,o.firstParallel)(c,g=>!!g)}insert(s,r){this.b.set(s,{lastUsedAt:Date.now(),config:r})}free(s){const r=this.b.get(s);r&&(r.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}p.a=1e3}),define(ye[301],De([1,0,12,2,116,34,59,35,47,41,20,25,82,16,13,77,24,89,49]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(p,n,s,r,a,c,g,i,t){super(p,n,s,r,a,c,g,i),this.B=s,this.C=t,n.remote.isRemote&&n.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:n.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,n){const s=n;if(!n.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const r=v.TaskHandleDTO.from(s,this.B),a=await this.a.$getTaskExecution(r);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(a,n);return this.a.$executeTask(r).catch(()=>{}),c}else{const r=v.TaskDTO.from(n,p);if(r===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(r.execution)&&await this.x(r,n,!1);const a=await this.y(await this.a.$getTaskExecution(r),n);return this.a.$executeTask(r).catch(()=>{}),a}}u(p,n,s,r){const a=[];if(r)for(const c of r){this.z(c,s),(!c.definition||!p[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const g=v.TaskDTO.from(c,s.extension);g&&(a.push(g),v.CustomExecutionDTO.is(g.execution)&&n.push(this.x(g,c,!0)))}return{tasks:a,extension:s.extension}}async v(p){return p}async F(p){let n=p&&p.length>0?p[0]:void 0;if(!n){const s=L.URI.file((0,u.homedir)());n=new y.WorkspaceFolder({uri:s,name:d.basename(s),index:0})}return{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,n){const s=L.URI.revive(p),r={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(s),c=await this.b.getWorkspaceFolders2()??[],g=await this.C.getResolver(),i=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const t of n.variables)r.variables[t]=await g.resolveAsync(i,t);if(n.process!==void 0){let t;if(n.process.path!==void 0){t=n.process.path.split(o.delimiter);for(let h=0;h<t.length;h++)t[h]=await g.resolveAsync(i,t[h])}r.process=await l.win32.findExecutable(await g.resolveAsync(i,n.process.name),n.process.cwd!==void 0?await g.resolveAsync(i,n.process.cwd):void 0,t)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(p,n,s){return l.win32.findExecutable(p,n,s)}};b=xe([ze(0,O.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,R.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,A.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,D.ILogService),ze(7,f.IExtHostApiDeprecationService),ze(8,m.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[302],De([1,0,89,49]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends L.ExtHostVariableResolverProviderService{j(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(ye[143],De([1,0,15,19,21,45,16,12,24,2,31]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(m,b,C,p){this.d=m,this.e=b,this.f=C,this.g=p,this.a=null,this.b=!1,this.c=0}search(m,b){const C=this.d.folderQueries||[],p=new l.CancellationTokenSource;return b.onCancellationRequested(()=>p.cancel()),new Promise((n,s)=>{this.a=new k(m);let r=!1;const a=(c,g)=>{if(!r&&!this.b){const i=this.h(c);f(c)&&typeof this.d.maxResults=="number"&&this.c+i>this.d.maxResults&&(this.b=!0,r=!0,p.cancel(),c=this.j(c,this.d.maxResults-this.c));const t=this.h(c);this.c+=t,(t>0||!f(c))&&this.a.add(c,g)}};Promise.all(C.map((c,g)=>this.k(c,i=>a(i,g),p.token))).then(c=>{p.dispose(),this.a.flush();const g=c.some(i=>!!i&&!!i.limitHit);n({limitHit:this.b||g,messages:(0,o.flatten)(c.map(i=>i?.message?Array.isArray(i.message)?i.message:[i.message]:[])),stats:{type:this.g}})},c=>{p.dispose();const g=(0,R.toErrorMessage)(c);s(new Error(g))})})}h(m){return f(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,b){const C=Array.isArray(m.ranges)?m.ranges:[m.ranges],p=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:C.slice(0,b),preview:{matches:p.slice(0,b),text:m.preview.text},uri:m.uri}}async k(m,b,C){const p=new O.QueryGlobTester(this.d,m),n=[],s={report:c=>{if(!this.l(c))return;const g=m.folder.scheme===S.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(c.uri))):void 0,i=y.relativePath(m.folder,c.uri);if(i){const t=p.includedInQuery(i,A.basename(i),g);(0,L.isThenable)(t)?n.push(t.then(h=>{h&&b(c)})):t&&b(c)}}},r=this.n(m),a=await this.e.provideTextSearchResults(v(this.d.contentPattern),r,s,C);return n.length&&await Promise.all(n),a}l(m){if(f(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const b=(0,O.resolvePatternsForProvider)(this.d.includePattern,m.includePattern),C=(0,O.resolvePatternsForProvider)(this.d.excludePattern,m.excludePattern),p={folder:I.URI.from(m.folder),excludes:C,includes:b,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.f.toCanonicalName(m.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=P;function v(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class k{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new d(512,b=>this.g(b))}add(m,b){this.d&&(this.b!==b||!y.isEqual(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:m.uri,results:[]}),this.d.results.push(D(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.TextSearchResultsCollector=k;function D(u){return f(u)?{preview:{matches:(0,o.mapArrayOrNot)(u.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:u.preview.text},ranges:(0,o.mapArrayOrNot)(u.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function f(u){return!!u.preview}e.extensionResultIsMatch=f;class d{constructor(m,b){this.g=m,this.h=b,this.c=0,this.d=[],this.e=0}addItem(m,b){!m||this.j(m,b)}addItems(m,b){!m||this.k(m,b)}j(m,b){this.d.push(m),this.e+=b,this.l()}k(m,b){this.d=this.d.concat(m),this.e+=b,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}d.a=4e3,d.b=50,e.BatchedCollector=d}),define(ye[85],De([1,0,6,5,4,295,20,56,13,2,143]),function(re,e,o,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let P=class{constructor(f,d,u){this.k=f,this.l=d,this.n=u,this.c=this.k.getProxy(L.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const u=this.d++;return this.e.set(u,d),this.c.$registerTextSearchProvider(u,this.o(f)),(0,o.toDisposable)(()=>{this.g.delete(f),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(f,d){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const u=this.d++;return this.h.set(u,d),this.c.$registerFileSearchProvider(u,this.o(f)),(0,o.toDisposable)(()=>{this.i.delete(f),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(f,d,u,m){const b=v(u),C=this.h.get(f);if(C)return this.j.fileSearch(b,C,p=>{this.c.$handleFileMatch(f,d,p.map(n=>n.resource))},m);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,u,m){const b=this.e.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const C=v(u);return this.q(C,b).search(n=>this.c.$handleTextMatch(f,d,n),m)}$enableExtensionHostSearch(){}q(f,d){return new O.TextSearchManager(f,d,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};P=xe([ze(0,S.IExtHostRpcService),ze(1,A.IURITransformerService),ze(2,y.ILogService)],P),e.ExtHostSearch=P;function v(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(k),extraFileResources:D.extraFileResources&&D.extraFileResources.map(f=>I.URI.revive(f))}}e.reviveQuery=v;function k(D){return{...D,folder:I.URI.revive(D.folder)}}}),define(ye[303],De([1,0,90,142,34,139,35,40,59,41,82,84,85,99,55,77,141,78,48,98,76,60,140,13,220,49,97]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p,n,s,r,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,n.ExtHostLoggerService,1),(0,o.registerSingleton)(s.ILogService,r.ExtHostLogService,1),(0,o.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,o.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration,0),(0,o.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,o.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,o.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(m.IExtHostFileSystemInfo,m.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService,1),(0,o.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,o.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,0),(0,o.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,o.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(D.IExtHostTunnelService,D.ExtHostTunnelService,0),(0,o.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,o.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,o.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,o.registerSingleton)(C.IExtHostTelemetry,C.ExtHostTelemetry,0),(0,o.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,o.registerSingleton)(a.IExtHostVariableResolverProvider,a.ExtHostVariableResolverProviderService,0)}),define(ye[100],De([1,0,15,13,31,81]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function S(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=S;function A(P,v,k,D){const f=(0,o.mapArrayOrNot)(k,y),d=new l.TextSearchMatch(v,f,D),u=d.preview.matches;return{ranges:(0,o.mapArrayOrNot)(f,I),uri:P,preview:{text:d.preview.text,matches:(0,o.mapArrayOrNot)(u,I)}}}e.createTextSearchResult=A;function y(P){return new l.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function I(P){return new R.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let O=class{constructor(v,k){this.a=v,this.b=k}appendLine(v){this.b.debug(`${this.a}#search`,v)}};O=xe([ze(1,L.ILogService)],O),e.OutputChannel=O}),define(ye[304],De([1,0,46,12,86,33,11,8,100,305]),function(re,e,o,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const O=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(b,C,p,n){const s=v(b,C,p,n),r=C.folder.fsPath;return{cmd:o.spawn(O,s.args,{cwd:r}),rgDiskPath:O,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=P;function v(b,C,p,n){const s=["--files","--hidden","--case-sensitive"];D([C],p,!1).forEach(a=>{const c=(0,y.anchorGlob)(a);if(s.push("-g",c),S.isMacintosh){const g=(0,l.normalizeNFD)(c);g!==c&&s.push("-g",g)}});const r=k([C],n,void 0,!1);return r.globArgs.forEach(a=>{const c=`!${(0,y.anchorGlob)(a)}`;if(s.push("-g",c),S.isMacintosh){const g=(0,l.normalizeNFD)(c);g!==c&&s.push("-g",g)}}),C.disregardIgnoreFiles!==!1?s.push("--no-ignore"):C.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),C.ignoreSymlinks||s.push("--follow"),b.exists&&s.push("--quiet"),s.push("--no-config"),C.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function k(b,C,p,n=!0){const s=[];let r={};return b.forEach(a=>{const c=Object.assign({},a.excludePattern||{},C||{}),g=f(c,n?a.folder.fsPath:void 0,p);s.push(...g.globArgs),g.siblingClauses&&(r=Object.assign(r,g.siblingClauses))}),{globArgs:s,siblingClauses:r}}function D(b,C,p=!0){const n=[];return b.forEach(s=>{const r=Object.assign({},C||{},s.includePattern||{}),a=f(r,p?s.folder.fsPath:void 0);n.push(...a.globArgs)}),n}function f(b,C,p){const n=[],s={};return Object.keys(b).forEach(r=>{if(p&&p.has(r)||!r)return;const a=b[r];r=u(C?d(C,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof a=="boolean"&&a?(r.startsWith("\\\\")&&(r+="**"),n.push(m(r))):a&&a.when&&(s[r]=a)}),{globArgs:n,siblingClauses:s}}function d(b,C){return L.isAbsolute(C)?C:L.join(b,C)}e.getAbsoluteGlob=d;function u(b){return b=A.rtrim(b,"\\"),A.rtrim(b,"/")}function m(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=m}),define(ye[306],De([1,0,46,70,12,307,15,45,38,86,33,11,43,8,9,29,31,304,111]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(r=>r())});class C{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&y.parse(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,m.prepareQuery)(this.b).normalizedLowercase),this.u=a.excludePattern&&y.parse(a.excludePattern),this.t=new Map,a.folderQueries.forEach(c=>{const g=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),i=c.folder.fsPath;a.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==i).forEach(t=>{(0,O.isEqualOrParent)(t,i)&&(g[l.relative(i,t)]=!0)}),this.t.set(i,new n(g,i))})}cancel(){this.l=!0,b.forEach(a=>a())}walk(a,c,g,i,t){if(this.m=v.StopWatch.create(!1),this.l)return t(null,this.j);c.forEach(h=>{const E=l.basename(h.fsPath);this.u&&this.u(h.fsPath,E)||this.J(g,{relativePath:h.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(a,(h,E)=>{this.x(this.y,this,h,g,i,w=>{if(w){const N=(0,A.toErrorMessage)(w);console.error(N),this.q.push(N),E(w,void 0)}else E(null,void 0)})},(h,E)=>{this.m.stop();const w=h?S.coalesce(h)[0]:null;t(w,this.j)})}w(a,c,g){const i=new Array(a.length),t=new Array(a.length);let h=!1,E=0;if(a.length===0)return g(null,[]);a.forEach((w,N)=>{c(w,(j,V)=>{if(j?(h=!0,i[N]=null,t[N]=j):(i[N]=V,t[N]=null),++E===a.length)return g(h?t:null,i)})})}x(a,c,...g){try{a.apply(c,g)}catch(i){g[g.length-1](i)}}y(a,c,g,i){const t=a.folder.fsPath,h=P.isMacintosh,E=()=>Q&&Q.kill();b.add(E);let w=F=>{b.delete(E),w=()=>{},i(F)},N="";const j=this.D(),V=(0,u.spawnRipgrepCmd)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),Q=V.cmd,q=!Object.keys(V.siblingClauses).length,U=V.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let T=`${V.rgDiskPath} ${U}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),g({message:T}),this.s=0,this.z(Q,"utf8",g,(F,B,Z)=>{if(F){w(F);return}if(this.j){w();return}const H=(N+(h?I.normalizeNFC(B||""):B)).split(`
`);if(Z){const Y=H.length;H[Y-1]=H[Y-1].trim(),H[Y-1]||H.pop()}else N=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=H.length,q){for(const Y of H)if(this.J(c,{base:t,relativePath:Y,searchPath:this.N(a,Y)}),this.j){E();break}(Z||this.j)&&w();return}this.G(a,j,t,H,c),Z&&(this.H(j,t,c),w())})}spawnFindCmd(a){const c=this.t.get(a.folder.fsPath),g=c.getBasenameTerms(),i=c.getPathTerms(),t=["-L","."];if(g.length||i.length){t.push("-not","(","(");for(const h of g)t.push("-name",h),t.push("-o");for(const h of i)t.push("-path",h),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),o.spawn("find",t,{cwd:a.folder.fsPath})}readStdout(a,c,g){let i="";this.z(a,c,()=>{},(t,h,E)=>{if(t){g(t);return}i+=h,E&&g(null,i)})}z(a,c,g,i){let t=(w,N,j)=>{(w||j)&&(t=()=>{},this.r?.stop()),i(w,N,j)},h=!1;a.stdout?(this.A(a.stdout,c,t),a.stdout.once("data",()=>h=!0)):g({message:"stdout is null"});let E;a.stderr?E=this.B(a.stderr):g({message:"stderr is null"}),a.on("error",w=>{t(w)}),a.on("close",w=>{let N;!h&&(N=this.C(E,c))&&s(N)?t(new Error(`command failed with error code ${w}: ${this.C(E,c)}`)):(this.g&&w===0&&(this.j=!0),t(null,"",!0))})}A(a,c,g){const i=new R.StringDecoder(c);return a.on("data",t=>{g(null,i.write(t))}),i}B(a){const c=[];return a.on("data",g=>{c.push(g)}),c}C(a,c){const g=new R.StringDecoder(c);return a.map(i=>g.write(i)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:c},g,i,t){i.indexOf(this.b)!==-1&&this.J(t,{base:g,relativePath:this.b,searchPath:this.N(a,this.b)});const h=E=>{const w=l.basename(E),N=l.dirname(E);let j=c[N];j||(j=c[N]=[],h(N)),j.push({base:g,relativePath:E,basename:w,searchPath:this.N(a,E)})};i.forEach(h)}H({rootEntries:a,pathToEntries:c},g,i){const t=this,h=this.t.get(g),E=this.b;function w(N){t.o++;const j=(0,d.hasSiblingFn)(()=>N.map(V=>V.basename));for(let V=0,Q=N.length;V<Q;V++){const q=N[V],{relativePath:U,basename:T}=q;if(h.test(U,T,E!==T?j:void 0))continue;const F=c[U];if(F)w(F);else{if(t.p++,U===E)continue;t.J(i,q)}if(t.j)break}}w(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,c,g,i,t){const h=a.folder,E=(0,d.hasSiblingFn)(()=>g);this.w(g,(w,N)=>{if(this.l||this.j)return N(null);const j=c?[c,w].join(l.sep):w;if(this.t.get(a.folder.fsPath).test(j,w,this.a.filePattern!==w?E:void 0))return N(null);const V=[h.fsPath,j].join(l.sep);L.lstat(V,(Q,q)=>{if(Q||this.l||this.j)return N(null);this.L(V,q,(U,T)=>U||this.l||this.j?N(null):T.isDirectory()?(this.o++,this.M(V,q,(F,B)=>F||this.l||this.j||(B=B||"",this.v[B])?N(null):(this.v[B]=!0,f.Promises.readdir(V).then(Z=>{if(this.l||this.j)return N(null);this.I(a,j,Z,i,_=>N(_||null))},Z=>{N(null)})))):(this.p++,j===this.b||this.h&&D.isNumber(T.size)&&T.size>this.h||this.J(i,{base:h.fsPath,relativePath:j,searchPath:this.N(a,j)}),N(null,void 0)))})},w=>{const N=w&&S.coalesce(w);return t(N&&N.length>0?N[0]:void 0)})}J(a,c){this.K(c)&&(!this.d||this.d(c.relativePath,l.basename(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(c))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(a,this.c)}return!0}L(a,c,g){return c.isSymbolicLink()?L.stat(a,g):g(null,c)}M(a,c,g){return c.isSymbolicLink()?L.realpath(a,(i,t)=>i?g(i):g(null,t)):g(null,a)}N(a,c){return a.folderName?l.join(a.folderName,c):c}}e.FileWalker=C;class p{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new C(a)}search(a,c,g){this.c.walk(this.a,this.b,a,c,(i,t)=>{g(i,{limitHit:t,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class n{constructor(a,c){this.expression=a,this.c=c,this.d(a)}d(a){let c,g;Object.keys(a).filter(i=>a[i]).forEach(i=>{l.isAbsolute(i)?(c=c||y.getEmptyExpression(),c[i]=a[i]):(g=g||y.getEmptyExpression(),g[i]=a[i])}),this.a=c&&y.parse(c,{trimForExclusions:!0}),this.b=g&&y.parse(g,{trimForExclusions:!0})}test(a,c,g){return this.b&&this.b(a,c,g)||this.a&&this.a(l.join(this.c,a),c,g)}getBasenameTerms(){const a=[];return this.a&&a.push(...y.getBasenameTerms(this.a)),this.b&&a.push(...y.getBasenameTerms(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...y.getPathTerms(this.a)),this.b&&a.push(...y.getPathTerms(this.b)),a}}function s(r){const a=r.trim().split(`
`),c=a[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return k.uppercaseFirstLetter(a[a.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ye[308],De([1,0,103,22]),function(re,e,o,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,S=512,A=512*8,y=512*128;var I;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class O extends Error{constructor(a,c){super(a),this.decodeStreamErrorKind=c}}e.DecodeStreamError=O;class P{static async create(a){let c;if(a!==e.UTF8)c=(await new Promise((i,t)=>{re(["@vscode/iconv-lite-umd"],i,t)})).getDecoder(f(a));else{const g=new TextDecoder;c={write(i){return g.decode(i,{stream:!0})},end(){return g.decode()}}}return new P(c)}constructor(a){this.a=a}write(a){return this.a.write(a)}end(){return this.a.end()}}function v(r,a){const c=a.minBytesRequiredForDetection??a.guessEncoding?A:S;return new Promise((g,i)=>{const t=(0,o.newWriteableStream)(V=>V.join("")),h=[];let E=0,w;const N=async()=>{try{const V=await s({buffer:L.VSBuffer.concat(h),bytesRead:E},a.guessEncoding);if(V.seemsBinary&&a.acceptTextOnly)throw new O("Stream is binary but only text is accepted for decoding",1);V.encoding=await a.overwriteEncoding(V.encoding),w=await P.create(V.encoding);const Q=w.write(L.VSBuffer.concat(h).buffer);t.write(Q),h.length=0,E=0,g({stream:t,detected:V})}catch(V){j?.dispose(),t.destroy(),i(V)}},j=(0,o.listenStream)(r,{onData:async V=>{w?t.write(w.write(V.buffer)):(h.push(V),E+=V.byteLength,E>=c&&(r.pause(),await N(),setTimeout(()=>r.resume())))},onError:V=>t.error(V),onEnd:async()=>{w||await N(),t.end(w?.end())}})})}e.toDecodeStream=v;async function k(r,a,c){const i=(await new Promise((E,w)=>{re(["@vscode/iconv-lite-umd"],E,w)})).getEncoder(f(a),c);let t=!1,h=!1;return{read(){if(h)return null;const E=r.read();if(typeof E!="string"){if(h=!0,!t&&c?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const w=i.end();return w&&w.length>0?(t=!0,L.VSBuffer.wrap(w)):null}return t=!0,L.VSBuffer.wrap(i.write(E))}}}e.toEncodeReadable=k;async function D(r){return(await new Promise((c,g)=>{re(["@vscode/iconv-lite-umd"],c,g)})).encodingExists(f(r))}e.encodingExists=D;function f(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=f;function d(r,a){if(!r||a<e.UTF16be_BOM.length)return null;const c=r.readUInt8(0),g=r.readUInt8(1);if(c===e.UTF16be_BOM[0]&&g===e.UTF16be_BOM[1])return e.UTF16be;if(c===e.UTF16le_BOM[0]&&g===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const i=r.readUInt8(2);return c===e.UTF8_BOM[0]&&g===e.UTF8_BOM[1]&&i===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const u=["ascii","utf-16","utf-32"];async function m(r){const a=await new Promise((h,E)=>{re(["jschardet"],h,E)}),c=r.slice(0,y),g=p(c.buffer),i=a.detect(g);if(!i||!i.encoding)return null;const t=i.encoding.toLowerCase();return 0<=u.indexOf(t)?null:C(i.encoding)}const b={ibm866:"cp866",big5:"cp950"};function C(r){const a=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[a]||a}function p(r){let a="";for(let c=0;c<r.length;c++)a+=String.fromCharCode(r[c]);return a}function n(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=r.match(/windows(\d+)/);return a?"windows-"+a[1]:r}}}e.toCanonicalName=n;function s({buffer:r,bytesRead:a},c){let g=d(r,a),i=!1;if(g!==e.UTF16be&&g!==e.UTF16le&&r){let t=!0,h=!0,E=!1;for(let w=0;w<a&&w<R;w++){const N=w%2===1,j=r.readUInt8(w)===0;if(j&&(E=!0),t&&(N&&!j||!N&&j)&&(t=!1),h&&(N&&j||!N&&!j)&&(h=!1),j&&!t&&!h)break}E&&(t?g=e.UTF16le:h?g=e.UTF16be:i=!0)}return c&&!i&&!g&&r?m(r.slice(0,a)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:i,encoding:g}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],De([1,0,308,29,143]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends l.TextSearchManager{constructor(A,y,I=L,O="searchProcess"){super(A,y,{readdir:P=>I.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,o.toCanonicalName)(P)},O)}}e.NativeTextSearchManager=R}),define(ye[309],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(l){if(l&&this.a.has(l)){const R=this.a.get(l);return this.a.delete(l),R}}addDragOperationTransfer(l,R){this.a.set(l,R)}getRenderedTreeElement(l){if(this.b.has(l))return this.b.get(l)}addRenderedTreeItemElement(l,R){this.b.set(l,R)}removeRenderedTreeItemElement(l){this.b.has(l)&&this.b.delete(l)}}e.TreeviewsService=o}),define(ye[310],De([1,0,183,7,24,2,3,6,226,19,7,9,15,14,21,309,26]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function u(C,p){if((0,P.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let n;return Array.isArray(C.highlights)&&(n=C.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:C.label,highlights:n}}}class m{constructor(p,n,s){this.d=p,this.e=n,this.f=s,this.a=new Map,this.b=new f.TreeviewsService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:a=>r(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(c=>r(c)?this.i(c):c):a})}registerTreeDataProvider(p,n,s){const r=this.createTreeView(p,{treeDataProvider:n},s);return{dispose:()=>r.dispose()}}createTreeView(p,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=n.dragAndDropController?.dropMimeTypes??[],a=n.dragAndDropController?.dragMimeTypes??[],c=!!n.dragAndDropController?.handleDrag,g=!!n.dragAndDropController?.handleDrop,i=this.h(p,n,s),t=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:c,hasHandleDrop:g});return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(s,"treeItemCheckbox"),i.onDidChangeCheckboxState},get message(){return i.message},set message(h){i.message=h},get title(){return i.title},set title(h){i.title=h},get description(){return i.description},set description(h){i.description=h},get badge(){return i.badge},set badge(h){h!==void 0&&O.ViewBadge.isViewBadge(h)?i.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(i.badge=void 0)},reveal:(h,E)=>i.reveal(h,E),dispose:async()=>{await t,this.a.delete(p),i.dispose()}}}$getChildren(p,n){const s=this.a.get(p);return s?s.getChildren(n):Promise.reject(new y.NoTreeViewError(p))}async $handleDrop(p,n,s,r,a,c,g,i){const t=this.a.get(p);if(!t)return Promise.reject(new y.NoTreeViewError(p));const h=k.DataTransfer.toDataTransfer(s,async E=>(await this.d.$resolveDropFileData(p,n,E)).buffer);return g===p&&i&&await this.g(h,t,i,a,c),t.onDrop(h,r,a)}async g(p,n,s,r,a){const c=this.b.removeDragOperationTransfer(a);if(c)(await c)?.forEach((g,i)=>{g&&p.set(i,g)});else if(a&&n.handleDrag){const g=n.handleDrag(s,p,r);this.b.addDragOperationTransfer(a,g),await g}return p}async $handleDrag(p,n,s,r){const a=this.a.get(p);if(!a)return Promise.reject(new y.NoTreeViewError(p));const c=await this.g(new L.DataTransfer,a,n,r,s);if(!!c)return k.DataTransfer.toDataTransferDTO(c)}async $hasResolve(p){const n=this.a.get(p);if(!n)throw new y.NoTreeViewError(p);return n.hasResolve}$resolve(p,n,s){const r=this.a.get(p);if(!r)throw new y.NoTreeViewError(p);return r.resolveTreeItem(n,s)}$setExpanded(p,n,s){const r=this.a.get(p);if(!r)throw new y.NoTreeViewError(p);r.setExpanded(n,s)}$setSelection(p,n){const s=this.a.get(p);if(!s)throw new y.NoTreeViewError(p);s.setSelection(n)}$setFocus(p,n){const s=this.a.get(p);if(!s)throw new y.NoTreeViewError(p);s.setFocus(n)}$setVisible(p,n){const s=this.a.get(p);if(!s)throw new y.NoTreeViewError(p);s.setVisible(n)}$changeCheckboxState(p,n){const s=this.a.get(p);if(!s)throw new y.NoTreeViewError(p);s.setCheckboxState(n)}h(p,n,s){const r=new b(p,n,this.d,this.e.converter,this.f,s);return this.a.set(p,r),r}i(p){const n=this.a.get(p.$treeViewId);return n&&"$treeItemHandle"in p?n.getExtensionElement(p.$treeItemHandle):n&&"$focusedTreeItem"in p&&p.$focusedTreeItem?n.focusedElement:null}}e.ExtHostTreeViews=m;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,P.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,n,s,r,a,c){if(super(),this.C=p,this.D=s,this.F=r,this.G=a,this.H=c,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new S.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new S.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new S.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new S.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new S.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new S.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new D.CancellationTokenSource,c.contributes&&c.contributes.views)for(const t in c.contributes.views)for(const h of c.contributes.views[t])h.id===p&&(this.J=h.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let g,i;this.B(S.Event.debounce(this.w.event,(t,h)=>(t||(t={message:!1,elements:[]}),h.element!==!1&&(g||(g=new Promise(E=>i=E),this.y=this.y.then(()=>g)),Array.isArray(h.element)?t.elements.push(...h.element):t.elements.push(h.element)),h.message&&(t.message=!0),t),200,!0)(({message:t,elements:h})=>{h.length&&(this.z=this.z.then(()=>{const E=i;return g=null,this.U(h).then(()=>E())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const n=p?this.getExtensionElement(p):void 0;if(p&&!n)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let s=this.Q(p);return s||(s=await this.R(n)),s?s.map(r=>r.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,n){n=n||{select:!0,focus:!1};const s=(0,P.isUndefinedOrNull)(n.select)?!0:n.select,r=(0,P.isUndefinedOrNull)(n.focus)?!1:n.focus,a=(0,P.isUndefinedOrNull)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(c=>this.P(p,c[c.length-1]).then(g=>this.D.$reveal(this.C,{item:g.item,parentChain:c.map(i=>i.item)},{select:s,focus:r,expand:a})),c=>this.G.error(c)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:a})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=k.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,n){const s=this.getExtensionElement(p);s&&(n?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(p){(0,v.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const n=(await Promise.all(p.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(p,n,s){const r=[];for(const a of p){const c=this.getExtensionElement(a);c&&r.push(c)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,n,s){const r=n?this.getExtensionElement(n):void 0;if(!(!r&&n||!this.g?.handleDrop))return(0,I.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,p,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,n){if(!this.f.resolveTreeItem)return;const s=this.i.get(p);if(s){const r=this.j.get(s);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,s,n)??r.extensionItem;return this.db(a),r.item.tooltip=this.ab(a.tooltip),r.item.command=this.bb(r.disposableStore,a.command),r.item}}}N(p){return this.O(p).then(n=>n?this.N(n).then(s=>this.P(n,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(p){const n=this.j.get(p);return n?Promise.resolve(n.parent?this.i.get(n.parent.item.handle):void 0):(0,I.asPromise)(()=>this.f.getParent(p))}P(p,n){const s=this.j.get(p);return s?Promise.resolve(s):(0,I.asPromise)(()=>this.f.getTreeItem(p)).then(r=>this.gb(p,r,n,!0)).then(r=>this.getChildren(n?n.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const c=this.j.get(a);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(p){if(p){let n;if(typeof p=="string"){const s=this.getExtensionElement(p);n=s?this.j.get(s):void 0}else n=p;return n&&n.children||void 0}return this.h}async R(p){this.nb(p);const n=new D.CancellationTokenSource(this.S.token);try{const s=p?this.j.get(p):void 0,r=await this.f.getChildren(p);if(n.token.isCancellationRequested)return;const a=await Promise.all((0,v.coalesce)(r||[]).map(async c=>{const g=await this.f.getTreeItem(c);return g&&!n.token.isCancellationRequested?this.Z(c,g,s):null}));return n.token.isCancellationRequested?void 0:(0,v.coalesce)(a)}finally{n.dispose()}}U(p){if(p.some(s=>!s))return this.S.dispose(!0),this.S=new D.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(p);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(p){const n=new Set,s=p.map(a=>this.j.get(a));for(const a of s)if(a&&!n.has(a.item.handle)){let c=a;for(;c&&c.parent&&s.findIndex(g=>c&&c.parent&&g&&g.item.handle===c.parent.item.handle)===-1;){const g=this.i.get(c.parent.item.handle);c=g?this.j.get(g):void 0}c&&!c.parent&&n.add(a.item.handle)}const r=[];return n.forEach(a=>{const c=this.i.get(a);if(c){const g=this.j.get(c);g&&(!g.parent||!n.has(g.parent.item.handle))&&r.push(a)}}),r}X(p){const n={};return Promise.all(p.map(s=>this.Y(s).then(r=>{r&&(n[s]=r.item)}))).then(()=>Object.keys(n).length?this.D.$refresh(this.C,n):void 0)}Y(p){const n=this.getExtensionElement(p);if(n){const s=this.j.get(n);if(s)return this.nb(n),(0,I.asPromise)(()=>this.f.getTreeItem(n)).then(r=>{if(r){const a=this.eb(n,r,s.parent);return this.lb(n,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}Z(p,n,s){const r=this.eb(p,n,s);if(n.id&&this.i.has(r.item.handle))throw new Error((0,o.localize)(0,null,n.id));return this.kb(p,r),this.mb(r,s),r}ab(p){return O.MarkdownString.isMarkdownString(p)?k.MarkdownString.from(p):p}bb(p,n){return n?{...this.F.toInternal(n,p),originalId:n.command}:void 0}cb(p){if(!p.checkboxState)return;let n,s;return typeof p.checkboxState=="number"?n=p.checkboxState:(n=p.checkboxState.state,s=p.checkboxState.tooltip),{isChecked:n===O.TreeItemCheckboxState.Checked,tooltip:s}}db(p){if(!O.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,n,s){this.db(n);const r=new A.DisposableStore,a=this.gb(p,n,s),c=this.hb(n);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:u(n.label,this.H),description:n.description,resourceUri:n.resourceUri,tooltip:this.ab(n.tooltip),command:this.bb(r,n.command),contextValue:n.contextValue,icon:c,iconDark:this.ib(n)||c,themeIcon:this.fb(n),collapsibleState:(0,P.isUndefinedOrNull)(n.collapsibleState)?O.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.cb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(p){return p.iconPath instanceof O.ThemeIcon?p.iconPath:void 0}gb(p,{id:n,label:s,resourceUri:r},a,c){if(n)return`${b.b}/${n}`;const g=u(s,this.H),i=a?a.item.handle:b.a;let t=g?g.label:r?(0,l.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const h=this.j.has(p)?this.j.get(p).item.handle:void 0,E=this.Q(a)||[];let w,N=0;do{if(w=`${i}/${N}:${t}`,c||!this.i.has(w)||h===w)break;N++}while(N<=E.length);return w}hb(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof O.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,n){this.i.set(n.item.handle,p),this.j.set(p,n)}lb(p,n,s,r){this.i.delete(n.item.handle),this.j.delete(p),n.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(p,n);const a=this.Q(r)||[],c=a.filter(g=>g.item.handle===s.item.handle)[0];c&&a.splice(a.indexOf(c),1,n)}mb(p,n){n?(n.children||(n.children=[]),n.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const n=this.j.get(p);if(n){if(n.children)for(const s of n.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}n.children=void 0}}else this.pb()}ob(p){const n=this.j.get(p);if(n){if(n.children)for(const s of n.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(p),this.i.delete(n.item.handle),n.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[311],De([1,0,21,10,3,37,2,121,107,153,164,44,5,96,253,252,40,254,35,256,257,258,241,259,59,42,260,261,264,265,266,142,244,272,273,274,99,41,276,310,14,7,73,279,80,141,34,233,263,72,139,82,84,85,13,56,20,25,267,240,55,77,250,277,79,78,282,280,281,251,48,275,278,98,60,76,268,81,269,16,125,243,222,262,6,26,227,97,218,270,271]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C,p,n,s,r,a,c,g,i,t,h,E,w,N,j,V,Q,q,U,T,F,B,Z,_,H,Y,ie,ge,X,J,ee,me,ve,Ie,Re,ae,le,ue,ne,ce,oe,M,z,G,te,de,we,Pe,be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,$,K,he,Le,Ne,qe,je,Ze,st,at,mt,gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(lt){const pt=lt.get(ue.IExtHostInitDataService),xt=lt.get(ke.IExtHostFileSystemInfo),jt=lt.get(de.IExtHostConsumerFileSystem),kt=lt.get(a.IExtHostExtensionService),ft=lt.get(ie.IExtHostWorkspace),Tt=lt.get(tt.IExtHostTelemetry),Bt=lt.get(m.IExtHostConfiguration),At=lt.get(ae.IURITransformerService),Xe=lt.get(le.IExtHostRpcService),Nt=lt.get(Q.IExtHostStorage),Gt=lt.get(te.IExtensionStoragePaths),Ft=lt.get(Re.ILoggerService),bt=lt.get(Re.ILogService),Ae=lt.get(oe.IExtHostTunnelService),Oe=lt.get(M.IExtHostApiDeprecationService),Se=lt.get(Y.IExtHostWindow),se=lt.get(nt.IExtHostSecretState),Fe=lt.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,xt),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Ft),Xe.set(v.ExtHostContext.ExtHostWorkspace,ft),Xe.set(v.ExtHostContext.ExtHostConfiguration,Bt),Xe.set(v.ExtHostContext.ExtHostExtensionService,kt),Xe.set(v.ExtHostContext.ExtHostStorage,Nt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Ae),Xe.set(v.ExtHostContext.ExtHostWindow,Se),Xe.set(v.ExtHostContext.ExtHostSecretState,se),Xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Fe);const We=Xe.set(v.ExtHostContext.ExtHostDecorations,lt.get(ee.IExtHostDecorations)),Ye=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),Ve=Xe.set(v.ExtHostContext.ExtHostCommands,lt.get(d.IExtHostCommands)),et=Xe.set(v.ExtHostContext.ExtHostTerminalService,lt.get(q.IExtHostTerminalService)),ut=Xe.set(v.ExtHostContext.ExtHostDebugService,lt.get(ve.IExtHostDebugService)),Pt=Xe.set(v.ExtHostContext.ExtHostSearch,lt.get(Ie.IExtHostSearch)),St=Xe.set(v.ExtHostContext.ExtHostTask,lt.get(me.IExtHostTask)),Dt=Xe.set(v.ExtHostContext.ExtHostOutputService,lt.get(E.IExtHostOutputService)),wt=Xe.set(v.ExtHostContext.ExtHostLocalization,lt.get(st.IExtHostLocalizationService)),Rt=Xe.set(v.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Xe)),yt=Xe.set(v.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Xe,Ye)),ri=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Xe,Ye,bt)),ei=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new n.ExtHostDocumentSaveParticipant(bt,yt,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),Ct=Xe.set(v.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(Xe,Ve,Ye,yt)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(Ct)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new he.ExtHostNotebookEditors(bt,Ct)),Jt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new rt.ExtHostNotebookKernels(Xe,pt,Ct,Ve,bt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(Xe,Ct)),Lt=Xe.set(v.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Xe,Ye)),zt=Xe.set(v.ExtHostContext.ExtHostTreeViews,new T.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),Ve,bt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,pt.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Xe,bt,xt,Ye)),_t=Xe.set(v.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Xe,yt,Ve.converter,At)),dt=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new i.ExtHostLanguageFeatures(Xe,At,yt,Ve,ai,bt,Oe,Tt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Xe,dt)),Ut=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(Xe,bt,Ye)),Xt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(Xe,ft,Ve)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Xe,Ve,bt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new gt.ExtHostQuickDiff(Xe,At)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Xe,Ve,yt)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Xe)),Zt=Xe.set(v.ExtHostContext.ExtHostAuthentication,new z.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new G.ExtHostTimeline(Xe,Ve)),ti=Xe.set(v.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Xe,pt.remote,ft,bt,Oe)),ii=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,ti,ft)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,yt,Gt,ti,ii)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,ti)),ni=Xe.set(v.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Xe,Ve,Ye)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Xe,Ct,Ye,Ve,bt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ce.ExtHostBulkEdits(Xe,Ye),Hi=new f.ExtHostClipboard(Xe),ki=new h.ExtHostMessageService(Xe,bt),Ri=new C.ExtHostDialogs(Xe),Li=new V.ExtHostStatusBar(Xe,Ve.converter);return D.ExtHostApiCommands.register(Ve),function($e,Wt,Oi){const vt=function(){let pe=!$e.isUnderDevelopment;function Ee(){pe||(bt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")Ee();else{const It=ot;typeof It.scheme>"u"&&Ee(),typeof It.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ot}}(),ji={getSession(pe,Ee,Me){return Zt.getSession($e,pe,Ee,Me)},async hasSession(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,pe,Ee,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(pe,Ee,Me,ot){return Zt.registerAuthenticationProvider(pe,Ee,Me,ot)}},di={registerCommand(pe,Ee,Me){return Ve.registerCommand(!0,pe,Ee,Me,void 0,$e)},registerTextEditorCommand(pe,Ee,Me){return Ve.registerCommand(!0,pe,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return It.edit(Ot=>{Ee.apply(Me,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+pe+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+pe,Ot)})},void 0,void 0,$e)},registerDiffInformationCommand:(pe,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"diffCommand"),Ve.registerCommand(!0,pe,async(...ot)=>{const It=Ye.activeEditor(!0);if(!It){bt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);Ee.apply(Me,[Ot,...ot])},void 0,void 0,$e)),executeCommand(pe,...Ee){return Ve.executeCommand(pe,...Ee)},getCommands(pe=!1){return Ve.getCommands(pe)}},Ni={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return et.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)($e,"envShellEvent"),et.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)($e,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)($e,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe){return tt.ExtHostTelemetryLogger.validateSender(pe),Tt.instantiateLogger($e,pe)},openExternal(pe,Ee){return Se.openUri(pe,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===pt.environment.appUriScheme)return Rt.createAppUri(pe);try{return await Se.asExternalUri(pe,{allowTunneling:!!pt.remote.authority})}catch(Ee){if((0,K.matchesScheme)(pe,$.Schemas.http)||(0,K.matchesScheme)(pe,$.Schemas.https))return pe;throw Ee}},get remoteName(){return(0,J.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)($e,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};pt.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(pe,Ee,Me){return ni.createTestController($e,pe,Ee,Me)},createTestObserver(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.createTestObserver()},runTests(pe){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.runTests(pe)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.results}},hi=pt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,qi={getExtension(pe,Ee){(0,je.isProposedApiEnabled)($e,"extensionsAny")||(Ee=!1);const Me=Wt.mine.getExtensionDescription(pe);if(Me)return new a.Extension(kt,$e.identifier,Me,hi,!1);if(Ee){const ot=Wt.all.getExtensionDescription(pe);if(ot)return new a.Extension(kt,$e.identifier,ot,hi,!0)}},get all(){const pe=[];for(const Ee of Wt.mine.getAllExtensionDescriptions())pe.push(new a.Extension(kt,$e.identifier,Ee,hi,!1));return pe},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)($e,"extensionsAny");const pe=new je.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Ee=[];for(const Me of Wt.all.getAllExtensionDescriptions()){const ot=!pe.has(Me.identifier);Ee.push(new a.Extension(kt,$e.identifier,Me,hi,ot))}return Ee},get onDidChange(){return(0,je.isProposedApiEnabled)($e,"extensionsAny")?l.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Ti={createDiagnosticCollection(pe){return ai.createDiagnosticCollection($e.identifier,pe)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:pe=>ai.getDiagnostics(pe),getLanguages(){return _t.getLanguages()},setTextDocumentLanguage(pe,Ee){return _t.changeLanguage(pe.uri,Ee)},match(pe,Ee){const Me=yt.getDocumentData(Ee.uri)?.notebook;return(0,O.score)(F.LanguageSelector.from(pe),Ee.uri,Ee.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(pe,Ee,Me){return dt.registerCodeActionProvider($e,vt(pe),Ee,Me)},registerDocumentPasteEditProvider(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,vt(pe),Ee,Me)},registerCodeLensProvider(pe,Ee){return dt.registerCodeLensProvider($e,vt(pe),Ee)},registerDefinitionProvider(pe,Ee){return dt.registerDefinitionProvider($e,vt(pe),Ee)},registerDeclarationProvider(pe,Ee){return dt.registerDeclarationProvider($e,vt(pe),Ee)},registerImplementationProvider(pe,Ee){return dt.registerImplementationProvider($e,vt(pe),Ee)},registerTypeDefinitionProvider(pe,Ee){return dt.registerTypeDefinitionProvider($e,vt(pe),Ee)},registerHoverProvider(pe,Ee){return dt.registerHoverProvider($e,vt(pe),Ee,$e.identifier)},registerEvaluatableExpressionProvider(pe,Ee){return dt.registerEvaluatableExpressionProvider($e,vt(pe),Ee,$e.identifier)},registerInlineValuesProvider(pe,Ee){return dt.registerInlineValuesProvider($e,vt(pe),Ee,$e.identifier)},registerDocumentHighlightProvider(pe,Ee){return dt.registerDocumentHighlightProvider($e,vt(pe),Ee)},registerLinkedEditingRangeProvider(pe,Ee){return dt.registerLinkedEditingRangeProvider($e,vt(pe),Ee)},registerReferenceProvider(pe,Ee){return dt.registerReferenceProvider($e,vt(pe),Ee)},registerRenameProvider(pe,Ee){return dt.registerRenameProvider($e,vt(pe),Ee)},registerDocumentSymbolProvider(pe,Ee,Me){return dt.registerDocumentSymbolProvider($e,vt(pe),Ee,Me)},registerWorkspaceSymbolProvider(pe){return dt.registerWorkspaceSymbolProvider($e,pe)},registerDocumentFormattingEditProvider(pe,Ee){return dt.registerDocumentFormattingEditProvider($e,vt(pe),Ee)},registerDocumentRangeFormattingEditProvider(pe,Ee){return dt.registerDocumentRangeFormattingEditProvider($e,vt(pe),Ee)},registerOnTypeFormattingEditProvider(pe,Ee,Me,...ot){return dt.registerOnTypeFormattingEditProvider($e,vt(pe),Ee,[Me].concat(ot))},registerDocumentSemanticTokensProvider(pe,Ee,Me){return dt.registerDocumentSemanticTokensProvider($e,vt(pe),Ee,Me)},registerDocumentRangeSemanticTokensProvider(pe,Ee,Me){return dt.registerDocumentRangeSemanticTokensProvider($e,vt(pe),Ee,Me)},registerSignatureHelpProvider(pe,Ee,Me,...ot){return typeof Me=="object"?dt.registerSignatureHelpProvider($e,vt(pe),Ee,Me):dt.registerSignatureHelpProvider($e,vt(pe),Ee,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(pe,Ee,...Me){return dt.registerCompletionItemProvider($e,vt(pe),Ee,Me)},registerInlineCompletionItemProvider(pe,Ee){return Ee.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,je.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,vt(pe),Ee)},registerDocumentLinkProvider(pe,Ee){return dt.registerDocumentLinkProvider($e,vt(pe),Ee)},registerColorProvider(pe,Ee){return dt.registerColorProvider($e,vt(pe),Ee)},registerFoldingRangeProvider(pe,Ee){return dt.registerFoldingRangeProvider($e,vt(pe),Ee)},registerSelectionRangeProvider(pe,Ee){return dt.registerSelectionRangeProvider($e,pe,Ee)},registerCallHierarchyProvider(pe,Ee){return dt.registerCallHierarchyProvider($e,pe,Ee)},registerTypeHierarchyProvider(pe,Ee){return dt.registerTypeHierarchyProvider($e,pe,Ee)},setLanguageConfiguration:(pe,Ee)=>dt.setLanguageConfiguration($e,pe,Ee),getTokenInformationAtPosition(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"tokenInformation"),_t.tokenAtPosition(pe,Ee)},registerInlayHintsProvider(pe,Ee){return dt.registerInlayHintsProvider($e,pe,Ee)},createLanguageStatusItem(pe,Ee){return _t.createLanguageStatusItem($e,pe,Ee)},registerDocumentDropEditProvider(pe,Ee){return dt.registerDocumentOnDropEditProvider($e,pe,Ee)}},xi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return et.activeTerminal},get terminals(){return et.terminals},async showTextDocument(pe,Ee,Me){const ot=await(S.URI.isUri(pe)?Promise.resolve(Vt.openTextDocument(pe)):Promise.resolve(pe));return Lt.showTextDocument(ot,Ee,Me)},createTextEditorDecorationType(pe){return Lt.createTextEditorDecorationType($e,pe)},onDidChangeActiveTextEditor(pe,Ee,Me){return Lt.onDidChangeActiveTextEditor(pe,Ee,Me)},onDidChangeVisibleTextEditors(pe,Ee,Me){return Lt.onDidChangeVisibleTextEditors(pe,Ee,Me)},onDidChangeTextEditorSelection(pe,Ee,Me){return Lt.onDidChangeTextEditorSelection(pe,Ee,Me)},onDidChangeTextEditorOptions(pe,Ee,Me){return Lt.onDidChangeTextEditorOptions(pe,Ee,Me)},onDidChangeTextEditorVisibleRanges(pe,Ee,Me){return Lt.onDidChangeTextEditorVisibleRanges(pe,Ee,Me)},onDidChangeTextEditorViewColumn(pe,Ee,Me){return Lt.onDidChangeTextEditorViewColumn(pe,Ee,Me)},onDidCloseTerminal(pe,Ee,Me){return et.onDidCloseTerminal(pe,Ee,Me)},onDidOpenTerminal(pe,Ee,Me){return et.onDidOpenTerminal(pe,Ee,Me)},onDidChangeActiveTerminal(pe,Ee,Me){return et.onDidChangeActiveTerminal(pe,Ee,Me)},onDidChangeTerminalDimensions(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"terminalDimensions"),et.onDidChangeTerminalDimensions(pe,Ee,Me)},onDidChangeTerminalState(pe,Ee,Me){return et.onDidChangeTerminalState(pe,Ee,Me)},onDidWriteTerminalData(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),et.onDidWriteTerminalData(pe,Ee,Me)},get state(){return Se.state},onDidChangeWindowState(pe,Ee,Me){return Se.onDidChangeWindowState(pe,Ee,Me)},showInformationMessage(pe,...Ee){return ki.showMessage($e,R.default.Info,pe,Ee[0],Ee.slice(1))},showWarningMessage(pe,...Ee){return ki.showMessage($e,R.default.Warning,pe,Ee[0],Ee.slice(1))},showErrorMessage(pe,...Ee){return ki.showMessage($e,R.default.Error,pe,Ee[0],Ee.slice(1))},showQuickPick(pe,Ee,Me){return Xt.showQuickPick($e,pe,Ee,Me)},showWorkspaceFolderPick(pe){return Xt.showWorkspaceFolderPick(pe)},showInputBox(pe,Ee){return Xt.showInput(pe,Ee)},showOpenDialog(pe){return Ri.showOpenDialog($e,pe)},showSaveDialog(pe){return Ri.showSaveDialog(pe)},createStatusBarItem(pe,Ee,Me){let ot,It,Ot;return typeof pe=="string"?(ot=pe,It=Ee,Ot=Me):(It=pe,Ot=Ee),Li.createStatusBarEntry($e,ot,It,Ot)},setStatusBarMessage(pe,Ee){return Li.setStatusBarMessage(pe,Ee)},withScmProgress(pe){return Oe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),li.withProgress($e,{location:B.ProgressLocation.SourceControl},(Ee,Me)=>pe({report(ot){}}))},withProgress(pe,Ee){return li.withProgress($e,pe,Ee)},createOutputChannel(pe,Ee){return Dt.createOutputChannel(pe,Ee,$e)},createWebviewPanel(pe,Ee,Me,ot){return ii.createWebviewPanel($e,pe,Ee,Me,ot)},createWebviewTextEditorInset(pe,Ee,Me,ot){return(0,je.checkProposedApiEnabled)($e,"editorInsets"),vi.createWebviewEditorInset(pe,Ee,Me,ot,$e)},createTerminal(pe,Ee,Me){return typeof pe=="object"?"pty"in pe?et.createExtensionTerminal(pe):et.createTerminalFromOptions(pe):et.createTerminal(pe,Ee,Me)},registerTerminalLinkProvider(pe){return et.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,Ee){return et.registerProfileProvider($e,pe,Ee)},registerTerminalQuickFixProvider(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),et.registerTerminalQuickFixProvider(pe,$e.identifier.value,Ee)},registerTreeDataProvider(pe,Ee){return zt.registerTreeDataProvider(pe,Ee,$e)},createTreeView(pe,Ee){return zt.createTreeView(pe,Ee,$e)},registerWebviewPanelSerializer:(pe,Ee)=>ii.registerWebviewPanelSerializer($e,pe,Ee),registerCustomEditorProvider:(pe,Ee,Me={})=>yi.registerCustomEditorProvider($e,pe,Ee,Me),registerFileDecorationProvider(pe){return We.registerFileDecorationProvider(pe,$e)},registerUriHandler(pe){return Rt.registerUriHandler($e.identifier,pe)},createQuickPick(){return Xt.createQuickPick($e)},createInputBox(){return Xt.createInputBox($e)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(pe,Ee,Me){return ui.onDidChangeActiveColorTheme(pe,Ee,Me)},registerWebviewViewProvider(pe,Ee,Me){return Di.registerWebviewViewProvider($e,pe,Ee,Me?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,Ee,Me){return Ct.onDidChangeActiveNotebookEditor(pe,Ee,Me)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,Ee,Me){return oi.onDidChangeNotebookEditorSelection(pe,Ee,Me)},onDidChangeNotebookEditorVisibleRanges(pe,Ee,Me){return oi.onDidChangeNotebookEditorVisibleRanges(pe,Ee,Me)},showNotebookDocument(pe,Ee){return Ct.showNotebookDocument(pe,Ee)},registerExternalUriOpener(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"externalUriOpener"),Ci.registerExternalUriOpener($e.identifier,pe,Ee,Me)},registerProfileContentHandler(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"profileContentHandlers"),Ii.registrProfileContentHandler($e,pe,Ee)},registerQuickDiffProvider(pe,Ee,Me,ot){return(0,je.checkProposedApiEnabled)($e,"quickDiffProvider"),wi.registerQuickDiffProvider(vt(pe),Ee,Me,ot)},get tabGroups(){return Fe.tabGroups}},Vt={get rootPath(){return Oe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(pe){throw L.readonly()},getWorkspaceFolder(pe){return ft.getWorkspaceFolder(pe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(pe){throw L.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(pe){throw L.readonly()},updateWorkspaceFolders:(pe,Ee,...Me)=>ft.updateWorkspaceFolders($e,pe,Ee||0,...Me),onDidChangeWorkspaceFolders:function(pe,Ee,Me){return ft.onDidChangeWorkspace(pe,Ee,Me)},asRelativePath:(pe,Ee)=>ft.getRelativePath(pe,Ee),findFiles:(pe,Ee,Me,ot)=>ft.findFiles(pe,Ee,Me,$e.identifier,ot),findTextInFiles:(pe,Ee,Me,ot)=>{(0,je.checkProposedApiEnabled)($e,"findTextInFiles");let It,Ot;return typeof Ee=="object"?(It=Ee,Ot=Me):(It={},Ot=Ee,ot=Me),ft.findTextInFiles(pe,It||{},Ot,$e.identifier,ot)},saveAll:pe=>ft.saveAll(pe),applyEdit(pe,Ee){return Wi.applyWorkspaceEdit(pe,$e,Ee)},createFileSystemWatcher:(pe,Ee,Me,ot)=>Ut.createFileSystemWatcher(ft,$e,pe,Ee,Me,ot),get textDocuments(){return yt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw L.readonly()},openTextDocument(pe){let Ee;const Me=pe;if(typeof pe=="string")Ee=Promise.resolve(S.URI.file(pe));else if(S.URI.isUri(pe))Ee=Promise.resolve(pe);else if(!Me||typeof Me=="object")Ee=yt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ot=>yt.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(pe,Ee,Me)=>yt.onDidAddDocument(pe,Ee,Me),onDidCloseTextDocument:(pe,Ee,Me)=>yt.onDidRemoveDocument(pe,Ee,Me),onDidChangeTextDocument:(pe,Ee,Me)=>yt.onDidChangeDocument(pe,Ee,Me),onDidSaveTextDocument:(pe,Ee,Me)=>yt.onDidSaveDocument(pe,Ee,Me),onWillSaveTextDocument:(pe,Ee,Me)=>ei.getOnWillSaveTextDocumentEvent($e)(pe,Ee,Me),get notebookDocuments(){return Ct.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,Ee){let Me;if(S.URI.isUri(pe))Me=pe,await Ct.openNotebookDocument(pe);else if(typeof pe=="string")Me=S.URI.revive(await Ct.createNotebookDocument({viewType:pe,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(pe,Ee,Me){return si.onDidSaveNotebookDocument(pe,Ee,Me)},onDidChangeNotebookDocument(pe,Ee,Me){return si.onDidChangeNotebookDocument(pe,Ee,Me)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(pe,Ee,Me,ot){return Ct.registerNotebookSerializer($e,pe,Ee,Me,(0,je.isProposedApiEnabled)($e,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(pe,Ee,Me)=>Oi.onDidChangeConfiguration(pe,Ee,Me),getConfiguration(pe,Ee){return Ee=arguments.length===1?void 0:Ee,Oi.getConfiguration(pe,Ee,$e)},registerTextDocumentContentProvider(pe,Ee){return ri.registerTextDocumentContentProvider(pe,Ee)},registerTaskProvider:(pe,Ee)=>(Oe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider($e,pe,Ee)),registerFileSystemProvider(pe,Ee,Me){return(0,qe.combinedDisposable)(Bi.registerFileSystemProvider($e,pe,Ee,Me),jt.addFileSystemProvider(pe,Ee))},get fs(){return jt.value},registerFileSearchProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"fileSearchProvider"),Pt.registerFileSearchProvider(pe,Ee)),registerTextSearchProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"textSearchProvider"),Pt.registerTextSearchProvider(pe,Ee)),registerRemoteAuthorityResolver:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"resolvers"),kt.registerRemoteAuthorityResolver(pe,Ee)),registerResourceLabelFormatter:pe=>((0,je.checkProposedApiEnabled)($e,"resolvers"),Si.$registerResourceLabelFormatter(pe)),onDidCreateFiles:(pe,Ee,Me)=>Ut.onDidCreateFile(pe,Ee,Me),onDidDeleteFiles:(pe,Ee,Me)=>Ut.onDidDeleteFile(pe,Ee,Me),onDidRenameFiles:(pe,Ee,Me)=>Ut.onDidRenameFile(pe,Ee,Me),onWillCreateFiles:(pe,Ee,Me)=>Ut.getOnWillCreateFileEvent($e)(pe,Ee,Me),onWillDeleteFiles:(pe,Ee,Me)=>Ut.getOnWillDeleteFileEvent($e)(pe,Ee,Me),onWillRenameFiles:(pe,Ee,Me)=>Ut.getOnWillRenameFileEvent($e)(pe,Ee,Me),openTunnel:pe=>((0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.openTunnel($e,pe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.getTunnels()},onDidChangeTunnels:(pe,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.onDidChangeTunnels(pe,Ee,Me)),registerPortAttributesProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"portsAttributes"),Ae.registerPortsAttributesProvider(pe,Ee)),registerTimelineProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"timeline"),$i.registerTimelineProvider(pe,Ee,$e.identifier,Ve.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:pe=>((0,je.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,Ee,Me)=>ft.onDidGrantWorkspaceTrust(pe,Ee,Me),registerEditSessionIdentityProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(pe,Ee)),onWillCreateEditSessionIdentity:(pe,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent($e)(pe,Ee,Me))},fi={get inputBox(){return Oe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox($e)},createSourceControl(pe,Ee,Me){return ci.createSourceControl($e,pe,Ee,Me)}},Gi={createCommentController(pe,Ee){return Ei.createCommentController($e,pe,Ee)}},$t={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(pe,Ee,Me){return ut.onDidStartDebugSession(pe,Ee,Me)},onDidTerminateDebugSession(pe,Ee,Me){return ut.onDidTerminateDebugSession(pe,Ee,Me)},onDidChangeActiveDebugSession(pe,Ee,Me){return ut.onDidChangeActiveDebugSession(pe,Ee,Me)},onDidReceiveDebugSessionCustomEvent(pe,Ee,Me){return ut.onDidReceiveDebugSessionCustomEvent(pe,Ee,Me)},onDidChangeBreakpoints(pe,Ee,Me){return ut.onDidChangeBreakpoints(pe,Ee,Me)},registerDebugConfigurationProvider(pe,Ee,Me){return ut.registerDebugConfigurationProvider(pe,Ee,Me||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,Ee){return ut.registerDebugAdapterDescriptorFactory($e,pe,Ee)},registerDebugAdapterTrackerFactory(pe,Ee){return ut.registerDebugAdapterTrackerFactory(pe,Ee)},startDebugging(pe,Ee,Me){return!Me||typeof Me=="object"&&"configuration"in Me?ut.startDebugging(pe,Ee,{parentSession:Me}):ut.startDebugging(pe,Ee,Me||{})},stopDebugging(pe){return ut.stopDebugging(pe)},addBreakpoints(pe){return ut.addBreakpoints(pe)},removeBreakpoints(pe){return ut.removeBreakpoints(pe)},asDebugSourceUri(pe,Ee){return ut.asDebugSourceUri(pe,Ee)}},mi={registerTaskProvider:(pe,Ee)=>St.registerTaskProvider($e,pe,Ee),fetchTasks:pe=>St.fetchTasks(pe),executeTask:pe=>St.executeTask($e,pe),get taskExecutions(){return St.taskExecutions},onDidStartTask:(pe,Ee,Me)=>St.onDidStartTask(pe,Ee,Me),onDidEndTask:(pe,Ee,Me)=>St.onDidEndTask(pe,Ee,Me),onDidStartTaskProcess:(pe,Ee,Me)=>St.onDidStartTaskProcess(pe,Ee,Me),onDidEndTaskProcess:(pe,Ee,Me)=>St.onDidEndTaskProcess(pe,Ee,Me)},Ki={createNotebookController(pe,Ee,Me,ot,It){return Jt.createNotebookController($e,pe,Ee,Me,ot,(0,je.isProposedApiEnabled)($e,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(pe,Ee)=>Ct.registerNotebookCellStatusBarItemProvider($e,pe,Ee),createRendererMessaging(pe){return bi.createRendererMessaging($e,pe)},createNotebookControllerDetectionTask(pe){return(0,je.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.createNotebookControllerDetectionTask($e,pe)},registerKernelSourceActionProvider(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.registerKernelSourceActionProvider($e,pe,Ee)},onDidChangeNotebookCellExecutionState(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(pe,Ee,Me)}},Xi={t(...pe){if(typeof pe[0]=="string"){const Ee=pe.shift(),Me=!pe||typeof pe[0]!="object"?pe:pe[0];return wt.getMessage($e.identifier.value,{message:Ee,args:Me})}return wt.getMessage($e.identifier.value,pe[0])},get bundle(){return wt.getBundle($e.identifier.value)},get uri(){return wt.getBundleUri($e.identifier.value)}};return{version:pt.version,authentication:ji,commands:di,comments:Gi,debug:$t,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:xi,workspace:Vt,Breakpoint:B.Breakpoint,TerminalOutputAnchor:B.TerminalOutputAnchor,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileDecoration2:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:I.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalQuickFixCommand:B.TerminalQuickFixCommand,TerminalQuickFixOpener:B.TerminalQuickFixOpener,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TerminalExitReason:B.TerminalExitReason,TerminalQuickFixType:B.TerminalQuickFixType,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:k.UIKind,Uri:S.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,NotebookKernelSourceAction:B.NotebookKernelSourceAction,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestRunRequest2:B.TestRunRequest2,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TelemetryTrustedValue:Z.TelemetryTrustedValue,LogLevel:Re.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[312],De([1,0,284,321,322,2,323]),function(re,e,o,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,v,k,D,f,d){const u=d.environment.useHostProxy,m=typeof u=="boolean"?u:!d.remote.isRemote,b=(0,S.createProxyResolver)({resolveProxy:p=>P.resolveProxy(p),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(p,n,...s)=>{switch(p){case S.LogLevel.Trace:D.trace(n,...s);break;case S.LogLevel.Debug:D.debug(n,...s);break;case S.LogLevel.Info:D.info(n,...s);break;case S.LogLevel.Warning:D.warn(n,...s);break;case S.LogLevel.Error:D.error(n,...s);break;case S.LogLevel.Critical:D.error(n,...s);break;case S.LogLevel.Off:break;default:r(p,n,s);break}function r(a,c,...g){D.error("Unknown log level",a),D.error(c,...g)}},getLogLevel:()=>D.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:m,env:process.env}),C=y(v,b);return O(k,C)}e.connectProxyResolver=A;function y(P,v){const k={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(f=>{k.config=P.getConfiguration("http").get("proxySupport")||"off"});const D={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(f=>{D.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,S.createHttpPatch)(o,v,{config:"off"},D,!0)),on:Object.assign({},o,(0,S.createHttpPatch)(o,v,{config:"on"},D,!0)),override:Object.assign({},o,(0,S.createHttpPatch)(o,v,{config:"override"},D,!0)),onRequest:Object.assign({},o,(0,S.createHttpPatch)(o,v,k,D,!0)),default:Object.assign(o,(0,S.createHttpPatch)(o,v,k,D,!1))},https:{off:Object.assign({},L,(0,S.createHttpPatch)(L,v,{config:"off"},D,!0)),on:Object.assign({},L,(0,S.createHttpPatch)(L,v,{config:"on"},D,!0)),override:Object.assign({},L,(0,S.createHttpPatch)(L,v,{config:"override"},D,!0)),onRequest:Object.assign({},L,(0,S.createHttpPatch)(L,v,k,D,!0)),default:Object.assign(L,(0,S.createHttpPatch)(L,v,k,D,!1))},tls:Object.assign(l,(0,S.createTlsPatch)(l))}}const I=new Map;function O(P,v){return P.getExtensionPathIndex().then(k=>{const D=globalThis._VSCODE_NODE_MODULES.module,f=D._load;D._load=function(u,m,b){if(u==="tls")return v.tls;if(u!=="http"&&u!=="https")return f.apply(this,arguments);const C=v[u],p=k.findSubstr(R.URI.file(m.filename));let n=I.get(p);if(n||I.set(p,n={}),!n[u]){const s=C.default;n[u]={...s}}return n[u]}})}}),define(ye[313],De([1,0,83,311,298,312,42,286,2,16,7,283,115,285]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class D extends l.RequireInterceptor{j(){const u=this,m=globalThis._VSCODE_NODE_MODULES.module,b=m._load;m._load=function(s,r,a){return s=p(s),u.a.has(s)?u.a.get(s).load(s,y.URI.file((0,v.realpathSync)(r.filename)),c=>b.apply(this,[c,r,a])):b.apply(this,arguments)};const C=m._resolveLookupPaths;m._resolveLookupPaths=(n,s)=>C.call(this,p(n),s);const p=n=>{for(const s of u.b){const r=s(n);if(r){n=r;break}}return n}}}class f extends S.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=O.ExtensionRuntime.Node}async ob(){this.h.createInstance(k.ExtHostConsoleForwarder);const u=this.h.invokeFunction(L.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const C=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=C.ipcHandlePath}await this.h.createInstance(D,u,{mine:this.D,all:this.F}).install(),o.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),o.mark("code/extHost/didInitProxyResolver")}pb(u){return u.main}async qb(u,m,b){if(m.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${m}', must be of file-scheme`);let C=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${m.toString(!0)}`),this.l.flush();const p=u?.identifier.value;u&&await this.s.initializeLocalizedMessages(u);try{p&&o.mark(`code/extHost/willLoadExtensionCode/${p}`),C=re.__$__nodeRequire(m.fsPath)}finally{p&&o.mark(`code/extHost/didLoadExtensionCode/${p}`),b.codeLoadingStop()}return C}async $setRemoteEnvironment(u){if(!!this.f.remote.isRemote)for(const m in u){const b=u[m];b===null?delete process.env[m]:process.env[m]=b}}}e.ExtHostExtensionService=f}),define(ye[145],De([1,0,46,324,307,15,61,38,12,8,2,31,81,325,305,100]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class u{constructor(w){this.a=w}provideTextSearchResults(w,N,j,V){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...N,folder:N.folder.toString()})}`),new Promise((Q,q)=>{V.onCancellationRequested(()=>Y());const U=s(w,N),T=N.folder.fsPath,F=U.map(ee=>ee.match(/^-/)?ee:`'${ee}'`).join(" ");this.a.appendLine(`${d} ${F}
 - cwd: ${T}`);let B=o.spawn(d,U,{cwd:T});B.on("error",ee=>{console.error(ee),this.a.appendLine("Error: "+(ee&&ee.message)),q((0,P.serializeSearchError)(new P.SearchError(ee&&ee.message,P.SearchErrorCode.rgProcessError)))});let Z=!1;const _=new C(N.maxResults,T,N.previewOptions);_.on("result",ee=>{Z=!0,ge="",j.report(ee)});let H=!1;const Y=()=>{H=!0,B?.kill(),_?.cancel()};let ie=!1;_.on("hitLimit",()=>{ie=!0,Y()});let ge="";B.stdout.on("data",ee=>{_.handleData(ee),Z||(ge+=ee)});let X=!1;B.stdout.once("data",()=>X=!0);let J="";B.stderr.on("data",ee=>{const me=ee.toString();this.a.appendLine(me),J.length+me.length<1e6&&(J+=me)}),B.on("close",()=>{if(this.a.appendLine(X?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),ge&&this.a.appendLine(`Got data without result: ${ge}`),this.a.appendLine(""),H)Q({limitHit:ie});else{_.flush(),B=null;let ee;J&&!X&&(ee=m(J))?q((0,P.serializeSearchError)(new P.SearchError(ee.message,ee.code))):Q({limitHit:ie})}})})}}e.RipgrepTextSearchEngine=u;function m(E){const w=E.split(`
`),N=w[0].trim();if(w.some(V=>V.startsWith("regex parse error")))return new P.SearchError(b(w),P.SearchErrorCode.regexParseError);const j=N.match(/grep config error: unknown encoding: (.*)/);if(j)return new P.SearchError(`Unknown encoding: ${j[1]}`,P.SearchErrorCode.unknownEncoding);if(N.startsWith("error parsing glob"))return new P.SearchError(N.charAt(0).toUpperCase()+N.substr(1),P.SearchErrorCode.globParseError);if(N.startsWith("the literal"))return new P.SearchError(N.charAt(0).toUpperCase()+N.substr(1),P.SearchErrorCode.invalidLiteral);if(N.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(N,P.SearchErrorCode.regexParseError)}function b(E){const w=["Regex parse error"],N=E.filter(j=>j.startsWith("PCRE2:"));if(N.length>=1){const j=N[0].replace("PCRE2:","");if(j.indexOf(":")!==-1&&j.split(":").length>=2){const V=j.split(":")[1];w.push(":"+V)}}return w.join("")}class C extends L.EventEmitter{constructor(w,N,j){super(),this.g=w,this.h=N,this.j=j,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,N){return super.on(w,N),this}handleData(w){if(this.b)return;const N=typeof w=="string"?w:this.d.write(w);this.k(N)}k(w){let N=w.indexOf(`
`);const j=this.a+w;if(N>=0)N+=this.a.length;else{this.a=j;return}let V=0;for(;N>=0;)this.m(j.substring(V,N).trim()),V=N+1,N=j.indexOf(`
`,V);this.a=j.substring(V)}m(w){if(this.b||!w)return;let N;try{N=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(N.type==="match"){const j=p(N.data.path),V=O.URI.file(y.join(this.h,j)),Q=this.n(N.data,V);this.p(Q),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(N.type==="context"){const j=p(N.data.path),V=O.URI.file(y.join(this.h,j));this.o(N.data,V).forEach(q=>this.p(q))}}n(w,N){const j=w.line_number-1,V=p(w.lines),Q=Buffer.from(V);let q=0,U=0,T=j;w.submatches.length===0&&w.submatches.push(V.length?{start:0,end:1,match:{text:V[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.coalesce)(w.submatches.map((B,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const _=p(B.match),H=Q.slice(q,B.start).toString(),Y=n(H),ie=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+U,ge=n(_),X=Y.numLines+T,J=ge.numLines+X,ee=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+ie;return q=B.end,U=ee,T=J,new v.Range(X,ie,J,ee)}));return(0,f.createTextSearchResult)(N,V,F,this.j)}o(w,N){const j=p(w.lines),V=w.line_number;return j.replace(/\r?\n$/,"").split(`
`).map((Q,q)=>({text:Q,uri:N,lineNumber:V+q}))}p(w){this.emit("result",w)}}e.RipgrepParser=C;function p(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function n(E){const w=/\n/g;let N=0,j=-1,V;for(;V=w.exec(E);)N++,j=V.index;const Q=j>=0?E.length-j-1:E.length;return{numLines:N,lastLineLength:Q}}function s(E,w){const N=["--hidden"];N.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:j,otherIncludes:V}=(0,S.groupBy)(w.includes,q=>q.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(V&&V.length){const q=new Set;V.forEach(U=>{q.add(U)}),N.push("-g","!*"),q.forEach(U=>{r(U).map(f.anchorGlob).forEach(T=>{N.push("-g",T)})})}j&&j.length&&j.forEach(q=>{N.push("-g",q)}),w.excludes.map(f.anchorGlob).forEach(q=>N.push("-g",`!${q}`)),w.maxFileSize&&N.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||N.push("--no-ignore-parent"):N.push("--no-ignore"),w.followSymlinks&&N.push("--follow"),w.encoding&&w.encoding!=="utf8"&&N.push("--encoding",w.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,I.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),w.usePCRE2&&N.push("--pcre2"),N.push("--crlf"),E.isRegExp&&(E.pattern=a(E.pattern),N.push("--engine","auto"));let Q;if(E.isWordMatch){const U=(0,I.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");N.push("--regexp",U)}else if(E.isRegExp){let q=g(E.pattern);q=i(q),N.push("--regexp",q)}else Q=E.pattern,N.push("--fixed-strings");return N.push("--no-config"),w.useGlobalIgnoreFiles||N.push("--no-ignore-global"),N.push("--json"),E.isMultiline&&N.push("--multiline"),w.beforeContext&&N.push("--before-context",w.beforeContext+""),w.afterContext&&N.push("--after-context",w.afterContext+""),N.push("--"),Q&&N.push(Q),N.push("."),N}e.getRgArgs=s;function r(E){return h(E).flatMap(N=>{const j=(0,A.splitGlobAware)(N,"/");return j.map((V,Q)=>j.slice(0,Q+1).join("/"))})}function a(E){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(w);)E=E.replace(w,"$1\\x{$2}");const N=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(N);)E=E.replace(N,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=a;const c=E=>E.type==="Assertion"&&E.kind==="lookbehind";function g(E){let w;try{w=new k.RegExpParser().parsePattern(E)}catch{return E}let N="",j=0;const V=(U,T,F)=>{N+=E.slice(j,U)+F,j=T},Q=[];return new k.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const T=Q[0];if(!T)V(U.start,U.end,"\\r?\\n");else if(!Q.some(c))if(T.type==="CharacterClass")if(T.negate){const F=E.slice(T.start+2,U.start)+E.slice(U.end,T.end-1);T.parent?.type==="Quantifier"?V(T.start,T.end,F?`[^${F}]`:"."):V(T.start,T.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=E.slice(T.start+1,U.start)+E.slice(U.end,T.end-1);V(T.start,T.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else T.type==="Quantifier"&&V(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){Q.unshift(U)},onQuantifierLeave(){Q.shift()},onCharacterClassRangeEnter(U){Q.unshift(U)},onCharacterClassRangeLeave(){Q.shift()},onCharacterClassEnter(U){Q.unshift(U)},onCharacterClassLeave(){Q.shift()},onAssertionEnter(U){c(U)&&Q.push(U)},onAssertionLeave(U){Q[0]===U&&Q.shift()}}).visit(w),N+=E.slice(j),N}e.fixRegexNewline=g;function i(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=i;function t(E){let w=!1,N=!1,j="",V="";for(let Q=0;Q<E.length;Q++){const q=E[Q];switch(q){case"\\":N?(w?V+="\\"+q:j+="\\"+q,N=!1):N=!0;break;case"{":if(N)w?V+=q:j+=q,N=!1;else{if(w)return{strInBraces:j+"{"+V+"{"+E.substring(Q+1)};w=!0}break;case"}":if(N)w?V+=q:j+=q,N=!1;else{if(w)return{fixedStart:j,strInBraces:V,fixedEnd:E.substring(Q+1)};j+=q}break;default:w?V+=(N?"\\":"")+q:j+=(N?"\\":"")+q,N=!1;break}}return{strInBraces:j+(w?"{"+V:"")}}function h(E){const{fixedStart:w,strInBraces:N,fixedEnd:j}=t(E);if(w===void 0||j===void 0)return[N];let V=(0,A.splitGlobAware)(N,",");V.length||(V=[""]);const Q=h(j);return V.flatMap(q=>{const U=w+q;return Q.map(T=>U+T)})}e.performBraceExpansionForRipgrep=h}),define(ye[314],De([1,0,21,145,126,16]),function(re,e,o,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class S{constructor(I){this.b=I,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(I,O,P,v){const k=new L.RipgrepTextSearchEngine(this.b);if(O.folder.scheme===R.Schemas.vscodeUserData){const D={...O,folder:O.folder.with({scheme:R.Schemas.file})},f=new l.Progress(d=>P.report({...d,uri:d.uri.with({scheme:O.folder.scheme})}));return this.c(v,d=>k.provideTextSearchResults(I,D,f,d))}else return this.c(v,D=>k.provideTextSearchResults(I,O,P,D))}async c(I,O){const P=A(I);this.a.add(P);const v=await O(P.token);return this.a.delete(P),v}d(){this.a.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=S;function A(y){const I=new o.CancellationTokenSource;return y.onCancellationRequested(()=>I.cancel()),I}}),define(ye[315],De([1,0,29,145,144]),function(re,e,o,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,I,O){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(k){O({message:k})}},v=new l.NativeTextSearchManager(this.a,new L.RipgrepTextSearchEngine(P),o);return new Promise((k,D)=>v.search(f=>{I(f.map(S))},y).then(f=>k({limitHit:f.limitHit,type:"success",stats:f.stats}),D))}}e.TextSearchEngineAdapter=R;function S(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,I)=>{if(I.ranges){const O=I;return y+(Array.isArray(O.ranges)?O.ranges.length:1)}else return y+1},0)}}}),define(ye[316],De([1,0,15,19,10,3,111,12,43,2,44,31,306,315]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class D{constructor(C="searchProcess"){this.d=C,this.b=Object.create(null)}fileSearch(C){let p;const n=u(C),s=new R.Emitter({onDidAddFirstListener:()=>{p=(0,L.createCancelablePromise)(r=>this.doFileSearchWithEngine(v.Engine,n,a=>s.fire(a),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}textSearch(C){let p;const n=u(C),s=new R.Emitter({onDidAddFirstListener:()=>{p=(0,L.createCancelablePromise)(r=>this.f(n,a=>s.fire(a),r)),p.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return s.event}f(C,p,n){return C.maxFileSize=(0,O.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new k.TextSearchEngineAdapter(C).search(n,p,p)}doFileSearch(C,p,n){return this.doFileSearchWithEngine(v.Engine,C,p,n)}doFileSearchWithEngine(C,p,n,s,r=D.a){let a=0;const c=i=>{Array.isArray(i)?(a+=i.length,n(i.map(t=>this.g(t)))):i.relativePath?(a++,n(this.g(i))):n(i)};if(p.sortByScore){let i=this.k(p,c,s);if(!i){const t=p.maxResults?Object.assign({},p,{maxResults:null}):p,h=new C(t);i=this.h(h,p,n,c,s)}return new Promise((t,h)=>{i.then(([E,w])=>{const N=w.map(j=>this.g(j));this.n(N,n,r),t(E)},h)})}const g=new C(p);return this.q(g,c,r,s).then(i=>({limitHit:i.limitHit,type:"success",stats:{detailStats:i.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0}}))}g(C){return{path:C.base?(0,A.join)(C.base,C.relativePath):C.relativePath}}h(C,p,n,s,r){const a=new R.Emitter;let c=(0,L.createCancelablePromise)(i=>{let t=[];const h=E=>{Array.isArray(E)?t=E:(s(E),a.fire(E))};return this.q(C,h,-1,i).then(E=>[E,t])}),g;if(p.cacheKey){g=this.j(p.cacheKey);const i={promise:c,event:a.event,resolved:!1};g.resultsToSearchCache[p.filePattern||""]=i,c.then(()=>{i.resolved=!0},t=>{delete g.resultsToSearchCache[p.filePattern||""]}),c=this.r(c)}return c.then(([i,t])=>{const h=g?g.scorerCache:Object.create(null),E=(typeof p.maxResults!="number"||p.maxResults>0)&&y.StopWatch.create(!1);return this.l(p,t,h,r).then(w=>{const N=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:i.stats,sortingTime:N,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:w.length},messages:i.messages,limitHit:i.limitHit||typeof p.maxResults=="number"&&t.length>p.maxResults},w]})})}j(C){const p=this.b[C];return p||(this.b[C]=new f)}k(C,p,n){const s=C.cacheKey&&this.b[C.cacheKey];if(!s)return;const r=this.o(s,C.filePattern||"",p,n);if(r)return r.then(([a,c,g])=>{const i=y.StopWatch.create(!1);return this.l(C,c,s.scorerCache,n).then(t=>{const h=i.elapsed(),E={fromCache:!0,detailStats:g,type:this.d,resultCount:c.length,sortingTime:h};return[{type:"success",limitHit:a.limitHit||typeof C.maxResults=="number"&&c.length>C.maxResults,stats:E},t]})})}l(C,p,n,s){const r=(0,S.prepareQuery)(C.filePattern||""),a=(g,i)=>(0,S.compareItemsByFuzzyScore)(g,i,r,!0,d,n),c=typeof C.maxResults=="number"?C.maxResults:Number.MAX_VALUE;return o.topAsync(p,a,c,1e4,s)}n(C,p,n){if(n&&n>0)for(let s=0;s<C.length;s+=n)p(C.slice(s,s+n));else p(C)}o(C,p,n,s){const r=y.StopWatch.create(!1),a=p.indexOf(A.sep)>=0;let c;for(const h in C.resultsToSearchCache)if(p.startsWith(h)){if(a&&h.indexOf(A.sep)<0&&h!=="")continue;const E=C.resultsToSearchCache[h];c={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!c)return null;const g=r.elapsed(),i=y.StopWatch.create(!1),t=c.event(n);return s&&s.onCancellationRequested(()=>{t.dispose()}),c.promise.then(([h,E])=>{if(s&&s.isCancellationRequested)throw(0,l.canceled)();const w=[],N=(0,S.prepareQuery)(p).normalizedLowercase;for(const j of E)!(0,P.isFilePatternMatch)(j,N)||w.push(j);return[h,w,{cacheWasResolved:c.resolved,cacheLookupTime:g,cacheFilterTime:i.elapsed(),cacheEntryCount:E.length}]})}q(C,p,n,s){return new Promise((r,a)=>{let c=[];s?.onCancellationRequested(()=>C.cancel()),C.search(g=>{g&&(n?(c.push(g),n>0&&c.length>=n&&(p(c),c=[])):p(g))},g=>{p(g)},(g,i)=>{c.length&&p(c),g?a(g):r(i)})})}clearCache(C){return delete this.b[C],Promise.resolve(void 0)}r(C){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,n){return C.then(p,n)}catch(p){return this.then(void 0,p)}finally(p){return C.finally(p)}}}}D.a=512,e.SearchService=D;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(b){return(0,A.basename)(b.relativePath)}getItemDescription(b){return(0,A.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function u(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(m),extraFileResources:b.extraFileResources&&b.extraFileResources.map(C=>I.URI.revive(C))}}function m(b){return{...b,folder:I.URI.revive(b.folder)}}}),define(ye[317],De([1,0,6,16,2,29,13,25,20,85,56,31,316,314,100,144]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends I.ExtHostSearch{constructor(m,b,C,p){super(m,C,p),this.s=R,this.t=-1,this.v=null,this.w=!1;const n=new D.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(L.Schemas.vscodeUserData,new k.RipgrepSearchProvider(n)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const m=new D.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(L.Schemas.file,new k.RipgrepSearchProvider(m)),this.y(L.Schemas.file,new v.SearchService("fileSearchProvider"))}y(m,b){const C=this.d++;return this.v=b,this.t=C,this.c.$registerFileSearchProvider(C,this.o(m)),(0,o.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(C)})}$provideFileSearchResults(m,b,C,p){const n=(0,I.reviveQuery)(C);return m===this.t?this.z(m,b,n,p):super.$provideFileSearchResults(m,b,C,p)}z(m,b,C,p){const n=s=>{if((0,P.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(m,b,s.map(r=>l.URI.file(r.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(C,n,p)}$clearCache(m){return this.v?.clearCache(m),super.$clearCache(m)}q(m,b){return new f.NativeTextSearchManager(m,b,void 0,"textSearchProvider")}};d=xe([ze(0,y.IExtHostRpcService),ze(1,A.IExtHostInitDataService),ze(2,O.IURITransformerService),ze(3,S.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[318],De([1,0,90,289,301,300,317,313,290,84,42,85,82,41,55,79,288,287,13,302,49]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u,m,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(O.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,o.registerSingleton)(m.ILoggerService,u.ExtHostLoggerService,1),(0,o.registerSingleton)(f.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,o.registerSingleton)(I.IExtHostDebugService,R.ExtHostDebugService,0),(0,o.registerSingleton)(P.IExtHostSearch,S.NativeExtHostSearch,0),(0,o.registerSingleton)(v.IExtHostTask,l.ExtHostTask,0),(0,o.registerSingleton)(k.IExtHostTerminalService,L.ExtHostTerminalService,0),(0,o.registerSingleton)(D.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,o.registerSingleton)(C.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[326],De([1,0,230,327,83,10,118,119,208,96,299,22,29,115,19,121,225,238,303,318]),function(re,e,o,L,l,R,S,A,y,I,O,P,v,k,D,f,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const m=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,g=c._load;c._load=function(i){if(i==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const b=process.exit.bind(process);function C(c){process.exit=function(g){if(c)b(g);else{const i=new Error("An extension called process.exit() and this was prevented.");console.warn(i.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(c){b()};function n(){const c=(0,u.readExtHostConnection)(process.env);if(c.type===3)return new Promise((g,i)=>{const t=h=>{const E=h[0],w=new S.BufferedEmitter;E.on("message",N=>w.fire(P.VSBuffer.wrap(N.data))),E.on("close",()=>{p("renderer closed the MessagePort")}),E.start(),g({onMessage:w.event,send:N=>E.postMessage(N.buffer)})};process.parentPort.on("message",h=>t(h.ports))});if(c.type===2)return new Promise((g,i)=>{let t=null;const h=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,w=3e5,N=new D.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),E),j=new D.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),w);process.on("message",(Q,q)=>{if(Q&&Q.type==="VSCODE_EXTHOST_IPC_SOCKET"){q.setNoDelay(!0);const U=P.VSBuffer.wrap(Buffer.from(Q.initialDataChunk,"base64"));let T;if(Q.skipWebSocketFrames)T=new A.NodeSocket(q,"extHost-socket");else{const F=P.VSBuffer.wrap(Buffer.from(Q.inflateBytes,"base64"));T=new A.WebSocketNodeSocket(new A.NodeSocket(q,"extHost-socket"),Q.permessageDeflate,F,!1)}t?(N.cancel(),j.cancel(),t.beginAcceptReconnection(T,U),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(h),t=new S.PersistentProtocol({socket:T,initialChunk:U}),t.sendResume(),t.onDidDispose(()=>p("renderer disconnected")),g(t),t.onSocketClose(()=>{N.schedule()}))}if(Q&&Q.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;N.isScheduled()&&j.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const g=c.pipeName;return new Promise((i,t)=>{const h=o.createConnection(g,()=>{h.removeListener("error",t);const E=new S.PersistentProtocol({socket:new A.NodeSocket(h,"extHost-renderer")});E.sendResume(),i(E)});h.once("error",t),h.on("close",()=>{p("renderer closed the socket")})})}}async function s(){const c=await n();return new class{constructor(){this.a=new S.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,c.onMessage(g=>{(0,I.isMessageOfType)(g,2)?(this.b=!0,p("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||c.send(g)}async drain(){if(c.drain)return c.drain()}}}function r(c){return new Promise(g=>{const i=c.onMessage(t=>{i.dispose();const h=JSON.parse(t.toString()),E=h.commit,w=y.default.commit;if(E&&w&&E!==w&&b(55),h.parentPid){let N=0;setInterval(function(){try{process.kill(h.parentPid,0),N=0}catch(V){V&&V.code==="EPERM"?(N++,N>=3&&p(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):p(`parent process ${h.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(h.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}c.send((0,I.createMessageOfType)(0)),g({protocol:c,initData:h})});c.send((0,I.createMessageOfType)(1))})}async function a(){const c=[];process.on("unhandledRejection",(N,j)=>{c.push(j),setTimeout(()=>{const V=c.indexOf(j);V>=0&&j.catch(Q=>{c.splice(V,1),(0,R.isCancellationError)(Q)||(console.warn(`rejected promise not handled within 1 second: ${Q}`),Q&&Q.stack&&console.warn(`stack trace: ${Q.stack}`),N&&(0,R.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const j=c.indexOf(N);j>=0&&c.splice(j,1)}),process.on("uncaughtException",function(N){(0,R.isSigPipeError)(N)||(0,R.onUnexpectedError)(N)}),l.mark("code/extHost/willConnectToRenderer");const g=await s();l.mark("code/extHost/didConnectToRenderer");const i=await r(g);l.mark("code/extHost/didWaitForInitData");const{initData:t}=i;C(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,f.boolean)(m.skipWorkspaceStorageLock,!1);const h=new class{constructor(){this.pid=process.pid}exit(j){b(j)}exists(j){return v.Promises.exists(j)}realpath(j){return(0,k.realpath)(j)}};let E=null;t.remote.authority&&m.transformURIs&&(E=(0,d.createURITransformer)(t.remote.authority));const w=new O.ExtensionHostMain(i.protocol,t,h,E);p=N=>w.terminate(N)}a().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ee2b180d582a7f601fa6ecfdad8d9fd269ab1884/core/vs/workbench/api/node/extensionHostProcess.js.map
